/* A Bison parser, made by GNU Bison 3.0.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2013 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         base_yyparse
#define yylex           base_yylex
#define yyerror         base_yyerror
#define yydebug         base_yydebug
#define yynerrs         base_yynerrs


/* Copy the first part of user declarations.  */
#line 1 "gram.y" /* yacc.c:339  */


/*#define YYDEBUG 1*/
/*-------------------------------------------------------------------------
 *
 * gram.y
 *	  POSTGRESQL BISON rules/actions
 *
 * Portions Copyright (c) 1996-2016, PostgreSQL Global Development Group
 * Portions Copyright (c) 1994, Regents of the University of California
 *
 *
 * IDENTIFICATION
 *	  src/backend/parser/gram.y
 *
 * HISTORY
 *	  AUTHOR			DATE			MAJOR EVENT
 *	  Andrew Yu			Sept, 1994		POSTQUEL to SQL conversion
 *	  Andrew Yu			Oct, 1994		lispy code conversion
 *
 * NOTES
 *	  CAPITALS are used to represent terminal symbols.
 *	  non-capitals are used to represent non-terminals.
 *
 *	  In general, nothing in this file should initiate database accesses
 *	  nor depend on changeable state (such as SET variables).  If you do
 *	  database accesses, your code will fail when we have aborted the
 *	  current transaction and are just parsing commands to find the next
 *	  ROLLBACK or COMMIT.  If you make use of SET variables, then you
 *	  will do the wrong thing in multi-query strings like this:
 *			SET SQL_inheritance TO off; SELECT * FROM foo;
 *	  because the entire string is parsed by gram.y before the SET gets
 *	  executed.  Anything that depends on the database or changeable state
 *	  should be handled during parse analysis so that it happens at the
 *	  right time not the wrong time.  The handling of SQL_inheritance is
 *	  a good example.
 *
 * WARNINGS
 *	  If you use a list, make sure the datum is a node so that the printing
 *	  routines work.
 *
 *	  Sometimes we assign constants to makeStrings. Make sure we don't free
 *	  those.
 *
 *-------------------------------------------------------------------------
 */
#include "postgres.h"

#include <ctype.h>
#include <limits.h>

#include "catalog/index.h"
#include "catalog/namespace.h"
#include "catalog/pg_am.h"
#include "catalog/pg_trigger.h"
#include "commands/defrem.h"
#include "commands/trigger.h"
#include "nodes/makefuncs.h"
#include "nodes/nodeFuncs.h"
#include "parser/gramparse.h"
#include "parser/parser.h"
#include "parser/parse_expr.h"
#include "storage/lmgr.h"
#include "utils/date.h"
#include "utils/datetime.h"
#include "utils/numeric.h"
#include "utils/xml.h"


/*
 * Location tracking support --- simpler than bison's default, since we only
 * want to track the start position not the end position of each nonterminal.
 */
#define YYLLOC_DEFAULT(Current, Rhs, N) \
	do { \
		if ((N) > 0) \
			(Current) = (Rhs)[1]; \
		else \
			(Current) = (-1); \
	} while (0)

/*
 * The above macro assigns -1 (unknown) as the parse location of any
 * nonterminal that was reduced from an empty rule.  This is problematic
 * for nonterminals defined like
 *		OptFooList: / * EMPTY * / { ... } | OptFooList Foo { ... } ;
 * because we'll set -1 as the location during the first reduction and then
 * copy it during each subsequent reduction, leaving us with -1 for the
 * location even when the list is not empty.  To fix that, do this in the
 * action for the nonempty rule(s):
 *		if (@$ < 0) @$ = @2;
 * (Although we have many nonterminals that follow this pattern, we only
 * bother with fixing @$ like this when the nonterminal's parse location
 * is actually referenced in some rule.)
 */

/*
 * Bison doesn't allocate anything that needs to live across parser calls,
 * so we can easily have it use palloc instead of malloc.  This prevents
 * memory leaks if we error out during parsing.  Note this only works with
 * bison >= 2.0.  However, in bison 1.875 the default is to use alloca()
 * if possible, so there's not really much problem anyhow, at least if
 * you're building with gcc.
 */
#define YYMALLOC palloc
#define YYFREE   pfree

/* Private struct for the result of privilege_target production */
typedef struct PrivTarget
{
	GrantTargetType targtype;
	GrantObjectType objtype;
	List	   *objs;
} PrivTarget;

/* Private struct for the result of import_qualification production */
typedef struct ImportQual
{
	ImportForeignSchemaType type;
	List	   *table_names;
} ImportQual;

/* ConstraintAttributeSpec yields an integer bitmask of these flags: */
#define CAS_NOT_DEFERRABLE			0x01
#define CAS_DEFERRABLE				0x02
#define CAS_INITIALLY_IMMEDIATE		0x04
#define CAS_INITIALLY_DEFERRED		0x08
#define CAS_NOT_VALID				0x10
#define CAS_NO_INHERIT				0x20


#define parser_yyerror(msg)  scanner_yyerror(msg, yyscanner)
#define parser_errposition(pos)  scanner_errposition(pos, yyscanner)

static void base_yyerror(YYLTYPE *yylloc, core_yyscan_t yyscanner,
						 const char *msg);
static Node *makeColumnRef(char *colname, List *indirection,
						   int location, core_yyscan_t yyscanner);
static Node *makeTypeCast(Node *arg, TypeName *typename, int location);
static Node *makeStringConst(char *str, int location);
static Node *makeStringConstCast(char *str, int location, TypeName *typename);
static Node *makeIntConst(int val, int location);
static Node *makeFloatConst(char *str, int location);
static Node *makeBitStringConst(char *str, int location);
static Node *makeNullAConst(int location);
static Node *makeAConst(Value *v, int location);
static Node *makeBoolAConst(bool state, int location);
static Node *makeRoleSpec(RoleSpecType type, int location);
static void check_qualified_name(List *names, core_yyscan_t yyscanner);
static List *check_func_name(List *names, core_yyscan_t yyscanner);
static List *check_indirection(List *indirection, core_yyscan_t yyscanner);
static List *extractArgTypes(List *parameters);
static List *extractAggrArgTypes(List *aggrargs);
static List *makeOrderedSetArgs(List *directargs, List *orderedargs,
								core_yyscan_t yyscanner);
static void insertSelectOptions(SelectStmt *stmt,
								List *sortClause, List *lockingClause,
								Node *limitOffset, Node *limitCount,
								WithClause *withClause,
								core_yyscan_t yyscanner);
static Node *makeSetOp(SetOperation op, bool all, Node *larg, Node *rarg);
static Node *doNegate(Node *n, int location);
static void doNegateFloat(Value *v);
static Node *makeAndExpr(Node *lexpr, Node *rexpr, int location);
static Node *makeOrExpr(Node *lexpr, Node *rexpr, int location);
static Node *makeNotExpr(Node *expr, int location);
static Node *makeAArrayExpr(List *elements, int location);
static Node *makeXmlExpr(XmlExprOp op, char *name, List *named_args,
						 List *args, int location);
static List *mergeTableFuncParameters(List *func_args, List *columns);
static TypeName *TableFuncTypeName(List *columns);
static RangeVar *makeRangeVarFromAnyName(List *names, int position, core_yyscan_t yyscanner);
static void SplitColQualList(List *qualList,
							 List **constraintList, CollateClause **collClause,
							 core_yyscan_t yyscanner);
static void processCASbits(int cas_bits, int location, const char *constrType,
			   bool *deferrable, bool *initdeferred, bool *not_valid,
			   bool *no_inherit, core_yyscan_t yyscanner);
static Node *makeRecursiveViewSelect(char *relname, List *aliases, Node *query);


#line 254 "gram.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "gram.h".  */
#ifndef YY_BASE_YY_GRAM_H_INCLUDED
# define YY_BASE_YY_GRAM_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int base_yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    IDENT = 258,
    FCONST = 259,
    SCONST = 260,
    BCONST = 261,
    XCONST = 262,
    Op = 263,
    ICONST = 264,
    PARAM = 265,
    TYPECAST = 266,
    DOT_DOT = 267,
    COLON_EQUALS = 268,
    EQUALS_GREATER = 269,
    LESS_EQUALS = 270,
    GREATER_EQUALS = 271,
    NOT_EQUALS = 272,
    ABORT_P = 273,
    ABSOLUTE_P = 274,
    ACCESS = 275,
    ACTION = 276,
    ADD_P = 277,
    ADMIN = 278,
    AFTER = 279,
    AGGREGATE = 280,
    ALL = 281,
    ALSO = 282,
    ALTER = 283,
    ALWAYS = 284,
    ANALYSE = 285,
    ANALYZE = 286,
    AND = 287,
    ANY = 288,
    ARRAY = 289,
    AS = 290,
    ASC = 291,
    ASSERTION = 292,
    ASSIGNMENT = 293,
    ASYMMETRIC = 294,
    AT = 295,
    ATTRIBUTE = 296,
    AUTHORIZATION = 297,
    BACKWARD = 298,
    BEFORE = 299,
    BEGIN_P = 300,
    BETWEEN = 301,
    BIGINT = 302,
    BINARY = 303,
    BIT = 304,
    BOOLEAN_P = 305,
    BOTH = 306,
    BY = 307,
    CACHE = 308,
    CALLED = 309,
    CASCADE = 310,
    CASCADED = 311,
    CASE = 312,
    CAST = 313,
    CATALOG_P = 314,
    CHAIN = 315,
    CHAR_P = 316,
    CHARACTER = 317,
    CHARACTERISTICS = 318,
    CHECK = 319,
    CHECKPOINT = 320,
    CLASS = 321,
    CLOSE = 322,
    CLUSTER = 323,
    COALESCE = 324,
    COLLATE = 325,
    COLLATION = 326,
    COLUMN = 327,
    COMMENT = 328,
    COMMENTS = 329,
    COMMIT = 330,
    COMMITTED = 331,
    CONCURRENTLY = 332,
    CONFIGURATION = 333,
    CONFLICT = 334,
    CONNECTION = 335,
    CONSTRAINT = 336,
    CONSTRAINTS = 337,
    CONTENT_P = 338,
    CONTINUE_P = 339,
    CONVERSION_P = 340,
    COPY = 341,
    COST = 342,
    CREATE = 343,
    CROSS = 344,
    CSV = 345,
    CUBE = 346,
    CURRENT_P = 347,
    CURRENT_CATALOG = 348,
    CURRENT_DATE = 349,
    CURRENT_ROLE = 350,
    CURRENT_SCHEMA = 351,
    CURRENT_TIME = 352,
    CURRENT_TIMESTAMP = 353,
    CURRENT_USER = 354,
    CURSOR = 355,
    CYCLE = 356,
    DATA_P = 357,
    DATABASE = 358,
    DAY_P = 359,
    DEALLOCATE = 360,
    DEC = 361,
    DECIMAL_P = 362,
    DECLARE = 363,
    DEFAULT = 364,
    DEFAULTS = 365,
    DEFERRABLE = 366,
    DEFERRED = 367,
    DEFINER = 368,
    DELETE_P = 369,
    DELIMITER = 370,
    DELIMITERS = 371,
    DEPENDS = 372,
    DESC = 373,
    DICTIONARY = 374,
    DISABLE_P = 375,
    DISCARD = 376,
    DISTINCT = 377,
    DO = 378,
    DOCUMENT_P = 379,
    DOMAIN_P = 380,
    DOUBLE_P = 381,
    DROP = 382,
    EACH = 383,
    ELSE = 384,
    ENABLE_P = 385,
    ENCODING = 386,
    ENCRYPTED = 387,
    END_P = 388,
    ENUM_P = 389,
    ESCAPE = 390,
    EVENT = 391,
    EXCEPT = 392,
    EXCLUDE = 393,
    EXCLUDING = 394,
    EXCLUSIVE = 395,
    EXECUTE = 396,
    EXISTS = 397,
    EXPLAIN = 398,
    EXTENSION = 399,
    EXTERNAL = 400,
    EXTRACT = 401,
    FALSE_P = 402,
    FAMILY = 403,
    FETCH = 404,
    FILTER = 405,
    FIRST_P = 406,
    FLOAT_P = 407,
    FOLLOWING = 408,
    FOR = 409,
    FORCE = 410,
    FOREIGN = 411,
    FORWARD = 412,
    FREEZE = 413,
    FROM = 414,
    FULL = 415,
    FUNCTION = 416,
    FUNCTIONS = 417,
    GLOBAL = 418,
    GRANT = 419,
    GRANTED = 420,
    GREATEST = 421,
    GROUP_P = 422,
    GROUPING = 423,
    HANDLER = 424,
    HAVING = 425,
    HEADER_P = 426,
    HOLD = 427,
    HOUR_P = 428,
    IDENTITY_P = 429,
    IF_P = 430,
    ILIKE = 431,
    IMMEDIATE = 432,
    IMMUTABLE = 433,
    IMPLICIT_P = 434,
    IMPORT_P = 435,
    IN_P = 436,
    INCLUDING = 437,
    INCREMENT = 438,
    INDEX = 439,
    INDEXES = 440,
    INHERIT = 441,
    INHERITS = 442,
    INITIALLY = 443,
    INLINE_P = 444,
    INNER_P = 445,
    INOUT = 446,
    INPUT_P = 447,
    INSENSITIVE = 448,
    INSERT = 449,
    INSTEAD = 450,
    INT_P = 451,
    INTEGER = 452,
    INTERSECT = 453,
    INTERVAL = 454,
    INTO = 455,
    INVOKER = 456,
    IS = 457,
    ISNULL = 458,
    ISOLATION = 459,
    JOIN = 460,
    KEY = 461,
    LABEL = 462,
    LANGUAGE = 463,
    LARGE_P = 464,
    LAST_P = 465,
    LATERAL_P = 466,
    LEADING = 467,
    LEAKPROOF = 468,
    LEAST = 469,
    LEFT = 470,
    LEVEL = 471,
    LIKE = 472,
    LIMIT = 473,
    LISTEN = 474,
    LOAD = 475,
    LOCAL = 476,
    LOCALTIME = 477,
    LOCALTIMESTAMP = 478,
    LOCATION = 479,
    LOCK_P = 480,
    LOCKED = 481,
    LOGGED = 482,
    MAPPING = 483,
    MATCH = 484,
    MATERIALIZED = 485,
    MAXVALUE = 486,
    METHOD = 487,
    MINUTE_P = 488,
    MINVALUE = 489,
    MODE = 490,
    MONTH_P = 491,
    MOVE = 492,
    NAME_P = 493,
    NAMES = 494,
    NATIONAL = 495,
    NATURAL = 496,
    NCHAR = 497,
    NEXT = 498,
    NO = 499,
    NONE = 500,
    NOT = 501,
    NOTHING = 502,
    NOTIFY = 503,
    NOTNULL = 504,
    NOWAIT = 505,
    NULL_P = 506,
    NULLIF = 507,
    NULLS_P = 508,
    NUMERIC = 509,
    OBJECT_P = 510,
    OF = 511,
    OFF = 512,
    OFFSET = 513,
    OIDS = 514,
    ON = 515,
    ONLY = 516,
    OPERATOR = 517,
    OPTION = 518,
    OPTIONS = 519,
    OR = 520,
    ORDER = 521,
    ORDINALITY = 522,
    OUT_P = 523,
    OUTER_P = 524,
    OVER = 525,
    OVERLAPS = 526,
    OVERLAY = 527,
    OWNED = 528,
    OWNER = 529,
    PARALLEL = 530,
    PARSER = 531,
    PARTIAL = 532,
    PARTITION = 533,
    PASSING = 534,
    PASSWORD = 535,
    PLACING = 536,
    PLANS = 537,
    POLICY = 538,
    POSITION = 539,
    PRECEDING = 540,
    PRECISION = 541,
    PRESERVE = 542,
    PREPARE = 543,
    PREPARED = 544,
    PRIMARY = 545,
    PRIOR = 546,
    PRIVILEGES = 547,
    PROCEDURAL = 548,
    PROCEDURE = 549,
    PROGRAM = 550,
    QUOTE = 551,
    RANGE = 552,
    READ = 553,
    REAL = 554,
    REASSIGN = 555,
    RECHECK = 556,
    RECURSIVE = 557,
    REF = 558,
    REFERENCES = 559,
    REFRESH = 560,
    REINDEX = 561,
    RELATIVE_P = 562,
    RELEASE = 563,
    RENAME = 564,
    REPEATABLE = 565,
    REPLACE = 566,
    REPLICA = 567,
    RESET = 568,
    RESTART = 569,
    RESTRICT = 570,
    RETURNING = 571,
    RETURNS = 572,
    REVOKE = 573,
    RIGHT = 574,
    ROLE = 575,
    ROLLBACK = 576,
    ROLLUP = 577,
    ROW = 578,
    ROWS = 579,
    RULE = 580,
    SAVEPOINT = 581,
    SCHEMA = 582,
    SCROLL = 583,
    SEARCH = 584,
    SECOND_P = 585,
    SECURITY = 586,
    SELECT = 587,
    SEQUENCE = 588,
    SEQUENCES = 589,
    SERIALIZABLE = 590,
    SERVER = 591,
    SESSION = 592,
    SESSION_USER = 593,
    SET = 594,
    SETS = 595,
    SETOF = 596,
    SHARE = 597,
    SHOW = 598,
    SIMILAR = 599,
    SIMPLE = 600,
    SKIP = 601,
    SMALLINT = 602,
    SNAPSHOT = 603,
    SOME = 604,
    SQL_P = 605,
    STABLE = 606,
    STANDALONE_P = 607,
    START = 608,
    STATEMENT = 609,
    STATISTICS = 610,
    STDIN = 611,
    STDOUT = 612,
    STORAGE = 613,
    STRICT_P = 614,
    STRIP_P = 615,
    SUBSTRING = 616,
    SYMMETRIC = 617,
    SYSID = 618,
    SYSTEM_P = 619,
    TABLE = 620,
    TABLES = 621,
    TABLESAMPLE = 622,
    TABLESPACE = 623,
    TEMP = 624,
    TEMPLATE = 625,
    TEMPORARY = 626,
    TEXT_P = 627,
    THEN = 628,
    TIME = 629,
    TIMESTAMP = 630,
    TO = 631,
    TRAILING = 632,
    TRANSACTION = 633,
    TRANSFORM = 634,
    TREAT = 635,
    TRIGGER = 636,
    TRIM = 637,
    TRUE_P = 638,
    TRUNCATE = 639,
    TRUSTED = 640,
    TYPE_P = 641,
    TYPES_P = 642,
    UNBOUNDED = 643,
    UNCOMMITTED = 644,
    UNENCRYPTED = 645,
    UNION = 646,
    UNIQUE = 647,
    UNKNOWN = 648,
    UNLISTEN = 649,
    UNLOGGED = 650,
    UNTIL = 651,
    UPDATE = 652,
    USER = 653,
    USING = 654,
    VACUUM = 655,
    VALID = 656,
    VALIDATE = 657,
    VALIDATOR = 658,
    VALUE_P = 659,
    VALUES = 660,
    VARCHAR = 661,
    VARIADIC = 662,
    VARYING = 663,
    VERBOSE = 664,
    VERSION_P = 665,
    VIEW = 666,
    VIEWS = 667,
    VOLATILE = 668,
    WHEN = 669,
    WHERE = 670,
    WHITESPACE_P = 671,
    WINDOW = 672,
    WITH = 673,
    WITHIN = 674,
    WITHOUT = 675,
    WORK = 676,
    WRAPPER = 677,
    WRITE = 678,
    XML_P = 679,
    XMLATTRIBUTES = 680,
    XMLCONCAT = 681,
    XMLELEMENT = 682,
    XMLEXISTS = 683,
    XMLFOREST = 684,
    XMLPARSE = 685,
    XMLPI = 686,
    XMLROOT = 687,
    XMLSERIALIZE = 688,
    YEAR_P = 689,
    YES_P = 690,
    ZONE = 691,
    NOT_LA = 692,
    NULLS_LA = 693,
    WITH_LA = 694,
    POSTFIXOP = 695,
    UMINUS = 696
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE YYSTYPE;
union YYSTYPE
{
#line 192 "gram.y" /* yacc.c:355  */

	core_YYSTYPE		core_yystype;
	/* these fields must match core_YYSTYPE: */
	int					ival;
	char				*str;
	const char			*keyword;

	char				chr;
	bool				boolean;
	JoinType			jtype;
	DropBehavior		dbehavior;
	OnCommitAction		oncommit;
	List				*list;
	Node				*node;
	Value				*value;
	ObjectType			objtype;
	TypeName			*typnam;
	FunctionParameter   *fun_param;
	FunctionParameterMode fun_param_mode;
	FuncWithArgs		*funwithargs;
	DefElem				*defelt;
	SortBy				*sortby;
	WindowDef			*windef;
	JoinExpr			*jexpr;
	IndexElem			*ielem;
	Alias				*alias;
	RangeVar			*range;
	IntoClause			*into;
	WithClause			*with;
	InferClause			*infer;
	OnConflictClause	*onconflict;
	A_Indices			*aind;
	ResTarget			*target;
	struct PrivTarget	*privtarget;
	AccessPriv			*accesspriv;
	struct ImportQual	*importqual;
	InsertStmt			*istmt;
	VariableSetStmt		*vsetstmt;

#line 776 "gram.c" /* yacc.c:355  */
};
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif

/* Location type.  */
#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE YYLTYPE;
struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
};
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif



int base_yyparse (core_yyscan_t yyscanner);

#endif /* !YY_BASE_YY_GRAM_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 804 "gram.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  763
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   92414

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  459
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  618
/* YYNRULES -- Number of rules.  */
#define YYNRULES  2510
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  4985

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   696

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,   448,     2,     2,
     453,   454,   446,   444,   457,   445,   455,   447,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   458,   456,
     440,   442,   441,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   451,     2,   452,   449,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   443,   450
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   734,   734,   741,   748,   758,   759,   760,   761,   762,
     763,   764,   765,   766,   767,   768,   769,   770,   771,   772,
     773,   774,   775,   776,   777,   778,   779,   780,   781,   782,
     783,   784,   785,   786,   787,   788,   789,   790,   791,   792,
     793,   794,   795,   796,   797,   798,   799,   800,   801,   802,
     803,   804,   805,   806,   807,   808,   809,   810,   811,   812,
     813,   814,   815,   816,   817,   818,   819,   820,   821,   822,
     823,   824,   825,   826,   827,   828,   829,   830,   831,   832,
     833,   834,   835,   836,   837,   838,   839,   840,   841,   842,
     843,   844,   845,   846,   847,   848,   849,   850,   851,   852,
     853,   854,   855,   856,   857,   858,   859,   860,   861,   862,
     863,   864,   865,   866,   867,   868,   869,   870,   871,   872,
     873,   874,   875,   876,   877,   878,   879,   880,   881,   882,
     884,   894,   905,   906,   907,   916,   917,   921,   922,   926,
     931,   935,   940,   945,   949,   953,   958,   962,  1010,  1012,
    1016,  1020,  1024,  1028,  1042,  1060,  1071,  1072,  1076,  1084,
    1102,  1114,  1135,  1142,  1159,  1166,  1183,  1201,  1212,  1213,
    1225,  1232,  1249,  1259,  1269,  1284,  1302,  1303,  1307,  1314,
    1322,  1323,  1324,  1325,  1326,  1327,  1341,  1347,  1353,  1362,
    1370,  1378,  1382,  1390,  1398,  1405,  1414,  1415,  1423,  1434,
    1442,  1450,  1461,  1469,  1477,  1484,  1493,  1503,  1504,  1508,
    1509,  1512,  1514,  1518,  1519,  1520,  1521,  1525,  1526,  1527,
    1533,  1545,  1549,  1553,  1568,  1575,  1576,  1577,  1581,  1582,
    1583,  1587,  1588,  1592,  1596,  1597,  1604,  1611,  1621,  1628,
    1638,  1639,  1644,  1645,  1650,  1656,  1662,  1668,  1674,  1684,
    1694,  1695,  1699,  1700,  1708,  1723,  1729,  1735,  1741,  1747,
    1766,  1775,  1784,  1795,  1806,  1815,  1824,  1835,  1846,  1855,
    1864,  1873,  1882,  1891,  1900,  1911,  1925,  1926,  1931,  1940,
    1949,  1958,  1967,  1976,  1984,  1992,  2001,  2010,  2019,  2028,
    2038,  2051,  2066,  2075,  2083,  2098,  2106,  2116,  2126,  2133,
    2140,  2148,  2156,  2163,  2170,  2178,  2186,  2194,  2201,  2208,
    2216,  2223,  2230,  2238,  2246,  2254,  2262,  2270,  2278,  2288,
    2295,  2303,  2311,  2319,  2327,  2335,  2342,  2349,  2356,  2362,
    2372,  2373,  2377,  2378,  2379,  2383,  2391,  2395,  2396,  2400,
    2407,  2414,  2421,  2431,  2434,  2435,  2439,  2440,  2445,  2449,
    2453,  2458,  2473,  2486,  2487,  2492,  2501,  2511,  2521,  2547,
    2553,  2586,  2615,  2637,  2638,  2642,  2643,  2652,  2653,  2654,
    2657,  2658,  2663,  2664,  2668,  2672,  2676,  2680,  2684,  2688,
    2692,  2696,  2700,  2704,  2708,  2712,  2716,  2720,  2729,  2733,
    2737,  2741,  2745,  2749,  2753,  2754,  2759,  2763,  2770,  2777,
    2778,  2779,  2780,  2781,  2785,  2789,  2797,  2808,  2824,  2841,
    2858,  2888,  2889,  2890,  2891,  2892,  2899,  2906,  2907,  2911,
    2912,  2916,  2917,  2921,  2925,  2932,  2936,  2943,  2944,  2945,
    2949,  2950,  2953,  2974,  2995,  2996,  3000,  3008,  3009,  3010,
    3041,  3048,  3055,  3066,  3077,  3089,  3098,  3131,  3138,  3145,
    3152,  3163,  3173,  3174,  3175,  3179,  3180,  3181,  3182,  3183,
    3184,  3193,  3201,  3205,  3218,  3233,  3247,  3262,  3276,  3294,
    3315,  3316,  3320,  3321,  3325,  3326,  3329,  3335,  3339,  3347,
    3352,  3358,  3359,  3363,  3368,  3375,  3376,  3386,  3388,  3390,
    3392,  3395,  3398,  3401,  3405,  3406,  3407,  3408,  3409,  3412,
    3413,  3418,  3419,  3420,  3421,  3424,  3425,  3426,  3427,  3430,
    3431,  3434,  3435,  3438,  3453,  3466,  3482,  3496,  3497,  3498,
    3510,  3523,  3539,  3552,  3553,  3565,  3585,  3595,  3608,  3616,
    3627,  3628,  3631,  3632,  3635,  3639,  3643,  3647,  3651,  3655,
    3659,  3663,  3667,  3671,  3675,  3679,  3685,  3686,  3690,  3691,
    3696,  3699,  3700,  3712,  3724,  3739,  3740,  3748,  3749,  3753,
    3754,  3758,  3759,  3763,  3764,  3768,  3779,  3792,  3793,  3803,
    3814,  3815,  3828,  3835,  3852,  3860,  3871,  3874,  3878,  3882,
    3886,  3890,  3902,  3912,  3915,  3919,  3932,  3941,  3951,  3961,
    3970,  3979,  3988,  3998,  4007,  4017,  4026,  4035,  4044,  4053,
    4062,  4071,  4080,  4089,  4098,  4107,  4116,  4125,  4134,  4143,
    4152,  4162,  4180,  4191,  4192,  4193,  4194,  4198,  4199,  4203,
    4204,  4214,  4225,  4245,  4253,  4265,  4266,  4270,  4274,  4282,
    4286,  4290,  4297,  4301,  4306,  4311,  4318,  4325,  4330,  4340,
    4354,  4355,  4360,  4361,  4365,  4366,  4376,  4387,  4407,  4416,
    4424,  4441,  4461,  4491,  4500,  4521,  4536,  4537,  4541,  4549,
    4564,  4575,  4576,  4588,  4596,  4613,  4635,  4651,  4665,  4676,
    4690,  4691,  4695,  4696,  4700,  4701,  4705,  4706,  4710,  4711,
    4715,  4716,  4717,  4718,  4719,  4729,  4748,  4768,  4793,  4794,
    4795,  4799,  4801,  4823,  4825,  4827,  4829,  4831,  4836,  4841,
    4851,  4852,  4856,  4857,  4861,  4862,  4866,  4867,  4868,  4872,
    4876,  4877,  4878,  4882,  4883,  4888,  4889,  4916,  4917,  4918,
    4919,  4920,  4921,  4926,  4937,  4960,  4970,  4984,  4986,  4991,
    4996,  4998,  5003,  5013,  5014,  5015,  5016,  5028,  5048,  5071,
    5081,  5092,  5102,  5112,  5123,  5132,  5139,  5146,  5155,  5164,
    5173,  5182,  5191,  5202,  5205,  5206,  5209,  5213,  5220,  5221,
    5222,  5223,  5224,  5227,  5230,  5231,  5239,  5246,  5247,  5250,
    5252,  5263,  5273,  5283,  5295,  5296,  5312,  5327,  5328,  5332,
    5342,  5353,  5362,  5372,  5381,  5382,  5385,  5386,  5389,  5390,
    5391,  5394,  5408,  5413,  5423,  5432,  5444,  5445,  5449,  5457,
    5469,  5479,  5492,  5502,  5524,  5534,  5552,  5563,  5574,  5584,
    5594,  5604,  5614,  5625,  5639,  5640,  5641,  5642,  5643,  5644,
    5645,  5646,  5647,  5648,  5649,  5650,  5651,  5652,  5653,  5654,
    5658,  5659,  5662,  5663,  5666,  5668,  5673,  5674,  5684,  5695,
    5696,  5697,  5731,  5740,  5749,  5758,  5767,  5776,  5785,  5794,
    5808,  5817,  5826,  5836,  5845,  5854,  5862,  5871,  5880,  5889,
    5901,  5902,  5903,  5904,  5905,  5906,  5907,  5908,  5909,  5910,
    5911,  5912,  5913,  5914,  5915,  5916,  5917,  5918,  5919,  5920,
    5921,  5922,  5926,  5927,  5941,  5952,  5963,  5974,  5985,  5996,
    6007,  6020,  6021,  6025,  6026,  6027,  6028,  6029,  6030,  6031,
    6032,  6033,  6034,  6035,  6038,  6039,  6049,  6055,  6063,  6071,
    6079,  6087,  6095,  6103,  6111,  6119,  6127,  6135,  6143,  6151,
    6159,  6167,  6175,  6183,  6193,  6194,  6197,  6198,  6208,  6224,
    6238,  6264,  6266,  6268,  6270,  6277,  6286,  6287,  6290,  6297,
    6304,  6311,  6325,  6333,  6341,  6349,  6357,  6365,  6373,  6381,
    6389,  6397,  6405,  6413,  6421,  6429,  6437,  6445,  6457,  6458,
    6462,  6463,  6468,  6469,  6473,  6474,  6479,  6495,  6508,  6518,
    6530,  6531,  6534,  6535,  6545,  6555,  6556,  6560,  6564,  6568,
    6579,  6592,  6606,  6623,  6624,  6625,  6626,  6638,  6664,  6693,
    6694,  6698,  6699,  6703,  6704,  6708,  6709,  6712,  6713,  6721,
    6732,  6743,  6756,  6757,  6760,  6761,  6764,  6765,  6766,  6769,
    6770,  6771,  6787,  6799,  6812,  6827,  6828,  6831,  6832,  6836,
    6837,  6845,  6846,  6850,  6851,  6866,  6875,  6884,  6893,  6902,
    6914,  6915,  6916,  6917,  6918,  6924,  6928,  6943,  6944,  6950,
    6960,  6964,  6969,  6977,  7018,  7022,  7026,  7030,  7038,  7039,
    7044,  7045,  7052,  7056,  7060,  7064,  7068,  7072,  7076,  7080,
    7084,  7088,  7092,  7096,  7100,  7104,  7108,  7113,  7120,  7124,
    7128,  7132,  7136,  7142,  7143,  7150,  7151,  7155,  7156,  7159,
    7171,  7175,  7190,  7201,  7202,  7207,  7208,  7223,  7234,  7248,
    7259,  7273,  7284,  7298,  7306,  7308,  7310,  7315,  7317,  7330,
    7339,  7340,  7344,  7348,  7360,  7371,  7382,  7395,  7396,  7397,
    7401,  7414,  7415,  7425,  7437,  7441,  7445,  7449,  7456,  7477,
    7486,  7495,  7504,  7515,  7516,  7519,  7520,  7521,  7524,  7525,
    7528,  7538,  7547,  7564,  7574,  7583,  7592,  7601,  7610,  7619,
    7628,  7638,  7647,  7656,  7665,  7674,  7684,  7694,  7703,  7712,
    7722,  7732,  7742,  7752,  7762,  7772,  7782,  7792,  7802,  7812,
    7822,  7832,  7843,  7854,  7865,  7876,  7886,  7896,  7907,  7918,
    7928,  7938,  7946,  7955,  7964,  7973,  7982,  7991,  8000,  8009,
    8018,  8032,  8033,  8036,  8037,  8047,  8057,  8067,  8077,  8096,
    8106,  8115,  8124,  8133,  8142,  8152,  8162,  8171,  8180,  8189,
    8198,  8207,  8216,  8225,  8234,  8243,  8252,  8261,  8270,  8279,
    8288,  8297,  8306,  8324,  8334,  8335,  8338,  8340,  8350,  8359,
    8367,  8375,  8383,  8391,  8400,  8408,  8416,  8425,  8433,  8441,
    8449,  8457,  8465,  8473,  8481,  8489,  8497,  8514,  8531,  8532,
    8533,  8538,  8544,  8553,  8554,  8555,  8556,  8557,  8561,  8562,
    8565,  8566,  8567,  8568,  8572,  8573,  8574,  8579,  8590,  8612,
    8622,  8623,  8626,  8635,  8641,  8660,  8667,  8674,  8681,  8688,
    8695,  8702,  8710,  8718,  8726,  8734,  8742,  8749,  8756,  8765,
    8766,  8767,  8771,  8774,  8777,  8780,  8783,  8790,  8792,  8794,
    8799,  8801,  8813,  8826,  8839,  8857,  8878,  8879,  8880,  8881,
    8891,  8907,  8917,  8918,  8922,  8923,  8927,  8931,  8935,  8953,
    8954,  8955,  8956,  8957,  8958,  8959,  8966,  8967,  8978,  8985,
    8992,  9003,  9020,  9027,  9045,  9051,  9067,  9080,  9089,  9097,
    9105,  9114,  9125,  9136,  9146,  9147,  9158,  9168,  9179,  9190,
    9201,  9212,  9221,  9233,  9234,  9248,  9271,  9279,  9288,  9299,
    9300,  9312,  9326,  9340,  9352,  9360,  9373,  9374,  9378,  9379,
    9380,  9381,  9382,  9395,  9405,  9418,  9419,  9423,  9424,  9427,
    9428,  9431,  9432,  9436,  9437,  9450,  9457,  9467,  9474,  9484,
    9485,  9486,  9487,  9488,  9489,  9490,  9491,  9492,  9496,  9500,
    9507,  9514,  9515,  9519,  9520,  9521,  9531,  9541,  9542,  9546,
    9547,  9548,  9549,  9559,  9566,  9584,  9585,  9595,  9601,  9607,
    9613,  9629,  9647,  9651,  9659,  9665,  9671,  9680,  9682,  9687,
    9698,  9708,  9718,  9724,  9733,  9742,  9748,  9749,  9760,  9774,
    9775,  9786,  9797,  9798,  9801,  9802,  9803,  9804,  9805,  9806,
    9807,  9808,  9811,  9812,  9816,  9817,  9818,  9829,  9847,  9848,
    9852,  9853,  9857,  9873,  9899,  9932,  9943,  9944,  9954,  9965,
    9968,  9969,  9970,  9971,  9972,  9975,  9976,  9977, 10025, 10026,
   10030, 10031, 10046, 10047, 10054, 10062, 10070, 10078, 10086, 10094,
   10105, 10106, 10133, 10147, 10162, 10163, 10182, 10186, 10190, 10207,
   10214, 10221, 10231, 10232, 10235, 10247, 10248, 10252, 10264, 10272,
   10277, 10282, 10287, 10292, 10300, 10308, 10313, 10318, 10325, 10326,
   10330, 10331, 10332, 10339, 10340, 10344, 10345, 10349, 10350, 10354,
   10358, 10359, 10362, 10371, 10384, 10385, 10386, 10387, 10391, 10392,
   10396, 10398, 10408, 10413, 10416, 10421, 10422, 10430, 10440, 10441,
   10442, 10450, 10454, 10455, 10458, 10459, 10484, 10485, 10489, 10490,
   10494, 10495, 10496, 10497, 10498, 10502, 10515, 10522, 10529, 10536,
   10537, 10541, 10542, 10546, 10547, 10551, 10552, 10556, 10567, 10568,
   10569, 10570, 10574, 10575, 10580, 10586, 10604, 10605, 10609, 10610,
   10616, 10621, 10629, 10636, 10644, 10679, 10704, 10708, 10734, 10738,
   10750, 10763, 10777, 10788, 10803, 10809, 10814, 10820, 10827, 10828,
   10836, 10840, 10844, 10850, 10857, 10862, 10863, 10864, 10865, 10869,
   10870, 10882, 10883, 10888, 10895, 10902, 10909, 10920, 10921, 10934,
   10938, 10945, 10958, 10971, 10972, 10987, 10997, 11009, 11014, 11015,
   11018, 11019, 11022, 11023, 11028, 11029, 11034, 11035, 11043, 11048,
   11049, 11053, 11057, 11063, 11093, 11098, 11105, 11110, 11116, 11121,
   11130, 11132, 11135, 11139, 11140, 11141, 11142, 11143, 11144, 11149,
   11169, 11170, 11171, 11172, 11183, 11189, 11197, 11198, 11204, 11209,
   11214, 11219, 11224, 11229, 11234, 11239, 11245, 11251, 11257, 11264,
   11286, 11295, 11299, 11307, 11311, 11319, 11331, 11352, 11356, 11362,
   11366, 11379, 11390, 11405, 11407, 11409, 11411, 11413, 11415, 11420,
   11421, 11425, 11426, 11433, 11442, 11450, 11459, 11470, 11478, 11479,
   11480, 11484, 11486, 11488, 11490, 11492, 11494, 11496, 11501, 11506,
   11512, 11520, 11525, 11532, 11539, 11543, 11547, 11583, 11584, 11586,
   11594, 11609, 11611, 11613, 11615, 11617, 11619, 11621, 11623, 11625,
   11627, 11629, 11631, 11633, 11635, 11638, 11640, 11642, 11645, 11647,
   11649, 11651, 11654, 11659, 11667, 11672, 11680, 11685, 11693, 11698,
   11707, 11715, 11723, 11731, 11749, 11757, 11765, 11773, 11781, 11797,
   11805, 11813, 11821, 11829, 11837, 11845, 11849, 11853, 11857, 11861,
   11869, 11877, 11885, 11893, 11913, 11935, 11946, 11953, 11969, 11974,
   11991, 11993, 11995, 11997, 11999, 12001, 12003, 12005, 12007, 12009,
   12011, 12013, 12015, 12017, 12019, 12021, 12023, 12025, 12027, 12029,
   12033, 12037, 12041, 12045, 12050, 12066, 12067, 12068, 12083, 12113,
   12115, 12117, 12128, 12152, 12163, 12174, 12182, 12192, 12202, 12211,
   12215, 12221, 12228, 12235, 12245, 12252, 12280, 12315, 12326, 12327,
   12334, 12340, 12366, 12376, 12389, 12397, 12410, 12420, 12433, 12443,
   12456, 12460, 12464, 12468, 12472, 12476, 12480, 12482, 12486, 12495,
   12500, 12507, 12522, 12529, 12533, 12537, 12541, 12545, 12552, 12560,
   12568, 12572, 12576, 12580, 12584, 12588, 12594, 12598, 12607, 12611,
   12615, 12620, 12634, 12636, 12640, 12642, 12644, 12647, 12650, 12653,
   12654, 12657, 12665, 12675, 12676, 12679, 12680, 12681, 12686, 12690,
   12694, 12698, 12709, 12710, 12714, 12715, 12723, 12724, 12728, 12729,
   12734, 12742, 12744, 12758, 12761, 12788, 12789, 12792, 12793, 12804,
   12822, 12829, 12838, 12855, 12900, 12908, 12916, 12924, 12932, 12953,
   12954, 12955, 12958, 12959, 12962, 12965, 12966, 12967, 12970, 12971,
   12974, 12975, 12976, 12977, 12978, 12979, 12980, 12981, 12982, 12983,
   12984, 12985, 12988, 12990, 12995, 12997, 13002, 13004, 13006, 13008,
   13010, 13012, 13024, 13028, 13035, 13039, 13045, 13049, 13058, 13069,
   13070, 13073, 13077, 13081, 13087, 13088, 13093, 13097, 13104, 13105,
   13106, 13107, 13108, 13109, 13110, 13111, 13121, 13125, 13132, 13139,
   13140, 13156, 13160, 13165, 13169, 13184, 13189, 13193, 13196, 13199,
   13200, 13201, 13204, 13211, 13221, 13235, 13236, 13240, 13251, 13252,
   13255, 13256, 13259, 13263, 13270, 13274, 13278, 13286, 13297, 13298,
   13302, 13303, 13307, 13308, 13311, 13312, 13323, 13324, 13333, 13334,
   13342, 13352, 13353, 13357, 13358, 13361, 13377, 13385, 13393, 13415,
   13416, 13427, 13431, 13458, 13460, 13465, 13468, 13471, 13473, 13475,
   13477, 13487, 13489, 13500, 13504, 13508, 13512, 13516, 13525, 13532,
   13564, 13568, 13574, 13581, 13585, 13589, 13595, 13596, 13598, 13599,
   13600, 13604, 13634, 13661, 13665, 13671, 13673, 13690, 13691, 13692,
   13697, 13698, 13699, 13704, 13705, 13706, 13707, 13713, 13714, 13715,
   13716, 13717, 13737, 13738, 13739, 13740, 13741, 13742, 13743, 13744,
   13745, 13746, 13747, 13748, 13749, 13750, 13751, 13752, 13753, 13754,
   13755, 13756, 13757, 13758, 13759, 13760, 13761, 13762, 13763, 13764,
   13765, 13766, 13767, 13768, 13769, 13770, 13771, 13772, 13773, 13774,
   13775, 13776, 13777, 13778, 13779, 13780, 13781, 13782, 13783, 13784,
   13785, 13786, 13787, 13788, 13789, 13790, 13791, 13792, 13793, 13794,
   13795, 13796, 13797, 13798, 13799, 13800, 13801, 13802, 13803, 13804,
   13805, 13806, 13807, 13808, 13809, 13810, 13811, 13812, 13813, 13814,
   13815, 13816, 13817, 13818, 13819, 13820, 13821, 13822, 13823, 13824,
   13825, 13826, 13827, 13828, 13829, 13830, 13831, 13832, 13833, 13834,
   13835, 13836, 13837, 13838, 13839, 13840, 13841, 13842, 13843, 13844,
   13845, 13846, 13847, 13848, 13849, 13850, 13851, 13852, 13853, 13854,
   13855, 13856, 13857, 13858, 13859, 13860, 13861, 13862, 13863, 13864,
   13865, 13866, 13867, 13868, 13869, 13870, 13871, 13872, 13873, 13874,
   13875, 13876, 13877, 13878, 13879, 13880, 13881, 13882, 13883, 13884,
   13885, 13886, 13887, 13888, 13889, 13890, 13891, 13892, 13893, 13894,
   13895, 13896, 13897, 13898, 13899, 13900, 13901, 13902, 13903, 13904,
   13905, 13906, 13907, 13908, 13909, 13910, 13911, 13912, 13913, 13914,
   13915, 13916, 13917, 13918, 13919, 13920, 13921, 13922, 13923, 13924,
   13925, 13926, 13927, 13928, 13929, 13930, 13931, 13932, 13933, 13934,
   13935, 13936, 13937, 13938, 13939, 13940, 13941, 13942, 13943, 13944,
   13945, 13946, 13947, 13948, 13949, 13950, 13951, 13952, 13953, 13954,
   13955, 13956, 13957, 13958, 13959, 13960, 13961, 13962, 13963, 13964,
   13965, 13966, 13967, 13968, 13969, 13970, 13971, 13972, 13973, 13974,
   13975, 13976, 13977, 13978, 13979, 13980, 13981, 13982, 13983, 13984,
   13985, 13986, 13987, 13988, 13989, 13990, 13991, 13992, 13993, 13994,
   13995, 13996, 13997, 13998, 13999, 14000, 14001, 14002, 14003, 14004,
   14005, 14006, 14007, 14021, 14022, 14023, 14024, 14025, 14026, 14027,
   14028, 14029, 14030, 14031, 14032, 14033, 14034, 14035, 14036, 14037,
   14038, 14039, 14040, 14041, 14042, 14043, 14044, 14045, 14046, 14047,
   14048, 14049, 14050, 14051, 14052, 14053, 14054, 14055, 14056, 14057,
   14058, 14059, 14060, 14061, 14062, 14063, 14064, 14065, 14066, 14067,
   14068, 14082, 14083, 14084, 14085, 14086, 14087, 14088, 14089, 14090,
   14091, 14092, 14093, 14094, 14095, 14096, 14097, 14098, 14099, 14100,
   14101, 14102, 14103, 14104, 14114, 14115, 14116, 14117, 14118, 14119,
   14120, 14121, 14122, 14123, 14124, 14125, 14126, 14127, 14128, 14129,
   14130, 14131, 14132, 14133, 14134, 14135, 14136, 14137, 14138, 14139,
   14140, 14141, 14142, 14143, 14144, 14145, 14146, 14147, 14148, 14149,
   14150, 14151, 14152, 14153, 14154, 14155, 14156, 14157, 14158, 14159,
   14160, 14161, 14162, 14163, 14164, 14165, 14166, 14167, 14168, 14169,
   14170, 14171, 14172, 14173, 14174, 14175, 14176, 14177, 14178, 14179,
   14180, 14181, 14182, 14183, 14184, 14185, 14186, 14187, 14188, 14189,
   14190
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "IDENT", "FCONST", "SCONST", "BCONST",
  "XCONST", "Op", "ICONST", "PARAM", "TYPECAST", "DOT_DOT", "COLON_EQUALS",
  "EQUALS_GREATER", "LESS_EQUALS", "GREATER_EQUALS", "NOT_EQUALS",
  "ABORT_P", "ABSOLUTE_P", "ACCESS", "ACTION", "ADD_P", "ADMIN", "AFTER",
  "AGGREGATE", "ALL", "ALSO", "ALTER", "ALWAYS", "ANALYSE", "ANALYZE",
  "AND", "ANY", "ARRAY", "AS", "ASC", "ASSERTION", "ASSIGNMENT",
  "ASYMMETRIC", "AT", "ATTRIBUTE", "AUTHORIZATION", "BACKWARD", "BEFORE",
  "BEGIN_P", "BETWEEN", "BIGINT", "BINARY", "BIT", "BOOLEAN_P", "BOTH",
  "BY", "CACHE", "CALLED", "CASCADE", "CASCADED", "CASE", "CAST",
  "CATALOG_P", "CHAIN", "CHAR_P", "CHARACTER", "CHARACTERISTICS", "CHECK",
  "CHECKPOINT", "CLASS", "CLOSE", "CLUSTER", "COALESCE", "COLLATE",
  "COLLATION", "COLUMN", "COMMENT", "COMMENTS", "COMMIT", "COMMITTED",
  "CONCURRENTLY", "CONFIGURATION", "CONFLICT", "CONNECTION", "CONSTRAINT",
  "CONSTRAINTS", "CONTENT_P", "CONTINUE_P", "CONVERSION_P", "COPY", "COST",
  "CREATE", "CROSS", "CSV", "CUBE", "CURRENT_P", "CURRENT_CATALOG",
  "CURRENT_DATE", "CURRENT_ROLE", "CURRENT_SCHEMA", "CURRENT_TIME",
  "CURRENT_TIMESTAMP", "CURRENT_USER", "CURSOR", "CYCLE", "DATA_P",
  "DATABASE", "DAY_P", "DEALLOCATE", "DEC", "DECIMAL_P", "DECLARE",
  "DEFAULT", "DEFAULTS", "DEFERRABLE", "DEFERRED", "DEFINER", "DELETE_P",
  "DELIMITER", "DELIMITERS", "DEPENDS", "DESC", "DICTIONARY", "DISABLE_P",
  "DISCARD", "DISTINCT", "DO", "DOCUMENT_P", "DOMAIN_P", "DOUBLE_P",
  "DROP", "EACH", "ELSE", "ENABLE_P", "ENCODING", "ENCRYPTED", "END_P",
  "ENUM_P", "ESCAPE", "EVENT", "EXCEPT", "EXCLUDE", "EXCLUDING",
  "EXCLUSIVE", "EXECUTE", "EXISTS", "EXPLAIN", "EXTENSION", "EXTERNAL",
  "EXTRACT", "FALSE_P", "FAMILY", "FETCH", "FILTER", "FIRST_P", "FLOAT_P",
  "FOLLOWING", "FOR", "FORCE", "FOREIGN", "FORWARD", "FREEZE", "FROM",
  "FULL", "FUNCTION", "FUNCTIONS", "GLOBAL", "GRANT", "GRANTED",
  "GREATEST", "GROUP_P", "GROUPING", "HANDLER", "HAVING", "HEADER_P",
  "HOLD", "HOUR_P", "IDENTITY_P", "IF_P", "ILIKE", "IMMEDIATE",
  "IMMUTABLE", "IMPLICIT_P", "IMPORT_P", "IN_P", "INCLUDING", "INCREMENT",
  "INDEX", "INDEXES", "INHERIT", "INHERITS", "INITIALLY", "INLINE_P",
  "INNER_P", "INOUT", "INPUT_P", "INSENSITIVE", "INSERT", "INSTEAD",
  "INT_P", "INTEGER", "INTERSECT", "INTERVAL", "INTO", "INVOKER", "IS",
  "ISNULL", "ISOLATION", "JOIN", "KEY", "LABEL", "LANGUAGE", "LARGE_P",
  "LAST_P", "LATERAL_P", "LEADING", "LEAKPROOF", "LEAST", "LEFT", "LEVEL",
  "LIKE", "LIMIT", "LISTEN", "LOAD", "LOCAL", "LOCALTIME",
  "LOCALTIMESTAMP", "LOCATION", "LOCK_P", "LOCKED", "LOGGED", "MAPPING",
  "MATCH", "MATERIALIZED", "MAXVALUE", "METHOD", "MINUTE_P", "MINVALUE",
  "MODE", "MONTH_P", "MOVE", "NAME_P", "NAMES", "NATIONAL", "NATURAL",
  "NCHAR", "NEXT", "NO", "NONE", "NOT", "NOTHING", "NOTIFY", "NOTNULL",
  "NOWAIT", "NULL_P", "NULLIF", "NULLS_P", "NUMERIC", "OBJECT_P", "OF",
  "OFF", "OFFSET", "OIDS", "ON", "ONLY", "OPERATOR", "OPTION", "OPTIONS",
  "OR", "ORDER", "ORDINALITY", "OUT_P", "OUTER_P", "OVER", "OVERLAPS",
  "OVERLAY", "OWNED", "OWNER", "PARALLEL", "PARSER", "PARTIAL",
  "PARTITION", "PASSING", "PASSWORD", "PLACING", "PLANS", "POLICY",
  "POSITION", "PRECEDING", "PRECISION", "PRESERVE", "PREPARE", "PREPARED",
  "PRIMARY", "PRIOR", "PRIVILEGES", "PROCEDURAL", "PROCEDURE", "PROGRAM",
  "QUOTE", "RANGE", "READ", "REAL", "REASSIGN", "RECHECK", "RECURSIVE",
  "REF", "REFERENCES", "REFRESH", "REINDEX", "RELATIVE_P", "RELEASE",
  "RENAME", "REPEATABLE", "REPLACE", "REPLICA", "RESET", "RESTART",
  "RESTRICT", "RETURNING", "RETURNS", "REVOKE", "RIGHT", "ROLE",
  "ROLLBACK", "ROLLUP", "ROW", "ROWS", "RULE", "SAVEPOINT", "SCHEMA",
  "SCROLL", "SEARCH", "SECOND_P", "SECURITY", "SELECT", "SEQUENCE",
  "SEQUENCES", "SERIALIZABLE", "SERVER", "SESSION", "SESSION_USER", "SET",
  "SETS", "SETOF", "SHARE", "SHOW", "SIMILAR", "SIMPLE", "SKIP",
  "SMALLINT", "SNAPSHOT", "SOME", "SQL_P", "STABLE", "STANDALONE_P",
  "START", "STATEMENT", "STATISTICS", "STDIN", "STDOUT", "STORAGE",
  "STRICT_P", "STRIP_P", "SUBSTRING", "SYMMETRIC", "SYSID", "SYSTEM_P",
  "TABLE", "TABLES", "TABLESAMPLE", "TABLESPACE", "TEMP", "TEMPLATE",
  "TEMPORARY", "TEXT_P", "THEN", "TIME", "TIMESTAMP", "TO", "TRAILING",
  "TRANSACTION", "TRANSFORM", "TREAT", "TRIGGER", "TRIM", "TRUE_P",
  "TRUNCATE", "TRUSTED", "TYPE_P", "TYPES_P", "UNBOUNDED", "UNCOMMITTED",
  "UNENCRYPTED", "UNION", "UNIQUE", "UNKNOWN", "UNLISTEN", "UNLOGGED",
  "UNTIL", "UPDATE", "USER", "USING", "VACUUM", "VALID", "VALIDATE",
  "VALIDATOR", "VALUE_P", "VALUES", "VARCHAR", "VARIADIC", "VARYING",
  "VERBOSE", "VERSION_P", "VIEW", "VIEWS", "VOLATILE", "WHEN", "WHERE",
  "WHITESPACE_P", "WINDOW", "WITH", "WITHIN", "WITHOUT", "WORK", "WRAPPER",
  "WRITE", "XML_P", "XMLATTRIBUTES", "XMLCONCAT", "XMLELEMENT",
  "XMLEXISTS", "XMLFOREST", "XMLPARSE", "XMLPI", "XMLROOT", "XMLSERIALIZE",
  "YEAR_P", "YES_P", "ZONE", "NOT_LA", "NULLS_LA", "WITH_LA", "'<'", "'>'",
  "'='", "POSTFIXOP", "'+'", "'-'", "'*'", "'/'", "'%'", "'^'", "UMINUS",
  "'['", "']'", "'('", "')'", "'.'", "';'", "','", "':'", "$accept",
  "stmtblock", "stmtmulti", "stmt", "CreateRoleStmt", "opt_with",
  "OptRoleList", "AlterOptRoleList", "AlterOptRoleElem",
  "CreateOptRoleElem", "CreateUserStmt", "AlterRoleStmt",
  "opt_in_database", "AlterRoleSetStmt", "AlterUserStmt",
  "AlterUserSetStmt", "DropRoleStmt", "DropUserStmt", "CreateGroupStmt",
  "AlterGroupStmt", "add_drop", "DropGroupStmt", "CreateSchemaStmt",
  "OptSchemaName", "OptSchemaEltList", "schema_stmt", "VariableSetStmt",
  "set_rest", "generic_set", "set_rest_more", "var_name", "var_list",
  "var_value", "iso_level", "opt_boolean_or_string", "zone_value",
  "opt_encoding", "NonReservedWord_or_Sconst", "VariableResetStmt",
  "reset_rest", "generic_reset", "SetResetClause",
  "FunctionSetResetClause", "VariableShowStmt", "ConstraintsSetStmt",
  "constraints_set_list", "constraints_set_mode", "CheckPointStmt",
  "DiscardStmt", "AlterTableStmt", "alter_table_cmds", "alter_table_cmd",
  "alter_column_default", "opt_drop_behavior", "opt_collate_clause",
  "alter_using", "replica_identity", "reloptions", "opt_reloptions",
  "reloption_list", "reloption_elem", "AlterCompositeTypeStmt",
  "alter_type_cmds", "alter_type_cmd", "ClosePortalStmt", "CopyStmt",
  "copy_from", "opt_program", "copy_file_name", "copy_options",
  "copy_opt_list", "copy_opt_item", "opt_binary", "opt_oids",
  "copy_delimiter", "opt_using", "copy_generic_opt_list",
  "copy_generic_opt_elem", "copy_generic_opt_arg",
  "copy_generic_opt_arg_list", "copy_generic_opt_arg_list_item",
  "CreateStmt", "OptTemp", "OptTableElementList",
  "OptTypedTableElementList", "TableElementList", "TypedTableElementList",
  "TableElement", "TypedTableElement", "columnDef", "columnOptions",
  "ColQualList", "ColConstraint", "ColConstraintElem", "ConstraintAttr",
  "TableLikeClause", "TableLikeOptionList", "TableLikeOption",
  "TableConstraint", "ConstraintElem", "opt_no_inherit", "opt_column_list",
  "columnList", "columnElem", "key_match", "ExclusionConstraintList",
  "ExclusionConstraintElem", "ExclusionWhereClause", "key_actions",
  "key_update", "key_delete", "key_action", "OptInherit", "OptWith",
  "OnCommitOption", "OptTableSpace", "OptConsTableSpace", "ExistingIndex",
  "CreateAsStmt", "create_as_target", "opt_with_data", "CreateMatViewStmt",
  "create_mv_target", "OptNoLog", "RefreshMatViewStmt", "CreateSeqStmt",
  "AlterSeqStmt", "OptSeqOptList", "SeqOptList", "SeqOptElem", "opt_by",
  "NumericOnly", "NumericOnly_list", "CreatePLangStmt", "opt_trusted",
  "handler_name", "opt_inline_handler", "validator_clause",
  "opt_validator", "DropPLangStmt", "opt_procedural",
  "CreateTableSpaceStmt", "OptTableSpaceOwner", "DropTableSpaceStmt",
  "CreateExtensionStmt", "create_extension_opt_list",
  "create_extension_opt_item", "AlterExtensionStmt",
  "alter_extension_opt_list", "alter_extension_opt_item",
  "AlterExtensionContentsStmt", "CreateFdwStmt", "fdw_option",
  "fdw_options", "opt_fdw_options", "DropFdwStmt", "AlterFdwStmt",
  "create_generic_options", "generic_option_list", "alter_generic_options",
  "alter_generic_option_list", "alter_generic_option_elem",
  "generic_option_elem", "generic_option_name", "generic_option_arg",
  "CreateForeignServerStmt", "opt_type", "foreign_server_version",
  "opt_foreign_server_version", "DropForeignServerStmt",
  "AlterForeignServerStmt", "CreateForeignTableStmt",
  "AlterForeignTableStmt", "ImportForeignSchemaStmt",
  "import_qualification_type", "import_qualification",
  "CreateUserMappingStmt", "auth_ident", "DropUserMappingStmt",
  "AlterUserMappingStmt", "CreatePolicyStmt", "AlterPolicyStmt",
  "DropPolicyStmt", "RowSecurityOptionalExpr",
  "RowSecurityOptionalWithCheck", "RowSecurityDefaultToRole",
  "RowSecurityOptionalToRole", "RowSecurityDefaultForCmd",
  "row_security_cmd", "CreateAmStmt", "CreateTrigStmt",
  "TriggerActionTime", "TriggerEvents", "TriggerOneEvent",
  "TriggerForSpec", "TriggerForOptEach", "TriggerForType", "TriggerWhen",
  "TriggerFuncArgs", "TriggerFuncArg", "OptConstrFromTable",
  "ConstraintAttributeSpec", "ConstraintAttributeElem", "DropTrigStmt",
  "CreateEventTrigStmt", "event_trigger_when_list",
  "event_trigger_when_item", "event_trigger_value_list",
  "AlterEventTrigStmt", "enable_trigger", "CreateAssertStmt",
  "DropAssertStmt", "DefineStmt", "definition", "def_list", "def_elem",
  "def_arg", "old_aggr_definition", "old_aggr_list", "old_aggr_elem",
  "opt_enum_val_list", "enum_val_list", "AlterEnumStmt",
  "opt_if_not_exists", "CreateOpClassStmt", "opclass_item_list",
  "opclass_item", "opt_default", "opt_opfamily", "opclass_purpose",
  "opt_recheck", "CreateOpFamilyStmt", "AlterOpFamilyStmt",
  "opclass_drop_list", "opclass_drop", "DropOpClassStmt",
  "DropOpFamilyStmt", "DropOwnedStmt", "ReassignOwnedStmt", "DropStmt",
  "drop_type", "any_name_list", "any_name", "attrs", "type_name_list",
  "TruncateStmt", "opt_restart_seqs", "CommentStmt", "comment_type",
  "comment_text", "SecLabelStmt", "opt_provider", "security_label_type",
  "security_label", "FetchStmt", "fetch_args", "from_in", "opt_from_in",
  "GrantStmt", "RevokeStmt", "privileges", "privilege_list", "privilege",
  "privilege_target", "grantee_list", "grantee", "opt_grant_grant_option",
  "function_with_argtypes_list", "function_with_argtypes", "GrantRoleStmt",
  "RevokeRoleStmt", "opt_grant_admin_option", "opt_granted_by",
  "AlterDefaultPrivilegesStmt", "DefACLOptionList", "DefACLOption",
  "DefACLAction", "defacl_privilege_target", "IndexStmt", "opt_unique",
  "opt_concurrently", "opt_index_name", "access_method_clause",
  "index_params", "index_elem", "opt_collate", "opt_class", "opt_asc_desc",
  "opt_nulls_order", "CreateFunctionStmt", "opt_or_replace", "func_args",
  "func_args_list", "func_args_with_defaults",
  "func_args_with_defaults_list", "func_arg", "arg_class", "param_name",
  "func_return", "func_type", "func_arg_with_default", "aggr_arg",
  "aggr_args", "aggr_args_list", "createfunc_opt_list",
  "common_func_opt_item", "createfunc_opt_item", "func_as",
  "transform_type_list", "opt_definition", "table_func_column",
  "table_func_column_list", "AlterFunctionStmt", "alterfunc_opt_list",
  "opt_restrict", "RemoveFuncStmt", "RemoveAggrStmt", "RemoveOperStmt",
  "oper_argtypes", "any_operator", "DoStmt", "dostmt_opt_list",
  "dostmt_opt_item", "CreateCastStmt", "cast_context", "DropCastStmt",
  "opt_if_exists", "CreateTransformStmt", "transform_element_list",
  "DropTransformStmt", "ReindexStmt", "reindex_target_type",
  "reindex_target_multitable", "reindex_option_list",
  "reindex_option_elem", "AlterTblSpcStmt", "RenameStmt", "opt_column",
  "opt_set_data", "AlterObjectDependsStmt", "AlterObjectSchemaStmt",
  "AlterOperatorStmt", "operator_def_list", "operator_def_elem",
  "AlterOwnerStmt", "RuleStmt", "RuleActionList", "RuleActionMulti",
  "RuleActionStmt", "RuleActionStmtOrEmpty", "event", "opt_instead",
  "DropRuleStmt", "NotifyStmt", "notify_payload", "ListenStmt",
  "UnlistenStmt", "TransactionStmt", "opt_transaction",
  "transaction_mode_item", "transaction_mode_list",
  "transaction_mode_list_or_empty", "ViewStmt", "opt_check_option",
  "LoadStmt", "CreatedbStmt", "createdb_opt_list", "createdb_opt_items",
  "createdb_opt_item", "createdb_opt_name", "opt_equal",
  "AlterDatabaseStmt", "AlterDatabaseSetStmt", "DropdbStmt",
  "AlterSystemStmt", "CreateDomainStmt", "AlterDomainStmt", "opt_as",
  "AlterTSDictionaryStmt", "AlterTSConfigurationStmt", "any_with",
  "CreateConversionStmt", "ClusterStmt", "cluster_index_specification",
  "VacuumStmt", "vacuum_option_list", "vacuum_option_elem", "AnalyzeStmt",
  "analyze_keyword", "opt_verbose", "opt_full", "opt_freeze",
  "opt_name_list", "ExplainStmt", "ExplainableStmt", "explain_option_list",
  "explain_option_elem", "explain_option_name", "explain_option_arg",
  "PrepareStmt", "prep_type_clause", "PreparableStmt", "ExecuteStmt",
  "execute_param_clause", "DeallocateStmt", "InsertStmt", "insert_target",
  "insert_rest", "insert_column_list", "insert_column_item",
  "opt_on_conflict", "opt_conf_expr", "returning_clause", "DeleteStmt",
  "using_clause", "LockStmt", "opt_lock", "lock_type", "opt_nowait",
  "opt_nowait_or_skip", "UpdateStmt", "set_clause_list", "set_clause",
  "single_set_clause", "multiple_set_clause", "set_target",
  "set_target_list", "DeclareCursorStmt", "cursor_name", "cursor_options",
  "opt_hold", "SelectStmt", "select_with_parens", "select_no_parens",
  "select_clause", "simple_select", "with_clause", "cte_list",
  "common_table_expr", "opt_with_clause", "into_clause",
  "OptTempTableName", "opt_table", "all_or_distinct", "distinct_clause",
  "opt_all_clause", "opt_sort_clause", "sort_clause", "sortby_list",
  "sortby", "select_limit", "opt_select_limit", "limit_clause",
  "offset_clause", "select_limit_value", "select_offset_value",
  "opt_select_fetch_first_value", "select_offset_value2", "row_or_rows",
  "first_or_next", "group_clause", "group_by_list", "group_by_item",
  "empty_grouping_set", "rollup_clause", "cube_clause",
  "grouping_sets_clause", "having_clause", "for_locking_clause",
  "opt_for_locking_clause", "for_locking_items", "for_locking_item",
  "for_locking_strength", "locked_rels_list", "values_clause",
  "from_clause", "from_list", "table_ref", "joined_table", "alias_clause",
  "opt_alias_clause", "func_alias_clause", "join_type", "join_outer",
  "join_qual", "relation_expr", "relation_expr_list",
  "relation_expr_opt_alias", "tablesample_clause", "opt_repeatable_clause",
  "func_table", "rowsfrom_item", "rowsfrom_list", "opt_col_def_list",
  "opt_ordinality", "where_clause", "where_or_current_clause",
  "OptTableFuncElementList", "TableFuncElementList", "TableFuncElement",
  "Typename", "opt_array_bounds", "SimpleTypename", "ConstTypename",
  "GenericType", "opt_type_modifiers", "Numeric", "opt_float", "Bit",
  "ConstBit", "BitWithLength", "BitWithoutLength", "Character",
  "ConstCharacter", "CharacterWithLength", "CharacterWithoutLength",
  "character", "opt_varying", "opt_charset", "ConstDatetime",
  "ConstInterval", "opt_timezone", "opt_interval", "interval_second",
  "a_expr", "b_expr", "c_expr", "func_application", "func_expr",
  "func_expr_windowless", "func_expr_common_subexpr", "xml_root_version",
  "opt_xml_root_standalone", "xml_attributes", "xml_attribute_list",
  "xml_attribute_el", "document_or_content", "xml_whitespace_option",
  "xmlexists_argument", "within_group_clause", "filter_clause",
  "window_clause", "window_definition_list", "window_definition",
  "over_clause", "window_specification", "opt_existing_window_name",
  "opt_partition_clause", "opt_frame_clause", "frame_extent",
  "frame_bound", "row", "explicit_row", "implicit_row", "sub_type",
  "all_Op", "MathOp", "qual_Op", "qual_all_Op", "subquery_Op", "expr_list",
  "func_arg_list", "func_arg_expr", "type_list", "array_expr",
  "array_expr_list", "extract_list", "extract_arg", "overlay_list",
  "overlay_placing", "position_list", "substr_list", "substr_from",
  "substr_for", "trim_list", "in_expr", "case_expr", "when_clause_list",
  "when_clause", "case_default", "case_arg", "columnref", "indirection_el",
  "opt_slice_bound", "indirection", "opt_indirection", "opt_asymmetric",
  "ctext_expr", "ctext_expr_list", "ctext_row", "opt_target_list",
  "target_list", "target_el", "qualified_name_list", "qualified_name",
  "name_list", "name", "database_name", "access_method", "attr_name",
  "index_name", "file_name", "func_name", "AexprConst", "Iconst", "Sconst",
  "SignedIconst", "RoleId", "RoleSpec", "role_list", "ColId",
  "type_function_name", "NonReservedWord", "ColLabel",
  "unreserved_keyword", "col_name_keyword", "type_func_name_keyword",
  "reserved_keyword", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
      60,    62,    61,   695,    43,    45,    42,    47,    37,    94,
     696,    91,    93,    40,    41,    46,    59,    44,    58
};
# endif

#define YYPACT_NINF -4460

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-4460)))

#define YYTABLE_NINF -2417

#define yytable_value_is_error(Yytable_value) \
  (!!((Yytable_value) == (-2417)))

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const int yypact[] =
{
    9188,    26,  8746, -4460, -4460,    26, -4460, 63442,    29,   586,
      78,   168, 13498, 63876, 70386,   542,   341, 12595,    26, 70386,
    1868, 48686, 60404,   797, 70386,   975,   714, 48686, 70386, 70820,
     842,   902,   914, 71254, 64310, 59102,   972, 70386,   916,   894,
   71688, 64744,   781, 65178,   714, 45224,   130,   819, 72122, 70386,
    2131,  1212,   873, -4460, -4460, -4460, -4460, -4460, -4460, -4460,
   -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460,
   -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460,
   -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460,
   -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460,
   -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460,
   -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460,
   -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460,
   -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460,
   -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460,
   -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460,
   -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460,    29,
   -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460,
    1966, -4460,   963,  2065,  1250,   871,  1014, -4460, -4460, -4460,
   56932, 70386, 70386, 70386,  1083, 70386,  1133, 70386,   427, 56932,
   52592, 65612,  1265,  1158, 41746, 72556, -4460, 51290, 70386, 70386,
   72990, 70386,  1400, 61706, 70386,  1473, 70386, 70386, 53026, 73424,
    1619,  1344, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460,
   -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460,
   -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460,
   -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460,
   -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460,
   -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460,
   -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460,
   -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460,
   -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460,
   -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460,
   -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460,
   -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460,
   -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460,
   -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460,
   -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460,
   -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460,
   -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460,
   -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460,
   -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460,
   -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460,
   -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460,
   -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460,
   -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460,
   -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460,
   -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460,
   -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460,
   -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460,
   -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460,
   -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460,
   -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460,
   -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460,
   -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460,
   -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, 70386,
    5498,   975, -4460, -4460,  2131, 70386,  1360, 56932, 70386,  1403,
   70386,  1460, 70386, -4460, 70386,  1512, 73858,   446,  1308, 52592,
    1657, 42181,  1598, 70386, 52592, 74292, 70386, 70386, -4460, -4460,
    1612, 70386, 70386, -4460,  1721, 53460,  1443,  1737,  1830,  1793,
     885, -4460, 66046, -4460, -4460, -4460, -4460, -4460, -4460, -4460,
   -4460, 56064,   341, -4460, -4460,  1765, 57366, 70386,  1831, -4460,
   -4460, 74726, 89868,  1608, -4460,   451, 57800, 53894,  1906,  1604,
   42616,  2000, 75160, 54328, 75594, -4460, -4460, 76028, -4460, 76462,
    1732,  1831, 76896, 90290, 54762, -4460,  1874, 77330, -4460,  1634,
    1329,  1463, 37807, -4460, -4460, -4460,    29, -4460, -4460, -4460,
   -4460, -4460, -4460, -4460, -4460,   310,   260,   209,   201,   333,
   -4460, -4460,   205,   212,   225,   310,  2074,  2074, -4460, 70386,
   -4460, -4460,   260,   598,  1640,  1640,  1640,  1837,   895, -4460,
    1640,  1777, -4460, -4460, -4460, -4460, 65178, -4460,  1665,   975,
    1693,  2098,  1743, -4460, -4460, -4460, -4460, -4460,  1767, 70386,
   70386, 70386, -4460, -4460,  2128,  1745,  1978,  1736, -4460, -4460,
   -4460,  1959,  1967,  1939,    84,   975,  1853, -4460,  2082, -4460,
    1982, 27559, 27559,   975, 66480, 77764,   249, 56064,   975, 66914,
    1807,  1177,  1987, -4460, -4460, -4460,   412, -4460,  2209,  1820,
    2056,  1736,  1344, 39117, -4460,  1835,  1482, 65178, -4460, -4460,
   -4460,   221,  2109, 28010, -4460, 70386,  1836, -4460,  1851,  1836,
    1864,  1878,  1250, -4460,  9188, 70386,  1211,  1211,  2270,  1211,
    1369,  1613, -4460,  2360, -4460,  2179,  2146, 65178,   819,   214,
   -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460,
   -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460,
   -4460, -4460, -4460,  1897,  1482, -4460,   224, -4460,  1357,  1917,
    1516,  1757, -4460, -4460,   235, 70386,  2032,   204,    49,  1962,
   67348,  2242,  1948, -4460, -4460, -4460,  2083,   918, -4460, -4460,
   -4460, -4460,  2256,  2299,  3874,   258, 67782, -4460, -4460, -4460,
   -4460, 70386, 70386, -4460, -4460, -4460, -4460, -4460, -4460, -4460,
   -4460, -4460,  2012, -4460, -4460,  1992,  2341,  2234,  2314,  2192,
    1052,  2259,   141,  2371,  6915,  1280, 68216, 70386,  2321,  2382,
    6976,  1531,   202,  2269,  1009,  2376,  2226,  1382,  2397,  7410,
   70386, -4460,  2325,  2458,   604, -4460,   119, -4460,  2175,  2315,
      60,  2353, 56932,  2135, -4460, -4460, 70386, -4460, -4460, 90712,
    2211, -4460,   478, 56932, -4460,  2335,  2187, 43051, 70386, -4460,
   70386, -4460, -4460, -4460, -4460, -4460,  2279,  2459, 70386, 90712,
   -4460,  2404, 70386, -4460,  2165, -4460, -4460, -4460, -4460,  1640,
   70386,  2170,  2561, 90712,   165, 70386,  1420,  2592, 70386,  2387,
    1420,  2215, 78198, -4460, -4460,  1420, -4460, -4460, -4460, 70386,
   70386,  2185,  1186,  2379,  1420,  2399,  2608,  2618,  2275,  2400,
     876,   865,   185,  2537,  1420,  2282, 78632, 79066, 70386,  2297,
   70386,  2637, 56932, 70386,  2562, -4460,  2424, -4460, -4460,  1184,
   -4460, -4460, -4460, -4460, -4460,  2576,  1897,   758,  2578,  2274,
    2580, -4460, -4460, -4460,  2320, -4460,  2320,  2320,  2276,  2276,
    2437,  2277,  2590, -4460, -4460, -4460,  1234,  2320,  2276, -4460,
   91556, -4460,  1508,  1555, -4460,   227, -4460,  2699, -4460, -4460,
   -4460, -4460, -4460, -4460, -4460, -4460,   142, -4460,   944,  1614,
   -4460, -4460,  2312, -4460,  2593,  1948,  2595, -4460,  2281, 79500,
   -4460, 79934, 80368,  2597,  2012, 52592,  2598,  2476,  2599,  2281,
    2600,  2483,  2604,   758,  2605, -4460,   919,  2596,  2610,  2493,
    2615,   227,  2617,  1709,  2281, 56498,  2619,   283, -4460, 29814,
   -4460,  2402, -4460,   819, -4460,  1542, -4460, 47818, -4460,  1463,
     260, -4460, 70386,   260, 70386,   260, 70386,   260, 70386,   260,
   70386, 70386, 70386,   260, -4460, -4460, -4460, 70386,  2316, 70386,
   70386, -4460, -4460, -4460, 60838, 52592, 61272, -4460, 70386, -4460,
      97,   975, -4460, -4460, 90712,  2730, 52592,  2637, -4460,  1556,
   -4460, -4460, -4460, -4460, -4460, -4460,  2555, 70386,  2620,  2627,
   60838, 52592, -4460, 80802, 56064,  2512,  2330, -4460, -4460, -4460,
   -4460, -4460,  1715,  2768,   286,  2781, 29814,  2337,   270,   270,
    2339,  2634, -4460, -4460, -4460,   234,  2342,  2344, -4460,   240,
     240,  2345,  2346, -4460,   248,  2347,  2348,  2789,  2797,   266,
    2351,  2354,  2355,  1234,   270, 29814, -4460,  2359,   240,  2361,
    2363,  2365,  2801,  2366, -4460,  2816,  2369,   298,   309,  2372,
    2374, -4460,  2345, -4460,   239,  2375,  2377,  2378,  2380,  2381,
    2383,  2388,  2389, 29814, 29814, 29814, -4460, 26206,  1482,   975,
   -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460,   279,  5331,
   -4460,  2405, -4460, -4460,  2558, -4460, -4460, 29814, -4460, -4460,
      79, -4460,   280, -4460, -4460, -4460,  1482,  2640,  2390, -4460,
   -4460,   740,  2391, -4460,  1840, -4460, -4460, -4460, -4460, -4460,
   -4460, 55196,  2809, -4460,   331,   975,   119,   322,  2753, 46950,
   47384, -4460, -4460,  2630, -4460, 70386, -4460, -4460, 29814, 44790,
   -4460,  1482,   122, -4460, -4460, -4460, -4460,  1562, -4460, -4460,
   -4460,    29, -4460, 13145, -4460,  1582,  1836, 70386, 70386,  2814,
   -4460, -4460, -4460,  1851, -4460, -4460,  1250,  1250, 29814,  1250,
    1023,  1242, 28461, 29814,  2696,  2601,   251,  1263,  2697, -4460,
    2602,  1369,  1613, 65178, 70386, 81236,  2513, -4460, 45658,  1538,
    1482,  2477,  2485,  2536, 49554,  2409,  2489,  2491,  2541, -4460,
    2651, -4460, -4460,  2495,  2496, 81670, -4460, -4460,   852, -4460,
   -4460, -4460,   852, -4460,  2433,  1495,   924,   264,  2501,   387,
     199,  2798, -4460,  1406,  2553, -4460, -4460, -4460,  5497, 70386,
    2741,  7713,  2624,   258,  2632,  2572, -4460, -4460,  2691,  2534,
   70386,  2535,  2661,   258,   288, 82104, -4460, -4460, -4460, -4460,
   -4460, -4460,  4848, 24911, -4460,  2542,  2515,  2547, 70386, 58234,
     348,  2657,  2659,  1218,   363,   510,  2603, 70386,  1499,  2664,
   70386,  2468,  2554,  2559,  2749,  2484,  1564,  2848,  2479, -4460,
   -4460, -4460,  1258,  2665, -4460,  2759,  2803,  4990,  2557,  2563,
   89024,  1222, 43486, 70386, 70386,  2850,  1476,  2584, -4460, -4460,
   -4460,  1476, 70386,  2585,  2588, 70386,   258, -4460,  2914,   258,
     258,  1630,  2917,  2609,   376,  1455,  1420,  2479,  1333, -4460,
    2621,  2625,   826, -4460,  2706, -4460, -4460,  1121,  2607, 65178,
     256,  1551,  2479,  2626,  2628,  2484,  2484, 70386, 70386, 70386,
   70386, 70386,   173,  2930,  2932,  2629,   193,  2649,  2520, -4460,
   51724,  2631, 77764, -4460, -4460, 70386,  2635,  1567,  2479,  1046,
    1603, -4460, -4460, -4460,  1344, -4460, 70386, -4460, 70386, -4460,
    1897, 90712,  2719,  2778, -4460,  2564, -4460,  1948,   258, -4460,
   70386, 70386,  2012,  2724,  1220,   921, 90712,  2733,  2793, 70386,
    2794,  2636,  2606,  2622, 46087, -4460,  2185,  2565,  2971, 70386,
   49554, -4460,  2986,   852, -4460, 90712,  2754,  2873, -4460, 70386,
    2770,  2569, -4460,  2908,  2638, -4460, -4460,   631, 70386, -4460,
    2883, 52592,   306,   975,  2616, 52592,  2804, 70386, 70386, 70386,
   70386, -4460, -4460,  2774,   893,   152, -4460, 51724, -4460, 70386,
    2787,  1333,  2800,  3009,    98,  1640, 82538,  2894, -4460, 82972,
    2613,  3014, 90712,  2842, -4460,  1718, -4460,  2723, -4460, 56932,
     758, -4460, -4460, -4460, -4460, 90712, 70386, -4460,  2614, -4460,
   -4460, 29814, -4460, -4460, -4460,  2074, -4460, 90712,  2320,  2320,
   -4460, -4460,  3018,  2681,  2684,  2074, -4460,  2074, -4460, 90712,
   -4460,  2611,  2612,  2721,  2074, -4460,  2685,  2692,  2693, -4460,
    2623,  2694,  2074, -4460, -4460,  1827, -4460, 83406, 56932,   758,
   52592, 52592,  2933,   283,  2936,  2673,  2937,  2678, 43486,   758,
     382, 70386, 70386, 52592, 70386, 70386, 70386, -4460, 70386, -4460,
   -4460, -4460, -4460, 90712, 70386, 70386, 90712, -4460, 52592, 51724,
    2938,  2940,   758, 70386, 70386, -4460, 13145,  1600, 83840,  1463,
   55630, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, 70386,
   -4460, 70386, -4460, 70386, -4460, 70386, -4460, 70386, -4460, -4460,
   -4460, 70386, -4460, 70386,  1602, -4460, -4460,  1606,   815, 70386,
   70386,   192, 56932, 70386,  2828, 70386, 70386, 70386, 70386, 70386,
    2708,  2391,    -2, -4460,  1145,   779, 65178,  2838, -4460, -4460,
    1611,  2131,  1019, 70386,  1139,  1767, -4460, -4460, 61272, 60404,
    2931,   176, 70386, -4460, -4460,  4704, 29814,  1482, 27108, -4460,
   -4460, 13145,  2675, 29814, 29814,  2639,  2074,  2074, -4460,   835,
   29814, 29814, 29814,  2074,  2074,  4257, 29814, 43486, 29814, 32971,
   23133, 29814, 29814, 26657, -4460, 29814,  2853, 34318, 29814,   322,
    2855, 29814,   322,  4257,  3083,  3083,  1780,  5640,  2642,  1482,
   -4460,  2074,  1027, -4460,   232, 90712, 29814, 29814, 29814, 29814,
   49554,  2722,   230, 70386, 29814,  2647,  1195, -4460, 29814, -4460,
    2648, 29814,  2726,   811, 29814, 29814, 29814, 29814, 29814, 29814,
   29814, 29814, 29814, -4460, 35190,   267,  2928,  2953,   571,   453,
   68650, 27559,  2945, 22229, -4460,   271,  2945, -4460, -4460, -4460,
   70386,  2809, -4460, -4460,  2727, -4460, -4460, -4460, -4460, -4460,
     291, -4460, -4460, -4460, -4460, -4460, -4460, -4460,  2652, -4460,
   -4460, -4460, -4460,  2652, -4460,  2654,  8982,  2655, -4460, -4460,
   -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460,
   -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460,
   -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460,
   -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460,
   -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460,
   -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460,
   -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460,
   -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460,
   -4460, -4460, -4460, -4460,  2941,  2943,   758, 70386,   221, 62140,
   -4460, 28010, -4460,  1621, -4460,  2653, -4460,  2924, -4460,  2672,
   -4460, 10436,  2924, -4460, -4460,   308,  2772,  2926,  2869, -4460,
   -4460, -4460,  2676, 13145, -4460,  1378, 13145,  1402, -4460, -4460,
   -4460, -4460, -4460, -4460,   809, -4460, 70386,   990,  2696,  1263,
    2735,   498,  3100, 70386, -4460, 39553,  2868, -4460,  3086, -4460,
   91556, -4460,  2686, -4460, 91134, 87746, -4460, -4460,   732, -4460,
     716,  2763,  2765,  2822, 52592, 70386, 70386, -4460, 49554, 52592,
   70386, 70386, -4460, 52592, 70386, 70386, -4460, -4460, -4460, -4460,
   -4460, 48252,   659, 60404,  2823, 59536, -4460, -4460,  2690, 70386,
    2752,  2946,  2947,    13, -4460, -4460, 84274, -4460,  2903, 52592,
   70386, 70386, 29814,  2904, 70386, 70386, -4460,   276,  2780,  2782,
   -4460, 70386,  2783,  2925, 56932,  2707, 70386, 70386, 90712,  2784,
     717, 56932,  2750, 43921, 70386, 70386, 70386, 70386,  2833,  3012,
   90712, 70386,  2959,  1213, 65178,   174,  1826,  2479,  2920, -4460,
    3024,  1072, -4460, 52592, -4460, 70386,  2912, -4460, -4460, -4460,
   69084,  3131,  2826, -4460, -4460, 84708, -4460, -4460, -4460,  1622,
   -4460, 52592, 52592, 70386,  8640, 85142,   827,  2934, -4460, -4460,
   90712, -4460, 70386, 70386, 70386,  3032,  2963, 70386, 62574, 85576,
   86010,  1138,  1214,  2965, 70386, 63008,  2966, -4460,  2875, 70386,
   -4460, -4460, 49988, 52592, 70386,   941, 49554, -4460, -4460, 70386,
   -4460,  2944,   328, -4460, 70386,  2385, -4460,  2824,  2831, 70386,
    2942,   188,  1871,  2479, 70386, 70386,  2748,  1623,  2830,    48,
   -4460,  2948,    89, 70386, -4460, 52592,   904, -4460,  2895, 52592,
   70386, 11663, -4460, -4460,   258, -4460, -4460, -4460, -4460, -4460,
   70386, 70386,   258, 70386,   258,  1090, -4460, 52592, 70386, -4460,
   -4460, -4460, 70386,  9429, 70386, 70386, 70386, 70386, 52592, 70386,
   -4460, -4460,  1185,  1037,  1064,  1388,   222, 70386,  3034, 70386,
   86444, 52592, 70386, 70386, 70386,   369, -4460,  2874, -4460, 52592,
     904,  9859, 70386, 70386,  2835,  2836,   207,  2915, -4460, -4460,
   -4460, -4460, -4460, -4460,  3013,  3179, 86878,   859, -4460,  3015,
    3016,  2817,  2821,  3019, 70386,   859, 70386, -4460, -4460, -4460,
   -4460,  3017, 70386,   859,  3020,   859,  2929,  2967,   148,  3043,
    2790,  1662, -4460, -4460, 29814, 90712, -4460,  1667, -4460,  2796,
     893, -4460, -4460, 49554, 70386,   219,   187,  3093, 58668,  1506,
    3082, 70386,  2837, 70386,  3085,  1506, 70386, -4460,  1809, 60404,
   -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460,  3091,
   -4460,   975,  2185,  2185,  2185,  2185, -4460, -4460, -4460, -4460,
    2985,  1645, -4460,  2799,  2185, 70386,  2906,  1506,  2805,  3107,
   -4460,  1333,  3108,  1060, 70386, 58668,  1856,  2839,  3005,  3218,
    1640,   975,  3008,  2996, -4460, 25333,  6179,  2999,  3052, 56064,
    3089,  3090,  3110, -4460,  1897, -4460,  3230, -4460, 29814,  1669,
    2812,   227, -4460, -4460,  2818,  2612,  2834,  2843,  2813,  2819,
   -4460,  2074,   231, 70386,  2827,  1042,   608,  2950,  2074,  3035,
    2829, -4460,  3136,   758,  1948, -4460,  2281, -4460, 70386, -4460,
   70386, 70386, 70386, 70386,  2012, -4460, -4460,  3025,   758,  2281,
    3026,   758,   758, -4460,  3080,  3029,   758,   227,  2281,  2954,
    3138, 56064, -4460,   283, -4460, -4460, 29814,  3045,  1640, -4460,
   -4460, -4460, -4460, -4460, -4460, -4460, -4460,  1685, -4460, 70386,
   -4460,  3114,  3115,  3116,  2844,  2845,  2877, 70386,  2846, -4460,
    2844,   258,  2844,  2391,  2391,  2844,  2845, 52158,  3281,  3141,
   -4460,  2939,  2854,  3150,   774, -4460,   824,   986,  3075, -4460,
   -4460, -4460, -4460, 90712, -4460, 52592,  2896, 70386, 70386, -4460,
     143,  3056,  2860, 52158,  3267,   758, -4460, 56932, -4460, -4460,
   90712,  2949,  2955, 56932,  3066,  2911, -4460, -4460, -4460, -4460,
   -4460, 90712, -4460,  3117, 70386,  1702, -4460, -4460,  1487, -4460,
    1496, 29814,   345, -4460, 11441,  1706, 29814,  2872,  2878, -4460,
   -4460, -4460, -4460, -4460, -4460, -4460,  2879,  3164, -4460,  1720,
    1729,  1735,  2881,  2882,  4306,  2884, 11507,  2886,  2888, 32971,
   32971, 26206,  1188, -4460, 32971,  2889,  3057,  1739,  6339,  2870,
    2890, 11551, 28912, 29814, 28912, 28912, 12194,  2870,  2892,  1749,
   49554,  3058, 12301,  1751, -4460, 29814, 49554,  4847, 29814, -4460,
   29814,  2893, -4460, -4460,  2594,  2594,  2594,  4257, -4460,  2913,
   -4460, 32971, 32971, -4460,  2441, 26206, -4460, -4460,  3172, -4460,
   -4460,  1547, -4460,  2899, -4460, -4460,  3137, 43486,  2679, 29814,
     265, 29814,  2647, 29814,  2977,  2594,  2594,  2594,   402,   402,
     287,   287,   287,  1795,   453, -4460, -4460, -4460,  2902,  2918,
    2919,  3096,  2921, 29814, -4460,  1942,  1956, 70386,  2656,  3175,
    3756, -4460, -4460, -4460, 36063,  2952, 29814, 29814, 29814,  2905,
   -4460,  1766, 13145,   609, -4460,   292,  2952, -4460,  1344,  2074,
    1027, 47818, -4460, -4460, 29814, -4460, -4460, -4460,  1851, -4460,
   -4460, -4460, -4460, -4460, 70386,  2131, 29814, -4460, -4460,  2453,
    2951, 29814,  1378, -4460, -4460,  2972, -4460, 29814, -4460, -4460,
   -4460,  2391, -4460,  3142, -4460, -4460, -4460, 36063,  2970,  2973,
   38680,  3126, -4460, 70386, -4460, 70386,   157, -4460, -4460, -4460,
    2956, -4460, -4460, 87746,  1614, -4460, 91134, -4460, 91134, -4460,
    1614,  3318, -4460, 87746,  1497, 52592, 70386, 70386, -4460, -4460,
   -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460,
   -4460, 52592, 52592,  3127, 70386,  3125,  3130, 29814,   955, 70386,
    2958,  2961,  1166,  3207, 70386, -4460,  3250,   758, -4460, -4460,
    3021, -4460, 13145, -4460, -4460, -4460, -4460, -4460, 52592, 70386,
   -4460, 56064, -4460, 70386,  1897, 90712, -4460, -4460, -4460, 70386,
    2974, 70386, -4460, 70386, 70386, 70386,  2012, -4460, -4460, -4460,
   -4460,  1010, 90712, -4460, -4460, 70386, 70386,   140,  3027,  3028,
   70386, -4460,   934,  2706, 10714, 70386, 70386, 70386,  3202, 70386,
   -4460, -4460, -4460, -4460,  3144, -4460, -4460, 87746, -4460,  2281,
    1085,  3030,  2479,  3154, -4460,  3260,  3145, -4460,   995, -4460,
   70386,  3074, -4460, -4460, -4460, -4460,  3266,   758,  3270,   758,
   70386, 70386, 70386, 70386,  3084, -4460, -4460, -4460, -4460,  3087,
    3200, -4460, 49554, 49554, 49554,  1753, -4460, -4460,   975, -4460,
   -4460, -4460, -4460, -4460, -4460,  3233, -4460,  1755, -4460,   -12,
   -4460, -4460, -4460, -4460, -4460, -4460, 52592, 70386, 11017,  3275,
   70386, 70386, 70386,  1586, -4460,   769, 90712, -4460, 89446, 52592,
   70386, 49554, 70386,  3044, 52592,  3022, -4460, -4460, -4460,  3204,
    3146, -4460,   899,  3156, 52592,  3038, -4460,  3061, -4460, -4460,
    3063,  1958,  2479,  1333, -4460, -4460, -4460, -4460, -4460, -4460,
   -4460, -4460,  1106,   405,  2020,  2479,  3064, -4460,  3067, -4460,
   -4460, -4460,  3214,  3216,  3217,  3071,  3072,  3122,  3076,  3077,
    3123, -4460,  3078,  3129,  3081,  3134,  3198,  3092,   758, 90712,
    3223,   975,  3124,  3320,   758, -4460,  3095, -4460, -4460,  3431,
   -4460, 70386, -4460,  3097,  2177,  2479, -4460, -4460, 52592, 70386,
   -4460, -4460, -4460,   859, 90712, 70386,  3272, -4460, -4460, -4460,
     859,   859, 70386, 70386,   859,  3273, -4460,  3274, 70386,  3276,
   -4460,   859, -4460, -4460,   237, -4460, -4460, -4460,  2929,  3311,
   41311, -4460,  3480,  5679,  3031, -4460, 49554, 41311,  1714,  1419,
     393,  1420, -4460, 56064, 70386, 56064, -4460,   187,  3145, 70386,
   70386,  3039,  3037, -4460, -4460, -4460, -4460, 52592,   656, 52592,
    2074, -4460, -4460,  3102, -4460, 70386,  1640,   238,  3113,  3453,
    2618,   306,  3185,  1515,  3395,  2839, -4460, -4460, -4460, -4460,
   70386, 70386,   893,   975, -4460,  3046,  3042, -4460, 70386, 70386,
   70386, 70386, 70386,  2896,  3049,  3050, 90712,   364,  3244,  3245,
    2484,  3471,  3366,  2131,  2839,  3133,  3370, 70386, -4460,  1761,
     124, -4460,   975, 56064, 88168,  3359, -4460,  6126, -4460, -4460,
     933, 70386,  3349, -4460, -4460,  2131,   758, 90712,  1763, -4460,
   -4460, -4460,  2074, -4460, -4460,  1353,  1353,  3068, -4460,  3069,
   -4460,  3457, -4460, -4460, -4460, -4460, -4460, -4460,  3070, -4460,
   -4460, 70386, -4460,   758,   283,  3128,   758,  3132,   758,   758,
   70386, -4460, 70386, -4460, -4460, 70386, 70386, -4460, -4460, 70386,
   51724,   758, -4460, 13145,  3380, -4460, -4460,  3196,  3199,  3203,
   70386,  2844, 56932, -4460,  3079, 52592,  1134, -4460, -4460,  3269,
   -4460, -4460, 65178,  3193, -4460, -4460, -4460, -4460,  3393,  3398,
   -4460, -4460, -4460,   253, -4460, -4460, -4460, 52592, 60838,   458,
   52592, -4460,  1897,  3337, -4460, -4460,  1948,   258, -4460,  3339,
   70386,  3340, -4460, -4460, -4460,  3098, 12971, 29814, -4460,  3414,
   90712, -4460,  5986, -4460, -4460, -4460, 29814, -4460, -4460, -4460,
   -4460, -4460, 29814, -4460, 29814,  3389, -4460, 23585,  3539,  3539,
    3094, 90712, 32971, 32971, 32971, 32971,   252,  2361, 32971, 32971,
   32971, 32971, 32971, 32971, 32971, 32971, 32971, 33873,   501, -4460,
    3282, 29814, 29814,  3400,  3389, -4460, 90712,  3103,  2870,  3104,
    3105, 29814, -4460, -4460,  1783, 34754,  3106, 49554, -4460, 29814,
   10485,  1804,  3151, 13023,  1482,  6306,   975, 29814,  2237,  2747,
   29814,  1808, 29814,  3403, -4460, -4460, -4460,  3099, -4460, -4460,
   90712, 29814,  3109,  3588, 32971, 32971,  3719, -4460,  4208, 29814,
   26206, -4460,  3299,  3152, 39989, -4460, 24037,  3111,   714,   714,
     714,   714, -4460, 70386, 70386, 70386, 36499,  3410, 35626, 69518,
    3118,  1355, -4460, 69518, 69952, -4460,  3139, -4460,  3119,  1482,
   29814,  3404,   760,   760,  3299, -4460, 29814, 29814, 29363,  3135,
   -4460,  3404,   119,  3140, -4460, -4460, 13145,  3121, -4460, -4460,
    3143, -4460,  3147, -4460,  2951,  1384, -4460,  6592,  3309, -4460,
   -4460, -4460,  3118, 30265,  3261, -4460,  1814, -4460, -4460,  3497,
    3261, -4460, -4460,  1821, 39553,  2970, 28010,  1482,  1838,  1552,
   -4460, -4460, 87746, -4460,  3194, -4460, -4460, -4460,  2281,  2281,
     150,  2844,  3425,   150,  7165, -4460, -4460, 36935, 70386, 70386,
   -4460, 70386,  1844,  1553, 70386, -4460, 70386, -4460, -4460, -4460,
   -4460, -4460,  3552, -4460, 70386, -4460, -4460,  3189,  3192, -4460,
   70386, 70386, 70386, 70386,  3387, -4460, -4460,  1917, -4460, -4460,
   52592, 70386, -4460, -4460, -4460,   250,  2336,  2479, -4460,  3222,
   -4460, -4460, -4460,  3409, -4460,  3550,  3235, 70386,  3462, 70386,
    3155, -4460,  1553,   784,  2484,   164, -4460, -4460,  3219, -4460,
   -4460, 70386, -4460, 70386, -4460, -4460, -4460, -4460, -4460, -4460,
   -4460,  3278, -4460, -4460, -4460, -4460, 49988, -4460, -4460, 70386,
   -4460, 49554, 41311, 49554, -4460,  1146,   367,  2539,  2479, 70386,
   -4460,  3231, -4460,  3234,  3236,  3284,   149,   211,  3237,  3240,
    3290,  3165,  3166,  3167, -4460, -4460,  1845, -4460,  3176,  3313,
   70386,  2281,  3170,  3206,   310,   975, -4460, -4460,   975,  2281,
     975, 70386, 70386, 70386,  3573,  3259, 70386, 70386, 70386, 70386,
   70386, 70386,  3478,   194,  1746, 52592, 70386, 70386, 52592, 70386,
   70386, 70386, 70386, 70386, 70386,  3489, 70386, -4460,  3565,  3495,
    1617,  3536,  3253, 70386, -4460, 70386,  2706, 70386, 70386, -4460,
   -4460, -4460,  3186,  3439,   859, -4460, -4460,  3441,  3442, -4460,
     859,   859,  3444,   859, -4460, -4460, -4460,  1420, -4460,   237,
   70386,  3147,  2074,  1258, -4460, -4460, -4460, -4460, -4460, -4460,
    2790, -4460, -4460,  1936, -4460, -4460, 70386,  3195, 70386, 70386,
   32971, -4460,  1395,   767, -4460,  3445, 70386,  3229, -4460, -4460,
   -4460,  3360, 70386, -4460, -4460, -4460, -4460, -4460,  3210, -4460,
    3466, 58668,  2281, 52592, 52592,  2281, -4460, 90712,  3211,  2839,
   -4460, -4460, -4460, -4460, -4460, -4460, 52592,  3022, 52592,   306,
    1335, 87312,  3238, -4460,  3208,  3501, -4460,  3205,  3209, -4460,
   -4460, 70386,  3145,  1855,  1333,  3621,   672,  1634, -4460, 59970,
    1856,  3466, -4460, -4460, -4460,  3582,  3300, -4460,  2131, 70386,
    2896,  3300,   975, 70386,  2752, -4460, 87746, 29814, 29814, -4460,
    3212, -4460,  3221,  6316, -4460,  3285,  3213,  2185, -4460, -4460,
   -4460, -4460, -4460, -4460,  3291,  3224, 70386, -4460, -4460,  3226,
   -4460,  3220, -4460, -4460, -4460, -4460, -4460, -4460,   758, -4460,
   -4460, 70386, -4460, 70386, -4460, -4460,   758,   758,   758,   758,
   -4460,  3342, -4460, 70386, 70386, 70386, 70386,  2844, -4460,   258,
   -4460,  3511, 52158, -4460, -4460,  1880, 70386, -4460, -4460, -4460,
    3574,   176,  3522, -4460, -4460,  3482,   903,  3483,  3484,   903,
    3485,   903, -4460, 29814, 13145, -4460,  3228, -4460, 13145,  7185,
   13145,  3400, -4460,  1894, 29814, -4460,  1949,  1949,  1949,  2983,
    3529, -4460,  1112,  3239,  1949,  1949,  1949,   338,   338,   206,
     206,   206,  3539,   501, 13145, 13145, -4460, -4460,  3242, -4460,
   -4460, -4460,  2870, -4460, 30716,  3388,  3638, -4460, -4460, -4460,
    3293,  3301,  3246, -4460, 29814, 31167,  3241, 91556,  3423, -4460,
     388, 29814, 29814,  4778, -4460,  8166, 29814, 90712,  1898,  4778,
     337, 29814,  2916,  2935, 29814, 29814,  4288,  7507,  3264, 29814,
   88590, -4460, -4460, -4460,  1904, 29814, 70386, 70386, 70386, 70386,
   -4460, -4460, -4460, 69518, 69952,  3254, 24474,  1355,  3265, 70386,
   -4460, -4460,  3268, 36063,  3515,  3456, -4460, 36063,  3456,  1453,
    3456,  3521,  3362, 40425, -4460, -4460,  3279,  3464, -4460, 22229,
    1592, 13145,  3681,  3564, 29814,  3283,  3288,  3292, 13145, 13145,
   29814, -4460,   975,  3564,   975, -4460, -4460, 43486, -4460, -4460,
   -4460, -4460, -4460,  3479, 13145, 27559, -4460,  2131, 70386,  1482,
      65, -4460,  3294, 70386, -4460,  3261, -4460, -4460,  3353,  1908,
   -4460, -4460, -4460, -4460, -4460,  3368, 60404,  3589, -4460, 29814,
    1910, -4460,  3331,  3680,   151,  1916,  1925,  1553, -4460,  3229,
   -4460,  1434,  3566,   356, -4460,   758, -4460, 90712, -4460, 70386,
   70386, -4460, -4460, -4460, -4460, 70386,  2409, -4460, -4460, 70386,
   70386, 70386, 70386, -4460, 52592, 70386, -4460, 70386, -4460, 49554,
    1419,  3500, -4460, -4460,  3502,   310, 70386, -4460, 90712,   758,
     758, -4460, -4460, -4460, -4460, -4460,  3312,  3703,  3390, 70386,
   70386, 70386, -4460, 70386, 52592, 70386, 70386,  2074,  2074, 90712,
    3303, -4460,  2074,  2074,  3305, -4460, 52592, 70386, 70386, -4460,
   -4460, -4460, -4460, 49554, 40864,  3381, -4460, 29814,  3699, -4460,
   -4460, -4460, -4460, -4460, -4460, -4460, -4460, 52592, 70386,  3391,
   -4460,  3392, -4460, -4460, -4460, 70386, 70386, 70386, 70386,  3624,
   -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460,
   70386, -4460, 70386, -4460, -4460,   975,   975, 90712,   758,   758,
   -4460, -4460, -4460,  3568,   859, -4460,   859,   859, -4460, -4460,
     859, -4460,  3319,   183, -4460,  1553,  1517,  3610,  3614, 29814,
   -4460,  1081,  2983, -4460, -4460, -4460, -4460,  3229,  1640,  3375,
   56932,  1140, -4460,  3594,   219, 58668,   275,  3323,  3443, -4460,
    2281,  2281,  3378, 70386,  3743,  2281,  3206, -4460,  3534,   709,
   70386,  3653,  3369, -4460,   975, -4460, -4460,  2839, -4460,  2131,
   70386, 58668,  2896,  1926, -4460, -4460, -4460,  3364,  3245,  1856,
    1208, 70386, -4460,  3367,  3749, -4460, -4460,  3627,  3527,  3335,
   -4460, 13145, 13145,   975, 91978,  6126, 90712,  3637, -4460, 70386,
     668,  3603,   758, -4460, -4460,   758,   758, -4460, -4460, -4460,
   -4460, 70386,  2844,  2844,  2844, -4460,  3530, -4460, -4460,  3595,
   -4460,   758, 52158,   903, -4460, -4460, -4460,   903,   903, -4460,
     903, -4460, 13145, -4460, -4460, -4460, -4460,  7831, 32971,  3635,
   -4460,  3343, 90712, -4460,  3345,  1952,  1964, 34318,  3496, -4460,
   -4460, -4460,  8148,  3396, 13145,  3449,  3348,  3350,  4778,  4778,
    8166,  1969, -4460,  4778, 29814, 29814,  4778,  4778, 29814, -4460,
   -4460,  8356,  3528, -4460, -4460,  8374, -4460, -4460, -4460, -4460,
   -4460, -4460, 50422, 69518,  3354, 70386,  1355, 36063, -4460, -4460,
    1682, -4460, 36063,  3605, -4460, 36063, 56932, -4460, 70386,  3355,
   70386, -4460,   609, 31618, 29814,  3399, -4460, -4460, -4460,  3299,
   -4460,  3399, -4460,  3361, 70386,  2390, -4460, -4460,  3736, 36935,
    3695,  3371, -4460, -4460, -4460, -4460, 52158,  3559, 52158,  1553,
    8496,  3229, 36935, 44356, 70386, 70386, 70386,  3516,  3229,  3375,
   -4460, -4460, -4460, -4460, -4460, -4460,  3372, -4460, -4460, -4460,
   -4460,  3446, -4460, -4460,   735,  2838, -4460,  1971, -4460, -4460,
   -4460, -4460, -4460,  3565, -4460, -4460, 41311, 52592, 70386, -4460,
    3447, -4460, -4460, -4460, -4460, -4460, 38244, 43486, -4460,   149,
    3374,  3376,   211, -4460, -4460, -4460, -4460, -4460, -4460, 70386,
    8948,  3379,   773,  2838, 70386, 70386,  1271,  1161,  1504,  2844,
    3667, -4460, -4460, -4460, -4460,  3565, -4460, -4460,   859, -4460,
   -4460, -4460, -4460, 49554, -4460,  2517, -4460,  1420,  3709, 56932,
    3793,  3793, 70386, -4460,  9308,  3580, -4460,  3375,  3604,  3650,
   -4460,  3383, 70386,  3543,  3385,  3386,   929,   929, 70386, 70386,
   70386,  1973,  2131, -4460,   306,  3700, 58668,  3145, -4460,  1334,
    3394,  3702, -4460,  3806,  2896,  3049,  3397, -4460, -4460, 59970,
    3581,  3300,  3245,  3525, -4460,  3531, -4460,   831, -4460,  2131,
   70386, 70386, 36935, -4460, 91134, -4460,  1977, -4460, -4460, -4460,
    3467,  2952,  3506,  3507,  3405, 70386,   103, -4460, -4460, -4460,
   -4460, -4460, 70386, -4460,   458, -4460, -4460, -4460, -4460, -4460,
    3499, 32971, 90712,  1988, 29814, -4460, 29814, -4460,  3808, -4460,
   -4460, -4460,    82, -4460, -4460, -4460,  4778,  4778,  4778, -4460,
    3813,  3299, -4460, -4460,  1989,  3823, -4460, 70386,  1994, -4460,
   29814,  3416, -4460, -4460, 36063,  1682,  3418,  2017, 70386,  2025,
   90712,  3413,  3420,    47,  3424, 22681,  3419, -4460, -4460, -4460,
   -4460, -4460, 13145, 13145, 70386, -4460,  3426, -4460, -4460, -4460,
   70386,  2035, -4460,   106, 25755, -4460, -4460,  1134,   150,   458,
    3680,  3375, -4460,  3429, -4460, -4460, -4460,  1278,  1278, 70386,
    3375, -4460, -4460, 70386,  3517, -4460, -4460, 49554,  3487, -4460,
     869,  2838, 70386, 90712,  1948,   109, -4460, 90712, 90712, -4460,
   -4460, -4460, 29814,  3519, -4460, -4460, -4460, -4460, -4460, 70386,
   70386, 70386, 70386, 70386,   758, -4460,  2036, -4460, 37371, -4460,
   -4460,  2592,   975,  2592,  1628, -4460, -4460,  2592, -4460,  2592,
   -4460,  3319,   975,  3793,   323, -4460, -4460, -4460,  1979,  3639,
   -4460,  1132,  3629,  3523,  3438, -4460, 56932,  3889,  3466, -4460,
   -4460, -4460, -4460, -4460, -4460, -4460, -4460,  2046,  3145,  3750,
    2839,  3367, 70386, -4460, -4460, -4460, -4460, 29814,  3607,  2131,
   -4460,  1856,  3466, -4460, -4460, -4460,  3300, -4460, -4460,  3833,
    3636,  3839,  2896, -4460,  2752,  2053, -4460,  6316, 91978, 90712,
    3781,  3490,  3491, -4460, -4460,  3504, 70386, -4460, -4460,  3145,
   -4460,  3499,  2064, -4460,  2068,  2080,  3608,  3509, -4460, 29814,
    1477,  3139, 50422,  3461, -4460,  2093, -4460, 13145, 70386, -4460,
   -4460, 29814, -4460,  2099, -4460, -4460, 29814,  3463, 29814, -4460,
   31618,  3460, -4460,  3883, -4460, -4460,  2952, 36935, -4460,  3583,
   -4460,  3760, -4460, 70386,  3510, 43486,  2951,  2951,  1640, -4460,
    1553, -4460, 70386, -4460, 29814, -4460,  3553, -4460, -4460,  2100,
   -4460,  1150,  3623,  3773,  2110,  2125,  9475, 70386,  2845,  1504,
    2845, -4460,  2844, -4460, -4460, 49554, -4460, 50856, -4460, -4460,
   -4460,   975, -4460,   975,  3677, 70386, 46516,   975,   975, -4460,
   -4460, -4460, -4460, -4460,  3801,  3744, -4460, -4460, -4460, -4460,
     269, -4460,  3673,  3674, 70386, -4460,  3498, -4460,  2132,  3599,
   -4460, -4460, 70386,  3896,  3902, -4460,   734,  9836, 56932,  3367,
    3245,  1856,  1419, -4460,  3689, -4460,  3690, -4460,  3503,  2839,
    6126, -4460, -4460,   805,  3794,  3796, -4460, -4460, -4460, -4460,
   -4460, -4460, -4460, -4460,  2870, 32069, 32069,  3505, -4460, -4460,
   70386, -4460,  2142,  2149, -4460,  2167, 31618,  2189, -4460, 70386,
    3514, -4460, -4460, 39553, 52158,  1278,  3518, -4460,  3524, -4460,
   -4460,  3604,  1553,  2838, 13145, 70386, 56932,  3906, -4460, -4460,
   -4460,  3623, -4460, -4460, -4460,  2838, 70386, -4460, -4460,  2197,
   -4460, -4460, -4460, 70386,  3208, -4460,  3208, -4460, -4460,  3640,
   -4460,   789,   789,  3850, -4460,  3572, -4460, -4460,  3526, -4460,
    3965, 70386, -4460,   149,  2131, 58668, -4460,  3520, -4460,  3300,
    3245, -4460, -4460, 36935,  3300, -4460, -4460, -4460,  2067, 56932,
   56932, 33422,  3649,   197, 11049, -4460, -4460, -4460, -4460,  2208,
   -4460,  3666, -4460,  2219, -4460, -4460, -4460,  1187,   458,  2951,
   29814,  1553, -4460,  3629, -4460,  2838,  1948, 70386, -4460, -4460,
   -4460, -4460, 50856,  3208,  3369, -4460,  3958, -4460,   759, -4460,
   -4460, -4460, -4460,  3145,  3303,  3367, 49120, -4460,  3300,  2248,
    2952, -4460,  2452, -4460, -4460, -4460, -4460, -4460, -4460, -4460,
    3532,  3533,  3950, -4460, -4460, -4460, -4460, -4460, -4460,  3535,
   -4460, -4460, -4460, -4460, -4460,  9956, -4460, -4460, -4460, -4460,
   -4460,  3842, -4460, -4460, -4460, -4460, -4460, -4460,  2252, -4460,
   -4460, -4460, -4460, -4460,  2839, -4460,  1946, -4460, -4460,  1963,
    1878,  3609,  3825, 32520, 29814, -4460,  1553,  3692, -4460, 49120,
    3300, -4460,  2452,  3642,  3643, -4460, 10367, 56932, -4460,  2952,
   -4460,  3569,  3577, -4460,  3544, -4460,  3835,  3837, 49120, 56932,
   56932,  2253, -4460, -4460, -4460
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
    1496,  1281,   568,  1366,  1365,  1281,   254,     0,  1368,     0,
    1281,   389,  1016,     0,     0,     0,     0,   568,  1281,     0,
    1496,     0,     0,     0,     0,     0,  1509,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1281,     0,     0,  1516,
       0,     0,     0,     0,  1509,     0,  1370,     0,     0,     0,
       0,     0,     2,     4,    67,    68,    29,    28,    34,    33,
      92,    93,    53,    17,    81,    60,   127,   126,   128,    40,
      36,    75,    25,    27,    37,    41,    62,    43,    54,   105,
      61,    23,    59,    86,    63,    89,    48,    11,    12,    49,
      79,    13,    50,    80,    14,    51,    15,   101,    69,    94,
      32,    58,    22,    85,    42,    65,    91,    66,     5,    44,
      77,    73,    10,    55,    56,    57,    82,    83,    84,   110,
      88,   122,    39,   119,    98,    99,   116,   100,   117,     8,
     102,    52,    16,   113,   112,   114,    76,    45,    78,    64,
      90,   111,    26,   115,    18,    19,    21,    20,   118,    87,
     108,   104,   123,   121,   129,   106,    70,     6,     7,    95,
      24,    47,     9,    31,    30,    46,    38,   125,    35,  1368,
      97,   109,    96,    71,   103,    74,   107,   124,    72,   120,
    1469,  1468,  1518,  1472,  1495,     0,  1484,  1280,  1279,  1265,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   567,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1291,  2077,  2092,  2093,  2094,  2095,  2096,  2097,  2098,
    2099,   360,  2100,  2101,  2102,  2103,  2104,  2105,  2106,  2107,
    2108,  2109,  2363,  2364,  2365,  2366,  2110,  2111,  2112,  2113,
    2114,  2115,  2116,  2367,  2368,  2117,  2118,  2119,  2120,  2121,
    2369,  2122,  2123,  2124,  2125,  2126,  2127,  2128,  2129,  2130,
    2131,  2132,  2133,  2134,  2135,  2136,  2137,  2138,  2139,  2140,
    2141,  2142,  2143,  2370,  2371,  2144,  2145,  2146,  2147,  2148,
    2149,  2150,  2151,  2152,  2153,  2154,  2155,  2156,  2157,  2158,
    2159,  2160,  2161,  2162,  2163,  2164,  2165,  2166,  2167,  2168,
    2169,  2372,  2170,  2171,  2172,  2373,  2173,  2174,  2175,  2374,
    2176,  2177,  2178,  2179,  2180,  2181,  2182,  2375,  2376,  2183,
    2184,  2185,  2186,  2187,  2188,  2189,  2190,  2191,  2192,  2193,
    2194,  2195,  2196,  2197,  2198,  2199,  2377,  2200,  2201,  2202,
    2203,  2378,  2379,  2380,  2204,  2205,  2206,  2207,  2208,  2209,
    2210,  2211,  2381,  2212,  2213,  2214,  2215,  2216,  2217,  2218,
    2219,  2220,  2221,  2222,  2223,  2224,  2225,  2226,  2227,  2228,
    2229,  2230,  2231,  2382,  2383,  2232,  2233,  2384,  2234,  2235,
    2236,  2385,  2237,  2386,  2238,  2239,  2240,  2241,  2242,  2243,
    2244,  2245,  2387,  2246,  2388,  2247,  2248,  2249,  2250,  2251,
    2252,  2253,  2254,  2255,  2256,  2389,  2257,  2390,  2260,  2258,
    2259,  2261,  2262,  2263,  2264,  2265,  2266,  2267,  2268,  2391,
    2269,  2270,  2271,  2272,  2273,  2274,  2275,  2276,  2277,  2278,
    2279,  2280,  2281,  2282,  2283,  2284,  2285,  2286,  2287,  2288,
    2392,  2289,  2290,  2291,  2292,  2293,  2294,  2295,  2296,  2297,
    2298,  2299,  2300,  2301,  2302,  2303,  2393,  2304,  2305,  2306,
    2307,  2394,  2308,  2309,  2310,  2311,  2312,  2313,  2314,  2315,
    2316,  2317,  2318,  2319,  2395,  2320,  2321,  2322,  2323,  2324,
    2325,  2326,  2327,  2396,  2397,  2328,  2329,  2398,  2330,  2399,
    2331,  2332,  2333,  2334,  2335,  2336,  2337,  2338,  2339,  2340,
    2341,  2342,  2343,  2344,  2345,  2346,  2347,  2400,  2401,  2348,
    2349,  2350,  2351,  2352,  2353,  2354,  2355,  2356,  2357,  2358,
    2359,  2402,  2403,  2404,  2405,  2406,  2407,  2408,  2409,  2410,
    2360,  2361,  2362,   359,  1459,  2045,  2078,  2079,  1367,  1347,
     568,     0,  1268,   388,  1496,     0,     0,     0,     0,     0,
       0,     0,     0,   784,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   177,     0,     0,   412,   411,
       0,     0,     0,   989,   417,     0,     0,     0,     0,     0,
     556,  1409,  2258,  1407,  1460,   255,   258,   259,   256,   257,
    2067,     0,  1099,  1100,  1102,     0,     0,     0,  1112,   822,
     823,     0,     0,     0,   825,     0,     0,     0,   818,     0,
       0,     0,     0,     0,     0,   824,   815,     0,   814,     0,
       0,  1112,     0,     0,     0,   816,     0,     0,  1269,  1406,
     418,  1496,     0,  1384,  1385,  1386,  1368,  1375,  1387,  1380,
    1382,  1381,  1383,  1379,  2066,  2093,   927,   927,   927,   927,
     924,   925,   927,   927,   927,  2275,     0,     0,   906,     0,
     908,  2068,   927,   932,   473,   473,   473,     0,   931,   936,
     473,     0,  1262,  1300,  2050,  1508,     0,   907,  1261,  2328,
    1398,     0,     0,  1127,  1123,  1125,  1126,  1124,     0,     0,
       0,  2291,  1273,   239,  2301,  2396,  2328,   238,   233,   234,
     207,  2097,     0,     0,   931,     0,  1270,  1271,   892,  1515,
    1513,     0,  2032,  2115,  2129,  2215,   230,  2286,  2292,  2301,
    2396,  2328,  2359,   186,   196,   191,     0,   248,  2301,  2396,
    2328,   244,  1291,     0,  1485,  1613,  2041,     0,  1264,  1263,
    1369,     0,  1372,     0,  1574,  2271,  1489,  1492,  1374,  1490,
    1481,     0,     0,     1,  1496,  1363,  1512,  1512,     0,  1512,
       0,  1473,  1481,  1476,  1480,     0,     0,     0,     0,  2077,
    2411,  2412,  2413,  2414,  2415,  2416,  2417,  2418,  2419,  2420,
    2421,  2422,  2423,  2424,  2425,  2426,  2427,  2428,  2429,  2430,
    2431,  2432,  2433,     0,     0,  2051,  2078,  2082,     0,   832,
       0,  1303,  2046,   976,     0,     0,     0,     0,  2045,     0,
       0,     0,     0,  2083,  2073,  2074,     0,  2071,  2072,  2084,
    2085,  2086,     0,  2188,     0,     0,     0,  1938,  1949,  1950,
    1951,  2119,  2173,  1946,  1947,  1948,  1940,  1941,  1942,  1943,
    1944,  1945,     0,  1097,  1939,     0,  2188,     0,   156,     0,
     134,     0,     0,  2188,     0,     0,     0,     0,     0,  2188,
       0,     0,     0,     0,     0,  2220,     0,   134,  2188,     0,
       0,  1285,     0,     0,     0,  1287,  1290,  1266,  1350,     0,
    2041,     0,     0,     0,   869,   861,     0,   870,   862,     0,
       0,   872,     0,     0,   864,     0,     0,     0,     0,   873,
       0,   863,   865,   875,   866,   871,     0,     0,     0,     0,
     867,     0,     0,  1277,     0,  1400,  1402,  1401,  1399,   473,
       0,     0,     0,     0,     0,     0,   134,  1335,     0,  2188,
     134,     0,     0,   416,   415,   134,  2071,   414,   413,  2119,
    2173,     0,  1015,     0,   134,  2188,     0,   179,   641,   571,
       0,     0,   743,  2220,   134,     0,     0,     0,     0,     0,
       0,   992,     0,     0,     0,   555,   568,  1410,  1408,     0,
    1103,   232,   231,  1101,   820,  2188,     0,   334,     0,     0,
    2188,  1322,  2080,  1671,  1700,  1678,  1700,  1700,  1667,  1667,
    2157,  1680,  2188,  1668,  1669,  1707,     0,  1700,  1667,  1672,
       0,  1670,  1710,  1710,  1695,   334,   836,  1652,  1653,  1654,
    1655,  1681,  1682,  1656,  1687,  1688,  1702,  1657,  1724,  1667,
    2081,   821,     0,   819,  2188,     0,  2188,  2075,   170,     0,
     817,  2119,  2173,  2188,     0,     0,  2188,     0,  2188,   162,
    2188,     0,  2188,   334,  2188,   572,     0,     0,  2188,     0,
    2188,   334,  2188,  2220,   164,     0,  2188,   334,   830,     0,
    1403,     0,  1377,  2400,  1392,     0,  1388,  1395,  1391,  1496,
     927,   926,     0,   927,     0,   927,     0,   927,     0,   927,
       0,     0,     0,   927,  2069,  2070,   909,     0,   933,     0,
       0,   940,   939,   938,     0,     0,     0,   941,     0,  1617,
    1433,     0,  1259,  1276,     0,     0,     0,   992,  1130,     0,
    1128,  1119,  1120,  1272,   237,   235,     0,     0,     0,     0,
       0,     0,  1278,     0,     0,     0,     0,  2054,  2056,  2057,
    1952,  2022,     0,  2364,  2365,  2366,  2011,     0,  2367,  2368,
    2369,  2413,  1854,  1841,  1850,  1855,  1842,  1844,  1851,  2370,
    2371,  2372,  2373,  2064,  2374,  2375,  2376,  2378,  2379,  2380,
    2381,  1846,  1848,  2382,  2383,     0,  2065,  2385,  2386,  2242,
    2388,  2389,  2391,  2392,  1852,  2394,  2395,  2396,  2397,  2398,
    2399,  2063,     0,  1853,  2401,  2403,  2404,  2405,  2406,  2407,
    2408,  2409,  2410,     0,     0,     0,  2038,     0,  1821,     0,
    1660,  1661,  1683,  1684,  1662,  1689,  1690,  1663,     0,  2037,
    1727,  1903,  1820,  1837,     0,  1826,  1827,     0,  1819,  1815,
    1498,  2033,     0,  1816,  2053,  2055,  2012,  1498,  2031,   199,
     250,     0,   251,  2039,  2301,   187,   229,   201,   228,   202,
     200,     0,  2117,   188,     0,     0,   189,     0,     0,     0,
       0,   247,   245,     0,  1267,     0,  1615,  1614,  2019,     0,
    2020,  2042,   841,  1362,  1360,  1361,  1359,     0,  1356,  1358,
    1371,  1368,  2027,  2026,  2028,     0,  1491,     0,     0,     0,
    1471,  1470,     3,  1374,  1510,  1511,     0,     0,     0,     0,
       0,     0,     0,     0,  1564,  1526,  1527,  1529,  1561,  1565,
    1573,     0,  1477,     0,     0,  1619,     0,  1575,     0,     0,
    2052,     0,     0,     0,     0,   833,     0,     0,     0,  1309,
       0,  1311,  1312,  1313,     0,     0,  1314,  1315,  1303,   241,
    1321,  1319,  1302,  1304,  1317,     0,     0,     0,     0,     0,
       0,     0,  1327,     0,     0,   168,   169,   584,   568,     0,
    2188,     0,     0,     0,     0,     0,  1055,  1062,     0,     0,
       0,     0,     0,     0,     0,     0,  1056,  1054,  1057,   243,
    1066,  1083,  1086,     0,   966,     0,     0,     0,     0,     0,
    1182,     0,     0,     0,  1182,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   264,   276,
     329,   548,     0,     0,   550,     0,  2188,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   132,   133,
     138,     0,     0,     0,     0,     0,     0,   535,   547,     0,
       0,     0,     0,     0,   544,     0,   134,   268,   528,   532,
       0,     0,     0,   650,   649,  1325,  1324,     0,     0,     0,
    1182,     0,   260,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   352,   353,
       0,     0,     0,   138,   161,     0,     0,     0,   270,     0,
       0,  1286,  1283,  1284,     0,  1289,     0,  1346,     0,   860,
       0,     0,     0,     0,   877,     0,   874,     0,     0,   868,
    2119,  2173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   391,     0,     0,   740,     0,     0,     0,     0,
       0,   751,     0,  1303,  1334,     0,     0,     0,   577,     0,
    2188,     0,   136,   785,     0,   741,   417,     0,     0,   136,
       0,     0,   173,     0,   645,     0,     0,     0,     0,     0,
       0,   689,   688,     0,     0,     0,   742,     0,   136,     0,
    2188,   531,  2188,     0,   473,   473,     0,     0,   991,   994,
       0,     0,     0,     0,  1463,  1465,  1464,     0,  1462,     0,
     334,   332,   333,   738,  1111,     0,     0,  1699,  1686,  1694,
    1693,     0,  1676,  1675,  1674,     0,  1673,     0,  1700,  1700,
    1698,  1677,  1652,     0,     0,     0,  1706,     0,  1704,     0,
     810,  1648,  1644,     0,     0,  1692,  1713,  1714,  1715,  1712,
    1725,  1711,     0,  1658,  1716,  1667,  1664,     0,     0,   334,
       0,     0,  2188,   334,  2188,     0,  2188,     0,     0,   334,
     334,     0,     0,     0,     0,     0,     0,   646,     0,   829,
     827,   826,   828,     0,     0,     0,     0,   808,     0,     0,
       0,  2188,   334,     0,     0,   807,  1962,     0,     0,  1496,
       0,   218,   219,   217,  1393,   220,  1394,  1390,  1376,     0,
     917,     0,   921,     0,   912,     0,   918,     0,   913,   910,
     911,     0,   916,     0,     0,   474,   476,     0,     0,  2141,
    2156,     0,  2179,  2208,  2209,  2292,  2297,     0,  2323,  2333,
       0,   942,   971,   937,   659,     0,     0,  1443,  1260,  1969,
       0,  1496,     0,     0,     0,     0,   236,   208,     0,     0,
       0,   973,  2291,  1275,   891,   568,     0,  1817,     0,  1824,
    1825,  2010,     0,     0,     0,     0,     0,     0,  1823,  1977,
       0,     0,     0,     0,     0,  1750,     0,     0,     0,  1990,
       0,  1996,     0,     0,  1787,     0,     0,     0,     0,     0,
       0,     0,     0,  1751,  1731,  1732,  1821,  1962,     0,  1822,
    2060,     0,  1724,  2036,  1952,     0,  1949,  1950,  1951,     0,
       0,     0,  2025,     0,  1960,     0,     0,  1765,  1958,  1767,
       0,     0,     0,     0,  1946,  1947,  1948,  1940,  1941,  1942,
    1943,  1944,  1945,  1956,  1747,     0,     0,  1905,     0,  1746,
       0,     0,  1577,     0,  2058,  2013,  1577,   252,   253,   249,
       0,     0,   204,   203,     0,   222,   226,   227,   198,   225,
       0,   221,   206,  1894,  1893,   205,   197,   194,   192,   209,
     211,   212,   195,   193,   246,     0,  2018,     0,  2087,  2434,
    2435,  2436,  2437,  2438,  2439,  2440,  2441,  2442,  2443,  2444,
    2445,  2446,  2447,  2448,  2449,  2450,  2451,  2452,  2453,  2454,
    2455,  2456,  2457,  2458,  2459,  2460,  2461,  2462,  2463,  2464,
    2465,  2466,  2467,  2468,  2469,  2470,  2471,  2472,  2473,  2474,
    2475,  2476,  2477,  2478,  2479,  2480,  2481,  2482,  2483,  2484,
    2485,  2486,  2487,  2488,  2489,  2490,  2491,  2492,  2493,  2494,
    2495,  2496,  2497,  2498,  2499,  2500,  2501,  2502,  2503,  2504,
    2505,  2506,  2507,  2508,  2509,  2510,  2015,  2014,  2048,  2088,
    2089,  2090,  2091,  2021,     0,     0,   334,  1354,     0,  1351,
    2030,     0,  1493,     0,  2043,     0,  1364,  1488,  1487,  1519,
    1520,  1008,  1486,  1544,  1545,  1540,     0,     0,     0,  1570,
    1568,  1536,  1530,  1535,  1533,     0,  1537,  1727,  1563,  1475,
    1524,  1525,  1528,  1474,     0,  1566,     0,  1446,  1564,  1529,
    1430,     0,  1412,     0,  1620,     0,  1030,  1032,     0,  1031,
       0,  1034,     0,  1043,     0,     0,  1029,  1048,     0,  1037,
    1035,     0,     0,     0,     0,     0,     0,   834,     0,     0,
       0,     0,  1310,     0,     0,  2323,   240,  1313,  1318,  1305,
    1316,     0,     0,     0,     0,     0,   975,   974,     0,     0,
     996,     0,     0,     0,  1330,   462,     0,   331,     0,     0,
       0,     0,     0,     0,     0,     0,   736,   733,     0,     0,
     732,     0,   582,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   620,     0,  1182,     0,   653,     0,  1064,
       0,     0,  1063,     0,  1067,     0,     0,  1065,  1060,  1061,
    2292,  2301,  2328,   242,  1085,     0,  1084,  1082,  1018,     0,
    1019,     0,     0,     0,     0,     0,  2166,  2188,   278,   293,
       0,  1181,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   316,     0,     0,
     319,   318,     0,     0,     0,     0,     0,   323,   302,     0,
     303,     0,     0,   322,     0,     0,   549,     0,     0,     0,
       0,  1182,     0,   272,     0,     0,     0,     0,     0,     0,
    1098,     0,   677,     0,   159,     0,   155,   158,     0,     0,
       0,     0,   534,   546,     0,   538,   539,   536,   540,   541,
       0,     0,     0,     0,     0,     0,   533,     0,     0,   643,
     642,   648,     0,     0,     0,     0,     0,     0,     0,     0,
    1132,  1131,     0,     0,     0,     0,     0,     0,   775,     0,
       0,     0,     0,     0,     0,     0,   662,     0,   661,     0,
     160,     0,     0,     0,     0,     0,     0,     0,   216,  1282,
    1288,  1349,  2049,  1348,     0,     0,     0,     0,   876,     0,
       0,     0,     0,     0,     0,     0,     0,   878,   879,   880,
     881,     0,     0,     0,     0,     0,   366,     0,     0,     0,
    2080,     0,   764,   739,     0,     0,   752,     0,   754,   757,
       0,  1301,   435,     0,     0,   574,   620,     0,   420,   166,
       0,     0,     0,     0,   679,   131,   177,   179,   418,     0,
     178,   180,   182,   183,   184,   181,   185,   640,   644,     0,
     570,     0,     0,     0,     0,     0,   690,   694,   693,   697,
     695,     0,   691,     0,     0,  1640,     0,   154,     0,     0,
     526,   530,     0,     0,     0,   420,   504,   345,  2188,     0,
     473,     0,  2188,     0,   993,     0,     0,     0,     0,     0,
       0,     0,     0,  1461,     0,  1089,     0,  1323,     0,     0,
       0,   334,  1697,  1696,  1649,  1645,     0,     0,     0,     0,
     837,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1665,  2188,   334,     0,  1087,   171,  2076,     0,   812,
       0,     0,     0,     0,     0,  1091,   804,     0,   334,   163,
       0,   334,   334,   573,     0,     0,   334,   334,   165,     0,
       0,     0,   565,   334,   831,  1405,     0,  2188,   473,  1378,
    1389,   914,   923,   922,   920,   919,   915,     0,   934,     0,
     472,     0,     0,     0,   948,   949,     0,     0,   947,   964,
     950,     0,   952,   944,   943,   953,   954,     0,     0,   973,
     657,     0,     0,     0,     0,  1440,     0,  1438,     0,  1618,
    1442,  1431,  1397,     0,  1396,     0,   519,     0,     0,  1129,
       0,     0,   931,     0,     0,   334,  1274,     0,   893,   894,
       0,     0,     0,     0,     0,     0,   900,   897,   898,   899,
     901,     0,   902,     0,     0,     0,  2023,  1973,     0,  1974,
       0,     0,  2009,  2005,     0,     0,     0,     0,     0,  1978,
    1981,  1982,  1983,  1980,  1984,  1979,     0,     0,  1985,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2392,     0,
       0,     0,     0,  1790,     0,     0,  1933,     0,  1962,  1995,
       0,     0,     0,     0,     0,     0,  1962,  2001,     0,     0,
       0,     0,  1892,     0,  1889,     0,     0,     0,     0,  2022,
       0,     0,  2061,  1728,  1742,  1743,  1744,  1748,  2035,     0,
    2024,     0,     0,  1729,  1756,     0,  2002,  1783,     0,  1788,
    1771,     0,  1764,     0,  1769,  1773,  1752,     0,  1749,     0,
    2025,  1961,     0,  1959,     0,  1739,  1740,  1741,  1733,  1734,
    1735,  1736,  1737,  1738,  1745,  1937,  1935,  1936,     0,     0,
       0,  1913,     0,     0,  1768,  2181,  2215,     0,  1509,  1509,
    1509,  1497,  1507,  2034,     0,  1635,     0,     0,     0,     0,
    1829,     0,  1966,  1518,  1964,  1035,  1635,  2040,     0,     0,
    1724,     0,  1616,  2016,  2019,   839,   840,   838,  1374,  1357,
    1353,  1352,  2029,  1373,     0,  1496,     0,  1006,  1007,     0,
    1011,     0,     0,  1538,  1571,     0,  1562,     0,  1542,  1543,
    1534,  1572,  1444,     0,  1567,  1479,  1478,     0,  1638,     0,
       0,  1422,  1414,     0,  1621,     0,  1577,  1448,  1450,  1451,
       0,  2022,  1033,     0,  1667,  1044,     0,  1028,     0,  1027,
    1667,     0,  1045,     0,  1667,     0,     0,     0,  1219,  1134,
    1190,   835,  1220,  1135,  1191,  1221,  1136,  1320,  1308,  1307,
    1306,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   715,  2188,   334,  1328,  1222,
       0,  1137,   330,  1329,  1192,  1333,   735,   734,     0,     0,
    1193,     0,   583,     0,     0,     0,   589,   590,   591,     0,
       0,     0,   592,     0,  2119,  2173,     0,   597,   604,   609,
     599,     0,     0,   611,   605,     0,     0,     0,     0,     0,
       0,   617,   624,     0,     0,     0,     0,     0,     0,     0,
    1058,  1059,  1223,  1140,     0,  1194,  1017,     0,  1141,   167,
       0,     0,   265,  2188,   280,     0,   626,   715,  1184,   300,
       0,     0,   315,   310,   311,   309,  2188,   334,  2188,   334,
       0,     0,     0,     0,     0,   312,   307,   308,   304,     0,
       0,   317,  2096,  2158,  2302,     0,   630,   632,     0,   637,
     320,  1157,   341,   340,   339,     0,   324,     0,   346,   349,
     321,   298,   301,   299,   295,   277,     0,     0,     0,     0,
       0,     0,     0,     0,  2047,     0,     0,  1093,     0,     0,
       0,     0,     0,     0,     0,   671,   157,  1172,   147,     0,
       0,   143,     0,     0,     0,     0,   137,     0,  1229,  1147,
       0,     0,   269,   529,   537,   542,  1151,   545,  1204,   543,
    1235,  1148,     0,  1182,     0,   261,     0,  1149,     0,  1198,
    1231,  1174,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1336,     0,     0,     0,     0,     0,     0,   334,     0,
       0,     0,  1184,  2188,   334,  1230,     0,  1179,  1212,     0,
     354,     0,  1173,     0,     0,   271,  1153,  1206,     0,     0,
     214,   213,   215,     0,     0,  2156,     0,   883,   844,   882,
       0,     0,     0,     0,     0,     0,   852,     0,     0,     0,
     843,     0,   842,   365,     0,   390,   363,   364,   366,     0,
       0,   763,     0,     0,     0,   753,     0,     0,     0,  1326,
       0,   134,   581,     0,     0,     0,   576,   619,   626,     0,
       0,     0,   419,   423,   427,   428,   429,     0,     0,     0,
       0,   148,   135,     0,   793,     0,   473,     0,   675,     0,
     179,   172,     0,     0,     0,   345,   750,   748,   747,   749,
       0,     0,     0,   768,   746,     0,  1639,  1641,     0,     0,
       0,     0,     0,   519,   422,     0,   476,     0,     0,   508,
       0,     0,     0,     0,   345,     0,     0,     0,  1022,     0,
    1040,  1023,     0,     0,     0,     0,  1071,  1078,  1072,  1050,
       0,     0,   553,  1466,  1467,     0,   334,     0,     0,  1666,
    1679,   811,     0,  1709,  1708,  1710,  1710,     0,  1650,     0,
    1701,  1702,  1718,  1719,  1720,  1721,  1722,  1723,     0,  1717,
    1659,     0,   621,   334,   334,     0,   334,     0,   334,   334,
       0,   668,     0,  1257,   647,     0,     0,   723,   809,     0,
       0,   334,   806,  1963,     0,   935,   475,     0,     0,     0,
       0,   946,     0,   551,   951,     0,   963,   958,   960,     0,
     967,   656,     0,     0,  1441,  1434,  1436,  1435,     0,     0,
    1432,  1970,   805,     0,   525,  1121,  1122,     0,     0,   334,
       0,   968,     0,     0,   895,   896,     0,     0,   903,     0,
       0,     0,  1514,  1971,  1972,     0,     0,     0,  2006,     0,
       0,  1867,     0,  1843,  1845,  1857,     0,  1868,  1828,  1869,
    1847,  1849,     0,  1953,     0,     0,  1858,     0,  1792,  1793,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1808,  1807,  1859,
    1932,     0,     0,  1993,  1994,  1860,     0,     0,  2000,     0,
       0,     0,  1865,  1870,     0,     0,     0,     0,  1876,     0,
    1897,     0,     0,     0,  1818,  1963,     0,     0,     0,     0,
       0,     0,     0,     0,  1789,  1772,  1766,     0,  1770,  1774,
       0,     0,     0,  1760,     0,     0,  1758,  1784,  1754,     0,
       0,  1785,     0,     0,     0,  1836,     0,     0,  1509,  1509,
    1509,  1509,  1506,     0,     0,     0,     0,  2289,     0,  1599,
    1576,  1578,  1586,  1599,  1604,  1838,  1633,  1839,     0,  2041,
       0,  1547,  1518,  1518,  1518,  1835,     0,     0,     0,     0,
    1517,  1547,   190,     0,   223,   210,  2018,     0,  1355,  2044,
       0,  1521,     0,  1954,  1011,     0,  1523,     0,     0,  1569,
    1531,  1445,  1429,     0,  1427,  1416,     0,  1417,  2022,     0,
    1427,  1413,  1456,     0,     0,  1638,     0,  1455,     0,  1667,
    1025,  1026,     0,  1049,     0,  1218,  1133,  1189,   978,   979,
       0,   977,     0,     0,     0,   461,   995,     0,     0,     0,
     715,     0,     0,   465,     0,  1331,     0,  1236,  1171,   585,
     586,   587,     0,   598,     0,   607,   606,     0,     0,   594,
       0,     0,     0,     0,     0,   593,   613,   557,   614,   616,
       0,     0,   615,   618,   623,  1182,     0,   654,  1159,     0,
    1210,  1052,  1185,     0,  1020,     0,     0,     0,     0,     0,
       0,   435,   294,     0,     0,     0,   282,   292,     0,  1188,
     326,     0,   297,     0,   290,   313,   305,   314,   306,   325,
     327,     0,   634,   635,   633,   629,     0,   636,   638,     0,
     343,     0,     0,     0,  1225,     0,  1182,     0,   273,     0,
    1155,     0,  1208,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1226,  1195,     0,  1214,     0,     0,
       0,   676,     0,   673,     0,     0,   140,   139,     0,   146,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   355,   336,     0,
     771,     0,     0,     0,   357,     0,     0,     0,     0,  1224,
    1142,   845,     0,     0,     0,   846,   857,     0,     0,   847,
       0,     0,     0,     0,   859,   368,   369,   134,   367,     0,
       0,  2242,  1940,  1941,   761,   766,   758,   760,   762,   759,
       0,   765,   715,     0,   755,   756,     0,     0,     0,     0,
       0,   447,     0,     0,   441,     0,     0,  1078,   434,   437,
     438,     0,     0,   577,   580,   578,   579,   612,     0,   454,
     500,     0,   150,     0,     0,   151,   149,     0,     0,   345,
     680,   684,   682,   681,   683,   678,     0,   671,     0,   175,
     418,     0,     0,   569,   696,   699,   692,     0,   767,   769,
     744,     0,   626,     0,   531,     0,   473,  1406,   514,     0,
     504,   500,   502,   501,   503,     0,   510,   344,     0,     0,
     519,   510,     0,     0,   996,  1021,     0,     0,     0,  1068,
    1073,  1069,     0,     0,  1036,     0,  1070,     0,  1051,  1014,
    1252,  1253,  1250,  1251,     0,     0,     0,  1458,  1090,     0,
    1685,     0,  1705,  1703,  1646,  1651,  1691,  1726,   334,  1088,
     813,     0,   800,     0,   802,  1092,   334,   334,   334,   334,
     663,     0,   566,     0,     0,     0,     0,   945,   965,     0,
     961,     0,     0,   928,   970,     0,     0,  1439,  1437,   517,
       0,   973,     0,   929,   972,     0,     0,     0,     0,     0,
       0,     0,  1975,     0,  2008,  2004,     0,  1840,  1976,     0,
    1988,  1987,  1933,     0,     0,  1791,  1803,  1804,  1805,  1989,
       0,  1813,     0,     0,  1800,  1801,  1802,  1794,  1795,  1796,
    1797,  1798,  1799,  1806,  1998,  1997,  1991,  1992,     0,  1862,
    1863,  1864,  1999,  1871,     0,  2110,  1898,  1875,  1891,  1890,
       0,     0,     0,  1878,     0,     0,  1887,     0,  1934,  2062,
    1730,     0,     0,  1757,  2003,  1775,     0,     0,     0,  1753,
    1953,     0,     0,     0,     0,     0,  1762,     0,     0,     0,
    1916,  1911,  1912,  1930,     0,     0,     0,     0,     0,     0,
    1500,  1499,  1505,  1599,  1604,     0,  1481,     0,  1586,     0,
    1598,  1584,  1597,     0,     0,  1610,  1608,     0,  1610,     0,
    1610,     0,  1580,     0,  1600,  1582,  1597,     0,  1625,     0,
    2042,  1634,     0,  1560,     0,     0,     0,     0,  1967,  1968,
       0,  1965,  1830,  1560,     0,  2017,  1494,     0,  1522,  1009,
    1010,  1539,  1532,  2137,  1636,     0,  1428,     0,     0,  1419,
    1425,  1411,     0,     0,  1449,  1427,  1452,  1046,     0,     0,
    1038,   984,   985,   983,   986,     0,     0,     0,   715,     0,
       0,   481,     0,  1003,  1003,     0,     0,   467,   513,  1078,
     718,     0,     0,     0,   716,   334,  1138,     0,   608,     0,
       0,   603,   601,   600,   602,     0,   558,  1234,  1139,     0,
       0,     0,     0,  1053,     0,     0,  1158,     0,   279,     0,
     432,     0,   287,  1183,     0,     0,     0,   286,     0,   334,
     334,   328,   631,   342,   347,   348,   351,     0,     0,     0,
       0,     0,  1187,     0,     0,     0,     0,     0,     0,     0,
     794,   777,     0,     0,   795,   796,     0,     0,     0,  1095,
    1096,  1094,  1213,     0,     0,     0,  1145,     0,     0,   667,
     144,   141,   142,   145,  1169,  1152,  1205,     0,     0,     0,
    1150,     0,  1199,  1165,  1161,     0,     0,     0,     0,     0,
    1233,  1178,  1203,  1232,  1176,  1201,  1175,  1200,  1177,  1202,
       0,  1170,     0,  1643,   774,     0,     0,     0,   334,   334,
     665,  1154,  1207,     0,     0,   848,     0,     0,   850,   851,
       0,   854,   373,   393,   685,   737,     0,     0,   714,     0,
     439,     0,   445,   449,   450,   448,   440,  1078,   473,   512,
       0,     0,   727,     0,   575,   420,   451,     0,     0,   424,
     153,   152,     0,     0,     0,   674,   673,   179,  2188,     0,
       0,   701,   705,   745,     0,  1642,   660,   345,   527,     0,
       0,   420,   519,     0,   425,   430,   431,     0,   508,   504,
       0,     0,   516,  1299,     0,   520,   522,     0,     0,     0,
    1024,  1041,  1042,     0,     0,  1078,     0,     0,  1077,     0,
       0,   560,   334,  1647,   622,   334,   334,   669,  1258,  1118,
     724,     0,   957,   956,   955,   552,     0,   959,   658,     0,
     518,   334,     0,     0,   905,   886,   904,     0,     0,   885,
       0,   884,  2007,  1856,  1866,  1986,  1932,  1963,     0,     0,
    1814,     0,     0,  1861,  2402,     0,     0,     0,     0,  1895,
    1896,  1877,     0,  2233,  1882,     0,     0,     0,  1781,  1779,
    1776,     0,  1777,  1761,     0,     0,  1759,  1755,     0,  1786,
    1902,     0,  1918,  1915,  1929,  1963,  1504,  1503,  1502,  1501,
    1585,  1583,     0,  1588,  1595,     0,  1579,     0,  1609,  1605,
       0,  1606,     0,     0,  1607,     0,     0,  1581,     0,  1595,
       0,  1632,  1518,     0,     0,  1907,  1833,  1834,  1831,  1518,
    2059,  1907,   224,     0,     0,  1426,  1415,  1418,     0,     0,
       0,     0,  1457,  1447,  1039,  1047,     0,     0,     0,   463,
       0,  1078,     0,     0,     0,  1005,  1005,     0,  1078,   512,
     720,   719,   722,   717,   721,  1332,     0,   595,   596,   610,
    1160,     0,  1211,  1167,     0,  1443,   281,     0,   627,   283,
     284,   285,   288,   336,   296,   289,     0,     0,     0,  1156,
       0,  1209,  1163,  1227,  1143,  1196,     0,     0,   783,     0,
       0,     0,     0,  1228,  1144,  1197,  1215,  1216,  1217,     0,
       0,     0,     0,  1443,     0,     0,     0,     0,     0,  1341,
       0,  1186,   335,   773,   772,   336,   356,  1180,     0,   849,
     855,   856,   853,     0,   362,   370,   394,   134,     0,     0,
    1109,  1109,     0,   715,     0,     0,   436,   512,   480,     0,
     442,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   666,   174,     0,   420,   626,   700,     0,
       0,     0,   770,     0,   519,   422,     0,  1404,   421,     0,
       0,   510,   508,     0,   505,     0,   509,     0,  1292,     0,
       0,     0,     0,  1074,     0,  1080,     0,  1035,  1012,  1075,
       0,  1635,     0,     0,     0,     0,   564,  1110,   801,   803,
     664,   962,     0,   969,   334,   887,   888,   889,   890,  1934,
    1809,     0,     0,     0,     0,  1872,     0,  1873,  1900,  1899,
    1879,  1883,     0,  1880,  1881,  1778,  1782,  1780,  1763,  1904,
       0,  1518,  1931,  1628,     0,  1631,  1587,     0,     0,  1589,
       0,     0,  1591,  1593,     0,     0,     0,     0,     0,     0,
    2045,     0,  2136,  2376,  2288,     0,  1546,  1548,  1551,  1553,
    1552,  1554,  1550,  1559,     0,  1483,     0,  1482,  1955,  1637,
       0,     0,   997,     0,     0,  1454,  1453,   963,     0,   334,
    1003,   512,   482,  2242,   483,  1002,  1004,  1008,  1008,     0,
     512,   715,   588,     0,     0,   266,   625,     0,   338,   350,
       0,  1443,     0,     0,     0,   790,   778,     0,     0,   797,
    1146,   670,     0,     0,   262,  1166,  1162,  1343,  1344,     0,
       0,     0,     0,     0,   334,   858,     0,   396,   403,   374,
     379,  1335,     0,  1335,     0,   376,   380,  1335,   375,  1335,
     372,   373,     0,  1109,     0,  1106,  1105,   713,     0,   471,
     443,     0,   491,     0,     0,   728,     0,     0,   500,   460,
     459,   456,   455,   457,   458,   453,   452,     0,   626,   787,
     345,  1299,     0,   639,   702,   703,   698,     0,     0,     0,
     515,   504,   500,   426,   435,   409,   510,   506,   507,     0,
       0,     0,   519,  1345,   996,     0,  1079,     0,     0,     0,
       0,     0,     0,  1113,   559,     0,     0,   563,   554,   626,
     930,  1810,     0,  1811,     0,     0,     0,  1885,  1884,     0,
    1921,  1633,     0,     0,  1627,     0,  1596,  1612,     0,  1592,
    1590,     0,  1601,     0,  1603,  1830,     0,     0,     0,  1555,
       0,  1906,  1908,     0,  1832,  1424,  1635,     0,  1421,     0,
     980,     0,   981,  1005,   486,     0,  1011,  1011,   473,   715,
     464,  1168,     0,   628,     0,   291,     0,   274,  1164,     0,
     781,     0,   792,   790,     0,     0,     0,     0,  1337,     0,
    1338,  1339,  1342,   358,   371,     0,   401,     0,   399,   398,
     400,     0,   387,     0,     0,     0,     0,     0,     0,   361,
     392,  1104,  1108,  1107,     0,     0,   444,   477,   478,   479,
       0,   446,   487,   488,     0,   725,     0,   730,     0,     0,
     499,   651,     0,     0,     0,  1293,     0,     0,     0,  1299,
     508,   504,   433,   407,     0,  1296,     0,   521,     0,   345,
    1078,  1081,  1076,  1256,     0,     0,   562,   561,   655,  1812,
    1888,  1874,  1901,  1886,  1917,     0,     0,     0,  1626,  1629,
       0,  1594,     0,     0,  1602,     0,     0,     0,  1549,     0,
       0,  1423,   998,     0,     0,  1008,     0,   715,     0,  1000,
     999,   480,   466,  1443,   337,     0,     0,     0,   788,   791,
     779,   792,   799,   798,   672,  1443,     0,   397,   406,     0,
     404,   377,   382,     0,   386,   384,   383,   378,   381,     0,
     470,     0,     0,     0,   489,     0,   490,   511,     0,   729,
       0,     0,   786,     0,     0,   420,   704,     0,  1294,   510,
     508,  1297,  1298,     0,   510,  1013,  1255,  1254,  1496,     0,
       0,  2363,  2137,  2335,     0,  1919,  1922,  1920,  1914,     0,
    1611,  1624,  1557,     0,  1556,  1909,  1910,  1635,   334,  1011,
       0,   468,   484,   491,   267,  1443,     0,     0,   780,   263,
    1340,   402,     0,   385,   705,   496,     0,   495,     0,   493,
     492,   726,   731,   626,   776,  1299,   708,   410,   510,     0,
    1635,  1238,  1496,  1237,  1239,  1247,  1244,  1246,  1245,  1243,
    1116,  1117,     0,  1926,  1925,  1924,  1928,  1927,  1630,     0,
    1622,  1558,  1420,   982,  1001,     0,   715,   275,   782,   789,
     405,     0,   494,   498,   497,   652,  1295,   710,     0,   706,
     709,   711,   712,   408,   345,   987,     0,  1248,  1242,  1481,
    1468,     0,     0,     0,     0,   485,   469,     0,   686,     0,
     510,  1240,  1496,     0,     0,  1923,     0,     0,   707,  1635,
    1241,     0,     0,  1623,     0,   988,     0,     0,   708,     0,
       0,     0,  1114,  1115,   687
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -4460, -4460, -4460,  3248, -4460,  -836,   290,  2516,  -577, -4460,
   -4460, -4460,  3153, -4460, -4460, -4460, -4460, -4460, -4460, -4460,
    3173, -4460, -4460,  1696, -2224, -4460, -4460,   163,  3148, -1203,
     135,  2745,  1366, -4460, -1052, -4460, -4460,  -545,   116, -4460,
    3157,  -684, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -4460,
    -783,  1841,  1201,   115, -2669, -4460, -4460, -1291, -2930, -4460,
     565, -4460, -4460,  1792, -4460, -4460, -4460,  1040,   472,  -513,
   -4460, -4460, -4460, -4460, -4460, -4460, -4460,  -656, -4460, -4460,
    -842,   158,    55, -2255,  -334, -4460, -4460,   441,  -336, -1343,
   -4460, -3291, -4460,    -5, -4460, -4460, -4460,  -313, -1298,  1307,
   -4460,  -657, -1091,  1610,  -741, -4460,  -205, -4460,  -822,  -671,
    -668,  -767, -3493, -3484, -3911, -3500, -2983,  1314,   159, -2867,
   -2954,   160,   408, -4460,   161,   162, -4460,   432,  -744, -1337,
   -4460,  -800, -4460, -4460, -4460, -2698, -4460, -4460, -4460, -4460,
      59, -4460, -4460, -4460, -4460,   474, -4460, -4460, -4460, -4460,
   -4460, -4460, -2474,  1773,  1774, -4460, -4460, -2905, -4460,  -823,
   -4460,   617, -2756,  1231, -4460, -4460, -4460,  2521, -4460, -4460,
   -4460, -4460, -4460, -4460, -4460, -4460, -4460, -1470, -4460, -4460,
   -4460, -4460, -4460,   459,     7, -4460, -4460, -4460, -4460, -4460,
     166, -4460,  1787,  1036, -4460, -4460, -4460,  -804,  -896,  -875,
   -4460, -2738, -4460, -4460, -4460, -4460,  -265, -4460, -4460, -4460,
   -4460, -4460, -4460,  -885, -4460,  1092, -2871, -4460, -4460,  1097,
   -4460, -4460, -4460, -4460, -4460,  -740,  -204,  2551, -4460,  -587,
    -701, -4460, -4460, -4460,  -201, -4460, -4460, -4460, -4460, -4460,
   -4460,  -985,    64,  -957,  -487, -4460, -4460, -4460, -4460, -2191,
   -4460, -4460, -4460, -3191, -4460,  4075,   406,   138,   167, -4460,
     -22,    71,  2998, -1050, -2424,   394,  -382, -4460, -1686, -4460,
   -4460, -4460, -2332, -4460, -4460, -4460, -4460, -3238,   170, -4460,
    2990, -4460, -3510, -4192, -3256, -3716, -4043, -4076, -3224, -4460,
   -4460, -1024, -4460, -4460, -4460, -1314,  2095, -1765, -4460, -1850,
     455,  1399,  -853, -2520, -3518,  -636, -2969, -4460, -4460, -3446,
    -495, -4460, -4460, -4460, -4460, -4460, -4460, -4460, -1017,  -556,
   -4460, -4460,  3512, -4460, -4026, -4460,  3486, -4460, -4460, -4460,
   -4460,  2392,  2394, -4460,  2384, -4460, -4460, -1287,  1173, -4460,
   -4460, -4460, -4460,   133, -4460, -4460, -4460, -4460,  -726,  -839,
   -4460, -4460, -4460,   171, -4460, -4460, -4460, -4460,  2019,  -831,
    -658,  3382,   177, -4311, -4460, -4460,  -972, -4460,  2791, -4460,
   -4460, -4460, -4460, -4460, -4460, -4460, -4460, -2499, -4460, -4460,
   -4086, -4460, -4460, -4460, -4460, -4460,  2171,  2166,    75,   -27,
   -4460, -4460, -1176, -4460,  -504, -4460,  2455, -4460, -4460, -4460,
   -4460, -1579,   178,   499, -4460,     3, -4460, -4460, -4460,   259,
   -4460, -4460, -3154,     5, -4460, -4460, -4460, -4460, -4077, -4460,
       6,  -644,   786, -4460, -4460, -2573, -4460,   179,    51, -4460,
   -4460,     1,     2,   -43,   -48,   -41,     4,   131,  2858, -4460,
    2909, -4460,   -14,  1643, -4460, -4460,  -752,  -151, -4460,  1475,
    -581,  2150,  2847,  2852, -4460,  1474, -4460, -4460,  1478, -4460,
     834,  -624,  -492, -4460, -4460, -4460, -4460,   296,  -576,  2162,
   -4460,  2861, -4460, -4460, -4460, -1687,  1483, -3148,   863, -3149,
   -3108,   351,   339, -1381,  -293,    -6,  -690,  2859, -4460, -4460,
     880,  -455, -4460, -4460,  -452, -2583,   825, -4460, -4010, -2126,
    -510,  2570,  -978, -4460, -4460,  -937, 14438, -4460, -4460, -4460,
   14923, 15241, -4460, -4460, 16233, 16260, -4460,  -805,  1080, 16859,
    7180,  -938, -1638,  -256, 13602, -2252, -1113, -2540, -4460, -3258,
   -2419, -4460, -4460, -4460,  -240,   939,   515, -4460, -4460, -4460,
   -4460,   -42, -4460,  -588, -4460,  -590, -4460, -4460, -4460,  -574,
   -4459,  2367, -4460, -4460, -4460,  -194, -4460, 17392,  1524, -4460,
    -901, -2506, -2509, -3107, -1636, -4460, -4460, -4460, -4460, -4460,
   -4460, -4460, -2781, -3036,  -669,  1594, -4460, -4460,  1686, -4460,
   -4460, -4460, -1222,  1540,  -757, -2412,  1597, -1846, -4460,  -749,
   -4460,  -706,  2368,  -696,  5188, -1228,  7070,  -472, -2090, -1143,
   -1426, -4460,  -154, -4460,    -7,   -16,    17,   -94,  -167,  -584,
    3671, 14118,  -589, -1235,  9591, 11879, 13046, -2865
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    51,    52,    53,    54,  1430,  2299,  2186,  3021,  3022,
      55,    56,  1426,    57,    58,    59,    60,    61,    62,    63,
    1358,    64,    65,   956,  1552,  2310,    66,  2036,   734,   735,
     736,  1858,  1859,  2249,  1860,  1848,  1247,  1685,  1379,   708,
     709,  1340,  1380,    68,    69,  1241,  1839,    70,    71,    72,
    1408,  1409,  1352,  1593,  4023,  4675,  2856,  2163,  3061,  2857,
    2858,    73,  1478,  1479,    74,    75,  2988,  2984,  3557,  4334,
    4335,  4550,   555,  2278,  4337,  4338,  4536,  4537,  4699,  4809,
    4810,  2311,  1547,  3055,  3640,  3012,  4093,  3013,  4094,  3014,
    4095,  2999,  3588,  3589,  3590,  3015,  4066,  4575,  3016,  2055,
    4716,  2346,  1707,  1705,  4562,  3900,  3901,  4787,  4721,  4722,
    4723,  4889,  4068,  3059,  3646,  4102,  4350,  2745,   643,  1573,
    3164,   644,  2349,   587,   645,  2312,    81,  2340,  2341,  1449,
    2194,  3564,  3144,    82,   976,  3406,  4406,  4617,  4618,    83,
     220,    84,  1556,    85,    86,  2295,  3006,    87,  2072,  2762,
      88,    89,  2791,  2792,  2793,    90,    91,  3431,  4277,  1410,
    2845,  2846,  2847,  2848,  3457,    92,  1554,  1454,  2319,    93,
      94,    95,    96,    97,  2462,  2463,    98,  2237,    99,   100,
     101,   102,   103,  3493,  3989,  3617,  2885,  3028,  3615,   104,
    2313,  1564,  2331,  2332,  4082,  4369,  4586,  4371,  4938,  4939,
    4343,  3383,  3914,   106,   107,  4061,  4062,  4728,   108,  2070,
     109,   110,   111,  1531,  2287,  2288,  3565,  1525,  2281,  2282,
    3627,  3628,   112,  2941,   113,  3970,  3971,   588,  4733,  4682,
    4800,   114,   115,  3974,  3975,   116,   117,   118,   119,   120,
     637,  1067,  1068,  1325,  1015,   121,  1956,   122,   922,  2968,
     123,  1135,  2504,  4145,   124,   668,  1081,  1082,  2314,   126,
     677,  2482,   679,  1720,  3146,  3147,  3713,  2448,   821,   127,
     128,  2459,  2485,   129,  1345,  2046,  2047,  3895,  2315,   589,
    1579,  2353,  2740,  4481,  4482,  4255,  4497,  2670,  3336,   131,
     590,  1384,  2119,  2356,  3069,  2013,  2014,  2015,  3663,  2016,
    3071,  2017,  1319,  2018,  3077,  3078,  3079,  3659,  3666,  3669,
    4395,  4396,   132,  1382,  2117,   133,   134,   135,  1421,   852,
     136,   602,   603,   137,  4555,   138,   989,   139,  4404,   140,
     141,   699,   700,  1119,  1120,   142,   143,  2133,  3438,   144,
     145,   146,  3486,  3487,   147,   148,  4903,  4946,  4947,  4948,
    3674,  4848,   149,  4905,  1112,   151,   152,   153,   189,   885,
     886,   887,  2316,  4388,   155,   156,  1341,  1342,  1343,  1344,
    2041,   157,   158,   159,   160,   161,   162,  1535,   163,   164,
    4529,   165,   166,  1497,   167,  1277,  1278,   168,   169,   549,
     752,  1281,  1289,   170,   647,  1075,  1076,  1077,  1687,   171,
    1115,   924,   648,  1070,   173,   649,  2001,  2691,  3346,  3347,
    3350,  4240,  3876,   650,  2688,   176,  1727,  2468,  2471,  2684,
     651,  2696,  2697,  2698,  2699,  2700,  3353,   652,   670,   979,
    2362,   653,  1208,   181,   182,   183,   762,   756,   757,   185,
    1832,  2631,   686,  1296,   721,   722,   770,  3320,  1969,  1970,
    1992,  1993,  1305,  1306,  1982,  1984,  2672,  1985,  2680,  1975,
    3853,  4466,  4467,  4468,  4469,  4470,  4471,  4225,  1988,  1989,
    1308,  1309,  1310,  1997,   186,  2635,  3300,  3301,  3302,  3830,
    3831,  3845,  3841,  4209,  4452,  3303,  1110,  1316,  4217,  4920,
    3304,  4443,  4444,  4634,  3848,  3311,  3344,  3045,  3046,  3047,
    2019,  1622,  1017,  1209,  1018,  1636,  1210,  1606,  1020,  1211,
    1212,  1213,  1023,  1214,  1215,  1216,  1026,  1598,  1625,  1217,
    1218,  1616,  1633,  1634,  1676,  2542,  1220,  1221,  1222,  3306,
    1223,  3786,  4176,  4165,  2563,  2564,  1855,  3782,  3246,  1827,
    2621,  4475,  4651,  4652,  3285,  3811,  4192,  4441,  4767,  4855,
    4856,  1224,  1225,  1226,  2618,  1823,   854,  1227,  3567,  1825,
    2557,  2643,  2644,  1730,  1750,  2510,  2526,  2527,  2537,  3205,
    2545,  2550,  3233,  3234,  2558,  2587,  1228,  2512,  2513,  3189,
    1752,  1229,  1270,  1867,  1271,  1747,  2582,  1284,  1285,   754,
    1237,  1230,  1231,  1721,   745,  4448,   544,   811,  2873,  1947,
     889,   683,  1232,  1233,  1234,  1235,  1414,   826,  1037,  1038,
     545,   805,   828,  2849,   546,   547,   807,  1952
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     604,   179,   180,   174,   184,   175,   177,   761,  1704,   684,
     853,  1639,   982,   713,   671,   951,  1238,  1101,  1102,  1103,
     671,  1311,   180,  1107,   184,  1684,  2449,  1649,  1242,  1317,
     747,   771,  1612,   827,  1948,  1413,   803,   744,   672,  1049,
     860,  1483,  1453,  3011,   672,   822,  2128,  1320,  2054,  1953,
    1064,   877,   760,  1078,  1643,  1495,   980,  1272,   543,  3169,
    1963,  1602,  1603,  3321,  1044,   594,  1545,   586,  2641,  2120,
    2251,  1611,  1635,  1256,  2976,  1618,   636,  1566,  1526,  3432,
    1740,  1447,  2980,  3031,  2982,  2875,  3452,  1462,  3454,  1948,
     936,  2129,  3412,   678,  3305,   646,  1488,  2336,  1953,  3638,
    1533,  2938,  1016,  3597,  1538,  3623,   714,  2140,  3668,  1542,
    3868,  2206,  2509,   859,  2157,  2662,    67,  1966,  1549,  3903,
    1448,  3902,  3352,  1016,   876,  3569,  3575,  3150,  1568,  3314,
    3312,  3313,  3569,  1590,  3651,  3897,   773,  1072,   982,   991,
    3940,  4059,   765,   774,  4109,  4115,  1061,  3305,  4099,  2646,
    3827,  4106,  2474,  2354,  2572,  3844,  4098,  3254,    76,    77,
      78,    79,    80,  3798,  2707,  2709,   105,   125,  1677,   707,
     130,   150,  2113,  2216,  2220,  2221,   741,   154,   172,   178,
     759,  2027,  1249,  3358,  3635,  1381,   772,  4381,  4256,  1304,
    1987,  1599,  1600,  1484,  1307,  3842,  3881,  3766,  4505,  2419,
    4605, -2175,  1610,   733,  1623, -2210,  1954,   870,  4457, -2107,
    4459,  3024, -2232,  4498,  2227,  3307,   553,  3211,   654, -2080,
    1565,  4254,  1602,  1603,  1273, -2261,  1355, -2080, -2080, -2081,
     881,  4531,  4532,  3657,  2232,  1083,  4524, -2081, -2081, -2416,
     654,  1611,   600,  1131, -1695, -1667,  2131, -2416, -2416,  2706,
    1618,     3,     4, -1680,   600,   808,   810,  1346, -1938,   814,
    2131,   816,  1411,  4681,  3610, -1938,  3943,   654,  3307,  2580,
    4735, -1707,  1522,  2062,  3002, -1700, -2052,  1686,  1725,  1830,
    1467,   874,  1591,  2960,   600,   600,  2333,  3208,  3209,  3357,
     750, -1700,  3228,  2615,  2446,  2289,   600, -2051,  1795,  -395,
    2616, -1695,  3167, -1710,  2580,  2756,  1788,  2986,  2062,  3408,
    3967,  3116,  3891,  3118, -1710,  4556,  2634,   654,  3413,   654,
   -2049,  1468,  2131,   882,  1529,  4238,  4627,  1801,  2131,  3258,
    3259,  1356, -1700, -2178,  1845,  1411,   600,  2214,  1591,  2936,
     654,  2484,   654,  1599,  1600,  2056,   600,  4615,  4006,  3211,
    4914,  1512,  3611,  4658,  2344,  3719,  2786,  1803,  1246,  1087,
     660,  4712,  1347, -1957,   660,   883,  2038,   551,   660,  1610,
   -1957,   660,  3972,  2057,  3750,  2880,  3751,   853,  3003,  1274,
    -134,  1275,   661,  4821,   660,  -134,   661,  4647,  -832,  1503,
     661,  2949,  4912,   661,  2308,  2772,  2862,  1473,  2883,  1795,
    1300,  2108,   946,   931,   187,  1853,   661,   946, -2231,  1518,
    3944,  3968,  2743,  1795,  4356,  1433,  2458,   884,   946,   660,
    2131,  4666,  4667,  1528,  3741,  1495,   853,   669,  4838,  2132,
    3462,  2787,  3612,   669,  4677,  2131,  1955,  1591,   548,  2131,
    1846,   661,  1801,  3463,  2139,  2063,  1854,   188,  4643,  2334,
    1434,  1789,   986,  3767,  1849,  1641,   187,  4357,  1803,  1861,
    1861,  1650,  1035,  4259,  1795,  2884,  2744,  4263,  2060,  1302,
    2309,  4596,  1803,  3973,  3187,   945,   982,  2131,  1469,  1835,
     954,  2444,  4915,  2259,  3892,  2450,  3506,  2452,   982,  2109,
    2455,   964,   660,  1801,  4965,  2263,  1474,  3720,  3752,   188,
    1761,  2881,  4713,  4659,  1324,  4007,  4616,  3969,  3753,  1348,
    2058,  1268,  3211,  1591,   661,  1269,  3893,  4628,  4239,  3945,
    1672,  1722,  3946,  1803,  2987,  2506,  2064,  4711,  2447,   819,
    1005,  2937,  1732,  3413,  3591,   923,  1831,  3894,  4149,  2141,
    4151,  1106,  1592,  3409,  1349,   982,  3004,  1741,   941,   601,
    2795,  2345,  1847,  1032,  1726,   928,   180,   925,   184,   926,
     927,  2291,  1420,  2099,  2870,  2578,  3658,  1953,   595,  2233,
    3613,  1258,  1470,  2107,  1350,  1688,  1494,  2228,  2097,  1726,
    1505, -1938,  4336,   751,  4936,   981,   604,  2863,  2757,  1744,
    2790,  3955,  2581,  3555,  3556,  1624,  2961,  3569,  1592,   761,
    1106,  1357,  1268,  4806,  1729,  2335,  1269,  2689,  2202,   921,
    2204,  4347,  2437,  1953,  3354,  4382,  2617,  2156,  1530,  1079,
    4785,   554,  1312,  3642,   934, -2231,  3929,  3274,   937,  3005,
    1276,  2211,  2215,  1641,  2173,  3614,  2192,  1351,  1530,  2195,
    2196,  2283,  3907,   180,   760,   184,   962,  2254,   671,  3376,
     671,  4899,   671,   666,   667,  3226,  2543, -2175,   671,  1094,
    1095, -2210,   982,  2250,  2561, -2107,  4822, -2080, -2232,  4398,
     982,   982,  1080,  1113,  1085,  3844,  1089, -2081,  1597,  4074,
    1109, -2261,  1093,  3098,  1619,  4206, -1957, -2416,  2423,  4210,
    4181, -2231, -1695,  1601,  1597,  1071,  4105,  1592,  2391,  1132,
    2369,  1605,   666,  1412, -2231,  4155,  1843,  1239,  2260,  4869,
    1248,   981,  1250,   853,   773,  4200,  4874,  1074,  1613, -1707,
    1096,   774,  1268, -1700, -2052,  2445,  1269,  4086,  4879,  1613,
    1998,  4243,  1791,  1833,  2456,  1999,  1822,  1614,  1500, -1700,
    1674,  1109,  2184,  3959,  2649, -2051,  2116,  2187,  1614,  1507,
   -1667,  1615,   666,   667,   666,   667,  3305,  4264,  3305,  2511,
    4859,  2671,  1617,  2061,   772,   179,   180,   174,   184,   175,
     177,  1315,  3541,  1592,  4663,   666,  1412,   666,   667,  3545,
    3546,  3507,  2814,  3549,  3223,  3224,  3225,  3226,  1259, -2178,
    3554,  3476,   820,  1948,  1428,  1084,  1086,  1088,  4927,  2464,
    1090,  1091,  1092,  2372,  2373,  4491,  3619,  3592,  2796,  3861,
    1097,   942,  4500,  1591,  1361,  1429,  1033,  2156,  1580,  2770,
    -134,  -134,  2142,  3603,   596, -1667,  1279,  4402,   671,  4839,
      39,   600,  4846,  2143,  4045,  2144,  3635,  3305,  2519,  1641,
     600,  3105,  3889,  1506,  4885,  2505,   550,  2508,  1819,  1820,
    1821,  1822,  1837,  2515,  1260,  1329,  3360,  2600,  3361,  2529,
    2530,  2531,  4044,    43,   600,  1492,  2180,  1127,  4933,  2547,
    2549,  2641,  2641,  2641,  2559,   768,   597,  3307,  4055,  3307,
      67,  4595,  3547,  3548,  2871,  2721,  1286,  4599,  1245,  1561,
    1098,  2145,  1253,  2057,  2622,  4600,  3477,  1817,  1818,  1819,
    1820,  1821,  1822,    47,   600,  1418,  1419,  2888,   600,  1562,
    2177,   598,  2113,   599,  3154,  3712,    48,  1838,  2347,  2465,
     719,  2859,    76,    77,    78,    79,    80,  1339,  4090,  4898,
     105,   125,  1330,  2302,   130,   150,  3879,    49,  1630,  2520,
    1355,   154,   172,   178,  4445,  3221,  3222,  3223,  3224,  3225,
    3226,  2690,  4415,   681,  1557,  4569,  4416,  4417,  3307,  4418,
    3746,  3747,  3748,  3749,  3156,  2344,  3754,  3755,  3756,  3757,
    3758,  3759,  3760,  3761,  3762,  3763,  3604,  2441,  4121,  2731,
     600,  3903, -1667,  1331,  2889,   775,  1520,  2601,  2048,  2729,
    4090,  2255,  2602,  1339,  3903,  1558,  3902,  1659,  2711,  2267,
    4847,   707,  1457,  4570,  2206,  2049,  2271,  2327,  2521,  3355,
    4934,  4571,  3324,  1543,  1544,  1976,   720,   693,  4056,  2048,
    2453,  2454,  3802,  3803,  2623,  2292,   768,  1493,  2603,  1789,
    3941,  1472,  1612,  4886,  1577,  1583,  2890,  1473,  1660,  4572,
    2268,  3070,  2303,  3478,  4403,  1356,   972,  3670,  1626,   981,
    2852,  1099,  4601,  1977,  4446,  4423,  2396,  2732,  3000,  4449,
    1563,   981,  2050,  2714,  4453,   776,  3318,  4455,  2522,  2409,
     671,  2523,  2358,  1592,  4504,  4729,  1332,  2209,  3479,   685,
    2051,   180,  2771,   184,  2418,  2366,  3330,  2328,  3400,  4750,
    2891,  1078,  2404,  2050,  4748,  1728,  4743,  1016,   694,  4741,
     766,  2853,  2466,  2786,  4887,  1645,  1647,  4740,  3480,  2380,
    2967,  2051,  4523,  4308,  4573,   691,  3155,  1627,   981,  3569,
    2371,  2467,  3433,   718,  2367,  4091,  2037,  3671,  4888,  3401,
    1620,  1626,   692,  1690,  3903,  1692,  1474,  1694,  4377,  1696,
    3566,  1698,  1699,  1700,  1749,  3577,  3668,  3566,  1702,  2442,
    3496,  1979,  1559,  2414,  4144,  2604,  1016,  4373, -1667,   742,
    4249,   767,  4366,  1758,   761,  2524,  3157, -1667,  1657,  1601,
   -1667,  1324,  4352, -1667,  1973,  2429,  1667,  1628,  2787,  2417,
    1629,  2443,  1675,  4278,  2892,  2800,  2712,  4835,  2854,  2713,
    3580,  2197,  1641,  1790,  1774,  1661,  1140,  2269,  -619,  3211,
    1627,  3052,  1792,  3212,  3213,  3214,  1980,  2922,  4676,  1786,
     973,  2535,   763,  2923,  2052,  3102,  1834,  3854,  1689,  3141,
    1336,  1691,  1337,  1693,  3664,  1695,  2739,  1697,   853,   768,
    1641,  1701,  1584,  1425,  4159,   981,  4160,  1294,  1851,  1852,
    2682,   695,   693,   981,   981,  2052,  1560,   671,  1967,  1968,
    4661,  1972,   671,   671,  1959,   774,   774,  4840,   774,  1401,
    1628,   715,  2166,  1629,   974,  3672,  1974,   654,   777,  2525,
     975,  1105,   753,  2801,  1630,  3103,  4501,  2329,   696,   697,
    -996,  4353,  2460,  1475,  1585,  2573,  3402,  4574,   881,  1662,
    2330,  2270,  4717,  3305,  2893,  1608,  1609,  3305,   772,   772,
    2681,   772,  2894,  4742,  4845,  2895,  4639,  1315,  3434,  3158,
    4242,  2928,  2924,  2238,  2667,  4622,  2053,  2588,  1476,  2589,
    2244,  2198,  4383,   694,  2199,  3244,  1641,  4345,  4052,   764,
    3673,  3251,  3584,  1295,  3435,  4384,  2683,  2790,  2931,  4897,
    2855,  2812,  2590,  4222,  4900,  3861,  2929,  2053,  1477,   568,
     187,  4229,  1106,  4035,   769,  2245,   671,  1630,  3425,  4038,
    4039, -2071,  4041,  2461,  4560,  -156,   671,   698,  4161,  3215,
    3113,  3585,  1630,  2932,  4445,   813,  2930,  1586,  1631,  3504,
    3403,   882,  2786,  3159,  2307,  3586,  1436,  3119,  2320,  4141,
    3216,  -156,    39,   188,  2904,  2475,  2668,  1632,  4943,  3903,
    2238,  4782,  2907,  2933,  2909,  1095,  4679,   570,  2902,  4718,
    4684,  4685,  1300,  3114,  3307,  4509,  4797,  2092,  3307,  3957,
    4590,  3569,  2265,   883,  3426,    43,  2543,  2543,  1587,   671,
    2915,  2543,   671,   671,  1437,  2364,  2210,  3036,  3037,  3038,
    3039,  2591,  4789,  4790,  3834,  3505,  2592,  2903,  1976,  3044,
    3217,  2593,   982,  2213,   853,   881,  3708,  2787,  2955,  2925,
    4969,  1631,  4583,  2830,  2151,    47,   695,  3088,  2543,  2543,
    1428,   778,  4530,  3587,  2397,   884,  1641,  4719,    48,  4798,
    2266,  1302,  3328,  3577,  2394,  3958,  1977,  2788,  -418,  3578,
    1530,  1429,   568,  3424,  2926,  4385,  2178,  1259,   568,    49,
    3579,   671,  2238,   696,   697,  4085,  3371,  4053,  4664,  2888,
    3886,  3086,  1588,    50,   815,  3835,  1438,  4669,  1300,  2831,
     835,  1303,  2789,  1301,  2927,  1255,  2066,  2776,  3580,  3017,
    3581,  2222,  2223,  2224,  2225,  3869,  2067,  2317,  2809,  2832,
    1978,  2136,  1339,  2137,  1401,  3836,  4260,  1339,   882,  3732,
     570,   640,  3711,  2641,  1450,   578,   570,   579,   822,  -524,
    3837,  2179,  2726,  1260,  1439,  2743,  2206,  1440,  2768,   836,
    3838,    14,  4054,   853,  2261,  2262,  1127,  2205,  2594,  4527,
    2783,  1546,    39,  2274,  1979,  3903,  2889,  1302,  2595,  1451,
     883,  3712,   930,  2286,  3870,  2833,  3839,  -418,  2370,  2138,
    4528,  4125,  3310,  4126,    19,  4558,  1442,  3582,  2378,  2896,
    2379,  4261,  3566,  3835,  4508,    43,  2790,  2384,  2664,  3379,
    2816,  2322,  2323,  2324,  2325,  2390,  3508,  1303,  3218,  3219,
    3220,  1321,  3221,  3222,  3223,  3224,  3225,  3226,  2890,  1980,
    3210,  4025,   884,  3836,  3354,  4924,  3488,  1444,  4747,  2042,
    4734,  3143,  3238,  3382,  2148,    47,  4534,  4584,  4212,  2043,
    3701,  4026,  3305,  2896,  3910,  3583,  1322,  3305,  3838,  3263,
    3584,  3264,  3305,  4731,  3840,  3305,  2044,   943,  4339,   944,
    2068,   180,  2158,   184,  3261,  2149,  1446,  3018,  4585,  4527,
    1452, -2071,  2891,  3064,  3265,    34,  1323,  2934,   578,  3305,
     579,  2678,  2679,    50,   578,  2365,   579,  4614,  4340,  3585,
    4528,  2886,  3305,   866,  4758,  2069,  2408,  2481,  4414,  2411,
    2469,  1482,  3287,  3586,   584, -1541, -1541,  2935,  2664,  2416,
    1546,  2197,   928,   180,   925,   184,   926,   927,  2424,   867,
    2431,  3911,  2432,  2528,  2433,   965,  2434,  3359,  2435,  2517,
    2518,  4673,  2436,  2714,  2395,  1074,  2532,  2533,  2399,  3399,
    1329,  2289, -1517,  4670,  2405,  2406,  3643, -1517,    31,  3647,
     982,  3834,  3840,  1613,  4765,  2994,   966,  2391,  2158,  3316,
    3317,  3668,  2203,  3307,  2571,  2148,  2892,  2422,  3307,    34,
    1326,  2158,  1614,  3307,  2158,    39,  3307,  3912,  3266,  3913,
    1428,  4766,   872,  3267,  2503,  1463,  1795,  2586,   967,  2480,
    4355,  3587,  2021,  2045,  3082,  1482,  2149,   965,  4610,  4844,
    3307,  1429,  4487,  2159,  4489,  1327,  3019,   880,    43,  4267,
    4268, -1517,   982,  3307,  2650,  1801,  4376,  1330,  1428,  2305,
    1464,   935,  3835,  4329,  1465,  4330,  4331,  2022,   966,  4332,
    2160,  1861,  3305,  4364,   968,  1328,   933,  2718,  2337,  1429,
    3473,  2198,  2722,  1669,  2199,  1803,  2725,  2583,    47,  3020,
    1466, -1517,  3836,  2161,  4704,  2162,  3131,  2023,  2217,  4705,
    3621,    48,  1251,  3237,  1670,  3239,  3240,  3837,  1331,   853,
     561,  3319,  2749,   938,  2243,  3474,  2893,  3838,     3,     4,
    4008,  2246,    49,  1841,  2894,  3041,  4420,  2895,  2156,   952,
    3042,  3391,  3707,  2247,  3305,   970,    50, -1481,  4757,  2159,
    2764,  4009,  4527,  3839,  4706,  3475,   968,   822,  1613, -1481,
    3268,  4792,  2159,  1268, -1481,  2159,  2802,  1269,  2248,  3183,
    3269,   960,  4450,  4528,  2426,  3364,  2160,  1614,  3184,  3624,
    1601,  -523,  2028,  3185,   946,  3908,   640,  1140,  3633,  2160,
    3211,  1615,  2160,  3161, -2417, -2417, -2417,   969,   671,  2161,
    3414,  2162,   568,  3307,  3576,  1613,    14,   971, -1481,  3042,
    3173,  1332,  2161,  1039,  2162,  2161,  2850,  2162,  4935,  1031,
    3322,  3179,  2673,  -990,  1614,  3437,  1679,   984, -1481,  1680,
    3888,  3840,  2692,   180,  2156,  1601,   988,  2028,  1617,    19,
    1734,  3417,  3778,  1735,  4960,  1040,  1957,  2156,   946,  1958,
    2156,  2733,  2898,  2736,   221,   981,   947,  2808,   948,   552,
     570,  1333,  2506,  1279,   671,  3307,  1960,   638, -1481,  1961,
    2910,  3272,  4701,  1268,  4703, -2052, -1481,  1269,  4707,  4871,
    4708,  2920,  1045,  2158,  2425,   716,  2438,  2426,  2730,  2439,
    2440,  1056,   982,  2439,  2945,  2472,  1334,  1601,  2473,  1324,
      34,  2657,   946,  4781,  3032,  2663,  2806,  2877,  2664,  2807,
    2878,  4451,  1065,   654,  2641,  3468,  3938,  1069,  2794,  2641,
    3910,  2887,  3305,  1100,  1250,  2641,  1335,  1104,  2158,  2543,
    2543,  2543,  2543, -1481,  1108,  2543,  2543,  2543,  2543,  2543,
    2543,  2543,  2543,  2543,  2543, -1481,  2991,  3305,  3722,  2992,
   -1481,  2995,  1111,  3089,  2996,  1336,  2426,  1337,  3930,  3104,
    3106,  3107,  3776,  4714,  3566,  2506,  2360,  4535,  2361,  3135,
    2766,  2767,  2439,  3942,  3947,  2952,  1114,  3368,  3369,  2778,
    1116,  2780,  3727,  2797,  1117,  2784,  3182,  3682,  3683,  2426,
    3191,  2543,  2543,  2426, -1481,  3593,  1748,  3911,    50,  4621,
    1124, -1481,   982,    31,  3197,  1338,  1118,  2426,   578,  3960,
     579,  1125,  1126,  3198, -1481,  2158,  2426,   671,  4956,  3199,
     581,  1127,  2426,  3230,  2159,   671,  2426,   671,  2872,  1130,
      39,   583, -1480,  3243,  1546,  3248,  2426,  3455,  3249,  3460,
    3456,  3217,  3461,  3307, -1480,  3655,  3389,  3680,  3656, -1480,
    2426,  2160,  1128,  3912, -1481,  3913,  2859,  4108,  3956,  1133,
    1129,  1268, -1481,    43,  1290,  1269,  1134,  3773,  3307,  2159,
    3774,  2969,  1136,  1254,  2161,  1140,  2162,  2158,  3211,  2969,
    1257,  1261,  3212,  3213,  3214,  3392,  1262,  2969,  3783,  2969,
    1263,  3784,  3794, -1480,  2905,  2426,  2160,  1280,  3877,  3791,
    4579,  3878,  3404,    47,  3057,  3882,  3058,   641,  3883,  2156,
    1601,  1267,  2028, -1480,  4922,  3503,    48,  3905,  3906,  2161,
    3148,  2162,  3887,  1287,  2565,  2713,  1362,  2568,  3909,  3982,
    3491,  2439,  3983,  3305,  1288,  3035,  3743,    49,  3162,  4087,
    3499,  3288,  2439,  3289,  4901,    28,  3148,  4945,  1290,  3725,
    2966,   642,  1298, -1480,  2156,  3290,  2159,  3291,  2975,  1363,
    2977, -1480,  1291,  3172,  4138,  3065,  2979,  1726,  1313,  3176,
    3772,  4096,  3070,   981,  3053,   180,  1314,  3509,  4156,  4394,
    1318,  2426,  4182,  2160,  4046,  2473,  4047, -1481,  4194,  1364,
    4868,  2426,  4245,  3033,  4251,  2713,  3481,  4252,  3483,  3609,
    4257,  1354,  1324,  2439,  3097,  3099,  2161,  3728,  2162,  4258,
    4378,  3108,  2439,  4379,  1359,  3814,  4975,  1365,  2159, -2417,
   -2417, -2417,  1385,  3221,  3222,  3223,  3224,  3225,  3226,    39,
    4961,  1383,  4962,   853,  2158,   981,  4425,  1389,  3054,  4426,
    1297,  2156,  1299,  1390,   982,  2160,   982,  1290,  4427, -1469,
    1366,  2426,  2391,  4435,  3307,  4506,  2473,  4580,  4507,  3528,
    2439,  4607,    43,  3602,  4608,  3605,  3566,  1387,  2161,  3216,
    2162,  1388,  4623,  4631,   671,  2473,  4632,  1422,  4636,  1794,
    3926,  2664,  1795,  1391,  3542,  1367, -1480,  4211,  3594,  4214,
    3596,   837,  3715,    39,  3115,  1420,  3117,  2543,   838,   839,
     840,  4642,    47,  2156,  3631,  3333,  4132,  4133,  4134,  4644,
    3308,  1801,  3631,  1423,   982,    48,  3091, -2417,  1368,  4656,
    4694,  1495,  4657,  4695,  1424,  1425,    43,   766,   761,  3217,
    4730,  1427,  1458,  1840,  3538,  1393,    49,  4749,  3112, -1518,
    4657,  1803,  1394,  1435, -1518,  1395,  1369,  1370,  4759,  1432,
    4902,  2473,  4760,  3121,  1459,  3249,  3123,  3124,  3661,  1471,
    1480,  3127,  3128,  3308,  4761,  1481,    47,  2426,  3132,  1485,
    1396,  1490,   761,  1786,  4606,  2159,  2816,  4771,  3365,    48,
    2664,  1371,  3850,  4774,  4796,    34,  3631,  2473,   767,  1372,
    3855,  3856,  3857,  2158,  4802,  4539,  1373,  2473,  3181,  1491,
      49,  1397,  2160,  1374,  1496,  1498,  3260,  3679, -1518,  4803,
    4376,  1375,  2473,  3721,    50,  1499,  4829,  1786,  1501,  4830,
    1508,  3387,  1504,  1376,  4276,  2161,  4860,  2162,  1509,  2664,
    3171,  1377,  1794,  4861,  2586,  1795,  2426,  4540,  1515, -2417,
   -2417, -2417,  1519,  1516,  3293,  3294,  3295, -2417, -1518,  1521,
    3281,  4862, -2417,  1524,  2426,  1527,   768,  1534,  1953,  1398,
    2156,  1399,  4541,  1537,  1801,   981,  3299,  1539,  1530,  1548,
    1802,  1400,  3323,  4864,   671,  1550,  2426,   761,  4542,  1401,
    1551,  4881,  4543,  4553,  4882,  1378, -2324,  2506, -2417,  1402,
    -176,  1553,  4918,  3931,  1803,  3631,   928,   180,   925,   184,
     926,   927,  4544,  4921,  1555,  4545,  4650,  3218,  3219,  3220,
    3736,  3221,  3222,  3223,  3224,  3225,  3226,  1794,  4546,  3299,
    1795,  1567,   760,  1569,  1796,  1797,  1798,  1404,  1405,  3464,
      28,  3745,  4944,  1810,  2159,  4657,  4958,  4984,  1576,  4959,
    4959,  1799,  3484,  4030,  1578,  3332,  1582,   206,  1589,  1801,
    1594,  4042,  1596,  1604,  1406,  1802,  3768,  1595,  1597,  1601,
    1605,  2160,  1607,  1621,  1637,  1638,  1652,  1640,  1641,  1648,
    1651,  1653,  1654,  1655, -2324,   981,  1656,  1658,  3488,  1803,
    1663,   769,  1664,  1665,  2161,  1140,  2162,  1666,  3211,  1668,
    1729,  1673,  3212,  3213,  3214,  1731,  2158,  1678,  4547,  1703,
    1804,  1736,  1745, -1671,  1738,  1805,  4548,  4316,  4317,  3792,
    4319,  1739,  4118,  1746,    39, -2417, -1678,  1407,  1755,  2156,
    1753,  3539,  1754, -2324, -1668,  1756,  3333,  1757,    50,  1759,
    1760,  1761, -1669,  3333,  1762, -2324, -1672,  1763,  1764,  4177,
   -2324,  1808,  1766,  4549,  1767, -2324,  1768,    43,  1769,  1770,
   -2324, -1670,  1771, -2324,  1826,  1772, -2324,  1773,  1775,  1828,
    1776,  1777,  3458,  1778,  1779,  3395,  1780,  3396,  3397,  3398,
    1830,  1781,  1782,  4394,  1844,  1856,  1864,  1831,  1840,  1965,
    1301,  1994,  2005,  2024, -2324,  1804,  1810,    47,  1996,  1303,
    1805,  2025,  3385,  2026,  2028,  2029,  3961,  2030,  2031,  2032,
      48,  2033,  2034,  4166, -2324,  2040,  3497,  2059, -2417,  2065,
    2071,  1806,  1807,  2094,  2098,  1817,  1818,  1819,  1820,  1821,
    1822,    49,  2100,   843,   844,   845,  1808,   846,   847,   848,
     849,   850,   851,  2101,  2102,    50, -1249,  2159, -1249,  4135,
    2103,  2105,  2106,  2122, -2324,  2123, -2324,  2134,  2121,  2135,
    2150,  2152, -2324,  2155,  1140,  3530,  2146,  3211,  1809,  2164,
    2153,  3212,  3213,  3214,  2160,  2154,  2165,  2156,  1812,  2167,
    2168,  1810,  3442,  1140,  3444,  2169,  3211,  2969,  4184,  3216,
    3212,  3213,  3214,  2183,  2969,  2969,  2174,  2161,  2969,  2162,
    2185,  2189,  2175,  2238,  2190,  2969,  2193,  4185,  3558,  2200,
    1401,  2229, -2324,  2230,  3568,  2212,  2234,  2235,  3710,  2256,
    2257,  3568,  4361,   671,  2264,  2201,  2258,   981,   822,   981,
     671,  1140,  2156,  2272,  3211,  2273,  2275,  2207,  3212,  3213,
    3214,  2208,  2218,  3724,  2219,  2231,  2285,  2239,  2279,  3217,
    2290,  2242,  2276,  3606,  2293,  2294,  2297,   563,  2284,  4070,
    4071,   685,  2298,  1812,  2277,  2306,  1452,  3629,  2321,  3543,
    2326,  1813,  4075,  2339, -2417, -2417, -2417,  2301,  1817,  1818,
    1819,  1820,  1821,  1822,  2343,  2543,  2342, -2324,  2351,  2357,
    2359,  2363,  2374,  3527,  4428,  2376,  3660,   981,  2377,  3534,
    2383,  2385,  2381,  2382,  3650,   180,  2355,  2368,  2386,  2387,
    2389, -2324,  2401, -2324, -2324,  2398,  2388,  2403,  2400,  2402,
    2420,  4096,  2421,  2451,  2457,  3681,  3677,   180,  2470,  2511,
    2483,  2560,  2516,  2566,  1795,  2619,  2579,  4072,  4538,  2570,
    2585,  2597,  2599,  2620,  2634,  2648,  2665, -2324,  2652,  2651,
   -2324, -2324, -2324,  2654,  2674,  2655,  1813,  2656,  3216,  1814,
    1815,  1816,   767,  1817,  1818,  1819,  1820,  1821,  1822,  2666,
    2676,  3808,  2675,  2677,  2687,  2693,  2702,  3216,  2703,  2715,
    2705,  2716,  3308,  2737,  3308,  1794,  1109,  1320,  1795,  2717,
    2734,  2739,  2741,  2742,  2748,  2753,  2758,  2763,  2759,  2761,
    2765,  2773,  2781,  4910,  4911,  2769,  2782,  2785,  2799,  4235,
     671,  2798,  2804,  1251,  1255, -2326,  2820,  1801,  3217,  2821,
    2815,  2834,  2839, -2417,  3696,  3216,  3697,  3218,  3219,  3220,
    3699,  3221,  3222,  3223,  3224,  3225,  3226,  3217,  2840,  2867,
    2866,  3678,  2869,  2861,  2897,  2876,  2879,  1803,  2882,  2940,
    2951,  2958,  2959,  2962,  2964,  2963,  2972,  2970,  2971,  4635,
    2973,  2974,  2981,  3308,  2983,  2978,  2985,  2989,  3689,  3690,
    4635,  3692,  2990,  3694,  3695,  3009,  3023,   761,  2997,  3027,
    3789,  3040,  3048,  3927,  3730,  3217,  3702,  3034,  3025,  3050,
    3051,  3062,  3043,  3063,  3066,   761,  3067,  3060,  3049,  3080,
    3081,  3083,  3084, -2326,  3085,  3087,  3090,  3095,  3333,  3092,
    3093,  3109,  3271,  3096,  3816,  3817,  3818,  3819,  3111,  3094,
    1630,  3101,  1786,  3110,  3723,  3120,  3122,  1729,  3125,  3126,
    3129,  3134,  3130,  4982,  4983,  3137,  3138,  3139,  3823,  3140,
    3826,  2664,  1674,  3142,  3149,  4692,  2484,  3152,  2543,  3153,
    3160,  4233, -2326, -2417,  3163,  3151,  3168,  1106, -2417,  3170,
    3175,  3177,  3178,  3196, -2326,  3180,  3193,  2426, -1930, -2326,
    3174,  3262,  3194,  3195, -2326,  3200,  3201,  3245,  3203, -2326,
    3206,  3207, -2326,  3229,  3235, -2326,  3242,  3256,  4010,  3257,
    4274,  4013,  3270,  3279, -2417,  3280,  3218,  3219,  3220,  3315,
    3221,  3222,  3223,  3224,  3225,  3226,  3284,  3310,  3341,  3339,
    3362,  3282,  3283, -2326,  3286,  3218,  3219,  3220,  3345,  3221,
    3222,  3223,  3224,  3225,  3226,  3343,  3349,  3370,  3372,  3335,
    3373,  3381,  3384, -2326,  3421,  3423,  3394,  3386,  3356,  1810,
    3428,  4348,  3429,  3410,  3411,  3440,  3427,  4266,  3441,  3430,
    4772,  3377,  3443,  4312,  3378,  3449,  3451,  3459,  3450,  3469,
    3490,  3492,  3494,  3218,  3219,  3220,  3495,  3221,  3222,  3223,
    3224,  3225,  3226, -2326,  3500, -2326,  3498,  3501,  4283,  3502,
    3510, -2326,  3512,  3511,  3513,  3514,  3568,  3515,  3516,  3517,
    3520,  4077,  3518,  3519,  3521,   671,  3522,  3523,  3525,  4298,
    4538,  3524,  3533,  3531,  3921,  3922,  3923,  3924,  3526,  3529,
    4461,  3535,  2227,  3537,  3544,  3550,  3551,  4476,  3553,  3991,
    3560, -2417,  3992,  3570,  3993,  3573,  4698,   671,  3607,  3616,
    4680, -2326,  4486,  3600,  3601,  3618,  3620,  3622,  4683,  3631,
    3630,  4551,  3639,  3644,  3641,  3645,  3648,  1140,  3649,  3652,
    3211,  3990,  3653,  3665,  3212,  3213,  3214,  4325,  3676,  1623,
    3684,  3685,  3703,  3704,  3687,  4625,  3705,  3691,  2969,  3716,
    3706,  3693,  3714,  3717,  2969,  2969,  3709,  2969,  3718,  3726,
     685,  3729,  3731,  3558,  4688,  3148,  4690,  3735,  3232,  1748,
    3211,  3744,  3797, -1929,  3231,  1094,  1095,  3769,  3770,  3771,
    3777,  3785,  3796,  3800,  1788,   768, -2326,  3809,  3815,  3825,
    3872,  3852,  3849,  3865, -2417,  3833,  3880,  3875,  3847,  3896,
    3890,  1817,  1818,  1819,  1820,  1821,  1822,  3917,  3919,  3862,
   -2326,  3920, -2326, -2326,  3864,  3925,  1794,  3866,  3932,  1795,
    3867,  3933,  3934,  3935,  3937,  3948,  4399,  3963,  3939,  3951,
    3964,  3966,  3965,  3976,  4814,  4816,  3977,  3978,  3984,  3979,
    3980,  3981,  3985,  3987,  3988,  3997, -2326,  3998,  1801, -2326,
   -2326, -2326,  4005,  4020, -2417,  4022,  4107,  4024,  3943,  4027,
    4033,  4034,  4050,  4036,  4037,  4808,  4040,  3667,  4049,  4103,
     180,  4057,  1729,  4067,  4060,  4081,  4089,  4100,  1803,  4083,
    4080,  4942,  4577,  4065,  4073,  2439,  4084,  4119,  4101,  4113,
    4117,  4116,  4123,   853,  4114,  4136,  4140,  4120,  4131,  3308,
    4122,  4142,  4153,  3308,  4143,  4147,  4148,  4150,  4158,  4630,
    4168,  4167,  4162,   680, -1931,   682,  4163,  4494,  4175,   688,
    4171, -2417,   671,  4510,   702,   710,   680,  4202,   717,  4169,
    4146,   710,   710,  4146,   746,  4146,   749,  4170,  4190,  4203,
    4207,  4205,  4883,  3801,  4942,  4208,  4215,  1794,  4764,  4216,
    1795,  4221,  4220,  4223,  4224,  4234,  4241,  4226,  4700,  4244,
    4773,  4515,  4227,  4942,  4246,  4775,  4228,  4777,  4248,  4253,
    4254,  4279,  4262,  4280,  4286,  4287, -2340,  4309,  4288,  1801,
    4299,  3217,  4302,  4311, -2417, -2417,  4320,  4314,  4315, -2417,
    4328,  4341,  4333,  4342,  4349,  4354,  4358,  4360,  4362,  4359,
    4365,  4368,  4380,  4370,  4389,  4387,  4390,  4391,  4392,  1803,
    3333,  4400,  4405,  4411,  4421,  4412,  4422,  4293,  4424,  4429,
    4431,  4432,  4433,  4124,  4434, -2417,  4440,  4447,  4458,  4303,
    4454,  4127,  4128,  4129,  4130,  4478,  4474,  4480,  4483,  4488,
    4499,  4533,  4503,  4512,  4484,  4552,  4502,  4517,  4554,  4518,
    4808,  4056,  4522,  4561,  4563,  3299,  4564,  4566,  4567,  3299,
    4568,  4589,  4582,  4588, -2340,  4594,  4230,  4587,  4232,  4597,
    1810,  4592,  4928,  4609,  3804,  4598,  4611,  4612,  4633,  4613,
    4626,   804,   809,   809,   812,  4629,   809,  4645,   818,  4638,
     804,  4641,   746,  4646,  4247,   855,  4650,  4648,  4236,   180,
    4654,   746,  4665,  4715,   746,  4672,  4674,  4687,   809,  4720,
     746,  4724,  4725, -2340,  4727, -2417,  1389,  4744,  4732,  4745,
   -2417,  4738,  1390,  4746,  4753, -2340,  4351,  4756,  4754,  4755,
   -2340,  4762,  1729,  4763,  4770, -2340,  4776,  4779,  4780,  4784,
   -2340,  4795,  4783, -2340,  4799,  4786, -2340,  4681,  4813,  4819,
    4820,  4833, -2417,  4823,  4825,  4831, -2417,  4834,   671,  3218,
    3219,  3220,  1391,  3221,  3222,  3223,  3224,  3225,  3226,   982,
    3528,  4828,  4841,  4842, -2340,  4849,  4843,  4850,  4877,  4858,
    4296,  4297,  4281,  4884,  4821,  4300,  4301,  3810,  3568,  4822,
    4892,  4870,  4913,  4896, -2340,  3148,  4919,   671,  4872,  4932,
    4891,  1810,  4953,  4957,  4964,  4963,  4967,  4976,  4954,  4951,
    4952,  1392,  4971,  4972,  1393,  4977,  4979,  4978,  4980,  2240,
    1386,  1394,  3029,  1729,  1395,  1863,  2865,  1729,  1729,  4323,
    4324,  4791,  1292,  1431, -2340,  1456, -2340,  3325,  2969,  3436,
    2969,  2969, -2340,  1455,  2969, -2417,  3954,  2950,  3559,  1396,
    4265,  4043,  1817,  1818,  1819,  1820,  1821,  1822,  4709,  4807,
    4930,  4591,  4069,  4593,  4576,  3375,  4346,  4492,  3308,  3136,
    4873,  4926,  4826,  3308,  4824,  4890,  3380,  4104,  3308,   853,
    1397,  3308,  4456, -2417,  4284,  4285,  4088,  4064,  4372,  3007,
    3008,  4318, -2340,  3952,  3453,  2318,  4076,  2998,  3626,  3148,
    4931,  3148,  4981,  4363,  4968,  3308,  4322,  4565,  3574,  3571,
    4374,   180,  3333,  4894,  2300,  4516,  4801,  4393,  3308,  4752,
    4878,  4519,   687,   853,  1723,  4660,  4137,  1733,   982,  4788,
    2708,  4110,  3363,  4751,   983,  3532,  4306,  1057,  1398,  2479,
    1399,   685,  4904,  4970,  1264,  2660,  2477,  4146,  2478,  2659,
    1400,  4146,  4146,  2039,  4146,  2430,  4092,  4237,  1401,  4867,
    3884,  3331,  4514,  4326,  4327,  1962,  1836, -2340,  1402,  2686,
    3338,  3340,  4863,  1991,  4375,  3863, -2417,  1990,  4778,  4231,
    2685,  3828,  4640,  1817,  1818,  1819,  1820,  1821,  1822,  1995,
    3342, -2340,  2000, -2340, -2340,  4201,  3824,  4769,  4213,  4768,
    3885,  3686,  2375,  1403,  4624,   822,  1404,  1405,  3779,  4477,
    4866,  4865,  4857,  3334,  3327,  2624,  3277,  3275,  3188,  2633,
       0,     0,     0,     0,     0,     0,     0, -2340,     0,  3299,
   -2340, -2340, -2340,  1406,  3299,     0,  1794,  3299,     0,  1795,
     890,     0,     0,     0,     0,     0,   746,     0,   804,     0,
       0,   809,     0,   812,     0,   809,     0,  4407,  3308,     0,
    4408,  4409,   855,  4485,     0,     0,   957,     0,  1801,     0,
       0,     0,     0,   809, -2417,     0,  4413,     0,     0,     0,
       0,     0,     0,     0,     0,  1794,     0,     0,  1795,     0,
    3568,     0,  1796,  1797,  1798,     0,  1407,   804,  1803,   671,
       0,     0,   812,     0,     0,  4479,     0,   804,     0,     0,
       0,   855,     0,   982,     0,     0,  1794,  1801,     0,  1795,
    3308,     0,     0,  1802,     0,     0,     0,     0,   809,     0,
       0,     0,  2969,     0,  1794,     0,     0,  1795,  4495,  4496,
    4496,  1796,  1797,  1798,     0,     0,     0,  1803,  1801,     0,
       0,     0,     0,     0, -2417,     0,     0,     0,  1799,     0,
       0,     0,     0,  3805,     0,     0,  1801,     0,     0,     0,
       0,     0,  1802,     0,     0,     0,     0,   746,  1803,     0,
       0,     0,     0,  4581,   180,     0,     0,     0,     0,     0,
     746,     0,  1123,     0,     0,     0,  1803,     0,     0,     0,
       0,     0,     0,     0, -2417,     0,     0,     0,     0, -2417,
    4602,   180,  1236,  1236,     0,   746,   710,     0,     0,     0,
     710,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4726,     0,   746,     0,     0,     0,   746,     0,
       0,     0,   761,  4188,  1236, -2417,     0,     0,     0,     0,
       0,     0,     0,  1804,     0,     0,   746,     0,  1805,     0,
       0,   761,     0,     0,     0,     0,     0,     0,   746,     0,
       0,     0,     0,     0,  4603,     0,  3299,     0,     0,  1806,
    1807,     0,     0,     0, -2417,     0,     0,  1786,     0, -2417,
    1810,   853,     0,     0,  1808,     0,     0,     0,  3308,     0,
       0,     0,  1804,     0,     0,     0,  1786,  1805,     0,     0,
       0,   746,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3308,     0, -2417,  1809,   746,  1806,  1807,
       0,     0,   809,   809,     0,     0,     0,     0,     0,  1810,
       0,     0,   981,  1808,     0,     0,  4702,     0,     0,  4620,
       0,   671,     0,     0,     0,     0,  4710,   710,   710,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1810,     0, -2417,     0,     0,  1809,     0,     0,     0,     0,
       0,     0,     0,   804,     0,     0,     0,     0,  1810,     0,
       0,  1811,     0,     0,   804,     0,     0,     0,   855,     0,
       0,     0,     0,     0,  4837,     0,     0,     0,     0,     0,
    4739,   180,     0,   809,  4689,     0,  4691,     0,     0,     0,
       0,  1812,     0,     0,  4662,     0,     0,     0,     0,     0,
       0,     0,     0,   746,     0,     0,     0,  3148,     0,     0,
     809,   809,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0, -2417,     0,     0,     0,     0,   746,   746,   746,
       0,   809,  4876,   804,     0, -2417,     0,     0,     0,  4693,
    1812,     0,  1817,  1818,  1819,  1820,  1821,  1822,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   981,     0,     0,     0,  4811,     0,  4812,     0,  3308,
       0,  4817,  4818,     0,  1813,   822,   822,  1814,  1815,  1816,
       0,  1817,  1818,  1819,  1820,  1821,  1822,     0,     0,     0,
     809,     0,   809,   809,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0, -2417,     0,  4496,     0,  2487,
       0,     0,  1817,  1818,  1819,  1820,  1821,  1822,     0,     0,
    1236,     0,     0,  1813,     0,     0,  1814,  1815,  1816,     0,
    1817,  1818,  1819,  1820,  1821,  1822,     0,     0,     0,     0,
       0,     0,     0,  3202,     0,     0,     0,     0,     0,     0,
    1706,  1706,     0,     0,     0,   746,  2488,   680,     0,     0,
       0,     0,     0,     0,     0,     0,  1794,     0,     0,  1795,
       0,     0,     0,     0,     0,     0,  4832,     0,  1737,     0,
       0,   746,     0,     0,  1743,     0,     0,  2489,     0,     0,
       0,     0,     0,  4974,     0,     0,     0,  1236,  1801,     0,
       0,     0,     0,     0, -2417,   822,   822,     0,     0,  2490,
       0,     0,     0,     0,     0,  4895,   180,     0,     0,     0,
    2491,     0,     0,     0,     0,     0,  1236,     0,  1803,  4909,
     180,  4906,   184,  4907,  4908,  1794,     0,     0,  1795,  4950,
    2492,     0,  1796,  1797,  1798,  2493,   981,     0,     0,     0,
    4880,     0,     0,     0,  1236,  1236,  1236,     0,  1236,  1799,
    4941,     0,     0,     0,     0,     0,     0,  1801,     0,  4940,
       0,     0,     0,  1802,     0,     0,     0,     0,  1236,     0,
       0,     0,  1362,  4909,  4949,  4906,   184,  4907,  4908,     0,
       0,     0,     0,  2494,     0,     0,     0,  1803,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2495,  1363,   746,     0,     0,  1236,
       0,  4929,     0,  4941,     0,     0,     0,     0,     0,     0,
       0,     0,  4940,     0, -2417,     0,     0,     0,     0, -2417,
       0,     0,  4941,  4909,   180,  4906,   184,  4907,  4908,  1236,
       0,  4940,     0,  1236,  1236,     0,     0,     0,     0,     0,
       0,     0,     0,  4923,   746,   746,  2004,     0,     0,     0,
       0,     0,     0,  1365,     0, -2417,     0,   206,     0,     0,
       0,     0,     0,     0,     0,     0,   710,     0,     0,     0,
       0,     0,  1389,     0,     0,     0,     0,     0,  1390,     0,
       0,     0,     0,  1804,  2496,     0,  1366,     0,  1805,     0,
       0,  2497,     0,     0,     0,     0,     0,  2498,     0,     0,
    1810,  2104,     0,     0,     0,     0,   710,     0,     0,  1806,
    1807,     0,     0,     0,     0,     0,     0,     0,  1391,   746,
    2130,  1367,     0,     0,  1808,     0,     0,     0,   746,  2499,
       0,   809,  2500,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2501,     0,     0,   855,  1368,   746,  1809,     0,     0,     0,
       0,     0,     0,   746,     0,     0,   746,  2170,     0,  1810,
    1393,     0,  1811,     0,     0,  2502,     0,  1394,     0,     0,
    1395,     0, -2417,  1370,     0,     0,     0,     0,     0,     0,
     746,     0,     0,     0,     0,     0,     0,     0,   809,   809,
     809,   809,   746,     0,     0,  1396,     0,     0,     0,     0,
       0,     0,     0,   710,     0,     0,   746,     0,     0,     0,
       0,    34,     0,  2114,     0,  1372,     0,  2252,     0,   746,
       0,     0,  1373,     0,     0,     0,  1397,     0,     0,  1374,
       0,   809,   809,     0,     0,     0,     0,  2115,     0,     0,
     809,  1812,     0,     0,     0,     0,     0,     0,     0,  1376,
     809,     0,     0,     0,     0,     0,     0,  1377,     0,     0,
       0,     0,     0,     0,     0, -2417,     0,     0,     0,   746,
       0,     0,  1817,  1818,  1819,  1820,  1821,  1822,   809,   809,
     809,   809,     0,     0,  1398,     0,  1399,     0,     0,     0,
     746,     0,     0,     0,     0,     0,  1400,   746,     0,     0,
    2252,     0,     0,     0,  1401,     0,     0,     0,     0,     0,
     804,  1378,     0,     0,  1402,     0,     0,   812,     0,     0,
       0,     0,  1236,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1813,     0,     0,  1814,  1815,  1816,
       0,  1817,  1818,  1819,  1820,  1821,  1822,     0,     0,  2171,
       0,     0,  1404,  1405,  3252,     0,     0,     0,     0,   804,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   855,
       0,     0,     0,   809,     0,     0,   809,     0,     0,  2172,
       0,     0,     0,     0,  1793,     0,   809,     0,     0,  1794,
       0,     0,  1795,     0,   809,   809,  1796,  1797,  1798,   746,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1799,     0,     0,  1800,     0,     0,     0,
       0,  1801,     0,     0,  1706,     0,     0,  1802,     0,     0,
       0,   809,     0,   804,     0,     0,     0,   746,   746,   834,
     809,     0,  1407,     0,     0,     0,     0,   746,   864,     0,
       0,  1803,     0,     0,   746,     0,     0,   879,     0,   680,
     680,     0,     0,  2486,     0,     0,     0,  1236,     0,  1236,
       0,     0,     0,     0,  1236,  1236,     0,     0,     0,     0,
       0,  1236,  1236,  1236,     0,     0,     0,  1236,   855,  1236,
    1236,  1236,  1236,  1236,  1236,     0,  1236,     0,  1236,  1236,
       0,     0,  1236,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1236,  1236,  1236,
    1236,     0,     0,     0,   809,  1236,     0,     0,     0,  1236,
       0,     0,  1236,     0,     0,  1236,  1236,  1236,  1236,  1236,
    1236,  1236,  1236,  1236,     0,  1236,     0,     0,     0,     0,
       0,   746,  1236,     0,  1236,     0,     0,  1804,     0,     0,
       0,   746,  1805,     0,     0,     0,     0,  2073,   891,     0,
       0,     0,  2074,   892,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1806,  1807,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1808,     0,
       0,     0,     0,     0,     0,  2075,   893,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2076,   894,
     895,     0,     0,     0,     0,     0,     0,     0,     0,   896,
    1809,     0,  2077,   897,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1810,     0,     0,  1811,     0,     0,     0,
       0,   898,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2078,   899,     0,     0,     0,     0,   746,     0,
     746,     0,  1236,  2079,   900,     0,     0,     0,     0,     0,
       0,     0,   901,     0,     0,     0,     0,     0,  1794,     0,
       0,  1795,     0,  2080,   902,  1796,  1797,  1798,  2081,   903,
       0,     0,     0,     0,     0,     0,     0,   746,     0,     0,
       0,     0,  1799,     0,  2694,  1812,  2701,     0,     0,     0,
    1801,     0,   904,     0,     0,     0,  1802,  1794,     0,     0,
    1795,     0,     0,     0,  1796,  1797,  1798,     0,     0,     0,
       0,     0,     0,     0,     0,   812,     0,   905,     0,     0,
    1803,  1799,     0,     0,   680,     0,   680,     0,     0,  1801,
       0,     0,     0,     0,     0,  1802,     0,  2082,   906,     0,
       0,     0,     0,  1236,     0,     0,     0,   888,     0,     0,
       0,     0,     0,   929,     0,   804,     0,   809,   809,  1803,
       0,     0,   804,     0,   855,     0,   809,     0,   809,  2083,
     907,     0,   809,     0,     0,   746,     0,     0,  1813,     0,
       0,  1814,  1815,  1816,     0,  1817,  1818,  1819,  1820,  1821,
    1822,   908,     0,     0,     0,     0,   710,     0,     0,     0,
     206,   206,     0,     0,     0,     0,  2130,     0,     0,     0,
       0,     0,     0,     0,  2818,     0,     0,     0,     0,     0,
       0,  2829,     0,     0,     0,     0,  1804,     0,   909,     0,
     746,  1805,     0,   910,  2084,   911,     0,     0,     0,     0,
    2085,   912,     0,  2086,   913,     0,     0,     0,     0,     0,
     746,     0,  1806,  1807,     0,  2874,  2874,     0,     0,     0,
       0,     0,     0,     0,   812,  1804,     0,  1808,     0,     0,
    1805,     0,  2087,   914,     0,     0,   915,     0,     0,  2088,
     916,   809,     0,     0,     0,     0,  2089,   917,     0,   918,
       0,  1806,  1807,  2090,   919,     0,     0,  1121,     0,  1809,
       0,     0,     0,     0,     0,     0,  1808,     0,  2939,     0,
    2942,  2944,  1810,     0,     0,  1811,     0,     0,  2091,   920,
       0,     0,  1243,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   809,  1809,     0,
       0,  1266,     0,     0,     0,   809,     0,   809,     0,     0,
       0,  1810,     0,   809,  1811,     0,     0,     0,     0,     0,
       0,     0,     0,  1293,     0,  1236,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2130,
       0,     0,  2874,     0,   746,     0,     0,  3030,     0,     0,
     680,     0,     0,     0,  1812,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1794,     0,     0,  1795,     0,     0,
       0,  1796,  1797,  1798,     0,     0,  2939,     0,     0,     0,
       0,     0,     0,     0,     0,   809,  3056,     0,  1799,     0,
       0,     0,     0,  1812,  1417,     0,  1801,     0,     0,     0,
       0,     0,  1802,     0,     0,     0,     0,     0,     0,  1236,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3100,     0,  1803,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   809,
       0,   809,  2874,   809,  2874,     0,     0,  1813,     0,     0,
    1814,  1815,  1816,     0,  1817,  1818,  1819,  1820,  1821,  1822,
       0,     0,     0,     0,  2569,     0,     0,  1236,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1706,     0,     0,     0,     0,     0,  1813,     0,     0,  1814,
    1815,  1816,     0,  1817,  1818,  1819,  1820,  1821,  1822,     0,
    1541,     0,     0,  3572,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   746,     0,
       0,     0,     0,     0,  1571,  1574,  1575,     0,   804,     0,
       0,  3072,  1804,     0,   804,     0,     0,  1805,     0,     0,
       0,     0,     0,     0,     0,   809,     0,     0,     0,     0,
    1362,     0,  1236,     0,     0,     0,     0,  1236,  1806,  1807,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1808,     0,     0,     0,     0,     0,     0,
    1236,  1236,  1236,  1363,  3072,  1236,     0,     0,     0,     0,
       0,     0,     0,  1236,  1236,  1236,  1236,     0,     0,     0,
       0,     0,     0,  1362,     0,  1809,  1236,     0,     0,  1236,
       0,  1236,     0,     0,     0,     0,     0,     0,  1810,     0,
       0,  1811,  1236,  1236,     0,     0,  1236,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1363,     0,   855,     0,
    1236,  1365,  1236,     0,  1236,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1243,     0,  1236,     0,     0,     0,   746,     0,
       0,     0,     0,     0,  1366,  3309,     0,  1236,  1236,  1236,
       0,     0,     0,     0,  1794,     0,     0,  1795,  1243,     0,
       0,  1796,  1797,  1798,  1365,  1236,     0,     0,     0,     0,
    1812,     0,     0,     0,  3073,     0,     0,  1236,  1799,  1367,
       0,     0,  1236,     0,     0,     0,  1801,  1794,  1236,     0,
    1795,  3072,  1802,     0,  1796,  1797,  1798,  1366,  3309,     0,
       0,  3348,     0,     0,  3351,     0,  2701,     0,     0,     0,
    1362,  1799,  1368,     0,     0,     0,  1803,     0,     0,  1801,
       0,     0,     0,     0,     0,  1802,     0,  3073,     0,     0,
       0,     0,  1367,     0,     0,     0,     0,     0,     0,     0,
       0,  1370,     0,  1363,     0,     0,     0,     0,  1236,  1803,
    2874,     0,     0,     0,     0,  1706,     0,     0,     0,     0,
       0,     0,     0,  1813,     0,  1368,  1814,  1815,  1816,     0,
    1817,  1818,  1819,  1820,  1821,  1822,     0,     0,     0,    34,
    3737,     0,   809,  1372,   809,   809,   809,     0,     0,     0,
    1373,     0,     0,  1865,  1370,     0,     0,  1374,     0,     0,
       0,  1365,     0,     0,     0,  2115,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1376,     0,     0,
       0,     0,  1804,     0,     0,  1377,     0,  1805,     0,     0,
       0,     0,    34,  3231,  1366,     0,  3074,     0,  3232,     0,
       0,     0,  2002,  1373,     0,  3075,     0,     0,  1806,  1807,
    1374,     0,     0,     0,     0,  1804,     0,     0,  2115,     0,
    1805,     0,     0,  1808,  3073,     0,     0,     0,     0,  1367,
    1376,     0,     0,     0,     0,     0,     0,     0,  1377,  1378,
       0,  1806,  1807,  3076,  3667,     0,     0,     0,     0,     0,
       0,     0,     0,   746,     0,  1809,  1808,     0,  3075,     0,
       0,     0,  1368,     0,     0,     0,     0,     0,  1810,     0,
       0,  1811,     0,     0,     0,     0,  2124,     0,     0,     0,
       0,     0,     0,     0,     0,  2147,     0,     0,  1809,     0,
       0,  1370,  1378,     0,     0,     0,  3076,     0,     0,     0,
    1794,  1810,     0,  1795,  1811,     0,     0,  1796,  1797,  1798,
       0,     0,  2182,     0,     0,     0,     0,     0,     0,     0,
    2188,     0,     0,  2191,  1799,     0,     0,     0,     0,    34,
       0,     0,  1801,  1372,     0,     0,   809,     0,  1802,     0,
    1373,     0,     0,  2874,  2874,     0,     0,  1374,     0,     0,
    1812,     0,     0,     0,     0,  2115,     0,     0,     0,  2226,
       0,     0,  1803,     0,     0,     0,     0,  1376,     0,     0,
       0,     0,     0,  2241,     0,  1377,     0,     0,     0,     0,
     746,   746,     0,  1812,     0,     0,  2253,     0,     0,     0,
       0,     0,     0,     0,     0,  3075,   746,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1706,   746,     0,     0,     0,     0,     0,     0,     0,
    1706,   746,   746,     0,     0,     0,     0,     0,     0,  1378,
       0,     0,     0,  3076,     0,     0,  2304,     0,   746,     0,
       0,     0,     0,  1813,     0,     0,  1814,  1815,  1816,     0,
    1817,  1818,  1819,  1820,  1821,  1822,     0,  2338,     0,     0,
    3788,     0,     0,     0,  2350,     0,     0,     0,  1804,     0,
       0,     0,     0,  1805,     0,     0,  1813,     0,     0,  1814,
    1815,  1816,     0,  1817,  1818,  1819,  1820,  1821,  1822,     0,
       0,   809,     0,   809,  1806,  1807,     0,   809,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1808,
       0,     0,     0,   804,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   746,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   746,
       0,  1809,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   809,     0,     0,  1810,     0,     0,  1811,  1236,     0,
       0,     0,     0,     0,     0,     0,  2428,  1236,     0,     0,
       0,     0,     0,  1236,     0,  1236,     0,     0,  1236,     0,
       0,     0,     0,  1236,  1236,  1236,  1236,     0,     0,  1236,
    1236,  1236,  1236,  1236,  1236,  1236,  1236,  1236,  1236,     0,
       0,     0,  1236,  1236,  1243,  1243,     0,     0,     0,     0,
       0,     0,  1236,     0,     0,     0,  1236,     0,     0,     0,
    1236,  2476,     0,     0,     0,     0,     0,     0,  1236,     0,
       0,  1236,     0,  1236,     0,     0,  1812,  1389,     0,     0,
       0,     0,  1236,  1390,     0,  1236,  1236,     0,     0,     0,
    1236,  1236,     0,     0,     0,  3812,     0,  1236,     0,     0,
       0,     0,     0,     0,   746,   746,   746,   804,  1436,  3309,
    3832,     0,     0,     0,  3832,  3846,     0,     0,     0,     0,
       0,  1236,     0,  1391,     0,     0,     0,  1236,  1236,  1236,
       0,     0,     0,     0,     0,     0,     0,     0,  1389,     0,
       0,     0,     0,     0,  1390,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1236,     0,  1437,     0,  2632,     0,
       0,     0,     0,     0,     0,  2701,     0,  1236,  2647,  1813,
       0,     0,  1814,  1815,  1816,  1393,  1817,  1818,  1819,  1820,
    1821,  1822,  1394,     0,  1391,  1395,  3871,     0,  3904,  1706,
    1706,     0,  2252,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1396,   809,   809,   809,   809,     0,     0,     0,     0,     0,
       0,     0,     0,   593,     0,     0,     0,     0,     0,   639,
       0,     0,     0,     0,     0,     0,  1393,     0,  1438,   690,
    2130,  1397,     0,  1394,     0,     0,  1395,     0,     0,     0,
       0,     0,     0,     0,  3950,     0,     0,     0,   758,   758,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1396,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2658,  1439,  2661,     0,  1440,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1441,
       0,  1399,  1397,     0,     0,     0,     0,     0,     0,     0,
       0,  1400,     0,  1794,     0,     0,  1795,     0,     0,  1401,
    1796,  1797,  1798,     0,  1243,     0,     0,     0,  1442,  1402,
       0,     0,     0,  1794,     0,     0,  1795,  1799,     0,     0,
    1796,  1797,  1798,     0,  4028,  1801,     0,     0,     0,     0,
       0,  1802,     0,     0,     0,     0,     0,  1799,     0,     0,
    1398,     0,  1399,     0,  1443,  1801,     0,  1404,  1405,  1444,
       0,  1802,  1400,     0,     0,  1803,     0,     0,     0,     0,
    1401,     0,     0,     0,     0,     0,     0,   746,     0,   809,
    1402,  1236,     0,     0,  1445,  1803,     0,   746,     0,     0,
       0,     0,     0,  4063,     0,     0,     0,   817,  1446,     0,
       0,     0,  2130,     0,     0,   857,     0,     0,   861,   862,
       0,   865,     0,     0,   871,  1460,   873,     0,  1404,  1405,
       0,     0,   746,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2939,     0,     0,     0,     0,     0,     0,     0,
    4097,     0,     0,     0,     0,  1461,     0,  1407,     0,     0,
     746,     0,     0,     0,  2252,     0,     0,     0,  1236,  1236,
       0,     0,     0,     0,     0,     0,     0,  2841,     0,     0,
       0,  1804,     0,     0,     0,     0,  1805,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2868,     0,     0,
       0,  1804,  2874,     0,  2874,     0,  1805,  1806,  1807,     0,
       0,     0,     0,     0,   746,     0,     0,     0,  1407,     0,
       0,     0,  1808,     0,     0,     0,     0,  1806,  1807,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1808,     0,  1236,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1809,  1236,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1810,     0,     0,
    1811,     0,  1389,     0,  1809,     0,     0,     0,  1390,     0,
       0,     0,     0,     0,     0,  1236,     0,  1810,     0,     0,
    1811,     0,     0,     0,     0,  1236,  1236,     0,     0,     0,
       0,     0,  1236,  1236,     0,     0,     0,  1236,     0,     0,
       0,     0,  1236,     0,     0,  1236,  1236,     0,  1391,     0,
    1236,  4193,     0,     0,     0,     0,  1236,   746,   746,   746,
     746,  3026,     0,     0,  3832,  3846,     0,  3832,     0,     0,
    4204,     0,     0,     0,  3309,     0,     0,     0,  3309,  1812,
       0,     0,     0,     0,  4219,  1794,     0,     0,  1795,     0,
    1236,     0,  1796,  1797,  1798,  1236,     0,     0,     0,  1812,
    1393,  1236,     0,     0,     0,     0,     0,  1394,   855,  1799,
    1395,     0,     0,     0,     0,     0,  1236,  1801,     0,  3348,
       0,     0,     0,  1802,  2701,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1396,     0,   680,     0,     0,
    1236,     0,     0,     0,     0,     0,     0,  1803,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2874,  2874,     0,     0,     0,     0,  1397,     0,     0,     0,
       0,     0,  1813,     0,     0,  1814,  1815,  1816,  2130,  1817,
    1818,  1819,  1820,  1821,  1822,     0,     0,  4282,     0,  3898,
       0,     0,  1813,     0,     0,  1814,  1815,  1816,   932,  1817,
    1818,  1819,  1820,  1821,  1822,     0,   940,     0,     0,  4154,
       0,     0,     0,   953,     0,     0,   958,   959,     0,     0,
       0,   961,     0,     0,  1398,     0,  1399,     0,  1236,     0,
       0,     0,   978,     0,     0,  3165,  1400,     0,     0,     0,
       0,     0,     0,     0,  1401,     0,     0,   987,   809,     0,
       0,     0,     0,  1804,  1402,     0,     0,     0,  1805,     0,
       0,     0,  1047,   809,  1051,     0,     0,  1053,     0,  1055,
       0,     0,  1059,     0,     0,     0,     0,     0,     0,  1806,
    1807,     0,     0,     0,     0,     0,     0,     0,     0,  1486,
    1236,     0,  1404,  1405,  1808,     0,     0,     0,     0,     0,
       0,   804,     0,     0,     0,  1389,  2130,     0,     0,     0,
       0,  1390,     0,     0,  1706,     0,     0,     0,     0,  1487,
       0,     0,     0,     0,     0,     0,  1809,     0,     0,     0,
       0,   809,  3056,     0,     0,     0,     0,     0,     0,  1810,
    1122,     0,  1811,     0,     0,     0,     0,     0,     0,     0,
       0,  1391,     0,     0,     0,     0,     0,     0,     0,     0,
     746,     0,  1028,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1407,  1028,     0,  3292,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   758,     0,     0,     0,  1236,
       0,     0,     0,  1393,     0,     0,     0,     0,  1236,  1794,
    1394,     0,  1795,  1395,     0,     0,  1796,  1797,  1798,     0,
       0,  1812,     0,     0,     0,  1236,  1236,     0,     0,  1236,
       0,     0,     0,  1799,     0,     0,     0,     0,  1396,     0,
       0,  1801,     0,   804,  3832,     0,     0,  1802,  3309,     0,
       0,     0,     0,  3309,     0,  1353,  3309,   804,     0,  2939,
       0,  4460,     0,     0,  1236,  1236,     0,     0,     0,  1397,
       0,  1803,     0,     0,     0,     0,     0,     0,     0,     0,
    3904,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3904,   855,   809,   809,   809,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1813,     0,     0,  1814,  1815,  1816,
    1489,  1817,  1818,  1819,  1820,  1821,  1822,  1398,     0,  1399,
       0,  4189,     0,     0,     0,     0,  1502,   804,   855,  1400,
       0,     0,     0,     0,     0,     0,     0,  1401,  1513,     0,
    1514,     0,     0,     0,     0,     0,     0,  1402,  1517,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1523,     0,     0,     0,     0,  1532,     0,  1804,  1536,     0,
     804,     0,  1805,   746,     0,     0,     0,     0,     0,     0,
       0,     0,  2095,  4063,     0,  1404,  1405,     0,     0,   746,
       0,  2874,     0,  1806,  1807,     0,     0,  2130,     0,     0,
       0,     0,     0,  1581,     0,     0,     0,     0,  1808,     0,
    4097,     0,  2096,     0,     0,     0,     0,     0,     0,     0,
       0,   809,   746,  3904,     0,     0,     0,     0,     0,     0,
    3489,     0,     0,     0,     0,     0,     0,     0,     0,  1028,
    1809,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1236,  1810,     0,  1236,  1811,  1236,     0,  1028,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1028,     0,  1407,     0,     0,     0,     0,
       0,  1236,     0,     0,     0,  3309,     0,     0,     0,  4460,
       0,     0,     0,     0,     0,     0,  1236,     0,     0,     0,
       0,     0,     0,     0,     0,  4653,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1236,  1794,     0,     0,  1795,
       0,     0,     0,  1796,  1797,  1798,     0,     0,     0,     0,
     746,     0,     0,     0,  1794,  1812,     0,  1795,  1724,     0,
    1799,  1796,  1797,  1798,     0,     0,     0,     0,  1801,     0,
    1028,     0,     0,  1236,  1802,     0,     0,  3598,  3599,     0,
     809,   809,   809,   809,     0,     0,  1801,     0,     0,     0,
       0,     0,  1802,  3608,     0,     0,     0,     0,  1803,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3625,
       0,     0,     0,     0,     0,     0,  1803,   804,  3634,  3636,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   746,     0,  3654,     0,     0,  1236,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1813,     0,
       0,  1814,  1815,  1816,     0,  1817,  1818,  1819,  1820,  1821,
    1822,     0,     0,     0,     0,  4419,     0,     0,     0,     0,
       0,     0,     0,     0,  1028,     0,     0,     0,     0,     0,
    1236,     0,     0,   804,     0,     0,     0,     0,     0,     0,
       0,     0,  1236,     0,     0,     0,     0,  1236,     0,  1236,
       0,  1236,     0,     0,  1804,     0,     0,     0,  3904,  1805,
       0,     0,     0,     0,   809,     0,   855,     0,     0,     0,
       0,     0,  1804,     0,     0,  1236,     0,  1805,     0,     0,
    1806,  1807,     0,     0,     0,     0,  1243,   758,  1964,     0,
       0,     0,     0,     0,  1794,  1808,     0,  1795, -2417, -2417,
       0,  1796,  1797,  1798,     0,     0,  1706,  1706,     0,     0,
       0,     0,  1794,  1808,     0,  1795,     0,     0,  1799,  1796,
    1797,  1798,     0,     0,     0,     0,  1801,  1809,     0,     0,
       0,     0,  1802,   809,     0,     0,  1799,     0,     0,   804,
    1810,     0,     0,  1811,  1801, -2417,     0,     0,     0,     0,
    1802,     0,     0,     0,     0,     0,  1803,     0,  1810,  2093,
       0,     0,     0,     0,  1850,     0,  1236,  1236,     0,     0,
       0,  2939,     0,     0,  1803,     0,     0,  1236,     0,     0,
    4653,     0,     0,     0,  2701,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   804,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   809,     0,     0,
       0,  3820,  3821,  3822,  1706,     0,     0,     0,     0,     0,
       0,     0,  1812,  2181,     0,     0,     0,     0,  1028,     0,
       0,     0,     0,     0,  1794,     0,  2130,  1795,     0,     0,
    1812,  1796,  1797,  1798,  3904,     0,     0,     0,     0,     0,
     804,   804,  1236,     0,     0,     0,     0,     0,  1799,     0,
       0,     0,  1804,     0,     0,     0,  1801,  1805,     0,     0,
       0,  1236,  1802,     0,     0,     0,     0,     0,   809,     0,
    1804,     0,     0,     0,     0,  1805,     0,     0,  1806,  1807,
       0,     0,     0,  1028,     0,     0,  1803,     0,     0,     0,
       0,     0,     0,  1808,     0,     0,  1806,  1807,     0,     0,
       0,     0,     0,     0,     0,  1813,     0,     0,  1814,  1815,
    1816,  1808,  1817,  1818,  1819,  1820,  1821,  1822,     0,     0,
    1028,     0,  4430,  1813,     0,  1809,  1814,  1815,  1816,  2296,
    1817,  1818,  1819,  1820,  1821,  1822,     0,     0,  1810,     0,
       0,  1811,     0,  1809,  1236,  1236,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1810,     0,   804,  1811,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     804,   804,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1389,     0,     0,     0,     0,     0,  1390,     0,
       0,     0,  1804,     0,     0,     0,     0,  1805,     0,     0,
       0,  1028,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1028,     0,  1806,  1807,
    1812,     0,     0,     0,  1028,     0,     0,  2393,  1391,     0,
       0,     0,     0,  1808,     0,  1028,     0,     0,  1812,     0,
       0,  2407,     0,     0,  2410,     0,  2412,     0,  2413,     0,
       0,     0,     0,     0,  2415,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1809,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1810,     0,
    1393,  1811,  1028,     0,  4048,     0,     0,  1394,     0,     0,
    1395,   190,     0,     0,  4058,  1028,     0,     0,     0,  1964,
       0,     0,     0,  1964,     0,  1964,     0,  1028,  1964,     0,
       0,     0,     0,  1813,     0,  1396,  1814,  1815,  1816,  1028,
    1817,  1818,  1819,  1820,  1821,  1822,     0,     0,     0,  4079,
    4439,  1813,     0,     0,  1814,  1815,  1816,   191,  1817,  1818,
    1819,  1820,  1821,  1822,     0,     0,  1397,     0,  4442,     0,
       0,   192,     0,     0,     0,     0,     0,  2350,     0,     0,
    1812,     0,     0,  1028,     0,     0,  1028,     0,     0,   193,
       0,     0,     0,     0,     0,   194,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   195,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   196,     0,  1398,     0,  1399,     0,     0,     0,
     197,  2428,     0,     0,     0,     0,  1400,     0,     0,     0,
       0,     0,   198,     0,  1401,     0,     0,   199,     0,     0,
       0,     0,     0,   200,  1402,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     201,     0,     0,  1813,     0,     0,  1814,  1815,  1816,     0,
    1817,  1818,  1819,  1820,  1821,  1822,     0,     0,     0,  2811,
    4490,     0,  1404,  1405,     0,   202,  1794,     0,     0,  1795,
       0,     0,     0,  1796,  1797,  1798,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1028,   203,     0,     0,  1406,
    1799,     0,     0,     0,     0,     0,     0,     0,  1801,     0,
    1794,     0,     0,  1795,  1802,     0,     0,  1796,  1797,  1798,
       0,     0,     0,     0,  4196,  4197,  4198,  4199,   204,     0,
       0,     0,     0,     0,  1799,     0,     0,     0,  1803,     0,
       0,     0,  1801,     0,     0,     0,     0,     0,  1802,   205,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   206,
       0,     0,  1407,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1803,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   207,     0,     0,     0,
       0,   208,     0,   209,     0,     0,     0,     0,     0,   210,
       0,     0,   211,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2719,  2720,     0,     0,     0,
    2723,  2724,     0,     0,     0,  2727,     0,     0,     0,     0,
     212,   213,     0,     0,   214,     0,     0,     0,   215,  2738,
       0,     0,     0,     0,  1804,     0,  2747,   216,     0,  1805,
    2750,  2751,   217,     0,  2754,  2755,     0,     0,     0,     0,
       0,  2760,     0,     0,   218,     0,     0,     0,     0,     0,
    1806,  1807,     0,     0,  2777,     0,  2779,   219,  1804,     0,
       0,     0,     0,  1805,     0,  1808,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2803,     0,     0,     0,     0,
    2805,     0,     0,     0,  1806,  1807,     0,     0,  -130,     0,
    1028,     0,     0,  2810,  1028,  1028,     0,  1809,     0,  1808,
       0,     0,  2817,     0,  2819,     0,     1,  2822,  2825,  2827,
    1810,     0,     0,  1811,  2835,  2838,     2,     0,     3,     4,
       0,     0,     0,     0,  2851,     0,     0,     0,     0,  2860,
       0,  1809,     0,     5,  2864,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1810,     0,     0,  1811,     0,     0,
       0,     0,     0,     6,     0,     7,     8,     0,  1028,     0,
    2899,     9,     0,    10,     0,     0,     0,     0,     0,     0,
    1028,  2906,     0,  2908,    11,     0,    12,     0,  2911,     0,
       0,     0,  2912,     0,  2916,  2917,  2918,  2919,     0,  2921,
       0,     0,  1812,    13,     0,     0,    14,     0,     0,     0,
       0,     0,  2946,  2947,  2948,     0,     0,  4401,     0,    15,
    1028,    16,  2956,  2957,     0,    17,  1794,     0,     0,  1795,
       0,    18,     0,  1796,  1797,  1798,  1812,     0,     0,    19,
       0,    20,     0,     0,     0,     0,     0,    21,     0,     0,
    1799,     0,     0,     0,     0,     0,     0,     0,  1801,     0,
       0,     0,    22,     0,  1802,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3001,     0,     0,     0,    23,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1803,     0,
       0,     0,     0,     0,     0,  1813,     0,     0,  1814,  1815,
    1816,     0,  1817,  1818,  1819,  1820,  1821,  1822,     0,     0,
       0,     0,  4521,     0,     0,     0,     0,    24,    25,     0,
       0,     0,     0,    26,     0,     0,     0,     0,     0,  1813,
       0,     0,  1814,  1815,  1816,    27,  1817,  1818,  1819,  1820,
    1821,  1822,     0,     0,  2653,     0,    28,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1389,     0,     0,     0,     0,     0,  1390,     0,     0,
       0,     0,     0,     0,     0,  1028,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    29,     0,     0,     0,
       0,     0,     0,  1794,  1804,     0,  1795,     0,    30,  1805,
    1796,  1797,  1798,    31,    32,     0,    33,  1391,     0,     0,
       0,    34,     0,     0,     0,     0,    35,  1799,     0,    36,
    1806,  1807,     0,     0,    37,  1801,     0,  1964,     0,    38,
      39,  1802,     0,     0,     0,  1808,     0,    40,     0,     0,
    4557,    41,     0,     0,     0,  1028,     0,     0,     0,     0,
       0,    42,     0,     0,     0,  1803,  1243,     0,  3166,  1393,
       0,     0,     0,    43,     0,     0,  1394,  1809,     0,  1395,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1810,     0,    44,  1811,     0,     0,     0,     0,     0,  4604,
       0,     0,    45,     0,  1396,     0,     0,     0,    46,     0,
       0,     0,     0,    47,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    48,     0,     0,     0,
       0,     0,     0,     0,     0,  1397,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    49,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    50,     0,     0,  -130,     0,     0,     0,     0,     0,
       0,  1804,  1812,  1028,     0,     0,  1805,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1028,     0,     0,  1398,     0,  1399,     0,  1806,  1807,     0,
       0,  1028,     0,     0,     0,  1400,     0,  4668,     0,     0,
       0,     0,  1808,  1401,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1402,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1809,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3329,     0,     0,  1810,  2913,     0,
    1811,  1404,  1405,     0,     0,  1813,     0,     0,  1814,  1815,
    1816,     0,  1817,  1818,  1819,  1820,  1821,  1822,     0,     0,
       0,     0,  4559,     0,     0,     0,     0,     0,  2914,     0,
    4736,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   806,     0,     0,     0,     0,  3366,  3367,     0,     0,
     806,   829,     0,     0,     0,     0,     0,     0,   829,     0,
       0,     0,     0,     0,  1964,     0,     0,     0,     0,   829,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1812,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3388,
       0,  1407,     0,  3390,     0,     0,     0,     0,     0,  3393,
       0,     0,     0,     0,  1794,     0,     0,  1795,     0,     0,
       0,  1796,  1797,  1798,     0,  3405,  3407,     0,     0,     0,
    3407,     0,     0,     0,     0,  3418,  3419,  3420,  1799,  3422,
       0,     0,     0,     0,     0,     0,  1801,     0,     0,     0,
       0,  1389,  1802,  1028,     0,     0,  1028,  1390,  1028,     0,
    3439,     0,     0,  1028,     0,     0,     0,     0,     0,     0,
    3445,  3446,  3447,  3448,     0,     0,  1803,     0,     0,     0,
       0,     0,  1813,     0,     0,  1814,  1815,  1816,     0,  1817,
    1818,  1819,  1820,  1821,  1822,     0,     0,  1391,     0,  4804,
       0,     0,     0,     0,     0,     0,     0,  3465,     0,     0,
    3470,  3471,  3472,     0,     0,  1028,     0,     0,     0,     0,
    3485,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1028,     0,  1794,     0,     0,  1795,     0,     0,
       0,  1796,  1797,  1798,     0,     0,     0,     0,     0,  1393,
       0,     0,     0,     0,     0,     0,  1394,  1028,  1799,  1395,
       0,     0,     0,     0,     0,     0,  1801,     0,     0,     0,
       0,     0,  1802,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1804,     0,  1396,     0,     0,  1805,     0,     0,
       0,  3536,     0,     0,     0,     0,  1803,     0,     0,  3540,
       0,     0,     0,     0,     0,     0,     0,     0,  1806,  1807,
       0,     0,     0,     0,     0,  1397,     0,     0,  3552,     0,
       0,     0,     0,  1808,     0,     0,  1028,     0,  1028,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3595,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1809,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1810,     0,
       0,  1811,     0,  1398,     0,  1399,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1400,     0,     0,  3632,  1028,
       0,     0,  3637,  1401,     0,     0,     0,     0,     0,     0,
       0,     0,  1804,  1402,     0,     0,     0,  1805,     0,     0,
       0,     0,     0,     0,  1028,     0,     0,     0,   806,     0,
       0,  3675,     0,     0,     0,     0,     0,     0,  1806,  1807,
     829,     0,     0,     0,     0,   829,     0,     0,  2953,     0,
    1028,  1404,  1405,  1808,     0,     0,   829,  1028,     0,     0,
    1812,  3688,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   829,     0,     0,  3698,     0,   806,  2954,  3700,
       0,     0,     0,  1030,     0,  1809,     0,   806,   829,     0,
    1964,     0,     0,     0,   829,     0,     0,     0,  1810,     0,
       0,  1811,     0,     0,  1030,   829,     0,     0,     0,     0,
       0,     0,     0,   829,     0,     0,  1028,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1028,     0,     0,     0,     0,     0,
       0,  1407,     0,     0,     0,     0,     0,  1028,     0,     0,
       0,     0,     0,  1813,     0,     0,  1814,  1815,  1816,     0,
    1817,  1818,  1819,  1820,  1821,  1822,     0,     0,     0,     0,
    4836,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1812,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   806,   806,     0,     0,     0,     0,   829,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   806,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1028,     0,     0,     0,     0,  1794,     0,     0,  1795,     0,
       0,     0,  1796,  1797,  1798,     0,     0,     0,     0,     0,
       0,  1028,     0,  1813,     0,     0,  1814,  1815,  1816,  1799,
    1817,  1818,  1819,  1820,  1821,  1822,     0,  1801,     0,     0,
    4955,     0,     0,  1802,     0,     0,  1028,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1803,     0,     0,
       0,     0,     0,     0,  1794,     0,     0,  1795,     0,     0,
    1028,  1796,  1797,  1798,  3915,     0,  3916,     0,     0,     0,
       0,     0,     0,     0,  3918,     0,     0,     0,  1799,     0,
       0,     0,  2667,     0,     0,     0,  1801,     0,     0,     0,
       0,  3928,  1802,   806,     0,     0,     0,     0,     0,     0,
    1030,     0,     0,  1794,   806,     0,  1795,  3936,     0,     0,
    1796,  1797,  1798,     0,     0,     0,  1803,     0,     0,     0,
    1030,  3949,     0,     0,     0,     0,     0,  1799,     0,     0,
       0,     0,     0,     0,  1030,  1801,     0,     0,     0,  3953,
       0,  1802,     0,     0,     0,     0,     0,     0,     0,  3962,
       0,     0,  1028,  1804,     0,     0,     0,     0,  1805,     0,
       0,     0,     0,     0,  2668,  1803,     0,     0,     0,     0,
    3986,     0,     0,   806,     0,     0,     0,     0,     0,  1806,
    1807,  3994,  3995,  3996,     0,     0,  3999,  4000,  4001,  4002,
    4003,  4004,     0,     0,  1808,     0,  4011,  4012,     0,  4014,
    4015,  4016,  4017,  4018,  4019,     0,  4021,     0,     0,     0,
       0,  1030,     0,     0,     0,  4029,     0,  4031,  4032,     0,
       0,     0,  1804,     0,     0,     0,  1809,  1805,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1810,
    3407,     0,  1811,     0,     0,     0,   829,     0,  1806,  1807,
       0,     0,  1028,     0,     0,     0,     0,     0,     0,  4051,
       0,     0,     0,  1808,     0,     0,   829,     0,     0,     0,
     806,  1804,     0,     0,     0,     0,  1805,     0,   829,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1809,     0,  1806,  1807,     0,
       0,     0,     0,     0,     0,     0,   829,     0,  1810,     0,
       0,  1811,  1808,     0,     0,  1030,     0,   829,     0,     0,
       0,  1812,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   829,     0,     0,   829,     0,     0,     0,     0,
       0,     0,     0,     0,  1809,     0,  1389,   806,     0,     0,
       0,     0,  1390,     0,     0,     0,  3407,  1810,     0,     0,
    1811,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   806,     0,     0,     0,
       0,     0,  3780,     0,  1964,  1964,  1964,     0,     0,     0,
    1812,     0,  1391,     0,     0,     0,  4139,  1028,     0,     0,
       0,     0,     0,     0,   806,   806,   806,     0,   806,     0,
       0,     0,     0,     0,  1813,     0,     0,  1814,  1815,  1816,
       0,  1817,  1818,  1819,  1820,  1821,  1822,     0,   806,     0,
       0,  4973,     0,     0,     0,     0,     0,     0,     0,  1812,
       0,     0,     0,     0,  1393,  2669,  1028,     0,     0,     0,
       0,  1394,   829,     0,  1395,  3781,     0,     0,     0,     0,
     829,   829,     0,     0,     0,     0,     0,     0,     0,   806,
    1949,     0,     0,     0,     0,     0,     0,     0,     0,  1396,
       0,     0,     0,  1813,     0,     0,  1814,  1815,  1816,     0,
    1817,  1818,  1819,  1820,  1821,  1822,     0,     0,     0,   806,
       0,     0,     0,   806,   806,     0,     0,     0,     0,     0,
    1397,     0,     0,     0,     0,     0,     0,     0,     0,  1030,
       0,     0,     0,     0,     0,  1949,     0,     0,     0,     0,
       0,     0,  1813,     0,     0,  1814,  1815,  1816,     0,  1817,
    1818,  1819,  1820,  1821,  1822,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1398,     0,
    1399,     0,     0,     0,     0,     0,     0,  1028,     0,     0,
    1400,     0,     0,     0,  1030,     0,     0,  1028,  1401,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1402,     0,
       0,     0,     0,     0,     0,  4269,     0,     0,     0,  4270,
    4271,  4272,  4273,     0,     0,  4275,     0,     0,     0,     0,
       0,  1030,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3415,     0,     0,  1404,  1405,     0,  4289,
    4290,  4291,     0,  4292,     0,  4294,  4295,     0,     0,  1389,
       0,     0,     0,     0,     0,  1390,     0,  4304,  4305,     0,
       0,     0,     0,  3416,     0,     0,     0,  1794,     0,     0,
    1795,     0,     0,     0,  1796,  1797,  1798,     0,  4313,     0,
       0,   829,     0,     0,     0,  1964,  1964,     0,  1964,     0,
       0,  1799,     0,     0,     0,  1391,     0,     0,     0,  1801,
    4321,     0,  1030,     0,     0,  1802,     0,  1028,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1030,     0,     0,
       0,     0,     0,     0,     0,  1030,  1407,     0,     0,  1803,
       0,  1949,     0,     0,     0,     0,  1030,     0,  1028,     0,
       0,     0,     0,     0,     0,     0,     0,  1393,     0,     0,
       0,     0,   829,     0,  1394,     0,   829,  1395,     0,  1028,
    4367,     0,     0,     0,     0,     0,     0,     0,   829,     0,
       0,     0,     0,     0,  1028,     0,     0,     0,     0,     0,
       0,  4386,  1396,  1030,     0,     0,     0,     0,     0,     0,
     806,     0,     0,     0,     0,     0,  1030,     0,     0,     0,
       0,     0,   806,     0,     0,     0,     0,     0,  1030,     0,
       0,  4410,  4916,  1397,     0,     0,     0,  1028,     0,     0,
    1030,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1804,     0,     0,     0,   806,
    1805,   829,   829,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   829,     0,     0,     0,     0,     0,
       0,  1806,  1807,     0,  1030,     0,     0,  1030,     0,   829,
     829,  1398,     0,  1399,     0,     0,  1808,     0,     0,     0,
       0,   829,     0,  1400,     0,  1964,     0,     0,     0,     0,
       0,  1401,     0,     0,     0,     0,     0,     0,     0,     0,
    1964,  1402,     0,     0,     0,     0,  1028,     0,  1809,     0,
       0,     0,     0,   806,     0,     0,     0,     0,     0,     0,
       0,  1810,     0,     0,  1811,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3466,     0,     0,  1404,
    1405,     0,     0,     0,  4917,     0,     0,   806,     0,   806,
       0,     0,  1028,     0,   806,   806,     0,     0,     0,     0,
       0,   806,   806,   806,     0,     0,  3467,   806,  4511,   806,
     806,   806,   806,   806,   806,     0,   806,     0,   806,   806,
       0,     0,   806,     0,     0,     0,     0,     0,     0,  4520,
       0,     0,     0,     0,  4525,  4526,  1030,   806,   806,   806,
     806,  1949,     0,  1812,     0,   806,     0,     0,     0,   806,
       0,     0,   806,     0,     0,   806,   806,   806,   806,   806,
     806,   806,   806,   806,     0,   806,     0,     0,     0,  1407,
       0,     0,   806,     0,   806,     0,     0,     0,     0,  4578,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1794,
       0,     0,  1795,     0,     0,     0,  1796,  1797,  1798,     0,
       0,     0,     0,     0,     0,     0,  1028,     0,     0,     0,
       0,     0,     0,  1799,     0,  3407,  3190,     0,     0,     0,
       0,  1801,  4619,     0,     0,     0,  1813,  1802,     0,  1814,
    1815,  1816,     0,  1817,  1818,  1819,  1820,  1821,  1822,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1803,     0,     0,     0,  1794,     0,  1964,  1795,     0,
       0,     0,  1796,  1797,  1798,     0,     0,     0,  1964,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1799,
       0,     0,     0,     0,     0,     0,     0,  1801,     0,     0,
    4655,     0,   806,  1802,     0,     0,     0,     0,     0,  1794,
       0,     0,  1795,     0,     0,     0,  1796,  1797,  1798,     0,
       0,     0,     0,  4671,  1028,     0,     0,  1803,     0,     0,
       0,     0,  4678,  1799,     0,     0,  3236,     0,     0,     0,
       0,  1801,     0,     0,     0,     0,     0,  1802,     0,     0,
       0,  1030,  1028,  1964,     0,  1030,  1030,     0,     0,     0,
       0,     0,     0,     0,     0,   829,     0,  1804,     0,  1949,
     829,  1803,  1805,     0,   829,     0,     0,     0,     0,     0,
       0,     0,   829,     0,     0,     0,     0,     0,     0,     0,
    1028,     0,     0,  1806,  1807,     0,     0,     0,     0,     0,
     829,     0,     0,   806,     0,     0,     0,     0,  1808,     0,
       0,     0,     0,     0,     0,   806,     0,     0,     0,  1030,
       0,     0,   806,     0,     0,     0,     0,     0,     0,     0,
       0,  1030,     0,  1804,     0,  1389,  3407,     0,  1805,     0,
    1809,  1390,     0,  1028,   829,     0,     0,  1028,  1028,     0,
       0,     0,     0,  1810,     0,     0,  1811,     0,  1964,  1806,
    1807,     0,   829,   829,     0,     0,  1436,     0,     0,     0,
       0,  1030,     0,     0,  1808,     0,     0,  1804,     0,     0,
       0,  1391,  1805,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4793,  1949,   829,     0,     0,  1949,     0,     0,
       0,     0,     0,  1806,  1807,     0,  1809,  4805,     0,     0,
       0,     0,     0,     0,  1437,     0,     0,     0,  1808,  1810,
       0,     0,  1811,     0,     0,     0,   829,     0,     0,     0,
     829,     0,     0,  1393,     0,  1812,     0,     0,  3204,  1028,
    1394,     0,     0,  1395,  4827,     0,     0,     0,   829,     0,
    1809,     0,     0,     0,     0,     0,     0,     0,     0,   829,
       0,     0,     0,  1810,     0,     0,  1811,     0,  1396,     0,
       0,     0,   829,     0,     0,     0,     0,     0,     0,     0,
     829,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1438,     0,     0,  1397,
       0,  1812,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4875,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   806,  1030,     0,  1813,     0,
       0,  1814,  1815,  1816,  1949,  1817,  1818,  1819,  1820,  1821,
    1822,     0,     0,     0,  1439,  1812,     0,  1440,     0,     0,
       0,  4893,     0,     0,     0,     0,     0,  1441,     0,  1399,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1400,
       0,     0,     0,     0,     0,     0,     0,  1401,     0,     0,
       0,     0,     0,     0,     0,     0,  1442,  1402,     0,     0,
       0,     0,     0,     0,  1813,     0,  1030,  1814,  1815,  1816,
     829,  1817,  1818,  1819,  1820,  1821,  1822,     0,     0,   806,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2900,     0,     0,  1404,  1405,  1444,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1813,     0,
       0,  1814,  1815,  1816,     0,  1817,  1818,  1819,  1820,  1821,
    1822,     0,  2901,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   829,     0,     0,     0,  1446,   806,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   829,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1030,  1407,   829,     0,     0,     0,
       0,     0,     0,     0,   829,     0,     0,     0,   806,   830,
       0,  1030,     0,     0,   806,     0,   830,     0,     0,     0,
       0,     0,  1030,     0,     0,     0,     0,   830,     0,     0,
       0,     0,   806,     0,     0,     0,     0,   806,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     806,   806,   806,     0,     0,   806,     0,     0,     0,     0,
       0,     0,     0,   806,   806,   806,   806,     0,     0,     0,
       0,  1949,     0,     0,     0,     0,   806,  1949,     0,   806,
       0,   806,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   806,   806,     0,     0,   806,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     806,     0,   806,     0,   806,     0,     0,     0,     0,     0,
       0,     0,  1794,     0,     0,  1795,     0,     0,     0,  1796,
    1797,  1798,     0,     0,   806,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   806,  1799,   806,   806,   806,
       0,     0,     0,     0,  1801,     0,     0,     0,     0,     0,
    1802,     0,   829,     0,     0,   806,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   806,     0,     0,
       0,     0,   806,     0,  1803,     0,     0,     0,   806,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   806,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1030,     0,     0,  1030,     0,  1030,
       0,     0,     0,     0,  1030,     0,   829,     0,     0,  1794,
       0,     0,  1795,     0,     0,     0,  1796,  1797,  1798,     0,
       0,     0,   829,   829,     0,     0,     0,     0,   806,     0,
       0,     0,     0,  1799,     0,     0,  3247,     0,     0,     0,
       0,  1801,     0,     0,     0,     0,     0,  1802,     0,   829,
       0,     0,   829,  3241,     0,     0,  1030,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1804,  1803,     0,  1030,     0,  1805,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1806,  1807,  1030,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1808,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1949,  1949,  1949,     0,     0,     0,     0,
       0,     0,     0,  1809,     0,     0,     0,     0,   830,     0,
       0,     0,     0,   830,     0,     0,  1810,   829,     0,  1811,
       0,     0,     0,     0,   830,     0,     0,  1030,     0,  1030,
     829,     0,  1949,     0,     0,   829,     0,  1804,     0,     0,
     830,     0,  1805,     0,     0,   829,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   830,     0,     0,     0,
       0,     0,   830,  1806,  1807,     0,     0,     0,     0,     0,
       0,     0,     0,   830,     0,     0,     0,     0,  1808,     0,
       0,   830,     0,     0,     0,     0,     0,     0,     0,     0,
    1030,     0,     0,     0,     0,     0,     0,     0,  1812,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   829,
    1809,     0,     0,     0,     0,  1030,     0,     0,     0,     0,
       0,     0,     0,  1810,     0,     0,  1811,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1030,     0,     0,     0,     0,     0,  1949,  1030,     0,
       0,     0,     0,     0,   829,     0,   829,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   830,     0,   829,     0,
     829,     0,     0,     0,     0,   605,     0,     0,     0,     0,
     606,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1813,   607,     0,  1814,  1815,  1816,     0,  1817,  1818,
    1819,  1820,  1821,  1822,     0,  1812,     0,  1030,     0,     0,
       0,     0,     0,   608,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   829,  1030,   609,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1030,     0,
     610,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   611,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     612,   829,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   613,     0,   806,     0,     0,   829,     0,  1813,   614,
       0,  1814,  1815,  1816,     0,  1817,  1818,  1819,  1820,  1821,
    1822,   615,     0,     0,     0,     0,   616,     0,   829,     0,
       0,   829,   617,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   806,   618,
       0,  1030,     0,     0,     0,     0,     0,   806,     0,     0,
       0,     0,     0,   806,     0,   806,     0,     0,   806,     0,
       0,     0,  1030,   806,   806,   806,   806,     0,     0,   806,
     806,   806,   806,   806,   806,   806,   806,   806,   806,     0,
       0,     0,   806,   806,     0,   619,     0,  1030,     0,     0,
       0,     0,   806,     0,     0,     0,   806,     0,  1949,     0,
     806,     0,     0,     0,     0,     0,     0,     0,   806,     0,
       0,   806,     0,   806,     0,     0,     0,   620,     0,     0,
       0,  1030,   806,     0,     0,   806,   806,     0,   621,     0,
     806,   806,     0,     0,     0,     0,     0,   806,   622,     0,
       0,     0,     0,     0,     0,     0,     0,   806,   206,   806,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   806,     0,     0,     0,     0,     0,   806,   806,   806,
       0,     0,     0,     0,     0,   623,     0,     0,     0,     0,
     624,     0,   625,     0,   830,     0,     0,     0,   626,     0,
       0,   627,     0,     0,   806,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   830,     0,     0,   806,     0,     0,
       0,     0,     0,  1030,     0,     0,   830,     0,     0,     0,
     628,     0,     0,   629,     0,     0,     0,   630,   806,     0,
       0,     0,     0,     0,   631,     0,   632,     0,     0,  1794,
       0,   633,  1795,     0,   830,     0,  1796,  1797,  1798,     0,
       0,     0,     0,   634,     0,   830,     0,     0,     0,     0,
       0,   829,     0,  1799,     0,     0,   635,     0,     0,     0,
     830,  1801,     0,   830,     0,     0,     0,  1802,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1794,     0,     0,  1795,     0,     0,     0,  1796,  1797,
    1798,  1803,     0,     0,     0,     0,     0,  1949,     0,     0,
       0,     0,  1949,  1030,  1949,  1799,     0,     0,  3787,     0,
       0,     0,     0,  1801,     0,     0,     0,     0,     0,  1802,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1803,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   829,     0,     0,   829,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     830,     0,     0,     0,     0,     0,     0,     0,   830,   830,
       0,     0,     0,     0,     0,     0,     0,  1804,  1950,     0,
       0,     0,  1805,  1794,     0,     0,  1795,     0,     0,     0,
    1796,  1797,  1798,     0,     0,     0,     0,     0,     0,     0,
       0,   806,     0,  1806,  1807,     0,     0,  1799,     0,     0,
       0,     0,     0,     0,     0,  1801,     0,     0,  1808,     0,
       0,  1802,     0,     0,   829,   829,     0,     0,  1030,  1804,
       0,     0,     0,  1950,  1805,     0,     0,   829,     0,   829,
       0,     0,     0,     0,     0,  1803,     0,     0,     0,     0,
    1809,     0,     0,     0,     0,  1806,  1807,     0,     0,     0,
       0,     0,     0,  1810,     0,     0,  1811,     0,     0,     0,
    1808,     0,     0,     0,     0,     0,   831,  1030,   806,   806,
       0,     0,     0,   831,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   831,     0,     0,     0,     0,     0,
       0,     0,  1809,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1810,     0,     0,  1811,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   829,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1812,     0,     0,     0,     0,
       0,  1804,     0,     0,   806,     0,  1805,     0,     0,     0,
       0,     0,     0,     0,     0,   806,     0,     0,     0,     0,
       0,     0,     0,     0,  3733,     0,     0,  1806,  1807,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   830,
       0,     0,  1808,     0,     0,   806,     0,  1812,     0,     0,
       0,     0,     0,     0,     0,   806,   806,     0,  1030,     0,
       0,     0,   806,   806,     0,     0,     0,   806,  1030,     0,
       0,     0,   806,     0,  1809,   806,   806,     0,     0,     0,
     806,     0,     0,     0,     0,     0,   806,  1810,  1813,  1950,
    1811,  1814,  1815,  1816,     0,  1817,  1818,  1819,  1820,  1821,
    1822,     0,     0,     0,   806,     0,     0,     0,   806,     0,
     830,     0,     0,     0,   830,     0,     0,     0,     0,     0,
     806,     0,     0,     0,     0,   806,   830,     0,     0,     0,
       0,   806,     0,     0,     0,     0,     0,     0,     0,     0,
    1813,     0,     0,  1814,  1815,  1816,   806,  1817,  1818,  1819,
    1820,  1821,  1822,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1812,
     806,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1030,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   556,   830,
     830,     0,     0,   557,     0,   829,     0,     0,     0,     0,
    1949,     0,   830,     0,     0,   558,     0,     0,     0,  1030,
       0,     0,     0,     0,     0,     0,     0,   830,   830,     0,
       0,     0,     0,     0,     0,   829,   559,     0,     0,   830,
    1030,     0,     0,     0,     0,     0,     0,   829,     0,   560,
       0,     0,     0,     0,  1949,  1030,     0,     0,   806,   561,
       0,     0,  1813,  -785,     0,  1814,  1815,  1816,   829,  1817,
    1818,  1819,  1820,  1821,  1822,     0,     0,     0,     0,     0,
       0,   562,     0,     0,     0,     0,     0,   563,     0,     0,
       0,     0,     0,     0,     0,   831,     0,     0,  1030,     0,
     831,     0,     0,   564,     0,     0,     0,     0,     0,     0,
       0,   831,     0,     0,   565,     0,     0,     0,     0,     0,
     806,     0,   566,     0,     0,     0,     0,   831,     0,     0,
       0,   806,     0,     0,   567,     0,     0,     0,     0,     0,
       0,   568,     0,   831,     0,   569,     0,     0,     0,   831,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1950,
     831,     0,  -990,     0,     0,     0,     0,     0,   831,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1030,     0,  1030,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   570,
       0,     0,     0,     0,     0,     0,     0,     0,  -524,     0,
       0,     0,     0,   829,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   806,
       0,     0,     0,  1030,     0,     0,     0,     0,   806,     0,
     571,     0,     0,   572,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   831,     0,   806,   806,     0,     0,   806,
       0,   573,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   806,     0,     0,     0,     0,   806,     0,
    -418,     0,     0,   806,     0,     0,   806,   806,     0,     0,
       0,     0,     0,     0,   806,   806,     0,     0,   574,     0,
       0,     0,     0,     0,     0,   575,     0,     0,     0,     0,
     806,  -418,     0,     0,   576,     0,     0,   829,     0,   829,
       0,     0,     0,   806,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  -418,     0,     0,   577,   578,     0,   579,
     580,     0,     0,     0,     0,     0,     0,  1030,   829,   581,
       0,     0,     0,     0,   582,     0,     0,   806,     0,     0,
     583,     0,     0,   584,     0,     0,   585,     0,     0,     0,
       0,     0,     0,   830,     0,     0,     0,  1950,   830,  -418,
       0,     0,   830,     0,     0,     0,     0,     0,     0,     0,
     830,     0,     0,     0,  1949,     0,     0,     0,     0,     0,
     806,     0,     0,     0,     0,     0,     0,     0,   830,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   830,   806,     0,  1030,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     830,   830,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   806,  1030,     0,   806,     0,   806,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1950,   830,     0,     0,  1950,     0,     0,     0,     0,
       0,   806,     0,     0,     0,   806,     0,     0,     0,     0,
       0,  1030,     0,     0,     0,     0,   806,     0,     0,     0,
       0,     0,     0,     0,   830,     0,     0,     0,   830,     0,
       0,     0,     0,     0,     0,   806,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   830,     0,     0,     0,
       0,   831,     0,     0,     0,     0,     0,   830,  1949,     0,
       0,     0,     0,     0,  1030,     0,     0,     0,  1030,  1030,
     830,   831,     0,   806,     0,     0,     0,     0,   830,     0,
       0,     0,     0,   831,     0,     0,     0,     0,     0,   829,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   831,     0,     0,     0,     0,     0,   806,     0,     0,
       0,     0,   831,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1950,     0,     0,     0,     0,   831,   806,     0,
     831,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1030,
    1030,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     806,     0,     0,   806,     0,     0,     0,     0,     0,     0,
       0,     0,   806,     0,     0,     0,     0,   806,   830,   806,
       0,   806,     0,     0,     0,     0,     0,     0,   806,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   806,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1949,     0,   829,     0,
       0,     0,     0,     0,     0,     0,     0,   831,     0,     0,
     830,     0,     0,     0,     0,   831,   831,     0,     0,     0,
       0,     0,     0,     0,     0,  1951,     0,     0,     0,     0,
       0,     0,     0,  1219,  1219,     0,     0,     0,     0,   806,
       0,     0,     0,     0,     0,     0,   830,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   830,  1283,   806,   806,     0,     0,
       0,     0,   830,     0,     0,     0,     0,   806,     0,     0,
    1951,     0,     0,     0,     0,   829,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   806,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   806,     0,     0,     0,     0,  1950,
     806,   806,   806,     0,     0,  1950,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   806,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   829,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1949,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   831,     0,     0,     0,
     830,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   806,   806,     0,     0,     0,     0,
    1949,     0,     0,     0,     0,     0,     0,     0,   806,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1949,
     806,   806,     0,     0,     0,     0,  1951,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   830,     0,     0,   831,     0,     0,
       0,   831,     0,     0,     0,     0,     0,     0,     0,     0,
     830,   830,     0,   831,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   830,     0,     0,
     830,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   831,   831,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   831,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   831,   831,     0,     0,     0,     0,
       0,  1950,  1950,  1950,     0,     0,   831,     0,     0,     0,
    1029,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   830,     0,     0,  1751,     0,
       0,  1029,     0,     0,     0,     0,     0,     0,   830,     0,
    1950,     0,     0,   830,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   830,     0,     0,     0,  1765,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1783,  1784,  1785,     0,  1787,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1829,
       0,     0,     0,     0,     0,     0,     0,   830,     0,     0,
       0,     0,     0,     0,     0,     0,  1951,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1866,     0,     0,     0,     0,  1950,     0,     0,     0,     0,
       0,     0,   830,     0,   830,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   830,     0,   830,     0,
    1971,     0,     0,     0,  1983,  1986,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   830,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   830,
       0,     0,     0,     0,     0,     0,     0,  1029,     0,     0,
       0,     0,     0,     0,   830,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1029,     0,     0,
       0,     0,     0,     0,     0,     0,   830,     0,     0,   830,
    1019,  1029,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     831,  1019,     0,     0,  1951,   831,     0,     0,     0,   831,
       0,     0,     0,     0,     0,     0,     0,   831,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   831,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1950,     0,  1029,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   831,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   831,   831,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1951,   831,
       0,     0,  1951,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   831,  1029,     0,     0,   831,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   831,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   831,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   831,     0,     0,
       0,     0,     0,     0,     0,   831,     0,     0,     0,   830,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1950,     0,  1019,     0,  1951,
    1950,     0,  1950,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2514,     0,  1019,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2534,     0,
    2536,  1019,     0,  2548,  2551,  2556,     0,     0,     0,     0,
    2562,     0,     0,  2567,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   830,     0,     0,   830,  2574,  2575,
    2576,  2577,     0,     0,     0,   831,  2584,     0,     0,     0,
    2596,     0,     0,  2598,     0,     0,  2605,  2606,  2607,  2608,
    2609,  2610,  2611,  2612,  2613,     0,  2614,     0,     0,     0,
       0,     0,     0,  1219,     0,  2642,  2020,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1019,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   831,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   830,   830,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   830,     0,   830,     0,     0,
       0,  2020,     0,   831,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   831,     0,     0,     0,     0,     0,     0,     0,   831,
       0,     0,     0,     0,     0,  1021,     0,     0,  1029,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1019,     0,     0,     0,  1021,     0,     0,     0,
       0,     0,     0,  1283,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   830,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1951,     0,     0,     0,
       0,     0,  1951,     0,     0,     0,     0,     0,     0,  1029,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1029,     0,     0,     0,     0,     0,
       0,     0,  2020,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1029,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2752,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   831,     0,     0,
    1029,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1029,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1029,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1029,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1019,     0,     0,     0,
       0,   831,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   831,   831,     0,
       0,  1029,     0,     0,  1029,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   831,     0,     0,   831,     0,     0,
       0,     0,     0,   830,     0,     0,     0,     0,  1950,     0,
       0,  1019,  1021,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1021,   830,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1022,     0,   830,  1021,     0,  1019,     0,
       0,     0,  1950,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1022,     0,   830,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2993,     0,  1951,  1951,
    1951,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   831,  1029,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   831,     0,  1951,     0,     0,
     831,     0,     0,  1021,     0,     0,     0,     0,     0,  1019,
     831,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2645,     0,     0,  1019,     0,     0,     0,     0,     0,
       0,     0,  1019,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1019,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   831,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1019,   830,     0,     0,     0,     0,     0,     0,  3133,     0,
       0,     0,     0,  1019,     0,     0,     0,  1021,     0,     0,
       0,     0,  1951,     0,     0,  1019,     0,     0,     0,   831,
       0,   831,     0,     0,     0,     0,     0,  1019,     0,     0,
       0,     0,     0,   831,     0,   831,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1019,     0,     0,  1019,     0,     0,     0,     0,     0,
       0,     0,     0,  3186,     0,     0,     0,     0,  3192,   831,
       0,     0,     0,     0,     0,   830,     0,   830,  2704,     0,
       0,     0,  2020,  2710,     0,     0,     0,     0,     0,     0,
    1022,     0,     0,  1787,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2556,     0,  2556,  2556,     0,     0,
    1022,     0,     0,     0,     0,     0,   830,  3250,     0,     0,
    3253,     0,  3255,     0,  1022,     0,   831,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   831,     0,     0,     0,     0,  1029,     0,     0,     0,
       0,  3273,     0,  3276,     0,  3278,     0,     0,  1029,     0,
       0,     0,  1950,   831,     0,     0,   831,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1019,     0,     0,     0,     0,  2642,  2642,
    2642,  1021,     0,     0,     0,     0,     0,     0,  1029,     0,
       0,  1022,     0,     0,     0,     0,  3326,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1971,     0,
       0,     0,     0,  3337,     0,     0,     0,     0,     0,  1986,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1951,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1021,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3374,
       0,     0,     0,  1021,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1022,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1950,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1029,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   830,     0,     0,
       0,     0,     0,     0,  1021,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1021,
       0,     0,     0,     0,     0,     0,     0,  1021,  1019,     0,
       0,     0,  1019,  1019,     0,     0,   831,     0,  1021,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2020,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1951,     0,     0,  1021,     0,  1951,     0,  1951,
       0,     0,     0,     0,     0,     0,  1019,     0,  1021,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1019,     0,
    1021,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1021,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1022,
       0,   831,     0,     0,   831,     0,     0,     0,  1019,     0,
       0,     0,     0,     0,  1950,     0,   830,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1021,     0,     0,  1021,
       0,  1029,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1029,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1029,
       0,     0,     0,     0,  1022,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   831,
     831,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1022,   831,   830,   831,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1021,     0,
       0,     0,     0,  1019,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1022,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2645,  2645,  2645,  1022,   831,     0,
       0,   830,     0,     0,     0,  1022,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1950,  1022,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3734,
       0,     0,     0,  1019,     0,     0,     0,     0,  3738,     0,
       0,     0,     0,     0,  3739,     0,  3740,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2020,     0,  1022,  2710,     0,  2710,     0,     0,     0,
       0,  2020,     0,  3764,  3765,     0,  1022,     0,  1950,     0,
       0,     0,     0,     0,     0,  1024,     0,     0,  1022,     0,
       0,  2562,     0,     0,     0,     0,     0,  1950,     0,  3790,
    1022,     0,  3793,     0,  3795,     0,  1024,     0,     0,     0,
       0,     0,  1025,  3799,     0,     0,     0,     0,     0,     0,
       0,  3806,  3807,  1029,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1025,     0,     0,     0,     0,     0,     0,
    1029,     0,     0,     0,  1022,     0,     0,  1022,     0,     0,
       0,  1019,  3851,     0,     0,     0,     0,     0,  3858,  3859,
    2642,     0,     0,     0,     0,  2020,     0,     0,  1019,     0,
       0,     0,     0,  1021,     0,     0,     0,  1021,  1021,  1019,
       0,     0,     0,     0,     0,  3874,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1283,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     831,     0,     0,     0,     0,  1951,     0,     0,     0,     0,
       0,     0,     0,     0,  1029,     0,  1029,     0,     0,     0,
       0,  1021,     0,     0,     0,     0,     0,     0,     0,     0,
     831,     0,     0,  1021,     0,     0,     0,     0,     0,     0,
       0,     0,   831,     0,     0,     0,     0,     0,     0,  1951,
       0,     0,     0,     0,     0,     0,  1022,     0,     0,     0,
       0,     0,     0,   831,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1021,     0,     0,     0,  1029,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1029,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2710,     0,
       0,     0,     0,     0,     0,  2710,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1024,     0,     0,     0,     0,     0,     0,     0,
       0,  1019,     0,     0,  1019,     0,  1019,     0,     0,     0,
       0,  1019,  1024,     0,     0,     0,     0,     0,     0,  1025,
       0,     0,     0,     0,     0,     0,  1024,     0,     0,     0,
       0,     0,     0,     0,  1029,     0,     0,     0,     0,  1025,
       0,     0,     0,     0,     0,     0,     0,     0,   831,     0,
       0,     0,  2710,  1025,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1019,     0,  1029,     0,     0,  1021,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1019,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1024,     0,  1019,     0,     0,     0,     0,
       0,  1022,     0,     0,     0,  1022,  1022,     0,     0,  4111,
    4112,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1025,     0,     0,     0,     0,     0,     0,     0,  1021,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   831,     0,   831,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1029,     0,
       0,     0,     0,     0,  1019,     0,  1019,     0,     0,  1022,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1029,
       0,  1022,     0,   831,     0,  4152,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4157,  1024,     0,     0,
       0,     0,     0,     0,  1029,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1022,     0,     0,  1025,     0,     0,  1019,     0,  1951,
       0,     0,     0,     0,     0,     0,  4172,  4174,  1029,     0,
       0,     0,     0,  4178,  4179,     0,  1021,     0,  4180,     0,
       0,     0,  1019,  4183,     0,     0,  4186,  4187,     0,     0,
       0,  4191,     0,  1021,     0,     0,     0,  4195,     0,     0,
       0,     0,     0,     0,  1021,     0,     0,     0,  1019,     0,
       0,     0,     0,     0,     0,  1019,  2645,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2642,     0,     0,     0,     0,  2642,     0,     0,     0,
       0,     0,  2642,     0,     0,     0,     0,     0,     0,     0,
       0,  1027,     0,     0,     0,     0,     0,  1219,     0,     0,
    2020,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1027,     0,  1019,     0,     0,     0,     0,     0,
       0,  4250,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1019,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1019,  1022,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1024,     0,  1951,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1025,     0,
    2710,     0,     0,     0,   831,     0,     0,     0,     0,  4310,
       0,     0,     0,     0,     0,     0,  1022,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1024,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1021,     0,  1019,  1021,
       0,  1021,     0,     0,     0,     0,  1021,     0,     0,     0,
       0,     0,     0,  1025,     0,     0,     0,     0,     0,  1019,
       0,  4344,     0,  1024,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1019,     0,     0,     0,     0,     0,
    1025,     0,     0,     0,     0,     0,     0,     0,  1021,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1021,     0,     0,  1019,     0,
       0,     0,     0,     0,  1022,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1029,     0,     0,     0,     0,
    1021,  1022,     0,     0,  1024,     0,     0,     0,     0,     0,
       0,  1951,  1022,   831,     0,     0,     0,     0,     0,  1024,
       0,     0,     0,     0,     0,     0,     0,  1024,  1027,     0,
       0,  1025,     0,     0,     0,     0,     0,     0,  1024,     0,
       0,     0,     0,     0,  2020,     0,  1025,     0,  1027,     0,
       0,     0,     0,     0,  1025,     0,  4436,  4437,     0,     0,
    4438,     0,  1027,     0,     0,  1025,     0,     0,     0,  1021,
    1019,  1021,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1024,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4472,  4473,     0,  1024,     0,
     831,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1024,     0,  1025,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1024,     0,     0,  1025,     0,     0,     0,     0,
       0,     0,  1021,     0,     0,     0,     0,  1025,     0,  1027,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1025,
       0,     0,     0,     0,     0,     0,     0,  1021,     0,     0,
       0,     0,     0,     0,     0,     0,  1024,     0,     0,  1024,
    1019,     0,     0,     0,     0,  1029,     0,     0,     0,     0,
       0,     0,     0,  1021,     0,  1029,     0,     0,     0,     0,
    1021,     0,     0,  1025,     0,     0,  1025,     0,   831,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1951,     0,  1022,     0,     0,  1022,     0,  1022,
       0,     0,     0,     0,  1022,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2645,     0,     0,
       0,     0,  2645,  1027,     0,     0,     0,     0,  2645,  1021,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1021,     0,     0,
       0,     0,     0,     0,     0,  1951,  1022,     0,     0,     0,
    1021,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1022,  1951,     0,  2562,     0,  1024,     0,
       0,     0,     0,     0,     0,  1029,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1019,     0,     0,  1022,     0,
       0,     0,  4637,     0,     0,  1025,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1029,  1787,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1283,  1029,     0,     0,
       0,     0,     0,     0,  1019,     0,     0,     0,     0,     0,
       0,     0,  2710,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1021,     0,     0,     0,  1022,     0,  1022,
       0,     0,     0,     0,  4686,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1021,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1029,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1021,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1027,     0,     0,
    1022,     0,     0,     0,     0,     0,     0,     0,     0,  4737,
       0,     0,     0,  1021,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1022,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1019,     0,     0,     0,     0,
       0,  1022,  4397,     0,  1029,  1019,     0,     0,  1022,     0,
       0,     0,  1027,  1024,     0,     0,     0,  1024,  1024,     0,
       0,     0,  4472,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1025,     0,     0,     0,  1025,  1025,  4794,     0,     0,  1027,
    1029,     0,     0,     0,     0,  1021,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1022,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1024,     0,     0,     0,  1022,     0,     0,     0,     0,
       0,     0,     0,  1024,     0,     0,     0,     0,  1022,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1025,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1025,     0,     0,     0,     0,  1019,     0,     0,     0,     0,
    1027,     0,     0,  1024,     0,     0,     0,  4854,  4854,     0,
       0,     0,     0,     0,     0,  1027,     0,     0,  4472,     0,
       0,     0,     0,  1027,     0,  1021,  1019,     0,     0,     0,
    1025,     0,     0,     0,  1027,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2710,     0,     0,  1019,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1019,     0,     0,     0,     0,     0,     0,     0,
       0,  1022,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1027,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1022,  4854,  1027,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1019,  1027,     0,     0,     0,
       0,     0,  4925,     0,     0,     0,     0,  1022,  1027,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1022,  2710,     0,     0,     0,     0,     0,  1024,     0,
       0,     0,  1027,     0,     0,  1027,     0,     0,     0,     0,
    1021,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1029,     0,     0,     0,     0,  1025,     0,     0,     0,     0,
       0,     0,     0,     0,  1019,  4854,  4966,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1029,  1021,
       0,     0,     0,     0,     0,     0,     0,     0,  1024,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1019,     0,     0,  1022,     0,     0,     0,     0,     0,     0,
       0,  1824,     0,     0,     0,  1025,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1029,     0,     0,     0,  1029,  1029,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1027,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1824,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1022,     0,     0,  1024,     0,     0,     0,
    1021,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1021,     0,     0,  1024,  1019,     0,  4397,  1029,     0,     0,
       0,     0,     0,  1025,  1024,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1025,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1025,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1019,     0,     0,     0,     0,     0,     0,     0,
    1021,     0,     0,     0,     0,     0,     0,     0,  1022,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1019,     0,     0,     0,     0,     0,     0,     0,     0,  1027,
       0,  1021,     0,  1027,  1027,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1021,     0,     0,     0,     0,  1022,  1019,     0,
       0,     0,     0,     0,     0,     0,     0,  1021,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1024,  1027,     0,  1024,
       0,  1024,     0,     0,     0,     0,  1024,     0,     0,  1027,
    1021,  1019,     0,     0,     0,  1019,  1019,     0,     0,     0,
       0,     0,     0,  1025,     0,     0,  1025,     0,  1025,     0,
       0,     0,     0,  1025,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1027,
       0,     0,     0,     0,     0,     0,     0,     0,  1024,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1024,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1025,     0,     0,  1022,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1022,  1021,
    1024,     0,  1025,     0,     0,     0,     0,  1019,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1025,  1824,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1021,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1024,
       0,  1024,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1025,     0,  1025,     0,
       0,     0,     0,  1824,  1027,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1824,  1022,     0,
       0,  2544,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1024,     0,     0,  1824,  1824,  1824,     0,  1824,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1022,
       0,     0,     0,     0,     0,     0,     0,  1024,     0,  1025,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1021,
    1022,     0,     0,     0,  1027,     0,     0,     0,     0,     0,
       0,  1824,     0,  1024,  1025,  1022,     0,     0,     0,     0,
    1024,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1025,     0,     0,     0,     0,     0,     0,  1025,  1824,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1022,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1024,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1024,     0,     0,
       0,     0,     0,     0,     0,     0,  1025,  1021,     0,     0,
    1024,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1027,     0,  1025,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1021,     0,  1025,     0,  1027,
       0,     0,     0,     0,     0,     0,     0,  1022,     0,     0,
    1027,     0,     0,  1824,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1824,     0,     0,  1824,     0,
       0,     0,     0,  1021,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1022,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1024,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1021,     0,     0,     0,
    1021,  1021,     0,     0,  1024,     0,     0,     0,     0,     0,
    1025,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1024,
       0,  1025,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1025,     0,     0,     0,
       0,     0,     0,  1024,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1022,     0,     0,
    1025,     0,  1021,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1027,     0,     0,  1027,     0,  1027,     0,     0,
       0,     0,  1027,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1024,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1025,     0,  1027,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1022,     0,     0,     0,     0,
       0,  1027,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1022,     0,     0,  1027,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1024,     0,     0,     0,     0,
       0,  1022,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1025,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1027,     0,  1027,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1022,     0,     0,     0,  1022,  1022,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1027,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1027,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1024,     0,     0,     0,     0,     0,     0,     0,     0,  1027,
    1022,     0,     0,     0,     0,     0,  1027,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1025,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1024,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1824,     0,     0,     0,
       0,     0,     0,     0,     0,  1027,  1025,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1824,     0,  1824,     0,
       0,  2544,  2544,  1027,  3227,     0,  2544,     0,     0,     0,
    1824,     0,     0,  1824,     0,     0,  1027,     0,  1824,     0,
       0,     0,     0,     0,  1824,     0,     0,     0,     0,  1824,
       0,     0,     0,     0,     0,     0,  1824,  1824,  1824,  1824,
       0,     0,     0,  2544,  2544,     0,  1824,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1824,     0,
    1824,     0,     0,     0,     0,     0,     0,  1824,  1824,  1824,
    1824,  1824,  1824,  1824,  1824,  1824,  1824,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1024,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1024,     0,     0,     0,  1824,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1025,     0,  1027,
       0,     0,     0,     0,     0,     0,     0,  1025,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1027,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1027,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1027,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1824,     0,     0,     0,     0,     0,
    1024,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1025,     0,     0,
       0,  1024,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1024,     0,     0,     0,     0,     0,  1025,     0,
       0,     0,     0,     0,     0,     0,     0,  1024,     0,     0,
       0,  1027,     0,     0,     0,     0,     0,     0,     0,  1025,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1025,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1024,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1025,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1027,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1024,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1025,     0,     0,     0,
       0,     0,     0,     0,     0,  1824,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1024,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1025,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1027,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1027,     0,     0,     0,  1024,
       0,     0,     0,     0,     0,  1824,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1025,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1824,     0,
       0,     0,     0,     0,  1824,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3227,  3227,     0,     0,  2544,  2544,  2544,  2544,     0,     0,
    2544,  2544,  2544,  2544,  2544,  2544,  2544,  2544,  2544,  2544,
    3227,     0,     0,     0,     0,     0,     0,  1024,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1824,     0,     0,  1824,  1027,  1824,     0,     0,
    3227,  3227,     0,     0,  1025,  1024,  1027,     0,     0,     0,
       0,     0,     0,     0,     0,  1824,  2544,  2544,  1824,     0,
    1824,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1025,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1024,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1824,     0,
    1025,     0,     0,     0,     0,     0,     0,     0,     0,  1824,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1024,     0,     0,     0,
    1024,  1024,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1824,     0,     0,     0,
       0,     0,     0,  1025,     0,     0,  1027,  1025,  1025,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1027,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1027,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1024,  1027,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1025,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1027,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2544,     0,     0,  1027,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1027,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1824,     0,     0,     0,
    1824,  1824,  1824,     0,     0,     0,     0,     0,  3227,  3227,
    3227,  3227,     0,     0,     0,  1027,  3227,  3227,  3227,  3227,
    3227,  3227,  3227,  3227,  3227,  3227,  1824,  1824,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1824,     0,     0,  1824,     0,  1824,     0,     0,
       0,  1824,     0,     0,  3227,  3227,     0,     0,  1824,  1824,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1824,     0,     0,     0,     0,     0,     0,
    1824,  1824,     0,  1027,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1824,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1027,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1027,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1027,     0,     0,     0,  1027,  1027,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3227,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1027,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1824,  1824,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1824,     0,     0,     0,     0,  1824,
    2544,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1824,     0,  1824,     0,     0,     0,
    1824,  1824,  1824,     0,     0,  1824,     0,     0,  1824,  1824,
       0,     0,     0,  1824,     0,     0,     0,  1824,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1824,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1824,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1824,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3227,  2544,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1824,  1824,
    1824,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1824,  1824,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3227,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1824,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1824,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1824,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1824,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   779,  1137,   600,  1138,  1139,  1140,   654,  1141,
       0,     0,     0,     0,     0,     0,  1824,   223,   224,   225,
     226,   227,   228,   229,   230,  2636,   232,   233,   234,     0,
       0,     0,     0,  1142,     0,     0,   235,   236,     0,   237,
     238,   780,   239,   240,   241,   242,  1143,   781,  1144,  1145,
       0,   246,   247,   248,   249,   250,  1146,  1147,   251,   252,
    1148,  1149,   255,     0,   256,   257,   258,   259,  1150,     0,
    1151,     0,   261,   262,   263,   264,   783,   265,   266,   267,
       0,   268,   269,   270,   271,   272,   273,  1824,   784,   274,
     275,   276,  1152,  1153,  1154,  1155,  1156,  1157,  1158,   277,
     278,   279,   280,   281,   282,  1159,  1160,   285,     0,   286,
       0,   287,   288,   289,   290,   291,   292,     0,   293,   294,
     295,  2637,     0,   296,   297,  1000,   299,   300,  1824,   301,
     302,   303,     0,   304,   305,   306,     0,   307,   308,   309,
     310,  1161,   312,   313,   314,  1162,  1163,   316,     0,   317,
     318,  1164,   320,     0,   321,     0,   322,   786,     0,   787,
     323,   324,   325,     0,   326,  1165,     0,  1166,   329,     0,
     330,   331,   332,   333,   334,   788,   335,   336,   337,   338,
       0,   339,   340,   341,   342,   343,   344,     0,   345,   789,
     346,   347,   348,   349,   350,  1167,  1168,     0,  1169,     0,
     354,   790,   791,   355,   792,   356,   357,   358,   359,   360,
       0,     0,   361,  1170,   793,   363,   794,     0,   364,   365,
     366,  1171,  1172,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,  1173,
     795,  1174,   385,   386,   387,  1175,   388,   389,   796,   390,
    1176,  1177,   392,  1178,   394,   395,   396,     0,   397,     0,
       0,  1179,   399,   400,     0,     0,   401,   402,   797,   403,
     798,  1180,   405,   406,   407,   408,   409,   410,   411,   412,
       0,   413,   414,  1181,   416,   417,   418,   419,   420,     0,
     421,   422,   423,   424,   425,   426,   427,   428,  1182,   430,
     431,   432,   433,     0,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,     0,   445,   446,   799,   447,
     448,   449,  1183,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,   462,   463,  1184,   464,   465,
     466,   467,   468,   800,   469,   470,  1185,   472,     0,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
    1186,     0,   485,   486,     0,   487,   801,   488,   489,   490,
     491,   492,     0,  1187,  1188,     0,     0,   495,   496,  1189,
     498,  1190,  1191,   500,   501,   502,   503,   504,   505,   506,
       0,  1192,   507,   508,   509,   510,   511,  1193,     0,   512,
     513,   514,   515,   516,   517,  1194,  2638,   519,   802,   520,
     521,   522,   523,     0,     0,   524,     0,     0,   525,   526,
     527,   528,   529,   530,   531,  1195,  1196,  1197,  1198,  1199,
    1200,  1201,  1202,   540,   541,   542,  1203,     0,     0,     0,
       0,     0,     0,  1204,  1205,  2639,     0,     0,     0,     0,
       0,     0,  1207,  2640,   779,  1137,   600,  1138,  1139,  1140,
     654,  1141,     0,     0,     0,     0,     0,     0,     0,   223,
     224,   225,   226,   227,   228,   229,   230,     0,   232,   233,
     234,     0,     0,     0,     0,  1142,     0,     0,   235,   236,
       0,   237,   238,   780,   239,   240,   241,   242,  1143,   781,
    1144,  1145,     0,   246,   247,   248,   249,   250,  1146,  1147,
     251,   252,  1148,  1149,   255,     0,   256,   257,   258,   259,
    1150,     0,  1151,     0,   261,   262,   263,   264,   783,   265,
     266,   267,     0,   268,   269,   270,   271,   272,   273,     0,
     784,   274,   275,   276,  1152,  1153,  1154,  1155,  1156,  1157,
    1158,   277,   278,   279,   280,   281,   282,  1159,  1160,   285,
       0,   286,     0,   287,   288,   289,   290,   291,   292,     0,
     293,   294,   295,     0,     0,   296,   297,  1000,   299,   300,
       0,   301,   302,   303,     0,   304,   305,   306,     0,   307,
     308,   309,   310,  1161,   312,   313,   314,  1162,  1163,   316,
       0,   317,   318,  1164,   320,     0,   321,     0,   322,   786,
       0,   787,   323,   324,   325,     0,   326,  1165,     0,  1166,
     329,     0,   330,   331,   332,   333,   334,   788,   335,   336,
     337,   338,     0,   339,   340,   341,   342,   343,   344,     0,
     345,   789,   346,   347,   348,   349,   350,  1167,  1168,     0,
    1169,     0,   354,   790,   791,   355,   792,   356,   357,   358,
     359,   360,     0,     0,   361,  1170,   793,   363,   794,     0,
     364,   365,   366,  1171,  1172,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,  1173,   795,  1174,   385,   386,   387,  1175,   388,   389,
     796,   390,  1176,  1177,   392,  1178,   394,   395,   396,     0,
     397,     0,     0,  1179,   399,   400,     0,     0,   401,   402,
     797,   403,   798,  1180,   405,   406,   407,   408,   409,   410,
     411,   412,     0,   413,   414,  1181,   416,   417,   418,   419,
     420,     0,   421,   422,   423,   424,   425,   426,   427,   428,
    1182,   430,   431,   432,   433,     0,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,     0,   445,   446,
     799,   447,   448,   449,  1183,   451,   452,   453,   454,   455,
     456,   457,   458,    39,   459,   460,   461,   462,   463,  1184,
     464,   465,   466,   467,   468,   800,   469,   470,  1185,   472,
       0,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,  1186,     0,   485,   486,    43,   487,   801,   488,
     489,   490,   491,   492,     0,  1187,  1188,     0,     0,   495,
     496,  1189,   498,  1190,  1191,   500,   501,   502,   503,   504,
     505,   506,     0,  1192,   507,   508,   509,   510,   511,  1193,
       0,   512,   513,   514,   515,   516,  1073,  1194,     0,   519,
     802,   520,   521,   522,   523,     0,     0,   524,     0,    48,
     525,   526,   527,   528,   529,   530,   531,  1195,  1196,  1197,
    1198,  1199,  1200,  1201,  1202,   540,   541,   542,  1203,     0,
      49,     0,     0,     0,     0,  1204,  1205,     0,     0,     0,
       0,     0,     0,     0,  1207,  4649,   779,  1137,   600,  1138,
    1139,  1140,   654,  1141,     0,     0,     0,     0,     0,     0,
       0,   223,   224,   225,   226,   227,   228,   229,   230,     0,
     232,   233,   234,     0,     0,     0,     0,  1142,     0,     0,
     235,   236,     0,   237,   238,   780,   239,   240,   241,   242,
    1143,   781,  1144,  1145,     0,   246,   247,   248,   249,   250,
    1146,  1147,   251,   252,  1148,  1149,   255,     0,   256,   257,
     258,   259,  1150,     0,  1151,     0,   261,   262,   263,   264,
     783,   265,   266,   267,     0,   268,   269,   270,   271,   272,
     273,     0,   784,   274,   275,   276,  1152,  1153,  1154,  1155,
    1156,  1157,  1158,   277,   278,   279,   280,   281,   282,  1159,
    1160,   285,     0,   286,     0,   287,   288,   289,   290,   291,
     292,     0,   293,   294,   295,     0,     0,   296,   297,  1000,
     299,   300,     0,   301,   302,   303,     0,   304,   305,   306,
       0,   307,   308,   309,   310,  1161,   312,   313,   314,  1162,
    1163,   316,     0,   317,   318,  1164,   320,     0,   321,     0,
     322,   786,     0,   787,   323,   324,   325,     0,   326,  1165,
       0,  1166,   329,     0,   330,   331,   332,   333,   334,   788,
     335,   336,   337,   338,     0,   339,   340,   341,   342,   343,
     344,     0,   345,   789,   346,   347,   348,   349,   350,  1167,
    1168,     0,  1169,     0,   354,   790,   791,   355,   792,   356,
     357,   358,   359,   360,     0,     0,   361,  1170,   793,   363,
     794,     0,   364,   365,   366,  1171,  1172,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,  1173,   795,  1174,   385,   386,   387,  1175,
     388,   389,   796,   390,  1176,  1177,   392,  1178,   394,   395,
     396,     0,   397,     0,     0,  1179,   399,   400,     0,     0,
     401,   402,   797,   403,   798,  1180,   405,   406,   407,   408,
     409,   410,   411,   412,     0,   413,   414,  1181,   416,   417,
     418,   419,   420,     0,   421,   422,   423,   424,   425,   426,
     427,   428,  1182,   430,   431,   432,   433,     0,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,     0,
     445,   446,   799,   447,   448,   449,  1183,   451,   452,   453,
     454,   455,   456,   457,   458,     0,   459,   460,   461,   462,
     463,  1184,   464,   465,   466,   467,   468,   800,   469,   470,
    1185,   472,     0,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,  1186,     0,   485,   486,     0,   487,
     801,   488,   489,   490,   491,   492,     0,  1187,  1188,     0,
       0,   495,   496,  1189,   498,  1190,  1191,   500,   501,   502,
     503,   504,   505,   506,     0,  1192,   507,   508,   509,   510,
     511,  1193,     0,   512,   513,   514,   515,   516,   517,  1194,
       0,   519,   802,   520,   521,   522,   523,     0,     0,   524,
       0,     0,   525,   526,   527,   528,   529,   530,   531,  1195,
    1196,  1197,  1198,  1199,  1200,  1201,  1202,   540,   541,   542,
    1203,     0,     0,     0,     0,     0,     0,  1204,  1205,     0,
       0,     0,     0,     0,     0,     0,  1207,  2546,   779,  1137,
     600,  1138,  1139,  1140,   654,  1141,     0,     0,     0,     0,
       0,     0,     0,   223,   224,   225,   226,   227,   228,   229,
     230,     0,   232,   233,   234,     0,     0,     0,     0,  1142,
       0,     0,   235,   236,     0,   237,   238,   780,   239,   240,
     241,   242,  1143,   781,  1144,  1145,     0,   246,   247,   248,
     249,   250,  1146,  1147,   251,   252,  1148,  1149,   255,     0,
     256,   257,   258,   259,  1150,     0,  1151,     0,   261,   262,
     263,   264,   783,   265,   266,   267,     0,   268,   269,   270,
     271,   272,   273,     0,   784,   274,   275,   276,  1152,  1153,
    1154,  1155,  1156,  1157,  1158,   277,   278,   279,   280,   281,
     282,  1159,  1160,   285,     0,   286,     0,   287,   288,   289,
     290,   291,   292,     0,   293,   294,   295,     0,     0,   296,
     297,  1000,   299,   300,     0,   301,   302,   303,     0,   304,
     305,   306,     0,   307,   308,   309,   310,  1161,   312,   313,
     314,  1162,  1163,   316,     0,   317,   318,  1164,   320,     0,
     321,     0,   322,   786,     0,   787,   323,   324,   325,     0,
     326,  1165,     0,  1166,   329,     0,   330,   331,   332,   333,
     334,   788,   335,   336,   337,   338,     0,   339,   340,   341,
     342,   343,   344,     0,   345,   789,   346,   347,   348,   349,
     350,  1167,  1168,     0,  1169,     0,   354,   790,   791,   355,
     792,   356,   357,   358,   359,   360,     0,     0,   361,  1170,
     793,   363,   794,     0,   364,   365,   366,  1171,  1172,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,  1173,   795,  1174,   385,   386,
     387,  1175,   388,   389,   796,   390,  1176,  1177,   392,  1178,
     394,   395,   396,     0,   397,     0,     0,  1179,   399,   400,
       0,     0,   401,   402,   797,   403,   798,  1180,   405,   406,
     407,   408,   409,   410,   411,   412,     0,   413,   414,  1181,
     416,   417,   418,   419,   420,     0,   421,   422,   423,   424,
     425,   426,   427,   428,  1182,   430,   431,   432,   433,     0,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,     0,   445,   446,   799,   447,   448,   449,  1183,   451,
     452,   453,   454,   455,   456,   457,   458,     0,   459,   460,
     461,   462,   463,  1184,   464,   465,   466,   467,   468,   800,
     469,   470,  1185,   472,     0,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,  1186,     0,   485,   486,
       0,   487,   801,   488,   489,   490,   491,   492,     0,  1187,
    1188,     0,     0,   495,   496,  1189,   498,  1190,  1191,   500,
     501,   502,   503,   504,   505,   506,     0,  1192,   507,   508,
     509,   510,   511,  1193,     0,   512,   513,   514,   515,   516,
     517,  1194,     0,   519,   802,   520,   521,   522,   523,     0,
       0,   524,     0,     0,   525,   526,   527,   528,   529,   530,
     531,  1195,  1196,  1197,  1198,  1199,  1200,  1201,  1202,   540,
     541,   542,  1203,     0,     0,     0,     0,     0,     0,  1204,
    1205,     0,     0,     0,     0,     0,     0,     0,  1207,  3742,
     779,  1137,   600,  1138,  1139,  1140,   654,  1141,     0,     0,
       0,     0,     0,     0,     0,   223,   224,   225,   226,   227,
     228,   229,   230,     0,   232,   233,   234,     0,     0,     0,
       0,  1142,     0,     0,   235,   236,     0,   237,   238,   780,
     239,   240,   241,   242,  1143,   781,  1144,  1145,     0,   246,
     247,   248,   249,   250,  1146,  1147,   251,   252,  1148,  1149,
     255,     0,   256,   257,   258,   259,  1150,     0,  1151,     0,
     261,   262,   263,   264,   783,   265,   266,   267,     0,   268,
     269,   270,   271,   272,   273,     0,   784,   274,   275,   276,
    1152,  1153,  1154,  1155,  1156,  1157,  1158,   277,   278,   279,
     280,   281,   282,  1159,  1160,   285,     0,   286,     0,   287,
     288,   289,   290,   291,   292,     0,   293,   294,   295,     0,
       0,   296,   297,  1000,   299,   300,     0,   301,   302,   303,
       0,   304,   305,   306,     0,   307,   308,   309,   310,  1161,
     312,   313,   314,  1162,  1163,   316,     0,   317,   318,  1164,
     320,     0,   321,     0,   322,   786,     0,   787,   323,   324,
     325,     0,   326,  1165,     0,  1166,   329,     0,   330,   331,
     332,   333,   334,   788,   335,   336,   337,   338,     0,   339,
     340,   341,   342,   343,   344,     0,   345,   789,   346,   347,
     348,   349,   350,  1167,  1168,     0,  1169,     0,   354,   790,
     791,   355,   792,   356,   357,   358,   359,   360,     0,     0,
     361,  1170,   793,   363,   794,     0,   364,   365,   366,  1171,
    1172,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,  1173,   795,  1174,
     385,   386,   387,  1175,   388,   389,   796,   390,  1176,  1177,
     392,  1178,   394,   395,   396,     0,   397,     0,     0,  1179,
     399,   400,     0,     0,   401,   402,   797,   403,   798,  1180,
     405,   406,   407,   408,   409,   410,   411,   412,     0,   413,
     414,  1181,   416,   417,   418,   419,   420,     0,   421,   422,
     423,   424,   425,   426,   427,   428,  1182,   430,   431,   432,
     433,     0,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,     0,   445,   446,   799,   447,   448,   449,
    1183,   451,   452,   453,   454,   455,   456,   457,   458,     0,
     459,   460,   461,   462,   463,  1184,   464,   465,   466,   467,
     468,   800,   469,   470,  1185,   472,     0,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,  1186,     0,
     485,   486,     0,   487,   801,   488,   489,   490,   491,   492,
       0,  1187,  1188,     0,     0,   495,   496,  1189,   498,  1190,
    1191,   500,   501,   502,   503,   504,   505,   506,     0,  1192,
     507,   508,   509,   510,   511,  1193,     0,   512,   513,   514,
     515,   516,   517,  1194,     0,   519,   802,   520,   521,   522,
     523,     0,     0,   524,     0,     0,   525,   526,   527,   528,
     529,   530,   531,  1195,  1196,  1197,  1198,  1199,  1200,  1201,
    1202,   540,   541,   542,  1203,     0,     0,   222,     0,     0,
       0,  1204,  1205,     0,     0,     0,     0,     0,     0,     0,
    1207,  3813,   223,   224,   225,   226,   227,   228,   229,   230,
       0,   232,   233,   234,     0,     0,     0,     0,     0,  3829,
       0,   235,   236,     0,   237,   238,     0,   239,   240,   241,
     242,   243,     0,   244,   245,     0,   246,   247,   248,   249,
     250,     0,     0,   251,   252,   253,   254,   255,     0,   256,
     257,   258,   259,   260,     0,     0,     0,   261,   262,   263,
     264,     0,   265,   266,   267,     0,   268,   269,   270,   271,
     272,   273,     0, -1599,   274,   275,   276,     0,     0,     0,
       0,     0,     0,     0,   277,   278,   279,   280,   281,   282,
     283,   284,   285,     0,   286,     0,   287,   288,   289,   290,
     291,   292,     0,   293,   294,   295,     0,     0,   296,   297,
     298,   299,   300,     0,   301,   302,   303,     0,   304,   305,
     306,     0,   307,   308,   309,   310,   311,   312,   313,   314,
     315,     0,   316,     0,   317,   318,   319,   320,     0,   321,
       0,   322,     0,     0, -1599,   323,   324,   325,     0,   326,
     327,     0,   328,   329,     0,   330,   331,   332,   333,   334,
       0,   335,   336,   337,   338,     0,   339,   340,   341,   342,
     343,   344,     0,   345, -1599,   346,   347,   348,   349,   350,
     351,   352,     0,   353,     0,   354,     0,     0,   355, -1599,
     356,   357,   358,   359,   360,     0,     0,   361,   362, -1599,
     363,     0,     0,   364,   365,   366,     0,     0,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383, -1599,   384,   385,   386,   387,
       0,   388,   389,     0,   390,     0,   391,   392,   393,   394,
     395,   396,     0,   397,     0,     0,   398,   399,   400,     0,
       0,   401,   402,     0,   403,     0,   404,   405,   406,   407,
     408,   409,   410,   411,   412,     0,   413,   414,   415,   416,
     417,   418,   419,   420,     0,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,     0,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
       0,   445,   446, -1599,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,     0,   459,   460,   461,
     462,   463,     0,   464,   465,   466,   467,   468,     0,   469,
     470,   471,   472,     0,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,     0,   485,   486,     0,
     487,     0,   488,   489,   490,   491,   492,     0,   493,   494,
       0,     0,   495,   496,   497,   498,   499,     0,   500,   501,
     502,   503,   504,   505,   506,     0,     0,   507,   508,   509,
     510,   511,     0,     0,   512,   513,   514,   515,   516,   517,
     518,     0,   519,     0,   520,   521,   522,   523,     0,     0,
     524,     0,     0,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,     0,     0,     0,   992,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1290,   223,
     224,   225,   226,   227,   228,   229,   230,     0,   232,   233,
     234,     0,     0,     0,     0,     0,     0,     0,   235,   236,
       0,   237,   238,   780,   239,   240,   241,     0,   993,   781,
     994,   995,     0,   246,   247,   248,   249,   250,     0,     0,
     251,   252,   996,   997,   255,     0,   256,   257,   258,   259,
       0,     0,   782,     0,   261,   262,   263,   264,   783,   265,
     266,   267,     0,   268,   269,   270,   271,   272,   273,     0,
     784,   274,   275,   276,     0,     0,     0,   785,     0,     0,
       0,   277,   278,   279,   280,   281,   282,   998,   999,   285,
       0,   286,     0,   287,   288,   289,   290,   291,   292,     0,
     293,   294,   295,     0,     0,   296,   297,  1000,   299,   300,
       0,   301,   302,   303,     0,   304,   305,   306,     0,   307,
     308,   309,   310,     0,   312,   313,   314,     0,     0,   316,
       0,   317,   318,  1001,   320,     0,   321,     0,   322,   786,
       0,   787,   323,   324,   325,     0,   326,     0,     0,     0,
     329,     0,   330,   331,   332,   333,   334,   788,   335,   336,
     337,   338,  2006,   339,   340,   341,   342,   343,   344,     0,
     345,   789,  2007,   347,   348,   349,   350,  1003,  1004,     0,
    1005,     0,   354,   790,   791,   355,   792,   356,   357,   358,
     359,   360,     0,     0,   361,     0,   793,   363,   794,     0,
     364,   365,   366,     0,     0,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,  1006,   795,  1007,   385,   386,     0,     0,   388,   389,
     796,   390,     0,     0,   392,  1008,   394,   395,   396,     0,
     397,     0,     0,   398,   399,   400,     0,     0,   401,  2009,
     797,   403,   798,     0,   405,   406,   407,   408,   409,   410,
     411,   412,     0,   413,   414,     0,   416,     0,   418,   419,
     420,     0,   421,   422,   423,   424,   425,   426,   427,   428,
    1009,   430,   431,   432,   433,     0,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,     0,   445,   446,
     799,   447,   448,   449,     0,   451,   452,   453,   454,   455,
     456,   457,   458,     0,   459,   460,   461,   462,   463,     0,
     464,   465,  2010,   467,   468,   800,   469,   470,  1011,   472,
       0,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,     0,     0,   485,   486,     0,   487,   801,   488,
     489,   490,   491,   492,     0,  1012,  1013,     0,     0,   495,
     496,     0,   498,     0,     0,   500,   501,   502,   503,   504,
     505,   506,     0,     0,   507,   508,   509,   510,   511,     0,
       0,   512,   513,   514,   515,   516,     0,  1014,  2011,   519,
     802,   520,   521,   522,   523,     0,     0,   524,     0,     0,
     525,   526,   527,   528,   529,   530,   992,     0,     0,     0,
       0,     0,     0,     0,     0,   540,   541,   542,     0,     0,
       0,   223,   224,   225,   226,   227,   228,   229,   230,     0,
     232,   233,   234,     0,     0,  2118,     0,     0,     0,     0,
     235,   236,     0,   237,   238,   780,   239,   240,   241,     0,
     993,   781,   994,   995,     0,   246,   247,   248,   249,   250,
       0,     0,   251,   252,   996,   997,   255,     0,   256,   257,
     258,   259,     0,     0,   782,     0,   261,   262,   263,   264,
     783,   265,   266,   267,     0,   268,   269,   270,   271,   272,
     273,     0,   784,   274,   275,   276,     0,     0,     0,   785,
       0,     0,     0,   277,   278,   279,   280,   281,   282,   998,
     999,   285,     0,   286,     0,   287,   288,   289,   290,   291,
     292,     0,   293,   294,   295,     0,     0,   296,   297,  1000,
     299,   300,     0,   301,   302,   303,     0,   304,   305,   306,
       0,   307,   308,   309,   310,     0,   312,   313,   314,     0,
       0,   316,     0,   317,   318,  1001,   320,     0,   321,     0,
     322,   786,     0,   787,   323,   324,   325,     0,   326,     0,
       0,     0,   329,     0,   330,   331,   332,   333,   334,   788,
     335,   336,   337,   338,  2006,   339,   340,   341,   342,   343,
     344,     0,   345,   789,  2007,   347,   348,   349,   350,  1003,
    1004,     0,  1005,     0,   354,   790,   791,   355,   792,   356,
     357,   358,   359,   360,     0,     0,   361,     0,   793,   363,
     794,     0,   364,   365,   366,     0,     0,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,  1006,   795,  1007,   385,   386,     0,     0,
     388,   389,   796,   390,     0,     0,   392,  1008,   394,   395,
     396,     0,   397,     0,     0,   398,   399,   400,     0,     0,
     401,  2009,   797,   403,   798,     0,   405,   406,   407,   408,
     409,   410,   411,   412,     0,   413,   414,     0,   416,     0,
     418,   419,   420,     0,   421,   422,   423,   424,   425,   426,
     427,   428,  1009,   430,   431,   432,   433,     0,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,     0,
     445,   446,   799,   447,   448,   449,     0,   451,   452,   453,
     454,   455,   456,   457,   458,     0,   459,   460,   461,   462,
     463,     0,   464,   465,  2010,   467,   468,   800,   469,   470,
    1011,   472,     0,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,     0,     0,   485,   486,     0,   487,
     801,   488,   489,   490,   491,   492,     0,  1012,  1013,     0,
       0,   495,   496,     0,   498,     0,     0,   500,   501,   502,
     503,   504,   505,   506,     0,     0,   507,   508,   509,   510,
     511,     0,     0,   512,   513,   514,   515,   516,     0,  1014,
    2011,   519,   802,   520,   521,   522,   523,     0,     0,   524,
       0,     0,   525,   526,   527,   528,   529,   530,   779,  1137,
     600,  1138,  1139,  1140,   654,  1141,     0,   540,   541,   542,
       0,     0,     0,   223,   224,   225,   226,   227,   228,   229,
     230,     0,   232,   233,   234,     0,     0,  3068,     0,  1142,
       0,     0,   235,   236,     0,   237,   238,   780,   239,   240,
     241,   242,  1143,   781,  1144,  1145,     0,   246,   247,   248,
     249,   250,  1146,  1147,   251,   252,  1148,  1149,   255,     0,
     256,   257,   258,   259,  1150,     0,  1151,     0,   261,   262,
     263,   264,   783,   265,   266,   267,     0,   268,   269,   270,
     271,   272,   273,     0,   784,   274,   275,   276,  1152,  1153,
    1154,  1155,  1156,  1157,  1158,   277,   278,   279,   280,   281,
     282,  1159,  1160,   285,  1282,   286,     0,   287,   288,   289,
     290,   291,   292,     0,   293,   294,   295,     0,     0,   296,
     297,  1000,   299,   300,     0,   301,   302,   303,     0,   304,
     305,   306,     0,   307,   308,   309,   310,  1161,   312,   313,
     314,  1162,  1163,   316,     0,   317,   318,  1164,   320,     0,
     321,     0,   322,   786,     0,   787,   323,   324,   325,     0,
     326,  1165,     0,  1166,   329,     0,   330,   331,   332,   333,
     334,   788,   335,   336,   337,   338,     0,   339,   340,   341,
     342,   343,   344,     0,   345,   789,   346,   347,   348,   349,
     350,  1167,  1168,     0,  1169,     0,   354,   790,   791,   355,
     792,   356,   357,   358,   359,   360,     0,     0,   361,  1170,
     793,   363,   794,     0,   364,   365,   366,  1171,  1172,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,  1173,   795,  1174,   385,   386,
     387,  1175,   388,   389,   796,   390,  1176,  1177,   392,  1178,
     394,   395,   396,     0,   397,     0,     0,  1179,   399,   400,
       0,     0,   401,   402,   797,   403,   798,  1180,   405,   406,
     407,   408,   409,   410,   411,   412,     0,   413,   414,  1181,
     416,   417,   418,   419,   420,     0,   421,   422,   423,   424,
     425,   426,   427,   428,  1182,   430,   431,   432,   433,     0,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,     0,   445,   446,   799,   447,   448,   449,  1183,   451,
     452,   453,   454,   455,   456,   457,   458,    39,   459,   460,
     461,   462,   463,  1184,   464,   465,   466,   467,   468,   800,
     469,   470,  1185,   472,     0,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,  1186,     0,   485,   486,
      43,   487,   801,   488,   489,   490,   491,   492,     0,  1187,
    1188,     0,     0,   495,   496,  1189,   498,  1190,  1191,   500,
     501,   502,   503,   504,   505,   506,     0,  1192,   507,   508,
     509,   510,   511,  1193,     0,   512,   513,   514,   515,   516,
    1073,  1194,     0,   519,   802,   520,   521,   522,   523,     0,
       0,   524,     0,    48,   525,   526,   527,   528,   529,   530,
     531,  1195,  1196,  1197,  1198,  1199,  1200,  1201,  1202,   540,
     541,   542,  1203,     0,    49,     0,     0,     0,     0,  1204,
    1205,     0,     0,     0,     0,     0,     0,     0,  1207,   779,
    1137,   600,  1138,  1139,  1140,   654,  1141,     0,     0,     0,
       0,     0,     0,     0,   223,   224,   225,   226,   227,   228,
     229,   230,     0,   232,   233,   234,     0,     0,     0,     0,
    1142,     0,     0,   235,   236,     0,   237,   238,   780,   239,
     240,   241,   242,  1143,   781,  1144,  1145,     0,   246,   247,
     248,   249,   250,  1146,  1147,   251,   252,  1148,  1149,   255,
       0,   256,   257,   258,   259,  1150,     0,  1151,     0,   261,
     262,   263,   264,   783,   265,   266,   267,     0,   268,   269,
     270,   271,   272,   273,     0,   784,   274,   275,   276,  1152,
    1153,  1154,  1155,  1156,  1157,  1158,   277,   278,   279,   280,
     281,   282,  1159,  1160,   285,     0,   286,     0,   287,   288,
     289,   290,   291,   292,     0,   293,   294,   295,     0,     0,
     296,   297,  1000,   299,   300,     0,   301,   302,   303,     0,
     304,   305,   306,     0,   307,   308,   309,   310,  1161,   312,
     313,   314,  1162,  1163,   316,     0,   317,   318,  1164,   320,
       0,   321,     0,   322,   786,     0,   787,   323,   324,   325,
       0,   326,  1165,     0,  1166,   329,     0,   330,   331,   332,
     333,   334,   788,   335,   336,   337,   338,     0,   339,   340,
     341,   342,   343,   344,     0,   345,   789,   346,   347,   348,
     349,   350,  1167,  1168,     0,  1169,     0,   354,   790,   791,
     355,   792,   356,   357,   358,   359,   360,     0,     0,   361,
    1170,   793,   363,   794,     0,   364,   365,   366,  1171,  1172,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,  1173,   795,  1174,   385,
     386,   387,  1175,   388,   389,   796,   390,  1176,  1177,   392,
    1178,   394,   395,   396,     0,   397,     0,     0,  1179,   399,
     400,     0,     0,   401,   402,   797,   403,   798,  1180,   405,
     406,   407,   408,   409,   410,   411,   412,     0,   413,   414,
    1181,   416,   417,   418,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,  1182,   430,   431,   432,   433,
       0,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,     0,   445,   446,   799,   447,   448,   449,  1183,
     451,   452,   453,   454,   455,   456,   457,   458,    39,   459,
     460,   461,   462,   463,  1184,   464,   465,   466,   467,   468,
     800,   469,   470,  1185,   472,     0,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,  1186,     0,   485,
     486,    43,   487,   801,   488,   489,   490,   491,   492,     0,
    1187,  1188,     0,     0,   495,   496,  1189,   498,  1190,  1191,
     500,   501,   502,   503,   504,   505,   506,     0,  1192,   507,
     508,   509,   510,   511,  1193,     0,   512,   513,   514,   515,
     516,  1073,  1194,     0,   519,   802,   520,   521,   522,   523,
       0,     0,   524,     0,    48,   525,   526,   527,   528,   529,
     530,   531,  1195,  1196,  1197,  1198,  1199,  1200,  1201,  1202,
     540,   541,   542,  1203,     0,    49,     0,     0,     0,     0,
    1204,  1205,     0,     0,     0,     0,     0,     0,     0,  1207,
     779,  1137,   600,  1138,  1139,  1140,   654,  1141,     0,     0,
       0,     0,     0,     0,     0,   223,   224,   225,   226,   227,
     228,   229,   230,     0,   232,   233,   234,     0,     0,     0,
       0,  1142,     0,     0,   235,   236,     0,   237,   238,   780,
     239,   240,   241,   242,  1143,   781,  1144,  1145,  2552,   246,
     247,   248,   249,   250,  1146,  1147,   251,   252,  1148,  1149,
     255,     0,   256,   257,   258,   259,  1150,     0,  1151,     0,
     261,   262,   263,   264,   783,   265,   266,   267,     0,   268,
     269,   270,   271,   272,   273,     0,   784,   274,   275,   276,
    1152,  1153,  1154,  1155,  1156,  1157,  1158,   277,   278,   279,
     280,   281,   282,  1159,  1160,   285,     0,   286,     0,   287,
     288,   289,   290,   291,   292,     0,   293,   294,   295,     0,
       0,   296,   297,  1000,   299,   300,     0,   301,   302,   303,
       0,   304,   305,   306,     0,   307,   308,   309,   310,  1161,
     312,   313,   314,  1162,  1163,   316,     0,   317,   318,  1164,
     320,     0,   321,     0,   322,   786,  2553,   787,   323,   324,
     325,     0,   326,  1165,     0,  1166,   329,     0,   330,   331,
     332,   333,   334,   788,   335,   336,   337,   338,     0,   339,
     340,   341,   342,   343,   344,     0,   345,   789,   346,   347,
     348,   349,   350,  1167,  1168,     0,  1169,     0,   354,   790,
     791,   355,   792,   356,   357,   358,   359,   360,     0,  2554,
     361,  1170,   793,   363,   794,     0,   364,   365,   366,  1171,
    1172,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,  1173,   795,  1174,
     385,   386,   387,  1175,   388,   389,   796,   390,  1176,  1177,
     392,  1178,   394,   395,   396,     0,   397,     0,     0,  1179,
     399,   400,     0,     0,   401,   402,   797,   403,   798,  1180,
     405,   406,   407,   408,   409,   410,   411,   412,     0,   413,
     414,  1181,   416,   417,   418,   419,   420,     0,   421,   422,
     423,   424,   425,   426,   427,   428,  1182,   430,   431,   432,
     433,     0,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,     0,   445,   446,   799,   447,   448,   449,
    1183,   451,   452,   453,   454,   455,   456,   457,   458,     0,
     459,   460,   461,   462,   463,  1184,   464,   465,   466,   467,
     468,   800,   469,   470,  1185,   472,     0,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,  1186,     0,
     485,   486,     0,   487,   801,   488,   489,   490,   491,   492,
       0,  1187,  1188,     0,  2555,   495,   496,  1189,   498,  1190,
    1191,   500,   501,   502,   503,   504,   505,   506,     0,  1192,
     507,   508,   509,   510,   511,  1193,     0,   512,   513,   514,
     515,   516,   517,  1194,     0,   519,   802,   520,   521,   522,
     523,     0,     0,   524,     0,     0,   525,   526,   527,   528,
     529,   530,   531,  1195,  1196,  1197,  1198,  1199,  1200,  1201,
    1202,   540,   541,   542,  1203,     0,     0,     0,     0,     0,
       0,  1204,  1205,     0,     0,     0,     0,     0,     0,     0,
    1207,   779,  1137,   600,  1138,  1139,  1140,   654,  1141,     0,
       0,     0,     0,     0,     0,     0,   223,   224,   225,   226,
     227,   228,   229,   230,     0,   232,   233,   234,     0,     0,
       0,     0,  1142,     0,     0,   235,   236,     0,   237,   238,
     780,   239,   240,   241,   242,  1143,   781,  1144,  1145,     0,
     246,   247,   248,   249,   250,  1146,  1147,   251,   252,  1148,
    1149,   255,     0,   256,   257,   258,   259,  1150,     0,  1151,
       0,   261,   262,   263,   264,   783,   265,   266,   267,     0,
     268,   269,   270,   271,   272,   273,     0,   784,   274,   275,
     276,  1152,  1153,  1154,  1155,  1156,  1157,  1158,   277,   278,
     279,   280,   281,   282,  1159,  1160,   285,     0,   286,     0,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
       0,     0,   296,   297,  1000,   299,   300,     0,   301,   302,
     303,     0,   304,   305,   306,     0,   307,   308,   309,   310,
    1161,   312,   313,   314,  1162,  1163,   316,     0,   317,   318,
    1164,   320,     0,   321,     0,   322,   786,     0,   787,   323,
     324,   325,     0,   326,  1165,     0,  1166,   329,     0,   330,
     331,   332,   333,   334,   788,   335,   336,   337,   338,     0,
     339,   340,   341,   342,   343,   344,     0,   345,   789,   346,
     347,   348,   349,   350,  1167,  1168,     0,  1169,     0,   354,
     790,   791,   355,   792,   356,   357,   358,   359,   360,     0,
       0,   361,  1170,   793,   363,   794,     0,   364,   365,   366,
    1171,  1172,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,  1173,   795,
    1174,   385,   386,   387,  1175,   388,   389,   796,   390,  1176,
    1177,   392,  1178,   394,   395,   396,     0,   397,     0,     0,
    1179,   399,   400,     0,     0,   401,   402,   797,   403,   798,
    1180,   405,   406,   407,   408,   409,   410,   411,   412,     0,
     413,   414,  1181,   416,   417,   418,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,  1182,   430,   431,
     432,   433,     0,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,     0,   445,   446,   799,   447,   448,
     449,  1183,   451,   452,   453,   454,   455,   456,   457,   458,
       0,   459,   460,   461,   462,   463,  1184,   464,   465,   466,
     467,   468,   800,   469,   470,  1185,   472,     0,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,  1186,
       0,   485,   486,     0,   487,   801,   488,   489,   490,   491,
     492,     0,  1187,  1188,     0,     0,   495,   496,  1189,   498,
    1190,  1191,   500,   501,   502,   503,   504,   505,   506,     0,
    1192,   507,   508,   509,   510,   511,  1193,     0,   512,   513,
     514,   515,   516,   517,  1194,     0,   519,   802,   520,   521,
     522,   523,     0,     0,   524,     0,     0,   525,   526,   527,
     528,   529,   530,   531,  1195,  1196,  1197,  1198,  1199,  1200,
    1201,  1202,   540,   541,   542,  1203,     0,     0,     0,     0,
       0,     0,  1204,  1205,     0,     0,     0,     0,     0,  1748,
    2507,  1207,   779,  1137,   600,  1138,  1139,  1140,   654,  1141,
       0,     0,     0,     0,     0,     0,     0,   223,   224,   225,
     226,   227,   228,   229,   230,     0,   232,   233,   234,     0,
       0,     0,     0,  1142,     0,     0,   235,   236,     0,   237,
     238,   780,   239,   240,   241,   242,  1143,   781,  1144,  1145,
       0,   246,   247,   248,   249,   250,  1146,  1147,   251,   252,
    1148,  1149,   255,     0,   256,   257,   258,   259,  1150,     0,
    1151,     0,   261,   262,   263,   264,   783,   265,   266,   267,
       0,   268,   269,   270,   271,   272,   273,     0,   784,   274,
     275,   276,  1152,  1153,  1154,  1155,  1156,  1157,  1158,   277,
     278,   279,   280,   281,   282,  1159,  1160,   285,     0,   286,
       0,   287,   288,   289,   290,   291,   292,     0,   293,   294,
     295,     0,     0,   296,   297,  1000,   299,   300,     0,   301,
     302,   303,     0,   304,   305,   306,     0,   307,   308,   309,
     310,  1161,   312,   313,   314,  1162,  1163,   316,     0,   317,
     318,  1164,   320,     0,   321,     0,   322,   786,     0,   787,
     323,   324,   325,     0,   326,  1165,     0,  1166,   329,     0,
     330,   331,   332,   333,   334,   788,   335,   336,   337,   338,
       0,   339,   340,   341,   342,   343,   344,     0,   345,   789,
     346,   347,   348,   349,   350,  1167,  1168,     0,  1169,     0,
     354,   790,   791,   355,   792,   356,   357,   358,   359,   360,
       0,     0,   361,  1170,   793,   363,   794,     0,   364,   365,
     366,  1171,  1172,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,  1173,
     795,  1174,   385,   386,   387,  1175,   388,   389,   796,   390,
    1176,  1177,   392,  1178,   394,   395,   396,     0,   397,     0,
       0,  1179,   399,   400,     0,     0,   401,   402,   797,   403,
     798,  1180,   405,   406,   407,   408,   409,   410,   411,   412,
       0,   413,   414,  1181,   416,   417,   418,   419,   420,     0,
     421,   422,   423,   424,   425,   426,   427,   428,  1182,   430,
     431,   432,   433,     0,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,     0,   445,   446,   799,   447,
     448,   449,  1183,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,   462,   463,  1184,   464,   465,
     466,   467,   468,   800,   469,   470,  1185,   472,     0,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
    1186,     0,   485,   486,     0,   487,   801,   488,   489,   490,
     491,   492,     0,  1187,  1188,     0,     0,   495,   496,  1189,
     498,  1190,  1191,   500,   501,   502,   503,   504,   505,   506,
       0,  1192,   507,   508,   509,   510,   511,  1193,     0,   512,
     513,   514,   515,   516,   517,  1194,     0,   519,   802,   520,
     521,   522,   523,     0,     0,   524,     0,     0,   525,   526,
     527,   528,   529,   530,   531,  1195,  1196,  1197,  1198,  1199,
    1200,  1201,  1202,   540,   541,   542,  1203,     0,     0,     0,
       0,     0,     0,  1204,  1205,  1206,     0,     0,     0,     0,
       0,     0,  1207,   779,  1137,   600,  1138,  1139,  1140,   654,
    1141,     0,     0,     0,     0,     0,     0,     0,   223,   224,
     225,   226,   227,   228,   229,   230,     0,   232,   233,   234,
       0,     0,     0,     0,  1142,     0,     0,   235,   236,     0,
     237,   238,   780,   239,   240,   241,   242,  1143,   781,  1144,
    1145,     0,   246,   247,   248,   249,   250,  1146,  1147,   251,
     252,  1148,  1149,   255,     0,   256,   257,   258,   259,  1150,
       0,  1151,     0,   261,   262,   263,   264,   783,   265,   266,
     267,     0,   268,   269,   270,   271,   272,   273,     0,   784,
     274,   275,   276,  1152,  1153,  1154,  1155,  1156,  1157,  1158,
     277,   278,   279,   280,   281,   282,  1159,  1160,   285,  1282,
     286,     0,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,     0,     0,   296,   297,  1000,   299,   300,     0,
     301,   302,   303,     0,   304,   305,   306,     0,   307,   308,
     309,   310,  1161,   312,   313,   314,  1162,  1163,   316,     0,
     317,   318,  1164,   320,     0,   321,     0,   322,   786,     0,
     787,   323,   324,   325,     0,   326,  1165,     0,  1166,   329,
       0,   330,   331,   332,   333,   334,   788,   335,   336,   337,
     338,     0,   339,   340,   341,   342,   343,   344,     0,   345,
     789,   346,   347,   348,   349,   350,  1167,  1168,     0,  1169,
       0,   354,   790,   791,   355,   792,   356,   357,   358,   359,
     360,     0,     0,   361,  1170,   793,   363,   794,     0,   364,
     365,   366,  1171,  1172,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
    1173,   795,  1174,   385,   386,   387,  1175,   388,   389,   796,
     390,  1176,  1177,   392,  1178,   394,   395,   396,     0,   397,
       0,     0,  1179,   399,   400,     0,     0,   401,   402,   797,
     403,   798,  1180,   405,   406,   407,   408,   409,   410,   411,
     412,     0,   413,   414,  1181,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,  1182,
     430,   431,   432,   433,     0,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,     0,   445,   446,   799,
     447,   448,   449,  1183,   451,   452,   453,   454,   455,   456,
     457,   458,     0,   459,   460,   461,   462,   463,  1184,   464,
     465,   466,   467,   468,   800,   469,   470,  1185,   472,     0,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,  1186,     0,   485,   486,     0,   487,   801,   488,   489,
     490,   491,   492,     0,  1187,  1188,     0,     0,   495,   496,
    1189,   498,  1190,  1191,   500,   501,   502,   503,   504,   505,
     506,     0,  1192,   507,   508,   509,   510,   511,  1193,     0,
     512,   513,   514,   515,   516,   517,  1194,     0,   519,   802,
     520,   521,   522,   523,     0,     0,   524,     0,     0,   525,
     526,   527,   528,   529,   530,   531,  1195,  1196,  1197,  1198,
    1199,  1200,  1201,  1202,   540,   541,   542,  1203,     0,     0,
       0,     0,     0,     0,  1204,  1205,     0,     0,     0,     0,
       0,     0,     0,  1207,   779,  1137,   600,  1138,  1139,  1140,
     654,  1141,     0,     0,     0,     0,     0,     0,     0,   223,
     224,   225,   226,   227,   228,   229,   230,  1981,   232,   233,
     234,     0,     0,     0,     0,  1142,     0,     0,   235,   236,
       0,   237,   238,   780,   239,   240,   241,   242,  1143,   781,
    1144,  1145,     0,   246,   247,   248,   249,   250,  1146,  1147,
     251,   252,  1148,  1149,   255,     0,   256,   257,   258,   259,
    1150,     0,  1151,     0,   261,   262,   263,   264,   783,   265,
     266,   267,     0,   268,   269,   270,   271,   272,   273,     0,
     784,   274,   275,   276,  1152,  1153,  1154,  1155,  1156,  1157,
    1158,   277,   278,   279,   280,   281,   282,  1159,  1160,   285,
       0,   286,     0,   287,   288,   289,   290,   291,   292,     0,
     293,   294,   295,     0,     0,   296,   297,  1000,   299,   300,
       0,   301,   302,   303,     0,   304,   305,   306,     0,   307,
     308,   309,   310,  1161,   312,   313,   314,  1162,  1163,   316,
       0,   317,   318,  1164,   320,     0,   321,     0,   322,   786,
       0,   787,   323,   324,   325,     0,   326,  1165,     0,  1166,
     329,     0,   330,   331,   332,   333,   334,   788,   335,   336,
     337,   338,     0,   339,   340,   341,   342,   343,   344,     0,
     345,   789,   346,   347,   348,   349,   350,  1167,  1168,     0,
    1169,     0,   354,   790,   791,   355,   792,   356,   357,   358,
     359,   360,     0,     0,   361,  1170,   793,   363,   794,     0,
     364,   365,   366,  1171,  1172,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,  1173,   795,  1174,   385,   386,   387,  1175,   388,   389,
     796,   390,  1176,  1177,   392,  1178,   394,   395,   396,     0,
     397,     0,     0,  1179,   399,   400,     0,     0,   401,   402,
     797,   403,   798,  1180,   405,   406,   407,   408,   409,   410,
     411,   412,     0,   413,   414,  1181,   416,   417,   418,   419,
     420,     0,   421,   422,   423,   424,   425,   426,   427,   428,
    1182,   430,   431,   432,   433,     0,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,     0,   445,   446,
     799,   447,   448,   449,  1183,   451,   452,   453,   454,   455,
     456,   457,   458,     0,   459,   460,   461,   462,   463,  1184,
     464,   465,   466,   467,   468,   800,   469,   470,  1185,   472,
       0,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,  1186,     0,   485,   486,     0,   487,   801,   488,
     489,   490,   491,   492,     0,  1187,  1188,     0,     0,   495,
     496,  1189,   498,  1190,  1191,   500,   501,   502,   503,   504,
     505,   506,     0,  1192,   507,   508,   509,   510,   511,  1193,
       0,   512,   513,   514,   515,   516,   517,  1194,     0,   519,
     802,   520,   521,   522,   523,     0,     0,   524,     0,     0,
     525,   526,   527,   528,   529,   530,   531,  1195,  1196,  1197,
    1198,  1199,  1200,  1201,  1202,   540,   541,   542,  1203,     0,
       0,     0,     0,     0,     0,  1204,  1205,     0,     0,     0,
       0,     0,     0,     0,  1207,   779,  1137,   600,  1138,  1139,
    1140,   654,  1141,     0,     0,     0,     0,     0,     0,     0,
     223,   224,   225,   226,   227,   228,   229,   230,     0,   232,
     233,   234,     0,     0,     0,     0,  1142,     0,     0,   235,
     236,     0,   237,   238,   780,   239,   240,   241,   242,  1143,
     781,  1144,  1145,     0,   246,   247,   248,   249,   250,  1146,
    1147,   251,   252,  1148,  1149,   255,     0,   256,   257,   258,
     259,  1150,     0,  1151,     0,   261,   262,   263,   264,   783,
     265,   266,   267,     0,   268,   269,   270,   271,   272,   273,
       0,   784,   274,   275,   276,  1152,  1153,  1154,  1155,  1156,
    1157,  1158,   277,   278,   279,   280,   281,   282,  1159,  1160,
     285,     0,   286,     0,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,     0,     0,   296,   297,  1000,   299,
     300,     0,   301,   302,   303,     0,   304,   305,   306,     0,
     307,   308,   309,   310,  1161,   312,   313,   314,  1162,  1163,
     316,     0,   317,   318,  1164,   320,     0,   321,     0,   322,
     786,  2553,   787,   323,   324,   325,     0,   326,  1165,     0,
    1166,   329,     0,   330,   331,   332,   333,   334,   788,   335,
     336,   337,   338,     0,   339,   340,   341,   342,   343,   344,
       0,   345,   789,   346,   347,   348,   349,   350,  1167,  1168,
       0,  1169,     0,   354,   790,   791,   355,   792,   356,   357,
     358,   359,   360,     0,     0,   361,  1170,   793,   363,   794,
       0,   364,   365,   366,  1171,  1172,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,  1173,   795,  1174,   385,   386,   387,  1175,   388,
     389,   796,   390,  1176,  1177,   392,  1178,   394,   395,   396,
       0,   397,     0,     0,  1179,   399,   400,     0,     0,   401,
     402,   797,   403,   798,  1180,   405,   406,   407,   408,   409,
     410,   411,   412,     0,   413,   414,  1181,   416,   417,   418,
     419,   420,     0,   421,   422,   423,   424,   425,   426,   427,
     428,  1182,   430,   431,   432,   433,     0,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,     0,   445,
     446,   799,   447,   448,   449,  1183,   451,   452,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,   462,   463,
    1184,   464,   465,   466,   467,   468,   800,   469,   470,  1185,
     472,     0,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,  1186,     0,   485,   486,     0,   487,   801,
     488,   489,   490,   491,   492,     0,  1187,  1188,     0,     0,
     495,   496,  1189,   498,  1190,  1191,   500,   501,   502,   503,
     504,   505,   506,     0,  1192,   507,   508,   509,   510,   511,
    1193,     0,   512,   513,   514,   515,   516,   517,  1194,     0,
     519,   802,   520,   521,   522,   523,     0,     0,   524,     0,
       0,   525,   526,   527,   528,   529,   530,   531,  1195,  1196,
    1197,  1198,  1199,  1200,  1201,  1202,   540,   541,   542,  1203,
       0,     0,     0,     0,     0,     0,  1204,  1205,     0,     0,
       0,     0,     0,     0,     0,  1207,   779,  1137,   600,  1138,
    1139,  1140,   654,  1141,     0,     0,     0,     0,     0,     0,
       0,   223,   224,   225,   226,   227,   228,   229,   230,     0,
     232,   233,   234,     0,     0,     0,     0,  1142,     0,     0,
     235,   236,     0,   237,   238,   780,   239,   240,   241,   242,
    1143,   781,  1144,  1145,     0,   246,   247,   248,   249,   250,
    1146,  1147,   251,   252,  1148,  1149,   255,     0,   256,   257,
     258,   259,  1150,     0,  1151,     0,   261,   262,   263,   264,
     783,   265,   266,   267,     0,   268,   269,   270,   271,   272,
     273,     0,   784,   274,   275,   276,  1152,  1153,  1154,  1155,
    1156,  1157,  1158,   277,   278,   279,   280,   281,   282,  1159,
    1160,   285,     0,   286,     0,   287,   288,   289,   290,   291,
     292,     0,   293,   294,   295,     0,     0,   296,   297,  1000,
     299,   300,     0,   301,   302,   303,     0,   304,   305,   306,
       0,   307,   308,   309,   310,  1161,   312,   313,   314,  1162,
    1163,   316,     0,   317,   318,  1164,   320,     0,   321,     0,
     322,   786,     0,   787,   323,   324,   325,     0,   326,  1165,
       0,  1166,   329,     0,   330,   331,   332,   333,   334,   788,
     335,   336,   337,   338,     0,   339,   340,   341,   342,   343,
     344,     0,   345,   789,   346,   347,   348,   349,   350,  1167,
    1168,     0,  1169,     0,   354,   790,   791,   355,   792,   356,
     357,   358,   359,   360,     0,     0,   361,  1170,   793,   363,
     794,     0,   364,   365,   366,  1171,  1172,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,  1173,   795,  1174,   385,   386,   387,  1175,
     388,   389,   796,   390,  1176,  1177,   392,  1178,   394,   395,
     396,     0,   397,     0,     0,  1179,   399,   400,     0,     0,
     401,   402,   797,   403,   798,  1180,   405,   406,   407,   408,
     409,   410,   411,   412,     0,   413,   414,  1181,   416,   417,
     418,   419,   420,     0,   421,   422,   423,   424,   425,   426,
     427,   428,  1182,   430,   431,   432,   433,     0,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,     0,
     445,   446,   799,   447,   448,   449,  1183,   451,   452,   453,
     454,   455,   456,   457,   458,     0,   459,   460,   461,   462,
     463,  1184,   464,   465,   466,   467,   468,   800,   469,   470,
    1185,   472,     0,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,  1186,     0,   485,   486,     0,   487,
     801,   488,   489,   490,   491,   492,     0,  1187,  1188,     0,
       0,   495,   496,  1189,   498,  1190,  1191,   500,   501,   502,
     503,   504,   505,   506,     0,  1192,   507,   508,   509,   510,
     511,  1193,     0,   512,   513,   514,   515,   516,   517,  1194,
    3860,   519,   802,   520,   521,   522,   523,     0,     0,   524,
       0,     0,   525,   526,   527,   528,   529,   530,   531,  1195,
    1196,  1197,  1198,  1199,  1200,  1201,  1202,   540,   541,   542,
    1203,     0,     0,     0,     0,     0,     0,  1204,  1205,     0,
       0,     0,     0,     0,     0,     0,  1207,   779,  1137,   600,
    1138,  1139,  1140,   654,  1141,     0,     0,     0,     0,     0,
       0,     0,   223,   224,   225,   226,   227,   228,   229,   230,
       0,   232,   233,   234,     0,     0,     0,     0,  1142,     0,
       0,   235,   236,     0,   237,   238,   780,   239,   240,   241,
     242,  1143,   781,  1144,  1145,     0,   246,   247,   248,   249,
     250,  1146,  1147,   251,   252,  1148,  1149,   255,     0,   256,
     257,   258,   259,  1150,     0,  1151,     0,   261,   262,   263,
     264,   783,   265,   266,   267,     0,   268,   269,   270,   271,
     272,   273,     0,   784,   274,   275,   276,  1152,  1153,  1154,
    1155,  1156,  1157,  1158,   277,   278,   279,   280,   281,   282,
    1159,  1160,   285,     0,   286,     0,   287,   288,   289,   290,
     291,   292,     0,   293,   294,   295,     0,     0,   296,   297,
    1000,   299,   300,     0,   301,   302,   303,     0,   304,   305,
     306,     0,   307,   308,   309,   310,  1161,   312,   313,   314,
    1162,  1163,   316,     0,   317,   318,  1164,   320,     0,   321,
       0,   322,   786,     0,   787,   323,   324,   325,     0,   326,
    1165,     0,  1166,   329,     0,   330,   331,   332,   333,   334,
     788,   335,   336,   337,   338,     0,   339,   340,   341,   342,
     343,   344,     0,   345,   789,   346,   347,   348,   349,   350,
    1167,  1168,     0,  1169,     0,   354,   790,   791,   355,   792,
     356,   357,   358,   359,   360,     0,     0,   361,  1170,   793,
     363,   794,     0,   364,   365,   366,  1171,  1172,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,  1173,   795,  1174,   385,   386,   387,
    1175,   388,   389,   796,   390,  1176,  1177,   392,  1178,   394,
     395,   396,     0,   397,     0,     0,  1179,   399,   400,     0,
       0,   401,   402,   797,   403,   798,  1180,   405,   406,   407,
     408,   409,   410,   411,   412,     0,   413,   414,  1181,   416,
     417,   418,   419,   420,     0,   421,   422,   423,   424,   425,
     426,   427,   428,  1182,   430,   431,   432,   433,     0,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
       0,   445,   446,   799,   447,   448,   449,  1183,   451,   452,
     453,   454,   455,   456,   457,   458,     0,   459,   460,   461,
     462,   463,  1184,   464,   465,   466,   467,   468,   800,   469,
     470,  1185,   472,     0,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,  1186,     0,   485,   486,     0,
     487,   801,   488,   489,   490,   491,   492,     0,  1187,  1188,
       0,     0,   495,   496,  1189,   498,  1190,  1191,   500,   501,
     502,   503,   504,   505,   506,     0,  1192,   507,   508,   509,
     510,   511,  1193,     0,   512,   513,   514,   515,   516,   517,
    1194,     0,   519,   802,   520,   521,   522,   523,     0,     0,
     524,     0,     0,   525,   526,   527,   528,   529,   530,   531,
    1195,  1196,  1197,  1198,  1199,  1200,  1201,  1202,   540,   541,
     542,  1203,     0,     0,     0,     0,     0,     0,  1204,  1205,
       0,     0,     0,     0,     0,     0,     0,  1207,   779,  1137,
     600,  1138,  1139,  1140,   654,  1141,     0,     0,     0,     0,
       0,     0,     0,   223,   224,   225,   226,   227,   228,   229,
     230,     0,   232,   233,   234,     0,     0,     0,     0,  1142,
       0,     0,   235,   236,     0,   237,   238,   780,   239,   240,
     241,   242,  1143,   781,  1144,  1145,     0,   246,   247,   248,
     249,   250,  1146,  1147,   251,   252,  1148,  1149,   255,     0,
     256,   257,   258,   259,  1150,     0,  1151,     0,   261,   262,
     263,   264,   783,   265,   266,   267,     0,   268,   269,   270,
     271,   272,   273,     0,   784,   274,   275,  3873,  1152,  1153,
    1154,  1155,  1156,  1157,  1158,   277,   278,   279,   280,   281,
     282,  1159,  1160,   285,     0,   286,     0,   287,   288,   289,
     290,   291,   292,     0,   293,   294,   295,     0,     0,   296,
     297,  1000,   299,   300,     0,   301,   302,   303,     0,   304,
     305,   306,     0,   307,   308,   309,   310,  1161,   312,   313,
     314,  1162,  1163,   316,     0,   317,   318,  1164,   320,     0,
     321,     0,   322,   786,     0,   787,   323,   324,   325,     0,
     326,  1165,     0,  1166,   329,     0,   330,   331,   332,   333,
     334,   788,   335,   336,   337,   338,     0,   339,   340,   341,
     342,   343,   344,     0,   345,   789,   346,   347,   348,   349,
     350,  1167,  1168,     0,  1169,     0,   354,   790,   791,   355,
     792,   356,   357,   358,   359,   360,     0,     0,   361,  1170,
     793,   363,   794,     0,   364,   365,   366,  1171,  1172,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,  1173,   795,  1174,   385,   386,
     387,  1175,   388,   389,   796,   390,  1176,  1177,   392,  1178,
     394,   395,   396,     0,   397,     0,     0,  1179,   399,   400,
       0,     0,   401,   402,   797,   403,   798,  1180,   405,   406,
     407,   408,   409,   410,   411,   412,     0,   413,   414,  1181,
     416,   417,   418,   419,   420,     0,   421,   422,   423,   424,
     425,   426,   427,   428,  1182,   430,   431,   432,   433,     0,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,     0,   445,   446,   799,   447,   448,   449,  1183,   451,
     452,   453,   454,   455,   456,   457,   458,     0,   459,   460,
     461,   462,   463,  1184,   464,   465,   466,   467,   468,   800,
     469,   470,  1185,   472,     0,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,  1186,     0,   485,   486,
       0,   487,   801,   488,   489,   490,   491,   492,     0,  1187,
    1188,     0,     0,   495,   496,  1189,   498,  1190,  1191,   500,
     501,   502,   503,   504,   505,   506,     0,  1192,   507,   508,
     509,   510,   511,  1193,     0,   512,   513,   514,   515,   516,
     517,  1194,     0,   519,   802,   520,   521,   522,   523,     0,
       0,   524,     0,     0,   525,   526,   527,   528,   529,   530,
     531,  1195,  1196,  1197,  1198,  1199,  1200,  1201,  1202,   540,
     541,   542,  1203,     0,     0,     0,     0,     0,     0,  1204,
    1205,     0,     0,     0,     0,     0,     0,     0,  1207,   779,
    1137,   600,  1138,  1139,  1140,   654,  1141,     0,     0,     0,
       0,     0,     0,     0,   223,   224,   225,   226,   227,   228,
     229,   230,     0,   232,   233,   234,     0,     0,     0,     0,
    1142,     0,     0,   235,   236,     0,   237,   238,   780,   239,
     240,   241,   242,  1143,   781,  1144,  1145,     0,   246,   247,
     248,   249,   250,  1146,  1147,   251,   252,  1148,  1149,   255,
       0,   256,   257,   258,   259,  1150,     0,  1151,     0,   261,
     262,   263,   264,   783,   265,   266,   267,     0,   268,   269,
     270,   271,   272,   273,     0,   784,   274,   275,   276,  1152,
    1153,  1154,  1155,  1156,  1157,  1158,   277,   278,   279,   280,
     281,   282,  1159,  1160,   285,     0,   286,     0,   287,   288,
     289,   290,   291,   292,     0,   293,   294,   295,     0,     0,
     296,   297,  1000,   299,   300,     0,   301,   302,   303,     0,
     304,   305,   306,     0,   307,   308,   309,   310,  1161,   312,
     313,   314,  1162,  1163,   316,     0,   317,   318,  1164,   320,
       0,   321,     0,   322,   786,     0,   787,   323,   324,   325,
       0,   326,  1165,     0,  1166,   329,     0,   330,   331,   332,
     333,   334,   788,   335,   336,   337,   338,     0,   339,   340,
     341,   342,   343,   344,     0,   345,   789,   346,   347,   348,
     349,   350,  1167,  1168,     0,  1169,     0,   354,   790,   791,
     355,   792,   356,   357,   358,   359,   360,     0,     0,   361,
    1170,   793,   363,   794,     0,   364,   365,   366,  1171,  1172,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,  1173,   795,  1174,   385,
     386,   387,  1175,   388,   389,   796,   390,  1176,  1177,   392,
    1178,   394,   395,   396,     0,   397,     0,     0,  1179,   399,
     400,     0,     0,   401,   402,   797,   403,   798,  1180,   405,
     406,   407,   408,   409,   410,   411,   412,     0,   413,   414,
    1181,   416,   417,   418,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,  1182,   430,   431,   432,   433,
       0,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,     0,   445,   446,   799,   447,   448,   449,  1183,
     451,   452,   453,   454,   455,   456,   457,   458,     0,   459,
     460,   461,   462,   463,  1184,   464,   465,   466,   467,   468,
     800,   469,   470,  1185,   472,     0,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,  1186,     0,   485,
     486,     0,   487,   801,   488,   489,   490,   491,   492,     0,
    1187,  1188,     0,     0,   495,   496,  1189,   498,  1190,  1191,
     500,   501,   502,   503,   504,   505,   506,     0,  1192,   507,
     508,   509,   510,   511,  1193,     0,   512,   513,   514,   515,
     516,   517,  1194,     0,   519,   802,   520,   521,   522,   523,
       0,     0,   524,     0,     0,   525,   526,   527,   528,   529,
     530,  4164,  1195,  1196,  1197,  1198,  1199,  1200,  1201,  1202,
     540,   541,   542,  1203,     0,     0,     0,     0,     0,     0,
    1204,  1205,     0,     0,     0,     0,     0,     0,     0,  1207,
     779,  1137,   600,  1138,  1139,  1140,   654,  1141,     0,     0,
       0,     0,     0,     0,     0,   223,   224,   225,   226,   227,
     228,   229,   230,     0,   232,   233,   234,     0,     0,     0,
       0,  1142,     0,     0,   235,   236,     0,   237,   238,   780,
     239,   240,   241,   242,  1143,   781,  1144,  1145,     0,   246,
     247,   248,   249,   250,  1146,  1147,   251,   252,  1148,  1149,
     255,     0,   256,   257,   258,   259,  1150,     0,  1151,     0,
     261,   262,   263,   264,   783,   265,   266,   267,     0,   268,
     269,   270,   271,   272,   273,     0,   784,   274,   275,   276,
    1152,  1153,  1154,  1155,  1156,  1157,  1158,   277,   278,   279,
     280,   281,   282,  1159,  1160,   285,     0,   286,     0,   287,
     288,   289,   290,   291,   292,     0,   293,   294,   295,     0,
       0,   296,   297,  1000,   299,   300,     0,   301,   302,   303,
       0,   304,   305,   306,     0,   307,   308,   309,   310,  1161,
     312,   313,   314,  1162,  1163,   316,     0,   317,   318,  1164,
     320,     0,   321,     0,   322,   786,     0,   787,   323,   324,
     325,     0,   326,  1165,     0,  1166,   329,     0,   330,   331,
     332,   333,   334,   788,   335,   336,   337,   338,     0,   339,
     340,   341,   342,   343,   344,     0,   345,   789,   346,   347,
     348,   349,   350,  1167,  1168,     0,  1169,     0,   354,   790,
     791,   355,   792,   356,   357,   358,   359,   360,     0,     0,
     361,  1170,   793,   363,   794,     0,   364,   365,   366,  1171,
    1172,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,  1173,   795,  1174,
     385,  4173,   387,  1175,   388,   389,   796,   390,  1176,  1177,
     392,  1178,   394,   395,   396,     0,   397,     0,     0,  1179,
     399,   400,     0,     0,   401,   402,   797,   403,   798,  1180,
     405,   406,   407,   408,   409,   410,   411,   412,     0,   413,
     414,  1181,   416,   417,   418,   419,   420,     0,   421,   422,
     423,   424,   425,   426,   427,   428,  1182,   430,   431,   432,
     433,     0,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,     0,   445,   446,   799,   447,   448,   449,
    1183,   451,   452,   453,   454,   455,   456,   457,   458,     0,
     459,   460,   461,   462,   463,  1184,   464,   465,   466,   467,
     468,   800,   469,   470,  1185,   472,     0,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,  1186,     0,
     485,   486,     0,   487,   801,   488,   489,   490,   491,   492,
       0,  1187,  1188,     0,     0,   495,   496,  1189,   498,  1190,
    1191,   500,   501,   502,   503,   504,   505,   506,     0,  1192,
     507,   508,   509,   510,   511,  1193,     0,   512,   513,   514,
     515,   516,   517,  1194,     0,   519,   802,   520,   521,   522,
     523,     0,     0,   524,     0,     0,   525,   526,   527,   528,
     529,   530,   531,  1195,  1196,  1197,  1198,  1199,  1200,  1201,
    1202,   540,   541,   542,  1203,     0,     0,     0,     0,     0,
       0,  1204,  1205,     0,     0,     0,     0,     0,     0,     0,
    1207,   779,  1137,   600,  1138,  1139,  1140,   654,  1141,     0,
       0,     0,     0,     0,     0,     0,   223,   224,   225,   226,
     227,   228,   229,   230,     0,   232,   233,   234,     0,     0,
       0,     0,  1142,     0,     0,   235,   236,     0,   237,   238,
     780,   239,   240,   241,   242,  1143,   781,  1144,  1145,     0,
     246,   247,   248,   249,   250,  1146,  1147,   251,   252,  1148,
    1149,   255,     0,   256,   257,   258,   259,  1150,     0,  1151,
       0,   261,   262,   263,   264,   783,   265,   266,   267,     0,
     268,   269,   270,   271,   272,   273,     0,   784,   274,  4462,
     276,  1152,  1153,  1154,  1155,  1156,  1157,  1158,   277,   278,
     279,   280,   281,   282,  1159,  1160,   285,     0,   286,     0,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
       0,     0,   296,   297,  1000,   299,   300,     0,   301,   302,
     303,     0,   304,   305,   306,     0,   307,   308,   309,   310,
    1161,   312,   313,   314,  1162,  1163,   316,     0,   317,   318,
    1164,   320,     0,   321,     0,   322,   786,     0,   787,   323,
     324,   325,     0,   326,  1165,     0,  4463,   329,     0,   330,
     331,   332,   333,   334,   788,   335,   336,   337,   338,     0,
     339,   340,   341,   342,   343,   344,     0,   345,   789,   346,
     347,   348,   349,   350,  1167,  1168,     0,  1169,     0,   354,
     790,   791,   355,   792,   356,   357,   358,   359,   360,     0,
       0,   361,  1170,   793,   363,   794,     0,   364,   365,   366,
    1171,  1172,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,  1173,   795,
    1174,   385,   386,   387,  1175,   388,   389,   796,   390,  1176,
    1177,   392,  1178,   394,   395,   396,     0,   397,     0,     0,
    1179,   399,   400,     0,     0,   401,   402,   797,   403,   798,
    1180,   405,   406,   407,   408,   409,   410,   411,   412,     0,
     413,   414,  1181,   416,   417,   418,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,  1182,   430,   431,
     432,   433,     0,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,     0,   445,   446,   799,   447,   448,
    4464,  1183,   451,   452,   453,   454,   455,   456,   457,   458,
       0,   459,   460,   461,   462,   463,  1184,   464,   465,   466,
     467,   468,   800,   469,   470,  1185,   472,     0,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,  1186,
       0,   485,   486,     0,   487,   801,   488,   489,   490,   491,
     492,     0,  1187,  1188,     0,     0,   495,   496,  1189,   498,
    1190,  1191,   500,   501,   502,   503,   504,   505,   506,     0,
    1192,   507,   508,   509,   510,   511,  1193,     0,   512,   513,
     514,   515,   516,   517,  1194,     0,   519,   802,   520,   521,
     522,   523,     0,     0,   524,     0,     0,   525,   526,   527,
     528,   529,   530,   531,  1195,  1196,  1197,  1198,  1199,  1200,
    1201,  1202,   540,   541,   542,  1203,     0,     0,     0,     0,
       0,     0,  1204,  1205,     0,     0,     0,     0,     0,     0,
       0,  4465,   779,  1137,   600,  1138,  1139,  1140,   654,  1141,
       0,     0,     0,     0,     0,     0,     0,   223,   224,   225,
     226,   227,   228,   229,   230,     0,   232,   233,   234,     0,
       0,     0,     0,  1142,     0,     0,   235,   236,     0,   237,
     238,   780,   239,   240,   241,  4851,  1143,   781,  1144,  1145,
       0,   246,   247,   248,   249,   250,  1146,  1147,   251,   252,
    1148,  1149,   255,     0,   256,   257,   258,   259,  1150,     0,
    1151,     0,   261,   262,   263,   264,   783,   265,   266,   267,
       0,   268,   269,   270,   271,   272,   273,     0,   784,   274,
     275,  4852,  1152,  1153,  1154,  1155,  1156,  1157,  1158,   277,
     278,   279,   280,   281,   282,  1159,  1160,   285,     0,   286,
       0,   287,   288,   289,   290,   291,   292,     0,   293,   294,
     295,     0,     0,   296,   297,  1000,   299,   300,     0,   301,
     302,   303,     0,   304,   305,   306,     0,   307,   308,   309,
     310,  1161,   312,   313,   314,  1162,  1163,   316,     0,   317,
     318,  1164,   320,     0,   321,     0,   322,   786,     0,   787,
     323,   324,   325,     0,   326,  1165,     0,  1166,   329,     0,
     330,   331,   332,   333,   334,   788,   335,   336,   337,   338,
       0,   339,   340,   341,   342,   343,   344,     0,   345,   789,
     346,   347,   348,   349,   350,  1167,  1168,     0,  1169,     0,
     354,   790,   791,   355,   792,   356,   357,   358,   359,   360,
       0,     0,   361,  1170,   793,   363,   794,     0,   364,   365,
     366,  1171,  1172,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,  1173,
     795,  1174,   385,   386,   387,  1175,   388,   389,   796,   390,
    1176,  1177,   392,  1178,   394,   395,   396,     0,   397,     0,
       0,  1179,   399,   400,     0,     0,   401,   402,   797,   403,
     798,  1180,   405,   406,   407,   408,   409,   410,   411,   412,
       0,   413,   414,  1181,   416,   417,   418,   419,   420,     0,
     421,   422,   423,   424,   425,   426,   427,   428,  1182,   430,
     431,   432,   433,     0,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,     0,   445,   446,   799,   447,
     448,   449,  1183,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,   462,   463,  1184,   464,   465,
     466,   467,   468,   800,   469,   470,  1185,   472,     0,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
    1186,     0,   485,   486,     0,   487,   801,   488,   489,   490,
     491,   492,     0,  1187,  1188,     0,     0,   495,   496,  1189,
     498,  1190,  1191,   500,   501,   502,   503,  4853,   505,   506,
       0,  1192,   507,   508,   509,   510,   511,  1193,     0,   512,
     513,   514,   515,   516,   517,  1194,     0,   519,   802,   520,
     521,   522,   523,     0,     0,   524,     0,     0,   525,   526,
     527,   528,   529,   530,   531,  1195,  1196,  1197,  1198,  1199,
    1200,  1201,  1202,   540,   541,   542,  1203,     0,     0,     0,
       0,     0,     0,  1204,  1205,     0,     0,     0,     0,     0,
       0,     0,  1207,   779,  1137,   600,  1138,  1139,  1140,   654,
    1141,     0,     0,     0,     0,     0,     0,     0,   223,   224,
     225,   226,   227,   228,   229,   230,     0,   232,   233,   234,
       0,     0,     0,     0,  1142,     0,     0,   235,   236,     0,
     237,   238,   780,   239,   240,   241,   242,  1143,   781,  1144,
    1145,     0,   246,   247,   248,   249,   250,  1146,  1147,   251,
     252,  1148,  1149,   255,     0,   256,   257,   258,   259,  1150,
       0,  1151,     0,   261,   262,   263,   264,   783,   265,   266,
     267,     0,   268,   269,   270,   271,   272,   273,     0,   784,
     274,   275,  4852,  1152,  1153,  1154,  1155,  1156,  1157,  1158,
     277,   278,   279,   280,   281,   282,  1159,  1160,   285,     0,
     286,     0,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,     0,     0,   296,   297,  1000,   299,   300,     0,
     301,   302,   303,     0,   304,   305,   306,     0,   307,   308,
     309,   310,  1161,   312,   313,   314,  1162,  1163,   316,     0,
     317,   318,  1164,   320,     0,   321,     0,   322,   786,     0,
     787,   323,   324,   325,     0,   326,  1165,     0,  1166,   329,
       0,   330,   331,   332,   333,   334,   788,   335,   336,   337,
     338,     0,   339,   340,   341,   342,   343,   344,     0,   345,
     789,   346,   347,   348,   349,   350,  1167,  1168,     0,  1169,
       0,   354,   790,   791,   355,   792,   356,   357,   358,   359,
     360,     0,     0,   361,  1170,   793,   363,   794,     0,   364,
     365,   366,  1171,  1172,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
    1173,   795,  1174,   385,   386,   387,  1175,   388,   389,   796,
     390,  1176,  1177,   392,  1178,   394,   395,   396,     0,   397,
       0,     0,  1179,   399,   400,     0,     0,   401,   402,   797,
     403,   798,  1180,   405,   406,   407,   408,   409,   410,   411,
     412,     0,   413,   414,  1181,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,  1182,
     430,   431,   432,   433,     0,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,     0,   445,   446,   799,
     447,   448,   449,  1183,   451,   452,   453,   454,   455,   456,
     457,   458,     0,   459,   460,   461,   462,   463,  1184,   464,
     465,   466,   467,   468,   800,   469,   470,  1185,   472,     0,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,  1186,     0,   485,   486,     0,   487,   801,   488,   489,
     490,   491,   492,     0,  1187,  1188,     0,     0,   495,   496,
    1189,   498,  1190,  1191,   500,   501,   502,   503,  4853,   505,
     506,     0,  1192,   507,   508,   509,   510,   511,  1193,     0,
     512,   513,   514,   515,   516,   517,  1194,     0,   519,   802,
     520,   521,   522,   523,     0,     0,   524,     0,     0,   525,
     526,   527,   528,   529,   530,   531,  1195,  1196,  1197,  1198,
    1199,  1200,  1201,  1202,   540,   541,   542,  1203,     0,     0,
       0,     0,     0,     0,  1204,  1205,     0,     0,     0,     0,
       0,     0,     0,  1207,   779,  1137,   600,  1138,  1139,  1140,
     654,  1141,     0,     0,     0,     0,     0,     0,     0,   223,
     224,   225,   226,   227,   228,   229,   230,     0,   232,   233,
     234,     0,     0,     0,     0,  1142,     0,     0,   235,   236,
       0,   237,   238,   780,   239,   240,   241,   242,  1143,   781,
    1144,  1145,     0,   246,   247,   248,   249,   250,  1146,  1147,
     251,   252,  1148,  1149,   255,     0,   256,   257,   258,   259,
    1150,     0,  1151,     0,   261,   262,   263,   264,   783,   265,
     266,   267,     0,   268,   269,   270,   271,   272,   273,     0,
     784,   274,   275,   276,  1152,  1153,  1154,  1155,  1156,  1157,
    1158,   277,   278,   279,   280,   281,   282,  1159,  1160,   285,
       0,   286,     0,   287,   288,   289,   290,   291,   292,     0,
     293,   294,   295,     0,     0,   296,   297,  1000,   299,   300,
       0,   301,   302,   303,     0,   304,   305,   306,     0,   307,
     308,   309,   310,  1161,   312,   313,   314,  1162,  1163,   316,
       0,   317,   318,  1164,   320,     0,   321,     0,   322,   786,
       0,   787,   323,   324,   325,     0,   326,  1165,     0,  1166,
     329,     0,   330,   331,   332,   333,   334,   788,   335,   336,
     337,   338,     0,   339,   340,   341,   342,   343,   344,     0,
     345,   789,   346,   347,   348,   349,   350,  1167,  1168,     0,
    1169,     0,   354,   790,   791,   355,   792,   356,   357,   358,
     359,   360,     0,     0,   361,  1170,   793,   363,   794,     0,
     364,   365,   366,  1171,  1172,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,  1173,   795,  1174,   385,   386,   387,     0,   388,   389,
     796,   390,  1176,  1177,   392,  1178,   394,   395,   396,     0,
     397,     0,     0,  1179,   399,   400,     0,     0,   401,   402,
     797,   403,   798,  1180,   405,   406,   407,   408,   409,   410,
     411,   412,     0,   413,   414,  1181,   416,   417,   418,   419,
     420,     0,   421,   422,   423,   424,   425,   426,   427,   428,
    1182,   430,   431,   432,   433,     0,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,     0,   445,   446,
     799,   447,   448,   449,  2538,   451,   452,   453,   454,   455,
     456,   457,   458,     0,   459,   460,   461,   462,   463,  1184,
     464,   465,   466,   467,   468,   800,   469,   470,  1185,   472,
       0,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,  1186,     0,   485,   486,     0,   487,   801,   488,
     489,   490,   491,   492,     0,  1187,  1188,     0,     0,   495,
     496,  1189,   498,  1190,  1191,   500,   501,   502,   503,   504,
     505,   506,     0,     0,   507,   508,   509,   510,   511,  1193,
       0,   512,   513,   514,   515,   516,   517,  1194,     0,   519,
     802,   520,   521,   522,   523,     0,     0,   524,     0,     0,
     525,   526,   527,   528,   529,   530,   531,  1195,  1196,  1197,
    1198,  1199,  1200,  1201,  1202,   540,   541,   542,     0,     0,
       0,     0,     0,     0,     0,  2539,  2540,     0,     0,     0,
       0,     0,     0,     0,  2541,   779,  1137,   600,  1138,  1139,
    1140,   654,  1141,     0,     0,     0,     0,     0,     0,     0,
     223,   224,   225,   226,   227,   228,   229,   230,     0,   232,
     233,   234,     0,     0,     0,     0,  1142,     0,     0,   235,
     236,     0,   237,   238,   780,   239,   240,   241, -2417,  1143,
     781,  1144,  1145,     0,   246,   247,   248,   249,   250,  1146,
    1147,   251,   252,  1148,  1149,   255,     0,   256,   257,   258,
     259,  1150,     0,  1151,     0,   261,   262,   263,   264,   783,
     265,   266,   267,     0,   268,   269,   270,   271,   272,   273,
       0,   784,   274,   275,  4852,  1152,  1153,  1154,  1155,  1156,
    1157,  1158,   277,   278,   279,   280,   281,   282,  1159,  1160,
     285,     0,   286,     0,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,     0,     0,   296,   297,  1000,   299,
     300,     0,   301,   302,   303,     0,   304,   305,   306,     0,
     307,   308,   309,   310,  1161,   312,   313,   314,  1162,  1163,
     316,     0,   317,   318,  1164,   320,     0,   321,     0,   322,
     786,     0,   787,   323,   324,   325,     0,   326,  1165,     0,
    1166,   329,     0,   330,   331,   332,   333,   334, -2417,   335,
     336,   337,   338,     0,   339,   340,   341,   342,   343,   344,
       0,   345,   789,   346,   347,   348,   349,   350,  1167,  1168,
       0,  1169,     0,   354,     0,     0,   355,   792,   356,   357,
     358,   359,   360,     0,     0,   361,  1170,   793,   363, -2417,
       0,   364,   365,   366,  1171,  1172,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,  1173,   795,  1174,   385,   386,   387,  1175,   388,
     389,     0,   390,  1176,  1177,   392,  1178,   394,   395,   396,
       0,   397,     0,     0,  1179,   399,   400,     0,     0,   401,
     402,   797,   403,   798,  1180,   405,   406,   407,   408,   409,
     410,   411,   412,     0,   413,   414,  1181,   416,   417,   418,
     419,   420,     0,   421,   422,   423,   424,   425,   426,   427,
     428,  1182,   430,   431,   432,   433,     0,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,     0,   445,
     446,   799,   447,   448,   449,  1183,   451,   452,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,   462,   463,
    1184,   464,   465,   466,   467,   468, -2417,   469,   470,  1185,
     472,     0,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,  1186,     0,   485,   486,     0,   487,   801,
     488,   489,   490,   491,   492,     0,  1187,  1188,     0,     0,
     495,   496,  1189,   498,  1190,  1191,   500,   501,   502,   503,
    4853,   505,   506,     0,  1192,   507,   508,   509,   510,   511,
    1193,     0,   512,   513,   514,   515,   516,   517,  1194,     0,
     519,   802,   520,   521,   522,   523,     0,     0,   524,     0,
       0,   525,   526,   527,   528,   529,   530,   531,  1195,  1196,
    1197,  1198,  1199,  1200,  1201,  1202,   540,   541,   542, -2417,
       0,     0,     0,     0,     0,     0,  1204,  1205,     0,     0,
       0,     0,     0,     0,     0,  1207,   779,  1137,   600,  1138,
    1139,  1140,   654,  1141,     0,     0,     0,     0,     0,     0,
       0,   223,   224,   225,   226,   227,   228,   229,   230,     0,
     232,   233,   234,     0,     0,     0,     0,  1142,     0,     0,
     235,   236,     0,   237,   238,   780,   239,   240,   241,   242,
    1143,   781,  1144,  1145,     0,   246,   247,   248,   249,   250,
    1146,  1147,   251,   252,  1148,  1149,   255,     0,   256,   257,
     258,   259,  1150,     0,  1151,     0,   261,   262,   263,   264,
     783,   265,   266,   267,     0,   268,   269,   270,   271,   272,
     273,     0,   784,   274,   275,   276,  1152,  1153,  1154,  1155,
    1156,  1157,  1158,   277,   278,   279,   280,   281,   282,  1159,
    1160,   285,     0,   286,     0,   287,   288,   289,   290,   291,
     292,     0,   293,   294,   295,     0,     0,   296,   297,  1000,
     299,   300,     0,   301,   302,   303,     0,   304,   305,   306,
       0,   307,   308,   309,   310,  1161,   312,   313,   314,  1162,
    1163,   316,     0,   317,   318,  1164,   320,     0,   321,     0,
     322,   786,     0,   787,   323,   324,   325,     0,   326,  1165,
       0,  1166,   329,     0,   330,   331,   332,   333,   334,   788,
     335,   336,   337,   338,     0,   339,   340,   341,   342,   343,
     344,     0,   345,   789,   346,   347,   348,   349,   350,  1167,
    1168,     0,  1169,     0,   354,     0,   791,   355,   792,   356,
     357,   358,   359,   360,     0,     0,   361,  1170,   793,   363,
     794,     0,   364,   365,   366,  1171,  1172,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,  1173,   795,  1174,   385,   386,   387,     0,
     388,   389,   796,   390,  1176,  1177,   392,  1178,   394,   395,
     396,     0,   397,     0,     0,  1179,   399,   400,     0,     0,
     401,   402,   797,   403,   798,  1180,   405,   406,   407,   408,
     409,   410,   411,   412,     0,   413,   414,  1181,   416,   417,
     418,   419,   420,     0,   421,   422,   423,   424,   425,   426,
     427,   428,  1182,   430,   431,   432,   433,     0,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,     0,
     445,   446,   799,   447,   448,   449,  2538,   451,   452,   453,
     454,   455,   456,   457,   458,     0,   459,   460,   461,   462,
     463,  1184,   464,   465,   466,   467,   468,   800,   469,   470,
    1185,   472,     0,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,  1186,     0,   485,   486,     0,   487,
     801,   488,   489,   490,   491,   492,     0,  1187,  1188,     0,
       0,   495,   496,  1189,   498,  1190,  1191,   500,   501,   502,
     503,   504,   505,   506,     0,     0,   507,   508,   509,   510,
     511,  1193,     0,   512,   513,   514,   515,   516,   517,  1194,
       0,   519,   802,   520,   521,   522,   523,     0,     0,   524,
       0,     0,   525,   526,   527,   528,   529,   530,   531,  1195,
    1196,  1197,  1198,  1199,  1200,  1201,  1202,   540,   541,   542,
       0,     0,     0,     0,     0,     0,     0,  2539,  2540,     0,
       0,   779,  1137,   600,  1138,  1139,  2541,   654,  1141,     0,
       0,     0,     0,     0,     0,     0,   223,   224,   225,   226,
     227,   228,   229,   230,     0,   232,   233,   234,     0,     0,
       0,     0,  1142,     0,     0,   235,   236,     0,   237,   238,
     780,   239,   240,   241,   242,  1143,   781,  1144,  1145,     0,
     246,   247,   248,   249,   250,  1146,  1147,   251,   252,  1148,
    1149,   255,     0,   256,   257,   258,   259,  1150,     0,  1151,
       0,   261,   262,   263,   264,   783,   265,   266,   267,     0,
     268,   269,   270,   271,   272,   273,     0,   784,   274,   275,
     276,  1152,  1153,  1154,  1155,  1156,  1157,  1158,   277,   278,
     279,   280,   281,   282,  1159,  1160,   285,     0,   286,     0,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
       0,     0,   296,   297,  1000,   299,   300,     0,   301,   302,
     303,     0,   304,   305,   306,     0,   307,   308,   309,   310,
    1161,   312,   313,   314,  1162,  1163,   316,     0,   317,   318,
    1164,   320,     0,   321,     0,   322,   786,     0,   787,   323,
     324,   325,     0,   326,  1165,     0,  1166,   329,     0,   330,
     331,   332,   333,   334,   788,   335,   336,   337,   338,     0,
     339,   340,   341,   342,   343,   344,     0,   345,   789,   346,
     347,   348,   349,   350,  1167,  1168,     0,  1169,     0,   354,
     790,   791,   355,   792,   356,   357,   358,   359,   360,     0,
       0,   361,  1170,   793,   363,   794,     0,   364,   365,   366,
    1171,  1172,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,  1173,   795,
    1174,   385,   386,   387,     0,   388,   389,   796,   390,  1176,
    1177,   392,  1178,   394,   395,   396,     0,   397,     0,     0,
     398,   399,   400,     0,     0,   401,   402,   797,   403,   798,
    1180,   405,   406,   407,   408,   409,   410,   411,   412,     0,
     413,   414,  1181,   416,   417,   418,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,  1182,   430,   431,
     432,   433,     0,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,     0,   445,   446,   799,   447,   448,
     449,  2538,   451,   452,   453,   454,   455,   456,   457,   458,
       0,   459,   460,   461,   462,   463,  1184,   464,   465,   466,
     467,   468,   800,   469,   470,  1185,   472,     0,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,  1186,
       0,   485,   486,     0,   487,   801,   488,   489,   490,   491,
     492,     0,  1187,  1188,     0,     0,   495,   496,  1189,   498,
    1190,  1191,   500,   501,   502,   503,   504,   505,   506,     0,
       0,   507,   508,   509,   510,   511,  1193,     0,   512,   513,
     514,   515,   516,   517,  1194,     0,   519,   802,   520,   521,
     522,   523,     0,     0,   524,     0,     0,   525,   526,   527,
     528,   529,   530,   531,  1195,  1196,  1197,  1198,  1199,  1200,
    1201,  1202,   540,   541,   542,     0,     0,   779,  1137,   600,
    1138,  1139,     0,   654,  1141,     0,     0,     0,     0,     0,
       0,  2541,   223,   224,   225,   226,   227,   228,   229,   230,
       0,   232,   233,   234,     0,     0,     0,     0,  1142,     0,
       0,   235,   236,     0,   237,   238,   780,   239,   240,   241,
     242,  1143,   781,  1144,  1145,     0,  3775,   247,   248,   249,
     250,  1146,  1147,   251,   252,  1148,  1149,   255,     0,   256,
     257,   258,   259,  1150,     0,  1151,     0,   261,   262,   263,
     264,   783,   265,   266,   267,     0,   268,   269,   270,   271,
     272,   273,     0,   784,   274,   275,   276,  1152,  1153,  1154,
    1155,  1156,  1157,  1158,   277,   278,   279,   280,   281,   282,
    1159,  1160,   285,     0,   286,     0,   287,   288,   289,   290,
     291,   292,     0,   293,   294,   295,     0,     0,   296,   297,
    1000,   299,   300,     0,   301,   302,   303,     0,   304,   305,
     306,     0,   307,   308,   309,   310,  1161,   312,   313,   314,
    1162,  1163,   316,     0,   317,   318,  1164,   320,     0,   321,
       0,   322,   786,     0,   787,   323,   324,   325,     0,   326,
    1165,     0,  1166,   329,     0,   330,   331,   332,   333,   334,
     788,   335,   336,   337,   338,     0,   339,   340,   341,   342,
     343,   344,     0,   345,   789,   346,   347,   348,   349,   350,
    1167,  1168,     0,  1169,     0,   354,   790,   791,   355,   792,
     356,   357,   358,   359,   360,     0,     0,   361,  1170,   793,
     363,   794,     0,   364,   365,   366,  1171,  1172,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,  1173,   795,  1174,   385,   386,   387,
       0,   388,   389,   796,   390,  1176,  1177,   392,  1178,   394,
     395,   396,     0,   397,     0,     0,   398,   399,   400,     0,
       0,   401,   402,   797,   403,   798,  1180,   405,   406,   407,
     408,   409,   410,   411,   412,     0,   413,   414,  1181,   416,
     417,   418,   419,   420,     0,   421,   422,   423,   424,   425,
     426,   427,   428,  1182,   430,   431,   432,   433,     0,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
       0,   445,   446,   799,   447,   448,   449,  2538,   451,   452,
     453,   454,   455,   456,   457,   458,     0,   459,   460,   461,
     462,   463,  1184,   464,   465,   466,   467,   468,   800,   469,
     470,  1185,   472,     0,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,  1186,     0,   485,   486,     0,
     487,   801,   488,   489,   490,   491,   492,     0,  1187,  1188,
       0,     0,   495,   496,  1189,   498,  1190,  1191,   500,   501,
     502,   503,   504,   505,   506,     0,     0,   507,   508,   509,
     510,   511,  1193,     0,   512,   513,   514,   515,   516,   517,
    1194,     0,   519,   802,   520,   521,   522,   523,     0,     0,
     524,     0,     0,   525,   526,   527,   528,   529,   530,   531,
    1195,  1196,  1197,  1198,  1199,  1200,  1201,  1202,   540,   541,
     542,     0,     0,   779,  1137,   600,  1138,  1139,  1140,   654,
    1141,     0,     0,     0,     0,     0,     0,  2541,   223,   224,
     225,   226,   227,   228,   229,   230,     0,   232,   233,   234,
       0,     0,     0,     0,  1142,     0,     0,   235,   236,     0,
     237,   238,   780,   239,   240,   241,     0,  1143,   781,  1144,
    1145,     0,   246,   247,   248,   249,   250,  1146,  1147,   251,
     252,  1148,  1149,   255,     0,   256,   257,   258,   259,  1150,
       0,  1151,     0,   261,   262,   263,   264,   783,   265,   266,
     267,     0,   268,   269,   270,   271,   272,   273,     0,   784,
     274,   275,   276,  1152,  1153,  1154,  1155,  1156,  1157,  1158,
     277,   278,   279,   280,   281,   282,  1159,  1160,   285,     0,
     286,     0,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,     0,     0,   296,   297,  1000,   299,   300,     0,
     301,   302,   303,     0,   304,     0,   306,     0,   307,   308,
     309,   310,  1161,   312,   313,   314,  1162,  1163,   316,     0,
     317,   318,  1164,   320,     0,   321,     0,   322,   786,     0,
     787,   323,   324,   325,     0,   326,  1165,     0,  1166,   329,
       0,   330,   331,   332,   333,   334,     0,   335,   336,   337,
     338,     0,   339,   340,   341,   342,   343,   344,     0,   345,
     789,   346,   347,   348,   349,   350,  1167,  1168,     0,  1169,
       0,   354,     0,     0,   355,   792,   356,   357,   358,   359,
     360,     0,     0,   361,  1170,   793,   363,     0,     0,   364,
     365,   366,  1171,  1172,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
    1173,   795,  1174,   385,   386,   387,  1175,   388,   389,     0,
     390,  1176,  1177,   392,  1178,   394,   395,   396,     0,   397,
       0,     0,  1179,   399,   400,     0,     0,   401,   402,   797,
     403,   798,  1180,   405,   406,   407,   408,   409,   410,   411,
     412,     0,   413,   414,  1181,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,  1182,
     430,   431,   432,   433,     0,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,     0,   445,   446,   799,
     447,   448,   449,  1183,   451,   452,   453,   454,   455,   456,
     457,   458,     0,   459,   460,   461,   462,   463,  1184,   464,
     465,   466,   467,   468,     0,   469,   470,  1185,   472,     0,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,  1186,     0,   485,   486,     0,   487,   801,   488,   489,
     490,   491,   492,     0,  1187,  1188,     0,     0,   495,   496,
    1189,   498,  1190,  1191,   500,   501,   502,   503,   504,   505,
     506,     0,  1192,   507,   508,   509,   510,   511,  1193,     0,
     512,   513,   514,   515,   516,   517,  1194,     0,   519,   802,
     520,   521,   522,   523,     0,     0,   524,     0,     0,   525,
     526,   527,   528,   529,   530,   531,  1195,  1196,  1197,  1198,
    1199,  1200,  1201,  1202,   540,   541,   542,     0,     0,   779,
       0,     0,     0,     0,  1204,  1205,     0,     0,     0,     0,
       0,     0,     0,  1207,   223,   224,   225,   226,   227,   228,
     229,   230,     0,   232,   233,   234,     0,     0,     0,     0,
       0,     0,     0,   235,   236,     0,   237,   238,   780,   239,
     240,   241,   242,   243,   781,   244,   245,     0,   246,   247,
     248,   249,   250,     0,  1147,   251,   252,   253,   254,   255,
       0,   256,   257,   258,   259,  1150,     0,  1151,     0,   261,
     262,   263,   264,   783,   265,   266,   267,     0,   268,   269,
     270,   271,   272,   273,     0,   784,   274,   275,   276,  1152,
    1153,  1154,  1155,  1156,  1157,  1158,   277,   278,   279,   280,
     281,   282,   283,   284,   285,     0,   286,     0,   287,   288,
     289,   290,   291,   292,     0,   293,   294,   295,     0,     0,
     296,   297,   298,   299,   300,     0,   301,   302,   303,     0,
     304,   305,   306,     0,   307,   308,   309,   310,   311,   312,
     313,   314,  1162,     0,   316,     0,   317,   318,   319,   320,
       0,   321,     0,   322,   786,     0,   787,   323,   324,   325,
       0,   326,  1165,     0,   328,   329,     0,   330,   331,   332,
     333,   334,   788,   335,   336,   337,   338,     0,   339,   340,
     341,   342,   343,   344,     0,   345,   789,   346,   347,   348,
     349,   350,   351,   352,     0,   353,     0,   354,   790,   791,
     355,   792,   356,   357,   358,   359,   360,  3296,     0,   361,
    1170,   793,   363,   794,     0,   364,   365,   366,  1171,  1172,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   795,   384,   385,
     386,   387,     0,   388,   389,   796,   390,     0,  1177,   392,
     393,   394,   395,   396,     0,   397,     0,   743,   398,   399,
     400,     0,     0,   401,   402,   797,   403,   798,  1180,   405,
     406,   407,   408,   409,   410,   411,   412,     0,   413,   414,
    1181,   416,   417,   418,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
       0,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,     0,   445,   446,   799,   447,   448,   449,   450,
    3297,   452,   453,   454,   455,   456,   457,   458,    39,   459,
     460,   461,   462,   463,  1184,   464,   465,   466,   467,   468,
     800,   469,   470,   471,   472,     0,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,  1186,     0,   485,
     486,    43,   487,   801,   488,   489,   490,   491,   492,     0,
     493,   494,     0,     0,   495,   496,  1189,   498,  1190,     0,
     500,   501,   502,   503,   504,   505,   506,     0,     0,   507,
     508,   509,   510,   511,  1193,     0,   512,   513,   514,   515,
     516,  1073,   518,     0,   519,   802,   520,   521,   522,   523,
       0,     0,   524,     0,    48,   525,   526,   527,   528,   529,
     530,   531,  1195,  1196,  1197,  1198,  1199,  1200,  1201,  1202,
     540,   541,   542,     0,     0,    49,   779,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3298,
       0,   223,   224,   225,   226,   227,   228,   229,   230,     0,
     232,   233,   234,     0,     0,     0,     0,     0,     0,     0,
     235,   236,     0,   237,   238,   780,   239,   240,   241,   242,
     243,   781,   244,   245,     0,   246,   247,   248,   249,   250,
       0,  1147,   251,   252,   253,   254,   255,     0,   256,   257,
     258,   259,  1150,     0,  1151,     0,   261,   262,   263,   264,
     783,   265,   266,   267,     0,   268,   269,   270,   271,   272,
     273,     0,   784,   274,   275,   276,  1152,  1153,  1154,  1155,
    1156,  1157,  1158,   277,   278,   279,   280,   281,   282,   283,
     284,   285,     0,   286,     0,   287,   288,   289,   290,   291,
     292,     0,   293,   294,   295,     0,     0,   296,   297,   298,
     299,   300,     0,   301,   302,   303,     0,   304,   305,   306,
       0,   307,   308,   309,   310,   311,   312,   313,   314,  1162,
       0,   316,     0,   317,   318,   319,   320,     0,   321,     0,
     322,   786,     0,   787,   323,   324,   325,     0,   326,  1165,
       0,   328,   329,     0,   330,   331,   332,   333,   334,   788,
     335,   336,   337,   338,     0,   339,   340,   341,   342,   343,
     344,     0,   345,   789,   346,   347,   348,   349,   350,   351,
     352,     0,   353,     0,   354,   790,   791,   355,   792,   356,
     357,   358,   359,   360,  3296,     0,   361,  1170,   793,   363,
     794,     0,   364,   365,   366,  1171,  1172,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   795,   384,   385,   386,   387,     0,
     388,   389,   796,   390,     0,  1177,   392,   393,   394,   395,
     396,     0,   397,     0,   743,   398,   399,   400,     0,     0,
     401,   402,   797,   403,   798,  1180,   405,   406,   407,   408,
     409,   410,   411,   412,     0,   413,   414,  1181,   416,   417,
     418,   419,   420,     0,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,     0,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,     0,
     445,   446,   799,   447,   448,   449,   450,  3297,   452,   453,
     454,   455,   456,   457,   458,     0,   459,   460,   461,   462,
     463,  1184,   464,   465,   466,   467,   468,   800,   469,   470,
     471,   472,     0,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,  1186,     0,   485,   486,     0,   487,
     801,   488,   489,   490,   491,   492,     0,   493,   494,     0,
       0,   495,   496,  1189,   498,  1190,     0,   500,   501,   502,
     503,   504,   505,   506,     0,     0,   507,   508,   509,   510,
     511,  1193,     0,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   802,   520,   521,   522,   523,     0,     0,   524,
       0,     0,   525,   526,   527,   528,   529,   530,   531,  1195,
    1196,  1197,  1198,  1199,  1200,  1201,  1202,   540,   541,   542,
       0,     0,   779,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3298,   223,   224,   225,
     226,   227,   228,   229,   230,     0,   232,   233,   234,     0,
       0,     0,     0,     0,     0,     0,   235,   236,     0,   237,
     238,   780,   239,   240,   241,   242,   243,   781,   244,   245,
       0,   246,   247,   248,   249,   250,     0,  1147,   251,   252,
     253,   254,   255,     0,   256,   257,   258,   259,  1150,     0,
    1151,     0,   261,   262,   263,   264,   783,   265,   266,   267,
       0,   268,   269,   270,   271,   272,   273,     0,   784,   274,
     275,   276,  1152,  1153,  1154,  1155,  1156,  1157,  1158,   277,
     278,   279,   280,   281,   282,   283,   284,   285,     0,   286,
       0,   287,   288,   289,   290,   291,   292,     0,   293,   294,
     295,     0,     0,   296,   297,   298,   299,   300,     0,   301,
     302,   303,     0,   304,   305,   306,     0,   307,   308,   309,
     310,   311,   312,   313,   314,  1162,     0,   316,     0,   317,
     318,   319,   320,     0,   321,     0,   322,   786,     0,   787,
     323,   324,   325,     0,   326,  1165,     0,   328,   329,     0,
     330,   331,   332,   333,   334,   788,   335,   336,   337,   338,
       0,   339,   340,   341,   342,   343,   344,     0,   345,   789,
     346,   347,   348,   349,   350,   351,   352,     0,   353,     0,
     354,   790,   791,   355,   792,   356,   357,   358,   359,   360,
       0,     0,   361,  1170,   793,   363,   794,     0,   364,   365,
     366,  1171,  1172,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     795,   384,   385,   386,   387,     0,   388,   389,   796,   390,
       0,  1177,   392,   393,   394,   395,   396,     0,   397,     0,
       0,   398,   399,   400,     0,     0,   401,   402,   797,   403,
     798,  1180,   405,   406,   407,   408,   409,   410,   411,   412,
       0,   413,   414,  1181,   416,   417,   418,   419,   420,     0,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,     0,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,     0,   445,   446,   799,   447,
     448,   449,   450,  3297,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,   462,   463,  1184,   464,   465,
     466,   467,   468,   800,   469,   470,   471,   472,     0,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
    1186,     0,   485,   486,     0,   487,   801,   488,   489,   490,
     491,   492,     0,   493,   494,     0,     0,   495,   496,  1189,
     498,  1190,     0,   500,   501,   502,   503,   504,   505,   506,
       0,     0,   507,   508,   509,   510,   511,  1193,     0,   512,
     513,   514,   515,   516,   517,   518,     0,   519,   802,   520,
     521,   522,   523,     0,     0,   524,     0,     0,   525,   526,
     527,   528,   529,   530,   531,  1195,  1196,  1197,  1198,  1199,
    1200,  1201,  1202,   540,   541,   542,     0,     0,   779,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    50,   223,   224,   225,   226,   227,   228,   229,
     230,     0,   232,   233,   234,     0,     0,     0,     0,     0,
       0,     0,   235,   236,     0,   237,   238,   780,   239,   240,
     241,   242,   243,   781,   244,   245,     0,   246,   247,   248,
     249,   250,     0,  1147,   251,   252,   253,   254,   255,     0,
     256,   257,   258,   259,  1150,     0,  1151,     0,   261,   262,
     263,   264,   783,   265,   266,   267,     0,   268,   269,   270,
     271,   272,   273,     0,   784,   274,   275,   276,  1152,  1153,
    1154,  1155,  1156,  1157,  1158,   277,   278,   279,   280,   281,
     282,   283,   284,   285,     0,   286,     0,   287,   288,   289,
     290,   291,   292,     0,   293,   294,   295,     0,     0,   296,
     297,   298,   299,   300,     0,   301,   302,   303,     0,   304,
     305,   306,     0,   307,   308,   309,   310,   311,   312,   313,
     314,  1162,     0,   316,     0,   317,   318,   319,   320,     0,
     321,     0,   322,   786,     0,   787,   323,   324,   325,     0,
     326,  1165,     0,   328,   329,     0,   330,   331,   332,   333,
     334,   788,   335,   336,   337,   338,     0,   339,   340,   341,
     342,   343,   344,     0,   345,   789,   346,   347,   348,   349,
     350,   351,   352,     0,   353,     0,   354,   790,   791,   355,
     792,   356,   357,   358,   359,   360,     0,     0,   361,  1170,
     793,   363,   794,     0,   364,   365,   366,  1171,  1172,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   795,   384,   385,   386,
     387,     0,   388,   389,   796,   390,     0,  1177,   392,   393,
     394,   395,   396,     0,   397,     0,     0,   398,   399,   400,
       0,     0,   401,   402,   797,   403,   798,  1180,   405,   406,
     407,   408,   409,   410,   411,   412,     0,   413,   414,  1181,
     416,   417,   418,   419,   420,     0,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,     0,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,     0,   445,   446,   799,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,     0,   459,   460,
     461,   462,   463,  1184,   464,   465,   466,   467,   468,   800,
     469,   470,   471,   472,     0,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,  1186,     0,   485,   486,
       0,   487,   801,   488,   489,   490,   491,   492,     0,   493,
     494,     0,     0,   495,   496,  1189,   498,  1190,     0,   500,
     501,   502,   503,   504,   505,   506,     0,     0,   507,   508,
     509,   510,   511,  1193,     0,   512,   513,   514,   515,   516,
     517,   518,     0,   519,   802,   520,   521,   522,   523,     0,
       0,   524,     0,     0,   525,   526,   527,   528,   529,   530,
     531,  1195,  1196,  1197,  1198,  1199,  1200,  1201,  1202,   540,
     541,   542,     0,     0,   823,  1411,   600,     0,     0,     0,
     654,     0,     0,     0,     0,     0,     0,     0,  3899,   223,
     224,   225,   226,   227,   228,   229,   230,     0,   232,   233,
     234,     0,     0,     0,     0,     0,     0,     0,   235,   236,
       0,   237,   238,   780,   239,   240,   241,   242,   243,   781,
     244,   245,     0,   246,   247,   248,   249,   250,     0,     0,
     251,   252,   253,   254,   255,     0,   256,   257,   258,   259,
     260,     0,   782,     0,   261,   262,   263,   264,   783,   265,
     266,   267,     0,   268,   269,   270,   271,   272,   273,     0,
     784,   274,   275,   276,     0,     0,     0,   785,     0,     0,
       0,   277,   278,   279,   280,   281,   282,   283,   284,   285,
       0,   286,     0,   287,   288,   289,   290,   291,   292,     0,
     293,   294,   295,     0,     0,   296,   297,   298,   299,   300,
       0,   301,   302,   303,     0,   304,   305,   306,     0,   307,
     308,   309,   310,   311,   312,   313,   314,   315,  1681,   316,
       0,   317,   318,   319,   320,     0,   321,     0,   322,   786,
       0,   787,   323,   324,   325,     0,   326,   327,     0,   328,
     329,     0,   330,   331,   332,   333,   334,   788,   335,   336,
     337,   338,     0,   339,   340,   341,   342,   343,   344,     0,
     345,   789,   346,   347,   348,   349,   350,   351,   352,     0,
     353,     0,   354,   790,   791,   355,   792,   356,   357,   358,
     359,   360,     0,     0,   361,   362,   793,   363,   794,     0,
     364,   365,   366,     0,     0,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   795,   384,   385,   386,   387,     0,   388,   389,
     796,   390,     0,   391,   392,   393,   394,   395,   396,     0,
     397,  1682,     0,   398,   399,   400,     0,     0,   401,   402,
     797,   403,   798,   404,   405,   406,   407,   408,   409,   410,
     411,   412,     0,   413,   414,   415,   416,   417,   418,   419,
     420,     0,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,     0,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,     0,   445,   446,
     799,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,     0,   459,   460,   461,   462,   463,     0,
     464,   465,   466,   467,   468,   800,   469,   470,   471,   472,
       0,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,     0,   485,   486,     0,   487,   801,   488,
     489,   490,   491,   492,     0,   493,   494,     0,     0,   495,
     496,   497,   498,   499,  1683,   500,   501,   502,   503,   504,
     505,   506,     0,     0,   507,   508,   509,   510,   511,     0,
       0,   512,   513,   514,   515,   516,   517,   518,     0,   519,
     802,   520,   521,   522,   523,     0,     0,   524,     0,     0,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,     0,     0,
     823,     0,     0,     0,     0,   666,  1412,  4696,     0,     0,
       0,     0,     0,     0,  4697,   223,   224,   225,   226,   227,
     228,   229,   230,     0,   232,   233,   234,     3,     4,     0,
       0,     0,     0,     0,   235,   236,     0,   237,   238,   780,
     239,   240,   241,   242,   243,   781,   244,   245,     0,   246,
     247,   248,   249,   250,     0,     0,   251,   252,   253,   254,
     255,     0,   256,   257,   258,   259,   260,     0,   782,     0,
     261,   262,   263,   264,   783,   265,   266,   267,     0,   268,
     269,   270,   271,   272,   273,     0,   784,   274,   275,   276,
       0,     0,     0,   785,     0,     0,     0,   277,   278,   279,
     280,   281,   282,   283,   284,   285,     0,   286,     0,   287,
     288,   289,   290,   291,   292,     0,   293,   294,   295,     0,
       0,   296,   297,   298,   299,   300,     0,   301,   302,   303,
       0,   304,   305,   306,     0,   307,   308,   309,   310,   311,
     312,   313,   314,   315,     0,   316,     0,   317,   318,   319,
     320,     0,   321,     0,   322,   786,     0,   787,   323,   324,
     325,     0,   326,   327,     0,   328,   329,     0,   330,   331,
     332,   333,   334,   788,   335,   336,   337,   338,     0,   339,
     340,   341,   342,   343,   344,     0,   345,   789,   346,   347,
     348,   349,   350,   351,   352,     0,   353,     0,   354,   790,
     791,   355,   792,   356,   357,   358,   359,   360,     0,     0,
     361,   362,   793,   363,   794,     0,   364,   365,   366,     0,
       0,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   795,   384,
     385,   386,   387,     0,   388,   389,   796,   390,     0,   391,
     392,   393,   394,   395,   396,     0,   397,     0,     0,   398,
     399,   400,     0,     0,   401,   402,   797,   403,   798,   404,
     405,   406,   407,   408,   409,   410,   411,   412,     0,   413,
     414,   415,   416,   417,   418,   419,   420,     0,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,     0,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,     0,   445,   446,   799,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,    39,
     459,   460,   461,   462,   463,     0,   464,   465,   466,   467,
     468,   800,   469,   470,   471,   472,     0,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,     0,
     485,   486,    43,   487,   801,   488,   489,   490,   491,   492,
       0,   493,   494,     0,     0,   495,   496,   497,   498,   499,
       0,   500,   501,   502,   503,   504,   505,   506,     0,     0,
     507,   508,   509,   510,   511,     0,     0,   512,   513,   514,
     515,   516,  1073,   518,     0,   519,   802,   520,   521,   522,
     523,     0,     0,   524,     0,    48,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,     0,     0,    49,   779,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      50,     0,   223,   224,   225,   226,   227,   228,   229,   230,
       0,   232,   233,   234,     0,     0,     0,     0,     0,     0,
       0,   235,   236,     0,   237,   238,   780,   239,   240,   241,
     242,   243,   781,   244,   245,     0,   246,   247,   248,   249,
     250,     0,     0,   251,   252,   253,   254,   255,     0,   256,
     257,   258,   259,   260,     0,   782,     0,   261,   262,   263,
     264,   783,   265,   266,   267,     0,   268,   269,   270,   271,
     272,   273,     0,   784,   274,   275,   276,     0,     0,     0,
     785,     0,     0,     0,   277,   278,   279,   280,   281,   282,
     283,   284,   285,     0,   286,     0,   287,   288,   289,   290,
     291,   292,     0,   293,   294,   295,     0,     0,   296,   297,
     298,   299,   300,     0,   301,   302,   303,     0,   304,   305,
     306,     0,   307,   308,   309,   310,   311,   312,   313,   314,
     315,     0,   316,     0,   317,   318,   319,   320,     0,   321,
       0,   322,   786,     0,   787,   323,   324,   325,     0,   326,
     327,     0,   328,   329,     0,   330,   331,   332,   333,   334,
     788,   335,   336,   337,   338,     0,   339,   340,   341,   342,
     343,   344,     0,   345,   789,   346,   347,   348,   349,   350,
     351,   352,     0,   353,     0,   354,   790,   791,   355,   792,
     356,   357,   358,   359,   360,     0,     0,   361,   362,   793,
     363,   794,     0,   364,   365,   366,     0,     0,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   795,   384,   385,   386,   387,
       0,   388,   389,   796,   390,     0,   391,   392,   393,   394,
     395,   396,     0,   397,     0,     0,   398,   399,   400,     0,
       0,   401,   402,   797,   403,   798,   404,   405,   406,   407,
     408,   409,   410,   411,   412,     0,   413,   414,   415,   416,
     417,   418,   419,   420,     0,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,     0,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
       0,   445,   446,   799,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,     0,   459,   460,   461,
     462,   463,     0,   464,   465,   466,   467,   468,   800,   469,
     470,   471,   472,     0,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,     0,   485,   486,     0,
     487,   801,   488,   489,   490,   491,   492,     0,   493,   494,
       0,     0,   495,   496,   497,   498,   499,     0,   500,   501,
     502,   503,   504,   505,   506,     0,     0,   507,   508,   509,
     510,   511,     0,     0,   512,   513,   514,   515,   516,   517,
     518,     0,   519,   802,   520,   521,   522,   523,     0,     0,
     524,     0,     0,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,     0,     0,   222,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4513,   223,   224,
     225,   226,   227,   228,   229,   230,     0,   232,   233,   234,
       0,     0,     0,     0,     0,     0,     0,   235,   236,     0,
     237,   238,     0,   239,   240,   241,   242,   243,     0,   244,
     245,     0,   246,   247,   248,   249,   250,     0,     0,   251,
     252,   253,   254,   255,     0,   256,   257,   258,   259,   260,
       0,     0,     0,   261,   262,   263,   264,     0,   265,   266,
     267,     0,   268,   269,   270,   271,   272,   273,     0,     0,
     274,   275,   276,     0,     0,     0,     0,     0,     0,     0,
     277,   278,   279,   280,   281,   282,   283,   284,   285,     0,
     286,     0,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,     0,     0,   296,   297,   298,   299,   300,     0,
     301,   302,   303,     0,   304,   305,   306,     0,   307,   308,
     309,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,   318,   319,   320,     0,   321,     0,   322,     0,     0,
       0,   323,   324,   325,     0,   326,   327,     0,   328,   329,
       0,   330,   331,   332,   333,   334,     0,   335,   336,   337,
     338,     0,   339,   340,   341,   342,   343,   344,     0,   345,
       0,   346,   347,   348,   349,   350,   351,   352,     0,   353,
       0,   354,     0,     0,   355,     0,   356,   357,   358,   359,
     360,     0,     0,   361,   362,     0,   363,     0,     0,   364,
     365,   366,     0,     0,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,     0,   384,   385,   386,   387,     0,   388,   389,     0,
     390,     0,   391,   392,   393,   394,   395,   396,     0,   397,
       0,     0,   398,   399,   400,     0,     0,   401,   402,     0,
     403,     0,   404,   405,   406,   407,   408,   409,   410,   411,
     412,     0,   413,   414,   415,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,     0,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,     0,   445,   446,     0,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,    39,   459,   460,   461,   462,   463,     0,   464,
     465,   466,   467,   468,     0,   469,   470,   471,   472,     0,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,     0,   485,   486,    43,   487,     0,   488,   489,
     490,   491,   492,     0,   493,   494,     0,     0,   495,   496,
     497,   498,   499,     0,   500,   501,   502,   503,   504,   505,
     506,     0,     0,   507,   508,   509,   510,   511,     0,     0,
     512,   513,   514,   515,   516,  1073,   518,     0,   519,     0,
     520,   521,   522,   523,     0,     0,   524,     0,    48,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,     0,     0,    49,
     222,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    50,     0,   223,   224,   225,   226,   227,
     228,   229,   230,     0,   232,   233,   234,     0,     0,     0,
       0,     0,     0,     0,   235,   236,     0,   237,   238,     0,
     239,   240,   241,   242,   243,     0,   244,   245,     0,   246,
     247,   248,   249,   250,     0,     0,   251,   252,   253,   254,
     255,     0,   256,   257,   258,   259,   260,     0,     0,     0,
     261,   262,   263,   264,     0,   265,   266,   267,     0,   268,
     269,   270,   271,   272,   273,     0,     0,   274,   275,   276,
       0,     0,     0,     0,     0,     0,     0,   277,   278,   279,
     280,   281,   282,   283,   284,   285,     0,   286,     0,   287,
     288,   289,   290,   291,   292,     0,   293,   294,   295,     0,
       0,   296,   297,   298,   299,   300,     0,   301,   302,   303,
       0,   304,   305,   306,     0,   307,   308,   309,   310,   311,
     312,   313,   314,   315,     0,   316,     0,   317,   318,   319,
     320,     0,   321,     0,   322,     0,     0,     0,   323,   324,
     325,     0,   326,   327,     0,   328,   329,     0,   330,   331,
     332,   333,   334,     0,   335,   336,   337,   338,     0,   339,
     340,   341,   342,   343,   344,     0,   345,     0,   346,   347,
     348,   349,   350,   351,   352,     0,   353,     0,   354,     0,
       0,   355,     0,   356,   357,   358,   359,   360,     0,     0,
     361,   362,     0,   363,     0,     0,   364,   365,   366,     0,
       0,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,     0,   384,
     385,   386,   387,     0,   388,   389,     0,   390,     0,   391,
     392,   393,   394,   395,   396,     0,   397,     0,     0,   398,
     399,   400,     0,     0,   401,   402,     0,   403,     0,   404,
     405,   406,   407,   408,   409,   410,   411,   412,     0,   413,
     414,   415,   416,   417,   418,   419,   420,     0,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,     0,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,     0,   445,   446,     0,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,     0,
     459,   460,   461,   462,   463,     0,   464,   465,   466,   467,
     468,     0,   469,   470,   471,   472,     0,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,     0,
     485,   486,     0,   487,     0,   488,   489,   490,   491,   492,
       0,   493,   494,     0,     0,   495,   496,   497,   498,   499,
       0,   500,   501,   502,   503,   504,   505,   506,     0,     0,
     507,   508,   509,   510,   511,     0,     0,   512,   513,   514,
     515,   516,   517,   518,     0,   519,     0,   520,   521,   522,
     523,     0,     0,   524,     0,     0,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,     0,     0,   222,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1265,   223,   224,   225,   226,   227,   228,   229,   230,     0,
     232,   233,   234,     0,     0,     0,     0,     0,     0,     0,
     235,   236,     0,   237,   238,     0,   239,   240,   241,   242,
     243,     0,   244,   245,     0,   246,   247,   248,   249,   250,
       0,     0,   251,   252,   253,   254,   255,     0,   256,   257,
     258,   259,   260,     0,     0,     0,   261,   262,   263,   264,
       0,   265,   266,   267,     0,   268,   269,   270,   271,   272,
     273,     0,     0,   274,   275,   276,     0,     0,     0,     0,
       0,     0,     0,   277,   278,   279,   280,   281,   282,   283,
     284,   285,     0,   286,     0,   287,   288,   289,   290,   291,
     292,     0,   293,   294,   295,     0,     0,   296,   297,   298,
     299,   300,     0,   301,   302,   303,     0,   304,   305,   306,
       0,   307,   308,   309,   310,   311,   312,   313,   314,   315,
       0,   316,     0,   317,   318,   319,   320,     0,   321,     0,
     322,     0,     0,     0,   323,   324,   325,     0,   326,   327,
       0,   328,   329,     0,   330,   331,   332,   333,   334,     0,
     335,   336,   337,   338,     0,   339,   340,   341,   342,   343,
     344,     0,   345,     0,   346,   347,   348,   349,   350,   351,
     352,     0,   353,     0,   354,     0,     0,   355,     0,   356,
     357,   358,   359,   360,     0,     0,   361,   362,     0,   363,
       0,     0,   364,   365,   366,     0,     0,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,     0,   384,   385,   386,   387,     0,
     388,   389,     0,   390,     0,   391,   392,   393,   394,   395,
     396,     0,   397,     0,     0,   398,   399,   400,     0,     0,
     401,   402,     0,   403,     0,   404,   405,   406,   407,   408,
     409,   410,   411,   412,     0,   413,   414,   415,   416,   417,
     418,   419,   420,     0,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,     0,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,     0,
     445,   446,     0,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,     0,   459,   460,   461,   462,
     463,     0,   464,   465,   466,   467,   468,     0,   469,   470,
     471,   472,     0,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,     0,   485,   486,     0,   487,
       0,   488,   489,   490,   491,   492,     0,   493,   494,     0,
       0,   495,   496,   497,   498,   499,     0,   500,   501,   502,
     503,   504,   505,   506,     0,     0,   507,   508,   509,   510,
     511,     0,     0,   512,   513,   514,   515,   516,   517,   518,
       0,   519,     0,   520,   521,   522,   523,     0,     0,   524,
       0,     0,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
       0,     0,   222,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2695,   223,   224,   225,
     226,   227,   228,   229,   230,     0,   232,   233,   234,     0,
       0,     0,     0,     0,     0,     0,   235,   236,     0,   237,
     238,     0,   239,   240,   241,   242,   243,     0,   244,   245,
       0,   246,   247,   248,   249,   250,     0,     0,   251,   252,
     253,   254,   255,     0,   256,   257,   258,   259,   260,     0,
       0,     0,   261,   262,   263,   264,     0,   265,   266,   267,
       0,   268,   269,   270,   271,   272,   273,     0,     0,   274,
     275,   276,     0,     0,     0,     0,     0,     0,     0,   277,
     278,   279,   280,   281,   282,   283,   284,   285,     0,   286,
       0,   287,   288,   289,   290,   291,   292,     0,   293,   294,
     295,     0,     0,   296,   297,   298,   299,   300,     0,   301,
     302,   303,     0,   304,   305,   306,     0,   307,   308,   309,
     310,   311,   312,   313,   314,   315,     0,   316,     0,   317,
     318,   319,   320,     0,   321,     0,   322,     0,     0,     0,
     323,   324,   325,     0,   326,   327,     0,   328,   329,     0,
     330,   331,   332,   333,   334,     0,   335,   336,   337,   338,
       0,   339,   340,   341,   342,   343,   344,     0,   345,     0,
     346,   347,   348,   349,   350,   351,   352,     0,   353,     0,
     354,     0,     0,   355,     0,   356,   357,   358,   359,   360,
       0,     0,   361,   362,     0,   363,     0,     0,   364,   365,
     366,     0,     0,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
       0,   384,   385,   386,   387,     0,   388,   389,     0,   390,
       0,   391,   392,   393,   394,   395,   396,     0,   397,     0,
       0,   398,   399,   400,     0,     0,   401,   402,     0,   403,
       0,   404,   405,   406,   407,   408,   409,   410,   411,   412,
       0,   413,   414,   415,   416,   417,   418,   419,   420,     0,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,     0,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,     0,   445,   446,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,   462,   463,     0,   464,   465,
     466,   467,   468,     0,   469,   470,   471,   472,     0,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,     0,   485,   486,     0,   487,     0,   488,   489,   490,
     491,   492,     0,   493,   494,     0,     0,   495,   496,   497,
     498,   499,     0,   500,   501,   502,   503,   504,   505,   506,
       0,     0,   507,   508,   509,   510,   511,     0,     0,   512,
     513,   514,   515,   516,   517,   518,     0,   519,     0,   520,
     521,   522,   523,     0,     0,   524,     0,     0,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,     0,     0,   222,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3810,   223,   224,   225,   226,   227,   228,   229,
     230,     0,   232,   233,   234,     0,     0,     0,     0,     0,
       0,     0,   235,   236,     0,   237,   238,     0,   239,   240,
     241,   242,   243,     0,   244,   245,     0,   246,   247,   248,
     249,   250,     0,     0,   251,   252,   253,   254,   255,     0,
     256,   257,   258,   259,   260,     0,     0,     0,   261,   262,
     263,   264,     0,   265,   266,   267,     0,   268,   269,   270,
     271,   272,   273,     0,     0,   274,   275,   276,     0,     0,
       0,     0,     0,     0,     0,   277,   278,   279,   280,   281,
     282,   283,   284,   285,     0,   286,     0,   287,   288,   289,
     290,   291,   292,     0,   293,   294,   295,     0,     0,   296,
     297,   298,   299,   300,     0,   301,   302,   303,     0,   304,
     305,   306,     0,   307,   308,   309,   310,   311,   312,   313,
     314,   315,     0,   316,     0,   317,   318,   319,   320,     0,
     321,     0,   322,     0,     0,     0,   323,   324,   325,     0,
     326,   327,     0,   328,   329,     0,   330,   331,   332,   333,
     334,     0,   335,   336,   337,   338,     0,   339,   340,   341,
     342,   343,   344,     0,   345,     0,   346,   347,   348,   349,
     350,   351,   352,     0,   353,     0,   354,     0,     0,   355,
       0,   356,   357,   358,   359,   360,     0,     0,   361,   362,
       0,   363,     0,     0,   364,   365,   366,     0,     0,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,     0,   384,   385,   386,
     387,     0,   388,   389,     0,   390,     0,   391,   392,   393,
     394,   395,   396,     0,   397,     0,     0,   398,   399,   400,
       0,     0,   401,   402,     0,   403,     0,   404,   405,   406,
     407,   408,   409,   410,   411,   412,     0,   413,   414,   415,
     416,   417,   418,   419,   420,     0,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,     0,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,     0,   445,   446,     0,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,     0,   459,   460,
     461,   462,   463,     0,   464,   465,   466,   467,   468,     0,
     469,   470,   471,   472,     0,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,     0,   485,   486,
       0,   487,     0,   488,   489,   490,   491,   492,     0,   493,
     494,     0,     0,   495,   496,   497,   498,   499,     0,   500,
     501,   502,   503,   504,   505,   506,     0,     0,   507,   508,
     509,   510,   511,     0,     0,   512,   513,   514,   515,   516,
     517,   518,     0,   519,     0,   520,   521,   522,   523,     0,
       0,   524,     0,     0,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,     0,     0,     0,     0,     0,   992,  1411,   600,
       0,     0,   837,   654,     0,     0,     0,     0,  4218,   838,
     839,   840,   223,   224,   225,   226,   227,   228,   229,   230,
    1869,   232,   233,   234,  1870,  1871,  1872,  1873,  1874,  1875,
    1876,   235,   236,  1877,   237,   238,   780,   239,   240,   241,
       0,   993,   781,   994,   995,  1878,   246,   247,   248,   249,
     250,  1879,  1880,   251,   252,   996,   997,   255,  1881,   256,
     257,   258,   259,     0,  1882,   782,  1883,   261,   262,   263,
     264,   783,   265,   266,   267,  1884,   268,   269,   270,   271,
     272,   273,  1885,   784,   274,   275,   276,  1886,  1887,  1888,
     785,  1889,  1890,  1891,   277,   278,   279,   280,   281,   282,
     998,   999,   285,  1892,   286,  1893,   287,   288,   289,   290,
     291,   292,  1894,   293,   294,   295,  1895,  1896,   296,   297,
    1000,   299,   300,  1897,   301,   302,   303,  1898,   304,   305,
     306,  1899,   307,   308,   309,   310,     0,   312,   313,   314,
       0,  1900,   316,  1901,   317,   318,  1001,   320,  1902,   321,
    1903,   322,   786,  1904,   787,   323,   324,   325,  1905,   326,
       0,  1906,     0,   329,  1907,   330,   331,   332,   333,   334,
     788,   335,   336,   337,   338,  1908,   339,   340,   341,   342,
     343,   344,  1909,   345,   789,     0,   347,   348,   349,   350,
    1003,  1004,  1910,  1005,  1911,   354,   790,   791,   355,   792,
     356,   357,   358,   359,   360,  1912,  1913,   361,     0,   793,
     363,   794,  1914,   364,   365,   366,  1915,  1916,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,  1006,   795,  1007,   385,   386,  4307,
    1917,   388,   389,   796,   390,  1918,     0,   392,  1008,   394,
     395,   396,  1919,   397,  1920,  1921,  3561,   399,   400,  1922,
    1923,   401,     0,   797,   403,   798,     0,   405,   406,   407,
     408,   409,   410,   411,   412,  1924,   413,   414,     0,   416,
       0,   418,   419,   420,  1925,   421,   422,   423,   424,   425,
     426,   427,   428,  1009,   430,   431,   432,   433,  1926,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
    1927,   445,   446,   799,   447,   448,   449,     0,   451,   452,
     453,   454,   455,   456,   457,   458,  1928,   459,   460,   461,
     462,   463,  1929,   464,   465,  2010,   467,   468,   800,   469,
     470,  1011,   472,  1930,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,     0,  1931,   485,   486,  1932,
     487,   801,   488,   489,   490,   491,   492,  1933,  1012,  1013,
    1934,  1935,   495,   496,     0,   498,     0,  1936,   500,   501,
     502,   503,   504,   505,   506,  1937,  1938,   507,   508,   509,
     510,   511,  1939,  1940,   512,   513,   514,   515,   516,     0,
    1014,  1941,   519,   802,   520,   521,   522,   523,  1942,  1943,
     524,  1944,  1945,   525,   526,   527,   528,   529,   530,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   540,   541,
     542,     0,     0,     0,   843,   844,   845,     0,  3562,  3563,
     848,   849,   850,   851,   992,  1411,   600,     0,     0,   837,
     654,     0,     0,     0,     0,     0,   838,   839,   840,   223,
     224,   225,   226,   227,   228,   229,   230,  1869,   232,   233,
     234,  1870,  1871,  1872,  1873,  1874,  1875,  1876,   235,   236,
    1877,   237,   238,   780,   239,   240,   241,     0,   993,   781,
     994,   995,  1878,   246,   247,   248,   249,   250,  1879,  1880,
     251,   252,   996,   997,   255,  1881,   256,   257,   258,   259,
       0,  1882,   782,  1883,   261,   262,   263,   264,   783,   265,
     266,   267,  1884,   268,   269,   270,   271,   272,   273,  1885,
     784,   274,   275,   276,  1886,  1887,  1888,   785,  1889,  1890,
    1891,   277,   278,   279,   280,   281,   282,   998,   999,   285,
    1892,   286,  1893,   287,   288,   289,   290,   291,   292,  1894,
     293,   294,   295,  1895,  1896,   296,   297,  1000,   299,   300,
    1897,   301,   302,   303,  1898,   304,   305,   306,  1899,   307,
     308,   309,   310,     0,   312,   313,   314,     0,  1900,   316,
    1901,   317,   318,  1001,   320,  1902,   321,  1903,   322,   786,
    1904,   787,   323,   324,   325,  1905,   326,     0,  1906,     0,
     329,  1907,   330,   331,   332,   333,   334,   788,   335,   336,
     337,   338,  1908,   339,   340,   341,   342,   343,   344,  1909,
     345,   789,     0,   347,   348,   349,   350,  1003,  1004,  1910,
    1005,  1911,   354,   790,   791,   355,   792,   356,   357,   358,
     359,   360,  1912,  1913,   361,     0,   793,   363,   794,  1914,
     364,   365,   366,  1915,  1916,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,  1006,   795,  1007,   385,   386,     0,  1917,   388,   389,
     796,   390,  1918,     0,   392,  1008,   394,   395,   396,  1919,
     397,  1920,  1921,  3561,   399,   400,  1922,  1923,   401,     0,
     797,   403,   798,     0,   405,   406,   407,   408,   409,   410,
     411,   412,  1924,   413,   414,     0,   416,     0,   418,   419,
     420,  1925,   421,   422,   423,   424,   425,   426,   427,   428,
    1009,   430,   431,   432,   433,  1926,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,  1927,   445,   446,
     799,   447,   448,   449,     0,   451,   452,   453,   454,   455,
     456,   457,   458,  1928,   459,   460,   461,   462,   463,  1929,
     464,   465,  2010,   467,   468,   800,   469,   470,  1011,   472,
    1930,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,     0,  1931,   485,   486,  1932,   487,   801,   488,
     489,   490,   491,   492,  1933,  1012,  1013,  1934,  1935,   495,
     496,     0,   498,     0,  1936,   500,   501,   502,   503,   504,
     505,   506,  1937,  1938,   507,   508,   509,   510,   511,  1939,
    1940,   512,   513,   514,   515,   516,     0,  1014,  1941,   519,
     802,   520,   521,   522,   523,  1942,  1943,   524,  1944,  1945,
     525,   526,   527,   528,   529,   530,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   540,   541,   542,     0,   222,
       0,   843,   844,   845,   837,  3562,  3563,   848,   849,   850,
     851,   838,   839,   840,   223,   224,   225,   226,   227,   228,
     229,   230,     0,   232,   233,   234,     0,     0,     0,     0,
       0,     0,     0,   235,   236,     0,   237,   238,     0,   239,
     240,   241,   242,   243,     0,   244,   245,     0,   246,   247,
     248,   249,   250,     0,     0,   251,   252,   253,   254,   255,
       0,   256,   841,   258,   259,   260,     0,     0,     0,   261,
     262,   263,   264,     0,   265,   266,   267,     0,   268,   269,
     270,   271,   272,   273,     0,     0,   274,   275,   276,     0,
       0,     0,     0,     0,     0,     0,   277,   278,   279,   280,
     281,   282,   283,   284,   285,     0,   286,     0,   287,   288,
     289,   290,   291,   292,     0,   293,   294,   295,     0,     0,
     296,   297,   298,   299,   300,     0,   301,   302,   303,     0,
     304,   305,   306,     0,   307,   308,   309,   310,   311,   312,
     313,   314,   315,     0,   842,     0,   317,   318,   319,   320,
       0,   321,     0,   322,     0,     0,     0,   323,   324,   325,
       0,   326,   327,     0,   328,   329,     0,   330,   331,   332,
     333,   334,     0,   335,   336,   337,   338,     0,   339,   340,
     341,   342,   343,   344,     0,   345,     0,   346,   347,   348,
     349,   350,   351,   352,     0,   353,     0,   354,     0,     0,
     355,     0,   356,   357,   358,   359,   360,     0,     0,   361,
     362,     0,   363,     0,     0,   364,   365,   366,     0,     0,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,     0,   384,   385,
     386,   387,     0,   388,   389,     0,   390,     0,   391,   392,
     393,   394,   395,   396,     0,   397,     0,     0,   398,   399,
     400,     0,     0,   401,   402,     0,   403,     0,   404,   405,
     406,   407,   408,   409,   410,   411,   412,     0,   413,   414,
     415,   416,   417,   418,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
       0,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,     0,   445,   446,     0,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,     0,   459,
     460,   461,   462,   463,     0,   464,   465,   466,   467,   468,
       0,   469,   470,   471,   472,     0,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,     0,   485,
     486,     0,   487,     0,   488,   489,   490,   491,   492,     0,
     493,   494,     0,     0,   495,   496,   497,   498,   499,     0,
     500,   501,   502,   503,   504,   505,   506,     0,     0,   507,
     508,   509,   510,   511,     0,     0,   512,   513,   514,   515,
     516,   517,   518,     0,   519,     0,   520,   521,   522,   523,
       0,     0,   524,     0,     0,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,     0,   222,     0,   843,   844,   845,   837,
     846,   847,   848,   849,   850,   851,   838,   839,   840,   223,
     224,   225,   226,   227,   228,   229,   230,     0,   232,   233,
     234,     0,     0,     0,     0,     0,     0,     0,   235,   236,
       0,   237,   238,     0,   239,   240,   241,   242,   243,     0,
     244,   245,     0,   246,   247,   248,   249,   250,     0,     0,
     251,   252,   253,   254,   255,     0,   256,   949,   258,   259,
     260,     0,     0,     0,   261,   262,   263,   264,     0,   265,
     266,   267,     0,   268,   269,   270,   271,   272,   273,     0,
       0,   274,   275,   276,     0,     0,     0,     0,     0,     0,
       0,   277,   278,   279,   280,   281,   282,   283,   284,   285,
       0,   286,     0,   287,   288,   289,   290,   291,   292,     0,
     293,   294,   295,     0,     0,   296,   297,   298,   299,   300,
       0,   301,   302,   303,     0,   304,   305,   306,     0,   307,
     308,   309,   310,   311,   312,   313,   314,   315,     0,   950,
       0,   317,   318,   319,   320,     0,   321,     0,   322,     0,
       0,     0,   323,   324,   325,     0,   326,   327,     0,   328,
     329,     0,   330,   331,   332,   333,   334,     0,   335,   336,
     337,   338,     0,   339,   340,   341,   342,   343,   344,     0,
     345,     0,   346,   347,   348,   349,   350,   351,   352,     0,
     353,     0,   354,     0,     0,   355,     0,   356,   357,   358,
     359,   360,     0,     0,   361,   362,     0,   363,     0,     0,
     364,   365,   366,     0,     0,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,     0,   384,   385,   386,   387,     0,   388,   389,
       0,   390,     0,   391,   392,   393,   394,   395,   396,     0,
     397,     0,     0,   398,   399,   400,     0,     0,   401,   402,
       0,   403,     0,   404,   405,   406,   407,   408,   409,   410,
     411,   412,     0,   413,   414,   415,   416,   417,   418,   419,
     420,     0,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,     0,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,     0,   445,   446,
       0,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,     0,   459,   460,   461,   462,   463,     0,
     464,   465,   466,   467,   468,     0,   469,   470,   471,   472,
       0,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,     0,   485,   486,     0,   487,     0,   488,
     489,   490,   491,   492,     0,   493,   494,     0,     0,   495,
     496,   497,   498,   499,     0,   500,   501,   502,   503,   504,
     505,   506,     0,     0,   507,   508,   509,   510,   511,     0,
       0,   512,   513,   514,   515,   516,   517,   518,     0,   519,
       0,   520,   521,   522,   523,     0,     0,   524,     0,     0,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,     0,   222,
       0,   843,   844,   845,   837,   846,   847,   848,   849,   850,
     851,   838,   839,   840,   223,   224,   225,   226,   227,   228,
     229,   230,     0,   232,   233,   234,     0,     0,     0,     0,
       0,     0,     0,   235,   236,     0,   237,   238,     0,   239,
     240,   241,   242,   243,     0,   244,   245,     0,   246,   247,
     248,   249,   250,     0,     0,   251,   252,   253,   254,   255,
       0,   256,  1041,   258,   259,   260,     0,     0,     0,   261,
     262,   263,   264,     0,   265,   266,   267,     0,   268,   269,
     270,   271,   272,   273,     0,     0,   274,   275,   276,     0,
       0,     0,     0,     0,     0,     0,   277,   278,   279,   280,
     281,   282,   283,   284,   285,     0,   286,     0,   287,   288,
     289,   290,   291,   292,     0,   293,   294,   295,     0,     0,
     296,   297,   298,   299,   300,     0,   301,   302,   303,     0,
     304,   305,   306,     0,   307,   308,   309,   310,   311,   312,
     313,   314,   315,     0,  1042,     0,   317,   318,   319,   320,
       0,   321,     0,   322,     0,     0,     0,   323,   324,   325,
       0,   326,   327,     0,   328,   329,     0,   330,   331,   332,
     333,  1043,     0,   335,   336,   337,   338,     0,   339,   340,
     341,   342,   343,   344,     0,   345,     0,   346,   347,   348,
     349,   350,   351,   352,     0,   353,     0,   354,     0,     0,
     355,     0,   356,   357,   358,   359,   360,     0,     0,   361,
     362,     0,   363,     0,     0,   364,   365,   366,     0,     0,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,     0,   384,   385,
     386,   387,     0,   388,   389,     0,   390,     0,   391,   392,
     393,   394,   395,   396,     0,   397,     0,     0,   398,   399,
     400,     0,     0,   401,   402,     0,   403,     0,   404,   405,
     406,   407,   408,   409,   410,   411,   412,     0,   413,   414,
     415,   416,   417,   418,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
       0,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,     0,   445,   446,     0,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,     0,   459,
     460,   461,   462,   463,     0,   464,   465,   466,   467,   468,
       0,   469,   470,   471,   472,     0,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,     0,   485,
     486,     0,   487,     0,   488,   489,   490,   491,   492,     0,
     493,   494,     0,     0,   495,   496,   497,   498,   499,     0,
     500,   501,   502,   503,   504,   505,   506,     0,     0,   507,
     508,   509,   510,   511,     0,     0,   512,   513,   514,   515,
     516,   517,   518,     0,   519,     0,   520,   521,   522,   523,
       0,     0,   524,     0,     0,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,     0,   222,     0,   843,   844,   845,   837,
     846,   847,   848,   849,   850,   851,   838,   839,   840,   223,
     224,   225,   226,   227,   228,   229,   230,     0,   232,   233,
     234,     0,     0,     0,     0,     0,     0,     0,   235,   236,
       0,   237,   238,     0,   239,   240,   241,   242,   243,     0,
     244,   245,     0,   246,   247,   248,   249,   250,     0,     0,
     251,   252,   253,   254,   255,     0,   256,  1510,   258,   259,
     260,     0,     0,     0,   261,   262,   263,   264,     0,   265,
     266,   267,     0,   268,   269,   270,   271,   272,   273,     0,
       0,   274,   275,   276,     0,     0,     0,     0,     0,     0,
       0,   277,   278,   279,   280,   281,   282,   283,   284,   285,
       0,   286,     0,   287,   288,   289,   290,   291,   292,     0,
     293,   294,   295,     0,     0,   296,   297,   298,   299,   300,
       0,   301,   302,   303,     0,   304,   305,   306,     0,   307,
     308,   309,   310,   311,   312,   313,   314,   315,     0,  1511,
       0,   317,   318,   319,   320,     0,   321,     0,   322,     0,
       0,     0,   323,   324,   325,     0,   326,   327,     0,   328,
     329,     0,   330,   331,   332,   333,   334,     0,   335,   336,
     337,   338,     0,   339,   340,   341,   342,   343,   344,     0,
     345,     0,   346,   347,   348,   349,   350,   351,   352,     0,
     353,     0,   354,     0,     0,   355,     0,   356,   357,   358,
     359,   360,     0,     0,   361,   362,     0,   363,     0,     0,
     364,   365,   366,     0,     0,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,     0,   384,   385,   386,   387,     0,   388,   389,
       0,   390,     0,   391,   392,   393,   394,   395,   396,     0,
     397,     0,     0,   398,   399,   400,     0,     0,   401,   402,
       0,   403,     0,   404,   405,   406,   407,   408,   409,   410,
     411,   412,     0,   413,   414,   415,   416,   417,   418,   419,
     420,     0,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,     0,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,     0,   445,   446,
       0,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,     0,   459,   460,   461,   462,   463,     0,
     464,   465,   466,   467,   468,     0,   469,   470,   471,   472,
       0,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,     0,   485,   486,     0,   487,     0,   488,
     489,   490,   491,   492,     0,   493,   494,     0,     0,   495,
     496,   497,   498,   499,     0,   500,   501,   502,   503,   504,
     505,   506,     0,     0,   507,   508,   509,   510,   511,     0,
       0,   512,   513,   514,   515,   516,   517,   518,     0,   519,
       0,   520,   521,   522,   523,     0,     0,   524,     0,     0,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,     0,   222,
       0,   843,   844,   845,   837,   846,   847,   848,   849,   850,
     851,   838,   839,   840,   223,   224,   225,   226,   227,   228,
     229,   230,     0,   232,   233,   234,     0,     0,     0,     0,
       0,     0,     0,   235,   236,     0,   237,   238,     0,   239,
     240,   241,   242,   243,     0,   244,   245,     0,   246,   247,
     248,   249,   250,     0,     0,   251,   252,   253,   254,   255,
       0,   256,   257,   258,   259,   260,     0,     0,     0,   261,
     262,   263,   264,     0,   265,   266,   267,     0,   268,   269,
     270,   271,   272,   273,     0,     0,   274,   275,   276,     0,
       0,     0,     0,     0,     0,     0,   277,   278,   279,   280,
     281,   282,   283,   284,   285,     0,   286,     0,   287,   288,
     289,   290,   291,   292,     0,   293,   294,   295,     0,     0,
     296,   297,   298,   299,   300,     0,   301,   302,   303,     0,
     304,   305,   306,     0,   307,   308,   309,   310,   311,   312,
     313,   314,   315,     0,   316,     0,   317,   318,   319,   320,
       0,   321,     0,   322,     0,     0,     0,   323,   324,   325,
       0,   326,   327,     0,   328,   329,     0,   330,   331,   332,
     333,   334,     0,   335,   336,   337,   338,     0,   339,   340,
     341,   342,   343,   344,     0,   345,     0,   346,   347,   348,
     349,   350,   351,   352,     0,   353,     0,   354,     0,     0,
     355,     0,   356,   357,   358,   359,   360,     0,     0,   361,
     362,     0,   363,     0,     0,   364,   365,   366,     0,     0,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,     0,   384,   385,
     386,   387,     0,   388,   389,     0,   390,     0,   391,   392,
     393,   394,   395,   396,     0,   397,     0,     0,   398,   399,
     400,     0,     0,   401,   402,     0,   403,     0,   404,   405,
     406,   407,   408,   409,   410,   411,   412,     0,   413,   414,
     415,   416,   417,   418,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
       0,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,     0,   445,   446,     0,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,     0,   459,
     460,   461,   462,   463,     0,   464,   465,   466,   467,   468,
       0,   469,   470,   471,   472,     0,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,     0,   485,
     486,     0,   487,     0,   488,   489,   490,   491,   492,     0,
     493,   494,     0,     0,   495,   496,   497,   498,   499,     0,
     500,   501,   502,   503,   504,   505,   506,     0,     0,   507,
     508,   509,   510,   511,     0,     0,   512,   513,   514,   515,
     516,   517,   518,     0,   519,     0,   520,   521,   522,   523,
       0,     0,   524,     0,     0,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,     0,   222,     0,   843,   844,   845,   837,
     846,   847,   848,   849,   850,   851,   838,   839,   840,   223,
     224,   225,   226,   227,   228,   229,   230,     0,   232,   233,
     234,     0,     0,     0,     0,     0,     0,     0,   235,   236,
       0,   237,   238,     0,   239,   240,   241,   242,   243,     0,
     244,   245,     0,   246,   247,   248,   249,   250,     0,     0,
     251,   252,   253,   254,   255,     0,   256,  2774,   258,   259,
     260,     0,     0,     0,   261,   262,   263,   264,     0,   265,
     266,   267,     0,   268,   269,   270,   271,   272,   273,     0,
       0,   274,   275,   276,     0,     0,     0,     0,     0,     0,
       0,   277,   278,   279,   280,   281,   282,   283,   284,   285,
       0,   286,     0,   287,   288,   289,   290,   291,   292,     0,
     293,   294,   295,     0,     0,   296,   297,   298,   299,   300,
       0,   301,   302,   303,     0,   304,   305,   306,     0,   307,
     308,   309,   310,   311,   312,   313,   314,   315,     0,  2775,
       0,   317,   318,   319,   320,     0,   321,     0,   322,     0,
       0,     0,   323,   324,   325,     0,   326,   327,     0,   328,
     329,     0,   330,   331,   332,   333,   334,     0,   335,   336,
     337,   338,     0,   339,   340,   341,   342,   343,   344,     0,
     345,     0,   346,   347,   348,   349,   350,   351,   352,     0,
     353,     0,   354,     0,     0,   355,     0,   356,   357,   358,
     359,   360,     0,     0,   361,   362,     0,   363,     0,     0,
     364,   365,   366,     0,     0,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,     0,   384,   385,   386,   387,     0,   388,   389,
       0,   390,     0,   391,   392,   393,   394,   395,   396,     0,
     397,     0,     0,   398,   399,   400,     0,     0,   401,   402,
       0,   403,     0,   404,   405,   406,   407,   408,   409,   410,
     411,   412,     0,   413,   414,   415,   416,   417,   418,   419,
     420,     0,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,     0,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,     0,   445,   446,
       0,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,     0,   459,   460,   461,   462,   463,     0,
     464,   465,   466,   467,   468,     0,   469,   470,   471,   472,
       0,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,     0,   485,   486,     0,   487,     0,   488,
     489,   490,   491,   492,     0,   493,   494,     0,     0,   495,
     496,   497,   498,   499,     0,   500,   501,   502,   503,   504,
     505,   506,     0,     0,   507,   508,   509,   510,   511,     0,
       0,   512,   513,   514,   515,   516,   517,   518,     0,   519,
       0,   520,   521,   522,   523,     0,     0,   524,     0,     0,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,     0,   222,
       0,   843,   844,   845,   837,   846,   847,   848,   849,   850,
     851,   838,   839,   840,   223,   224,   225,   226,   227,   228,
     229,   230,     0,   232,   233,   234,     0,     0,     0,     0,
       0,     0,     0,   235,   236,     0,   237,   238,     0,   239,
     240,   241,   242,   243,     0,   244,   245,     0,   246,   247,
     248,   249,   250,     0,     0,   251,   252,   253,   254,   255,
       0,   256,   257,   258,   259,   260,     0,     0,     0,   261,
     262,   263,   264,     0,   265,   266,   267,     0,   268,   269,
     270,   271,   272,   273,     0,     0,   274,   275,   276,     0,
       0,     0,     0,     0,     0,     0,   277,   278,   279,   280,
     281,   282,   283,   284,   285,     0,   286,     0,   287,   288,
     289,   290,   291,   292,     0,   293,   294,   295,     0,     0,
     296,   297,   298,   299,   300,     0,   301,   302,   303,     0,
     304,   305,   306,     0,   307,   308,   309,   310,   311,   312,
     313,   314,   315,     0,   316,     0,   317,   318,   319,   320,
       0,   321,     0,   322,     0,     0,     0,   323,   324,   325,
       0,   326,   327,     0,   328,   329,     0,   330,   331,   332,
     333,   334,     0,   335,   336,   337,   338,     0,   339,   340,
     341,   342,   343,   344,     0,   345,     0,   346,   347,   348,
     349,   350,   351,   352,     0,   353,     0,   354,     0,     0,
     355,     0,   356,   357,   358,   359,   360,     0,     0,   361,
     362,     0,   363,     0,     0,   364,   365,   366,     0,     0,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,     0,   384,   385,
     386,   387,     0,   388,   389,     0,   390,     0,   391,   392,
     393,   394,   395,   396,     0,   397,     0,     0,  4493,   399,
     400,     0,     0,   401,   402,     0,   403,     0,   404,   405,
     406,   407,   408,   409,   410,   411,   412,     0,   413,   414,
     415,   416,   417,   418,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
       0,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,     0,   445,   446,     0,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,     0,   459,
     460,   461,   462,   463,     0,   464,   465,   466,   467,   468,
       0,   469,   470,   471,   472,     0,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,     0,   485,
     486,     0,   487,     0,   488,   489,   490,   491,   492,     0,
     493,   494,     0,     0,   495,   496,   497,   498,   499,     0,
     500,   501,   502,   503,   504,   505,   506,     0,     0,   507,
     508,   509,   510,   511,     0,     0,   512,   513,   514,   515,
     516,   517,   518,     0,   519,     0,   520,   521,   522,   523,
       0,     0,   524,     0,     0,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,  1868,     0,     0,   843,   844,   845,     0,
     846,   847,   848,   849,   850,   851,     0,     0,   223,   224,
     225,   226,   227,   228,   229,   230,  1869,   232,   233,   234,
    1870,  1871,  1872,  1873,  1874,  1875,  1876,   235,   236,  1877,
     237,   238,   780,   239,   240,   241,   242,   243,   781,   244,
     245,  1878,   246,   247,   248,   249,   250,  1879,  1880,   251,
     252,   253,   254,   255,  1881,   256,   257,   258,   259,   260,
    1882,   782,  1883,   261,   262,   263,   264,   783,   265,   266,
     267,  1884,   268,   269,   270,   271,   272,   273,  1885,   784,
     274,   275,   276,  1886,  1887,  1888,   785,  1889,  1890,  1891,
     277,   278,   279,   280,   281,   282,   283,   284,   285,  1892,
     286,  1893,   287,   288,   289,   290,   291,   292,  1894,   293,
     294,   295,  1895,  1896,   296,   297,   298,   299,   300,  1897,
     301,   302,   303,  1898,   304,   305,   306,  1899,   307,   308,
     309,   310,   311,   312,   313,   314,   315,  1900,   316,  1901,
     317,   318,   319,   320,  1902,   321,  1903,   322,   786,  1904,
     787,   323,   324,   325,  1905,   326,   327,  1906,   328,   329,
    1907,   330,   331,   332,   333,   334,   788,   335,   336,   337,
     338,  1908,   339,   340,   341,   342,   343,   344,  1909,   345,
     789,   346,   347,   348,   349,   350,   351,   352,  1910,   353,
    1911,   354,   790,   791,   355,   792,   356,   357,   358,   359,
     360,  1912,  1913,   361,   362,   793,   363,   794,  1914,   364,
     365,   366,  1915,  1916,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   795,   384,   385,   386,   387,  1917,   388,   389,   796,
     390,  1918,   391,   392,   393,   394,   395,   396,  1919,   397,
    1920,  1921,   398,   399,   400,  1922,  1923,   401,   402,   797,
     403,   798,   404,   405,   406,   407,   408,   409,   410,   411,
     412,  1924,   413,   414,   415,   416,   417,   418,   419,   420,
    1925,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,  1926,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,  1927,   445,   446,   799,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,  1928,   459,   460,   461,   462,   463,  1929,   464,
     465,   466,   467,   468,   800,   469,   470,   471,   472,  1930,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,  1931,   485,   486,  1932,   487,   801,   488,   489,
     490,   491,   492,  1933,   493,   494,  1934,  1935,   495,   496,
     497,   498,   499,  1936,   500,   501,   502,   503,   504,   505,
     506,  1937,  1938,   507,   508,   509,   510,   511,  1939,  1940,
     512,   513,   514,   515,   516,   517,   518,  1941,   519,   802,
     520,   521,   522,   523,  1942,  1943,   524,  1944,  1945,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   222,     0,     0,
       0,     0,     0,     0,     0,     0,  1946,     0,     0,     0,
       0,     0,   223,   224,   225,   226,   227,   228,   229,   230,
       0,   232,   233,   234,     0,     0,     0,     0,     0,     0,
       0,   235,   236,     0,   237,   238,     0,   239,   240,   241,
     242,   243,     0,   244,   245,     0,   246,   247,   248,   249,
     250,     0,     0,   251,   252,   253,   254,   255,     0,   256,
     257,   258,   259,   260,     0,     0,     0,   261,   262,   263,
     264,     0,   265,   266,   267,     0,   268,   269,   270,   271,
     272,   273,     0,     0,   274,   275,   276,     0,     0,     0,
       0,     0,     0,     0,   277,   278,   279,   280,   281,   282,
     283,   284,   285,     0,   286,     0,   287,   288,   289,   290,
     291,   292,     0,   293,   294,   295,     0,     0,   296,   297,
     298,   299,   300,     0,   301,   302,   303,     0,   304,   305,
     306,     0,   307,   308,   309,   310,   311,   312,   313,   314,
     315,     0,   316,     0,   317,   318,   319,   320,     0,   321,
       0,   322,     0,     0,     0,   323,   324,   325,     0,   326,
     327,     0,   328,   329,     0,   330,   331,   332,   333,   334,
       0,   335,   336,   337,   338,     0,   339,   340,   341,   342,
     343,   344,     0,   345,     0,   346,   347,   348,   349,   350,
     351,   352,     0,   353,     0,   354,     0,     0,   355,     0,
     356,   357,   358,   359,   360,     0,     0,   361,   362,     0,
     363,     0,     0,   364,   365,   366,     0,     0,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,     0,   384,   385,   386,   387,
       0,   388,   389,     0,   390,     0,   391,   392,   393,   394,
     395,   396,     0,   397,     0,     0,   398,   399,   400,     0,
       0,   401,   402,     0,   403,     0,   404,   405,   406,   407,
     408,   409,   410,   411,   412,     0,   413,   414,   415,   416,
     417,   418,   419,   420,     0,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,     0,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
       0,   445,   446,     0,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,     0,   459,   460,   461,
     462,   463,     0,   464,   465,   466,   467,   468,     0,   469,
     470,   471,   472,     0,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,     0,   485,   486,     0,
     487,     0,   488,   489,   490,   491,   492,     0,   493,   494,
       0,     0,   495,   496,   497,   498,   499,     0,   500,   501,
     502,   503,   504,   505,   506,     0,     0,   507,   508,   509,
     510,   511,     0,     0,   512,   513,   514,   515,   516,   517,
     518,     0,   519,     0,   520,   521,   522,   523,     0,     0,
     524,     0,     0,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   992,     0,     0,     0,     0,     0,     0,     0,     0,
     748,     0,     0,     0,     0,     0,   223,   224,   225,   226,
     227,   228,   229,   230,     0,   232,   233,   234,     0,     0,
       0,     0,     0,     0,     0,   235,   236,     0,   237,   238,
     780,   239,   240,   241,     0,   993,   781,   994,   995,     0,
     246,   247,   248,   249,   250,     0,     0,   251,   252,   996,
     997,   255,     0,   256,   257,   258,   259,     0,     0,   782,
       0,   261,   262,   263,   264,   783,   265,   266,   267,     0,
     268,   269,   270,   271,   272,   273,     0,   784,   274,   275,
     276,     0,     0,     0,   785,     0,     0,     0,   277,   278,
     279,   280,   281,   282,   998,   999,   285,     0,   286,     0,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
       0,     0,   296,   297,  1000,   299,   300,     0,   301,   302,
     303,     0,   304,   305,   306,     0,   307,   308,   309,   310,
       0,   312,   313,   314,     0,     0,   316,     0,   317,   318,
    1001,   320,     0,   321,     0,   322,   786,     0,   787,   323,
     324,   325,     0,   326,     0,     0,     0,   329,     0,   330,
     331,   332,   333,   334,   788,   335,   336,   337,   338,  2006,
     339,   340,   341,   342,   343,   344,     0,   345,   789,  2007,
     347,   348,   349,   350,  1003,  1004,     0,  1005,     0,   354,
     790,   791,   355,   792,   356,   357,   358,   359,   360,     0,
       0,   361,     0,   793,   363,   794,     0,   364,   365,   366,
       0,     0,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,  1006,   795,
    1007,   385,   386,     0,     0,   388,   389,   796,   390,     0,
       0,   392,  1008,   394,   395,   396,     0,   397,     0,     0,
     398,   399,   400,     0,  2008,   401,  2009,   797,   403,   798,
       0,   405,   406,   407,   408,   409,   410,   411,   412,     0,
     413,   414,     0,   416,     0,   418,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,  1009,   430,   431,
     432,   433,     0,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,     0,   445,   446,   799,   447,   448,
     449,     0,   451,   452,   453,   454,   455,   456,   457,   458,
       0,   459,   460,   461,   462,   463,     0,   464,   465,  2010,
     467,   468,   800,   469,   470,  1011,   472,     0,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,     0,
       0,   485,   486,     0,   487,   801,   488,   489,   490,   491,
     492,     0,  1012,  1013,     0,     0,   495,   496,     0,   498,
       0,     0,   500,   501,   502,   503,   504,   505,   506,     0,
       0,   507,   508,   509,   510,   511,     0,     0,   512,   513,
     514,   515,   516,     0,  1014,  2011,   519,   802,   520,   521,
     522,   523,     0,     0,   524,     0,     0,   525,   526,   527,
     528,   529,   530,     0,     0,     0,     0,     0,     0,     0,
    2280,     0,   540,   541,   542,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2012,   223,   224,   225,   226,   227,
     228,   229,   230,     0,   232,   233,   234,     0,     0,     0,
       0,     0,     0,     0,   235,   236,     0,   237,   238,   780,
     239,   240,   241,     0,   993,   781,   994,   995,     0,   246,
     247,   248,   249,   250,     0,     0,   251,   252,   996,   997,
     255,     0,   256,   257,   258,   259,     0,     0,   782,     0,
     261,   262,   263,   264,   783,   265,   266,   267,     0,   268,
     269,   270,   271,   272,   273,     0,   784,   274,   275,   276,
       0,     0,     0,   785,     0,     0,     0,   277,   278,   279,
     280,   281,   282,   998,   999,   285,     0,   286,     0,   287,
     288,   289,   290,   291,   292,     0,   293,   294,   295,     0,
       0,   296,   297,  1000,   299,   300,     0,   301,   302,   303,
       0,   304,   305,   306,     0,   307,   308,   309,   310,     0,
     312,   313,   314,     0,     0,   316,     0,   317,   318,  1001,
     320,     0,   321,     0,   322,   786,     0,   787,   323,   324,
     325,     0,   326,     0,     0,     0,   329,     0,   330,   331,
     332,   333,   334,   788,   335,   336,   337,   338,  2006,   339,
     340,   341,   342,   343,   344,     0,   345,   789,  2007,   347,
     348,   349,   350,  1003,  1004,     0,  1005,     0,   354,   790,
     791,   355,   792,   356,   357,   358,   359,   360,     0,     0,
     361,     0,   793,   363,   794,     0,   364,   365,   366,     0,
       0,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,  1006,   795,  1007,
     385,   386,     0,     0,   388,   389,   796,   390,     0,     0,
     392,  1008,   394,   395,   396,     0,   397,     0,     0,   398,
     399,   400,     0,  2008,   401,  2009,   797,   403,   798,     0,
     405,   406,   407,   408,   409,   410,   411,   412,     0,   413,
     414,     0,   416,     0,   418,   419,   420,     0,   421,   422,
     423,   424,   425,   426,   427,   428,  1009,   430,   431,   432,
     433,     0,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,     0,   445,   446,   799,   447,   448,   449,
       0,   451,   452,   453,   454,   455,   456,   457,   458,     0,
     459,   460,   461,   462,   463,     0,   464,   465,  2010,   467,
     468,   800,   469,   470,  1011,   472,     0,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,     0,     0,
     485,   486,     0,   487,   801,   488,   489,   490,   491,   492,
       0,  1012,  1013,     0,     0,   495,   496,     0,   498,     0,
       0,   500,   501,   502,   503,   504,   505,   506,     0,     0,
     507,   508,   509,   510,   511,     0,     0,   512,   513,   514,
     515,   516,     0,  1014,  2011,   519,   802,   520,   521,   522,
     523,     0,     0,   524,     0,     0,   525,   526,   527,   528,
     529,   530,     0,     0,     0,     0,     0,     0,     0,   222,
       0,   540,   541,   542,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2012,   223,   224,   225,   226,   227,   228,
     229,   230,     0,   232,   233,   234,     0,     0,     0,     0,
       0,     0,     0,   235,   236,     0,   237,   238,     0,   239,
     240,   241,   242,   243,     0,   244,   245,     0,   246,   247,
     248,   249,   250,     0,     0,   251,   252,   253,   254,   255,
       0,   256,   257,   258,   259,   260,     0,     0,     0,   261,
     262,   263,   264,     0,   265,   266,   267,     0,   268,   269,
     270,   271,   272,   273,     0,     0,   274,   275,   276,     0,
       0,     0,     0,     0,     0,     0,   277,   278,   279,   280,
     281,   282,   283,   284,   285,     0,   286,     0,   287,   288,
     289,   290,   291,   292,     0,   293,   294,   295,     0,     0,
     296,   297,   298,   299,   300,     0,   301,   302,   303,     0,
     304,   305,   306,     0,   307,   308,   309,   310,   311,   312,
     313,   314,   315,     0,   316,     0,   317,   318,   319,   320,
       0,   321,     0,   322,     0,     0,     0,   323,   324,   325,
       0,   326,   327,     0,   328,   329,     0,   330,   331,   332,
     333,   334,     0,   335,   336,   337,   338,     0,   339,   340,
     341,   342,   343,   344,     0,   345,     0,   346,   347,   348,
     349,   350,   351,   352,     0,   353,     0,   354,     0,     0,
     355,     0,   356,   357,   358,   359,   360,     0,     0,   361,
     362,     0,   363,     0,     0,   364,   365,   366,     0,     0,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,     0,   384,   385,
     386,   387,     0,   388,   389,     0,   390,     0,   391,   392,
     393,   394,   395,   396,     0,   397,     0,     0,   398,   399,
     400,     0,     0,   401,   402,     0,   403,     0,   404,   405,
     406,   407,   408,   409,   410,   411,   412,     0,   413,   414,
     415,   416,   417,   418,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
       0,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,     0,   445,   446,     0,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,     0,   459,
     460,   461,   462,   463,     0,   464,   465,   466,   467,   468,
       0,   469,   470,   471,   472,     0,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,     0,   485,
     486,     0,   487,     0,   488,   489,   490,   491,   492,     0,
     493,   494,     0,     0,   495,   496,   497,   498,   499,     0,
     500,   501,   502,   503,   504,   505,   506,     0,     0,   507,
     508,   509,   510,   511,     0,     0,   512,   513,   514,   515,
     516,   517,   518,     0,   519,     0,   520,   521,   522,   523,
       0,     0,   524,     0,     0,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   823,  1411,   600,     0,     0,     0,   654,
       0,     0,  4815,     0,     0,     0,     0,     0,   223,   224,
     225,   226,   227,   228,   229,   230,     0,   232,   233,   234,
       0,     0,     0,     0,     0,     0,     0,   235,   236,     0,
     237,   238,   780,   239,   240,   241,   242,   243,   781,   244,
     245,     0,   246,   247,   248,   249,   250,     0,     0,   251,
     252,   253,   254,   255,     0,   256,   257,   258,   259,   260,
       0,   782,     0,   261,   262,   263,   264,   783,   265,   266,
     267,     0,   268,   269,   270,   271,   272,   273,     0,   784,
     274,   275,   276,     0,     0,     0,   785,     0,     0,     0,
     277,   278,   279,   280,   281,   282,   283,   284,   285,  1857,
     286,     0,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,     0,     0,   296,   297,   298,   299,   300,     0,
     301,   302,   303,     0,   304,   305,   306,     0,   307,   308,
     309,   310,   311,   312,   313,   314,   315,  1681,   316,     0,
     317,   318,   319,   320,     0,   321,     0,   322,   786,     0,
     787,   323,   324,   325,     0,   326,   327,     0,   328,   329,
       0,   330,   331,   332,   333,   334,   788,   335,   336,   337,
     338,     0,   339,   340,   341,   342,   343,   344,     0,   345,
     789,   346,   347,   348,   349,   350,   351,   352,     0,   353,
       0,   354,   790,   791,   355,   792,   356,   357,   358,   359,
     360,     0,     0,   361,   362,   793,   363,   794,     0,   364,
     365,   366,     0,     0,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   795,   384,   385,   386,   387,     0,   388,   389,   796,
     390,     0,   391,   392,   393,   394,   395,   396,     0,   397,
    1682,     0,   398,   399,   400,     0,     0,   401,   402,   797,
     403,   798,   404,   405,   406,   407,   408,   409,   410,   411,
     412,     0,   413,   414,   415,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,     0,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,     0,   445,   446,   799,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,     0,   459,   460,   461,   462,   463,     0,   464,
     465,   466,   467,   468,   800,   469,   470,   471,   472,     0,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,     0,   485,   486,     0,   487,   801,   488,   489,
     490,   491,   492,     0,   493,   494,     0,     0,   495,   496,
     497,   498,   499,  1683,   500,   501,   502,   503,   504,   505,
     506,     0,     0,   507,   508,   509,   510,   511,     0,     0,
     512,   513,   514,   515,   516,   517,   518,     0,   519,   802,
     520,   521,   522,   523,     0,     0,   524,     0,     0,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   823,  1411,   600,
       0,     0,     0,   654,   666,  1412,     0,     0,     0,     0,
       0,     0,   223,   224,   225,   226,   227,   228,   229,   230,
       0,   232,   233,   234,     0,     0,     0,     0,     0,     0,
       0,   235,   236,     0,   237,   238,   780,   239,   240,   241,
     242,   243,   781,   244,   245,     0,   246,   247,   248,   249,
     250,     0,     0,   251,   252,   253,   254,   255,     0,   256,
     257,   258,   259,   260,     0,   782,     0,   261,   262,   263,
     264,   783,   265,   266,   267,     0,   268,   269,   270,   271,
     272,   273,     0,   784,   274,   275,   276,     0,     0,     0,
     785,     0,     0,     0,   277,   278,   279,   280,   281,   282,
     283,   284,   285,  1862,   286,     0,   287,   288,   289,   290,
     291,   292,     0,   293,   294,   295,     0,     0,   296,   297,
     298,   299,   300,     0,   301,   302,   303,     0,   304,   305,
     306,     0,   307,   308,   309,   310,   311,   312,   313,   314,
     315,  1681,   316,     0,   317,   318,   319,   320,     0,   321,
       0,   322,   786,     0,   787,   323,   324,   325,     0,   326,
     327,     0,   328,   329,     0,   330,   331,   332,   333,   334,
     788,   335,   336,   337,   338,     0,   339,   340,   341,   342,
     343,   344,     0,   345,   789,   346,   347,   348,   349,   350,
     351,   352,     0,   353,     0,   354,   790,   791,   355,   792,
     356,   357,   358,   359,   360,     0,     0,   361,   362,   793,
     363,   794,     0,   364,   365,   366,     0,     0,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   795,   384,   385,   386,   387,
       0,   388,   389,   796,   390,     0,   391,   392,   393,   394,
     395,   396,     0,   397,  1682,     0,   398,   399,   400,     0,
       0,   401,   402,   797,   403,   798,   404,   405,   406,   407,
     408,   409,   410,   411,   412,     0,   413,   414,   415,   416,
     417,   418,   419,   420,     0,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,     0,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
       0,   445,   446,   799,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,     0,   459,   460,   461,
     462,   463,     0,   464,   465,   466,   467,   468,   800,   469,
     470,   471,   472,     0,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,     0,   485,   486,     0,
     487,   801,   488,   489,   490,   491,   492,     0,   493,   494,
       0,     0,   495,   496,   497,   498,   499,  1683,   500,   501,
     502,   503,   504,   505,   506,     0,     0,   507,   508,   509,
     510,   511,     0,     0,   512,   513,   514,   515,   516,   517,
     518,     0,   519,   802,   520,   521,   522,   523,     0,     0,
     524,     0,     0,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   823,  1411,   600,     0,     0,     0,   654,   666,  1412,
       0,     0,     0,     0,     0,     0,   223,   224,   225,   226,
     227,   228,   229,   230,     0,   232,   233,   234,     0,     0,
       0,     0,     0,     0,     0,   235,   236,     0,   237,   238,
     780,   239,   240,   241,   242,   243,   781,   244,   245,     0,
     246,   247,   248,   249,   250,     0,     0,   251,   252,   253,
     254,   255,     0,   256,   257,   258,   259,   260,     0,   782,
       0,   261,   262,   263,   264,   783,   265,   266,   267,     0,
     268,   269,   270,   271,   272,   273,     0,   784,   274,   275,
     276,     0,     0,     0,   785,     0,     0,     0,   277,   278,
     279,   280,   281,   282,   283,   284,   285,     0,   286,     0,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
       0,     0,   296,   297,   298,   299,   300,     0,   301,   302,
     303,     0,   304,   305,   306,     0,   307,   308,   309,   310,
     311,   312,   313,   314,   315,  1681,   316,     0,   317,   318,
     319,   320,     0,   321,     0,   322,   786,     0,   787,   323,
     324,   325,     0,   326,   327,     0,   328,   329,     0,   330,
     331,   332,   333,   334,   788,   335,   336,   337,   338,     0,
     339,   340,   341,   342,   343,   344,     0,   345,   789,   346,
     347,   348,   349,   350,   351,   352,     0,   353,     0,   354,
     790,   791,   355,   792,   356,   357,   358,   359,   360,     0,
       0,   361,   362,   793,   363,   794,     0,   364,   365,   366,
       0,     0,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   795,
     384,   385,   386,   387,     0,   388,   389,   796,   390,     0,
     391,   392,   393,   394,   395,   396,     0,   397,  1682,     0,
     398,   399,   400,     0,     0,   401,   402,   797,   403,   798,
     404,   405,   406,   407,   408,   409,   410,   411,   412,     0,
     413,   414,   415,   416,   417,   418,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,     0,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,     0,   445,   446,   799,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
       0,   459,   460,   461,   462,   463,     0,   464,   465,   466,
     467,   468,   800,   469,   470,   471,   472,     0,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
       0,   485,   486,     0,   487,   801,   488,   489,   490,   491,
     492,     0,   493,   494,     0,     0,   495,   496,   497,   498,
     499,  1683,   500,   501,   502,   503,   504,   505,   506,     0,
       0,   507,   508,   509,   510,   511,     0,     0,   512,   513,
     514,   515,   516,   517,   518,     0,   519,   802,   520,   521,
     522,   523,     0,     0,   524,     0,     0,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   823,     0,   600,     0,     0,
       0,   654,   666,  1412,     0,     0,     0,     0,     0,     0,
     223,   224,   225,   226,   227,   228,   229,   230,     0,   232,
     233,   234,     0,     0,     0,     0,     0,     0,     0,   235,
     236,     0,   237,   238,   780,   239,   240,   241,   242,   243,
     781,   244,   245,     0,   246,   247,   248,   249,   250,     0,
       0,   251,   252,   253,   254,   255,     0,   256,   257,   258,
     259,   260,     0,   782,     0,   261,   262,   263,   264,   783,
     265,   266,   267,     0,   268,   269,   270,   271,   272,   273,
       0,   784,   274,   275,   276,     0,     0,     0,   785,     0,
       0,     0,   277,   278,   279,   280,   281,   282,   283,   284,
     285,  2728,   286,     0,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,     0,     0,   296,   297,   298,   299,
     300,     0,   301,   302,   303,     0,   304,   305,   306,     0,
     307,   308,   309,   310,   311,   312,   313,   314,   315,  1681,
     316,     0,   317,   318,   319,   320,     0,   321,     0,   322,
     786,     0,   787,   323,   324,   325,     0,   326,   327,     0,
     328,   329,     0,   330,   331,   332,   333,   334,   788,   335,
     336,   337,   338,     0,   339,   340,   341,   342,   343,   344,
       0,   345,   789,   346,   347,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   790,   791,   355,   792,   356,   357,
     358,   359,   360,     0,     0,   361,   362,   793,   363,   794,
       0,   364,   365,   366,     0,     0,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   795,   384,   385,   386,   387,     0,   388,
     389,   796,   390,     0,   391,   392,   393,   394,   395,   396,
       0,   397,  1682,     0,   398,   399,   400,     0,     0,   401,
     402,   797,   403,   798,   404,   405,   406,   407,   408,   409,
     410,   411,   412,     0,   413,   414,   415,   416,   417,   418,
     419,   420,     0,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,     0,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,     0,   445,
     446,   799,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,   462,   463,
       0,   464,   465,   466,   467,   468,   800,   469,   470,   471,
     472,     0,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,     0,   485,   486,     0,   487,   801,
     488,   489,   490,   491,   492,     0,   493,   494,     0,     0,
     495,   496,   497,   498,   499,  1683,   500,   501,   502,   503,
     504,   505,   506,     0,     0,   507,   508,   509,   510,   511,
       0,     0,   512,   513,   514,   515,   516,   517,   518,     0,
     519,   802,   520,   521,   522,   523,     0,     0,   524,     0,
       0,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   222,
       0,     0,     0,     0,     0,   654,   666,   667,     0,     0,
       0,     0,     0,     0,   223,   655,   225,   226,   227,   228,
     229,   230,   656,   232,   233,   234,     0,     0,     0,     0,
       0,     0,     0,   235,   236,     0,   237,   238,     0,   657,
     240,   241,   242,   243,     0,   244,   245,     0,   246,   247,
     248,   249,   250,     0,     0,   251,   252,   253,   254,   255,
       0,   256,   257,   258,   259,   260,     0,     0,     0,   261,
     262,   263,   264,     0,   265,   266,   267,     0,   268,   269,
     270,   271,   272,   273,     0,     0,   274,   275,   276,     0,
       0,     0,     0,     0,     0,     0,   277,   278,   279,   280,
     281,   282,   283,   284,   285,     0,   286,     0,   287,   288,
     289,   290,   291,   292,     0,   293,   294,   295,     0,     0,
     296,   297,   298,   299,   300,     0,   301,   302,   303,     0,
     304,   305,   306,     0,   307,   308,   309,   310,   311,   312,
     313,   314,   315,     0,   316,     0,   317,   658,   319,   320,
       0,   321,     0,   659,     0,   660,     0,   323,   324,   325,
       0,   326,   327,     0,   328,   329,     0,   330,   331,   332,
     333,   334,     0,   335,   336,   337,   338,   661,   339,   340,
     341,   342,   343,   344,     0,   345,     0,   346,   347,   348,
     349,   350,   351,   352,     0,   353,     0,   354,     0,     0,
     355,     0,   356,   357,   358,   359,   662,     0,     0,   361,
     362,     0,   363,     0,     0,   364,   365,   366,     0,     0,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,     0,   384,   663,
     386,   387,     0,   388,   389,     0,   390,     0,   391,   392,
     393,   394,   395,   396,     0,   397,     0,     0,   398,   399,
     400,     0,     0,   401,   402,     0,   403,     0,   404,   405,
     406,   407,   408,   409,   410,   411,   412,     0,   413,   414,
     415,   416,   417,   418,   419,   420,     0,   664,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
       0,   434,   435,   665,   437,   438,   439,   440,   441,   442,
     443,   444,     0,   445,   446,     0,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,     0,   459,
     460,   461,   462,   463,     0,   464,   465,   466,   467,   468,
       0,   469,   470,   471,   472,     0,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,     0,   485,
     486,     0,   487,     0,   488,   489,   490,   491,   492,     0,
     493,   494,     0,     0,   495,   496,   497,   498,   499,     0,
     500,   501,   502,   503,   504,   505,   506,     0,     0,   507,
     508,   509,   510,   511,     0,     0,   512,   513,   514,   515,
     516,   517,   518,     0,   519,     0,   520,   521,   522,   523,
       0,     0,   524,     0,     0,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,  1868,  4937,   600,     0,     0,     0,   654,
     666,   667,     0,     0,     0,     0,     0,     0,   223,   224,
     225,   226,   227,   228,   229,   230,  1869,   232,   233,   234,
    1870,  1871,  1872,  1873,  1874,  1875,  1876,   235,   236,  1877,
     237,   238,   780,   239,   240,   241,   242,   243,   781,   244,
     245,  1878,   246,   247,   248,   249,   250,  1879,  1880,   251,
     252,   253,   254,   255,  1881,   256,   257,   258,   259,   260,
    1882,   782,  1883,   261,   262,   263,   264,   783,   265,   266,
     267,  1884,   268,   269,   270,   271,   272,   273,  1885,   784,
     274,   275,   276,  1886,  1887,  1888,   785,  1889,  1890,  1891,
     277,   278,   279,   280,   281,   282,   283,   284,   285,  1892,
     286,  1893,   287,   288,   289,   290,   291,   292,  1894,   293,
     294,   295,  1895,  1896,   296,   297,   298,   299,   300,  1897,
     301,   302,   303,  1898,   304,   305,   306,  1899,   307,   308,
     309,   310,   311,   312,   313,   314,   315,  1900,   316,  1901,
     317,   318,   319,   320,  1902,   321,  1903,   322,   786,  1904,
     787,   323,   324,   325,  1905,   326,   327,  1906,   328,   329,
    1907,   330,   331,   332,   333,   334,   788,   335,   336,   337,
     338,  1908,   339,   340,   341,   342,   343,   344,  1909,   345,
     789,   346,   347,   348,   349,   350,   351,   352,  1910,   353,
    1911,   354,   790,   791,   355,   792,   356,   357,   358,   359,
     360,  1912,  1913,   361,   362,   793,   363,   794,  1914,   364,
     365,   366,  1915,  1916,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   795,   384,   385,   386,   387,  1917,   388,   389,   796,
     390,  1918,   391,   392,   393,   394,   395,   396,  1919,   397,
    1920,  1921,   398,   399,   400,  1922,  1923,   401,   402,   797,
     403,   798,   404,   405,   406,   407,   408,   409,   410,   411,
     412,  1924,   413,   414,   415,   416,   417,   418,   419,   420,
    1925,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,  1926,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,  1927,   445,   446,   799,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,  1928,   459,   460,   461,   462,   463,  1929,   464,
     465,   466,   467,   468,   800,   469,   470,   471,   472,  1930,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,  1931,   485,   486,  1932,   487,   801,   488,   489,
     490,   491,   492,  1933,   493,   494,  1934,  1935,   495,   496,
     497,   498,   499,  1936,   500,   501,   502,   503,   504,   505,
     506,  1937,  1938,   507,   508,   509,   510,   511,  1939,  1940,
     512,   513,   514,   515,   516,   517,   518,  1941,   519,   802,
     520,   521,   522,   523,  1942,  1943,   524,  1944,  1945,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,  1868,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   223,   224,   225,   226,   227,   228,   229,   230,
    1869,   232,   233,   234,  1870,  1871,  1872,  1873,  1874,  1875,
    1876,   235,   236,  1877,   237,   238,   780,   239,   240,   241,
     242,   243,   781,   244,   245,  1878,   246,   247,   248,   249,
     250,  1879,  1880,   251,   252,   253,   254,   255,  1881,   256,
     257,   258,   259,   260,  1882,   782,  1883,   261,   262,   263,
     264,   783,   265,   266,   267,  1884,   268,   269,   270,   271,
     272,   273,  1885,   784,   274,   275,   276,  1886,  1887,  1888,
     785,  1889,  1890,  1891,   277,   278,   279,   280,   281,   282,
     283,   284,   285,  1892,   286,  1893,   287,   288,   289,   290,
     291,   292,  1894,   293,   294,   295,  1895,  1896,   296,   297,
     298,   299,   300,  1897,   301,   302,   303,  1898,   304,   305,
     306,  1899,   307,   308,   309,   310,   311,   312,   313,   314,
     315,  1900,   316,  1901,   317,   318,   319,   320,  1902,   321,
    1903,   322,   786,  1904,   787,   323,   324,   325,  1905,   326,
     327,  1906,   328,   329,  1907,   330,   331,   332,   333,   334,
     788,   335,   336,   337,   338,  1908,   339,   340,   341,   342,
     343,   344,  1909,   345,   789,   346,   347,   348,   349,   350,
     351,   352,  1910,   353,  1911,   354,   790,   791,   355,   792,
     356,   357,   358,   359,   360,  1912,  1913,   361,   362,   793,
     363,   794,  1914,   364,   365,   366,  1915,  1916,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   795,   384,   385,   386,   387,
    1917,   388,   389,   796,   390,  1918,   391,   392,   393,   394,
     395,   396,  1919,   397,  1920,  1921,   398,   399,   400,  1922,
    1923,   401,   402,   797,   403,   798,   404,   405,   406,   407,
     408,   409,   410,   411,   412,  1924,   413,   414,   415,   416,
     417,   418,   419,   420,  1925,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,  1926,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
    1927,   445,   446,   799,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,  1928,   459,   460,   461,
     462,   463,  1929,   464,   465,   466,   467,   468,   800,   469,
     470,   471,   472,  1930,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,  1931,   485,   486,  1932,
     487,   801,   488,   489,   490,   491,   492,  1933,   493,   494,
    1934,  1935,   495,   496,   497,   498,   499,  1936,   500,   501,
     502,   503,   504,   505,   506,  1937,  1938,   507,   508,   509,
     510,   511,  1939,  1940,   512,   513,   514,   515,   516,   517,
     518,  1941,   519,   802,   520,   521,   522,   523,  1942,  1943,
     524,  1944,  1945,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,  1868,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   223,   224,   225,   226,
    2842,   228,   229,   230,  1869,   232,   233,   234,  1870,  1871,
    1872,  1873,  1874,  1875,  1876,   235,   236,  1877,   237,   238,
     780,   239,   240,   241,   242,   243,   781,   244,   245,  1878,
     246,   247,   248,   249,   250,  1879,  1880,   251,   252,   253,
     254,   255,  1881,   256,   257,   258,   259,   260,  1882,   782,
    1883,   261,   262,   263,   264,   783,   265,   266,   267,  1884,
     268,   269,   270,   271,   272,   273,  1885,   784,   274,   275,
     276,  1886,  1887,  1888,   785,  1889,  1890,  1891,   277,   278,
     279,   280,   281,   282,   283,   284,   285,  1892,   286,  1893,
     287,   288,   289,   290,   291,   292,  1894,   293,   294,   295,
    1895,  1896,   296,   297,   298,  2843,   300,  1897,   301,   302,
     303,  1898,   304,   305,   306,  1899,   307,   308,   309,   310,
     311,   312,   313,   314,   315,  1900,   316,  1901,   317,   318,
     319,   320,  1902,   321,  1903,   322,   786,  1904,   787,   323,
     324,   325,  1905,   326,   327,  1906,   328,   329,  1907,   330,
     331,   332,   333,   334,   788,   335,   336,   337,   338,  1908,
     339,   340,   341,   342,   343,   344,  1909,   345,   789,   346,
     347,   348,   349,   350,   351,   352,  1910,   353,  1911,   354,
     790,   791,   355,   792,   356,   357,   358,   359,   360,  1912,
    1913,   361,   362,   793,   363,   794,  1914,   364,   365,   366,
    1915,  1916,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   795,
     384,   385,   386,   387,  1917,   388,   389,   796,   390,  1918,
     391,   392,   393,   394,   395,   396,  1919,   397,  1920,  1921,
     398,   399,   400,  1922,  1923,   401,   402,   797,   403,   798,
     404,   405,   406,   407,   408,   409,   410,   411,   412,  1924,
     413,   414,   415,   416,   417,   418,   419,   420,  1925,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,  1926,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,  1927,   445,   446,   799,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
    1928,   459,   460,   461,   462,   463,  1929,  2844,   465,   466,
     467,   468,   800,   469,   470,   471,   472,  1930,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
    1931,   485,   486,  1932,   487,   801,   488,   489,   490,   491,
     492,  1933,   493,   494,  1934,  1935,   495,   496,   497,   498,
     499,  1936,   500,   501,   502,   503,   504,   505,   506,  1937,
    1938,   507,   508,   509,   510,   511,  1939,  1940,   512,   513,
     514,   515,   516,   517,   518,  1941,   519,   802,   520,   521,
     522,   523,  1942,  1943,   524,  1944,  1945,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   779,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     223,   224,   225,   226,   227,   228,   229,   230,     0,   232,
     233,   234,     0,     0,     0,     0,     0,     0,     0,   235,
     236,     0,   237,   238,   780,   239,   240,   241,   242,   243,
     781,   244,   245,     0,   246,   247,   248,   249,   250,     0,
    1147,   251,   252,   253,   254,   255,     0,   256,   257,   258,
     259,  1150,     0,  1151,     0,   261,   262,   263,   264,   783,
     265,   266,   267,     0,   268,   269,   270,   271,   272,   273,
       0,   784,   274,   275,   276,  1152,  1153,  1154,  1155,  1156,
    1157,  1158,   277,   278,   279,   280,   281,   282,   283,   284,
     285,     0,   286,     0,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,     0,     0,   296,   297,   298,   299,
     300,     0,   301,   302,   303,     0,   304,   305,   306,     0,
     307,   308,   309,   310,   311,   312,   313,   314,  1162,     0,
     316,     0,   317,   318,   319,   320,     0,   321,     0,   322,
     786,     0,   787,   323,   324,   325,     0,   326,  1165,     0,
     328,   329,     0,   330,   331,   332,   333,   334,   788,   335,
     336,   337,   338,     0,   339,   340,   341,   342,   343,   344,
       0,   345,   789,   346,   347,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   790,   791,   355,   792,   356,   357,
     358,   359,   360,     0,     0,   361,  1170,   793,   363,   794,
       0,   364,   365,   366,  1171,  1172,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   795,   384,   385,   386,   387,     0,   388,
     389,   796,   390,     0,  1177,   392,   393,   394,   395,   396,
       0,   397,     0,     0,   398,   399,   400,     0,     0,   401,
     402,   797,   403,   798,  1180,   405,   406,   407,   408,   409,
     410,   411,   412,     0,   413,   414,  1181,   416,   417,   418,
     419,   420,     0,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,     0,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,     0,   445,
     446,   799,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,   462,   463,
    1184,   464,   465,   466,   467,   468,   800,   469,   470,   471,
     472,     0,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,  1186,     0,   485,   486,     0,   487,   801,
     488,   489,   490,   491,   492,     0,   493,   494,     0,     0,
     495,   496,  1189,   498,  1190,     0,   500,   501,   502,   503,
     504,   505,   506,     0,     0,   507,   508,   509,   510,   511,
    1193,     0,   512,   513,   514,   515,   516,   517,   518,     0,
     519,   802,   520,   521,   522,   523,     0,     0,   524,     0,
       0,   525,   526,   527,   528,   529,   530,   531,  1195,  1196,
    1197,  1198,  1199,  1200,  1201,  1202,   540,   541,   542,   823,
       0,   600,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   223,   224,   225,   226,   227,   228,
     229,   230,     0,   232,   233,   234,     0,     0,     0,     0,
       0,     0,     0,   235,   236,     0,   237,   238,   780,   239,
     240,   241,   242,   243,   781,   244,   245,     0,   246,   247,
     248,   249,   250,     0,     0,   251,   252,   253,   254,   255,
       0,   256,   257,   258,   259,   260,     0,   782,     0,   261,
     262,   263,   264,   783,   265,   266,   267,     0,   268,   269,
     270,   271,   272,   273,     0,   784,   274,   275,   276,     0,
       0,     0,   785,     0,     0,     0,   277,   278,   279,   280,
     281,   282,   283,   284,   285,     0,   286,     0,   287,   288,
     289,   290,   291,   292,     0,   293,   294,   295,     0,     0,
     296,   297,   298,   299,   300,     0,   301,   302,   303,     0,
     304,   305,   306,     0,   307,   308,   309,   310,   311,   312,
     313,   314,   315,  1681,   316,     0,   317,   318,   319,   320,
       0,   321,     0,   322,   786,     0,   787,   323,   324,   325,
       0,   326,   327,     0,   328,   329,     0,   330,   331,   332,
     333,   334,   788,   335,   336,   337,   338,     0,   339,   340,
     341,   342,   343,   344,     0,   345,   789,   346,   347,   348,
     349,   350,   351,   352,     0,   353,     0,   354,   790,   791,
     355,   792,   356,   357,   358,   359,   360,     0,     0,   361,
     362,   793,   363,   794,     0,   364,   365,   366,     0,     0,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   795,   384,   385,
     386,   387,     0,   388,   389,   796,   390,     0,   391,   392,
     393,   394,   395,   396,     0,   397,  1682,     0,   398,   399,
     400,     0,     0,   401,   402,   797,   403,   798,   404,   405,
     406,   407,   408,   409,   410,   411,   412,     0,   413,   414,
     415,   416,   417,   418,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
       0,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,     0,   445,   446,   799,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,     0,   459,
     460,   461,   462,   463,     0,   464,   465,   466,   467,   468,
     800,   469,   470,   471,   472,     0,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,     0,   485,
     486,     0,   487,   801,   488,   489,   490,   491,   492,     0,
     493,   494,     0,     0,   495,   496,   497,   498,   499,  1683,
     500,   501,   502,   503,   504,   505,   506,     0,     0,   507,
     508,   509,   510,   511,     0,     0,   512,   513,   514,   515,
     516,   517,   518,     0,   519,   802,   520,   521,   522,   523,
       0,     0,   524,     0,     0,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   823,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   223,   224,
     225,   226,   227,   228,   229,   230,   858,   232,   233,   234,
       0,     0,     0,     0,     0,     0,     0,   235,   236,     0,
     237,   238,   780,   239,   240,   241,   242,   243,   781,   244,
     245,     0,   246,   247,   248,   249,   250,     0,     0,   251,
     252,   253,   254,   255,     0,   256,   257,   258,   259,   260,
       0,   782,     0,   261,   262,   263,   264,   783,   265,   266,
     267,     0,   268,   269,   270,   271,   272,   273,     0,   784,
     274,   275,   276,     0,     0,     0,   785,     0,     0,   824,
     277,   278,   279,   280,   281,   282,   283,   284,   285,     0,
     286,     0,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,     0,     0,   296,   297,   298,   299,   300,     0,
     301,   302,   303,     0,   304,   305,   306,     0,   307,   308,
     309,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,   318,   319,   320,     0,   321,     0,   322,   786,     0,
     787,   323,   324,   325,     0,   326,   327,     0,   328,   329,
       0,   330,   331,   332,   333,   334,   788,   335,   336,   337,
     338,     0,   339,   340,   341,   342,   343,   344,     0,   345,
     789,   346,   347,   348,   349,   350,   351,   352,     0,   353,
       0,   354,   790,   791,   355,   792,   356,   357,   358,   359,
     360,     0,     0,   361,   362,   793,   363,   794,     0,   364,
     365,   366,     0,     0,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   795,   384,   385,   386,   387,     0,   388,   389,   796,
     390,     0,   391,   392,   393,   394,   395,   396,     0,   397,
       0,     0,   398,   399,   400,     0,     0,   401,   402,   797,
     403,   798,   404,   405,   406,   407,   408,   409,   410,   411,
     412,     0,   413,   414,   415,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,     0,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,     0,   445,   446,   799,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,     0,   459,   460,   461,   462,   463,   825,   464,
     465,   466,   467,   468,   800,   469,   470,   471,   472,     0,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,     0,   485,   486,     0,   487,   801,   488,   489,
     490,   491,   492,     0,   493,   494,     0,     0,   495,   496,
     497,   498,   499,     0,   500,   501,   502,   503,   504,   505,
     506,     0,     0,   507,   508,   509,   510,   511,     0,     0,
     512,   513,   514,   515,   516,   517,   518,     0,   519,   802,
     520,   521,   522,   523,     0,     0,   524,     0,     0,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   823,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   223,   224,   225,   226,   227,   228,   229,   230,
       0,   232,   233,   234,     0,     0,     0,     0,     0,     0,
       0,   235,   236,     0,   237,   238,   780,   239,   240,   241,
     242,   243,   781,   244,   245,     0,   246,   247,   248,   249,
     250,     0,     0,   251,   252,   253,   254,   255,     0,   256,
     257,   258,   259,   260,     0,   782,     0,   261,   262,   263,
     264,   783,   265,   266,   267,     0,   268,   269,   270,   271,
     272,   273,     0,   784,   274,   275,   276,     0,     0,     0,
     785,     0,     0,   824,   277,   278,   279,   280,   281,   282,
     283,   284,   285,     0,   286,     0,   287,   288,   289,   290,
     291,   292,     0,   293,   294,   295,     0,     0,   296,   297,
     298,   299,   300,     0,   301,   302,   303,     0,   304,   305,
     306,     0,   307,   308,   309,   310,   311,   312,   313,   314,
     315,     0,   316,     0,   317,   318,   319,   320,     0,   321,
       0,   322,   786,     0,   787,   323,   324,   325,     0,   326,
     327,     0,   328,   329,     0,   330,   331,   332,   333,   334,
     788,   335,   336,   337,   338,     0,   339,   340,   341,   342,
     343,   344,     0,   345,   789,   346,   347,   348,   349,   350,
     351,   352,     0,   353,     0,   354,   790,   791,   355,   792,
     356,   357,   358,   359,   360,     0,     0,   361,   362,   793,
     363,   794,     0,   364,   365,   366,     0,     0,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   795,   384,   385,   386,   387,
       0,   388,   389,   796,   390,     0,   391,   392,   393,   394,
     395,   396,     0,   397,     0,     0,   398,   399,   400,     0,
       0,   401,   402,   797,   403,   798,   404,   405,   406,   407,
     408,   409,   410,   411,   412,     0,   413,   414,   415,   416,
     417,   418,   419,   420,     0,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,     0,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
       0,   445,   446,   799,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,     0,   459,   460,   461,
     462,   463,   825,   464,   465,   466,   467,   468,   800,   469,
     470,   471,   472,     0,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,     0,   485,   486,     0,
     487,   801,   488,   489,   490,   491,   492,     0,   493,   494,
       0,     0,   495,   496,   497,   498,   499,     0,   500,   501,
     502,   503,   504,   505,   506,     0,     0,   507,   508,   509,
     510,   511,  2236,     0,   512,   513,   514,   515,   516,   517,
     518,     0,   519,   802,   520,   521,   522,   523,     0,     0,
     524,     0,     0,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   823,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   223,   224,   225,   226,
     227,   228,   229,   230,     0,   232,   233,   234,     0,     0,
       0,     0,     0,     0,     0,   235,   236,     0,   237,   238,
     780,   239,   240,   241,   242,   243,   781,   244,   245,     0,
     246,   247,   248,   249,   250,     0,     0,   251,   252,   253,
     254,   255,     0,   256,   257,   258,   259,   260,     0,   782,
       0,   261,   262,   263,   264,   783,   265,   266,   267,     0,
     268,   269,   270,   271,   272,   273,     0,   784,   274,   275,
     276,     0,     0,     0,   785,     0,     0,   824,   277,   278,
     279,   280,   281,   282,   283,   284,   285,     0,   286,     0,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
       0,     0,   296,   297,   298,   299,   300,     0,   301,   302,
     303,     0,   304,   305,   306,     0,   307,   308,   309,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,   318,
     319,   320,     0,   321,     0,   322,   786,     0,   787,   323,
     324,   325,     0,   326,   327,  3145,   328,   329,     0,   330,
     331,   332,   333,   334,   788,   335,   336,   337,   338,     0,
     339,   340,   341,   342,   343,   344,     0,   345,   789,   346,
     347,   348,   349,   350,   351,   352,     0,   353,     0,   354,
     790,   791,   355,   792,   356,   357,   358,   359,   360,     0,
       0,   361,   362,   793,   363,   794,     0,   364,   365,   366,
       0,     0,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   795,
     384,   385,   386,   387,     0,   388,   389,   796,   390,     0,
     391,   392,   393,   394,   395,   396,     0,   397,     0,     0,
     398,   399,   400,     0,     0,   401,   402,   797,   403,   798,
     404,   405,   406,   407,   408,   409,   410,   411,   412,     0,
     413,   414,   415,   416,   417,   418,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,     0,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,     0,   445,   446,   799,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
       0,   459,   460,   461,   462,   463,   825,   464,   465,   466,
     467,   468,   800,   469,   470,   471,   472,     0,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
       0,   485,   486,     0,   487,   801,   488,   489,   490,   491,
     492,     0,   493,   494,     0,     0,   495,   496,   497,   498,
     499,     0,   500,   501,   502,   503,   504,   505,   506,     0,
       0,   507,   508,   509,   510,   511,     0,     0,   512,   513,
     514,   515,   516,   517,   518,     0,   519,   802,   520,   521,
     522,   523,     0,     0,   524,     0,     0,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   823,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     223,   224,   225,   226,   227,   228,   229,   230,     0,   232,
     233,   234,     0,     0,     0,     0,     0,     0,     0,   235,
     236,     0,   237,   238,   780,   239,   240,   241,   242,   243,
     781,   244,   245,     0,   246,   247,   248,   249,   250,     0,
       0,   251,   252,   253,   254,   255,     0,   256,   257,   258,
     259,   260,     0,   782,     0,   261,   262,   263,   264,   783,
     265,   266,   267,     0,   268,   269,   270,   271,   272,   273,
       0,   784,   274,   275,   276,     0,     0,     0,   785,     0,
       0,   824,   277,   278,   279,   280,   281,   282,   283,   284,
     285,     0,   286,     0,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,     0,     0,   296,   297,   298,   299,
     300,     0,   301,   302,   303,     0,   304,   305,   306,     0,
     307,   308,   309,   310,   311,   312,   313,   314,   315,     0,
     316,     0,   317,   318,   319,   320,     0,   321,     0,   322,
     786,     0,   787,   323,   324,   325,     0,   326,   327,     0,
     328,   329,     0,   330,   331,   332,   333,   334,   788,   335,
     336,   337,   338,     0,   339,   340,   341,   342,   343,   344,
       0,   345,   789,   346,   347,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   790,   791,   355,   792,   356,   357,
     358,   359,   360,     0,     0,   361,   362,   793,   363,   794,
       0,   364,   365,   366,     0,     0,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   795,   384,   385,   386,   387,     0,   388,
     389,   796,   390,     0,   391,   392,   393,   394,   395,   396,
       0,   397,     0,     0,   398,   399,   400,     0,     0,   401,
     402,   797,   403,   798,   404,   405,   406,   407,   408,   409,
     410,   411,   412,     0,   413,   414,   415,   416,   417,   418,
     419,   420,     0,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,     0,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,     0,   445,
     446,   799,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,   462,   463,
     825,   464,   465,   466,   467,   468,   800,   469,   470,   471,
     472,     0,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,     0,   485,   486,     0,   487,   801,
     488,   489,   490,   491,   492,     0,   493,   494,     0,     0,
     495,   496,   497,   498,   499,     0,   500,   501,   502,   503,
     504,   505,   506,     0,     0,   507,   508,   509,   510,   511,
       0,     0,   512,   513,   514,   515,   516,   517,   518,     0,
     519,   802,   520,   521,   522,   523,     0,     0,   524,     0,
       0,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   823,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   223,   224,   225,   226,   227,   228,
     229,   230,     0,   232,   233,   234,     0,     0,     0,     0,
       0,     0,     0,   235,   236,     0,   237,   238,   780,   239,
     240,   241,   242,   243,   781,   244,   245,     0,   246,   247,
     248,   249,   250,     0,     0,   251,   252,   253,   254,   255,
       0,   256,   257,   258,   259,   260,     0,   782,     0,   261,
     262,   263,   264,   783,   265,   266,   267,     0,   268,   269,
     270,   271,   272,   273,     0,   784,   274,   275,   276,     0,
       0,     0,   785,     0,     0,   824,   277,   278,   279,   280,
     281,   282,   283,   284,   285,     0,   286,     0,   287,   288,
     289,   290,   291,   292,     0,   293,   294,   295,     0,     0,
     296,   297,   298,   299,   300,     0,   301,   302,   303,     0,
     304,   305,   306,     0,   307,   308,   309,   310,   311,   312,
     313,   314,   315,     0,   316,     0,   317,   318,   319,   320,
       0,   321,     0,   322,   786,     0,   787,   323,   324,   325,
       0,   326,   327,     0,   328,   329,     0,   330,   331,   332,
     333,   334,   788,   335,   336,   337,   338,     0,   339,   340,
     341,   342,   343,   344,     0,   345,   789,   346,   347,   348,
     349,   350,   351,   352,     0,   353,     0,   354,   790,   791,
     355,   792,   356,   357,   358,   359,   360,     0,     0,   361,
     362,   793,   363,   794,     0,   364,   365,   366,     0,     0,
     367,   368,   369,   370,   875,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   795,   384,   385,
     386,   387,     0,   388,   389,   796,   390,     0,   391,   392,
     393,   394,   395,   396,     0,   397,     0,     0,   398,   399,
     400,     0,     0,   401,   402,   797,   403,   798,   404,   405,
     406,   407,   408,   409,   410,   411,   412,     0,   413,   414,
     415,   416,   417,   418,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
       0,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,     0,   445,   446,   799,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,     0,   459,
     460,   461,   462,   463,   825,   464,   465,   466,   467,   468,
     800,   469,   470,   471,   472,     0,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,     0,   485,
     486,     0,   487,   801,   488,   489,   490,   491,   492,     0,
     493,   494,     0,     0,   495,   496,   497,   498,   499,     0,
     500,   501,   502,   503,   504,   505,   506,     0,     0,   507,
     508,   509,   510,   511,     0,     0,   512,   513,   514,   515,
     516,   517,   518,     0,   519,   802,   520,   521,   522,   523,
       0,     0,   524,     0,     0,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   823,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   223,   224,
     225,   226,   227,   228,   229,   230,     0,   232,   233,   234,
       0,     0,     0,     0,     0,     0,     0,   235,   236,     0,
     237,   238,   780,   239,   240,   241,   242,   243,   781,   244,
     245,     0,   246,   247,   248,   249,   250,     0,     0,   251,
     252,   253,   254,   255,     0,   256,   257,   258,   259,   260,
       0,   782,     0,   261,   262,   263,   264,   783,   265,   266,
     267,     0,   268,   269,   270,   271,   272,   273,     0,   784,
     274,   275,   276,     0,     0,     0,   785,     0,     0,   824,
     277,   278,   279,   280,   281,   282,   283,   284,   285,     0,
     286,     0,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,     0,     0,   296,   297,   298,   299,   300,     0,
     301,   302,   303,     0,   304,   305,   306,     0,   307,   308,
     309,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,   318,   319,   320,     0,   321,     0,   322,   786,     0,
     787,   323,   324,   325,     0,   326,   327,     0,   328,   329,
       0,   330,   331,   332,   333,   334,   788,   335,   336,   337,
     338,     0,   339,   340,   341,   342,   343,   344,     0,   345,
     789,   346,   347,   348,   349,   350,   351,   352,     0,   353,
       0,   354,   790,   791,   355,   792,   356,   357,   358,   359,
     360,     0,     0,   361,   362,   793,   363,   794,     0,   364,
     365,   366,     0,     0,   367,   368,   369,   370,   963,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   795,   384,   385,   386,   387,     0,   388,   389,   796,
     390,     0,   391,   392,   393,   394,   395,   396,     0,   397,
       0,     0,   398,   399,   400,     0,     0,   401,   402,   797,
     403,   798,   404,   405,   406,   407,   408,   409,   410,   411,
     412,     0,   413,   414,   415,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,     0,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,     0,   445,   446,   799,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,     0,   459,   460,   461,   462,   463,   825,   464,
     465,   466,   467,   468,   800,   469,   470,   471,   472,     0,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,     0,   485,   486,     0,   487,   801,   488,   489,
     490,   491,   492,     0,   493,   494,     0,     0,   495,   496,
     497,   498,   499,     0,   500,   501,   502,   503,   504,   505,
     506,     0,     0,   507,   508,   509,   510,   511,     0,     0,
     512,   513,   514,   515,   516,   517,   518,     0,   519,   802,
     520,   521,   522,   523,     0,     0,   524,     0,     0,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   823,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   223,   224,   225,   226,   227,   228,   229,   230,
       0,   232,   233,   234,     0,     0,     0,     0,     0,     0,
       0,   235,   236,     0,   237,   238,   780,   239,   240,   241,
     242,   243,   781,   244,   245,     0,   246,   247,   248,   249,
     250,     0,     0,   251,   252,   253,   254,   255,     0,   256,
     257,   258,   259,   260,     0,   782,     0,   261,   262,   263,
     264,   783,   265,   266,   267,     0,   268,   269,   270,   271,
     272,   273,     0,   784,   274,   275,   276,     0,     0,     0,
     785,     0,     0,   824,   277,   278,   279,   280,   281,   282,
     283,   284,   285,     0,   286,     0,   287,   288,   289,   290,
     291,   292,     0,   293,   294,   295,     0,     0,   296,   297,
     298,   299,   300,     0,   301,   302,   303,     0,   304,   305,
     306,     0,   307,   308,   309,   310,   311,   312,   313,   314,
     315,     0,   316,     0,   317,   318,   319,   320,     0,   321,
       0,   322,   786,     0,   787,   323,   324,   325,     0,   326,
     327,     0,   328,   329,     0,   330,   331,   332,   333,  1036,
     788,   335,   336,   337,   338,     0,   339,   340,   341,   342,
     343,   344,     0,   345,   789,   346,   347,   348,   349,   350,
     351,   352,     0,   353,     0,   354,   790,   791,   355,   792,
     356,   357,   358,   359,   360,     0,     0,   361,   362,   793,
     363,   794,     0,   364,   365,   366,     0,     0,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   795,   384,   385,   386,   387,
       0,   388,   389,   796,   390,     0,   391,   392,   393,   394,
     395,   396,     0,   397,     0,     0,   398,   399,   400,     0,
       0,   401,   402,   797,   403,   798,   404,   405,   406,   407,
     408,   409,   410,   411,   412,     0,   413,   414,   415,   416,
     417,   418,   419,   420,     0,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,     0,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
       0,   445,   446,   799,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,     0,   459,   460,   461,
     462,   463,   825,   464,   465,   466,   467,   468,   800,   469,
     470,   471,   472,     0,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,     0,   485,   486,     0,
     487,   801,   488,   489,   490,   491,   492,     0,   493,   494,
       0,     0,   495,   496,   497,   498,   499,     0,   500,   501,
     502,   503,   504,   505,   506,     0,     0,   507,   508,   509,
     510,   511,     0,     0,   512,   513,   514,   515,   516,   517,
     518,     0,   519,   802,   520,   521,   522,   523,     0,     0,
     524,     0,     0,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   823,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   223,   224,   225,   226,
     227,   228,   229,   230,     0,   232,   233,   234,     0,     0,
       0,     0,     0,     0,     0,   235,   236,     0,   237,   238,
     780,   239,   240,   241,   242,   243,   781,   244,   245,     0,
     246,   247,   248,   249,   250,     0,     0,   251,   252,   253,
     254,   255,     0,   256,   257,   258,   259,   260,     0,   782,
       0,   261,   262,   263,   264,   783,   265,   266,   267,     0,
     268,   269,   270,   271,   272,   273,     0,   784,   274,   275,
     276,     0,     0,     0,   785,     0,     0,   824,   277,   278,
     279,   280,   281,   282,   283,   284,   285,     0,   286,     0,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
       0,     0,   296,   297,   298,   299,   300,     0,   301,   302,
     303,     0,   304,   305,   306,     0,   307,   308,   309,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,   318,
     319,   320,     0,   321,     0,   322,   786,     0,   787,   323,
     324,   325,     0,   326,   327,     0,   328,   329,     0,   330,
     331,   332,   333,  1048,   788,   335,   336,   337,   338,     0,
     339,   340,   341,   342,   343,   344,     0,   345,   789,   346,
     347,   348,   349,   350,   351,   352,     0,   353,     0,   354,
     790,   791,   355,   792,   356,   357,   358,   359,   360,     0,
       0,   361,   362,   793,   363,   794,     0,   364,   365,   366,
       0,     0,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   795,
     384,   385,   386,   387,     0,   388,   389,   796,   390,     0,
     391,   392,   393,   394,   395,   396,     0,   397,     0,     0,
     398,   399,   400,     0,     0,   401,   402,   797,   403,   798,
     404,   405,   406,   407,   408,   409,   410,   411,   412,     0,
     413,   414,   415,   416,   417,   418,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,     0,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,     0,   445,   446,   799,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
       0,   459,   460,   461,   462,   463,   825,   464,   465,   466,
     467,   468,   800,   469,   470,   471,   472,     0,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
       0,   485,   486,     0,   487,   801,   488,   489,   490,   491,
     492,     0,   493,   494,     0,     0,   495,   496,   497,   498,
     499,     0,   500,   501,   502,   503,   504,   505,   506,     0,
       0,   507,   508,   509,   510,   511,     0,     0,   512,   513,
     514,   515,   516,   517,   518,     0,   519,   802,   520,   521,
     522,   523,     0,     0,   524,     0,     0,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   823,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     223,   224,   225,   226,   227,   228,   229,   230,     0,   232,
     233,   234,     0,     0,     0,     0,     0,     0,     0,   235,
     236,     0,   237,   238,   780,   239,   240,   241,   242,   243,
     781,   244,   245,     0,   246,   247,   248,   249,   250,     0,
       0,   251,   252,   253,   254,   255,     0,   256,   257,   258,
     259,   260,     0,   782,     0,   261,   262,   263,   264,   783,
     265,   266,   267,     0,   268,   269,   270,   271,   272,   273,
       0,   784,   274,   275,   276,     0,     0,     0,   785,     0,
       0,   824,   277,   278,   279,   280,   281,   282,   283,   284,
     285,     0,   286,     0,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,     0,     0,   296,   297,   298,   299,
     300,     0,   301,   302,   303,     0,   304,   305,   306,     0,
     307,   308,   309,   310,   311,   312,   313,   314,   315,     0,
     316,     0,   317,   318,   319,   320,     0,   321,     0,   322,
     786,     0,   787,   323,   324,   325,     0,   326,   327,     0,
     328,   329,     0,   330,   331,   332,   333,  1062,   788,   335,
     336,   337,   338,     0,   339,   340,   341,   342,   343,   344,
       0,   345,   789,   346,   347,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   790,   791,   355,   792,   356,   357,
     358,   359,   360,     0,     0,   361,   362,   793,   363,   794,
       0,   364,   365,   366,     0,     0,   367,   368,   369,   370,
    1063,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   795,   384,   385,   386,   387,     0,   388,
     389,   796,   390,     0,   391,   392,   393,   394,   395,   396,
       0,   397,     0,     0,   398,   399,   400,     0,     0,   401,
     402,   797,   403,   798,   404,   405,   406,   407,   408,   409,
     410,   411,   412,     0,   413,   414,   415,   416,   417,   418,
     419,   420,     0,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,     0,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,     0,   445,
     446,   799,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,   462,   463,
     825,   464,   465,   466,   467,   468,   800,   469,   470,   471,
     472,     0,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,     0,   485,   486,     0,   487,   801,
     488,   489,   490,   491,   492,     0,   493,   494,     0,     0,
     495,   496,   497,   498,   499,     0,   500,   501,   502,   503,
     504,   505,   506,     0,     0,   507,   508,   509,   510,   511,
       0,     0,   512,   513,   514,   515,   516,   517,   518,     0,
     519,   802,   520,   521,   522,   523,     0,     0,   524,     0,
       0,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   823,
       0,   600,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   223,   224,   225,   226,   227,   228,
     229,   230,     0,   232,   233,   234,     0,     0,     0,     0,
       0,     0,     0,   235,   236,     0,   237,   238,   780,   239,
     240,   241,   242,   243,   781,   244,   245,     0,   246,   247,
     248,   249,   250,     0,     0,   251,   252,   253,   254,   255,
       0,   256,   257,   258,   259,   260,     0,   782,     0,   261,
     262,   263,   264,   783,   265,   266,   267,     0,   268,   269,
     270,   271,   272,   273,     0,   784,   274,   275,   276,     0,
       0,     0,   785,     0,     0,     0,   277,   278,   279,   280,
     281,   282,   283,   284,   285,  1842,   286,     0,   287,   288,
     289,   290,   291,   292,     0,   293,   294,   295,     0,     0,
     296,   297,   298,   299,   300,     0,   301,   302,   303,     0,
     304,   305,   306,     0,   307,   308,   309,   310,   311,   312,
     313,   314,   315,     0,   316,     0,   317,   318,   319,   320,
       0,   321,     0,   322,   786,     0,   787,   323,   324,   325,
       0,   326,   327,     0,   328,   329,     0,   330,   331,   332,
     333,   334,   788,   335,   336,   337,   338,     0,   339,   340,
     341,   342,   343,   344,     0,   345,   789,   346,   347,   348,
     349,   350,   351,   352,     0,   353,     0,   354,   790,   791,
     355,   792,   356,   357,   358,   359,   360,     0,     0,   361,
     362,   793,   363,   794,     0,   364,   365,   366,     0,     0,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   795,   384,   385,
     386,   387,     0,   388,   389,   796,   390,     0,   391,   392,
     393,   394,   395,   396,     0,   397,     0,     0,   398,   399,
     400,     0,     0,   401,   402,   797,   403,   798,   404,   405,
     406,   407,   408,   409,   410,   411,   412,     0,   413,   414,
     415,   416,   417,   418,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
       0,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,     0,   445,   446,   799,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,     0,   459,
     460,   461,   462,   463,     0,   464,   465,   466,   467,   468,
     800,   469,   470,   471,   472,     0,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,     0,   485,
     486,     0,   487,   801,   488,   489,   490,   491,   492,     0,
     493,   494,     0,     0,   495,   496,   497,   498,   499,     0,
     500,   501,   502,   503,   504,   505,   506,     0,     0,   507,
     508,   509,   510,   511,     0,     0,   512,   513,   514,   515,
     516,   517,   518,     0,   519,   802,   520,   521,   522,   523,
       0,     0,   524,     0,     0,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   823,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   223,   224,
     225,   226,   227,   228,   229,   230,     0,   232,   233,   234,
       3,     4,     0,     0,     0,     0,     0,   235,   236,     0,
     237,   238,   780,   239,   240,   241,   242,   243,   781,   244,
     245,     0,   246,   247,   248,   249,   250,     0,     0,   251,
     252,   253,   254,   255,     0,   256,   257,   258,   259,   260,
       0,   782,     0,   261,   262,   263,   264,   783,   265,   266,
     267,     0,   268,   269,   270,   271,   272,   273,     0,   784,
     274,   275,   276,     0,     0,     0,   785,     0,     0,     0,
     277,   278,   279,   280,   281,   282,   283,   284,   285,     0,
     286,     0,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,     0,     0,   296,   297,   298,   299,   300,     0,
     301,   302,   303,     0,   304,   305,   306,     0,   307,   308,
     309,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,   318,   319,   320,     0,   321,     0,   322,   786,     0,
     787,   323,   324,   325,     0,   326,   327,     0,   328,   329,
       0,   330,   331,   332,   333,   334,   788,   335,   336,   337,
     338,     0,   339,   340,   341,   342,   343,   344,     0,   345,
     789,   346,   347,   348,   349,   350,   351,   352,     0,   353,
       0,   354,   790,   791,   355,   792,   356,   357,   358,   359,
     360,     0,     0,   361,   362,   793,   363,   794,     0,   364,
     365,   366,     0,     0,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   795,   384,   385,   386,   387,     0,   388,   389,   796,
     390,     0,   391,   392,   393,   394,   395,   396,     0,   397,
       0,     0,   398,   399,   400,     0,     0,   401,   402,   797,
     403,   798,   404,   405,   406,   407,   408,   409,   410,   411,
     412,     0,   413,   414,   415,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,     0,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,     0,   445,   446,   799,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,     0,   459,   460,   461,   462,   463,     0,   464,
     465,   466,   467,   468,   800,   469,   470,   471,   472,     0,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,     0,   485,   486,     0,   487,   801,   488,   489,
     490,   491,   492,     0,   493,   494,     0,     0,   495,   496,
     497,   498,   499,     0,   500,   501,   502,   503,   504,   505,
     506,     0,     0,   507,   508,   509,   510,   511,     0,     0,
     512,   513,   514,   515,   516,   517,   518,     0,   519,   802,
     520,   521,   522,   523,     0,     0,   524,     0,     0,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   823,     0,   600,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   223,   224,   225,   226,   227,   228,   229,   230,
       0,   232,   233,   234,     0,     0,     0,     0,     0,     0,
       0,   235,   236,     0,   237,   238,   780,   239,   240,   241,
     242,   243,   781,   244,   245,     0,   246,   247,   248,   249,
     250,     0,     0,   251,   252,   253,   254,   255,     0,   256,
     257,   258,   259,   260,     0,   782,     0,   261,   262,   263,
     264,   783,   265,   266,   267,     0,   268,   269,   270,   271,
     272,   273,     0,   784,   274,   275,   276,     0,     0,     0,
     785,     0,     0,     0,   277,   278,   279,   280,   281,   282,
     283,   284,   285,     0,   286,     0,   287,   288,   289,   290,
     291,   292,     0,   293,   294,   295,     0,     0,   296,   297,
     298,   299,   300,     0,   301,   302,   303,     0,   304,   305,
     306,     0,   307,   308,   309,   310,   311,   312,   313,   314,
     315,     0,   316,     0,   317,   318,   319,   320,     0,   321,
       0,   322,   786,     0,   787,   323,   324,   325,     0,   326,
     327,     0,   328,   329,     0,   330,   331,   332,   333,   334,
     788,   335,   336,   337,   338,     0,   339,   340,   341,   342,
     343,   344,     0,   345,   789,   346,   347,   348,   349,   350,
     351,   352,     0,   353,     0,   354,   790,   791,   355,   792,
     356,   357,   358,   359,   360,     0,     0,   361,   362,   793,
     363,   794,     0,   364,   365,   366,     0,     0,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   795,   384,   385,   386,   387,
       0,   388,   389,   796,   390,     0,   391,   392,   393,   394,
     395,   396,     0,   397,     0,     0,   398,   399,   400,     0,
       0,   401,   402,   797,   403,   798,   404,   405,   406,   407,
     408,   409,   410,   411,   412,     0,   413,   414,   415,   416,
     417,   418,   419,   420,     0,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,     0,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
       0,   445,   446,   799,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,     0,   459,   460,   461,
     462,   463,     0,   464,   465,   466,   467,   468,   800,   469,
     470,   471,   472,     0,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,     0,   485,   486,     0,
     487,   801,   488,   489,   490,   491,   492,     0,   493,   494,
       0,     0,   495,   496,   497,   498,   499,     0,   500,   501,
     502,   503,   504,   505,   506,     0,     0,   507,   508,   509,
     510,   511,     0,     0,   512,   513,   514,   515,   516,   517,
     518,     0,   519,   802,   520,   521,   522,   523,     0,     0,
     524,     0,     0,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   823,     0,   600,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   223,   224,   225,   226,
     227,   228,   229,   230,     0,   232,   233,   234,     0,     0,
       0,     0,     0,     0,     0,   235,   236,     0,   237,   238,
     780,   239,   240,   241,   242,   243,   781,   244,   245,     0,
     246,   247,   248,   249,   250,     0,     0,   251,   252,   253,
     254,   255,     0,   256,   257,   258,   259,   260,     0,   782,
       0,   261,   262,   263,   264,   783,   265,   266,   267,     0,
     268,   269,   270,   271,   272,   273,     0,   784,   274,   275,
     276,     0,     0,     0,   785,     0,     0,     0,   277,   278,
     279,   280,   281,   282,   283,   284,   285,     0,   286,     0,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
       0,     0,   296,   297,   298,   299,   300,     0,   301,   302,
     303,     0,   304,   305,   306,     0,   307,   308,   309,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,   318,
     319,   320,     0,   321,     0,   322,   786,     0,   787,   323,
     324,   325,     0,   326,   327,     0,   328,   329,     0,   330,
     331,   332,   333,  1671,   788,   335,   336,   337,   338,     0,
     339,   340,   341,   342,   343,   344,     0,   345,   789,   346,
     347,   348,   349,   350,   351,   352,     0,   353,     0,   354,
     790,   791,   355,   792,   356,   357,   358,   359,   360,     0,
       0,   361,   362,   793,   363,   794,     0,   364,   365,   366,
       0,     0,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   795,
     384,   385,   386,   387,     0,   388,   389,   796,   390,     0,
     391,   392,   393,   394,   395,   396,     0,   397,     0,     0,
     398,   399,   400,     0,     0,   401,   402,   797,   403,   798,
     404,   405,   406,   407,   408,   409,   410,   411,   412,     0,
     413,   414,   415,   416,   417,   418,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,     0,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,     0,   445,   446,   799,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
       0,   459,   460,   461,   462,   463,     0,   464,   465,   466,
     467,   468,   800,   469,   470,   471,   472,     0,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
       0,   485,   486,     0,   487,   801,   488,   489,   490,   491,
     492,     0,   493,   494,     0,     0,   495,   496,   497,   498,
     499,     0,   500,   501,   502,   503,   504,   505,   506,     0,
       0,   507,   508,   509,   510,   511,     0,     0,   512,   513,
     514,   515,   516,   517,   518,     0,   519,   802,   520,   521,
     522,   523,     0,     0,   524,     0,     0,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   779,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     223,   224,   225,   226,   227,   228,   229,   230,     0,   232,
     233,   234,     0,     0,     0,     0,     0,     0,     0,   235,
     236,     0,   237,   238,   780,   239,   240,   241,   242,   243,
     781,   244,   245,     0,   246,   247,   248,   249,   250,     0,
       0,   251,   252,   253,   254,   255,     0,   256,   257,   258,
     259,   260,     0,   782,     0,   261,   262,   263,   264,   783,
     265,   266,   267,     0,   268,   269,   270,   271,   272,   273,
       0,   784,   274,   275,   276,     0,     0,     0,   785,     0,
       0,     0,   277,   278,   279,   280,   281,   282,   283,   284,
     285,     0,   286,     0,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,     0,     0,   296,   297,   298,   299,
     300,     0,   301,   302,   303,     0,   304,   305,   306,     0,
     307,   308,   309,   310,   311,   312,   313,   314,   315,     0,
     316,     0,   317,   318,   319,   320,     0,   321,     0,   322,
     786,     0,   787,   323,   324,   325,     0,   326,   327,     0,
     328,   329,     0,   330,   331,   332,   333,   334,   788,   335,
     336,   337,   338,     0,   339,   340,   341,   342,   343,   344,
       0,   345,   789,   346,   347,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   790,   791,   355,   792,   356,   357,
     358,   359,   360,     0,     0,   361,   362,   793,   363,   794,
       0,   364,   365,   366,     0,     0,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   795,   384,   385,   386,   387,     0,   388,
     389,   796,   390,     0,   391,   392,   393,   394,   395,   396,
       0,   397,     0,     0,   398,   399,   400,     0,     0,   401,
     402,   797,   403,   798,   404,   405,   406,   407,   408,   409,
     410,   411,   412,     0,   413,   414,   415,   416,   417,   418,
     419,   420,     0,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,     0,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,     0,   445,
     446,   799,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,   462,   463,
       0,   464,   465,   466,   467,   468,   800,   469,   470,   471,
     472,     0,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,     0,   485,   486,     0,   487,   801,
     488,   489,   490,   491,   492,     0,   493,   494,     0,     0,
     495,   496,   497,   498,   499,     0,   500,   501,   502,   503,
     504,   505,   506,     0,     0,   507,   508,   509,   510,   511,
       0,     0,   512,   513,   514,   515,   516,   517,   518,     0,
     519,   802,   520,   521,   522,   523,     0,     0,   524,     0,
       0,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   779,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   223,   224,   225,   226,   227,   228,
     229,   230,     0,   232,   233,   234,     0,     0,     0,     0,
       0,     0,     0,   235,   236,     0,   237,   238,   780,   239,
     240,   241,   242,   243,   781,   244,   245,     0,   246,   247,
     248,   249,   250,     0,     0,   251,   252,   253,   254,   255,
       0,   256,   257,   258,   259,   260,     0,   782,     0,   261,
     262,   263,   264,   783,   265,   266,   267,     0,   268,   269,
     270,   271,   272,   273,     0,   784,   274,   275,   276,     0,
       0,     0,   785,     0,     0,     0,   277,   278,   279,   280,
     281,   282,   283,   284,   285,     0,   286,     0,   287,   288,
     289,   290,   291,   292,     0,   293,   294,   295,     0,     0,
     296,   297,   298,   299,   300,     0,   301,   302,   303,     0,
     304,   305,   306,     0,   307,   308,   309,   310,   311,   312,
     313,   314,   315,     0,   316,     0,   317,   318,   319,   320,
       0,   321,     0,   322,   786,     0,   787,   323,   324,   325,
       0,   326,   327,     0,   328,   329,     0,   330,   331,   332,
     333,   985,   788,   335,   336,   337,   338,     0,   339,   340,
     341,   342,   343,   344,     0,   345,   789,   346,   347,   348,
     349,   350,   351,   352,     0,   353,     0,   354,   790,   791,
     355,   792,   356,   357,   358,   359,   360,     0,     0,   361,
     362,   793,   363,   794,     0,   364,   365,   366,     0,     0,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   795,   384,   385,
     386,   387,     0,   388,   389,   796,   390,     0,   391,   392,
     393,   394,   395,   396,     0,   397,     0,     0,   398,   399,
     400,     0,     0,   401,   402,   797,   403,   798,   404,   405,
     406,   407,   408,   409,   410,   411,   412,     0,   413,   414,
     415,   416,   417,   418,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
       0,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,     0,   445,   446,   799,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,     0,   459,
     460,   461,   462,   463,     0,   464,   465,   466,   467,   468,
     800,   469,   470,   471,   472,     0,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,     0,   485,
     486,     0,   487,   801,   488,   489,   490,   491,   492,     0,
     493,   494,     0,     0,   495,   496,   497,   498,   499,     0,
     500,   501,   502,   503,   504,   505,   506,     0,     0,   507,
     508,   509,   510,   511,     0,     0,   512,   513,   514,   515,
     516,   517,   518,     0,   519,   802,   520,   521,   522,   523,
       0,     0,   524,     0,     0,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   779,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   223,   224,
     225,   226,   227,   228,   229,   230,     0,   232,   233,   234,
       0,     0,     0,     0,     0,     0,     0,   235,   236,     0,
     237,   238,   780,   239,   240,   241,   242,   243,   781,   244,
     245,     0,   246,   247,   248,   249,   250,     0,     0,   251,
     252,   253,   254,   255,     0,   256,   257,   258,   259,   260,
       0,   782,     0,   261,   262,   263,   264,   783,   265,   266,
     267,     0,   268,   269,   270,   271,   272,   273,     0,   784,
     274,   275,   276,     0,     0,     0,   785,     0,     0,     0,
     277,   278,   279,   280,   281,   282,   283,   284,   285,     0,
     286,     0,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,     0,     0,   296,   297,   298,   299,   300,     0,
     301,   302,   303,     0,   304,   305,   306,     0,   307,   308,
     309,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,   318,   319,   320,     0,   321,     0,   322,   786,     0,
     787,   323,   324,   325,     0,   326,   327,     0,   328,   329,
       0,   330,   331,   332,   333,  1034,   788,   335,   336,   337,
     338,     0,   339,   340,   341,   342,   343,   344,     0,   345,
     789,   346,   347,   348,   349,   350,   351,   352,     0,   353,
       0,   354,   790,   791,   355,   792,   356,   357,   358,   359,
     360,     0,     0,   361,   362,   793,   363,   794,     0,   364,
     365,   366,     0,     0,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   795,   384,   385,   386,   387,     0,   388,   389,   796,
     390,     0,   391,   392,   393,   394,   395,   396,     0,   397,
       0,     0,   398,   399,   400,     0,     0,   401,   402,   797,
     403,   798,   404,   405,   406,   407,   408,   409,   410,   411,
     412,     0,   413,   414,   415,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,     0,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,     0,   445,   446,   799,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,     0,   459,   460,   461,   462,   463,     0,   464,
     465,   466,   467,   468,   800,   469,   470,   471,   472,     0,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,     0,   485,   486,     0,   487,   801,   488,   489,
     490,   491,   492,     0,   493,   494,     0,     0,   495,   496,
     497,   498,   499,     0,   500,   501,   502,   503,   504,   505,
     506,     0,     0,   507,   508,   509,   510,   511,     0,     0,
     512,   513,   514,   515,   516,   517,   518,     0,   519,   802,
     520,   521,   522,   523,     0,     0,   524,     0,     0,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   222,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   223,   224,   225,   226,   227,   228,   229,   230,
       0,   232,   233,   234,     0,     0,     0,     0,     0,     0,
       0,   235,   236,     0,   237,   238,     0,   239,   240,   241,
     242,   243,     0,   244,   245,     0,   246,   247,   248,   249,
     250,     0,     0,   251,   252,   253,   254,   255,  2048,   256,
     257,   258,   259,   260,     0,     0,  2125,   261,   262,   263,
     264,     0,   265,   266,   267,  2049,   268,   269,   270,   271,
     272,   273,     0,     0,   274,   275,   276,     0,     0,     0,
       0,     0,     0,     0,   277,   278,   279,   280,   281,   282,
     283,   284,   285,     0,   286,     0,   287,   288,   289,   290,
     291,   292,     0,   293,   294,   295,     0,     0,   296,   297,
     298,   299,   300,     0,   301,   302,   303,     0,   304,   305,
     306,     0,  2126,   308,   309,   310,   311,   312,   313,   314,
     315,     0,   316,     0,   317,   318,   319,   320,     0,   321,
    2051,   322,     0,     0,     0,   323,   324,   325,     0,   326,
     327,     0,   328,   329,     0,   330,   331,   332,   333,  2127,
       0,   335,   336,   337,   338,     0,   339,   340,   341,   342,
     343,   344,     0,   345,     0,   346,   347,   348,   349,   350,
     351,   352,     0,   353,     0,   354,     0,     0,   355,     0,
     356,   357,   358,   359,   360,     0,     0,   361,   362,     0,
     363,     0,     0,   364,   365,   366,     0,     0,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,     0,   384,   385,   386,   387,
       0,   388,   389,     0,   390,     0,   391,   392,   393,   394,
     395,   396,     0,   397,     0,     0,   398,   399,   400,     0,
       0,   401,   402,     0,   403,     0,   404,   405,   406,   407,
     408,   409,   410,   411,   412,     0,   413,   414,   415,   416,
     417,   418,   419,   420,  2052,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,     0,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
       0,   445,   446,     0,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,     0,   459,   460,   461,
     462,   463,     0,   464,   465,   466,   467,   468,     0,   469,
     470,   471,   472,     0,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,     0,   485,   486,     0,
     487,     0,   488,   489,   490,   491,   492,     0,   493,   494,
       0,     0,   495,   496,   497,   498,   499,     0,   500,   501,
     502,   503,   504,   505,   506,     0,  2053,   507,   508,   509,
     510,   511,     0,     0,   512,   513,   514,   515,   516,   517,
     518,     0,   519,     0,   520,   521,   522,   523,     0,     0,
     524,     0,     0,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   222,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   223,   224,   225,   226,
     227,   228,   229,   230,     0,   232,   233,   234,     0,     0,
       0,     0,     0,     0,     0,   235,   236,     0,   237,   238,
       0,   239,   240,   241,   242,   243,     0,   244,   245,     0,
     246,   247,   248,   249,   250,     0,     0,   251,   252,   253,
     254,   255,  2048,   256,   257,   258,   259,   260,     0,     0,
       0,   261,   262,   263,   264,     0,   265,   266,   267,  2049,
     268,   269,   270,   271,   272,   273,     0,     0,   274,   275,
     276,     0,     0,     0,     0,     0,     0,     0,   277,   278,
     279,   280,   281,   282,   283,   284,   285,     0,   286,     0,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
       0,     0,   296,   297,   298,   299,   300,     0,   301,   302,
     303,     0,   304,   305,   306,     0,  2126,   308,   309,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,   318,
     319,   320,     0,   321,  2051,   322,     0,     0,     0,   323,
     324,   325,     0,   326,   327,     0,   328,   329,     0,   330,
     331,   332,   333,   334,     0,   335,   336,   337,   338,     0,
     339,   340,   341,   342,   343,   344,     0,   345,     0,   346,
     347,   348,   349,   350,   351,   352,     0,   353,     0,   354,
       0,     0,   355,     0,   356,   357,   358,   359,   360,     0,
       0,   361,   362,     0,   363,  3010,     0,   364,   365,   366,
       0,     0,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,     0,
     384,   385,   386,   387,     0,   388,   389,     0,   390,     0,
     391,   392,   393,   394,   395,   396,     0,   397,     0,     0,
     398,   399,   400,     0,     0,   401,   402,     0,   403,     0,
     404,   405,   406,   407,   408,   409,   410,   411,   412,     0,
     413,   414,   415,   416,   417,   418,   419,   420,  2052,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,     0,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,     0,   445,   446,     0,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
       0,   459,   460,   461,   462,   463,     0,   464,   465,   466,
     467,   468,     0,   469,   470,   471,   472,     0,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
       0,   485,   486,     0,   487,     0,   488,   489,   490,   491,
     492,     0,   493,   494,     0,     0,   495,   496,   497,   498,
     499,     0,   500,   501,   502,   503,   504,   505,   506,     0,
    2053,   507,   508,   509,   510,   511,     0,     0,   512,   513,
     514,   515,   516,   517,   518,     0,   519,     0,   520,   521,
     522,   523,     0,     0,   524,     0,     0,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   222,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     223,   224,   225,   226,   227,   711,   229,   230,   673,   232,
     233,   234,     0,     0,     0,     0,     0,     0,     0,   235,
     236,     0,   237,   238,     0,   239,   240,   241,   242,   243,
       0,   244,   245,     0,   246,   247,   248,   249,   250,     0,
       0,   251,   252,   253,   254,   255,     0,   256,   257,   258,
     259,   260,     0,     0,     0,   261,   262,   263,   264,     0,
     265,   266,   267,     0,   268,   269,   270,   271,   272,   273,
     674,     0,   274,   275,   276,     0,     0,     0,     0,     0,
       0,     0,   277,   278,   279,   280,   281,   282,   283,   284,
     285,     0,   286,     0,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,     0,     0,   296,   297,   298,   299,
     300,     0,   301,   302,   303,     0,   304,   305,   306,     0,
     307,   308,   309,   310,   311,   312,   313,   314,   315,     0,
     316,     0,   317,   318,   319,   320,     0,   321,     0,   322,
       0,     0,     0,   323,   324,   325,   712,   326,   327,     0,
     328,   329,     0,   330,   331,   332,   333,   334,     0,   335,
     336,   337,   338,     0,   339,   340,   341,   342,   343,   344,
       0,   345,     0,   346,   347,   348,   349,   350,   351,   352,
       0,   353,     0,   354,     0,     0,   355,     0,   356,   357,
     358,   359,   360,     0,     0,   361,   362,     0,   363,     0,
       0,   364,   365,   366,     0,     0,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,     0,   384,   385,   386,   387,     0,   388,
     389,     0,   390,     0,   391,   392,   393,   394,   395,   396,
       0,   397,     0,     0,   398,   399,   400,     0,     0,   401,
     402,     0,   403,     0,   404,   405,   406,   407,   408,   409,
     410,   411,   412,     0,   413,   414,   415,   416,   417,   418,
     419,   420,     0,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   675,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,     0,   445,
     446,     0,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   676,   459,   460,   461,   462,   463,
       0,   464,   465,   466,   467,   468,     0,   469,   470,   471,
     472,     0,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,     0,   485,   486,     0,   487,     0,
     488,   489,   490,   491,   492,     0,   493,   494,     0,     0,
     495,   496,   497,   498,   499,     0,   500,   501,   502,   503,
     504,   505,   506,     0,     0,   507,   508,   509,   510,   511,
       0,     0,   512,   513,   514,   515,   516,   517,   518,     0,
     519,     0,   520,   521,   522,   523,     0,     0,   524,     0,
       0,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   222,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   223,   224,   225,   226,   227,   228,
     229,   230,   673,   232,   233,   234,     0,     0,     0,     0,
       0,     0,     0,   235,   236,     0,   237,   238,     0,   239,
     240,   241,   242,   243,     0,   244,   245,     0,   246,   247,
     248,   249,   250,     0,     0,   251,   252,   253,   254,   255,
       0,   256,   257,   258,   259,   260,     0,     0,     0,   261,
     262,   263,   264,     0,   265,   266,   267,     0,   268,   269,
     270,   271,   272,   273,   674,     0,   274,   275,   276,     0,
       0,     0,     0,     0,     0,     0,   277,   278,   279,   280,
     281,   282,   283,   284,   285,     0,   286,     0,   287,   288,
     289,   290,   291,   292,     0,   293,   294,   295,     0,     0,
     296,   297,   298,   299,   300,     0,   301,   302,   303,     0,
     304,   305,   306,     0,   307,   308,   309,   310,   311,   312,
     313,   314,   315,     0,   316,     0,   317,   318,   319,   320,
       0,   321,     0,   322,     0,     0,     0,   323,   324,   325,
    2735,   326,   327,     0,   328,   329,     0,   330,   331,   332,
     333,   334,     0,   335,   336,   337,   338,     0,   339,   340,
     341,   342,   343,   344,     0,   345,     0,   346,   347,   348,
     349,   350,   351,   352,     0,   353,     0,   354,     0,     0,
     355,     0,   356,   357,   358,   359,   360,     0,     0,   361,
     362,     0,   363,     0,     0,   364,   365,   366,     0,     0,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,     0,   384,   385,
     386,   387,     0,   388,   389,     0,   390,     0,   391,   392,
     393,   394,   395,   396,     0,   397,     0,     0,   398,   399,
     400,     0,     0,   401,   402,     0,   403,     0,   404,   405,
     406,   407,   408,   409,   410,   411,   412,     0,   413,   414,
     415,   416,   417,   418,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     675,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,     0,   445,   446,     0,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   676,   459,
     460,   461,   462,   463,     0,   464,   465,   466,   467,   468,
       0,   469,   470,   471,   472,     0,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,     0,   485,
     486,     0,   487,     0,   488,   489,   490,   491,   492,     0,
     493,   494,     0,     0,   495,   496,   497,   498,   499,     0,
     500,   501,   502,   503,   504,   505,   506,     0,     0,   507,
     508,   509,   510,   511,     0,     0,   512,   513,   514,   515,
     516,   517,   518,     0,   519,     0,   520,   521,   522,   523,
       0,     0,   524,     0,     0,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   222,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   223,   224,
     225,   226,   227,   228,   229,   230,     0,   232,   233,   234,
       0,     0,     0,     0,     0,     0,     0,   235,   236,     0,
     237,   238,     0,   239,   240,   241,   242,   243,     0,   244,
     245,     0,   246,   247,   248,   249,   250,     0,     0,   251,
     252,   253,   254,   255,  2048,   256,   257,   258,   259,   260,
       0,     0,     0,   261,   262,   263,   264,     0,   265,   266,
     267,  2049,   268,   269,   270,   271,   272,   273,     0,     0,
     274,   275,   276,     0,     0,     0,     0,     0,     0,     0,
     277,   278,   279,   280,   281,   282,   283,   284,   285,     0,
     286,     0,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,     0,     0,   296,   297,   298,   299,   300,     0,
     301,   302,   303,     0,   304,   305,   306,     0,  2126,   308,
     309,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,   318,   319,   320,     0,   321,  2051,   322,     0,     0,
       0,   323,   324,   325,     0,   326,   327,     0,   328,   329,
       0,   330,   331,   332,   333,   334,     0,   335,   336,   337,
     338,     0,   339,   340,   341,   342,   343,   344,     0,   345,
       0,   346,   347,   348,   349,   350,   351,   352,     0,   353,
       0,   354,     0,     0,   355,     0,   356,   357,   358,   359,
     360,     0,     0,   361,   362,     0,   363,     0,     0,   364,
     365,   366,     0,     0,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,     0,   384,   385,   386,   387,     0,   388,   389,     0,
     390,     0,   391,   392,   393,   394,   395,   396,     0,   397,
       0,     0,   398,   399,   400,     0,     0,   401,   402,     0,
     403,     0,   404,   405,   406,   407,   408,   409,   410,   411,
     412,     0,   413,   414,   415,   416,   417,   418,   419,   420,
    2052,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,     0,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,     0,   445,   446,     0,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,     0,   459,   460,   461,   462,   463,     0,   464,
     465,   466,   467,   468,     0,   469,   470,   471,   472,     0,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,     0,   485,   486,     0,   487,     0,   488,   489,
     490,   491,   492,     0,   493,   494,     0,     0,   495,   496,
     497,   498,   499,     0,   500,   501,   502,   503,   504,   505,
     506,     0,  2053,   507,   508,   509,   510,   511,     0,     0,
     512,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     520,   521,   522,   523,     0,     0,   524,     0,     0,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   222,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   223,   224,   225,   226,   227,   228,   229,   230,
     673,   232,   233,   234,     0,     0,     0,     0,     0,     0,
       0,   235,   236,     0,   237,   238,     0,   239,   240,   241,
     242,   243,     0,   244,   245,     0,   246,   247,   248,   249,
     250,     0,     0,   251,   252,   253,   254,   255,     0,   256,
     257,   258,   259,   260,     0,     0,     0,   261,   262,   263,
     264,     0,   265,   266,   267,     0,   268,   269,   270,   271,
     272,   273,   674,     0,   274,   275,   276,     0,     0,     0,
       0,     0,     0,     0,   277,   278,   279,   280,   281,   282,
     283,   284,   285,     0,   286,     0,   287,   288,   289,   290,
     291,   292,     0,   293,   294,   295,     0,     0,   296,   297,
     298,   299,   300,     0,   301,   302,   303,     0,   304,   305,
     306,     0,   307,   308,   309,   310,   311,   312,   313,   314,
     315,     0,   316,     0,   317,   318,   319,   320,     0,   321,
       0,   322,     0,     0,     0,   323,   324,   325,     0,   326,
     327,     0,   328,   329,     0,   330,   331,   332,   333,   334,
       0,   335,   336,   337,   338,     0,   339,   340,   341,   342,
     343,   344,     0,   345,     0,   346,   347,   348,   349,   350,
     351,   352,     0,   353,     0,   354,     0,     0,   355,     0,
     356,   357,   358,   359,   360,     0,     0,   361,   362,     0,
     363,     0,     0,   364,   365,   366,     0,     0,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,     0,   384,   385,   386,   387,
       0,   388,   389,     0,   390,     0,   391,   392,   393,   394,
     395,   396,     0,   397,     0,     0,   398,   399,   400,     0,
       0,   401,   402,     0,   403,     0,   404,   405,   406,   407,
     408,   409,   410,   411,   412,     0,   413,   414,   415,   416,
     417,   418,   419,   420,     0,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   675,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
       0,   445,   446,     0,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   676,   459,   460,   461,
     462,   463,     0,   464,   465,   466,   467,   468,     0,   469,
     470,   471,   472,     0,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,     0,   485,   486,     0,
     487,     0,   488,   489,   490,   491,   492,     0,   493,   494,
       0,     0,   495,   496,   497,   498,   499,     0,   500,   501,
     502,   503,   504,   505,   506,     0,     0,   507,   508,   509,
     510,   511,     0,     0,   512,   513,   514,   515,   516,   517,
     518,     0,   519,     0,   520,   521,   522,   523,     0,     0,
     524,     0,     0,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   222,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   223,   224,   225,   226,
     227,   228,   229,   230,  1708,   232,   233,   234,     0,     0,
       0,     0,     0,     0,     0,   235,   236,     0,   237,   238,
       0,   239,   240,   241,   242,   243,     0,   244,   245,     0,
     246,   247,   248,   249,   250,     0,     0,   251,   252,   253,
     254,   255,     0,   256,   257,   258,   259,   260,     0,     0,
       0,   261,   262,   263,   264,     0,   265,   266,   267,     0,
     268,   269,   270,   271,   272,   273,     0,     0,   274,   275,
     276,     0,     0,     0,     0,     0,     0,     0,   277,   278,
     279,  1709,   281,   282,   283,   284,   285,     0,   286,     0,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
       0,     0,   296,  1710,   298,   299,   300,     0,   301,   302,
     303,     0,   304,   305,   306,     0,   307,   308,   309,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,   318,
     319,   320,     0,   321,  1711,   322,     0,     0,     0,  1712,
     324,   325,     0,   326,   327,     0,   328,   329,     0,   330,
     331,   332,   333,   334,     0,   335,   336,   337,   338,     0,
     339,   340,   341,   342,   343,   344,     0,   345,     0,   346,
     347,   348,   349,   350,   351,   352,     0,   353,     0,   354,
       0,     0,   355,     0,   356,   357,  1713,  1714,   360,     0,
       0,   361,   362,     0,   363,     0,     0,   364,   365,   366,
       0,     0,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,     0,
     384,   385,   386,   387,     0,   388,   389,     0,   390,     0,
     391,   392,   393,   394,   395,   396,     0,   397,     0,     0,
     398,   399,   400,     0,     0,   401,   402,     0,   403,     0,
     404,   405,   406,   407,   408,   409,   410,   411,   412,     0,
     413,   414,   415,   416,   417,   418,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,     0,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,     0,   445,   446,     0,   447,   448,
     449,   450,   451,   452,   453,  1715,   455,   456,   457,   458,
       0,  1716,   460,   461,   462,   463,     0,   464,   465,   466,
     467,   468,     0,   469,   470,   471,   472,     0,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
       0,   485,   486,  1717,   487,     0,  1718,   489,   490,   491,
     492,     0,   493,   494,     0,     0,   495,   496,   497,   498,
     499,     0,   500,   501,  1719,   503,   504,   505,   506,     0,
       0,   507,   508,   509,   510,   511,     0,     0,   512,   513,
     514,   515,   516,   517,   518,     0,   519,     0,   520,   521,
     522,   523,     0,     0,   524,     0,     0,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   222,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     223,   224,   225,   226,   227,   228,   229,   230,     0,   232,
     233,   234,     0,     0,     0,     0,     0,     0,     0,   235,
     236,     0,   237,   238,     0,   239,   240,   241,   242,   243,
       0,   244,   245,     0,   246,   247,   248,   249,   250,     0,
       0,   251,   252,   253,   254,   255,     0,   256,   257,   258,
     259,   260,     0,     0,     0,   261,   262,   263,   264,     0,
     265,   266,   267,     0,   268,   269,   270,   271,   272,   273,
     674,     0,   274,   275,   276,     0,     0,     0,     0,     0,
       0,     0,   277,   278,   279,   280,   281,   282,   283,   284,
     285,     0,   286,     0,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,     0,     0,   296,   297,   298,   299,
     300,     0,   301,   302,   303,     0,   304,   305,   306,     0,
     307,   308,   309,   310,   311,   312,   313,   314,   315,     0,
     316,     0,   317,   318,   319,   320,     0,   321,     0,   322,
       0,     0,     0,   323,   324,   325,     0,   326,   327,     0,
     328,   329,     0,   330,   331,   332,   333,   334,     0,   335,
     336,   337,   338,     0,   339,   340,   341,   342,   343,   344,
       0,   345,     0,   346,   347,   348,   349,   350,   351,   352,
       0,   353,     0,   354,     0,     0,   355,     0,   356,   357,
     358,   359,   360,     0,     0,   361,   362,     0,   363,     0,
       0,   364,   365,   366,     0,     0,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,     0,   384,   385,   386,   387,     0,   388,
     389,     0,   390,     0,   391,   392,   393,   394,   395,   396,
       0,   397,     0,     0,   398,   399,   400,     0,     0,   401,
     402,     0,   403,     0,   404,   405,   406,   407,   408,   409,
     410,   411,   412,     0,   413,   414,   415,   416,   417,   418,
     419,   420,     0,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   675,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,     0,   445,
     446,     0,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   676,   459,   460,   461,   462,   463,
       0,   464,   465,   466,   467,   468,     0,   469,   470,   471,
     472,     0,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,     0,   485,   486,     0,   487,     0,
     488,   489,   490,   491,   492,     0,   493,   494,     0,     0,
     495,   496,   497,   498,   499,     0,   500,   501,   502,   503,
     504,   505,   506,     0,     0,   507,   508,   509,   510,   511,
       0,     0,   512,   513,   514,   515,   516,   517,   518,     0,
     519,     0,   520,   521,   522,   523,     0,     0,   524,     0,
       0,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   222,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   223,   224,   225,   226,   227,   228,
     229,   230,   868,   232,   233,   234,     0,     0,     0,     0,
       0,     0,     0,   235,   236,     0,   237,   238,     0,   239,
     240,   241,   242,   243,     0,   244,   245,     0,   246,   247,
     248,   249,   250,     0,     0,   251,   252,   253,   254,   255,
       0,   256,   257,   258,   259,   260,     0,     0,     0,   261,
     262,   263,   264,     0,   265,   266,   267,     0,   268,   269,
     270,   271,   272,   273,     0,     0,   274,   275,   276,     0,
       0,     0,     0,     0,     0,     0,   277,   278,   279,   280,
     281,   282,   283,   284,   285,     0,   286,     0,   287,   288,
     289,   290,   291,   292,     0,   293,   294,   295,     0,     0,
     296,   297,   298,   299,   300,     0,   301,   302,   303,     0,
     304,   305,   306,     0,   307,   308,   309,   310,   311,   312,
     313,   314,   315,     0,   316,     0,   317,   318,   319,   320,
       0,   321,     0,   322,     0,     0,     0,   323,   324,   325,
       0,   326,   327,     0,   328,   329,     0,   330,   331,   332,
     333,   869,     0,   335,   336,   337,   338,     0,   339,   340,
     341,   342,   343,   344,     0,   345,     0,   346,   347,   348,
     349,   350,   351,   352,     0,   353,     0,   354,     0,     0,
     355,     0,   356,   357,   358,   359,   360,     0,     0,   361,
     362,     0,   363,     0,     0,   364,   365,   366,     0,     0,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,     0,   384,   385,
     386,   387,     0,   388,   389,     0,   390,     0,   391,   392,
     393,   394,   395,   396,     0,   397,     0,   743,   398,   399,
     400,     0,     0,   401,   402,     0,   403,     0,   404,   405,
     406,   407,   408,   409,   410,   411,   412,     0,   413,   414,
     415,   416,   417,   418,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
       0,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,     0,   445,   446,     0,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,     0,   459,
     460,   461,   462,   463,     0,   464,   465,   466,   467,   468,
       0,   469,   470,   471,   472,     0,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,     0,   485,
     486,     0,   487,     0,   488,   489,   490,   491,   492,     0,
     493,   494,     0,     0,   495,   496,   497,   498,   499,     0,
     500,   501,   502,   503,   504,   505,   506,     0,     0,   507,
     508,   509,   510,   511,     0,     0,   512,   513,   514,   515,
     516,   517,   518,     0,   519,     0,   520,   521,   522,   523,
       0,     0,   524,     0,     0,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   222,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   223,   224,
     225,   226,   227,   228,   229,   230,     0,   232,   233,   234,
       3,     4,     0,     0,     0,     0,     0,   235,   236,     0,
     237,   238,     0,   239,   240,   241,   242,   243,     0,   244,
     245,     0,   246,   247,   248,   249,   250,     0,     0,   251,
     252,   253,   254,   255,     0,   256,   257,   258,   259,   260,
       0,     0,     0,   261,   262,   263,   264,     0,   265,   266,
     267,     0,   268,   269,   270,   271,   272,   273,     0,     0,
     274,   275,   276,     0,     0,     0,     0,     0,     0,     0,
     277,   278,   279,   280,   281,   282,   283,   284,   285,     0,
     286,     0,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,     0,     0,   296,   297,   298,   299,   300,     0,
     301,   302,   303,     0,   304,   305,   306,     0,   307,   308,
     309,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,   318,   319,   320,     0,   321,     0,   322,     0,     0,
       0,   323,   324,   325,     0,   326,   327,     0,   328,   329,
       0,   330,   331,   332,   333,   334,     0,   335,   336,   337,
     338,     0,   339,   340,   341,   342,   343,   344,     0,   345,
       0,   346,   347,   348,   349,   350,   351,   352,     0,   353,
       0,   354,     0,     0,   355,     0,   356,   357,   358,   359,
     360,     0,     0,   361,   362,     0,   363,     0,     0,   364,
     365,   366,     0,     0,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,     0,   384,   385,   386,   387,     0,   388,   389,     0,
     390,     0,   391,   392,   393,   394,   395,   396,     0,   397,
       0,     0,   398,   399,   400,     0,     0,   401,   402,     0,
     403,     0,   404,   405,   406,   407,   408,   409,   410,   411,
     412,     0,   413,   414,   415,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,     0,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,     0,   445,   446,     0,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,     0,   459,   460,   461,   462,   463,     0,   464,
     465,   466,   467,   468,     0,   469,   470,   471,   472,     0,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,     0,   485,   486,     0,   487,     0,   488,   489,
     490,   491,   492,     0,   493,   494,     0,     0,   495,   496,
     497,   498,   499,     0,   500,   501,   502,   503,   504,   505,
     506,     0,     0,   507,   508,   509,   510,   511,     0,     0,
     512,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     520,   521,   522,   523,     0,     0,   524,     0,     0,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   222,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   223,   224,   225,   226,   227,   228,   229,   230,
    2823,   232,   233,   234,     0,     0,     0,     0,     0,     0,
       0,   235,   236,     0,   237,   238,     0,   239,   240,   241,
     242,   243,     0,   244,   245,     0,   246,   247,   248,   249,
     250,     0,     0,   251,   252,   253,   254,   255,     0,   256,
     257,   258,   259,   260,     0,     0,     0,   261,   262,   263,
     264,     0,   265,   266,   267,     0,   268,   269,   270,   271,
     272,   273,     0,     0,   274,   275,   276,     0,     0,     0,
       0,     0,     0,     0,   277,   278,   279,   280,   281,   282,
     283,   284,   285,     0,   286,     0,   287,   288,   289,   290,
     291,   292,     0,   293,   294,   295,     0,     0,   296,   297,
     298,   299,   300,     0,   301,   302,   303,     0,   304,   305,
     306,     0,   307,   308,   309,   310,   311,   312,   313,   314,
     315,     0,   316,     0,   317,   318,   319,   320,     0,   321,
       0,   322,     0,     0,     0,   323,   324,   325,     0,   326,
     327,     0,   328,   329,     0,   330,   331,   332,   333,   334,
       0,   335,   336,   337,   338,     0,   339,   340,   341,   342,
     343,   344,     0,   345,     0,   346,   347,   348,   349,   350,
     351,   352,     0,   353,     0,   354,     0,     0,   355,     0,
     356,   357,   358,   359,   360,     0,     0,   361,   362,     0,
     363,     0,     0,   364,   365,   366,     0,     0,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,     0,   384,   385,   386,   387,
       0,   388,   389,     0,   390,     0,   391,   392,   393,   394,
     395,   396,     0,   397,     0,     0,   398,   399,   400,     0,
       0,   401,   402,     0,   403,     0,   404,   405,   406,   407,
     408,   409,   410,   411,   412,     0,   413,   414,   415,   416,
     417,   418,   419,   420,     0,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,     0,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
       0,   445,   446,     0,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,     0,   459,   460,   461,
     462,   463,     0,   464,   465,   466,   467,   468,     0,   469,
     470,   471,   472,     0,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,     0,   485,   486,     0,
     487,     0,   488,   489,   490,   491,   492,     0,   493,   494,
       0,     0,   495,   496,   497,   498,   499,     0,   500,   501,
     502,   503,   504,   505,   506,     0,     0,   507,   508,   509,
     510,   511,  2824,     0,   512,   513,   514,   515,   516,   517,
     518,     0,   519,     0,   520,   521,   522,   523,     0,     0,
     524,     0,     0,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   222,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   223,   224,   225,   226,
     227,   228,   229,   230,  2836,   232,   233,   234,     0,     0,
       0,     0,     0,     0,     0,   235,   236,     0,   237,   238,
       0,   239,   240,   241,   242,   243,     0,   244,   245,     0,
     246,   247,   248,   249,   250,     0,     0,   251,   252,   253,
     254,   255,     0,   256,   257,   258,   259,   260,     0,     0,
       0,   261,   262,   263,   264,     0,   265,   266,   267,     0,
     268,   269,   270,   271,   272,   273,     0,     0,   274,   275,
     276,     0,     0,     0,     0,     0,     0,     0,   277,   278,
     279,   280,   281,   282,   283,   284,   285,     0,   286,     0,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
       0,     0,   296,   297,   298,   299,   300,     0,   301,   302,
     303,     0,   304,   305,   306,     0,   307,   308,   309,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,   318,
     319,   320,     0,   321,     0,   322,     0,     0,     0,   323,
     324,   325,     0,   326,   327,     0,   328,   329,     0,   330,
     331,   332,   333,   334,     0,   335,   336,   337,   338,     0,
     339,   340,   341,   342,   343,   344,     0,   345,     0,   346,
     347,   348,   349,   350,   351,   352,     0,   353,     0,   354,
       0,     0,   355,     0,   356,   357,   358,   359,   360,     0,
       0,   361,   362,     0,   363,     0,     0,   364,   365,   366,
       0,     0,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,     0,
     384,   385,   386,   387,     0,   388,   389,     0,   390,     0,
     391,   392,   393,   394,   395,   396,     0,   397,     0,     0,
     398,   399,   400,     0,     0,   401,   402,     0,   403,     0,
     404,   405,   406,   407,   408,   409,   410,   411,   412,     0,
     413,   414,   415,   416,   417,   418,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,     0,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,     0,   445,   446,     0,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
       0,   459,   460,   461,   462,   463,     0,   464,   465,   466,
     467,   468,     0,   469,   470,   471,   472,     0,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
       0,   485,   486,     0,   487,     0,   488,   489,   490,   491,
     492,     0,   493,   494,     0,     0,   495,   496,   497,   498,
     499,     0,   500,   501,   502,   503,   504,   505,   506,     0,
       0,   507,   508,   509,   510,   511,  2837,     0,   512,   513,
     514,   515,   516,   517,   518,     0,   519,     0,   520,   521,
     522,   523,     0,     0,   524,     0,     0,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   222,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,     0,     0,     0,     0,     0,     0,     0,   235,
     236,     0,   237,   238,     0,   239,   240,   241,   242,   243,
       0,   244,   245,     0,   246,   247,   248,   249,   250,     0,
       0,   251,   252,   253,   254,   255,     0,   256,   257,   258,
     259,   260,     0,     0,     0,   261,   262,   263,   264,     0,
     265,   266,   267,     0,   268,   269,   270,   271,   272,   273,
       0,     0,   274,   275,   276,     0,     0,     0,     0,     0,
       0,     0,   277,   278,   279,   280,   281,   282,   283,   284,
     285,     0,   286,     0,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,     0,     0,   296,   297,   298,   299,
     300,     0,   301,   302,   303,     0,   304,   305,   306,     0,
     307,   308,   309,   310,   311,   312,   313,   314,   315,     0,
     316,     0,   317,   318,   319,   320,     0,   321,     0,   322,
       0,     0,     0,   323,   324,   325,     0,   326,   327,     0,
     328,   329,     0,   330,   331,   332,   333,   334,     0,   335,
     336,   337,   338,     0,   339,   340,   341,   342,   343,   344,
       0,   345,     0,   346,   347,   348,   349,   350,   351,   352,
       0,   353,     0,   354,     0,     0,   355,     0,   356,   357,
     358,   359,   360,     0,     0,   361,   362,     0,   363,     0,
       0,   364,   365,   366,     0,     0,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,     0,   384,   385,   386,   387,     0,   388,
     389,     0,   390,     0,   391,   392,   393,   394,   395,   396,
       0,   397,     0,     0,   398,   399,   400,     0,     0,   401,
     402,     0,   403,     0,   404,   405,   406,   407,   408,   409,
     410,   411,   412,     0,   413,   414,   415,   416,   417,   418,
     419,   420,     0,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,     0,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,     0,   445,
     446,     0,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,   462,   463,
       0,   464,   465,   466,   467,   468,     0,   469,   470,   471,
     472,     0,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,     0,   485,   486,     0,   487,     0,
     488,   489,   490,   491,   492,     0,   493,   494,     0,     0,
     495,   496,   497,   498,   499,     0,   500,   501,   502,   503,
     504,   505,   506,     0,     0,   507,   508,   509,   510,   511,
       0,     0,   512,   513,   514,   515,   516,   517,   518,     0,
     519,     0,   520,   521,   522,   523,     0,     0,   524,     0,
       0,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   222,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   223,   224,   225,   226,   227,   228,
     229,   230,   591,   232,   233,   234,     0,     0,     0,     0,
       0,     0,     0,   235,   236,     0,   237,   238,     0,   239,
     240,   241,   242,   243,     0,   244,   245,     0,   246,   247,
     248,   249,   250,     0,     0,   251,   252,   253,   254,   255,
       0,   256,   257,   258,   259,   260,     0,     0,     0,   261,
     262,   263,   264,     0,   265,   266,   267,     0,   268,   269,
     270,   271,   272,   273,     0,     0,   274,   275,   276,     0,
       0,     0,     0,     0,     0,     0,   277,   278,   279,   280,
     281,   282,   283,   284,   285,     0,   286,     0,   287,   288,
     289,   290,   291,   292,     0,   293,   294,   295,     0,     0,
     296,   297,   298,   299,   300,     0,   301,   302,   303,     0,
     304,   305,   306,     0,   307,   308,   309,   310,   311,   312,
     313,   314,   315,     0,   316,     0,   317,   318,   319,   320,
       0,   321,     0,   322,     0,     0,     0,   323,   324,   325,
       0,   326,   327,     0,   328,   329,     0,   330,   331,   332,
     333,   334,     0,   335,   336,   337,   338,     0,   339,   340,
     341,   342,   343,   344,     0,   345,     0,   346,   347,   348,
     349,   350,   351,   352,     0,   353,     0,   354,     0,     0,
     355,     0,   356,   357,   358,   359,   360,     0,     0,   361,
     362,     0,   363,     0,     0,   364,   365,   366,     0,     0,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,     0,   384,   385,
     386,   387,     0,   388,   389,     0,   390,     0,   391,   392,
     393,   394,   395,   396,     0,   397,     0,     0,   398,   399,
     400,     0,     0,   401,   402,     0,   403,     0,   404,   405,
     406,   407,   408,   409,   410,   411,   412,     0,   413,   414,
     415,   416,   417,   418,   592,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
       0,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,     0,   445,   446,     0,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,     0,   459,
     460,   461,   462,   463,     0,   464,   465,   466,   467,   468,
       0,   469,   470,   471,   472,     0,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,     0,   485,
     486,     0,   487,     0,   488,   489,   490,   491,   492,     0,
     493,   494,     0,     0,   495,   496,   497,   498,   499,     0,
     500,   501,   502,   503,   504,   505,   506,     0,     0,   507,
     508,   509,   510,   511,     0,     0,   512,   513,   514,   515,
     516,   517,   518,     0,   519,     0,   520,   521,   522,   523,
       0,     0,   524,     0,     0,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   222,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   223,   224,
     225,   226,   227,   228,   229,   230,   703,   232,   233,   234,
       0,     0,     0,     0,     0,     0,     0,   235,   236,     0,
     237,   238,     0,   239,   240,   241,   242,   243,     0,   244,
     245,     0,   246,   247,   248,   249,   250,     0,     0,   251,
     252,   253,   254,   255,     0,   256,   257,   258,   259,   260,
       0,     0,     0,   261,   262,   263,   264,     0,   265,   266,
     267,     0,   268,   269,   270,   271,   272,   273,     0,     0,
     274,   275,   276,     0,     0,     0,     0,     0,     0,     0,
     277,   278,   279,   280,   281,   282,   283,   284,   285,     0,
     286,     0,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,     0,     0,   296,   297,   298,   299,   300,     0,
     301,   302,   303,     0,   304,   305,   306,     0,   307,   308,
     309,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,   318,   319,   320,     0,   321,     0,   322,     0,     0,
       0,   323,   324,   325,     0,   326,   327,     0,   328,   329,
       0,   330,   331,   332,   333,   334,     0,   335,   336,   337,
     338,     0,   339,   340,   341,   342,   343,   344,     0,   345,
       0,   346,   347,   348,   349,   350,   351,   352,     0,   353,
       0,   354,     0,     0,   355,     0,   356,   357,   358,   359,
     360,     0,     0,   361,   362,     0,   363,     0,     0,   364,
     365,   366,     0,     0,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,     0,   384,   385,   386,   387,     0,   388,   389,     0,
     390,     0,   391,   392,   393,   394,   395,   396,     0,   397,
       0,     0,   398,   399,   400,     0,     0,   401,   402,     0,
     403,     0,   404,   405,   406,   407,   408,   409,   410,   411,
     412,     0,   413,   414,   415,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,     0,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,     0,   445,   446,     0,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,     0,   459,   460,   461,   462,   704,     0,   464,
     465,   466,   467,   468,     0,   469,   470,   471,   472,     0,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,     0,   485,   486,     0,   487,     0,   488,   489,
     490,   491,   492,     0,   705,   494,     0,     0,   706,   496,
     497,   498,   499,     0,   500,   501,   502,   503,   504,   505,
     506,     0,     0,   507,   508,   509,   510,   511,     0,     0,
     512,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     520,   521,   522,   523,     0,     0,   524,     0,     0,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   222,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   223,   224,   225,   226,   227,   228,   229,   230,
     737,   232,   233,   234,     0,     0,     0,     0,     0,     0,
       0,   235,   236,     0,   237,   238,     0,   239,   240,   241,
     242,   243,     0,   244,   245,     0,   246,   247,   248,   249,
     250,     0,     0,   251,   252,   253,   254,   255,     0,   256,
     257,   258,   259,   260,     0,     0,     0,   261,   262,   263,
     264,     0,   265,   266,   267,     0,   268,   269,   270,   271,
     272,   273,     0,     0,   274,   275,   276,     0,     0,     0,
       0,     0,     0,     0,   277,   278,   279,   280,   281,   282,
     283,   284,   285,     0,   286,     0,   287,   288,   289,   290,
     291,   292,     0,   293,   294,   295,     0,     0,   296,   297,
     298,   299,   300,     0,   301,   302,   303,     0,   304,   305,
     306,     0,   307,   308,   309,   310,   311,   312,   313,   314,
     315,     0,   316,     0,   317,   318,   319,   320,     0,   321,
       0,   322,     0,     0,     0,   323,   324,   325,     0,   326,
     327,     0,   328,   329,     0,   330,   331,   332,   333,   334,
       0,   335,   336,   337,   338,     0,   339,   340,   341,   342,
     343,   344,     0,   345,     0,   346,   347,   348,   349,   350,
     351,   352,     0,   353,     0,   354,     0,     0,   355,     0,
     356,   357,   358,   359,   360,     0,     0,   361,   362,     0,
     363,     0,     0,   364,   365,   366,     0,     0,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,     0,   384,   385,   386,   387,
       0,   388,   389,     0,   390,     0,   391,   392,   393,   394,
     395,   396,     0,   397,     0,     0,   398,   399,   400,     0,
       0,   401,   402,     0,   403,     0,   404,   405,   406,   407,
     408,   409,   410,   411,   412,     0,   413,   414,   415,   416,
     417,   418,   419,   420,     0,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,     0,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
       0,   445,   446,     0,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,     0,   459,   460,   461,
     462,   738,     0,   464,   465,   466,   467,   468,     0,   469,
     470,   471,   472,     0,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,     0,   485,   486,     0,
     487,     0,   488,   489,   490,   491,   492,     0,   739,   494,
       0,     0,   740,   496,   497,   498,   499,     0,   500,   501,
     502,   503,   504,   505,   506,     0,     0,   507,   508,   509,
     510,   511,     0,     0,   512,   513,   514,   515,   516,   517,
     518,     0,   519,     0,   520,   521,   522,   523,     0,     0,
     524,     0,     0,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   222,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   223,   224,   225,   226,
     227,   228,   229,   230,     0,   232,   233,   234,     0,     0,
       0,     0,     0,     0,     0,   235,   236,     0,   237,   238,
       0,   239,   240,   241,   242,   243,     0,   244,   245,     0,
     246,   247,   248,   249,   250,     0,     0,   251,   252,   253,
     254,   255,     0,   256,   257,   258,   259,   260,     0,     0,
       0,   261,   262,   263,   264,     0,   265,   266,   267,     0,
     268,   269,   270,   271,   272,   273,     0,     0,   274,   275,
     276,     0,     0,     0,     0,     0,     0,     0,   277,   278,
     279,   280,   281,   282,   283,   284,   285,     0,   286,     0,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
       0,     0,   296,   297,   298,   299,   300,     0,   301,   302,
     303,     0,   304,   305,   306,     0,   307,   308,   309,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,   318,
     319,   320,     0,   321,     0,   322,     0,     0,     0,   323,
     324,   325,     0,   326,   327,     0,   328,   329,     0,   330,
     331,   332,   333,   334,     0,   335,   336,   337,   338,     0,
     339,   340,   341,   342,   343,   344,     0,   345,     0,   346,
     347,   348,   349,   350,   351,   352,     0,   353,     0,   354,
       0,     0,   355,     0,   356,   357,   358,   359,   360,     0,
       0,   361,   362,     0,   363,     0,     0,   364,   365,   366,
       0,     0,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,     0,
     384,   385,   386,   387,     0,   388,   389,     0,   390,     0,
     391,   392,   393,   394,   395,   396,     0,   397,     0,   743,
     398,   399,   400,     0,     0,   401,   402,     0,   403,     0,
     404,   405,   406,   407,   408,   409,   410,   411,   412,     0,
     413,   414,   415,   416,   417,   418,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,     0,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,     0,   445,   446,     0,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
       0,   459,   460,   461,   462,   463,     0,   464,   465,   466,
     467,   468,     0,   469,   470,   471,   472,     0,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
       0,   485,   486,     0,   487,     0,   488,   489,   490,   491,
     492,     0,   493,   494,     0,     0,   495,   496,   497,   498,
     499,     0,   500,   501,   502,   503,   504,   505,   506,     0,
       0,   507,   508,   509,   510,   511,     0,     0,   512,   513,
     514,   515,   516,   517,   518,     0,   519,     0,   520,   521,
     522,   523,     0,     0,   524,     0,     0,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   222,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     223,   224,   225,   226,   227,   228,   229,   230,   832,   232,
     233,   234,     0,     0,     0,     0,     0,     0,     0,   235,
     236,     0,   237,   238,     0,   239,   240,   241,   242,   243,
       0,   244,   245,     0,   246,   247,   248,   249,   250,     0,
       0,   251,   252,   253,   254,   255,     0,   256,   257,   258,
     259,   260,     0,     0,     0,   261,   262,   263,   264,     0,
     265,   266,   267,     0,   268,   269,   270,   271,   272,   273,
       0,     0,   274,   275,   276,     0,     0,     0,     0,     0,
       0,     0,   277,   278,   279,   280,   281,   282,   283,   284,
     285,     0,   286,     0,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,     0,     0,   296,   297,   298,   299,
     300,     0,   301,   302,   303,     0,   304,   305,   306,     0,
     307,   308,   309,   310,   311,   312,   313,   314,   315,     0,
     316,     0,   317,   318,   319,   320,     0,   321,     0,   322,
       0,     0,     0,   323,   324,   325,     0,   326,   327,     0,
     328,   329,     0,   330,   331,   332,   333,   833,     0,   335,
     336,   337,   338,     0,   339,   340,   341,   342,   343,   344,
       0,   345,     0,   346,   347,   348,   349,   350,   351,   352,
       0,   353,     0,   354,     0,     0,   355,     0,   356,   357,
     358,   359,   360,     0,     0,   361,   362,     0,   363,     0,
       0,   364,   365,   366,     0,     0,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,     0,   384,   385,   386,   387,     0,   388,
     389,     0,   390,     0,   391,   392,   393,   394,   395,   396,
       0,   397,     0,     0,   398,   399,   400,     0,     0,   401,
     402,     0,   403,     0,   404,   405,   406,   407,   408,   409,
     410,   411,   412,     0,   413,   414,   415,   416,   417,   418,
     419,   420,     0,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,     0,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,     0,   445,
     446,     0,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,   462,   463,
       0,   464,   465,   466,   467,   468,     0,   469,   470,   471,
     472,     0,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,     0,   485,   486,     0,   487,     0,
     488,   489,   490,   491,   492,     0,   493,   494,     0,     0,
     495,   496,   497,   498,   499,     0,   500,   501,   502,   503,
     504,   505,   506,     0,     0,   507,   508,   509,   510,   511,
       0,     0,   512,   513,   514,   515,   516,   517,   518,     0,
     519,     0,   520,   521,   522,   523,     0,     0,   524,     0,
       0,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   222,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   223,   224,   225,   226,   227,   228,
     229,   230,   977,   232,   233,   234,     0,     0,     0,     0,
       0,     0,     0,   235,   236,     0,   237,   238,     0,   239,
     240,   241,   242,   243,     0,   244,   245,     0,   246,   247,
     248,   249,   250,     0,     0,   251,   252,   253,   254,   255,
       0,   256,   257,   258,   259,   260,     0,     0,     0,   261,
     262,   263,   264,     0,   265,   266,   267,     0,   268,   269,
     270,   271,   272,   273,     0,     0,   274,   275,   276,     0,
       0,     0,     0,     0,     0,     0,   277,   278,   279,   280,
     281,   282,   283,   284,   285,     0,   286,     0,   287,   288,
     289,   290,   291,   292,     0,   293,   294,   295,     0,     0,
     296,   297,   298,   299,   300,     0,   301,   302,   303,     0,
     304,   305,   306,     0,   307,   308,   309,   310,   311,   312,
     313,   314,   315,     0,   316,     0,   317,   318,   319,   320,
       0,   321,     0,   322,     0,     0,     0,   323,   324,   325,
       0,   326,   327,     0,   328,   329,     0,   330,   331,   332,
     333,   334,     0,   335,   336,   337,   338,     0,   339,   340,
     341,   342,   343,   344,     0,   345,     0,   346,   347,   348,
     349,   350,   351,   352,     0,   353,     0,   354,     0,     0,
     355,     0,   356,   357,   358,   359,   360,     0,     0,   361,
     362,     0,   363,     0,     0,   364,   365,   366,     0,     0,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,     0,   384,   385,
     386,   387,     0,   388,   389,     0,   390,     0,   391,   392,
     393,   394,   395,   396,     0,   397,     0,     0,   398,   399,
     400,     0,     0,   401,   402,     0,   403,     0,   404,   405,
     406,   407,   408,   409,   410,   411,   412,     0,   413,   414,
     415,   416,   417,   418,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
       0,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,     0,   445,   446,     0,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,     0,   459,
     460,   461,   462,   463,     0,   464,   465,   466,   467,   468,
       0,   469,   470,   471,   472,     0,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,     0,   485,
     486,     0,   487,     0,   488,   489,   490,   491,   492,     0,
     493,   494,     0,     0,   495,   496,   497,   498,   499,     0,
     500,   501,   502,   503,   504,   505,   506,     0,     0,   507,
     508,   509,   510,   511,     0,     0,   512,   513,   514,   515,
     516,   517,   518,     0,   519,     0,   520,   521,   522,   523,
       0,     0,   524,     0,     0,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   222,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   223,   224,
     225,   226,   227,   228,   229,   230,  1240,   232,   233,   234,
       0,     0,     0,     0,     0,     0,     0,   235,   236,     0,
     237,   238,     0,   239,   240,   241,   242,   243,     0,   244,
     245,     0,   246,   247,   248,   249,   250,     0,     0,   251,
     252,   253,   254,   255,     0,   256,   257,   258,   259,   260,
       0,     0,     0,   261,   262,   263,   264,     0,   265,   266,
     267,     0,   268,   269,   270,   271,   272,   273,     0,     0,
     274,   275,   276,     0,     0,     0,     0,     0,     0,     0,
     277,   278,   279,   280,   281,   282,   283,   284,   285,     0,
     286,     0,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,     0,     0,   296,   297,   298,   299,   300,     0,
     301,   302,   303,     0,   304,   305,   306,     0,   307,   308,
     309,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,   318,   319,   320,     0,   321,     0,   322,     0,     0,
       0,   323,   324,   325,     0,   326,   327,     0,   328,   329,
       0,   330,   331,   332,   333,   334,     0,   335,   336,   337,
     338,     0,   339,   340,   341,   342,   343,   344,     0,   345,
       0,   346,   347,   348,   349,   350,   351,   352,     0,   353,
       0,   354,     0,     0,   355,     0,   356,   357,   358,   359,
     360,     0,     0,   361,   362,     0,   363,     0,     0,   364,
     365,   366,     0,     0,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,     0,   384,   385,   386,   387,     0,   388,   389,     0,
     390,     0,   391,   392,   393,   394,   395,   396,     0,   397,
       0,     0,   398,   399,   400,     0,     0,   401,   402,     0,
     403,     0,   404,   405,   406,   407,   408,   409,   410,   411,
     412,     0,   413,   414,   415,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,     0,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,     0,   445,   446,     0,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,     0,   459,   460,   461,   462,   463,     0,   464,
     465,   466,   467,   468,     0,   469,   470,   471,   472,     0,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,     0,   485,   486,     0,   487,     0,   488,   489,
     490,   491,   492,     0,   493,   494,     0,     0,   495,   496,
     497,   498,   499,     0,   500,   501,   502,   503,   504,   505,
     506,     0,     0,   507,   508,   509,   510,   511,     0,     0,
     512,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     520,   521,   522,   523,     0,     0,   524,     0,     0,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   222,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   223,   224,   225,   226,   227,   228,   229,   230,
       0,   232,   233,   234,     0,     0,     0,     0,     0,     0,
       0,   235,   236,     0,   237,   238,  1251,   239,   240,   241,
     242,   243,     0,   244,   245,     0,   246,   247,   248,   249,
     250,     0,     0,   723,   252,   253,   254,  1252,     0,   256,
     257,   258,   259,   260,     0,     0,     0,   261,   262,   263,
     264,     0,   265,   266,   267,     0,   268,   269,   270,   271,
     272,   273,     0,     0,   274,   275,   276,     0,     0,     0,
       0,     0,     0,     0,   277,   278,   279,   280,   281,   282,
     283,   284,   285,     0,   286,     0,   287,   288,   289,   290,
     291,   292,     0,   293,   294,   295,     0,     0,   296,   297,
     298,   299,   300,     0,   301,   302,   303,     0,   304,   305,
     306,     0,   307,   308,   309,   310,   311,   312,   313,   314,
     315,     0,   316,     0,   317,   318,   319,   320,     0,   321,
       0,   322,     0,     0,     0,   323,   324,   325,     0,   326,
     327,     0,   328,   329,     0,   330,   331,   332,   333,   334,
       0,   335,   336,   337,   338,     0,   339,   340,   341,   342,
     343,   344,     0,   345,     0,   346,   347,   348,   349,   350,
     351,   352,     0,   353,     0,   354,     0,     0,   355,     0,
     356,   357,   358,   359,   360,     0,     0,   361,   362,     0,
     363,     0,     0,   364,   365,   366,     0,     0,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   726,   383,     0,   384,   385,   386,   387,
       0,   388,   389,     0,   390,     0,   391,   392,   393,   394,
     395,   396,     0,   397,     0,     0,   398,   399,   400,     0,
       0,   401,   402,     0,   403,     0,   404,   405,   406,   407,
     408,   409,   410,   411,   412,     0,   413,   414,   415,   416,
     417,   418,   419,   420,     0,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,     0,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
       0,   445,   446,     0,   727,   448,   449,   450,   451,   452,
     453,   728,   455,   456,   457,   458,     0,   459,   460,   461,
     462,  1244,     0,   464,   465,   466,   467,   468,     0,   469,
     470,   471,   472,     0,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,     0,   485,   486,     0,
     487,     0,   488,   489,   490,   491,   492,     0,   730,   494,
       0,     0,   731,   496,   497,   498,   499,     0,   500,   501,
     502,   503,   504,   505,   506,     0,     0,   507,   508,   509,
     510,   511,     0,     0,   512,   513,   514,   515,   516,   517,
     518,     0,   519,     0,   520,   521,   522,   523,     0,     0,
     524,     0,     0,   525,   526,   527,   528,   529,   732,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   222,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   223,   224,   225,   226,
     227,   228,   229,   230,     0,   232,   233,   234,     0,     0,
       0,     0,     0,     0,     0,   235,   236,     0,   237,   238,
       0,   239,   240,   241,   242,   243,     0,   244,   245,     0,
     246,   247,   248,   249,   250,     0,     0,   251,   252,   253,
     254,   255,     0,   256,   257,   258,   259,   260,     0,     0,
       0,   261,   262,   263,   264,     0,   265,   266,   267,     0,
     268,   269,   270,   271,   272,   273,     0,     0,   274,   275,
     276,     0,     0,     0,     0,     0,     0,     0,   277,   278,
     279,   280,   281,   282,   283,   284,   285,     0,   286,     0,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
       0,     0,   296,   297,   298,   299,   300,     0,   301,   302,
     303,     0,   304,   305,   306,     0,   307,   308,   309,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,   318,
     319,   320,     0,   321,     0,   322,     0,     0,     0,   323,
     324,   325,     0,   326,   327,     0,   328,   329,     0,   330,
     331,   332,   333,  1360,     0,   335,   336,   337,   338,     0,
     339,   340,   341,   342,   343,   344,     0,   345,     0,   346,
     347,   348,   349,   350,   351,   352,     0,   353,     0,   354,
       0,     0,   355,     0,   356,   357,   358,   359,   360,     0,
       0,   361,   362,     0,   363,     0,     0,   364,   365,   366,
       0,     0,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,     0,
     384,   385,   386,   387,     0,   388,   389,     0,   390,     0,
     391,   392,   393,   394,   395,   396,     0,   397,     0,   743,
     398,   399,   400,     0,     0,   401,   402,     0,   403,     0,
     404,   405,   406,   407,   408,   409,   410,   411,   412,     0,
     413,   414,   415,   416,   417,   418,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,     0,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,     0,   445,   446,     0,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
       0,   459,   460,   461,   462,   463,     0,   464,   465,   466,
     467,   468,     0,   469,   470,   471,   472,     0,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
       0,   485,   486,     0,   487,     0,   488,   489,   490,   491,
     492,     0,   493,   494,     0,     0,   495,   496,   497,   498,
     499,     0,   500,   501,   502,   503,   504,   505,   506,     0,
       0,   507,   508,   509,   510,   511,     0,     0,   512,   513,
     514,   515,   516,   517,   518,     0,   519,     0,   520,   521,
     522,   523,     0,     0,   524,     0,     0,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   222,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     223,   224,   225,   226,   227,   228,   229,   230,  1415,   232,
     233,   234,     0,     0,     0,     0,     0,     0,     0,   235,
     236,     0,   237,   238,     0,   239,   240,   241,   242,   243,
       0,   244,   245,     0,   246,   247,   248,   249,   250,     0,
       0,   251,   252,   253,   254,   255,     0,   256,   257,   258,
     259,   260,     0,     0,     0,   261,   262,   263,   264,     0,
     265,   266,   267,     0,   268,   269,   270,   271,   272,   273,
       0,     0,   274,   275,   276,     0,     0,     0,     0,     0,
       0,     0,   277,   278,   279,   280,   281,   282,   283,   284,
     285,     0,   286,     0,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,     0,     0,   296,   297,   298,   299,
     300,     0,   301,   302,   303,     0,   304,   305,   306,     0,
     307,   308,   309,   310,   311,   312,   313,   314,   315,     0,
     316,     0,   317,   318,   319,   320,     0,   321,     0,   322,
       0,     0,     0,   323,   324,   325,     0,   326,   327,     0,
     328,   329,     0,   330,   331,   332,   333,  1416,     0,   335,
     336,   337,   338,     0,   339,   340,   341,   342,   343,   344,
       0,   345,     0,   346,   347,   348,   349,   350,   351,   352,
       0,   353,     0,   354,     0,     0,   355,     0,   356,   357,
     358,   359,   360,     0,     0,   361,   362,     0,   363,     0,
       0,   364,   365,   366,     0,     0,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,     0,   384,   385,   386,   387,     0,   388,
     389,     0,   390,     0,   391,   392,   393,   394,   395,   396,
       0,   397,     0,     0,   398,   399,   400,     0,     0,   401,
     402,     0,   403,     0,   404,   405,   406,   407,   408,   409,
     410,   411,   412,     0,   413,   414,   415,   416,   417,   418,
     419,   420,     0,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,     0,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,     0,   445,
     446,     0,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,   462,   463,
       0,   464,   465,   466,   467,   468,     0,   469,   470,   471,
     472,     0,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,     0,   485,   486,     0,   487,     0,
     488,   489,   490,   491,   492,     0,   493,   494,     0,     0,
     495,   496,   497,   498,   499,     0,   500,   501,   502,   503,
     504,   505,   506,     0,     0,   507,   508,   509,   510,   511,
       0,     0,   512,   513,   514,   515,   516,   517,   518,     0,
     519,     0,   520,   521,   522,   523,     0,     0,   524,     0,
       0,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   222,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   223,   224,   225,   226,   227,   228,
     229,   230,   703,   232,   233,   234,     0,     0,     0,     0,
       0,     0,     0,   235,   236,     0,   237,   238,     0,   239,
     240,   241,   242,   243,     0,   244,   245,     0,   246,   247,
     248,   249,   250,     0,     0,   251,   252,   253,   254,   255,
       0,   256,   257,   258,   259,   260,     0,     0,     0,   261,
     262,   263,   264,     0,   265,   266,   267,     0,   268,   269,
     270,   271,   272,   273,     0,     0,   274,   275,   276,     0,
       0,     0,     0,     0,     0,     0,   277,   278,   279,   280,
     281,   282,   283,   284,   285,     0,   286,     0,   287,   288,
     289,   290,   291,   292,     0,   293,   294,   295,     0,     0,
     296,   297,   298,   299,   300,     0,   301,   302,   303,     0,
     304,   305,   306,     0,   307,   308,   309,   310,   311,   312,
     313,   314,   315,     0,   316,     0,   317,   318,   319,   320,
       0,   321,     0,   322,     0,     0,     0,   323,   324,   325,
       0,   326,   327,     0,   328,   329,     0,   330,   331,   332,
     333,   334,     0,   335,   336,   337,   338,     0,   339,   340,
     341,   342,   343,   344,     0,   345,     0,   346,   347,   348,
     349,   350,   351,   352,     0,   353,     0,   354,     0,     0,
     355,     0,   356,   357,   358,   359,   360,     0,     0,   361,
     362,     0,   363,     0,     0,   364,   365,   366,     0,     0,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,     0,   384,   385,
     386,   387,     0,   388,   389,     0,   390,     0,   391,   392,
     393,   394,   395,   396,     0,   397,     0,     0,   398,   399,
     400,     0,     0,   401,   402,     0,   403,     0,   404,   405,
     406,   407,   408,   409,   410,   411,   412,     0,   413,   414,
     415,   416,   417,   418,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
       0,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,     0,   445,   446,     0,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,     0,   459,
     460,   461,   462,   463,     0,   464,   465,   466,   467,   468,
       0,   469,   470,   471,   472,     0,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,     0,   485,
     486,     0,   487,     0,   488,   489,   490,   491,   492,     0,
     493,   494,     0,     0,   495,   496,   497,   498,   499,     0,
     500,   501,   502,   503,   504,   505,   506,     0,     0,   507,
     508,   509,   510,   511,     0,     0,   512,   513,   514,   515,
     516,   517,   518,     0,   519,     0,   520,   521,   522,   523,
       0,     0,   524,     0,     0,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   222,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   223,   224,
     225,   226,   227,   228,   229,   230,     0,   232,   233,   234,
       0,     0,     0,     0,     0,     0,     0,   235,   236,     0,
     237,   238,     0,   239,   240,   241,   242,   243,     0,   244,
     245,     0,   246,   247,   248,   249,   250,     0,     0,   251,
     252,   253,   254,   255,     0,   256,   257,   258,   259,   260,
       0,     0,     0,   261,   262,   263,   264,     0,   265,   266,
     267,     0,   268,   269,   270,   271,   272,   273,     0,     0,
     274,   275,   276,     0,     0,     0,     0,     0,     0,     0,
     277,   278,   279,   280,   281,   282,   283,   284,   285,     0,
     286,     0,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,     0,     0,   296,   297,   298,   299,   300,     0,
     301,   302,   303,     0,   304,   305,   306,     0,   307,   308,
     309,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,   318,   319,   320,     0,   321,     0,   322,     0,     0,
       0,   323,   324,  2625,     0,   326,   327,     0,   328,   329,
       0,   330,   331,   332,   333,   334,     0,   335,   336,   337,
     338,     0,   339,   340,   341,   342,   343,   344,     0,   345,
       0,   346,   347,   348,   349,   350,   351,   352,     0,   353,
       0,   354,     0,     0,   355,     0,   356,   357,   358,   359,
     360,     0,     0,   361,   362,     0,   363,     0,     0,   364,
     365,  2626,     0,     0,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,     0,   384,   385,   386,   387,     0,   388,   389,     0,
     390,     0,   391,   392,   393,   394,   395,   396,     0,   397,
       0,     0,   398,   399,   400,     0,     0,   401,   402,     0,
     403,     0,   404,   405,   406,   407,   408,   409,   410,   411,
     412,     0,   413,   414,   415,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,     0,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,     0,   445,   446,     0,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,     0,   459,   460,   461,   462,   463,     0,   464,
     465,   466,   467,   468,     0,   469,   470,   471,   472,     0,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,     0,   485,   486,  2627,   487,     0,   488,  2628,
     490,  2629,   492,     0,   493,   494,     0,     0,   495,   496,
     497,   498,   499,     0,   500,   501,   502,   503,   504,   505,
     506,     0,     0,   507,   508,  2630,   510,   511,     0,     0,
     512,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     520,   521,   522,   523,     0,     0,   524,     0,     0,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   222,     0,   600,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   223,   224,   225,   226,   227,   228,   229,   230,
       0,   232,   233,   234,     0,     0,     0,     0,     0,     0,
       0,   235,   236,     0,   237,   238,     0,   239,   240,   241,
     242,   243,     0,   244,   245,     0,   246,   247,   248,   249,
     250,     0,     0,   251,   252,   253,   254,   255,     0,   256,
     257,   258,   259,   260,     0,     0,     0,   261,   262,   263,
     264,     0,   265,   266,   267,     0,   268,   269,   270,   271,
     272,   273,     0,     0,   274,   275,   276,     0,     0,     0,
       0,     0,     0,     0,   277,   278,   279,   280,   281,   282,
     283,   284,   285,     0,   286,     0,   287,   288,   289,   290,
     291,   292,     0,   293,   294,   295,     0,     0,   296,   297,
     298,   299,   300,     0,   301,   302,   303,     0,   304,   305,
     306,     0,   307,   308,   309,   310,   311,   312,   313,   314,
     315,     0,   316,     0,   317,   318,   319,   320,     0,   321,
       0,   322,     0,     0,     0,   323,   324,   325,     0,   326,
     327,     0,   328,   329,     0,   330,   331,   332,   333,   334,
       0,   335,   336,   337,   338,     0,   339,   340,   341,   342,
     343,   344,     0,   345,     0,   346,   347,   348,   349,   350,
     351,   352,     0,   353,     0,   354,     0,     0,   355,     0,
     356,   357,   358,   359,   360,     0,     0,   361,   362,     0,
     363,     0,     0,   364,   365,   366,     0,     0,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,     0,   384,   385,   386,   387,
       0,   388,   389,     0,   390,     0,   391,   392,   393,   394,
     395,   396,     0,   397,     0,     0,   398,   399,   400,     0,
       0,   401,   402,     0,   403,     0,   404,   405,   406,   407,
     408,   409,   410,   411,   412,     0,   413,   414,   415,   416,
     417,   418,   419,   420,     0,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,     0,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
       0,   445,   446,     0,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,     0,   459,   460,   461,
     462,   463,     0,   464,   465,   466,   467,   468,     0,   469,
     470,   471,   472,     0,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,     0,   485,   486,     0,
     487,     0,   488,   489,   490,   491,   492,     0,   493,   494,
       0,     0,   495,   496,   497,   498,   499,     0,   500,   501,
     502,   503,   504,   505,   506,     0,     0,   507,   508,   509,
     510,   511,     0,     0,   512,   513,   514,   515,   516,   517,
     518,     0,   519,     0,   520,   521,   522,   523,     0,     0,
     524,     0,     0,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   222,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   223,   224,   225,   226,
     227,   228,   229,   230,     0,   232,   233,   234,     0,     0,
       0,     0,     0,  3829,     0,   235,   236,     0,   237,   238,
       0,   239,   240,   241,   242,   243,     0,   244,   245,     0,
     246,   247,   248,   249,   250,     0,     0,   251,   252,   253,
     254,   255,     0,   256,   257,   258,   259,   260,     0,     0,
       0,   261,   262,   263,   264,     0,   265,   266,   267,     0,
     268,   269,   270,   271,   272,   273,     0,     0,   274,   275,
     276,     0,     0,     0,     0,     0,     0,     0,   277,   278,
     279,   280,   281,   282,   283,   284,   285,     0,   286,     0,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
       0,     0,   296,   297,   298,   299,   300,     0,   301,   302,
     303,     0,   304,   305,   306,     0,   307,   308,   309,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,   318,
     319,   320,     0,   321,     0,   322,     0,     0,     0,   323,
     324,   325,     0,   326,   327,     0,   328,   329,     0,   330,
     331,   332,   333,   334,     0,   335,   336,   337,   338,     0,
     339,   340,   341,   342,   343,   344,     0,   345,     0,   346,
     347,   348,   349,   350,   351,   352,     0,   353,     0,   354,
       0,     0,   355,     0,   356,   357,   358,   359,   360,     0,
       0,   361,   362,     0,   363,     0,     0,   364,   365,   366,
       0,     0,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,     0,
     384,   385,   386,   387,     0,   388,   389,     0,   390,     0,
     391,   392,   393,   394,   395,   396,     0,   397,     0,     0,
     398,   399,   400,     0,     0,   401,   402,     0,   403,     0,
     404,   405,   406,   407,   408,   409,   410,   411,   412,     0,
     413,   414,   415,   416,   417,   418,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,     0,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,     0,   445,   446,     0,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
       0,   459,   460,   461,   462,   463,     0,   464,   465,   466,
     467,   468,     0,   469,   470,   471,   472,     0,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
       0,   485,   486,     0,   487,     0,   488,   489,   490,   491,
     492,     0,   493,   494,     0,     0,   495,   496,   497,   498,
     499,     0,   500,   501,   502,   503,   504,   505,   506,     0,
       0,   507,   508,   509,   510,   511,     0,     0,   512,   513,
     514,   515,   516,   517,   518,     0,   519,     0,   520,   521,
     522,   523,     0,     0,   524,     0,     0,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   222,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     223,   224,   225,   226,   227,   228,   229,   230,     0,   232,
     233,   234,     0,     0,     0,     0,     0,  3843,     0,   235,
     236,     0,   237,   238,     0,   239,   240,   241,   242,   243,
       0,   244,   245,     0,   246,   247,   248,   249,   250,     0,
       0,   251,   252,   253,   254,   255,     0,   256,   257,   258,
     259,   260,     0,     0,     0,   261,   262,   263,   264,     0,
     265,   266,   267,     0,   268,   269,   270,   271,   272,   273,
       0,     0,   274,   275,   276,     0,     0,     0,     0,     0,
       0,     0,   277,   278,   279,   280,   281,   282,   283,   284,
     285,     0,   286,     0,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,     0,     0,   296,   297,   298,   299,
     300,     0,   301,   302,   303,     0,   304,   305,   306,     0,
     307,   308,   309,   310,   311,   312,   313,   314,   315,     0,
     316,     0,   317,   318,   319,   320,     0,   321,     0,   322,
       0,     0,     0,   323,   324,   325,     0,   326,   327,     0,
     328,   329,     0,   330,   331,   332,   333,   334,     0,   335,
     336,   337,   338,     0,   339,   340,   341,   342,   343,   344,
       0,   345,     0,   346,   347,   348,   349,   350,   351,   352,
       0,   353,     0,   354,     0,     0,   355,     0,   356,   357,
     358,   359,   360,     0,     0,   361,   362,     0,   363,     0,
       0,   364,   365,   366,     0,     0,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,     0,   384,   385,   386,   387,     0,   388,
     389,     0,   390,     0,   391,   392,   393,   394,   395,   396,
       0,   397,     0,     0,   398,   399,   400,     0,     0,   401,
     402,     0,   403,     0,   404,   405,   406,   407,   408,   409,
     410,   411,   412,     0,   413,   414,   415,   416,   417,   418,
     419,   420,     0,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,     0,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,     0,   445,
     446,     0,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,   462,   463,
       0,   464,   465,   466,   467,   468,     0,   469,   470,   471,
     472,     0,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,     0,   485,   486,     0,   487,     0,
     488,   489,   490,   491,   492,     0,   493,   494,     0,     0,
     495,   496,   497,   498,   499,     0,   500,   501,   502,   503,
     504,   505,   506,     0,     0,   507,   508,   509,   510,   511,
       0,     0,   512,   513,   514,   515,   516,   517,   518,     0,
     519,     0,   520,   521,   522,   523,     0,     0,   524,     0,
       0,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   222,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   223,   224,   225,   226,   227,   228,
     229,   230,     0,   232,   233,   234,     0,     0,     0,     0,
       0,     0,     0,   235,   236,     0,   237,   238,     0,   239,
     240,   241,   242,   243,     0,   244,   245,     0,   246,   247,
     248,   249,   250,     0,     0,   251,   252,   253,   254,   255,
       0,   256,   257,   258,   259,   260,     0,     0,     0,   261,
     262,   263,   264,     0,   265,   266,   267,     0,   268,   269,
     270,   271,   272,   273,     0,     0,   274,   275,   276,     0,
       0,     0,     0,     0,     0,     0,   277,   278,   279,   280,
     281,   282,   283,   284,   285,     0,   286,     0,   287,   288,
     289,   290,   291,   292,     0,   293,   294,   295,     0,     0,
     296,   297,   298,   299,   300,     0,   301,   302,   303,     0,
     304,   305,   306,     0,   307,   308,   309,   310,   311,   312,
     313,   314,   315,     0,   316,     0,   317,   318,   319,   320,
       0,   321,     0,   322,     0,     0,     0,   323,   324,   325,
       0,   326,   327,     0,   328,   329,     0,   330,   331,   332,
     333,   334,     0,   335,   336,   337,   338,     0,   339,   340,
     341,   342,   343,   344,     0,   345,     0,   346,   347,   348,
     349,   350,   351,   352,     0,   353,     0,   354,     0,     0,
     355,     0,   356,   357,   358,   359,   360,     0,     0,   361,
     362,     0,   363,     0,     0,   364,   365,   366,     0,     0,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,     0,   384,   385,
     386,   387,     0,   388,   389,     0,   390,     0,   391,   392,
     393,   394,   395,   396,     0,   397,     0,     0,   398,   399,
     400,     0,     0,   401,   402,     0,   403,     0,   404,   405,
     406,   407,   408,   409,   410,   411,   412,     0,   413,   414,
     415,   416,   417,   418,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
       0,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,     0,   445,   446,     0,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,     0,   459,
     460,   461,   462,   463,     0,   464,   465,   466,   467,   468,
       0,   469,   470,   471,   472,     0,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,     0,   485,
     486,     0,   487,     0,   488,   489,   490,   491,   492,     0,
     493,   494,     0,     0,   495,   496,   497,   498,   499,     0,
     500,   501,   502,   503,   504,   505,   506,     0,     0,   507,
     508,   509,   510,   511,     0,     0,   512,   513,   514,   515,
     516,   517,   518,     0,   519,     0,   520,   521,   522,   523,
       0,     0,   524,     0,     0,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   222,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   223,   224,
     225,   226,   227,   228,   229,   230,     0,   232,   233,   234,
       0,     0,     0,     0,     0,     0,     0,   235,   236,     0,
     237,   238,     0,   239,   240,   241,   242,   243,     0,   244,
     245,     0,   246,   247,   248,   249,   250,     0,     0,   251,
     252,   253,   254,   255,     0,   256,   257,   258,   259,   260,
       0,     0,     0,   261,   262,   263,   264,     0,   265,   266,
     267,     0,   268,   269,   270,   271,   272,   273,     0,     0,
     274,   275,   276,     0,     0,     0,     0,     0,     0,     0,
     277,   278,   279,   280,   281,   282,   283,   284,   285,     0,
     286,     0,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,     0,     0,   296,   297,   298,   299,   300,     0,
     301,   302,   303,     0,   304,   305,   306,     0,   307,   308,
     309,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,   318,   319,   320,     0,   321,     0,   322,     0,     0,
       0,   323,   324,   325,     0,   326,   327,     0,   328,   329,
       0,   330,   331,   332,   333,   334,     0,   335,   336,   337,
     338,     0,   339,   340,   341,   342,   343,   344,     0,   345,
       0,   346,   347,   348,   349,   350,   351,   352,     0,   353,
       0,   354,     0,     0,   355,     0,   356,   357,   358,   359,
     360,     0,     0,   361,   362,     0,   363,     0,     0,   364,
     365,   366,     0,     0,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,     0,   384,   385,   386,   387,     0,   388,   389,     0,
     390,     0,   391,   392,   393,   394,   395,   396,     0,   397,
       0,     0,   398,   399,   400,     0,     0,   401,   402,     0,
     403,     0,   404,   405,   406,   407,   408,   409,   410,   411,
     412,     0,   413,   414,   415,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,     0,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,     0,   445,   446,     0,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,     0,   459,   460,   461,   462,   463,     0,   464,
     465,   466,   467,   468,     0,   469,   470,   471,   472,     0,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,     0,   485,   486,     0,   487,     0,   488,   489,
     490,   491,   492,     0,   493,   494,     0,     0,   689,   496,
     497,   498,   499,     0,   500,   501,   502,   503,   504,   505,
     506,     0,     0,   507,   508,   509,   510,   511,     0,     0,
     512,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     520,   521,   522,   523,     0,     0,   524,     0,     0,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   222,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   223,   224,   225,   226,   227,   228,   229,   230,
       0,   232,   233,   234,     0,     0,     0,     0,     0,     0,
       0,   235,   236,     0,   237,   238,     0,   239,   240,   241,
     242,   243,     0,   244,   245,     0,   246,   247,   248,   249,
     250,     0,     0,   251,   252,   253,   254,   255,     0,   256,
     257,   258,   259,   260,     0,     0,     0,   261,   262,   263,
     264,     0,   265,   266,   267,     0,   268,   269,   270,   271,
     272,   273,     0,     0,   274,   275,   276,     0,     0,     0,
       0,     0,     0,     0,   277,   278,   279,   280,   281,   282,
     283,   284,   285,     0,   286,     0,   287,   288,   289,   290,
     291,   292,     0,   293,   294,   295,     0,     0,   296,   297,
     298,   299,   300,     0,   301,   302,   303,     0,   304,   305,
     306,     0,   307,   308,   309,   310,   311,   312,   313,   314,
     315,     0,   316,     0,   317,   318,   319,   320,     0,   321,
       0,   322,     0,     0,     0,   323,   324,   325,     0,   326,
     327,     0,   328,   329,     0,   330,   331,   332,   333,   334,
       0,   335,   336,   337,   338,     0,   339,   340,   341,   342,
     343,   344,     0,   345,     0,   346,   347,   348,   349,   350,
     351,   352,     0,   353,     0,   354,     0,     0,   355,     0,
     356,   357,   358,   359,   360,     0,     0,   361,   362,     0,
     363,     0,     0,   364,   365,   366,     0,     0,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,     0,   384,   385,   386,   387,
       0,   388,   389,     0,   390,     0,   391,   392,   393,   394,
     395,   396,     0,   397,     0,     0,   398,   399,   400,     0,
       0,   401,   402,     0,   403,     0,   404,   405,   406,   407,
     408,   409,   410,   411,   412,     0,   413,   414,   415,   416,
     417,   418,   419,   420,     0,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,     0,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
       0,   445,   446,     0,   447,   448,   449,   450,   451,   452,
     701,   454,   455,   456,   457,   458,     0,   459,   460,   461,
     462,   463,     0,   464,   465,   466,   467,   468,     0,   469,
     470,   471,   472,     0,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,     0,   485,   486,     0,
     487,     0,   488,   489,   490,   491,   492,     0,   493,   494,
       0,     0,   495,   496,   497,   498,   499,     0,   500,   501,
     502,   503,   504,   505,   506,     0,     0,   507,   508,   509,
     510,   511,     0,     0,   512,   513,   514,   515,   516,   517,
     518,     0,   519,     0,   520,   521,   522,   523,     0,     0,
     524,     0,     0,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   222,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   223,   224,   225,   226,
     227,   228,   229,   230,     0,   232,   233,   234,     0,     0,
       0,     0,     0,     0,     0,   235,   236,     0,   237,   238,
       0,   239,   240,   241,   242,   243,     0,   244,   245,     0,
     246,   247,   248,   249,   250,     0,     0,   723,   252,   253,
     254,   255,     0,   256,   257,   258,   259,   260,     0,     0,
       0,   261,   262,   263,   264,     0,   265,   266,   267,     0,
     724,   269,   270,   271,   272,   273,     0,     0,   274,   275,
     276,     0,     0,     0,     0,     0,     0,     0,   277,   278,
     279,   280,   281,   282,   283,   284,   285,     0,   286,     0,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
       0,     0,   296,   297,   298,   299,   300,     0,   301,   302,
     303,     0,   304,   305,   306,     0,   307,   308,   309,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,   318,
     319,   320,     0,   321,     0,   322,     0,     0,     0,   323,
     324,   325,     0,   326,   327,     0,   328,   329,     0,   330,
     331,   332,   333,   334,     0,   335,   336,   337,   338,     0,
     339,   340,   341,   342,   343,   344,     0,   345,     0,   346,
     347,   348,   349,   350,   351,   352,     0,   353,     0,   354,
       0,     0,   355,     0,   356,   357,   358,   359,   360,     0,
       0,   361,   362,     0,   363,     0,     0,   364,   365,   725,
       0,     0,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   726,   383,     0,
     384,   385,   386,   387,     0,   388,   389,     0,   390,     0,
     391,   392,   393,   394,   395,   396,     0,   397,     0,     0,
     398,   399,   400,     0,     0,   401,   402,     0,   403,     0,
     404,   405,   406,   407,   408,   409,   410,   411,   412,     0,
     413,   414,   415,   416,   417,   418,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,     0,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,     0,   445,   446,     0,   727,   448,
     449,   450,   451,   452,   453,   728,   455,   456,   457,   458,
       0,   459,   460,   461,   462,   729,     0,   464,   465,   466,
     467,   468,     0,   469,   470,   471,   472,     0,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
       0,   485,   486,     0,   487,     0,   488,   489,   490,   491,
     492,     0,   730,   494,     0,     0,   731,   496,   497,   498,
     499,     0,   500,   501,   502,   503,   504,   505,   506,     0,
       0,   507,   508,   509,   510,   511,     0,     0,   512,   513,
     514,   515,   516,   517,   518,     0,   519,     0,   520,   521,
     522,   523,     0,     0,   524,     0,     0,   525,   526,   527,
     528,   529,   732,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   222,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     223,   224,   225,   226,   227,   228,   229,   230,     0,   232,
     233,   234,     0,     0,     0,     0,     0,     0,     0,   235,
     236,     0,   237,   238,     0,   239,   240,   241,   242,   243,
       0,   244,   245,     0,   246,   247,   248,   249,   250,     0,
       0,   251,   252,   253,   254,   255,     0,   256,   257,   258,
     259,   260,     0,     0,     0,   261,   262,   263,   264,     0,
     265,   266,   267,     0,   268,   269,   270,   271,   272,   273,
       0,     0,   274,   275,   276,     0,     0,     0,     0,     0,
       0,     0,   277,   278,   279,   280,   281,   282,   283,   284,
     285,     0,   286,     0,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,     0,     0,   296,   297,   298,   299,
     300,     0,   301,   302,   303,     0,   304,   305,   306,     0,
     307,   308,   309,   310,   311,   312,   313,   314,   315,     0,
     316,     0,   317,   318,   319,   320,     0,   321,     0,   322,
       0,     0,     0,   323,   324,   325,     0,   326,   327,     0,
     328,   329,     0,   330,   331,   332,   333,   334,     0,   335,
     336,   337,   338,     0,   339,   340,   341,   342,   343,   344,
       0,   345,     0,   346,   347,   348,   349,   350,   351,   352,
       0,   353,     0,   354,     0,     0,   355,     0,   356,   357,
     358,   359,   360,     0,     0,   361,   362,     0,   363,     0,
       0,   364,   365,   366,     0,     0,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,     0,   384,   385,   386,   387,     0,   388,
     389,     0,   390,     0,   391,   392,   393,   394,   395,   396,
       0,   397,     0,     0,   398,   399,   400,     0,     0,   401,
     402,     0,   403,     0,   404,   405,   406,   407,   408,   409,
     410,   411,   412,     0,   413,   414,   415,   416,   417,   418,
     419,   420,     0,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   755,   433,     0,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,     0,   445,
     446,     0,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,   462,   463,
       0,   464,   465,   466,   467,   468,     0,   469,   470,   471,
     472,     0,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,     0,   485,   486,     0,   487,     0,
     488,   489,   490,   491,   492,     0,   493,   494,     0,     0,
     495,   496,   497,   498,   499,     0,   500,   501,   502,   503,
     504,   505,   506,     0,     0,   507,   508,   509,   510,   511,
       0,     0,   512,   513,   514,   515,   516,   517,   518,     0,
     519,     0,   520,   521,   522,   523,     0,     0,   524,     0,
       0,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   222,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   223,   224,   225,   226,   227,   228,
     229,   230,     0,   232,   233,   234,     0,     0,     0,     0,
       0,     0,     0,   235,   236,     0,   237,   238,     0,   239,
     240,   241,   242,   243,     0,   244,   245,     0,   246,   247,
     248,   249,   250,     0,     0,   251,   252,   253,   254,   255,
       0,   256,   257,   258,   259,   260,     0,     0,     0,   261,
     262,   263,   264,     0,   265,   266,   267,     0,   268,   269,
     270,   271,   272,   273,     0,     0,   274,   275,   276,     0,
       0,     0,     0,     0,     0,     0,   277,   278,   279,   280,
     281,   282,   283,   284,   285,     0,   286,     0,   287,   288,
     289,   290,   291,   292,     0,   293,   294,   295,     0,     0,
     296,   297,   298,   299,   300,     0,   301,   302,   303,     0,
     304,   305,   306,     0,   307,   308,   309,   310,   311,   312,
     313,   314,   315,     0,   316,     0,   317,   318,   319,   320,
       0,   321,     0,   322,     0,     0,     0,   323,   324,   325,
       0,   326,   327,     0,   328,   329,     0,   330,   331,   332,
     333,   856,     0,   335,   336,   337,   338,     0,   339,   340,
     341,   342,   343,   344,     0,   345,     0,   346,   347,   348,
     349,   350,   351,   352,     0,   353,     0,   354,     0,     0,
     355,     0,   356,   357,   358,   359,   360,     0,     0,   361,
     362,     0,   363,     0,     0,   364,   365,   366,     0,     0,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,     0,   384,   385,
     386,   387,     0,   388,   389,     0,   390,     0,   391,   392,
     393,   394,   395,   396,     0,   397,     0,     0,   398,   399,
     400,     0,     0,   401,   402,     0,   403,     0,   404,   405,
     406,   407,   408,   409,   410,   411,   412,     0,   413,   414,
     415,   416,   417,   418,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
       0,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,     0,   445,   446,     0,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,     0,   459,
     460,   461,   462,   463,     0,   464,   465,   466,   467,   468,
       0,   469,   470,   471,   472,     0,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,     0,   485,
     486,     0,   487,     0,   488,   489,   490,   491,   492,     0,
     493,   494,     0,     0,   495,   496,   497,   498,   499,     0,
     500,   501,   502,   503,   504,   505,   506,     0,     0,   507,
     508,   509,   510,   511,     0,     0,   512,   513,   514,   515,
     516,   517,   518,     0,   519,     0,   520,   521,   522,   523,
       0,     0,   524,     0,     0,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   222,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   223,   224,
     225,   226,   227,   228,   229,   230,     0,   232,   233,   234,
       0,     0,     0,     0,     0,     0,     0,   235,   236,     0,
     237,   238,     0,   239,   240,   241,   242,   243,     0,   244,
     245,     0,   246,   247,   248,   249,   250,     0,     0,   251,
     252,   253,   254,   255,     0,   256,   257,   258,   259,   260,
       0,     0,     0,   261,   262,   263,   264,     0,   265,   266,
     267,     0,   268,   269,   270,   271,   272,   273,     0,     0,
     274,   275,   276,     0,     0,     0,     0,     0,     0,     0,
     277,   278,   279,   280,   281,   282,   283,   284,   285,     0,
     286,     0,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,     0,     0,   296,   297,   298,   299,   300,     0,
     301,   302,   303,     0,   304,   305,   306,     0,   307,   308,
     309,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,   318,   319,   320,     0,   321,     0,   322,     0,     0,
       0,   323,   324,   325,     0,   326,   327,     0,   328,   329,
       0,   330,   331,   332,   333,   863,     0,   335,   336,   337,
     338,     0,   339,   340,   341,   342,   343,   344,     0,   345,
       0,   346,   347,   348,   349,   350,   351,   352,     0,   353,
       0,   354,     0,     0,   355,     0,   356,   357,   358,   359,
     360,     0,     0,   361,   362,     0,   363,     0,     0,   364,
     365,   366,     0,     0,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,     0,   384,   385,   386,   387,     0,   388,   389,     0,
     390,     0,   391,   392,   393,   394,   395,   396,     0,   397,
       0,     0,   398,   399,   400,     0,     0,   401,   402,     0,
     403,     0,   404,   405,   406,   407,   408,   409,   410,   411,
     412,     0,   413,   414,   415,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,     0,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,     0,   445,   446,     0,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,     0,   459,   460,   461,   462,   463,     0,   464,
     465,   466,   467,   468,     0,   469,   470,   471,   472,     0,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,     0,   485,   486,     0,   487,     0,   488,   489,
     490,   491,   492,     0,   493,   494,     0,     0,   495,   496,
     497,   498,   499,     0,   500,   501,   502,   503,   504,   505,
     506,     0,     0,   507,   508,   509,   510,   511,     0,     0,
     512,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     520,   521,   522,   523,     0,     0,   524,     0,     0,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   222,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   223,   224,   225,   226,   227,   228,   229,   230,
       0,   232,   233,   234,     0,     0,     0,     0,     0,     0,
       0,   235,   236,     0,   237,   238,     0,   239,   240,   241,
     242,   243,     0,   244,   245,     0,   246,   247,   248,   249,
     250,     0,     0,   251,   252,   253,   254,   255,     0,   256,
     257,   258,   259,   260,     0,     0,     0,   261,   262,   263,
     264,     0,   265,   266,   267,     0,   268,   269,   270,   271,
     272,   273,     0,     0,   274,   275,   276,     0,     0,     0,
       0,     0,     0,     0,   277,   278,   279,   280,   281,   282,
     283,   284,   285,     0,   286,     0,   287,   288,   289,   290,
     291,   292,     0,   293,   294,   295,     0,     0,   296,   297,
     298,   299,   300,     0,   301,   302,   303,     0,   304,   305,
     306,     0,   307,   308,   309,   310,   311,   312,   313,   314,
     315,     0,   316,     0,   317,   318,   319,   320,     0,   321,
       0,   322,     0,     0,     0,   323,   324,   325,     0,   326,
     327,     0,   328,   329,     0,   330,   331,   332,   333,   878,
       0,   335,   336,   337,   338,     0,   339,   340,   341,   342,
     343,   344,     0,   345,     0,   346,   347,   348,   349,   350,
     351,   352,     0,   353,     0,   354,     0,     0,   355,     0,
     356,   357,   358,   359,   360,     0,     0,   361,   362,     0,
     363,     0,     0,   364,   365,   366,     0,     0,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,     0,   384,   385,   386,   387,
       0,   388,   389,     0,   390,     0,   391,   392,   393,   394,
     395,   396,     0,   397,     0,     0,   398,   399,   400,     0,
       0,   401,   402,     0,   403,     0,   404,   405,   406,   407,
     408,   409,   410,   411,   412,     0,   413,   414,   415,   416,
     417,   418,   419,   420,     0,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,     0,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
       0,   445,   446,     0,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,     0,   459,   460,   461,
     462,   463,     0,   464,   465,   466,   467,   468,     0,   469,
     470,   471,   472,     0,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,     0,   485,   486,     0,
     487,     0,   488,   489,   490,   491,   492,     0,   493,   494,
       0,     0,   495,   496,   497,   498,   499,     0,   500,   501,
     502,   503,   504,   505,   506,     0,     0,   507,   508,   509,
     510,   511,     0,     0,   512,   513,   514,   515,   516,   517,
     518,     0,   519,     0,   520,   521,   522,   523,     0,     0,
     524,     0,     0,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   222,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   223,   224,   225,   226,
     227,   228,   229,   230,     0,   232,   233,   234,     0,     0,
       0,     0,     0,     0,     0,   235,   236,     0,   237,   238,
       0,   239,   240,   241,   242,   243,     0,   244,   245,     0,
     246,   247,   248,   249,   250,     0,     0,   251,   252,   253,
     254,   255,     0,   256,   257,   258,   259,   260,     0,     0,
       0,   261,   262,   263,   264,     0,   265,   266,   267,     0,
     268,   269,   270,   271,   272,   273,     0,     0,   274,   275,
     276,     0,     0,     0,     0,     0,     0,     0,   277,   278,
     279,   280,   281,   282,   283,   284,   285,     0,   286,     0,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
       0,     0,   296,   297,   298,   299,   300,     0,   301,   302,
     303,     0,   304,   305,   306,     0,   307,   308,   309,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,   318,
     319,   320,     0,   321,     0,   322,     0,     0,     0,   323,
     324,   325,     0,   326,   327,     0,   328,   329,     0,   330,
     331,   332,   333,   939,     0,   335,   336,   337,   338,     0,
     339,   340,   341,   342,   343,   344,     0,   345,     0,   346,
     347,   348,   349,   350,   351,   352,     0,   353,     0,   354,
       0,     0,   355,     0,   356,   357,   358,   359,   360,     0,
       0,   361,   362,     0,   363,     0,     0,   364,   365,   366,
       0,     0,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,     0,
     384,   385,   386,   387,     0,   388,   389,     0,   390,     0,
     391,   392,   393,   394,   395,   396,     0,   397,     0,     0,
     398,   399,   400,     0,     0,   401,   402,     0,   403,     0,
     404,   405,   406,   407,   408,   409,   410,   411,   412,     0,
     413,   414,   415,   416,   417,   418,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,     0,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,     0,   445,   446,     0,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
       0,   459,   460,   461,   462,   463,     0,   464,   465,   466,
     467,   468,     0,   469,   470,   471,   472,     0,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
       0,   485,   486,     0,   487,     0,   488,   489,   490,   491,
     492,     0,   493,   494,     0,     0,   495,   496,   497,   498,
     499,     0,   500,   501,   502,   503,   504,   505,   506,     0,
       0,   507,   508,   509,   510,   511,     0,     0,   512,   513,
     514,   515,   516,   517,   518,     0,   519,     0,   520,   521,
     522,   523,     0,     0,   524,     0,     0,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   222,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     223,   224,   225,   226,   227,   228,   229,   230,     0,   232,
     233,   234,     0,     0,     0,     0,     0,     0,     0,   235,
     236,     0,   237,   238,     0,   239,   240,   241,   242,   243,
       0,   244,   245,     0,   246,   247,   248,   249,   250,     0,
       0,   251,   252,   253,   254,   255,     0,   256,   257,   258,
     259,   260,     0,     0,     0,   261,   262,   263,   264,     0,
     265,   266,   267,     0,   268,   269,   270,   271,   272,   273,
       0,     0,   274,   275,   276,     0,     0,     0,     0,     0,
       0,     0,   277,   278,   279,   280,   281,   282,   283,   284,
     285,     0,   286,     0,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,     0,     0,   296,   297,   298,   299,
     300,     0,   301,   302,   303,     0,   304,   305,   306,     0,
     307,   308,   309,   310,   311,   312,   313,   314,   315,     0,
     316,     0,   317,   318,   319,   320,     0,   321,     0,   322,
       0,     0,     0,   323,   324,   325,     0,   326,   327,     0,
     328,   329,     0,   330,   331,   332,   333,   955,     0,   335,
     336,   337,   338,     0,   339,   340,   341,   342,   343,   344,
       0,   345,     0,   346,   347,   348,   349,   350,   351,   352,
       0,   353,     0,   354,     0,     0,   355,     0,   356,   357,
     358,   359,   360,     0,     0,   361,   362,     0,   363,     0,
       0,   364,   365,   366,     0,     0,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,     0,   384,   385,   386,   387,     0,   388,
     389,     0,   390,     0,   391,   392,   393,   394,   395,   396,
       0,   397,     0,     0,   398,   399,   400,     0,     0,   401,
     402,     0,   403,     0,   404,   405,   406,   407,   408,   409,
     410,   411,   412,     0,   413,   414,   415,   416,   417,   418,
     419,   420,     0,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,     0,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,     0,   445,
     446,     0,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,   462,   463,
       0,   464,   465,   466,   467,   468,     0,   469,   470,   471,
     472,     0,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,     0,   485,   486,     0,   487,     0,
     488,   489,   490,   491,   492,     0,   493,   494,     0,     0,
     495,   496,   497,   498,   499,     0,   500,   501,   502,   503,
     504,   505,   506,     0,     0,   507,   508,   509,   510,   511,
       0,     0,   512,   513,   514,   515,   516,   517,   518,     0,
     519,     0,   520,   521,   522,   523,     0,     0,   524,     0,
       0,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   222,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   223,   224,   225,   226,   227,   228,
     229,   230,     0,   232,   233,   234,     0,     0,     0,     0,
       0,     0,     0,   235,   236,     0,   237,   238,     0,   239,
     240,   241,   242,   243,     0,   244,   245,     0,   246,   247,
     248,   249,   250,     0,     0,   251,   252,   253,   254,   255,
       0,   256,   257,   258,   259,   260,     0,     0,     0,   261,
     262,   263,   264,     0,   265,   266,   267,     0,   268,   269,
     270,   271,   272,   273,     0,     0,   274,   275,   276,     0,
       0,     0,     0,     0,     0,     0,   277,   278,   279,   280,
     281,   282,   283,   284,   285,     0,   286,     0,   287,   288,
     289,   290,   291,   292,     0,   293,   294,   295,     0,     0,
     296,   297,   298,   299,   300,     0,   301,   302,   303,     0,
     304,   305,   306,     0,   307,   308,   309,   310,   311,   312,
     313,   314,   315,     0,   316,     0,   317,   318,   319,   320,
       0,   321,     0,   322,     0,     0,     0,   323,   324,   325,
       0,   326,   327,     0,   328,   329,     0,   330,   331,   332,
     333,   990,     0,   335,   336,   337,   338,     0,   339,   340,
     341,   342,   343,   344,     0,   345,     0,   346,   347,   348,
     349,   350,   351,   352,     0,   353,     0,   354,     0,     0,
     355,     0,   356,   357,   358,   359,   360,     0,     0,   361,
     362,     0,   363,     0,     0,   364,   365,   366,     0,     0,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,     0,   384,   385,
     386,   387,     0,   388,   389,     0,   390,     0,   391,   392,
     393,   394,   395,   396,     0,   397,     0,     0,   398,   399,
     400,     0,     0,   401,   402,     0,   403,     0,   404,   405,
     406,   407,   408,   409,   410,   411,   412,     0,   413,   414,
     415,   416,   417,   418,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
       0,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,     0,   445,   446,     0,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,     0,   459,
     460,   461,   462,   463,     0,   464,   465,   466,   467,   468,
       0,   469,   470,   471,   472,     0,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,     0,   485,
     486,     0,   487,     0,   488,   489,   490,   491,   492,     0,
     493,   494,     0,     0,   495,   496,   497,   498,   499,     0,
     500,   501,   502,   503,   504,   505,   506,     0,     0,   507,
     508,   509,   510,   511,     0,     0,   512,   513,   514,   515,
     516,   517,   518,     0,   519,     0,   520,   521,   522,   523,
       0,     0,   524,     0,     0,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   222,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   223,   224,
     225,   226,   227,   228,   229,   230,     0,   232,   233,   234,
       0,     0,     0,     0,     0,     0,     0,   235,   236,     0,
     237,   238,     0,   239,   240,   241,   242,   243,     0,   244,
     245,     0,   246,   247,   248,   249,   250,     0,     0,   251,
     252,   253,   254,   255,     0,   256,   257,   258,   259,   260,
       0,     0,     0,   261,   262,   263,   264,     0,   265,   266,
     267,     0,   268,   269,   270,   271,   272,   273,     0,     0,
     274,   275,   276,     0,     0,     0,     0,     0,     0,     0,
     277,   278,   279,   280,   281,   282,   283,   284,   285,     0,
     286,     0,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,     0,     0,   296,   297,   298,   299,   300,     0,
     301,   302,   303,     0,   304,   305,   306,     0,   307,   308,
     309,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,   318,   319,   320,     0,   321,     0,   322,     0,     0,
       0,   323,   324,   325,     0,   326,   327,     0,   328,   329,
       0,   330,   331,   332,   333,  1046,     0,   335,   336,   337,
     338,     0,   339,   340,   341,   342,   343,   344,     0,   345,
       0,   346,   347,   348,   349,   350,   351,   352,     0,   353,
       0,   354,     0,     0,   355,     0,   356,   357,   358,   359,
     360,     0,     0,   361,   362,     0,   363,     0,     0,   364,
     365,   366,     0,     0,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,     0,   384,   385,   386,   387,     0,   388,   389,     0,
     390,     0,   391,   392,   393,   394,   395,   396,     0,   397,
       0,     0,   398,   399,   400,     0,     0,   401,   402,     0,
     403,     0,   404,   405,   406,   407,   408,   409,   410,   411,
     412,     0,   413,   414,   415,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,     0,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,     0,   445,   446,     0,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,     0,   459,   460,   461,   462,   463,     0,   464,
     465,   466,   467,   468,     0,   469,   470,   471,   472,     0,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,     0,   485,   486,     0,   487,     0,   488,   489,
     490,   491,   492,     0,   493,   494,     0,     0,   495,   496,
     497,   498,   499,     0,   500,   501,   502,   503,   504,   505,
     506,     0,     0,   507,   508,   509,   510,   511,     0,     0,
     512,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     520,   521,   522,   523,     0,     0,   524,     0,     0,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   222,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   223,   224,   225,   226,   227,   228,   229,   230,
       0,   232,   233,   234,     0,     0,     0,     0,     0,     0,
       0,   235,   236,     0,   237,   238,     0,   239,   240,   241,
     242,   243,     0,   244,   245,     0,   246,   247,   248,   249,
     250,     0,     0,   251,   252,   253,   254,   255,     0,   256,
     257,   258,   259,   260,     0,     0,     0,   261,   262,   263,
     264,     0,   265,   266,   267,     0,   268,   269,   270,   271,
     272,   273,     0,     0,   274,   275,   276,     0,     0,     0,
       0,     0,     0,     0,   277,   278,   279,   280,   281,   282,
     283,   284,   285,     0,   286,     0,   287,   288,   289,   290,
     291,   292,     0,   293,   294,   295,     0,     0,   296,   297,
     298,   299,   300,     0,   301,   302,   303,     0,   304,   305,
     306,     0,   307,   308,   309,   310,   311,   312,   313,   314,
     315,     0,   316,     0,   317,   318,   319,   320,     0,   321,
       0,   322,     0,     0,     0,   323,   324,   325,     0,   326,
     327,     0,   328,   329,     0,   330,   331,   332,   333,  1050,
       0,   335,   336,   337,   338,     0,   339,   340,   341,   342,
     343,   344,     0,   345,     0,   346,   347,   348,   349,   350,
     351,   352,     0,   353,     0,   354,     0,     0,   355,     0,
     356,   357,   358,   359,   360,     0,     0,   361,   362,     0,
     363,     0,     0,   364,   365,   366,     0,     0,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,     0,   384,   385,   386,   387,
       0,   388,   389,     0,   390,     0,   391,   392,   393,   394,
     395,   396,     0,   397,     0,     0,   398,   399,   400,     0,
       0,   401,   402,     0,   403,     0,   404,   405,   406,   407,
     408,   409,   410,   411,   412,     0,   413,   414,   415,   416,
     417,   418,   419,   420,     0,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,     0,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
       0,   445,   446,     0,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,     0,   459,   460,   461,
     462,   463,     0,   464,   465,   466,   467,   468,     0,   469,
     470,   471,   472,     0,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,     0,   485,   486,     0,
     487,     0,   488,   489,   490,   491,   492,     0,   493,   494,
       0,     0,   495,   496,   497,   498,   499,     0,   500,   501,
     502,   503,   504,   505,   506,     0,     0,   507,   508,   509,
     510,   511,     0,     0,   512,   513,   514,   515,   516,   517,
     518,     0,   519,     0,   520,   521,   522,   523,     0,     0,
     524,     0,     0,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   222,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   223,   224,   225,   226,
     227,   228,   229,   230,     0,   232,   233,   234,     0,     0,
       0,     0,     0,     0,     0,   235,   236,     0,   237,   238,
       0,   239,   240,   241,   242,   243,     0,   244,   245,     0,
     246,   247,   248,   249,   250,     0,     0,   251,   252,   253,
     254,   255,     0,   256,   257,   258,   259,   260,     0,     0,
       0,   261,   262,   263,   264,     0,   265,   266,   267,     0,
     268,   269,   270,   271,   272,   273,     0,     0,   274,   275,
     276,     0,     0,     0,     0,     0,     0,     0,   277,   278,
     279,   280,   281,   282,   283,   284,   285,     0,   286,     0,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
       0,     0,   296,   297,   298,   299,   300,     0,   301,   302,
     303,     0,   304,   305,   306,     0,   307,   308,   309,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,   318,
     319,   320,     0,   321,     0,   322,     0,     0,     0,   323,
     324,   325,     0,   326,   327,     0,   328,   329,     0,   330,
     331,   332,   333,  1052,     0,   335,   336,   337,   338,     0,
     339,   340,   341,   342,   343,   344,     0,   345,     0,   346,
     347,   348,   349,   350,   351,   352,     0,   353,     0,   354,
       0,     0,   355,     0,   356,   357,   358,   359,   360,     0,
       0,   361,   362,     0,   363,     0,     0,   364,   365,   366,
       0,     0,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,     0,
     384,   385,   386,   387,     0,   388,   389,     0,   390,     0,
     391,   392,   393,   394,   395,   396,     0,   397,     0,     0,
     398,   399,   400,     0,     0,   401,   402,     0,   403,     0,
     404,   405,   406,   407,   408,   409,   410,   411,   412,     0,
     413,   414,   415,   416,   417,   418,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,     0,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,     0,   445,   446,     0,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
       0,   459,   460,   461,   462,   463,     0,   464,   465,   466,
     467,   468,     0,   469,   470,   471,   472,     0,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
       0,   485,   486,     0,   487,     0,   488,   489,   490,   491,
     492,     0,   493,   494,     0,     0,   495,   496,   497,   498,
     499,     0,   500,   501,   502,   503,   504,   505,   506,     0,
       0,   507,   508,   509,   510,   511,     0,     0,   512,   513,
     514,   515,   516,   517,   518,     0,   519,     0,   520,   521,
     522,   523,     0,     0,   524,     0,     0,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   222,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     223,   224,   225,   226,   227,   228,   229,   230,     0,   232,
     233,   234,     0,     0,     0,     0,     0,     0,     0,   235,
     236,     0,   237,   238,     0,   239,   240,   241,   242,   243,
       0,   244,   245,     0,   246,   247,   248,   249,   250,     0,
       0,   251,   252,   253,   254,   255,     0,   256,   257,   258,
     259,   260,     0,     0,     0,   261,   262,   263,   264,     0,
     265,   266,   267,     0,   268,   269,   270,   271,   272,   273,
       0,     0,   274,   275,   276,     0,     0,     0,     0,     0,
       0,     0,   277,   278,   279,   280,   281,   282,   283,   284,
     285,     0,   286,     0,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,     0,     0,   296,   297,   298,   299,
     300,     0,   301,   302,   303,     0,   304,   305,   306,     0,
     307,   308,   309,   310,   311,   312,   313,   314,   315,     0,
     316,     0,   317,   318,   319,   320,     0,   321,     0,   322,
       0,     0,     0,   323,   324,   325,     0,   326,   327,     0,
     328,   329,     0,   330,   331,   332,   333,  1054,     0,   335,
     336,   337,   338,     0,   339,   340,   341,   342,   343,   344,
       0,   345,     0,   346,   347,   348,   349,   350,   351,   352,
       0,   353,     0,   354,     0,     0,   355,     0,   356,   357,
     358,   359,   360,     0,     0,   361,   362,     0,   363,     0,
       0,   364,   365,   366,     0,     0,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,     0,   384,   385,   386,   387,     0,   388,
     389,     0,   390,     0,   391,   392,   393,   394,   395,   396,
       0,   397,     0,     0,   398,   399,   400,     0,     0,   401,
     402,     0,   403,     0,   404,   405,   406,   407,   408,   409,
     410,   411,   412,     0,   413,   414,   415,   416,   417,   418,
     419,   420,     0,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,     0,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,     0,   445,
     446,     0,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,   462,   463,
       0,   464,   465,   466,   467,   468,     0,   469,   470,   471,
     472,     0,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,     0,   485,   486,     0,   487,     0,
     488,   489,   490,   491,   492,     0,   493,   494,     0,     0,
     495,   496,   497,   498,   499,     0,   500,   501,   502,   503,
     504,   505,   506,     0,     0,   507,   508,   509,   510,   511,
       0,     0,   512,   513,   514,   515,   516,   517,   518,     0,
     519,     0,   520,   521,   522,   523,     0,     0,   524,     0,
       0,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   222,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   223,   224,   225,   226,   227,   228,
     229,   230,     0,   232,   233,   234,     0,     0,     0,     0,
       0,     0,     0,   235,   236,     0,   237,   238,     0,   239,
     240,   241,   242,   243,     0,   244,   245,     0,   246,   247,
     248,   249,   250,     0,     0,   251,   252,   253,   254,   255,
       0,   256,   257,   258,   259,   260,     0,     0,     0,   261,
     262,   263,   264,     0,   265,   266,   267,     0,   268,   269,
     270,   271,   272,   273,     0,     0,   274,   275,   276,     0,
       0,     0,     0,     0,     0,     0,   277,   278,   279,   280,
     281,   282,   283,   284,   285,     0,   286,     0,   287,   288,
     289,   290,   291,   292,     0,   293,   294,   295,     0,     0,
     296,   297,   298,   299,   300,     0,   301,   302,   303,     0,
     304,   305,   306,     0,   307,   308,   309,   310,   311,   312,
     313,   314,   315,     0,   316,     0,   317,   318,   319,   320,
       0,   321,     0,   322,     0,     0,     0,   323,   324,   325,
       0,   326,   327,     0,   328,   329,     0,   330,   331,   332,
     333,  1058,     0,   335,   336,   337,   338,     0,   339,   340,
     341,   342,   343,   344,     0,   345,     0,   346,   347,   348,
     349,   350,   351,   352,     0,   353,     0,   354,     0,     0,
     355,     0,   356,   357,   358,   359,   360,     0,     0,   361,
     362,     0,   363,     0,     0,   364,   365,   366,     0,     0,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,     0,   384,   385,
     386,   387,     0,   388,   389,     0,   390,     0,   391,   392,
     393,   394,   395,   396,     0,   397,     0,     0,   398,   399,
     400,     0,     0,   401,   402,     0,   403,     0,   404,   405,
     406,   407,   408,   409,   410,   411,   412,     0,   413,   414,
     415,   416,   417,   418,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
       0,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,     0,   445,   446,     0,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,     0,   459,
     460,   461,   462,   463,     0,   464,   465,   466,   467,   468,
       0,   469,   470,   471,   472,     0,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,     0,   485,
     486,     0,   487,     0,   488,   489,   490,   491,   492,     0,
     493,   494,     0,     0,   495,   496,   497,   498,   499,     0,
     500,   501,   502,   503,   504,   505,   506,     0,     0,   507,
     508,   509,   510,   511,     0,     0,   512,   513,   514,   515,
     516,   517,   518,     0,   519,     0,   520,   521,   522,   523,
       0,     0,   524,     0,     0,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   222,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   223,   224,
     225,   226,   227,   228,   229,   230,     0,   232,   233,   234,
       0,     0,     0,     0,     0,     0,     0,   235,   236,     0,
     237,   238,     0,   239,   240,   241,   242,   243,     0,   244,
     245,     0,   246,   247,   248,   249,   250,     0,     0,   251,
     252,   253,   254,   255,     0,   256,   257,   258,   259,   260,
       0,     0,     0,   261,   262,   263,   264,     0,   265,   266,
     267,     0,   268,   269,   270,   271,   272,   273,     0,     0,
     274,   275,   276,     0,     0,     0,     0,     0,     0,     0,
     277,   278,   279,   280,   281,   282,   283,   284,   285,     0,
     286,     0,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,     0,     0,   296,   297,   298,   299,   300,     0,
     301,   302,   303,     0,   304,   305,   306,     0,   307,   308,
     309,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,   318,   319,   320,     0,   321,     0,   322,     0,     0,
       0,   323,   324,   325,     0,   326,   327,     0,   328,   329,
       0,   330,   331,   332,   333,  1066,     0,   335,   336,   337,
     338,     0,   339,   340,   341,   342,   343,   344,     0,   345,
       0,   346,   347,   348,   349,   350,   351,   352,     0,   353,
       0,   354,     0,     0,   355,     0,   356,   357,   358,   359,
     360,     0,     0,   361,   362,     0,   363,     0,     0,   364,
     365,   366,     0,     0,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,     0,   384,   385,   386,   387,     0,   388,   389,     0,
     390,     0,   391,   392,   393,   394,   395,   396,     0,   397,
       0,     0,   398,   399,   400,     0,     0,   401,   402,     0,
     403,     0,   404,   405,   406,   407,   408,   409,   410,   411,
     412,     0,   413,   414,   415,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,     0,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,     0,   445,   446,     0,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,     0,   459,   460,   461,   462,   463,     0,   464,
     465,   466,   467,   468,     0,   469,   470,   471,   472,     0,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,     0,   485,   486,     0,   487,     0,   488,   489,
     490,   491,   492,     0,   493,   494,     0,     0,   495,   496,
     497,   498,   499,     0,   500,   501,   502,   503,   504,   505,
     506,     0,     0,   507,   508,   509,   510,   511,     0,     0,
     512,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     520,   521,   522,   523,     0,     0,   524,     0,     0,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   222,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   223,   224,   225,   226,   227,   228,   229,   230,
       0,   232,   233,   234,     0,     0,     0,     0,     0,     0,
       0,   235,   236,     0,   237,   238,     0,   239,   240,   241,
     242,   243,     0,   244,   245,     0,   246,   247,   248,   249,
     250,     0,     0,   723,   252,   253,   254,   255,     0,   256,
     257,   258,   259,   260,     0,     0,     0,   261,   262,   263,
     264,     0,   265,   266,   267,     0,   268,   269,   270,   271,
     272,   273,     0,     0,   274,   275,   276,     0,     0,     0,
       0,     0,     0,     0,   277,   278,   279,   280,   281,   282,
     283,   284,   285,     0,   286,     0,   287,   288,   289,   290,
     291,   292,     0,   293,   294,   295,     0,     0,   296,   297,
     298,   299,   300,     0,   301,   302,   303,     0,   304,   305,
     306,     0,   307,   308,   309,   310,   311,   312,   313,   314,
     315,     0,   316,     0,   317,   318,   319,   320,     0,   321,
       0,   322,     0,     0,     0,   323,   324,   325,     0,   326,
     327,     0,   328,   329,     0,   330,   331,   332,   333,   334,
       0,   335,   336,   337,   338,     0,   339,   340,   341,   342,
     343,   344,     0,   345,     0,   346,   347,   348,   349,   350,
     351,   352,     0,   353,     0,   354,     0,     0,   355,     0,
     356,   357,   358,   359,   360,     0,     0,   361,   362,     0,
     363,     0,     0,   364,   365,   366,     0,     0,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   726,   383,     0,   384,   385,   386,   387,
       0,   388,   389,     0,   390,     0,   391,   392,   393,   394,
     395,   396,     0,   397,     0,     0,   398,   399,   400,     0,
       0,   401,   402,     0,   403,     0,   404,   405,   406,   407,
     408,   409,   410,   411,   412,     0,   413,   414,   415,   416,
     417,   418,   419,   420,     0,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,     0,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
       0,   445,   446,     0,   727,   448,   449,   450,   451,   452,
     453,   728,   455,   456,   457,   458,     0,   459,   460,   461,
     462,  1244,     0,   464,   465,   466,   467,   468,     0,   469,
     470,   471,   472,     0,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,     0,   485,   486,     0,
     487,     0,   488,   489,   490,   491,   492,     0,   730,   494,
       0,     0,   731,   496,   497,   498,   499,     0,   500,   501,
     502,   503,   504,   505,   506,     0,     0,   507,   508,   509,
     510,   511,     0,     0,   512,   513,   514,   515,   516,   517,
     518,     0,   519,     0,   520,   521,   522,   523,     0,     0,
     524,     0,     0,   525,   526,   527,   528,   529,   732,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   222,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   223,   224,   225,   226,
     227,   228,   229,   230,     0,   232,   233,   234,     0,     0,
       0,     0,     0,     0,     0,   235,   236,     0,   237,   238,
       0,   239,   240,   241,   242,   243,     0,   244,   245,     0,
     246,   247,   248,   249,   250,     0,     0,   251,   252,   253,
     254,   255,     0,   256,   257,   258,   259,   260,     0,     0,
       0,   261,   262,   263,   264,     0,   265,   266,   267,     0,
     268,   269,   270,   271,   272,   273,     0,     0,   274,   275,
     276,     0,     0,     0,     0,     0,     0,     0,   277,   278,
     279,   280,   281,   282,   283,   284,   285,     0,   286,     0,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
       0,     0,   296,   297,   298,   299,   300,     0,   301,   302,
     303,     0,   304,   305,   306,     0,   307,   308,   309,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,   318,
     319,   320,     0,   321,     0,   322,     0,     0,     0,   323,
     324,   325,     0,   326,   327,     0,   328,   329,     0,   330,
     331,   332,   333,  1540,     0,   335,   336,   337,   338,     0,
     339,   340,   341,   342,   343,   344,     0,   345,     0,   346,
     347,   348,   349,   350,   351,   352,     0,   353,     0,   354,
       0,     0,   355,     0,   356,   357,   358,   359,   360,     0,
       0,   361,   362,     0,   363,     0,     0,   364,   365,   366,
       0,     0,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,     0,
     384,   385,   386,   387,     0,   388,   389,     0,   390,     0,
     391,   392,   393,   394,   395,   396,     0,   397,     0,     0,
     398,   399,   400,     0,     0,   401,   402,     0,   403,     0,
     404,   405,   406,   407,   408,   409,   410,   411,   412,     0,
     413,   414,   415,   416,   417,   418,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,     0,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,     0,   445,   446,     0,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
       0,   459,   460,   461,   462,   463,     0,   464,   465,   466,
     467,   468,     0,   469,   470,   471,   472,     0,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
       0,   485,   486,     0,   487,     0,   488,   489,   490,   491,
     492,     0,   493,   494,     0,     0,   495,   496,   497,   498,
     499,     0,   500,   501,   502,   503,   504,   505,   506,     0,
       0,   507,   508,   509,   510,   511,     0,     0,   512,   513,
     514,   515,   516,   517,   518,     0,   519,     0,   520,   521,
     522,   523,     0,     0,   524,     0,     0,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   222,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     223,   224,   225,   226,   227,   228,   229,   230,     0,   232,
     233,   234,     0,     0,     0,     0,     0,     0,     0,   235,
     236,     0,   237,   238,     0,   239,   240,   241,   242,   243,
       0,   244,   245,     0,   246,   247,   248,   249,   250,     0,
       0,   251,   252,   253,   254,   255,     0,   256,   257,   258,
     259,   260,     0,     0,     0,   261,   262,   263,   264,     0,
     265,   266,   267,     0,   268,   269,   270,   271,   272,   273,
       0,     0,   274,   275,   276,     0,     0,     0,     0,     0,
       0,     0,   277,   278,   279,   280,   281,   282,   283,   284,
     285,     0,   286,     0,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,     0,     0,   296,   297,   298,   299,
     300,     0,   301,   302,   303,     0,   304,   305,   306,     0,
     307,   308,   309,   310,   311,   312,   313,   314,   315,     0,
     316,     0,   317,   318,   319,   320,     0,   321,     0,   322,
       0,     0,     0,   323,   324,   325,     0,   326,   327,     0,
     328,   329,     0,   330,   331,   332,   333,  1570,     0,   335,
     336,   337,   338,     0,   339,   340,   341,   342,   343,   344,
       0,   345,     0,   346,   347,   348,   349,   350,   351,   352,
       0,   353,     0,   354,     0,     0,   355,     0,   356,   357,
     358,   359,   360,     0,     0,   361,   362,     0,   363,     0,
       0,   364,   365,   366,     0,     0,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,     0,   384,   385,   386,   387,     0,   388,
     389,     0,   390,     0,   391,   392,   393,   394,   395,   396,
       0,   397,     0,     0,   398,   399,   400,     0,     0,   401,
     402,     0,   403,     0,   404,   405,   406,   407,   408,   409,
     410,   411,   412,     0,   413,   414,   415,   416,   417,   418,
     419,   420,     0,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,     0,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,     0,   445,
     446,     0,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,   462,   463,
       0,   464,   465,   466,   467,   468,     0,   469,   470,   471,
     472,     0,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,     0,   485,   486,     0,   487,     0,
     488,   489,   490,   491,   492,     0,   493,   494,     0,     0,
     495,   496,   497,   498,   499,     0,   500,   501,   502,   503,
     504,   505,   506,     0,     0,   507,   508,   509,   510,   511,
       0,     0,   512,   513,   514,   515,   516,   517,   518,     0,
     519,     0,   520,   521,   522,   523,     0,     0,   524,     0,
       0,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   222,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   223,   224,   225,   226,   227,   228,
     229,   230,     0,   232,   233,   234,     0,     0,     0,     0,
       0,     0,     0,   235,   236,     0,   237,   238,     0,   239,
     240,   241,   242,   243,     0,   244,   245,     0,   246,   247,
     248,   249,   250,     0,     0,   251,   252,   253,   254,   255,
       0,   256,   257,   258,   259,   260,     0,     0,     0,   261,
     262,   263,   264,     0,   265,   266,   267,     0,   268,   269,
     270,   271,   272,   273,     0,     0,   274,   275,   276,     0,
       0,     0,     0,     0,     0,     0,   277,   278,   279,   280,
     281,   282,   283,   284,   285,     0,   286,     0,   287,   288,
     289,   290,   291,   292,     0,   293,   294,   295,     0,     0,
     296,   297,   298,   299,   300,     0,   301,   302,   303,     0,
     304,   305,   306,     0,   307,   308,   309,   310,   311,   312,
     313,   314,   315,     0,   316,     0,   317,   318,   319,   320,
       0,   321,     0,   322,     0,     0,     0,   323,   324,   325,
       0,   326,   327,     0,   328,   329,     0,   330,   331,   332,
     333,  1572,     0,   335,   336,   337,   338,     0,   339,   340,
     341,   342,   343,   344,     0,   345,     0,   346,   347,   348,
     349,   350,   351,   352,     0,   353,     0,   354,     0,     0,
     355,     0,   356,   357,   358,   359,   360,     0,     0,   361,
     362,     0,   363,     0,     0,   364,   365,   366,     0,     0,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,     0,   384,   385,
     386,   387,     0,   388,   389,     0,   390,     0,   391,   392,
     393,   394,   395,   396,     0,   397,     0,     0,   398,   399,
     400,     0,     0,   401,   402,     0,   403,     0,   404,   405,
     406,   407,   408,   409,   410,   411,   412,     0,   413,   414,
     415,   416,   417,   418,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
       0,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,     0,   445,   446,     0,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,     0,   459,
     460,   461,   462,   463,     0,   464,   465,   466,   467,   468,
       0,   469,   470,   471,   472,     0,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,     0,   485,
     486,     0,   487,     0,   488,   489,   490,   491,   492,     0,
     493,   494,     0,     0,   495,   496,   497,   498,   499,     0,
     500,   501,   502,   503,   504,   505,   506,     0,     0,   507,
     508,   509,   510,   511,     0,     0,   512,   513,   514,   515,
     516,   517,   518,     0,   519,     0,   520,   521,   522,   523,
       0,     0,   524,     0,     0,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   222,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   223,   224,
     225,   226,   227,   228,   229,   230,     0,   232,   233,   234,
       0,     0,     0,     0,     0,     0,     0,   235,   236,     0,
     237,   238,     0,   239,   240,   241,   242,   243,     0,   244,
     245,     0,   246,   247,   248,   249,   250,     0,     0,   251,
     252,   253,   254,   255,     0,   256,   257,   258,   259,   260,
       0,     0,     0,   261,   262,   263,   264,     0,   265,   266,
     267,     0,   268,   269,   270,   271,   272,   273,     0,     0,
     274,   275,   276,     0,     0,     0,     0,     0,     0,     0,
     277,   278,   279,   280,   281,   282,   283,   284,   285,     0,
     286,     0,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,     0,     0,   296,   297,   298,   299,   300,     0,
     301,   302,   303,     0,   304,   305,   306,     0,   307,   308,
     309,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,   318,   319,   320,     0,   321,     0,   322,     0,     0,
       0,   323,   324,   325,     0,   326,   327,     0,   328,   329,
       0,   330,   331,   332,   333,  1642,     0,   335,   336,   337,
     338,     0,   339,   340,   341,   342,   343,   344,     0,   345,
       0,   346,   347,   348,   349,   350,   351,   352,     0,   353,
       0,   354,     0,     0,   355,     0,   356,   357,   358,   359,
     360,     0,     0,   361,   362,     0,   363,     0,     0,   364,
     365,   366,     0,     0,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,     0,   384,   385,   386,   387,     0,   388,   389,     0,
     390,     0,   391,   392,   393,   394,   395,   396,     0,   397,
       0,     0,   398,   399,   400,     0,     0,   401,   402,     0,
     403,     0,   404,   405,   406,   407,   408,   409,   410,   411,
     412,     0,   413,   414,   415,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,     0,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,     0,   445,   446,     0,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,     0,   459,   460,   461,   462,   463,     0,   464,
     465,   466,   467,   468,     0,   469,   470,   471,   472,     0,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,     0,   485,   486,     0,   487,     0,   488,   489,
     490,   491,   492,     0,   493,   494,     0,     0,   495,   496,
     497,   498,   499,     0,   500,   501,   502,   503,   504,   505,
     506,     0,     0,   507,   508,   509,   510,   511,     0,     0,
     512,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     520,   521,   522,   523,     0,     0,   524,     0,     0,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   222,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   223,   224,   225,   226,   227,   228,   229,   230,
       0,   232,   233,   234,     0,     0,     0,     0,     0,     0,
       0,   235,   236,     0,   237,   238,     0,   239,   240,   241,
     242,   243,     0,   244,   245,     0,   246,   247,   248,   249,
     250,     0,     0,   251,   252,   253,   254,   255,     0,   256,
     257,   258,   259,   260,     0,     0,     0,   261,   262,   263,
     264,     0,   265,   266,   267,     0,   268,   269,   270,   271,
     272,   273,     0,     0,   274,   275,   276,     0,     0,     0,
       0,     0,     0,     0,   277,   278,   279,   280,   281,   282,
     283,   284,   285,     0,   286,     0,   287,   288,   289,   290,
     291,   292,     0,   293,   294,   295,     0,     0,   296,   297,
     298,   299,   300,     0,   301,   302,   303,     0,   304,   305,
     306,     0,   307,   308,   309,   310,   311,   312,   313,   314,
     315,     0,   316,     0,   317,   318,   319,   320,     0,   321,
       0,   322,     0,     0,     0,   323,   324,   325,     0,   326,
     327,     0,   328,   329,     0,   330,   331,   332,   333,  1644,
       0,   335,   336,   337,   338,     0,   339,   340,   341,   342,
     343,   344,     0,   345,     0,   346,   347,   348,   349,   350,
     351,   352,     0,   353,     0,   354,     0,     0,   355,     0,
     356,   357,   358,   359,   360,     0,     0,   361,   362,     0,
     363,     0,     0,   364,   365,   366,     0,     0,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,     0,   384,   385,   386,   387,
       0,   388,   389,     0,   390,     0,   391,   392,   393,   394,
     395,   396,     0,   397,     0,     0,   398,   399,   400,     0,
       0,   401,   402,     0,   403,     0,   404,   405,   406,   407,
     408,   409,   410,   411,   412,     0,   413,   414,   415,   416,
     417,   418,   419,   420,     0,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,     0,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
       0,   445,   446,     0,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,     0,   459,   460,   461,
     462,   463,     0,   464,   465,   466,   467,   468,     0,   469,
     470,   471,   472,     0,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,     0,   485,   486,     0,
     487,     0,   488,   489,   490,   491,   492,     0,   493,   494,
       0,     0,   495,   496,   497,   498,   499,     0,   500,   501,
     502,   503,   504,   505,   506,     0,     0,   507,   508,   509,
     510,   511,     0,     0,   512,   513,   514,   515,   516,   517,
     518,     0,   519,     0,   520,   521,   522,   523,     0,     0,
     524,     0,     0,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   222,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   223,   224,   225,   226,
     227,   228,   229,   230,     0,   232,   233,   234,     0,     0,
       0,     0,     0,     0,     0,   235,   236,     0,   237,   238,
       0,   239,   240,   241,   242,   243,     0,   244,   245,     0,
     246,   247,   248,   249,   250,     0,     0,   251,   252,   253,
     254,   255,     0,   256,   257,   258,   259,   260,     0,     0,
       0,   261,   262,   263,   264,     0,   265,   266,   267,     0,
     268,   269,   270,   271,   272,   273,     0,     0,   274,   275,
     276,     0,     0,     0,     0,     0,     0,     0,   277,   278,
     279,   280,   281,   282,   283,   284,   285,     0,   286,     0,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
       0,     0,   296,   297,   298,   299,   300,     0,   301,   302,
     303,     0,   304,   305,   306,     0,   307,   308,   309,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,   318,
     319,   320,     0,   321,     0,   322,     0,     0,     0,   323,
     324,   325,     0,   326,   327,     0,   328,   329,     0,   330,
     331,   332,   333,  1646,     0,   335,   336,   337,   338,     0,
     339,   340,   341,   342,   343,   344,     0,   345,     0,   346,
     347,   348,   349,   350,   351,   352,     0,   353,     0,   354,
       0,     0,   355,     0,   356,   357,   358,   359,   360,     0,
       0,   361,   362,     0,   363,     0,     0,   364,   365,   366,
       0,     0,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,     0,
     384,   385,   386,   387,     0,   388,   389,     0,   390,     0,
     391,   392,   393,   394,   395,   396,     0,   397,     0,     0,
     398,   399,   400,     0,     0,   401,   402,     0,   403,     0,
     404,   405,   406,   407,   408,   409,   410,   411,   412,     0,
     413,   414,   415,   416,   417,   418,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,     0,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,     0,   445,   446,     0,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
       0,   459,   460,   461,   462,   463,     0,   464,   465,   466,
     467,   468,     0,   469,   470,   471,   472,     0,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
       0,   485,   486,     0,   487,     0,   488,   489,   490,   491,
     492,     0,   493,   494,     0,     0,   495,   496,   497,   498,
     499,     0,   500,   501,   502,   503,   504,   505,   506,     0,
       0,   507,   508,   509,   510,   511,     0,     0,   512,   513,
     514,   515,   516,   517,   518,     0,   519,     0,   520,   521,
     522,   523,     0,     0,   524,     0,     0,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   222,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     223,   224,   225,   226,   227,   228,   229,   230,     0,   232,
     233,   234,     0,     0,     0,     0,     0,     0,     0,   235,
     236,     0,   237,   238,     0,   239,   240,   241,   242,   243,
       0,   244,   245,     0,   246,   247,   248,   249,   250,     0,
       0,   251,   252,   253,   254,   255,     0,   256,   257,   258,
     259,   260,     0,     0,     0,   261,   262,   263,   264,     0,
     265,   266,   267,     0,   268,   269,   270,   271,   272,   273,
       0,     0,   274,   275,   276,     0,     0,     0,     0,     0,
       0,     0,   277,   278,   279,   280,   281,   282,   283,   284,
     285,     0,   286,     0,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,     0,     0,   296,   297,   298,   299,
     300,     0,   301,   302,   303,     0,   304,   305,   306,     0,
     307,   308,   309,   310,   311,   312,   313,   314,   315,     0,
     316,     0,   317,   318,   319,   320,     0,   321,     0,   322,
       0,     0,     0,   323,   324,   325,     0,   326,   327,     0,
     328,   329,     0,   330,   331,   332,   333,   334,     0,   335,
     336,   337,   338,     0,   339,   340,   341,   342,   343,   344,
       0,   345,     0,   346,   347,   348,   349,   350,   351,   352,
       0,   353,     0,   354,     0,     0,   355,     0,   356,   357,
     358,   359,   360,     0,     0,   361,   362,     0,   363,     0,
       0,   364,   365,   366,     0,     0,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,     0,   384,   385,   386,   387,     0,   388,
     389,     0,   390,     0,   391,   392,   393,   394,   395,   396,
       0,   397,     0,     0,   398,   399,   400,     0,     0,   401,
     402,     0,   403,     0,   404,   405,   406,   407,   408,   409,
     410,   411,   412,     0,   413,   414,   415,   416,   417,   418,
     419,   420,     0,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,     0,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,     0,   445,
     446,     0,   447,   448,   449,   450,   451,   452,  1742,   454,
     455,   456,   457,   458,     0,   459,   460,   461,   462,   463,
       0,   464,   465,   466,   467,   468,     0,   469,   470,   471,
     472,     0,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,     0,   485,   486,     0,   487,     0,
     488,   489,   490,   491,   492,     0,   493,   494,     0,     0,
     495,   496,   497,   498,   499,     0,   500,   501,   502,   503,
     504,   505,   506,     0,     0,   507,   508,   509,   510,   511,
       0,     0,   512,   513,   514,   515,   516,   517,   518,     0,
     519,     0,   520,   521,   522,   523,     0,     0,   524,     0,
       0,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   222,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   223,   224,   225,   226,   227,   228,
     229,   230,     0,   232,   233,   234,     0,     0,     0,     0,
       0,  2003,     0,   235,   236,     0,   237,   238,     0,   239,
     240,   241,   242,   243,     0,   244,   245,     0,   246,   247,
     248,   249,   250,     0,     0,   251,   252,   253,   254,   255,
       0,   256,   257,   258,   259,   260,     0,     0,     0,   261,
     262,   263,   264,     0,   265,   266,   267,     0,   268,   269,
     270,   271,   272,   273,     0,     0,   274,   275,   276,     0,
       0,     0,     0,     0,     0,     0,   277,   278,   279,   280,
     281,   282,   283,   284,   285,     0,   286,     0,   287,   288,
     289,   290,   291,   292,     0,   293,   294,   295,     0,     0,
     296,   297,   298,   299,   300,     0,   301,   302,   303,     0,
     304,   305,   306,     0,   307,   308,   309,   310,   311,   312,
     313,   314,   315,     0,   316,     0,   317,   318,   319,   320,
       0,   321,     0,   322,     0,     0,     0,   323,   324,   325,
       0,   326,   327,     0,   328,   329,     0,   330,   331,   332,
     333,   334,     0,   335,   336,   337,   338,     0,   339,   340,
     341,   342,   343,   344,     0,   345,     0,   346,   347,   348,
     349,   350,   351,   352,     0,   353,     0,   354,     0,     0,
     355,     0,   356,   357,   358,   359,   360,     0,     0,   361,
     362,     0,   363,     0,     0,   364,   365,   366,     0,     0,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,     0,   384,   385,
     386,   387,     0,   388,   389,     0,   390,     0,   391,   392,
     393,   394,   395,   396,     0,   397,     0,     0,   398,   399,
     400,     0,     0,   401,   402,     0,   403,     0,   404,   405,
     406,   407,   408,   409,   410,   411,   412,     0,   413,   414,
     415,   416,   417,   418,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
       0,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,     0,   445,   446,     0,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,     0,   459,
     460,   461,   462,   463,     0,     0,   465,   466,   467,   468,
       0,   469,   470,   471,   472,     0,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,     0,   485,
     486,     0,   487,     0,   488,   489,   490,   491,   492,     0,
     493,   494,     0,     0,   495,   496,   497,   498,   499,     0,
     500,   501,   502,   503,   504,   505,   506,     0,     0,   507,
     508,   509,   510,   511,     0,     0,   512,   513,   514,   515,
     516,   517,   518,     0,   519,     0,   520,   521,   522,   523,
       0,     0,   524,     0,     0,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   222,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   223,   224,
     225,   226,   227,   228,   229,   230,     0,   232,   233,   234,
       0,     0,     0,     0,     0,     0,     0,   235,   236,     0,
     237,   238,     0,   239,   240,   241,   242,   243,     0,   244,
     245,     0,   246,   247,   248,   249,   250,     0,     0,   723,
     252,   253,   254,   255,     0,   256,   257,   258,   259,   260,
       0,     0,     0,   261,   262,   263,   264,     0,   265,   266,
     267,     0,   268,   269,   270,   271,   272,   273,     0,     0,
     274,   275,   276,     0,     0,     0,     0,     0,     0,     0,
     277,   278,   279,   280,   281,   282,   283,   284,   285,     0,
     286,     0,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,     0,     0,   296,   297,   298,   299,   300,     0,
     301,   302,   303,     0,   304,   305,   306,     0,   307,   308,
     309,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,   318,   319,   320,     0,   321,     0,   322,     0,     0,
       0,   323,   324,   325,     0,   326,   327,     0,   328,   329,
       0,   330,   331,   332,   333,   334,     0,   335,   336,   337,
     338,     0,   339,   340,   341,   342,   343,   344,     0,   345,
       0,   346,   347,   348,   349,   350,   351,   352,     0,   353,
       0,   354,     0,     0,   355,     0,   356,   357,   358,   359,
     360,     0,     0,   361,   362,     0,   363,     0,     0,   364,
     365,   366,     0,     0,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   726,
     383,     0,   384,   385,   386,   387,     0,   388,   389,     0,
     390,     0,   391,   392,   393,   394,   395,   396,     0,   397,
       0,     0,   398,   399,   400,     0,     0,   401,   402,     0,
     403,     0,   404,   405,   406,   407,   408,   409,   410,   411,
     412,     0,   413,   414,   415,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,     0,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,     0,   445,   446,     0,
     727,   448,   449,   450,   451,   452,   453,   728,   455,   456,
     457,   458,     0,   459,   460,   461,   462,  1244,     0,   464,
     465,   466,   467,   468,     0,   469,   470,   471,   472,     0,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,     0,   485,   486,     0,   487,     0,  2035,   489,
     490,   491,   492,     0,   730,   494,     0,     0,   731,   496,
     497,   498,   499,     0,   500,   501,   502,   503,   504,   505,
     506,     0,     0,   507,   508,   509,   510,   511,     0,     0,
     512,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     520,   521,   522,   523,     0,     0,   524,     0,     0,   525,
     526,   527,   528,   529,   732,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   222,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   223,   224,   225,   226,   227,   228,   229,   230,
       0,   232,   233,   234,     0,     0,     0,     0,     0,     0,
       0,   235,   236,     0,   237,   238,     0,   239,   240,   241,
     242,   243,     0,   244,   245,     0,   246,   247,   248,   249,
     250,     0,     0,   723,   252,   253,   254,   255,     0,   256,
     257,   258,   259,   260,     0,     0,     0,   261,   262,   263,
     264,     0,   265,   266,   267,     0,   268,   269,   270,   271,
     272,   273,     0,     0,   274,   275,   276,     0,     0,     0,
       0,     0,     0,     0,   277,   278,   279,   280,   281,   282,
     283,   284,   285,     0,   286,     0,   287,   288,   289,   290,
     291,   292,     0,   293,   294,   295,     0,     0,   296,   297,
     298,   299,   300,     0,   301,   302,   303,     0,   304,   305,
     306,     0,   307,   308,   309,   310,   311,   312,   313,   314,
     315,     0,   316,     0,   317,   318,   319,   320,     0,   321,
       0,   322,     0,     0,     0,   323,   324,   325,     0,   326,
     327,     0,   328,   329,     0,   330,   331,   332,   333,   334,
       0,   335,   336,   337,   338,     0,   339,   340,   341,   342,
     343,   344,     0,   345,     0,   346,   347,   348,   349,   350,
     351,   352,     0,   353,     0,   354,     0,     0,   355,     0,
     356,   357,   358,   359,   360,     0,     0,   361,   362,     0,
     363,     0,     0,   364,   365,   366,     0,     0,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   726,   383,     0,   384,   385,   386,   387,
       0,   388,   389,     0,   390,     0,   391,   392,   393,   394,
     395,   396,     0,   397,     0,     0,   398,   399,   400,     0,
       0,   401,   402,     0,   403,     0,   404,   405,   406,   407,
     408,   409,   410,   411,   412,     0,   413,   414,   415,   416,
     417,   418,   419,   420,     0,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,     0,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
       0,   445,   446,     0,   727,   448,   449,   450,   451,   452,
     453,  2110,   455,   456,   457,   458,     0,   459,   460,   461,
     462,  2111,     0,   464,   465,   466,   467,   468,     0,   469,
     470,   471,   472,     0,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,     0,   485,   486,     0,
     487,     0,   488,   489,   490,   491,   492,     0,   730,   494,
       0,     0,  2112,   496,   497,   498,   499,     0,   500,   501,
     502,   503,   504,   505,   506,     0,     0,   507,   508,   509,
     510,   511,     0,     0,   512,   513,   514,   515,   516,   517,
     518,     0,   519,     0,   520,   521,   522,   523,     0,     0,
     524,     0,     0,   525,   526,   527,   528,   529,   732,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   222,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   223,   224,   225,   226,
     227,   228,   229,   230,     0,   232,   233,   234,     0,     0,
       0,     0,     0,     0,     0,   235,   236,     0,   237,   238,
       0,   239,   240,   241,   242,   243,     0,   244,   245,     0,
     246,   247,   248,   249,   250,     0,     0,   251,   252,   253,
     254,   255,     0,   256,   257,   258,   259,   260,     0,     0,
       0,   261,   262,   263,   264,     0,   265,   266,   267,     0,
     268,   269,   270,   271,   272,   273,     0,     0,   274,   275,
     276,     0,     0,     0,     0,     0,     0,     0,   277,   278,
     279,   280,   281,   282,   283,   284,   285,     0,   286,     0,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
       0,     0,   296,   297,   298,   299,   300,     0,   301,   302,
     303,     0,   304,   305,   306,     0,   307,   308,   309,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,   318,
     319,   320,     0,   321,     0,   322,     0,     0,     0,   323,
     324,   325,     0,   326,   327,     0,   328,   329,     0,   330,
     331,   332,   333,  2348,     0,   335,   336,   337,   338,     0,
     339,   340,   341,   342,   343,   344,     0,   345,     0,   346,
     347,   348,   349,   350,   351,   352,     0,   353,     0,   354,
       0,     0,   355,     0,   356,   357,   358,   359,   360,     0,
       0,   361,   362,     0,   363,     0,     0,   364,   365,   366,
       0,     0,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,     0,
     384,   385,   386,   387,     0,   388,   389,     0,   390,     0,
     391,   392,   393,   394,   395,   396,     0,   397,     0,     0,
     398,   399,   400,     0,     0,   401,   402,     0,   403,     0,
     404,   405,   406,   407,   408,   409,   410,   411,   412,     0,
     413,   414,   415,   416,   417,   418,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,     0,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,     0,   445,   446,     0,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
       0,   459,   460,   461,   462,   463,     0,   464,   465,   466,
     467,   468,     0,   469,   470,   471,   472,     0,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
       0,   485,   486,     0,   487,     0,   488,   489,   490,   491,
     492,     0,   493,   494,     0,     0,   495,   496,   497,   498,
     499,     0,   500,   501,   502,   503,   504,   505,   506,     0,
       0,   507,   508,   509,   510,   511,     0,     0,   512,   513,
     514,   515,   516,   517,   518,     0,   519,     0,   520,   521,
     522,   523,     0,     0,   524,     0,     0,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   222,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     223,   224,   225,   226,   227,   228,   229,   230,     0,   232,
     233,   234,     0,     0,     0,     0,     0,     0,     0,   235,
     236,     0,   237,   238,     0,   239,   240,   241,   242,   243,
       0,   244,   245,     0,   246,   247,   248,   249,   250,     0,
       0,   251,   252,   253,   254,   255,     0,   256,   257,   258,
     259,   260,     0,     0,     0,   261,   262,   263,   264,     0,
     265,   266,   267,     0,   268,   269,   270,   271,   272,   273,
       0,     0,   274,   275,   276,     0,     0,     0,     0,     0,
       0,     0,   277,   278,   279,   280,   281,   282,   283,   284,
     285,     0,   286,     0,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,     0,     0,   296,   297,   298,   299,
     300,     0,   301,   302,   303,     0,   304,   305,   306,     0,
     307,   308,   309,   310,   311,   312,   313,   314,   315,     0,
     316,     0,   317,   318,   319,   320,     0,   321,     0,   322,
       0,     0,     0,   323,   324,   325,     0,   326,   327,     0,
     328,   329,     0,   330,   331,   332,   333,  2352,     0,   335,
     336,   337,   338,     0,   339,   340,   341,   342,   343,   344,
       0,   345,     0,   346,   347,   348,   349,   350,   351,   352,
       0,   353,     0,   354,     0,     0,   355,     0,   356,   357,
     358,   359,   360,     0,     0,   361,   362,     0,   363,     0,
       0,   364,   365,   366,     0,     0,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,     0,   384,   385,   386,   387,     0,   388,
     389,     0,   390,     0,   391,   392,   393,   394,   395,   396,
       0,   397,     0,     0,   398,   399,   400,     0,     0,   401,
     402,     0,   403,     0,   404,   405,   406,   407,   408,   409,
     410,   411,   412,     0,   413,   414,   415,   416,   417,   418,
     419,   420,     0,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,     0,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,     0,   445,
     446,     0,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,   462,   463,
       0,   464,   465,   466,   467,   468,     0,   469,   470,   471,
     472,     0,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,     0,   485,   486,     0,   487,     0,
     488,   489,   490,   491,   492,     0,   493,   494,     0,     0,
     495,   496,   497,   498,   499,     0,   500,   501,   502,   503,
     504,   505,   506,     0,     0,   507,   508,   509,   510,   511,
       0,     0,   512,   513,   514,   515,   516,   517,   518,     0,
     519,     0,   520,   521,   522,   523,     0,     0,   524,     0,
       0,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   222,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   223,   224,   225,   226,   227,   228,
     229,   230,     0,   232,   233,   234,     0,     0,     0,     0,
       0,     0,     0,   235,   236,     0,   237,   238,     0,   239,
     240,   241,   242,   243,     0,   244,   245,     0,   246,   247,
     248,   249,   250,     0,     0,   251,   252,   253,   254,   255,
       0,   256,   257,   258,   259,   260,     0,     0,     0,   261,
     262,   263,   264,     0,   265,   266,   267,     0,   268,   269,
     270,   271,   272,   273,     0,     0,   274,   275,   276,     0,
       0,     0,     0,     0,     0,     0,   277,   278,   279,   280,
     281,   282,   283,   284,   285,     0,   286,     0,   287,   288,
     289,   290,   291,   292,     0,   293,   294,   295,     0,     0,
     296,   297,   298,   299,   300,     0,   301,   302,   303,     0,
     304,   305,   306,     0,   307,   308,   309,   310,   311,   312,
     313,   314,   315,     0,   316,     0,   317,   318,   319,   320,
       0,   321,     0,   322,     0,     0,     0,   323,   324,   325,
       0,   326,   327,     0,   328,   329,     0,   330,   331,   332,
     333,  2392,     0,   335,   336,   337,   338,     0,   339,   340,
     341,   342,   343,   344,     0,   345,     0,   346,   347,   348,
     349,   350,   351,   352,     0,   353,     0,   354,     0,     0,
     355,     0,   356,   357,   358,   359,   360,     0,     0,   361,
     362,     0,   363,     0,     0,   364,   365,   366,     0,     0,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,     0,   384,   385,
     386,   387,     0,   388,   389,     0,   390,     0,   391,   392,
     393,   394,   395,   396,     0,   397,     0,     0,   398,   399,
     400,     0,     0,   401,   402,     0,   403,     0,   404,   405,
     406,   407,   408,   409,   410,   411,   412,     0,   413,   414,
     415,   416,   417,   418,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
       0,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,     0,   445,   446,     0,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,     0,   459,
     460,   461,   462,   463,     0,   464,   465,   466,   467,   468,
       0,   469,   470,   471,   472,     0,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,     0,   485,
     486,     0,   487,     0,   488,   489,   490,   491,   492,     0,
     493,   494,     0,     0,   495,   496,   497,   498,   499,     0,
     500,   501,   502,   503,   504,   505,   506,     0,     0,   507,
     508,   509,   510,   511,     0,     0,   512,   513,   514,   515,
     516,   517,   518,     0,   519,     0,   520,   521,   522,   523,
       0,     0,   524,     0,     0,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   222,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   223,   224,
     225,   226,   227,   228,   229,   230,     0,   232,   233,   234,
       0,     0,     0,     0,     0,     0,     0,   235,   236,     0,
     237,   238,     0,   239,   240,   241,   242,   243,     0,   244,
     245,     0,   246,   247,   248,   249,   250,     0,     0,   251,
     252,   253,   254,   255,     0,   256,   257,   258,   259,   260,
       0,     0,     0,   261,   262,   263,   264,     0,   265,   266,
     267,     0,   268,   269,   270,   271,   272,   273,     0,     0,
     274,   275,   276,     0,     0,     0,     0,     0,     0,     0,
     277,   278,   279,   280,   281,   282,   283,   284,   285,     0,
     286,     0,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,     0,     0,   296,   297,   298,   299,   300,     0,
     301,   302,   303,     0,   304,   305,   306,     0,   307,   308,
     309,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,   318,   319,   320,     0,   321,     0,   322,     0,     0,
       0,   323,   324,   325,     0,   326,   327,     0,   328,   329,
       0,   330,   331,   332,   333,  2427,     0,   335,   336,   337,
     338,     0,   339,   340,   341,   342,   343,   344,     0,   345,
       0,   346,   347,   348,   349,   350,   351,   352,     0,   353,
       0,   354,     0,     0,   355,     0,   356,   357,   358,   359,
     360,     0,     0,   361,   362,     0,   363,     0,     0,   364,
     365,   366,     0,     0,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,     0,   384,   385,   386,   387,     0,   388,   389,     0,
     390,     0,   391,   392,   393,   394,   395,   396,     0,   397,
       0,     0,   398,   399,   400,     0,     0,   401,   402,     0,
     403,     0,   404,   405,   406,   407,   408,   409,   410,   411,
     412,     0,   413,   414,   415,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,     0,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,     0,   445,   446,     0,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,     0,   459,   460,   461,   462,   463,     0,   464,
     465,   466,   467,   468,     0,   469,   470,   471,   472,     0,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,     0,   485,   486,     0,   487,     0,   488,   489,
     490,   491,   492,     0,   493,   494,     0,     0,   495,   496,
     497,   498,   499,     0,   500,   501,   502,   503,   504,   505,
     506,     0,     0,   507,   508,   509,   510,   511,     0,     0,
     512,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     520,   521,   522,   523,     0,     0,   524,     0,     0,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   222,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   223,   224,   225,   226,   227,   228,   229,   230,
       0,   232,   233,   234,     0,     0,     0,     0,     0,     0,
       0,   235,   236,     0,   237,   238,     0,   239,   240,   241,
     242,   243,     0,   244,   245,     0,   246,   247,   248,   249,
     250,     0,     0,   251,   252,   253,   254,   255,     0,   256,
     257,   258,   259,   260,     0,     0,     0,   261,   262,   263,
     264,     0,   265,   266,   267,     0,   268,   269,   270,   271,
     272,   273,     0,     0,   274,   275,   276,     0,     0,     0,
       0,     0,     0,     0,   277,   278,   279,   280,   281,   282,
     283,   284,   285,     0,   286,     0,   287,   288,   289,   290,
     291,   292,     0,   293,   294,   295,     0,     0,   296,   297,
     298,   299,   300,     0,   301,   302,   303,     0,   304,   305,
     306,     0,   307,   308,   309,   310,   311,   312,   313,   314,
     315,     0,   316,     0,   317,   318,   319,   320,     0,   321,
       0,   322,     0,     0,     0,   323,   324,   325,     0,   326,
     327,     0,   328,   329,     0,   330,   331,   332,   333,  2746,
       0,   335,   336,   337,   338,     0,   339,   340,   341,   342,
     343,   344,     0,   345,     0,   346,   347,   348,   349,   350,
     351,   352,     0,   353,     0,   354,     0,     0,   355,     0,
     356,   357,   358,   359,   360,     0,     0,   361,   362,     0,
     363,     0,     0,   364,   365,   366,     0,     0,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,     0,   384,   385,   386,   387,
       0,   388,   389,     0,   390,     0,   391,   392,   393,   394,
     395,   396,     0,   397,     0,     0,   398,   399,   400,     0,
       0,   401,   402,     0,   403,     0,   404,   405,   406,   407,
     408,   409,   410,   411,   412,     0,   413,   414,   415,   416,
     417,   418,   419,   420,     0,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,     0,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
       0,   445,   446,     0,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,     0,   459,   460,   461,
     462,   463,     0,   464,   465,   466,   467,   468,     0,   469,
     470,   471,   472,     0,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,     0,   485,   486,     0,
     487,     0,   488,   489,   490,   491,   492,     0,   493,   494,
       0,     0,   495,   496,   497,   498,   499,     0,   500,   501,
     502,   503,   504,   505,   506,     0,     0,   507,   508,   509,
     510,   511,     0,     0,   512,   513,   514,   515,   516,   517,
     518,     0,   519,     0,   520,   521,   522,   523,     0,     0,
     524,     0,     0,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   222,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   223,   224,   225,   226,
     227,   228,   229,   230,     0,   232,   233,   234,     0,     0,
       0,     0,     0,     0,     0,   235,   236,     0,   237,   238,
       0,   239,   240,   241,   242,   243,     0,   244,   245,     0,
     246,   247,   248,   249,   250,     0,     0,   723,   252,   253,
     254,   255,     0,   256,   257,   258,   259,   260,     0,     0,
       0,   261,   262,   263,   264,     0,   265,   266,   267,     0,
     268,   269,   270,   271,   272,   273,     0,     0,   274,   275,
     276,     0,     0,     0,     0,     0,     0,     0,   277,   278,
     279,   280,   281,   282,   283,   284,   285,     0,   286,     0,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
       0,     0,   296,   297,   298,   299,   300,     0,   301,   302,
     303,     0,   304,   305,   306,     0,   307,   308,   309,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,   318,
     319,   320,     0,   321,     0,   322,     0,     0,     0,   323,
     324,   325,     0,   326,   327,     0,   328,   329,     0,   330,
     331,   332,   333,   334,     0,   335,   336,   337,   338,     0,
     339,   340,   341,   342,   343,   344,     0,   345,     0,   346,
     347,   348,   349,   350,   351,   352,     0,   353,     0,   354,
       0,     0,   355,     0,   356,   357,   358,   359,   360,     0,
       0,   361,   362,     0,   363,     0,     0,   364,   365,   366,
       0,     0,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   726,   383,     0,
     384,   385,   386,   387,     0,   388,   389,     0,   390,     0,
     391,   392,   393,   394,   395,   396,     0,   397,     0,     0,
     398,   399,   400,     0,     0,   401,   402,     0,   403,     0,
     404,   405,   406,   407,   408,   409,   410,   411,   412,     0,
     413,   414,   415,   416,   417,   418,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,     0,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,     0,   445,   446,     0,   727,   448,
     449,   450,   451,   452,   453,   728,   455,   456,   457,   458,
       0,   459,   460,   461,   462,  2111,     0,   464,   465,   466,
     467,   468,     0,   469,   470,   471,   472,     0,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
       0,   485,   486,     0,   487,     0,   488,   489,   490,   491,
     492,     0,   730,   494,     0,     0,  2112,   496,   497,   498,
     499,     0,   500,   501,   502,   503,   504,   505,   506,     0,
       0,   507,   508,   509,   510,   511,     0,     0,   512,   513,
     514,   515,   516,   517,   518,     0,   519,     0,   520,   521,
     522,   523,     0,     0,   524,     0,     0,   525,   526,   527,
     528,   529,   732,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   222,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     223,   224,   225,   226,   227,   228,   229,   230,     0,   232,
     233,   234,     0,     0,     0,     0,     0,     0,     0,   235,
     236,     0,   237,   238,     0,   239,   240,   241,   242,   243,
       0,   244,   245,     0,   246,   247,   248,   249,   250,     0,
       0,   251,   252,   253,   254,   255,     0,   256,   257,   258,
     259,   260,     0,     0,     0,   261,   262,   263,   264,     0,
     265,   266,   267,     0,   268,   269,   270,   271,   272,   273,
       0,     0,   274,   275,   276,     0,     0,     0,     0,     0,
       0,     0,   277,   278,   279,   280,   281,   282,   283,   284,
     285,     0,   286,     0,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,     0,     0,   296,   297,   298,   299,
     300,     0,   301,   302,   303,     0,   304,   305,   306,     0,
     307,   308,   309,   310,   311,   312,   313,   314,   315,     0,
     316,     0,   317,   318,   319,   320,     0,   321,     0,   322,
       0,     0,     0,   323,   324,   325,     0,   326,   327,     0,
     328,   329,     0,   330,   331,   332,   333,  2813,     0,   335,
     336,   337,   338,     0,   339,   340,   341,   342,   343,   344,
       0,   345,     0,   346,   347,   348,   349,   350,   351,   352,
       0,   353,     0,   354,     0,     0,   355,     0,   356,   357,
     358,   359,   360,     0,     0,   361,   362,     0,   363,     0,
       0,   364,   365,   366,     0,     0,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,     0,   384,   385,   386,   387,     0,   388,
     389,     0,   390,     0,   391,   392,   393,   394,   395,   396,
       0,   397,     0,     0,   398,   399,   400,     0,     0,   401,
     402,     0,   403,     0,   404,   405,   406,   407,   408,   409,
     410,   411,   412,     0,   413,   414,   415,   416,   417,   418,
     419,   420,     0,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,     0,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,     0,   445,
     446,     0,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,   462,   463,
       0,   464,   465,   466,   467,   468,     0,   469,   470,   471,
     472,     0,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,     0,   485,   486,     0,   487,     0,
     488,   489,   490,   491,   492,     0,   493,   494,     0,     0,
     495,   496,   497,   498,   499,     0,   500,   501,   502,   503,
     504,   505,   506,     0,     0,   507,   508,   509,   510,   511,
       0,     0,   512,   513,   514,   515,   516,   517,   518,     0,
     519,     0,   520,   521,   522,   523,     0,     0,   524,     0,
       0,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   222,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   223,   224,   225,   226,   227,   228,
     229,   230,     0,   232,   233,   234,     0,     0,     0,     0,
       0,     0,     0,   235,   236,     0,   237,   238,     0,   239,
     240,   241,   242,   243,     0,   244,   245,     0,   246,   247,
     248,   249,   250,     0,     0,   251,   252,   253,   254,   255,
       0,   256,   257,   258,   259,   260,     0,     0,     0,   261,
     262,   263,   264,     0,   265,   266,   267,     0,   268,   269,
     270,   271,   272,   273,     0,     0,   274,   275,   276,     0,
       0,     0,     0,     0,     0,     0,   277,   278,   279,   280,
     281,   282,   283,   284,   285,     0,   286,     0,   287,   288,
     289,   290,   291,   292,     0,   293,   294,   295,     0,     0,
     296,   297,   298,   299,   300,     0,   301,   302,   303,     0,
     304,   305,   306,     0,   307,   308,   309,   310,   311,   312,
     313,   314,   315,     0,   316,     0,   317,   318,   319,   320,
       0,   321,     0,   322,     0,     0,     0,   323,   324,   325,
       0,   326,   327,     0,   328,   329,     0,   330,   331,   332,
     333,  2826,     0,   335,   336,   337,   338,     0,   339,   340,
     341,   342,   343,   344,     0,   345,     0,   346,   347,   348,
     349,   350,   351,   352,     0,   353,     0,   354,     0,     0,
     355,     0,   356,   357,   358,   359,   360,     0,     0,   361,
     362,     0,   363,     0,     0,   364,   365,   366,     0,     0,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,     0,   384,   385,
     386,   387,     0,   388,   389,     0,   390,     0,   391,   392,
     393,   394,   395,   396,     0,   397,     0,     0,   398,   399,
     400,     0,     0,   401,   402,     0,   403,     0,   404,   405,
     406,   407,   408,   409,   410,   411,   412,     0,   413,   414,
     415,   416,   417,   418,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
       0,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,     0,   445,   446,     0,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,     0,   459,
     460,   461,   462,   463,     0,   464,   465,   466,   467,   468,
       0,   469,   470,   471,   472,     0,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,     0,   485,
     486,     0,   487,     0,   488,   489,   490,   491,   492,     0,
     493,   494,     0,     0,   495,   496,   497,   498,   499,     0,
     500,   501,   502,   503,   504,   505,   506,     0,     0,   507,
     508,   509,   510,   511,     0,     0,   512,   513,   514,   515,
     516,   517,   518,     0,   519,     0,   520,   521,   522,   523,
       0,     0,   524,     0,     0,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   222,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   223,   224,
     225,   226,   227,   228,   229,   230,     0,   232,   233,   234,
       0,     0,     0,     0,     0,     0,     0,   235,   236,     0,
     237,   238,     0,   239,   240,   241,   242,   243,     0,   244,
     245,     0,   246,   247,   248,   249,   250,     0,     0,   251,
     252,   253,   254,   255,     0,   256,   257,   258,   259,   260,
       0,     0,     0,   261,   262,   263,   264,     0,   265,   266,
     267,     0,   268,   269,   270,   271,   272,   273,     0,     0,
     274,   275,   276,     0,     0,     0,     0,     0,     0,     0,
     277,   278,   279,   280,   281,   282,   283,   284,   285,     0,
     286,     0,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,     0,     0,   296,   297,   298,   299,   300,     0,
     301,   302,   303,     0,   304,   305,   306,     0,   307,   308,
     309,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,   318,   319,   320,     0,   321,     0,   322,     0,     0,
       0,   323,   324,   325,     0,   326,   327,     0,   328,   329,
       0,   330,   331,   332,   333,  2828,     0,   335,   336,   337,
     338,     0,   339,   340,   341,   342,   343,   344,     0,   345,
       0,   346,   347,   348,   349,   350,   351,   352,     0,   353,
       0,   354,     0,     0,   355,     0,   356,   357,   358,   359,
     360,     0,     0,   361,   362,     0,   363,     0,     0,   364,
     365,   366,     0,     0,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,     0,   384,   385,   386,   387,     0,   388,   389,     0,
     390,     0,   391,   392,   393,   394,   395,   396,     0,   397,
       0,     0,   398,   399,   400,     0,     0,   401,   402,     0,
     403,     0,   404,   405,   406,   407,   408,   409,   410,   411,
     412,     0,   413,   414,   415,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,     0,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,     0,   445,   446,     0,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,     0,   459,   460,   461,   462,   463,     0,   464,
     465,   466,   467,   468,     0,   469,   470,   471,   472,     0,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,     0,   485,   486,     0,   487,     0,   488,   489,
     490,   491,   492,     0,   493,   494,     0,     0,   495,   496,
     497,   498,   499,     0,   500,   501,   502,   503,   504,   505,
     506,     0,     0,   507,   508,   509,   510,   511,     0,     0,
     512,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     520,   521,   522,   523,     0,     0,   524,     0,     0,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   222,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   223,   224,   225,   226,   227,   228,   229,   230,
       0,   232,   233,   234,     0,     0,     0,     0,     0,     0,
       0,   235,   236,     0,   237,   238,     0,   239,   240,   241,
     242,   243,     0,   244,   245,     0,   246,   247,   248,   249,
     250,     0,     0,   251,   252,   253,   254,   255,     0,   256,
     257,   258,   259,   260,     0,     0,     0,   261,   262,   263,
     264,     0,   265,   266,   267,     0,   268,   269,   270,   271,
     272,   273,     0,     0,   274,   275,   276,     0,     0,     0,
       0,     0,     0,     0,   277,   278,   279,   280,   281,   282,
     283,   284,   285,     0,   286,     0,   287,   288,   289,   290,
     291,   292,     0,   293,   294,   295,     0,     0,   296,   297,
     298,   299,   300,     0,   301,   302,   303,     0,   304,   305,
     306,     0,   307,   308,   309,   310,   311,   312,   313,   314,
     315,     0,   316,     0,   317,   318,   319,   320,     0,   321,
       0,   322,     0,     0,     0,   323,   324,   325,     0,   326,
     327,     0,   328,   329,     0,   330,   331,   332,   333,  2943,
       0,   335,   336,   337,   338,     0,   339,   340,   341,   342,
     343,   344,     0,   345,     0,   346,   347,   348,   349,   350,
     351,   352,     0,   353,     0,   354,     0,     0,   355,     0,
     356,   357,   358,   359,   360,     0,     0,   361,   362,     0,
     363,     0,     0,   364,   365,   366,     0,     0,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,     0,   384,   385,   386,   387,
       0,   388,   389,     0,   390,     0,   391,   392,   393,   394,
     395,   396,     0,   397,     0,     0,   398,   399,   400,     0,
       0,   401,   402,     0,   403,     0,   404,   405,   406,   407,
     408,   409,   410,   411,   412,     0,   413,   414,   415,   416,
     417,   418,   419,   420,     0,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,     0,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
       0,   445,   446,     0,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,     0,   459,   460,   461,
     462,   463,     0,   464,   465,   466,   467,   468,     0,   469,
     470,   471,   472,     0,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,     0,   485,   486,     0,
     487,     0,   488,   489,   490,   491,   492,     0,   493,   494,
       0,     0,   495,   496,   497,   498,   499,     0,   500,   501,
     502,   503,   504,   505,   506,     0,     0,   507,   508,   509,
     510,   511,     0,     0,   512,   513,   514,   515,   516,   517,
     518,     0,   519,     0,   520,   521,   522,   523,     0,     0,
     524,     0,     0,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   222,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   223,   224,   225,   226,
     227,   228,   229,   230,     0,   232,   233,   234,     0,     0,
       0,     0,     0,     0,     0,   235,   236,     0,   237,   238,
       0,   239,   240,   241,   242,   243,     0,   244,   245,     0,
     246,   247,   248,   249,   250,     0,     0,   251,   252,   253,
     254,   255,     0,   256,   257,   258,   259,   260,     0,     0,
       0,   261,   262,   263,   264,     0,   265,   266,   267,     0,
     268,   269,   270,   271,   272,   273,     0,     0,   274,   275,
     276,     0,     0,     0,     0,     0,     0,     0,   277,   278,
     279,   280,   281,   282,   283,   284,   285,     0,   286,     0,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
       0,     0,   296,  2965,   298,   299,   300,     0,   301,   302,
     303,     0,   304,   305,   306,     0,   307,   308,   309,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,   318,
     319,   320,     0,   321,     0,   322,     0,     0,     0,   323,
     324,   325,     0,   326,   327,     0,   328,   329,     0,   330,
     331,   332,   333,   334,     0,   335,   336,   337,   338,     0,
     339,   340,   341,   342,   343,   344,     0,   345,     0,   346,
     347,   348,   349,   350,   351,   352,     0,   353,     0,   354,
       0,     0,   355,     0,   356,   357,   358,   359,   360,     0,
       0,   361,   362,     0,   363,     0,     0,   364,   365,   366,
       0,     0,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,     0,
     384,   385,   386,   387,     0,   388,   389,     0,   390,     0,
     391,   392,   393,   394,   395,   396,     0,   397,     0,     0,
     398,   399,   400,     0,     0,   401,   402,     0,   403,     0,
     404,   405,   406,   407,   408,   409,   410,   411,   412,     0,
     413,   414,   415,   416,   417,   418,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,     0,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,     0,   445,   446,     0,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
       0,   459,   460,   461,   462,   463,     0,   464,   465,   466,
     467,   468,     0,   469,   470,   471,   472,     0,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
       0,   485,   486,     0,   487,     0,   488,   489,   490,   491,
     492,     0,   493,   494,     0,     0,   495,   496,   497,   498,
     499,     0,   500,   501,   502,   503,   504,   505,   506,     0,
       0,   507,   508,   509,   510,   511,     0,     0,   512,   513,
     514,   515,   516,   517,   518,     0,   519,     0,   520,   521,
     522,   523,     0,     0,   524,     0,     0,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   222,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     223,   224,   225,   226,   227,   228,   229,   230,     0,   232,
     233,   234,     0,     0,     0,     0,     0,     0,     0,   235,
     236,     0,   237,   238,     0,   239,   240,   241,   242,   243,
       0,   244,   245,     0,   246,   247,   248,   249,   250,     0,
       0,   251,   252,   253,   254,   255,     0,   256,   257,   258,
     259,   260,     0,     0,     0,   261,   262,   263,   264,     0,
     265,   266,   267,     0,   268,   269,   270,   271,   272,   273,
       0,     0,   274,   275,   276,     0,     0,     0,     0,     0,
       0,     0,   277,   278,   279,   280,   281,   282,   283,   284,
     285,     0,   286,     0,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,     0,     0,   296,   297,   298,   299,
     300,     0,   301,   302,   303,     0,   304,   305,   306,     0,
     307,   308,   309,   310,   311,   312,   313,   314,   315,     0,
     316,     0,   317,   318,   319,   320,     0,   321,     0,   322,
       0,     0,     0,   323,   324,   325,     0,   326,   327,     0,
     328,   329,     0,   330,   331,   332,   333,  4078,     0,   335,
     336,   337,   338,     0,   339,   340,   341,   342,   343,   344,
       0,   345,     0,   346,   347,   348,   349,   350,   351,   352,
       0,   353,     0,   354,     0,     0,   355,     0,   356,   357,
     358,   359,   360,     0,     0,   361,   362,     0,   363,     0,
       0,   364,   365,   366,     0,     0,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,     0,   384,   385,   386,   387,     0,   388,
     389,     0,   390,     0,   391,   392,   393,   394,   395,   396,
       0,   397,     0,     0,   398,   399,   400,     0,     0,   401,
     402,     0,   403,     0,   404,   405,   406,   407,   408,   409,
     410,   411,   412,     0,   413,   414,   415,   416,   417,   418,
     419,   420,     0,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,     0,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,     0,   445,
     446,     0,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,   462,   463,
       0,   464,   465,   466,   467,   468,     0,   469,   470,   471,
     472,     0,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,     0,   485,   486,     0,   487,     0,
     488,   489,   490,   491,   492,     0,   493,   494,     0,     0,
     495,   496,   497,   498,   499,     0,   500,   501,   502,   503,
     504,   505,   506,     0,     0,   507,   508,   509,   510,   511,
       0,     0,   512,   513,   514,   515,   516,   517,   518,     0,
     519,     0,   520,   521,   522,   523,     0,     0,   524,     0,
       0,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   992,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   223,   224,   225,   226,   227,   228,
     229,   230,     0,   232,   233,   234,     0,     0,     0,     0,
       0,     0,     0,   235,   236,     0,   237,   238,   780,   239,
     240,   241,     0,   993,   781,   994,   995,     0,   246,   247,
     248,   249,   250,     0,     0,   251,   252,   996,   997,   255,
       0,   256,   257,   258,   259,     0,     0,   782,     0,   261,
     262,   263,   264,   783,   265,   266,   267,     0,   268,   269,
     270,   271,   272,   273,     0,   784,   274,   275,   276,     0,
       0,     0,   785,     0,     0,     0,   277,   278,   279,   280,
     281,   282,   998,   999,   285,     0,   286,     0,   287,   288,
     289,   290,   291,   292,     0,   293,   294,   295,     0,     0,
     296,   297,  1000,   299,   300,     0,   301,   302,   303,     0,
     304,   305,   306,     0,   307,   308,   309,   310,     0,   312,
     313,   314,     0,     0,   316,     0,   317,   318,  1001,   320,
       0,   321,     0,   322,   786,     0,   787,   323,   324,   325,
       0,   326,     0,     0,     0,   329,     0,   330,   331,   332,
     333,   334,   788,   335,   336,   337,   338,  2006,   339,   340,
     341,   342,   343,   344,     0,   345,   789,  2007,   347,   348,
     349,   350,  1003,  1004,     0,  1005,     0,   354,   790,   791,
     355,   792,   356,   357,   358,   359,   360,     0,     0,   361,
       0,   793,   363,   794,     0,   364,   365,   366,     0,     0,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,  1006,   795,  1007,   385,
     386,     0,     0,   388,   389,   796,   390,     0,     0,   392,
    1008,   394,   395,   396,     0,   397,     0,     0,   398,   399,
     400,     0,     0,   401,  2009,   797,   403,   798,     0,   405,
     406,   407,   408,   409,   410,   411,   412,     0,   413,   414,
       0,   416,     0,   418,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,  1009,   430,   431,   432,   433,
       0,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,     0,   445,   446,   799,   447,   448,   449,     0,
     451,   452,   453,   454,   455,   456,   457,   458,     0,   459,
     460,   461,   462,   463,     0,   464,   465,  2010,   467,   468,
     800,   469,   470,  1011,   472,     0,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,     0,     0,   485,
     486,     0,   487,   801,   488,   489,   490,   491,   492,     0,
    1012,  1013,     0,     0,   495,   496,     0,   498,     0,     0,
     500,   501,   502,   503,   504,   505,   506,     0,     0,   507,
     508,   509,   510,   511,     0,     0,   512,   513,   514,   515,
     516,     0,  1014,  2011,   519,   802,   520,   521,   522,   523,
       0,     0,   524,     0,     0,   525,   526,   527,   528,   529,
     530,   992,     0,     0,     0,     0,     0,     0,     0,     0,
     540,   541,   542,     0,     0,     0,   223,   224,   225,   226,
     227,   228,   229,   230,     0,   232,   233,   234,     0,     0,
       0,     0,     0,     0,     0,   235,   236,     0,   237,   238,
     780,   239,   240,   241,     0,   993,   781,   994,   995,     0,
     246,   247,   248,   249,   250,     0,     0,   251,   252,   996,
     997,   255,     0,   256,   257,   258,   259,     0,     0,   782,
       0,   261,   262,   263,   264,   783,   265,   266,   267,     0,
     268,   269,   270,   271,   272,   273,     0,   784,   274,   275,
     276,     0,     0,     0,   785,     0,     0,     0,   277,   278,
     279,   280,   281,   282,   998,   999,   285,     0,   286,     0,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
       0,     0,   296,   297,  1000,   299,   300,     0,   301,   302,
     303,     0,   304,   305,   306,     0,   307,   308,   309,   310,
       0,   312,   313,   314,     0,     0,   316,     0,   317,   318,
    1001,   320,     0,   321,     0,   322,   786,     0,   787,   323,
     324,   325,     0,   326,     0,     0,     0,   329,     0,   330,
     331,   332,   333,   334,   788,   335,   336,   337,   338,     0,
     339,   340,   341,   342,   343,   344,     0,   345,   789,     0,
     347,   348,   349,   350,  1003,  1004,     0,  1005,     0,   354,
     790,   791,   355,   792,   356,   357,   358,   359,   360,     0,
       0,   361,     0,   793,   363,   794,     0,   364,   365,   366,
       0,     0,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,  1006,   795,
    1007,   385,   386,     0,     0,   388,   389,   796,   390,  2106,
       0,   392,  1008,   394,   395,   396,     0,   397,     0,     0,
     398,   399,   400,     0,     0,   401,     0,   797,   403,   798,
       0,   405,   406,   407,   408,   409,   410,   411,   412,     0,
     413,   414,     0,   416,     0,   418,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,  1009,   430,   431,
     432,   433,     0,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,     0,   445,   446,   799,   447,   448,
     449,     0,   451,   452,   453,   454,   455,   456,   457,   458,
       0,   459,   460,   461,   462,   463,     0,   464,   465,  2010,
     467,   468,   800,   469,   470,  1011,   472,     0,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,     0,
       0,   485,   486,  3662,   487,   801,   488,   489,   490,   491,
     492,     0,  1012,  1013,     0,     0,   495,   496,     0,   498,
       0,     0,   500,   501,   502,   503,   504,   505,   506,     0,
       0,   507,   508,   509,   510,   511,     0,     0,   512,   513,
     514,   515,   516,     0,  1014,     0,   519,   802,   520,   521,
     522,   523,     0,     0,   524,     0,     0,   525,   526,   527,
     528,   529,   530,   222,     0,     0,     0,     0,     0,     0,
       0,     0,   540,   541,   542,     0,     0,     0,   223,   224,
     225,   226,   227,   228,   229,   230,     0,   232,   233,   234,
       0,     0,     0,     0,     0,     0,     0,   235,   236,     0,
     237,   238,     0,   239,   240,   241,   242,   243,     0,   244,
     245,     0,   246,   247,   248,   249,   250,     0,     0,   251,
     252,   253,   254,   255,     0,   256,   257,   258,   259,   260,
       0,     0,     0,   261,   262,   263,   264,     0,   265,   266,
     267,     0,   268,   269,   270,   271,   272,   273,     0,     0,
     274,   275,   276,     0,     0,     0,     0,     0,     0,     0,
     277,   278,   279,   280,   281,   282,   283,   284,   285,     0,
     286,     0,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,     0,     0,   296,   297,   298,   299,   300,     0,
     301,   302,   303,     0,   304,   305,   306,     0,   307,   308,
     309,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,   318,   319,   320,     0,   321,     0,   322,     0,     0,
       0,   323,   324,   325,     0,   326,   327,     0,   328,   329,
       0,   330,   331,   332,   333,   334,     0,   335,   336,   337,
     338,     0,   339,   340,   341,   342,   343,   344,     0,   345,
       0,   346,   347,   348,   349,   350,   351,   352,     0,   353,
       0,   354,     0,     0,   355,     0,   356,   357,   358,   359,
     360,     0,     0,   361,   362,     0,   363,     0,     0,   364,
     365,   366,     0,     0,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,     0,   384,   385,   386,   387,     0,   388,   389,     0,
     390,     0,   391,   392,   393,   394,   395,   396,     0,   397,
       0,     0,   398,   399,   400,     0,     0,   401,   402,     0,
     403,     0,   404,   405,   406,   407,   408,   409,     0,   411,
     412,     0,   413,   414,   415,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,   425,   426,     0,   428,   429,
     430,   431,   432,   433,     0,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,     0,   445,   446,     0,
     447,   448,   449,   450,     0,   452,   453,   454,   455,   456,
     457,   458,     0,   459,   460,   461,   462,   463,     0,   464,
     465,   466,   467,   468,     0,   469,   470,   471,   472,     0,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,     0,   485,   486,     0,   487,     0,   488,   489,
     490,   491,   492,     0,   493,   494,     0,     0,   495,   496,
     497,   498,   499,     0,   500,   501,   502,   503,   504,   505,
     506,     0,     0,   507,   508,   509,   510,   511,     0,     0,
     512,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     520,   521,   522,   523,     0,     0,   524,     0,     0,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   992,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   223,   224,   225,   226,   227,   228,   229,   230,
       0,   232,   233,   234,     0,     0,     0,     0,     0,     0,
       0,   235,   236,     0,   237,   238,   780,   239,   240,   241,
       0,   993,   781,   994,   995,     0,   246,   247,   248,   249,
     250,     0,     0,   251,   252,   996,   997,   255,     0,   256,
     257,   258,   259,     0,     0,   782,     0,   261,   262,   263,
     264,   783,   265,   266,   267,     0,   268,   269,   270,   271,
     272,   273,     0,   784,   274,   275,   276,     0,     0,     0,
     785,     0,     0,     0,   277,   278,   279,   280,   281,   282,
     998,   999,   285,     0,   286,     0,   287,   288,   289,   290,
     291,   292,     0,   293,   294,   295,     0,     0,   296,   297,
    1000,   299,   300,     0,   301,   302,   303,     0,   304,   305,
     306,     0,   307,   308,   309,   310,     0,   312,   313,   314,
       0,     0,   316,     0,   317,   318,  1001,   320,     0,   321,
       0,   322,   786,     0,   787,   323,   324,   325,     0,   326,
       0,     0,     0,   329,     0,   330,   331,   332,   333,   334,
     788,   335,   336,   337,   338,     0,   339,   340,   341,   342,
     343,   344,     0,   345,   789,     0,   347,   348,   349,   350,
    1003,  1004,     0,  1005,     0,   354,   790,   791,   355,   792,
     356,   357,   358,   359,   360,     0,     0,   361,     0,   793,
     363,   794,     0,   364,   365,   366,     0,     0,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,  1006,   795,  1007,   385,   386,  2176,
       0,   388,   389,   796,   390,     0,     0,   392,  1008,   394,
     395,   396,     0,   397,     0,     0,   398,   399,   400,     0,
       0,   401,     0,   797,   403,   798,     0,   405,   406,   407,
     408,   409,   410,   411,   412,     0,   413,   414,     0,   416,
       0,   418,   419,   420,     0,   421,   422,   423,   424,   425,
     426,   427,   428,  1009,   430,   431,   432,   433,     0,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
       0,   445,   446,   799,   447,   448,   449,     0,   451,   452,
     453,   454,   455,   456,   457,   458,     0,   459,   460,   461,
     462,   463,     0,   464,   465,  1010,   467,   468,   800,   469,
     470,  1011,   472,     0,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,     0,     0,   485,   486,     0,
     487,   801,   488,   489,   490,   491,   492,     0,  1012,  1013,
       0,     0,   495,   496,     0,   498,     0,     0,   500,   501,
     502,   503,   504,   505,   506,     0,     0,   507,   508,   509,
     510,   511,     0,     0,   512,   513,   514,   515,   516,     0,
    1014,     0,   519,   802,   520,   521,   522,   523,     0,     0,
     524,     0,     0,   525,   526,   527,   528,   529,   530,   992,
       0,     0,     0,     0,     0,     0,     0,     0,   540,   541,
     542,     0,     0,     0,   223,   224,   225,   226,   227,   228,
     229,   230,     0,   232,   233,   234,     0,     0,     0,     0,
       0,     0,     0,   235,   236,     0,   237,   238,   780,   239,
     240,   241,     0,   993,   781,   994,   995,     0,   246,   247,
     248,   249,   250,     0,     0,   251,   252,   996,   997,   255,
       0,   256,   257,   258,   259,     0,     0,   782,     0,   261,
     262,   263,   264,   783,   265,   266,   267,     0,   268,   269,
     270,   271,   272,   273,     0,   784,   274,   275,   276,     0,
       0,     0,   785,     0,     0,     0,   277,   278,   279,   280,
     281,   282,   998,   999,   285,     0,   286,     0,   287,   288,
     289,   290,   291,   292,     0,   293,   294,   295,     0,     0,
     296,   297,  1000,   299,   300,     0,   301,   302,   303,     0,
     304,   305,   306,     0,   307,   308,   309,   310,     0,   312,
     313,   314,     0,     0,   316,     0,   317,   318,  1001,   320,
       0,   321,     0,   322,   786,     0,   787,   323,   324,   325,
       0,   326,     0,     0,     0,   329,     0,   330,   331,   332,
     333,   334,   788,   335,   336,   337,   338,     0,   339,   340,
     341,   342,   343,   344,     0,   345,   789,     0,   347,   348,
     349,   350,  1003,  1004,     0,  1005,     0,   354,   790,   791,
     355,   792,   356,   357,   358,   359,   360,     0,     0,   361,
       0,   793,   363,   794,     0,   364,   365,   366,     0,     0,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,  1006,   795,  1007,   385,
     386,  3482,     0,   388,   389,   796,   390,     0,     0,   392,
    1008,   394,   395,   396,     0,   397,     0,     0,   398,   399,
     400,     0,     0,   401,     0,   797,   403,   798,     0,   405,
     406,   407,   408,   409,   410,   411,   412,     0,   413,   414,
       0,   416,     0,   418,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,  1009,   430,   431,   432,   433,
       0,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,     0,   445,   446,   799,   447,   448,   449,     0,
     451,   452,   453,   454,   455,   456,   457,   458,     0,   459,
     460,   461,   462,   463,     0,   464,   465,  1010,   467,   468,
     800,   469,   470,  1011,   472,     0,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,     0,     0,   485,
     486,     0,   487,   801,   488,   489,   490,   491,   492,     0,
    1012,  1013,     0,     0,   495,   496,     0,   498,     0,     0,
     500,   501,   502,   503,   504,   505,   506,     0,     0,   507,
     508,   509,   510,   511,     0,     0,   512,   513,   514,   515,
     516,     0,  1014,     0,   519,   802,   520,   521,   522,   523,
       0,     0,   524,     0,     0,   525,   526,   527,   528,   529,
     530,   992,     0,     0,     0,     0,     0,     0,     0,     0,
     540,   541,   542,     0,     0,     0,   223,   224,   225,   226,
     227,   228,   229,   230,     0,   232,   233,   234,     0,     0,
       0,     0,     0,     0,     0,   235,   236,     0,   237,   238,
     780,   239,   240,   241,     0,   993,   781,   994,   995,     0,
     246,   247,   248,   249,   250,     0,     0,   251,   252,   996,
     997,   255,     0,   256,   257,   258,   259,     0,     0,   782,
       0,   261,   262,   263,   264,   783,   265,   266,   267,     0,
     268,   269,   270,   271,   272,   273,     0,   784,   274,   275,
     276,     0,     0,     0,   785,     0,     0,     0,   277,   278,
     279,   280,   281,   282,   998,   999,   285,     0,   286,     0,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
       0,     0,   296,   297,  1000,   299,   300,     0,   301,   302,
     303,     0,   304,   305,   306,     0,   307,   308,   309,   310,
       0,   312,   313,   314,     0,     0,   316,     0,   317,   318,
    1001,   320,     0,   321,     0,   322,   786,     0,   787,   323,
     324,   325,     0,   326,     0,     0,     0,   329,     0,   330,
     331,   332,   333,  1002,   788,   335,   336,   337,   338,     0,
     339,   340,   341,   342,   343,   344,     0,   345,   789,     0,
     347,   348,   349,   350,  1003,  1004,     0,  1005,     0,   354,
     790,   791,   355,   792,   356,   357,   358,   359,   360,     0,
       0,   361,     0,   793,   363,   794,     0,   364,   365,   366,
       0,     0,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,  1006,   795,
    1007,   385,   386,     0,     0,   388,   389,   796,   390,     0,
       0,   392,  1008,   394,   395,   396,     0,   397,     0,     0,
     398,   399,   400,     0,     0,   401,     0,   797,   403,   798,
       0,   405,   406,   407,   408,   409,   410,   411,   412,     0,
     413,   414,     0,   416,     0,   418,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,  1009,   430,   431,
     432,   433,     0,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,     0,   445,   446,   799,   447,   448,
     449,     0,   451,   452,   453,   454,   455,   456,   457,   458,
       0,   459,   460,   461,   462,   463,     0,   464,   465,  1010,
     467,   468,   800,   469,   470,  1011,   472,     0,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,     0,
       0,   485,   486,     0,   487,   801,   488,   489,   490,   491,
     492,     0,  1012,  1013,     0,     0,   495,   496,     0,   498,
       0,     0,   500,   501,   502,   503,   504,   505,   506,     0,
       0,   507,   508,   509,   510,   511,     0,     0,   512,   513,
     514,   515,   516,     0,  1014,     0,   519,   802,   520,   521,
     522,   523,     0,     0,   524,     0,     0,   525,   526,   527,
     528,   529,   530,   992,     0,     0,     0,     0,     0,     0,
       0,     0,   540,   541,   542,     0,     0,     0,   223,   224,
     225,   226,   227,   228,   229,   230,     0,   232,   233,   234,
       0,     0,     0,     0,     0,     0,     0,   235,   236,     0,
     237,   238,   780,   239,   240,   241,     0,   993,   781,   994,
     995,     0,   246,   247,   248,   249,   250,     0,     0,   251,
     252,   996,   997,   255,     0,   256,   257,   258,   259,     0,
       0,   782,     0,   261,   262,   263,   264,   783,   265,   266,
     267,     0,   268,   269,   270,   271,   272,   273,     0,   784,
     274,   275,   276,     0,     0,     0,   785,     0,     0,     0,
     277,   278,   279,   280,   281,   282,   998,   999,   285,     0,
     286,     0,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,     0,     0,   296,   297,  1000,   299,   300,     0,
     301,   302,   303,     0,   304,   305,   306,     0,   307,   308,
     309,   310,     0,   312,   313,   314,     0,     0,   316,     0,
     317,   318,  1001,   320,     0,   321,     0,   322,   786,     0,
     787,   323,   324,   325,     0,   326,     0,     0,     0,   329,
       0,   330,   331,   332,   333,  1060,   788,   335,   336,   337,
     338,     0,   339,   340,   341,   342,   343,   344,     0,   345,
     789,     0,   347,   348,   349,   350,  1003,  1004,     0,  1005,
       0,   354,   790,   791,   355,   792,   356,   357,   358,   359,
     360,     0,     0,   361,     0,   793,   363,   794,     0,   364,
     365,   366,     0,     0,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
    1006,   795,  1007,   385,   386,     0,     0,   388,   389,   796,
     390,     0,     0,   392,  1008,   394,   395,   396,     0,   397,
       0,     0,   398,   399,   400,     0,     0,   401,     0,   797,
     403,   798,     0,   405,   406,   407,   408,   409,   410,   411,
     412,     0,   413,   414,     0,   416,     0,   418,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,  1009,
     430,   431,   432,   433,     0,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,     0,   445,   446,   799,
     447,   448,   449,     0,   451,   452,   453,   454,   455,   456,
     457,   458,     0,   459,   460,   461,   462,   463,     0,   464,
     465,  1010,   467,   468,   800,   469,   470,  1011,   472,     0,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,     0,     0,   485,   486,     0,   487,   801,   488,   489,
     490,   491,   492,     0,  1012,  1013,     0,     0,   495,   496,
       0,   498,     0,     0,   500,   501,   502,   503,   504,   505,
     506,     0,     0,   507,   508,   509,   510,   511,     0,     0,
     512,   513,   514,   515,   516,     0,  1014,     0,   519,   802,
     520,   521,   522,   523,     0,     0,   524,     0,     0,   525,
     526,   527,   528,   529,   530,   992,     0,     0,     0,     0,
       0,     0,     0,     0,   540,   541,   542,     0,     0,     0,
     223,   224,   225,   226,   227,   228,   229,   230,     0,   232,
     233,   234,     0,     0,     0,     0,     0,     0,     0,   235,
     236,     0,   237,   238,   780,   239,   240,   241,     0,   993,
     781,   994,   995,     0,   246,   247,   248,   249,   250,     0,
       0,   251,   252,   996,   997,   255,     0,   256,   257,   258,
     259,     0,     0,   782,     0,   261,   262,   263,   264,   783,
     265,   266,   267,     0,   268,   269,   270,   271,   272,   273,
       0,   784,   274,   275,   276,     0,     0,     0,   785,     0,
       0,     0,   277,   278,   279,   280,   281,   282,   998,   999,
     285,     0,   286,     0,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,     0,     0,   296,   297,  1000,   299,
     300,     0,   301,   302,   303,     0,   304,   305,   306,     0,
     307,   308,   309,   310,     0,   312,   313,   314,     0,     0,
     316,     0,   317,   318,  1001,   320,     0,   321,     0,   322,
     786,     0,   787,   323,   324,   325,     0,   326,     0,     0,
       0,   329,     0,   330,   331,   332,   333,   334,   788,   335,
     336,   337,   338,     0,   339,   340,   341,   342,   343,   344,
       0,   345,   789,     0,   347,   348,   349,   350,  1003,  1004,
       0,  1005,     0,   354,   790,   791,   355,   792,   356,   357,
     358,   359,   360,     0,     0,   361,     0,   793,   363,   794,
       0,   364,   365,   366,     0,     0,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,  1006,   795,  1007,   385,   386,     0,     0,   388,
     389,   796,   390,     0,     0,   392,  1008,   394,   395,   396,
       0,   397,     0,     0,   398,   399,   400,     0,     0,   401,
       0,   797,   403,   798,     0,   405,   406,   407,   408,   409,
     410,   411,   412,     0,   413,   414,     0,   416,     0,   418,
     419,   420,     0,   421,   422,   423,   424,   425,   426,   427,
     428,  1009,   430,   431,   432,   433,     0,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,     0,   445,
     446,   799,   447,   448,   449,     0,   451,   452,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,   462,   463,
       0,   464,   465,  1010,   467,   468,   800,   469,   470,  1011,
     472,     0,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,     0,     0,   485,   486,     0,   487,   801,
     488,   489,   490,   491,   492,     0,  1012,  1013,     0,     0,
     495,   496,     0,   498,     0,     0,   500,   501,   502,   503,
     504,   505,   506,     0,     0,   507,   508,   509,   510,   511,
       0,     0,   512,   513,   514,   515,   516,     0,  1014,     0,
     519,   802,   520,   521,   522,   523,     0,     0,   524,     0,
       0,   525,   526,   527,   528,   529,   530,   992,     0,     0,
       0,     0,     0,     0,     0,     0,   540,   541,   542,     0,
       0,     0,   223,   224,   225,   226,   227,   228,   229,   230,
       0,   232,   233,   234,     0,     0,     0,     0,     0,     0,
       0,   235,   236,     0,   237,   238,   780,   239,   240,   241,
       0,   993,   781,   994,   995,     0,   246,   247,   248,   249,
     250,     0,     0,   251,   252,   996,   997,   255,     0,   256,
     257,   258,   259,     0,     0,   782,     0,   261,   262,   263,
     264,   783,   265,   266,   267,     0,   268,   269,   270,   271,
     272,   273,     0,   784,   274,   275,   276,     0,     0,     0,
     785,     0,     0,     0,   277,   278,   279,   280,   281,   282,
     998,   999,   285,     0,   286,     0,   287,   288,   289,   290,
     291,   292,     0,   293,   294,   295,     0,     0,   296,   297,
    1000,   299,   300,     0,   301,   302,   303,     0,   304,   305,
     306,     0,   307,   308,   309,   310,     0,   312,   313,   314,
       0,     0,   316,     0,   317,   318,  1001,   320,     0,   321,
       0,   322,   786,     0,   787,   323,   324,   325,     0,   326,
       0,     0,     0,   329,     0,   330,   331,   332,   333,   334,
     788,   335,   336,   337,   338,     0,   339,   340,   341,   342,
     343,   344,     0,   345,   789,     0,   347,   348,   349,   350,
    1003,  1004,     0,  1005,     0,   354,   790,   791,   355,   792,
     356,   357,   358,   359,   360,     0,     0,   361,     0,   793,
     363,   794,     0,   364,   365,   366,     0,     0,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,  1006,   795,  1007,   385,   386,     0,
       0,   388,   389,   796,   390,     0,     0,   392,  1008,   394,
     395,   396,     0,   397,     0,     0,   398,   399,   400,     0,
       0,   401,     0,   797,   403,   798,     0,   405,   406,   407,
     408,   409,   410,   411,   412,     0,   413,   414,     0,   416,
       0,   418,   419,   420,     0,   421,   422,   423,   424,   425,
     426,   427,   428,  1009,   430,   431,   432,   433,     0,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
       0,   445,   446,   799,   447,   448,   449,     0,   451,   452,
     453,   454,   455,   456,   457,   458,     0,   459,   460,   461,
     462,   463,     0,   464,   465,  2010,   467,   468,   800,   469,
     470,  1011,   472,     0,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,     0,     0,   485,   486,     0,
     487,   801,   488,   489,   490,   491,   492,     0,  1012,  1013,
       0,     0,   495,   496,     0,   498,     0,     0,   500,   501,
     502,   503,   504,   505,   506,     0,     0,   507,   508,   509,
     510,   511,     0,     0,   512,   513,   514,   515,   516,     0,
    1014,     0,   519,   802,   520,   521,   522,   523,     0,     0,
     524,     0,     0,   525,   526,   527,   528,   529,   530,   992,
       0,     0,     0,     0,     0,     0,     0,     0,   540,   541,
     542,     0,     0,     0,   223,   224,   225,   226,   227,   228,
     229,   230,     0,   232,   233,   234,     0,     0,     0,     0,
       0,     0,     0,   235,   236,     0,   237,   238,   780,   239,
     240,   241,     0,   993,   781,   994,   995,     0,   246,   247,
     248,   249,   250,     0,     0,   251,   252,   996,   997,   255,
       0,   256,   257,   258,   259,     0,     0,   782,     0,   261,
     262,   263,   264,   783,   265,   266,   267,     0,   268,   269,
     270,   271,   272,   273,     0,   784,   274,   275,   276,     0,
       0,     0,   785,     0,     0,     0,   277,   278,   279,   280,
     281,   282,   998,   999,   285,     0,   286,     0,   287,   288,
     289,   290,   291,   292,     0,   293,   294,   295,     0,     0,
     296,   297,  1000,   299,   300,     0,   301,   302,   303,     0,
     304,   305,   306,     0,   307,   308,   309,   310,     0,   312,
     313,   314,     0,     0,   316,     0,   317,   318,  1001,   320,
       0,   321,     0,   322,   786,     0,   787,   323,   324,   325,
       0,   326,     0,     0,     0,   329,     0,   330,   331,   332,
     333,   334,   788,   335,   336,   337,   338,     0,   339,   340,
     341,   342,   343,   344,     0,   345,   789,     0,   347,   348,
     349,   350,  1003,  1004,     0,  1005,     0,   354,   790,   791,
     355,   792,   356,   357,   358,   359,   360,     0,     0,   361,
       0,   793,   363,   794,     0,   364,   365,   366,     0,     0,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,  1006,   795,  1007,   385,
     386,     0,     0,   388,   389,   796,   390,     0,     0,   392,
    1008,   394,   395,   396,     0,   397,     0,     0,   398,   399,
     400,     0,     0,   401,     0,   797,   403,   798,     0,   405,
     406,   407,   408,   409,   410,   411,   412,     0,   413,   414,
       0,   416,     0,   418,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,  1009,   430,   431,   432,   433,
       0,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,     0,   445,   446,   799,   447,   448,   449,     0,
     451,   452,   453,   454,   455,   456,   457,   458,     0,   459,
     460,   461,   462,   463,     0,   464,   465,     0,   467,   468,
     800,   469,   470,  1011,   472,     0,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,     0,     0,   485,
     486,     0,   487,   801,   488,   489,   490,   491,   492,     0,
    1012,  1013,     0,     0,   495,   496,     0,   498,     0,     0,
     500,   501,   502,   503,   504,   505,   506,     0,     0,   507,
     508,   509,   510,   511,     0,     0,   512,   513,   514,   515,
     516,     0,  1014,     0,   519,   802,   520,   521,   522,   523,
       0,     0,   524,     0,     0,   525,   526,   527,   528,   529,
     530,   992,     0,     0,     0,     0,     0,     0,     0,     0,
     540,   541,   542,     0,     0,     0,   223,   224,   225,   226,
     227,   228,   229,   230,     0,   232,   233,   234,     0,     0,
       0,     0,     0,     0,     0,   235,   236,     0,   237,   238,
     780,   239,   240,   241,     0,     0,   781,     0,     0,     0,
     246,   247,   248,   249,   250,     0,     0,   251,   252,     0,
       0,   255,     0,   256,   257,   258,   259,     0,     0,   782,
       0,   261,   262,   263,   264,   783,   265,   266,   267,     0,
     268,   269,   270,   271,   272,   273,     0,   784,   274,   275,
     276,     0,     0,     0,   785,     0,     0,     0,   277,   278,
     279,   280,   281,   282,     0,     0,   285,     0,   286,     0,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
       0,     0,   296,   297,   298,   299,   300,     0,   301,   302,
     303,     0,   304,   305,   306,     0,   307,   308,   309,   310,
       0,   312,   313,   314,     0,     0,   316,     0,   317,   318,
       0,   320,     0,   321,     0,   322,   786,     0,   787,   323,
     324,   325,     0,   326,     0,     0,     0,   329,     0,   330,
     331,   332,   333,   334,   788,   335,   336,   337,   338,     0,
     339,   340,   341,   342,   343,   344,     0,   345,   789,     0,
     347,   348,   349,   350,     0,     0,     0,     0,     0,   354,
     790,   791,   355,   792,   356,   357,   358,   359,   360,     0,
       0,   361,     0,   793,   363,   794,     0,   364,   365,   366,
       0,     0,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,     0,   795,
       0,   385,   386,     0,     0,   388,   389,   796,   390,     0,
       0,   392,     0,   394,   395,   396,     0,   397,     0,     0,
     398,   399,   400,     0,     0,   401,     0,   797,   403,   798,
       0,   405,   406,   407,   408,   409,   410,   411,   412,     0,
     413,   414,     0,   416,     0,   418,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,     0,   430,   431,
     432,   433,     0,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,     0,   445,   446,   799,   447,   448,
     449,     0,   451,   452,   453,   454,   455,   456,   457,   458,
       0,   459,   460,   461,   462,   463,     0,   464,   465,     0,
     467,   468,   800,   469,   470,     0,   472,     0,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,     0,
       0,   485,   486,     0,   487,   801,   488,   489,   490,   491,
     492,     0,     0,     0,     0,     0,   495,   496,     0,   498,
       0,     0,   500,   501,   502,   503,   504,   505,   506,     0,
       0,   507,   508,   509,   510,   511,     0,     0,   512,   513,
     514,   515,   516,     0,     0,     0,   519,   802,   520,   521,
     522,   523,     0,     0,   524,     0,     0,   525,   526,   527,
     528,   529,   530,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   540,   541,   542
};

static const yytype_int16 yycheck[] =
{
      16,     0,     0,     0,     0,     0,     0,    50,  1099,    25,
     204,  1035,   601,    35,    21,   571,   722,   674,   675,   676,
      27,   773,    20,   680,    20,  1077,  1712,  1044,   724,   778,
      44,   182,  1010,   200,  1269,   835,   190,    43,    21,   623,
     207,   877,   865,  2298,    27,   199,  1389,   804,  1346,  1271,
     634,   218,    50,   642,  1039,   886,   601,   747,     7,  2483,
    1288,   998,   999,  2646,   620,    14,   951,    12,  1833,  1383,
    1496,  1008,  1029,   731,  2265,  1013,    17,   962,   931,  2817,
    1130,   864,  2273,  2307,  2275,  2175,  2842,   870,  2844,  1324,
     562,  1389,  2790,    22,  2634,    20,   879,  1567,  1320,  3053,
     936,  2227,   612,  3008,   940,  3035,    35,  1394,  3077,   945,
    3334,  1448,  1748,   207,  1405,  1961,     0,  1293,   954,  3377,
     864,  3377,  2695,   633,   218,  2990,  2997,  2459,   964,  2638,
    2636,  2637,  2997,   986,  3064,  3373,   184,   641,   727,   611,
    3431,  3587,   169,   184,  3654,  3663,   633,  2687,  3641,  1836,
    3298,  3651,  1731,  1579,  1792,  3304,  3640,  2569,     0,     0,
       0,     0,     0,  3270,  2014,  2015,     0,     0,  1069,    34,
       0,     0,  1375,  1460,  1465,  1466,    41,     0,     0,     0,
      49,  1324,   727,  2703,  3051,   821,   184,  4098,  3904,   770,
    1303,   996,   997,   877,   770,  3303,  3350,  3233,  4275,  1669,
    4392,     0,  1007,    40,    62,     0,    84,   213,  4218,     0,
    4220,  2301,     0,  4256,    41,  2634,    48,    11,     9,     5,
      35,    70,  1159,  1160,     3,     0,    22,    13,    14,     5,
     111,  4317,  4318,   109,    41,    26,  4313,    13,    14,     5,
       9,  1178,     5,   159,     5,     5,    72,    13,    14,  2014,
    1188,    30,    31,     5,     5,   191,   192,    22,    26,   195,
      72,   197,     4,   154,    26,    33,   102,     9,  2687,    39,
    4581,     5,   929,   109,    55,     5,     5,  1077,   181,   200,
      78,   217,    55,    76,     5,     5,   134,  2539,  2540,  2701,
     160,     5,  2544,    26,   102,  1530,     5,     5,    11,   116,
      33,    62,   159,     5,    39,    29,  1207,   159,   109,   169,
     161,  2401,   162,  2403,     5,  4341,   159,     9,  2792,     9,
     260,   119,    72,   204,   159,   260,   244,    40,    72,  2581,
    2582,   127,    62,     0,     3,     4,     5,    81,    55,   117,
       9,   165,     9,  1148,  1149,    81,     5,   244,   154,    11,
     153,   907,   114,   247,   256,   102,   169,    70,   109,    26,
     159,    38,   127,    26,   159,   246,  1338,   289,   159,  1174,
      33,   159,   161,   109,   122,   327,   124,   571,   159,   158,
       4,   160,   181,   114,   159,     9,   181,   340,   339,   899,
     181,    22,  4851,   181,    88,  2081,    68,    28,   309,    11,
     149,   113,   569,   557,   378,    83,   181,   574,   159,   919,
     246,   262,   399,    11,   139,   274,   418,   298,   585,   159,
      72,  4497,  4498,   933,  3205,  1256,   620,    21,  4739,    81,
     442,   244,   194,    27,  4511,    72,   314,    55,   409,    72,
     109,   181,    40,   455,    81,   246,   124,   421,  4458,   297,
     309,  1208,   606,  3234,  1254,   457,   378,   182,    70,  1259,
    1260,  1045,   616,  3909,    11,   376,   453,   111,    81,   218,
     164,  4382,    70,   262,   129,   569,  1065,    72,   276,  1236,
     574,  1709,   285,  1507,   334,  1713,    81,  1715,  1077,   201,
    1718,   585,   159,    40,  4953,  1512,   127,   244,   246,   421,
     453,   453,   179,   397,   455,   311,   403,   358,   256,   274,
     246,   451,    11,    55,   181,   455,   366,   435,   453,   355,
    1065,  1105,   358,    70,   376,  1747,   327,  4553,   336,   102,
     199,   309,  1116,  3007,   141,   551,   457,   387,  3729,    29,
    3731,   457,   315,   403,   309,  1134,   327,  1131,   102,   208,
     376,   453,   221,   102,   457,   554,   554,   554,   554,   554,
     554,  1533,   453,  1363,   376,  1800,   442,  1789,    26,   376,
     332,   159,   370,  1373,   339,  1079,   457,   404,  1361,   457,
     102,   349,   399,   453,  4895,   601,   602,   259,   312,  1134,
     403,  3462,   362,   356,   357,   453,   389,  3462,   315,   642,
     457,   397,   451,  4689,  1114,   453,   455,   109,  1444,   550,
    1446,  4057,  1703,  1835,   457,  4099,   349,   453,   453,   646,
    4663,   453,   773,   259,   560,   376,   376,   362,   564,   410,
     409,  1454,   376,   457,  1417,   397,  1436,   402,   453,  1439,
    1440,  1526,  3380,   641,   642,   641,   582,  1500,   655,  2739,
     657,  4843,   659,   444,   445,   449,  1769,   456,   665,   666,
     667,   456,  1251,  1494,  1777,   456,   397,   453,   456,  4115,
    1259,  1260,   655,   689,   657,  3824,   659,   453,   408,  3609,
     686,   456,   665,   452,   457,  3833,   349,   453,  1673,  3837,
    3797,   442,   453,   453,   408,   640,  3650,   315,  1635,   715,
    1601,   453,   444,   445,   455,  3741,  1251,   723,  1508,  4785,
     726,   727,   728,   907,   762,  3823,  4793,   642,   420,   453,
     669,   762,   451,   453,   453,  1710,   455,  3632,  4805,   420,
    1311,  3885,   453,   453,  1719,  1311,   449,   439,   892,   453,
     457,   747,  1426,   376,   453,   453,  1382,  1431,   439,   903,
      34,   453,   444,   445,   444,   445,  3296,   401,  3298,   414,
    4770,   453,   453,   376,   762,   764,   764,   764,   764,   764,
     764,   777,  2963,   315,  4490,   444,   445,   444,   445,  2970,
    2971,   376,  2125,  2974,   446,   447,   448,   449,   376,   456,
    2981,    22,   365,  2028,   418,   657,   658,   659,  4875,    20,
     662,   663,   664,  1608,  1609,  4251,  3030,   414,  2095,  3318,
     672,   365,  4258,    55,   820,   439,   365,   453,   972,   102,
     444,   445,   312,   167,   282,   109,   751,   159,   835,  4740,
     332,     5,    27,   323,  3572,   325,  3703,  3377,     3,   457,
       5,   233,  3362,   365,    55,  1746,   260,  1748,   446,   447,
     448,   449,   112,  1754,   442,     3,  2706,    46,  2708,  1760,
    1761,  1762,  3560,   365,     5,   261,  1422,   455,   109,  1770,
    1771,  2636,  2637,  2638,  1775,   266,   334,  3296,   111,  3298,
     764,  4381,  2972,  2973,  2171,  2028,   755,    56,   725,    24,
     292,   381,   729,   109,   323,    64,   127,   444,   445,   446,
     447,   448,   449,   405,     5,   841,   842,     3,     5,    44,
    1420,   369,  2115,   371,   140,   457,   418,   177,  1575,   140,
      26,  2156,   764,   764,   764,   764,   764,   811,   256,  4840,
     764,   764,    80,   302,   764,   764,  3348,   439,   330,   104,
      22,   764,   764,   764,  4202,   444,   445,   446,   447,   448,
     449,   453,  4143,   156,    78,    26,  4147,  4148,  3377,  4150,
    3212,  3213,  3214,  3215,   140,   256,  3218,  3219,  3220,  3221,
    3222,  3223,  3224,  3225,  3226,  3227,   320,   162,  3676,   320,
       5,  4239,   266,   131,    80,   114,   922,   176,    64,  2041,
     256,  1501,   181,   877,  4252,   119,  4252,    78,   266,    78,
     195,   866,   867,    74,  2341,    81,  1516,   114,   173,  2696,
     251,    82,  2650,   949,   950,   206,   122,   103,   251,    64,
    1716,  1717,  3274,  3275,   453,  1535,   266,   423,   217,  1786,
     246,    22,  2010,   244,   970,   976,   132,    28,   119,   110,
     119,  2355,   411,   274,   376,   127,   161,   114,   104,  1065,
     109,   453,   221,   244,  4203,  4162,  1640,   398,  2293,  4207,
     195,  1077,   138,  2020,  4212,   194,   457,  4215,   233,  1653,
    1077,   236,  1582,   315,   339,  4568,   224,   251,   309,   365,
     156,  1079,   365,  1079,  1668,  1595,  2665,   194,    78,  4607,
     186,  1680,  1648,   138,  4604,  1111,  4596,  1607,   184,  4592,
     137,   160,   323,   169,   315,  1041,  1042,  4591,   339,  1619,
     251,   156,   339,  3984,   185,   273,   342,   173,  1134,  3984,
    1607,   342,   127,   207,  1596,   453,   274,   194,   339,   119,
    1015,   104,   230,  1082,  4392,  1084,   127,  1086,  4092,  1088,
    2990,  1090,  1091,  1092,  1142,    64,  4115,  2997,  1097,   334,
     251,   342,   276,  1663,   251,   344,  1666,  4087,   442,   378,
    3898,   198,   453,  1161,  1207,   330,   342,   451,  1053,   453,
     454,   455,    32,   457,   151,  1679,  1061,   233,   244,  1666,
     236,   366,  1067,  3939,   280,   113,   454,   453,   247,   457,
     109,   101,   457,  1209,  1192,   276,     8,   276,   264,    11,
     173,   141,  1218,    15,    16,    17,   397,    22,   339,  1207,
     325,  1767,     0,    28,   290,   173,  1232,   457,  1080,  2447,
     368,  1083,   370,  1085,  3074,  1087,   399,  1089,  1422,   266,
     457,  1093,    48,   181,   122,  1251,   124,    26,  1254,  1255,
     250,   327,   103,  1259,  1260,   290,   370,  1254,  1296,  1297,
    4488,  1299,  1259,  1260,  1281,  1296,  1297,  4741,  1299,   264,
     233,   289,     4,   236,   379,   332,   243,     9,   397,   434,
     385,   376,   453,   201,   330,   233,  4259,   384,   364,   365,
     453,   141,   137,   274,   100,  1795,   276,   358,   111,   370,
     397,   370,   160,  3833,   390,    61,    62,  3837,  1296,  1297,
    1996,  1299,   398,  4594,  4750,   401,  4454,  1313,   313,   323,
    3883,   274,   127,  1480,    36,  4422,   392,   122,   309,   124,
     274,   231,   114,   184,   234,  2560,   457,   246,  3580,   456,
     397,  2566,   251,   122,   339,   127,   346,   403,  2223,  4839,
     399,  2124,   147,  3849,  4844,  3854,   309,   392,   339,   163,
     378,  3860,   457,  3544,   391,   309,  1363,   330,   273,  3550,
    3551,   309,  3553,   218,  4347,   313,  1373,   453,   256,   181,
    2394,   290,   330,   309,  4632,   292,   339,   193,   434,   273,
     370,   204,   169,   397,  1551,   304,    53,  2404,  1555,  3721,
     202,   339,   332,   421,  2194,   376,   118,   453,  4898,  4657,
    1567,  4657,  2202,   339,  2204,  1412,  4513,   221,  2191,   277,
    4517,  4518,   149,  2398,  3833,  4286,   266,  1358,  3837,   273,
    4374,  4286,   202,   246,   339,   365,  2539,  2540,   244,  1436,
    2213,  2544,  1439,  1440,   101,  1589,  1452,  2322,  2323,  2324,
    2325,   246,  4666,  4667,    89,   339,   251,  2191,   206,  2334,
     262,   256,  2041,  1459,  1648,   111,  3142,   244,  2241,   274,
    4960,   434,  4367,   325,  1400,   405,   327,  2368,  2581,  2582,
     418,   457,   311,   392,  1641,   298,   457,   345,   418,   329,
     260,   218,  2658,    64,  1638,   339,   244,   274,   302,    70,
     453,   439,   163,  2807,   309,   287,   274,   376,   163,   439,
      81,  1508,  1669,   364,   365,  3631,  2734,   112,  4491,     3,
    3356,  2364,   328,   453,   381,   160,   183,  4500,   149,   381,
     255,   258,   309,   154,   339,   348,   120,  2083,   109,    23,
     111,  1467,  1468,  1469,  1470,   151,   130,  1553,  2122,   325,
     298,   323,  1426,   325,   264,   190,   112,  1431,   204,  3185,
     221,    88,   418,  3318,   274,   369,   221,   371,  1712,   230,
     205,   339,  2034,   442,   231,   399,  2903,   234,  2078,   411,
     215,   108,   177,  1767,  1510,  1511,   455,   244,   383,   418,
    2090,   395,   332,  1519,   342,  4843,    80,   218,   393,   309,
     246,   457,   232,  1529,   210,   381,   241,   411,  1605,   381,
     439,  3691,   415,  3693,   141,  4343,   273,   188,  1615,  2186,
    1617,   177,  3462,   160,  4283,   365,   403,  1624,   457,   453,
    2130,  1557,  1558,  1559,  1560,  1632,  2913,   258,   440,   441,
     442,   274,   444,   445,   446,   447,   448,   449,   132,   397,
    2541,    24,   298,   190,   457,  4869,  2881,   314,  4602,   154,
    4580,  2451,  2553,  2744,   155,   405,  4325,   323,   205,   164,
    3130,    44,  4202,  2240,   111,   246,   309,  4207,   215,   122,
     251,   124,  4212,  4578,   319,  4215,   181,   369,   161,   371,
     274,  1679,   227,  1679,  2585,   186,   353,   181,   354,   418,
     410,   309,   186,  2350,   147,   313,   339,   309,   369,  4239,
     371,   323,   324,   453,   369,  1590,   371,  4405,   191,   290,
     439,  2183,  4252,   313,  4619,   309,  1652,  1739,  4142,  1655,
    1726,   339,  2623,   304,   395,   323,   324,   339,   457,  1665,
     395,   101,  1731,  1731,  1731,  1731,  1731,  1731,  1674,   339,
    1689,   188,  1691,  1759,  1693,   302,  1695,  2704,  1697,  1756,
    1757,  4507,  1701,  2710,  1639,  1680,  1763,  1764,  1643,  2776,
       3,  2996,   149,  4501,  1649,  1650,  3057,   154,   305,  3060,
    2359,    89,   319,   420,   297,  2285,   333,  2714,   227,    13,
      14,  4750,   327,  4202,  1791,   155,   280,  1672,  4207,   313,
     274,   227,   439,  4212,   227,   332,  4215,   244,   251,   246,
     418,   324,   329,   256,  1745,   274,    11,  1805,   365,  1738,
    4065,   392,   274,   318,  2359,   339,   186,   302,  4401,  4749,
    4239,   439,  4246,   368,  4248,   309,   320,   208,   365,  3919,
    3920,   218,  2421,  4252,  1850,    40,  4091,    80,   418,  1549,
     309,   381,   160,  4034,   313,  4036,  4037,   309,   333,  4040,
     395,  2651,  4392,  4077,   411,   339,   453,  2024,  1568,   439,
     274,   231,  2029,   154,   234,    70,  2033,  1803,   405,   363,
     339,   258,   190,   418,   246,   420,  2421,   339,   327,   251,
     365,   418,    42,  2552,   175,  2554,  2555,   205,   131,  2083,
      81,  2643,  2059,   381,   327,   309,   390,   215,    30,    31,
     154,   298,   439,    63,   398,   260,  4158,   401,   453,   311,
     265,  2764,  3140,   310,  4454,    85,   453,   137,  4616,   368,
    2074,   175,   418,   241,   296,   339,   411,  2081,   420,   149,
     383,  4669,   368,   451,   154,   368,  2103,   455,   335,   452,
     393,   329,   260,   439,   457,   448,   395,   439,   452,  3040,
     453,   230,   455,   457,  2121,  3381,    88,     8,  3049,   395,
      11,   453,   395,  2473,    15,    16,    17,   230,  1975,   418,
    2793,   420,   163,  4392,   260,   420,   108,   184,   198,   265,
    2490,   224,   418,    77,   420,   418,  2153,   420,  4893,   381,
    2648,  2501,  1975,   184,   439,  2818,   454,   232,   218,   457,
     448,   319,  2001,  2001,   453,   453,   175,   455,   453,   141,
     454,  2794,  3247,   457,  4944,   411,   454,   453,  2185,   457,
     453,  2043,  2189,  2045,     5,  2041,   369,  2121,   371,    10,
     221,   274,  3254,  1958,  2041,  4454,   454,    18,   258,   457,
    2207,  2597,  4541,   451,  4543,   453,   266,   455,  4547,  4787,
    4549,  2218,    52,   227,   454,    36,   454,   457,  2041,   457,
     454,   329,  2651,   457,  2231,   454,   309,   453,   457,   455,
     313,  1956,  2239,  4656,   265,   454,   454,   454,   457,   457,
     457,   399,   208,     9,  3849,  2868,  3429,   453,  2094,  3854,
     111,  2185,  4632,   453,  2110,  3860,   339,   260,   227,  3212,
    3213,  3214,  3215,   137,   327,  3218,  3219,  3220,  3221,  3222,
    3223,  3224,  3225,  3226,  3227,   149,   454,  4657,  3168,   457,
     154,   454,   457,   454,   457,   368,   457,   370,  3415,  2385,
    2386,  2387,  3245,   154,  3984,  3357,   418,  4328,   420,   454,
    2076,  2077,   457,  3434,  3435,  2239,   453,  2731,  2732,  2085,
      52,  2087,  3176,   327,   411,  2091,   454,  3095,  3096,   457,
     454,  3274,  3275,   457,   198,  3001,   451,   188,   453,  4421,
      42,   391,  2761,   305,   454,   418,   409,   457,   369,  3466,
     371,   436,   204,   454,   218,   227,   457,  2194,  4926,   454,
     381,   455,   457,   454,   368,  2202,   457,  2204,   327,   260,
     332,   392,   137,   454,   395,   454,   457,   454,   457,   454,
     457,   262,   457,  4632,   149,   454,  2761,   454,   457,   154,
     457,   395,   263,   244,   258,   246,  3461,  3653,  3463,   376,
     263,   451,   266,   365,   454,   455,   154,   454,  4657,   368,
     457,  2257,   260,   436,   418,     8,   420,   227,    11,  2265,
     263,    42,    15,    16,    17,  2765,   436,  2273,   454,  2275,
     204,   457,   454,   198,  2200,   457,   395,   158,   454,    32,
    4360,   457,  2782,   405,   418,   454,   420,   409,   457,   453,
     453,   446,   455,   218,  4867,   327,   418,  3378,  3379,   418,
    2457,   420,   454,   457,  1779,   457,    54,  1782,   454,   454,
    2884,   457,   457,  4843,   453,  2321,  3207,   439,  2475,   454,
    2894,   369,   457,   371,   247,   248,  2483,  4900,   454,  3172,
    2256,   453,    52,   258,   453,   369,   368,   371,  2264,    87,
    2266,   266,   454,  2487,   454,  2351,  2272,   457,   159,  2493,
    3241,  3639,  3656,  2359,  2343,  2343,   200,   327,   454,  4114,
     453,   457,   454,   395,   418,   457,   420,   391,   454,   117,
    4784,   457,   454,  2308,   454,   457,  2876,   457,  2878,  3026,
     454,   339,   455,   457,  2381,  2382,   418,  3177,   420,   454,
     454,  2388,   457,   457,   422,  3286,  4969,   145,   368,   440,
     441,   442,   309,   444,   445,   446,   447,   448,   449,   332,
     454,   453,   456,  2597,   227,  2421,   454,    22,  2344,   457,
     767,   453,   769,    28,  3003,   395,  3005,   454,   454,   456,
     178,   457,  3359,   454,  4843,   454,   457,   454,   457,  2939,
     457,   454,   365,  3017,   457,  3019,  4286,   181,   418,   202,
     420,   142,   454,   454,  2451,   457,   457,   455,   454,     8,
    3407,   457,    11,    68,  2964,   213,   391,  3838,  3003,  3840,
    3005,     8,  3152,   332,  2400,   453,  2402,  3580,    15,    16,
      17,   454,   405,   453,   457,  2669,  3704,  3705,  3706,   454,
    2634,    40,   457,   142,  3073,   418,  2371,    46,   246,   454,
     454,  3322,   457,   457,   260,   181,   365,   137,  2541,   262,
     454,   309,   181,   457,   327,   120,   439,   454,  2393,   149,
     457,    70,   127,   142,   154,   130,   274,   275,   454,   260,
     453,   457,   454,  2408,   142,   457,  2411,  2412,  3073,   260,
     154,  2416,  2417,  2687,   454,   309,   405,   457,  2423,   142,
     155,   216,  2585,  2541,  4394,   368,  3056,   454,  2715,   418,
     457,   309,  3309,   454,   454,   313,   457,   457,   198,   317,
    3312,  3313,  3314,   227,   454,    48,   324,   457,  2504,   111,
     439,   186,   395,   331,   399,   260,   135,  3087,   218,   454,
    4835,   339,   457,  3167,   453,   232,   454,  2585,   453,   457,
     255,  2758,   381,   351,  3937,   418,   454,   420,   411,   457,
    2485,   359,     8,   454,  2602,    11,   457,    90,   329,    15,
      16,    17,   208,   154,  2628,  2629,  2630,   176,   258,   454,
    2618,   454,   181,   453,   457,    64,   266,    35,  3850,   244,
     453,   246,   115,   246,    40,  2651,  2634,   422,   453,   260,
      46,   256,  2649,   454,  2651,   246,   457,  2690,   131,   264,
      42,   454,   135,  4339,   457,   413,     0,  3879,   217,   274,
      42,   386,   454,   327,    70,   457,  2665,  2665,  2665,  2665,
    2665,  2665,   155,   454,   274,   158,   457,   440,   441,   442,
    3190,   444,   445,   446,   447,   448,   449,     8,   171,  2687,
      11,   154,  2690,   411,    15,    16,    17,   312,   313,  2866,
     248,  3211,   454,   262,   368,   457,   454,   454,   411,   457,
     457,    32,  2879,  3536,    77,   262,   154,   293,   142,    40,
     142,  3557,   142,   286,   339,    46,  3236,   453,   408,   453,
     453,   395,   142,    34,   422,   142,   260,   142,   457,   142,
     142,   142,   142,   260,    88,  2761,   142,   142,  3983,    70,
     154,   391,   142,   260,   418,     8,   420,   142,    11,   142,
    3270,   142,    15,    16,    17,    35,   227,   365,   251,   453,
     176,   216,   260,     5,   154,   181,   259,  4005,  4006,    32,
    4008,   154,  3667,   453,   332,   344,     5,   402,   154,   453,
     453,  2958,   453,   137,     5,   453,  2990,   453,   453,   453,
     453,   453,     5,  2997,   453,   149,     5,   453,   453,  3787,
     154,   217,   453,   296,   453,   159,   453,   365,   453,   453,
     164,     5,   453,   167,   419,   453,   170,   453,   453,   271,
     453,   453,  2848,   453,   453,  2771,   453,  2773,  2774,  2775,
     200,   453,   453,  4608,    35,    92,   216,   457,   457,    35,
     154,   154,   339,   376,   198,   176,   262,   405,   256,   258,
     181,   376,  2747,   327,   455,   376,   327,   376,   327,   218,
     418,   376,   376,  3774,   218,   442,  2892,   376,   437,    81,
     327,   202,   203,   142,   260,   444,   445,   446,   447,   448,
     449,   439,   260,   440,   441,   442,   217,   444,   445,   446,
     447,   448,   449,   331,   213,   453,   454,   368,   456,  3709,
     376,   376,   251,   398,   258,   368,   260,   260,   376,   260,
     256,   453,   266,   174,     8,  2941,   323,    11,   249,    81,
     376,    15,    16,    17,   395,   376,   457,   453,   344,   274,
     181,   262,  2827,     8,  2829,   142,    11,  2963,    32,   202,
      15,    16,    17,   103,  2970,  2971,   399,   418,  2974,   420,
     376,   376,   399,  3130,   376,  2981,    52,    32,  2984,    52,
     264,    41,   316,    41,  2990,   368,   327,   457,  3145,   260,
     202,  2997,  4073,  2990,   260,   376,   422,  3003,  3142,  3005,
    2997,     8,   453,   260,    11,   202,   202,   376,    15,    16,
      17,   376,   376,  3170,   376,   376,    35,   376,   386,   262,
      24,   376,   376,  3020,   260,   142,   246,   109,   453,  3603,
    3604,   365,   453,   344,   418,   142,   410,  3043,   224,  2965,
     256,   437,  3616,   246,   440,   441,   442,   399,   444,   445,
     446,   447,   448,   449,    35,  4158,   246,   391,   154,    35,
     208,   328,    34,  2938,  4167,   374,  3072,  3073,   374,  2944,
     339,   376,   451,   451,  3063,  3063,   453,   453,   376,   376,
     376,   415,   399,   417,   418,   142,   453,   399,   142,   142,
     142,  4379,   142,   255,   376,  3092,  3085,  3085,   250,   414,
     159,   238,   453,   238,    11,   167,   374,  3607,  4333,   457,
     453,   453,   376,   150,   159,   378,   453,   451,   454,   457,
     454,   455,   456,   458,   342,   174,   437,   174,   202,   440,
     441,   442,   198,   444,   445,   446,   447,   448,   449,   457,
     261,  3282,   206,   457,   399,    35,   268,   202,    52,   376,
     454,   376,  3296,   453,  3298,     8,  3152,  3904,    11,   327,
     327,   399,   206,   206,   251,   251,   376,   232,   376,   376,
     453,   411,   329,  4849,  4850,   381,   154,   208,   144,  3875,
    3177,   251,   260,    42,   348,     0,   144,    40,   262,   216,
     246,   216,   216,    46,  3120,   202,  3122,   440,   441,   442,
    3126,   444,   445,   446,   447,   448,   449,   262,   323,   368,
     376,  3086,   260,   259,   309,   457,   376,    70,   260,   175,
     336,   376,   376,   298,    35,   202,   399,   202,   202,  4447,
     399,   202,   202,  3377,   295,   208,   259,   184,  3113,  3114,
    4458,  3116,   442,  3118,  3119,   142,   154,  3280,   442,   154,
    3256,   256,   336,  3410,  3180,   262,  3131,   156,   411,   142,
     142,   246,   453,    35,   246,  3298,   260,   418,   453,   260,
     208,   172,   172,    88,   154,    35,   454,   454,  3462,   451,
     436,   236,   135,   454,  3288,  3289,  3290,  3291,   142,   436,
     330,   454,  3280,   454,  3169,   260,   260,  3797,   208,   260,
     336,   246,   154,  4979,  4980,   181,   181,   181,  3296,   422,
    3298,   457,   457,   457,    23,  4533,   165,   453,  4421,   159,
     235,  3867,   137,   176,   418,   376,   260,   457,   181,    52,
     365,   255,   411,   159,   149,   208,   454,   457,   271,   154,
     381,   159,   454,   454,   159,   454,   454,   279,   454,   164,
     454,   453,   167,   454,   454,   170,   454,   454,  3515,   436,
    3934,  3518,   453,   376,   217,   453,   440,   441,   442,   454,
     444,   445,   446,   447,   448,   449,   270,   415,   226,   397,
      52,   453,   453,   198,   453,   440,   441,   442,   405,   444,
     445,   446,   447,   448,   449,   415,   260,   260,   263,   438,
     260,   184,   142,   218,   192,   251,   422,   376,   442,   262,
     246,  4058,   142,   376,   376,   331,   376,  3917,   142,   264,
    4638,   453,   142,  3997,   453,   331,   216,   184,   331,   144,
     376,   399,   218,   440,   441,   442,   280,   444,   445,   446,
     447,   448,   449,   258,   396,   260,   280,   376,  3948,   376,
     376,   266,   228,   376,   228,   228,  3462,   376,   376,   327,
     327,  3618,   376,   376,   376,  3462,   327,   376,   260,  3969,
    4695,   327,   142,   339,  3400,  3401,  3402,  3403,   376,   246,
    4222,   376,    41,   376,   202,   202,   202,  4229,   202,  3495,
     169,   344,  3498,     3,  3500,   454,  4538,  3494,   386,   376,
    4514,   316,  4241,   454,   457,    42,   311,   102,  4515,   457,
     454,  4337,   453,   259,   454,   260,    35,     8,   142,   376,
      11,  3494,   142,   154,    15,    16,    17,  4027,   169,    62,
     452,   452,   142,   327,   454,  4426,   327,   399,  3544,   336,
     327,   399,   263,   140,  3550,  3551,   457,  3553,   140,   202,
     365,   202,   202,  3559,  4529,  3712,  4531,   133,   159,   451,
      11,   457,   453,   271,   154,  3562,  3563,   454,   454,   454,
     454,   410,   159,   454,  4465,   266,   391,   415,   457,   159,
     261,   167,   453,   452,   437,   457,    79,   316,   439,   154,
     386,   444,   445,   446,   447,   448,   449,    35,   399,   454,
     415,   399,   417,   418,   454,   208,     8,   454,   376,    11,
     453,   192,    52,   368,   142,   386,  4116,   376,   453,   331,
     376,   327,   376,   376,  4705,  4706,   376,   327,   442,   454,
     454,   454,   309,   453,   418,    52,   451,   368,    40,   454,
     455,   456,   154,   144,    46,    70,  3652,   142,   102,   386,
     454,   202,  3578,   202,   202,  4697,   202,   418,   453,  3648,
    3648,   206,  4162,   187,   294,   154,    35,    75,    70,   454,
     422,  4896,  4358,   453,   453,   457,   457,   376,   368,   457,
     457,   386,   452,  3867,   453,   164,   102,   453,   336,  3833,
     454,   159,   454,  3837,   202,   202,   202,   202,   159,  4441,
      52,   303,   453,    22,   271,    24,   454,  4253,   457,    28,
     454,   202,  3709,  4287,    33,    34,    35,   453,    37,   416,
    3726,    40,    41,  3729,    43,  3731,    45,   416,   454,   454,
     205,   453,  4813,   135,  4959,   269,   205,     8,  4629,   367,
      11,   267,   453,    52,   170,   256,   442,   454,  4538,   386,
    4641,  4297,   454,  4978,   376,  4646,   454,  4648,   159,   418,
      70,   251,   186,   251,   442,    52,     0,   376,   368,    40,
     457,   262,   457,    64,   176,    46,   142,   376,   376,   181,
     202,   161,   453,   159,   399,   181,   453,   399,    35,   336,
     246,   128,   418,   414,    35,   418,   159,   260,   453,    70,
    3984,   154,   189,   263,   159,   200,   453,  3964,   453,   303,
     404,   352,   454,  3688,   454,   217,   278,   453,   453,  3976,
     205,  3696,  3697,  3698,  3699,   454,   417,    81,   123,   260,
     304,   154,   376,   376,   453,   116,   454,   453,    35,   453,
    4882,   251,   453,   229,   184,  3833,   453,   294,   453,  3837,
     454,    35,   142,   141,    88,   264,  3862,   453,  3864,   324,
     262,   454,  4876,   386,   135,   324,   350,   350,    35,   454,
      52,   190,   191,   192,   193,    52,   195,   454,   197,   453,
     199,   453,   201,   453,  3896,   204,   457,   453,  3877,  3877,
     454,   210,   453,   244,   213,   368,   399,   368,   217,   260,
     219,   368,   454,   137,     5,   176,    22,    64,   148,   263,
     181,   294,    28,    64,   123,   149,  4060,   403,   418,   418,
     154,   303,  4422,   404,   453,   159,   453,   457,    35,   159,
     164,   368,   339,   167,   301,   415,   170,   154,   251,   128,
     186,    35,   344,   260,   260,   336,   217,    35,  3945,   440,
     441,   442,    68,   444,   445,   446,   447,   448,   449,  4538,
    4460,   453,   263,   263,   198,   161,   453,   161,    52,   454,
    3967,  3968,  3945,   323,   114,  3972,  3973,   453,  3984,   397,
       5,   453,   323,   453,   218,  4142,   310,  3984,   454,    21,
     454,   262,    32,   141,   159,   376,   294,   418,   453,   457,
     457,   117,   350,   350,   120,   418,   161,   453,   161,  1483,
     827,   127,  2306,  4513,   130,  1260,  2165,  4517,  4518,  4025,
    4026,  4668,   764,   860,   258,   867,   260,  2651,  4034,  2818,
    4036,  4037,   266,   866,  4040,   437,  3461,  2235,  2988,   155,
    3915,  3559,   444,   445,   446,   447,   448,   449,  4551,  4695,
    4882,  4375,  3601,  4379,  4357,  2738,  4051,  4252,  4202,  2439,
    4791,  4873,  4723,  4207,  4722,  4822,  2742,  3649,  4212,  4253,
     186,  4215,  4216,   344,  3949,  3950,  3634,  3593,  4084,  2296,
    2296,  4007,   316,  3456,  2843,  1554,  3617,  2290,  3042,  4246,
    4884,  4248,  4978,  4076,  4959,  4239,  4022,  4352,  2996,  2992,
    4089,  4089,  4286,  4833,  1543,  4299,  4683,  4113,  4252,  4609,
    4801,  4302,    27,  4297,  1106,  4487,  3712,  1117,  4697,  4665,
    2015,  3656,  2713,  4608,   602,  2942,  3983,   631,   244,  1735,
     246,   365,  4848,  4962,   742,  1959,  1734,  4143,  1734,  1958,
     256,  4147,  4148,  1342,  4150,  1680,  3637,  3878,   264,  4783,
    3354,  2666,  4296,  4028,  4029,  1287,  1237,   391,   274,  1999,
    2672,  2677,  4776,  1306,  4090,  3321,   437,  1305,  4650,  3863,
    1998,  3298,  4455,   444,   445,   446,   447,   448,   449,  1308,
    2687,   415,  1313,   417,   418,  3824,  3296,  4632,  3839,  4631,
    3355,  3101,  1612,   309,  4424,  4339,   312,   313,  3249,  4231,
    4780,  4779,  4766,  2669,  2654,  1828,  2602,  2600,  2512,  1831,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   451,    -1,  4207,
     454,   455,   456,   339,  4212,    -1,     8,  4215,    -1,    11,
     549,    -1,    -1,    -1,    -1,    -1,   555,    -1,   557,    -1,
      -1,   560,    -1,   562,    -1,   564,    -1,  4122,  4392,    -1,
    4125,  4126,   571,  4241,    -1,    -1,   575,    -1,    40,    -1,
      -1,    -1,    -1,   582,    46,    -1,  4141,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     8,    -1,    -1,    11,    -1,
    4286,    -1,    15,    16,    17,    -1,   402,   606,    70,  4286,
      -1,    -1,   611,    -1,    -1,  4234,    -1,   616,    -1,    -1,
      -1,   620,    -1,  4882,    -1,    -1,     8,    40,    -1,    11,
    4454,    -1,    -1,    46,    -1,    -1,    -1,    -1,   637,    -1,
      -1,    -1,  4328,    -1,     8,    -1,    -1,    11,  4254,  4255,
    4256,    15,    16,    17,    -1,    -1,    -1,    70,    40,    -1,
      -1,    -1,    -1,    -1,    46,    -1,    -1,    -1,    32,    -1,
      -1,    -1,    -1,   135,    -1,    -1,    40,    -1,    -1,    -1,
      -1,    -1,    46,    -1,    -1,    -1,    -1,   686,    70,    -1,
      -1,    -1,    -1,  4362,  4362,    -1,    -1,    -1,    -1,    -1,
     699,    -1,   701,    -1,    -1,    -1,    70,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   176,    -1,    -1,    -1,    -1,   181,
    4389,  4389,   721,   722,    -1,   724,   725,    -1,    -1,    -1,
     729,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4566,    -1,   743,    -1,    -1,    -1,   747,    -1,
      -1,    -1,  4465,   135,   753,   217,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   176,    -1,    -1,   765,    -1,   181,    -1,
      -1,  4484,    -1,    -1,    -1,    -1,    -1,    -1,   777,    -1,
      -1,    -1,    -1,    -1,  4390,    -1,  4454,    -1,    -1,   202,
     203,    -1,    -1,    -1,   176,    -1,    -1,  4465,    -1,   181,
     262,  4665,    -1,    -1,   217,    -1,    -1,    -1,  4632,    -1,
      -1,    -1,   176,    -1,    -1,    -1,  4484,   181,    -1,    -1,
      -1,   820,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4657,    -1,   217,   249,   836,   202,   203,
      -1,    -1,   841,   842,    -1,    -1,    -1,    -1,    -1,   262,
      -1,    -1,  4538,   217,    -1,    -1,  4542,    -1,    -1,  4414,
      -1,  4538,    -1,    -1,    -1,    -1,  4552,   866,   867,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     262,    -1,   344,    -1,    -1,   249,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   892,    -1,    -1,    -1,    -1,   262,    -1,
      -1,   265,    -1,    -1,   903,    -1,    -1,    -1,   907,    -1,
      -1,    -1,    -1,    -1,  4738,    -1,    -1,    -1,    -1,    -1,
    4589,  4589,    -1,   922,  4530,    -1,  4532,    -1,    -1,    -1,
      -1,   344,    -1,    -1,  4489,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   942,    -1,    -1,    -1,  4784,    -1,    -1,
     949,   950,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   344,    -1,    -1,    -1,    -1,   966,   967,   968,
      -1,   970,  4796,   972,    -1,   437,    -1,    -1,    -1,  4534,
     344,    -1,   444,   445,   446,   447,   448,   449,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4697,    -1,    -1,    -1,  4701,    -1,  4703,    -1,  4843,
      -1,  4707,  4708,    -1,   437,  4849,  4850,   440,   441,   442,
      -1,   444,   445,   446,   447,   448,   449,    -1,    -1,    -1,
    1039,    -1,  1041,  1042,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   437,    -1,  4663,    -1,    25,
      -1,    -1,   444,   445,   446,   447,   448,   449,    -1,    -1,
    1069,    -1,    -1,   437,    -1,    -1,   440,   441,   442,    -1,
     444,   445,   446,   447,   448,   449,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   457,    -1,    -1,    -1,    -1,    -1,    -1,
    1099,  1100,    -1,    -1,    -1,  1104,    72,  1106,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     8,    -1,    -1,    11,
      -1,    -1,    -1,    -1,    -1,    -1,  4732,    -1,  1127,    -1,
      -1,  1130,    -1,    -1,  1133,    -1,    -1,   103,    -1,    -1,
      -1,    -1,    -1,  4967,    -1,    -1,    -1,  1146,    40,    -1,
      -1,    -1,    -1,    -1,    46,  4979,  4980,    -1,    -1,   125,
      -1,    -1,    -1,    -1,    -1,  4834,  4834,    -1,    -1,    -1,
     136,    -1,    -1,    -1,    -1,    -1,  1175,    -1,    70,  4848,
    4848,  4848,  4848,  4848,  4848,     8,    -1,    -1,    11,  4902,
     156,    -1,    15,    16,    17,   161,  4882,    -1,    -1,    -1,
    4806,    -1,    -1,    -1,  1203,  1204,  1205,    -1,  1207,    32,
    4896,    -1,    -1,    -1,    -1,    -1,    -1,    40,    -1,  4896,
      -1,    -1,    -1,    46,    -1,    -1,    -1,    -1,  1227,    -1,
      -1,    -1,    54,  4902,  4902,  4902,  4902,  4902,  4902,    -1,
      -1,    -1,    -1,   209,    -1,    -1,    -1,    70,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   230,    87,  1265,    -1,    -1,  1268,
      -1,  4877,    -1,  4959,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4959,    -1,   176,    -1,    -1,    -1,    -1,   181,
      -1,    -1,  4978,  4962,  4962,  4962,  4962,  4962,  4962,  1298,
      -1,  4978,    -1,  1302,  1303,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4868,  1313,  1314,  1315,    -1,    -1,    -1,
      -1,    -1,    -1,   145,    -1,   217,    -1,   293,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1335,    -1,    -1,    -1,
      -1,    -1,    22,    -1,    -1,    -1,    -1,    -1,    28,    -1,
      -1,    -1,    -1,   176,   320,    -1,   178,    -1,   181,    -1,
      -1,   327,    -1,    -1,    -1,    -1,    -1,   333,    -1,    -1,
     262,  1370,    -1,    -1,    -1,    -1,  1375,    -1,    -1,   202,
     203,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    68,  1388,
    1389,   213,    -1,    -1,   217,    -1,    -1,    -1,  1397,   365,
      -1,  1400,   368,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     386,    -1,    -1,  1422,   246,  1424,   249,    -1,    -1,    -1,
      -1,    -1,    -1,  1432,    -1,    -1,  1435,   117,    -1,   262,
     120,    -1,   265,    -1,    -1,   411,    -1,   127,    -1,    -1,
     130,    -1,   344,   275,    -1,    -1,    -1,    -1,    -1,    -1,
    1459,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1467,  1468,
    1469,  1470,  1471,    -1,    -1,   155,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1482,    -1,    -1,  1485,    -1,    -1,    -1,
      -1,   313,    -1,   315,    -1,   317,    -1,  1496,    -1,  1498,
      -1,    -1,   324,    -1,    -1,    -1,   186,    -1,    -1,   331,
      -1,  1510,  1511,    -1,    -1,    -1,    -1,   339,    -1,    -1,
    1519,   344,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   351,
    1529,    -1,    -1,    -1,    -1,    -1,    -1,   359,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   437,    -1,    -1,    -1,  1548,
      -1,    -1,   444,   445,   446,   447,   448,   449,  1557,  1558,
    1559,  1560,    -1,    -1,   244,    -1,   246,    -1,    -1,    -1,
    1569,    -1,    -1,    -1,    -1,    -1,   256,  1576,    -1,    -1,
    1579,    -1,    -1,    -1,   264,    -1,    -1,    -1,    -1,    -1,
    1589,   413,    -1,    -1,   274,    -1,    -1,  1596,    -1,    -1,
      -1,    -1,  1601,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   437,    -1,    -1,   440,   441,   442,
      -1,   444,   445,   446,   447,   448,   449,    -1,    -1,   309,
      -1,    -1,   312,   313,   457,    -1,    -1,    -1,    -1,  1638,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1648,
      -1,    -1,    -1,  1652,    -1,    -1,  1655,    -1,    -1,   339,
      -1,    -1,    -1,    -1,     3,    -1,  1665,    -1,    -1,     8,
      -1,    -1,    11,    -1,  1673,  1674,    15,    16,    17,  1678,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    32,    -1,    -1,    35,    -1,    -1,    -1,
      -1,    40,    -1,    -1,  1703,    -1,    -1,    46,    -1,    -1,
      -1,  1710,    -1,  1712,    -1,    -1,    -1,  1716,  1717,   201,
    1719,    -1,   402,    -1,    -1,    -1,    -1,  1726,   210,    -1,
      -1,    70,    -1,    -1,  1733,    -1,    -1,   219,    -1,  1738,
    1739,    -1,    -1,  1742,    -1,    -1,    -1,  1746,    -1,  1748,
      -1,    -1,    -1,    -1,  1753,  1754,    -1,    -1,    -1,    -1,
      -1,  1760,  1761,  1762,    -1,    -1,    -1,  1766,  1767,  1768,
    1769,  1770,  1771,  1772,  1773,    -1,  1775,    -1,  1777,  1778,
      -1,    -1,  1781,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1796,  1797,  1798,
    1799,    -1,    -1,    -1,  1803,  1804,    -1,    -1,    -1,  1808,
      -1,    -1,  1811,    -1,    -1,  1814,  1815,  1816,  1817,  1818,
    1819,  1820,  1821,  1822,    -1,  1824,    -1,    -1,    -1,    -1,
      -1,  1830,  1831,    -1,  1833,    -1,    -1,   176,    -1,    -1,
      -1,  1840,   181,    -1,    -1,    -1,    -1,    20,    20,    -1,
      -1,    -1,    25,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   202,   203,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   217,    -1,
      -1,    -1,    -1,    -1,    -1,    58,    58,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    71,    71,
      72,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    81,
     249,    -1,    85,    85,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   262,    -1,    -1,   265,    -1,    -1,    -1,
      -1,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   125,   125,    -1,    -1,    -1,    -1,  1957,    -1,
    1959,    -1,  1961,   136,   136,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   144,    -1,    -1,    -1,    -1,    -1,     8,    -1,
      -1,    11,    -1,   156,   156,    15,    16,    17,   161,   161,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1996,    -1,    -1,
      -1,    -1,    32,    -1,  2003,   344,  2005,    -1,    -1,    -1,
      40,    -1,   184,    -1,    -1,    -1,    46,     8,    -1,    -1,
      11,    -1,    -1,    -1,    15,    16,    17,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2034,    -1,   209,    -1,    -1,
      70,    32,    -1,    -1,  2043,    -1,  2045,    -1,    -1,    40,
      -1,    -1,    -1,    -1,    -1,    46,    -1,   230,   230,    -1,
      -1,    -1,    -1,  2062,    -1,    -1,    -1,   549,    -1,    -1,
      -1,    -1,    -1,   555,    -1,  2074,    -1,  2076,  2077,    70,
      -1,    -1,  2081,    -1,  2083,    -1,  2085,    -1,  2087,   262,
     262,    -1,  2091,    -1,    -1,  2094,    -1,    -1,   437,    -1,
      -1,   440,   441,   442,    -1,   444,   445,   446,   447,   448,
     449,   283,    -1,    -1,    -1,    -1,  2115,    -1,    -1,    -1,
     293,   293,    -1,    -1,    -1,    -1,  2125,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2133,    -1,    -1,    -1,    -1,    -1,
      -1,  2140,    -1,    -1,    -1,    -1,   176,    -1,   320,    -1,
    2149,   181,    -1,   325,   327,   327,    -1,    -1,    -1,    -1,
     333,   333,    -1,   336,   336,    -1,    -1,    -1,    -1,    -1,
    2169,    -1,   202,   203,    -1,  2174,  2175,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2183,   176,    -1,   217,    -1,    -1,
     181,    -1,   365,   365,    -1,    -1,   368,    -1,    -1,   372,
     372,  2200,    -1,    -1,    -1,    -1,   379,   379,    -1,   381,
      -1,   202,   203,   386,   386,    -1,    -1,   699,    -1,   249,
      -1,    -1,    -1,    -1,    -1,    -1,   217,    -1,  2227,    -1,
    2229,  2230,   262,    -1,    -1,   265,    -1,    -1,   411,   411,
      -1,    -1,   724,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2256,   249,    -1,
      -1,   743,    -1,    -1,    -1,  2264,    -1,  2266,    -1,    -1,
      -1,   262,    -1,  2272,   265,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   765,    -1,  2284,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2298,
      -1,    -1,  2301,    -1,  2303,    -1,    -1,  2306,    -1,    -1,
    2309,    -1,    -1,    -1,   344,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     8,    -1,    -1,    11,    -1,    -1,
      -1,    15,    16,    17,    -1,    -1,  2335,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2344,  2345,    -1,    32,    -1,
      -1,    -1,    -1,   344,   836,    -1,    40,    -1,    -1,    -1,
      -1,    -1,    46,    -1,    -1,    -1,    -1,    -1,    -1,  2368,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2383,    -1,    70,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2398,
      -1,  2400,  2401,  2402,  2403,    -1,    -1,   437,    -1,    -1,
     440,   441,   442,    -1,   444,   445,   446,   447,   448,   449,
      -1,    -1,    -1,    -1,   454,    -1,    -1,  2426,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2439,    -1,    -1,    -1,    -1,    -1,   437,    -1,    -1,   440,
     441,   442,    -1,   444,   445,   446,   447,   448,   449,    -1,
     942,    -1,    -1,   454,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2477,    -1,
      -1,    -1,    -1,    -1,   966,   967,   968,    -1,  2487,    -1,
      -1,    35,   176,    -1,  2493,    -1,    -1,   181,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2504,    -1,    -1,    -1,    -1,
      54,    -1,  2511,    -1,    -1,    -1,    -1,  2516,   202,   203,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   217,    -1,    -1,    -1,    -1,    -1,    -1,
    2539,  2540,  2541,    87,    35,  2544,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2552,  2553,  2554,  2555,    -1,    -1,    -1,
      -1,    -1,    -1,    54,    -1,   249,  2565,    -1,    -1,  2568,
      -1,  2570,    -1,    -1,    -1,    -1,    -1,    -1,   262,    -1,
      -1,   265,  2581,  2582,    -1,    -1,  2585,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    87,    -1,  2597,    -1,
    2599,   145,  2601,    -1,  2603,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1104,    -1,  2623,    -1,    -1,    -1,  2627,    -1,
      -1,    -1,    -1,    -1,   178,  2634,    -1,  2636,  2637,  2638,
      -1,    -1,    -1,    -1,     8,    -1,    -1,    11,  1130,    -1,
      -1,    15,    16,    17,   145,  2654,    -1,    -1,    -1,    -1,
     344,    -1,    -1,    -1,   208,    -1,    -1,  2666,    32,   213,
      -1,    -1,  2671,    -1,    -1,    -1,    40,     8,  2677,    -1,
      11,    35,    46,    -1,    15,    16,    17,   178,  2687,    -1,
      -1,  2690,    -1,    -1,  2693,    -1,  2695,    -1,    -1,    -1,
      54,    32,   246,    -1,    -1,    -1,    70,    -1,    -1,    40,
      -1,    -1,    -1,    -1,    -1,    46,    -1,   208,    -1,    -1,
      -1,    -1,   213,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   275,    -1,    87,    -1,    -1,    -1,    -1,  2737,    70,
    2739,    -1,    -1,    -1,    -1,  2744,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   437,    -1,   246,   440,   441,   442,    -1,
     444,   445,   446,   447,   448,   449,    -1,    -1,    -1,   313,
     454,    -1,  2771,   317,  2773,  2774,  2775,    -1,    -1,    -1,
     324,    -1,    -1,  1265,   275,    -1,    -1,   331,    -1,    -1,
      -1,   145,    -1,    -1,    -1,   339,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   351,    -1,    -1,
      -1,    -1,   176,    -1,    -1,   359,    -1,   181,    -1,    -1,
      -1,    -1,   313,   154,   178,    -1,   317,    -1,   159,    -1,
      -1,    -1,  1314,   324,    -1,   379,    -1,    -1,   202,   203,
     331,    -1,    -1,    -1,    -1,   176,    -1,    -1,   339,    -1,
     181,    -1,    -1,   217,   208,    -1,    -1,    -1,    -1,   213,
     351,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   359,   413,
      -1,   202,   203,   417,   418,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2882,    -1,   249,   217,    -1,   379,    -1,
      -1,    -1,   246,    -1,    -1,    -1,    -1,    -1,   262,    -1,
      -1,   265,    -1,    -1,    -1,    -1,  1388,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1397,    -1,    -1,   249,    -1,
      -1,   275,   413,    -1,    -1,    -1,   417,    -1,    -1,    -1,
       8,   262,    -1,    11,   265,    -1,    -1,    15,    16,    17,
      -1,    -1,  1424,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1432,    -1,    -1,  1435,    32,    -1,    -1,    -1,    -1,   313,
      -1,    -1,    40,   317,    -1,    -1,  2965,    -1,    46,    -1,
     324,    -1,    -1,  2972,  2973,    -1,    -1,   331,    -1,    -1,
     344,    -1,    -1,    -1,    -1,   339,    -1,    -1,    -1,  1471,
      -1,    -1,    70,    -1,    -1,    -1,    -1,   351,    -1,    -1,
      -1,    -1,    -1,  1485,    -1,   359,    -1,    -1,    -1,    -1,
    3009,  3010,    -1,   344,    -1,    -1,  1498,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   379,  3025,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3040,  3041,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3049,  3050,  3051,    -1,    -1,    -1,    -1,    -1,    -1,   413,
      -1,    -1,    -1,   417,    -1,    -1,  1548,    -1,  3067,    -1,
      -1,    -1,    -1,   437,    -1,    -1,   440,   441,   442,    -1,
     444,   445,   446,   447,   448,   449,    -1,  1569,    -1,    -1,
     454,    -1,    -1,    -1,  1576,    -1,    -1,    -1,   176,    -1,
      -1,    -1,    -1,   181,    -1,    -1,   437,    -1,    -1,   440,
     441,   442,    -1,   444,   445,   446,   447,   448,   449,    -1,
      -1,  3120,    -1,  3122,   202,   203,    -1,  3126,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   217,
      -1,    -1,    -1,  3142,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3152,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3168,
      -1,   249,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3180,    -1,    -1,   262,    -1,    -1,   265,  3187,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1678,  3196,    -1,    -1,
      -1,    -1,    -1,  3202,    -1,  3204,    -1,    -1,  3207,    -1,
      -1,    -1,    -1,  3212,  3213,  3214,  3215,    -1,    -1,  3218,
    3219,  3220,  3221,  3222,  3223,  3224,  3225,  3226,  3227,    -1,
      -1,    -1,  3231,  3232,  1716,  1717,    -1,    -1,    -1,    -1,
      -1,    -1,  3241,    -1,    -1,    -1,  3245,    -1,    -1,    -1,
    3249,  1733,    -1,    -1,    -1,    -1,    -1,    -1,  3257,    -1,
      -1,  3260,    -1,  3262,    -1,    -1,   344,    22,    -1,    -1,
      -1,    -1,  3271,    28,    -1,  3274,  3275,    -1,    -1,    -1,
    3279,  3280,    -1,    -1,    -1,  3284,    -1,  3286,    -1,    -1,
      -1,    -1,    -1,    -1,  3293,  3294,  3295,  3296,    53,  3298,
    3299,    -1,    -1,    -1,  3303,  3304,    -1,    -1,    -1,    -1,
      -1,  3310,    -1,    68,    -1,    -1,    -1,  3316,  3317,  3318,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    -1,
      -1,    -1,    -1,    -1,    28,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3343,    -1,   101,    -1,  1830,    -1,
      -1,    -1,    -1,    -1,    -1,  3354,    -1,  3356,  1840,   437,
      -1,    -1,   440,   441,   442,   120,   444,   445,   446,   447,
     448,   449,   127,    -1,    68,   130,   454,    -1,  3377,  3378,
    3379,    -1,  3381,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     155,  3400,  3401,  3402,  3403,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    13,    -1,    -1,    -1,    -1,    -1,    19,
      -1,    -1,    -1,    -1,    -1,    -1,   120,    -1,   183,    29,
    3429,   186,    -1,   127,    -1,    -1,   130,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3443,    -1,    -1,    -1,    48,    49,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   155,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1957,   231,  1959,    -1,   234,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   244,
      -1,   246,   186,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   256,    -1,     8,    -1,    -1,    11,    -1,    -1,   264,
      15,    16,    17,    -1,  1996,    -1,    -1,    -1,   273,   274,
      -1,    -1,    -1,     8,    -1,    -1,    11,    32,    -1,    -1,
      15,    16,    17,    -1,  3533,    40,    -1,    -1,    -1,    -1,
      -1,    46,    -1,    -1,    -1,    -1,    -1,    32,    -1,    -1,
     244,    -1,   246,    -1,   309,    40,    -1,   312,   313,   314,
      -1,    46,   256,    -1,    -1,    70,    -1,    -1,    -1,    -1,
     264,    -1,    -1,    -1,    -1,    -1,    -1,  3576,    -1,  3578,
     274,  3580,    -1,    -1,   339,    70,    -1,  3586,    -1,    -1,
      -1,    -1,    -1,  3592,    -1,    -1,    -1,   197,   353,    -1,
      -1,    -1,  3601,    -1,    -1,   205,    -1,    -1,   208,   209,
      -1,   211,    -1,    -1,   214,   309,   216,    -1,   312,   313,
      -1,    -1,  3621,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3631,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3639,    -1,    -1,    -1,    -1,   339,    -1,   402,    -1,    -1,
    3649,    -1,    -1,    -1,  3653,    -1,    -1,    -1,  3657,  3658,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2149,    -1,    -1,
      -1,   176,    -1,    -1,    -1,    -1,   181,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2169,    -1,    -1,
      -1,   176,  3691,    -1,  3693,    -1,   181,   202,   203,    -1,
      -1,    -1,    -1,    -1,  3703,    -1,    -1,    -1,   402,    -1,
      -1,    -1,   217,    -1,    -1,    -1,    -1,   202,   203,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   217,    -1,  3733,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   249,  3744,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   262,    -1,    -1,
     265,    -1,    22,    -1,   249,    -1,    -1,    -1,    28,    -1,
      -1,    -1,    -1,    -1,    -1,  3774,    -1,   262,    -1,    -1,
     265,    -1,    -1,    -1,    -1,  3784,  3785,    -1,    -1,    -1,
      -1,    -1,  3791,  3792,    -1,    -1,    -1,  3796,    -1,    -1,
      -1,    -1,  3801,    -1,    -1,  3804,  3805,    -1,    68,    -1,
    3809,  3810,    -1,    -1,    -1,    -1,  3815,  3816,  3817,  3818,
    3819,  2303,    -1,    -1,  3823,  3824,    -1,  3826,    -1,    -1,
    3829,    -1,    -1,    -1,  3833,    -1,    -1,    -1,  3837,   344,
      -1,    -1,    -1,    -1,  3843,     8,    -1,    -1,    11,    -1,
    3849,    -1,    15,    16,    17,  3854,    -1,    -1,    -1,   344,
     120,  3860,    -1,    -1,    -1,    -1,    -1,   127,  3867,    32,
     130,    -1,    -1,    -1,    -1,    -1,  3875,    40,    -1,  3878,
      -1,    -1,    -1,    46,  3883,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   155,    -1,  3896,    -1,    -1,
    3899,    -1,    -1,    -1,    -1,    -1,    -1,    70,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3919,  3920,    -1,    -1,    -1,    -1,   186,    -1,    -1,    -1,
      -1,    -1,   437,    -1,    -1,   440,   441,   442,  3937,   444,
     445,   446,   447,   448,   449,    -1,    -1,  3946,    -1,   454,
      -1,    -1,   437,    -1,    -1,   440,   441,   442,   558,   444,
     445,   446,   447,   448,   449,    -1,   566,    -1,    -1,   454,
      -1,    -1,    -1,   573,    -1,    -1,   576,   577,    -1,    -1,
      -1,   581,    -1,    -1,   244,    -1,   246,    -1,  3987,    -1,
      -1,    -1,   592,    -1,    -1,  2477,   256,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   264,    -1,    -1,   607,  4007,    -1,
      -1,    -1,    -1,   176,   274,    -1,    -1,    -1,   181,    -1,
      -1,    -1,   622,  4022,   624,    -1,    -1,   627,    -1,   629,
      -1,    -1,   632,    -1,    -1,    -1,    -1,    -1,    -1,   202,
     203,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   309,
    4049,    -1,   312,   313,   217,    -1,    -1,    -1,    -1,    -1,
      -1,  4060,    -1,    -1,    -1,    22,  4065,    -1,    -1,    -1,
      -1,    28,    -1,    -1,  4073,    -1,    -1,    -1,    -1,   339,
      -1,    -1,    -1,    -1,    -1,    -1,   249,    -1,    -1,    -1,
      -1,  4090,  4091,    -1,    -1,    -1,    -1,    -1,    -1,   262,
     700,    -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    68,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4119,    -1,   612,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   402,   633,    -1,  2627,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   755,    -1,    -1,    -1,  4158,
      -1,    -1,    -1,   120,    -1,    -1,    -1,    -1,  4167,     8,
     127,    -1,    11,   130,    -1,    -1,    15,    16,    17,    -1,
      -1,   344,    -1,    -1,    -1,  4184,  4185,    -1,    -1,  4188,
      -1,    -1,    -1,    32,    -1,    -1,    -1,    -1,   155,    -1,
      -1,    40,    -1,  4202,  4203,    -1,    -1,    46,  4207,    -1,
      -1,    -1,    -1,  4212,    -1,   815,  4215,  4216,    -1,  4218,
      -1,  4220,    -1,    -1,  4223,  4224,    -1,    -1,    -1,   186,
      -1,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4239,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4252,  4253,  4254,  4255,  4256,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   437,    -1,    -1,   440,   441,   442,
     880,   444,   445,   446,   447,   448,   449,   244,    -1,   246,
      -1,   454,    -1,    -1,    -1,    -1,   896,  4296,  4297,   256,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   264,   908,    -1,
     910,    -1,    -1,    -1,    -1,    -1,    -1,   274,   918,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     930,    -1,    -1,    -1,    -1,   935,    -1,   176,   938,    -1,
    4339,    -1,   181,  4342,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   309,  4352,    -1,   312,   313,    -1,    -1,  4358,
      -1,  4360,    -1,   202,   203,    -1,    -1,  4366,    -1,    -1,
      -1,    -1,    -1,   973,    -1,    -1,    -1,    -1,   217,    -1,
    4379,    -1,   339,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4390,  4391,  4392,    -1,    -1,    -1,    -1,    -1,    -1,
    2882,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   899,
     249,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4421,   262,    -1,  4424,   265,  4426,    -1,   919,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   933,    -1,   402,    -1,    -1,    -1,    -1,
      -1,  4450,    -1,    -1,    -1,  4454,    -1,    -1,    -1,  4458,
      -1,    -1,    -1,    -1,    -1,    -1,  4465,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4474,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4484,     8,    -1,    -1,    11,
      -1,    -1,    -1,    15,    16,    17,    -1,    -1,    -1,    -1,
    4499,    -1,    -1,    -1,     8,   344,    -1,    11,  1108,    -1,
      32,    15,    16,    17,    -1,    -1,    -1,    -1,    40,    -1,
    1010,    -1,    -1,  4522,    46,    -1,    -1,  3009,  3010,    -1,
    4529,  4530,  4531,  4532,    -1,    -1,    40,    -1,    -1,    -1,
      -1,    -1,    46,  3025,    -1,    -1,    -1,    -1,    70,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3041,
      -1,    -1,    -1,    -1,    -1,    -1,    70,  4566,  3050,  3051,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4582,    -1,  3067,    -1,    -1,  4587,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   437,    -1,
      -1,   440,   441,   442,    -1,   444,   445,   446,   447,   448,
     449,    -1,    -1,    -1,    -1,   454,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1114,    -1,    -1,    -1,    -1,    -1,
    4629,    -1,    -1,  4632,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4641,    -1,    -1,    -1,    -1,  4646,    -1,  4648,
      -1,  4650,    -1,    -1,   176,    -1,    -1,    -1,  4657,   181,
      -1,    -1,    -1,    -1,  4663,    -1,  4665,    -1,    -1,    -1,
      -1,    -1,   176,    -1,    -1,  4674,    -1,   181,    -1,    -1,
     202,   203,    -1,    -1,    -1,    -1,  3168,  1287,  1288,    -1,
      -1,    -1,    -1,    -1,     8,   217,    -1,    11,   202,   203,
      -1,    15,    16,    17,    -1,    -1,  4705,  4706,    -1,    -1,
      -1,    -1,     8,   217,    -1,    11,    -1,    -1,    32,    15,
      16,    17,    -1,    -1,    -1,    -1,    40,   249,    -1,    -1,
      -1,    -1,    46,  4732,    -1,    -1,    32,    -1,    -1,  4738,
     262,    -1,    -1,   265,    40,   249,    -1,    -1,    -1,    -1,
      46,    -1,    -1,    -1,    -1,    -1,    70,    -1,   262,  1359,
      -1,    -1,    -1,    -1,  1254,    -1,  4765,  4766,    -1,    -1,
      -1,  4770,    -1,    -1,    70,    -1,    -1,  4776,    -1,    -1,
    4779,    -1,    -1,    -1,  4783,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4796,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4806,    -1,    -1,
      -1,  3293,  3294,  3295,  4813,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   344,  1423,    -1,    -1,    -1,    -1,  1318,    -1,
      -1,    -1,    -1,    -1,     8,    -1,  4835,    11,    -1,    -1,
     344,    15,    16,    17,  4843,    -1,    -1,    -1,    -1,    -1,
    4849,  4850,  4851,    -1,    -1,    -1,    -1,    -1,    32,    -1,
      -1,    -1,   176,    -1,    -1,    -1,    40,   181,    -1,    -1,
      -1,  4870,    46,    -1,    -1,    -1,    -1,    -1,  4877,    -1,
     176,    -1,    -1,    -1,    -1,   181,    -1,    -1,   202,   203,
      -1,    -1,    -1,  1383,    -1,    -1,    70,    -1,    -1,    -1,
      -1,    -1,    -1,   217,    -1,    -1,   202,   203,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   437,    -1,    -1,   440,   441,
     442,   217,   444,   445,   446,   447,   448,   449,    -1,    -1,
    1420,    -1,   454,   437,    -1,   249,   440,   441,   442,  1539,
     444,   445,   446,   447,   448,   449,    -1,    -1,   262,    -1,
      -1,   265,    -1,   249,  4953,  4954,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   262,    -1,  4967,   265,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4979,  4980,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    -1,    -1,    -1,    -1,    -1,    28,    -1,
      -1,    -1,   176,    -1,    -1,    -1,    -1,   181,    -1,    -1,
      -1,  1501,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1516,    -1,   202,   203,
     344,    -1,    -1,    -1,  1524,    -1,    -1,  1637,    68,    -1,
      -1,    -1,    -1,   217,    -1,  1535,    -1,    -1,   344,    -1,
      -1,  1651,    -1,    -1,  1654,    -1,  1656,    -1,  1658,    -1,
      -1,    -1,    -1,    -1,  1664,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   249,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   262,    -1,
     120,   265,  1582,    -1,  3576,    -1,    -1,   127,    -1,    -1,
     130,    25,    -1,    -1,  3586,  1595,    -1,    -1,    -1,  1709,
      -1,    -1,    -1,  1713,    -1,  1715,    -1,  1607,  1718,    -1,
      -1,    -1,    -1,   437,    -1,   155,   440,   441,   442,  1619,
     444,   445,   446,   447,   448,   449,    -1,    -1,    -1,  3621,
     454,   437,    -1,    -1,   440,   441,   442,    71,   444,   445,
     446,   447,   448,   449,    -1,    -1,   186,    -1,   454,    -1,
      -1,    85,    -1,    -1,    -1,    -1,    -1,  3649,    -1,    -1,
     344,    -1,    -1,  1663,    -1,    -1,  1666,    -1,    -1,   103,
      -1,    -1,    -1,    -1,    -1,   109,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   125,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   136,    -1,   244,    -1,   246,    -1,    -1,    -1,
     144,  3703,    -1,    -1,    -1,    -1,   256,    -1,    -1,    -1,
      -1,    -1,   156,    -1,   264,    -1,    -1,   161,    -1,    -1,
      -1,    -1,    -1,   167,   274,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     184,    -1,    -1,   437,    -1,    -1,   440,   441,   442,    -1,
     444,   445,   446,   447,   448,   449,    -1,    -1,    -1,   309,
     454,    -1,   312,   313,    -1,   209,     8,    -1,    -1,    11,
      -1,    -1,    -1,    15,    16,    17,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1795,   230,    -1,    -1,   339,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    -1,
       8,    -1,    -1,    11,    46,    -1,    -1,    15,    16,    17,
      -1,    -1,    -1,    -1,  3816,  3817,  3818,  3819,   262,    -1,
      -1,    -1,    -1,    -1,    32,    -1,    -1,    -1,    70,    -1,
      -1,    -1,    40,    -1,    -1,    -1,    -1,    -1,    46,   283,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   293,
      -1,    -1,   402,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   320,    -1,    -1,    -1,
      -1,   325,    -1,   327,    -1,    -1,    -1,    -1,    -1,   333,
      -1,    -1,   336,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2025,  2026,    -1,    -1,    -1,
    2030,  2031,    -1,    -1,    -1,  2035,    -1,    -1,    -1,    -1,
     364,   365,    -1,    -1,   368,    -1,    -1,    -1,   372,  2049,
      -1,    -1,    -1,    -1,   176,    -1,  2056,   381,    -1,   181,
    2060,  2061,   386,    -1,  2064,  2065,    -1,    -1,    -1,    -1,
      -1,  2071,    -1,    -1,   398,    -1,    -1,    -1,    -1,    -1,
     202,   203,    -1,    -1,  2084,    -1,  2086,   411,   176,    -1,
      -1,    -1,    -1,   181,    -1,   217,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2105,    -1,    -1,    -1,    -1,
    2110,    -1,    -1,    -1,   202,   203,    -1,    -1,     0,    -1,
    2010,    -1,    -1,  2123,  2014,  2015,    -1,   249,    -1,   217,
      -1,    -1,  2132,    -1,  2134,    -1,    18,  2137,  2138,  2139,
     262,    -1,    -1,   265,  2144,  2145,    28,    -1,    30,    31,
      -1,    -1,    -1,    -1,  2154,    -1,    -1,    -1,    -1,  2159,
      -1,   249,    -1,    45,  2164,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   262,    -1,    -1,   265,    -1,    -1,
      -1,    -1,    -1,    65,    -1,    67,    68,    -1,  2078,    -1,
    2190,    73,    -1,    75,    -1,    -1,    -1,    -1,    -1,    -1,
    2090,  2201,    -1,  2203,    86,    -1,    88,    -1,  2208,    -1,
      -1,    -1,  2212,    -1,  2214,  2215,  2216,  2217,    -1,  2219,
      -1,    -1,   344,   105,    -1,    -1,   108,    -1,    -1,    -1,
      -1,    -1,  2232,  2233,  2234,    -1,    -1,  4119,    -1,   121,
    2130,   123,  2242,  2243,    -1,   127,     8,    -1,    -1,    11,
      -1,   133,    -1,    15,    16,    17,   344,    -1,    -1,   141,
      -1,   143,    -1,    -1,    -1,    -1,    -1,   149,    -1,    -1,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    -1,
      -1,    -1,   164,    -1,    46,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2294,    -1,    -1,    -1,   180,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    70,    -1,
      -1,    -1,    -1,    -1,    -1,   437,    -1,    -1,   440,   441,
     442,    -1,   444,   445,   446,   447,   448,   449,    -1,    -1,
      -1,    -1,   454,    -1,    -1,    -1,    -1,   219,   220,    -1,
      -1,    -1,    -1,   225,    -1,    -1,    -1,    -1,    -1,   437,
      -1,    -1,   440,   441,   442,   237,   444,   445,   446,   447,
     448,   449,    -1,    -1,   452,    -1,   248,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    -1,    -1,    -1,    -1,    -1,    28,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2285,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   288,    -1,    -1,    -1,
      -1,    -1,    -1,     8,   176,    -1,    11,    -1,   300,   181,
      15,    16,    17,   305,   306,    -1,   308,    68,    -1,    -1,
      -1,   313,    -1,    -1,    -1,    -1,   318,    32,    -1,   321,
     202,   203,    -1,    -1,   326,    40,    -1,  2447,    -1,   331,
     332,    46,    -1,    -1,    -1,   217,    -1,   339,    -1,    -1,
    4342,   343,    -1,    -1,    -1,  2355,    -1,    -1,    -1,    -1,
      -1,   353,    -1,    -1,    -1,    70,  4358,    -1,  2478,   120,
      -1,    -1,    -1,   365,    -1,    -1,   127,   249,    -1,   130,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     262,    -1,   384,   265,    -1,    -1,    -1,    -1,    -1,  4391,
      -1,    -1,   394,    -1,   155,    -1,    -1,    -1,   400,    -1,
      -1,    -1,    -1,   405,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   418,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   186,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   439,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   453,    -1,    -1,   456,    -1,    -1,    -1,    -1,    -1,
      -1,   176,   344,  2473,    -1,    -1,   181,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2490,    -1,    -1,   244,    -1,   246,    -1,   202,   203,    -1,
      -1,  2501,    -1,    -1,    -1,   256,    -1,  4499,    -1,    -1,
      -1,    -1,   217,   264,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   274,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   249,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2664,    -1,    -1,   262,   309,    -1,
     265,   312,   313,    -1,    -1,   437,    -1,    -1,   440,   441,
     442,    -1,   444,   445,   446,   447,   448,   449,    -1,    -1,
      -1,    -1,   454,    -1,    -1,    -1,    -1,    -1,   339,    -1,
    4582,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   190,    -1,    -1,    -1,    -1,  2716,  2717,    -1,    -1,
     199,   200,    -1,    -1,    -1,    -1,    -1,    -1,   207,    -1,
      -1,    -1,    -1,    -1,  2734,    -1,    -1,    -1,    -1,   218,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   344,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2759,
      -1,   402,    -1,  2763,    -1,    -1,    -1,    -1,    -1,  2769,
      -1,    -1,    -1,    -1,     8,    -1,    -1,    11,    -1,    -1,
      -1,    15,    16,    17,    -1,  2785,  2786,    -1,    -1,    -1,
    2790,    -1,    -1,    -1,    -1,  2795,  2796,  2797,    32,  2799,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    -1,    -1,    -1,
      -1,    22,    46,  2703,    -1,    -1,  2706,    28,  2708,    -1,
    2820,    -1,    -1,  2713,    -1,    -1,    -1,    -1,    -1,    -1,
    2830,  2831,  2832,  2833,    -1,    -1,    70,    -1,    -1,    -1,
      -1,    -1,   437,    -1,    -1,   440,   441,   442,    -1,   444,
     445,   446,   447,   448,   449,    -1,    -1,    68,    -1,   454,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2867,    -1,    -1,
    2870,  2871,  2872,    -1,    -1,  2765,    -1,    -1,    -1,    -1,
    2880,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2782,    -1,     8,    -1,    -1,    11,    -1,    -1,
      -1,    15,    16,    17,    -1,    -1,    -1,    -1,    -1,   120,
      -1,    -1,    -1,    -1,    -1,    -1,   127,  2807,    32,   130,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    -1,    -1,    -1,
      -1,    -1,    46,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   176,    -1,   155,    -1,    -1,   181,    -1,    -1,
      -1,  2951,    -1,    -1,    -1,    -1,    70,    -1,    -1,  2959,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   202,   203,
      -1,    -1,    -1,    -1,    -1,   186,    -1,    -1,  2978,    -1,
      -1,    -1,    -1,   217,    -1,    -1,  2876,    -1,  2878,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3004,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   249,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   262,    -1,
      -1,   265,    -1,   244,    -1,   246,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   256,    -1,    -1,  3048,  2939,
      -1,    -1,  3052,   264,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   176,   274,    -1,    -1,    -1,   181,    -1,    -1,
      -1,    -1,    -1,    -1,  2964,    -1,    -1,    -1,   557,    -1,
      -1,  3081,    -1,    -1,    -1,    -1,    -1,    -1,   202,   203,
     569,    -1,    -1,    -1,    -1,   574,    -1,    -1,   309,    -1,
    2990,   312,   313,   217,    -1,    -1,   585,  2997,    -1,    -1,
     344,  3111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   601,    -1,    -1,  3125,    -1,   606,   339,  3129,
      -1,    -1,    -1,   612,    -1,   249,    -1,   616,   617,    -1,
    3140,    -1,    -1,    -1,   623,    -1,    -1,    -1,   262,    -1,
      -1,   265,    -1,    -1,   633,   634,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   642,    -1,    -1,  3056,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3074,    -1,    -1,    -1,    -1,    -1,
      -1,   402,    -1,    -1,    -1,    -1,    -1,  3087,    -1,    -1,
      -1,    -1,    -1,   437,    -1,    -1,   440,   441,   442,    -1,
     444,   445,   446,   447,   448,   449,    -1,    -1,    -1,    -1,
     454,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     344,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   721,   722,    -1,    -1,    -1,    -1,   727,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   753,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3190,    -1,    -1,    -1,    -1,     8,    -1,    -1,    11,    -1,
      -1,    -1,    15,    16,    17,    -1,    -1,    -1,    -1,    -1,
      -1,  3211,    -1,   437,    -1,    -1,   440,   441,   442,    32,
     444,   445,   446,   447,   448,   449,    -1,    40,    -1,    -1,
     454,    -1,    -1,    46,    -1,    -1,  3236,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    70,    -1,    -1,
      -1,    -1,    -1,    -1,     8,    -1,    -1,    11,    -1,    -1,
    3270,    15,    16,    17,  3384,    -1,  3386,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3394,    -1,    -1,    -1,    32,    -1,
      -1,    -1,    36,    -1,    -1,    -1,    40,    -1,    -1,    -1,
      -1,  3411,    46,   892,    -1,    -1,    -1,    -1,    -1,    -1,
     899,    -1,    -1,     8,   903,    -1,    11,  3427,    -1,    -1,
      15,    16,    17,    -1,    -1,    -1,    70,    -1,    -1,    -1,
     919,  3441,    -1,    -1,    -1,    -1,    -1,    32,    -1,    -1,
      -1,    -1,    -1,    -1,   933,    40,    -1,    -1,    -1,  3459,
      -1,    46,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3469,
      -1,    -1,  3362,   176,    -1,    -1,    -1,    -1,   181,    -1,
      -1,    -1,    -1,    -1,   118,    70,    -1,    -1,    -1,    -1,
    3490,    -1,    -1,   972,    -1,    -1,    -1,    -1,    -1,   202,
     203,  3501,  3502,  3503,    -1,    -1,  3506,  3507,  3508,  3509,
    3510,  3511,    -1,    -1,   217,    -1,  3516,  3517,    -1,  3519,
    3520,  3521,  3522,  3523,  3524,    -1,  3526,    -1,    -1,    -1,
      -1,  1010,    -1,    -1,    -1,  3535,    -1,  3537,  3538,    -1,
      -1,    -1,   176,    -1,    -1,    -1,   249,   181,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   262,
    3560,    -1,   265,    -1,    -1,    -1,  1045,    -1,   202,   203,
      -1,    -1,  3462,    -1,    -1,    -1,    -1,    -1,    -1,  3579,
      -1,    -1,    -1,   217,    -1,    -1,  1065,    -1,    -1,    -1,
    1069,   176,    -1,    -1,    -1,    -1,   181,    -1,  1077,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   249,    -1,   202,   203,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1105,    -1,   262,    -1,
      -1,   265,   217,    -1,    -1,  1114,    -1,  1116,    -1,    -1,
      -1,   344,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1131,    -1,    -1,  1134,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   249,    -1,    22,  1146,    -1,    -1,
      -1,    -1,    28,    -1,    -1,    -1,  3676,   262,    -1,    -1,
     265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1175,    -1,    -1,    -1,
      -1,    -1,   287,    -1,  3704,  3705,  3706,    -1,    -1,    -1,
     344,    -1,    68,    -1,    -1,    -1,  3716,  3607,    -1,    -1,
      -1,    -1,    -1,    -1,  1203,  1204,  1205,    -1,  1207,    -1,
      -1,    -1,    -1,    -1,   437,    -1,    -1,   440,   441,   442,
      -1,   444,   445,   446,   447,   448,   449,    -1,  1227,    -1,
      -1,   454,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   344,
      -1,    -1,    -1,    -1,   120,   399,  3656,    -1,    -1,    -1,
      -1,   127,  1251,    -1,   130,   360,    -1,    -1,    -1,    -1,
    1259,  1260,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1268,
    1269,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   155,
      -1,    -1,    -1,   437,    -1,    -1,   440,   441,   442,    -1,
     444,   445,   446,   447,   448,   449,    -1,    -1,    -1,  1298,
      -1,    -1,    -1,  1302,  1303,    -1,    -1,    -1,    -1,    -1,
     186,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1318,
      -1,    -1,    -1,    -1,    -1,  1324,    -1,    -1,    -1,    -1,
      -1,    -1,   437,    -1,    -1,   440,   441,   442,    -1,   444,
     445,   446,   447,   448,   449,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   244,    -1,
     246,    -1,    -1,    -1,    -1,    -1,    -1,  3787,    -1,    -1,
     256,    -1,    -1,    -1,  1383,    -1,    -1,  3797,   264,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   274,    -1,
      -1,    -1,    -1,    -1,    -1,  3925,    -1,    -1,    -1,  3929,
    3930,  3931,  3932,    -1,    -1,  3935,    -1,    -1,    -1,    -1,
      -1,  1420,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   309,    -1,    -1,   312,   313,    -1,  3959,
    3960,  3961,    -1,  3963,    -1,  3965,  3966,    -1,    -1,    22,
      -1,    -1,    -1,    -1,    -1,    28,    -1,  3977,  3978,    -1,
      -1,    -1,    -1,   339,    -1,    -1,    -1,     8,    -1,    -1,
      11,    -1,    -1,    -1,    15,    16,    17,    -1,  3998,    -1,
      -1,  1480,    -1,    -1,    -1,  4005,  4006,    -1,  4008,    -1,
      -1,    32,    -1,    -1,    -1,    68,    -1,    -1,    -1,    40,
    4020,    -1,  1501,    -1,    -1,    46,    -1,  3917,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1516,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1524,   402,    -1,    -1,    70,
      -1,  1530,    -1,    -1,    -1,    -1,  1535,    -1,  3948,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   120,    -1,    -1,
      -1,    -1,  1551,    -1,   127,    -1,  1555,   130,    -1,  3969,
    4080,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1567,    -1,
      -1,    -1,    -1,    -1,  3984,    -1,    -1,    -1,    -1,    -1,
      -1,  4101,   155,  1582,    -1,    -1,    -1,    -1,    -1,    -1,
    1589,    -1,    -1,    -1,    -1,    -1,  1595,    -1,    -1,    -1,
      -1,    -1,  1601,    -1,    -1,    -1,    -1,    -1,  1607,    -1,
      -1,  4131,   153,   186,    -1,    -1,    -1,  4027,    -1,    -1,
    1619,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   176,    -1,    -1,    -1,  1638,
     181,  1640,  1641,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1653,    -1,    -1,    -1,    -1,    -1,
      -1,   202,   203,    -1,  1663,    -1,    -1,  1666,    -1,  1668,
    1669,   244,    -1,   246,    -1,    -1,   217,    -1,    -1,    -1,
      -1,  1680,    -1,   256,    -1,  4205,    -1,    -1,    -1,    -1,
      -1,   264,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4220,   274,    -1,    -1,    -1,    -1,  4116,    -1,   249,    -1,
      -1,    -1,    -1,  1712,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   262,    -1,    -1,   265,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   309,    -1,    -1,   312,
     313,    -1,    -1,    -1,   285,    -1,    -1,  1746,    -1,  1748,
      -1,    -1,  4162,    -1,  1753,  1754,    -1,    -1,    -1,    -1,
      -1,  1760,  1761,  1762,    -1,    -1,   339,  1766,  4288,  1768,
    1769,  1770,  1771,  1772,  1773,    -1,  1775,    -1,  1777,  1778,
      -1,    -1,  1781,    -1,    -1,    -1,    -1,    -1,    -1,  4309,
      -1,    -1,    -1,    -1,  4314,  4315,  1795,  1796,  1797,  1798,
    1799,  1800,    -1,   344,    -1,  1804,    -1,    -1,    -1,  1808,
      -1,    -1,  1811,    -1,    -1,  1814,  1815,  1816,  1817,  1818,
    1819,  1820,  1821,  1822,    -1,  1824,    -1,    -1,    -1,   402,
      -1,    -1,  1831,    -1,  1833,    -1,    -1,    -1,    -1,  4359,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     8,
      -1,    -1,    11,    -1,    -1,    -1,    15,    16,    17,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4286,    -1,    -1,    -1,
      -1,    -1,    -1,    32,    -1,  4405,    35,    -1,    -1,    -1,
      -1,    40,  4412,    -1,    -1,    -1,   437,    46,    -1,   440,
     441,   442,    -1,   444,   445,   446,   447,   448,   449,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    70,    -1,    -1,    -1,     8,    -1,  4447,    11,    -1,
      -1,    -1,    15,    16,    17,    -1,    -1,    -1,  4458,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    -1,    -1,
    4480,    -1,  1961,    46,    -1,    -1,    -1,    -1,    -1,     8,
      -1,    -1,    11,    -1,    -1,    -1,    15,    16,    17,    -1,
      -1,    -1,    -1,  4503,  4394,    -1,    -1,    70,    -1,    -1,
      -1,    -1,  4512,    32,    -1,    -1,    35,    -1,    -1,    -1,
      -1,    40,    -1,    -1,    -1,    -1,    -1,    46,    -1,    -1,
      -1,  2010,  4422,  4533,    -1,  2014,  2015,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2024,    -1,   176,    -1,  2028,
    2029,    70,   181,    -1,  2033,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2041,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4460,    -1,    -1,   202,   203,    -1,    -1,    -1,    -1,    -1,
    2059,    -1,    -1,  2062,    -1,    -1,    -1,    -1,   217,    -1,
      -1,    -1,    -1,    -1,    -1,  2074,    -1,    -1,    -1,  2078,
      -1,    -1,  2081,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2090,    -1,   176,    -1,    22,  4616,    -1,   181,    -1,
     249,    28,    -1,  4513,  2103,    -1,    -1,  4517,  4518,    -1,
      -1,    -1,    -1,   262,    -1,    -1,   265,    -1,  4638,   202,
     203,    -1,  2121,  2122,    -1,    -1,    53,    -1,    -1,    -1,
      -1,  2130,    -1,    -1,   217,    -1,    -1,   176,    -1,    -1,
      -1,    68,   181,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4672,  2152,  2153,    -1,    -1,  2156,    -1,    -1,
      -1,    -1,    -1,   202,   203,    -1,   249,  4687,    -1,    -1,
      -1,    -1,    -1,    -1,   101,    -1,    -1,    -1,   217,   262,
      -1,    -1,   265,    -1,    -1,    -1,  2185,    -1,    -1,    -1,
    2189,    -1,    -1,   120,    -1,   344,    -1,    -1,   281,  4609,
     127,    -1,    -1,   130,  4724,    -1,    -1,    -1,  2207,    -1,
     249,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2218,
      -1,    -1,    -1,   262,    -1,    -1,   265,    -1,   155,    -1,
      -1,    -1,  2231,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2239,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   183,    -1,    -1,   186,
      -1,   344,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4795,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2284,  2285,    -1,   437,    -1,
      -1,   440,   441,   442,  2293,   444,   445,   446,   447,   448,
     449,    -1,    -1,    -1,   231,   344,    -1,   234,    -1,    -1,
      -1,  4831,    -1,    -1,    -1,    -1,    -1,   244,    -1,   246,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   256,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   264,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   273,   274,    -1,    -1,
      -1,    -1,    -1,    -1,   437,    -1,  2355,   440,   441,   442,
    2359,   444,   445,   446,   447,   448,   449,    -1,    -1,  2368,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   309,    -1,    -1,   312,   313,   314,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   437,    -1,
      -1,   440,   441,   442,    -1,   444,   445,   446,   447,   448,
     449,    -1,   339,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2421,    -1,    -1,    -1,   353,  2426,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2457,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2473,   402,  2475,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2483,    -1,    -1,    -1,  2487,   200,
      -1,  2490,    -1,    -1,  2493,    -1,   207,    -1,    -1,    -1,
      -1,    -1,  2501,    -1,    -1,    -1,    -1,   218,    -1,    -1,
      -1,    -1,  2511,    -1,    -1,    -1,    -1,  2516,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2539,  2540,  2541,    -1,    -1,  2544,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2552,  2553,  2554,  2555,    -1,    -1,    -1,
      -1,  2560,    -1,    -1,    -1,    -1,  2565,  2566,    -1,  2568,
      -1,  2570,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2581,  2582,    -1,    -1,  2585,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2599,    -1,  2601,    -1,  2603,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     8,    -1,    -1,    11,    -1,    -1,    -1,    15,
      16,    17,    -1,    -1,  2623,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2634,    32,  2636,  2637,  2638,
      -1,    -1,    -1,    -1,    40,    -1,    -1,    -1,    -1,    -1,
      46,    -1,  2651,    -1,    -1,  2654,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2666,    -1,    -1,
      -1,    -1,  2671,    -1,    70,    -1,    -1,    -1,  2677,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2687,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2703,    -1,    -1,  2706,    -1,  2708,
      -1,    -1,    -1,    -1,  2713,    -1,  2715,    -1,    -1,     8,
      -1,    -1,    11,    -1,    -1,    -1,    15,    16,    17,    -1,
      -1,    -1,  2731,  2732,    -1,    -1,    -1,    -1,  2737,    -1,
      -1,    -1,    -1,    32,    -1,    -1,    35,    -1,    -1,    -1,
      -1,    40,    -1,    -1,    -1,    -1,    -1,    46,    -1,  2758,
      -1,    -1,  2761,   159,    -1,    -1,  2765,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     176,    70,    -1,  2782,    -1,   181,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   202,   203,  2807,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   217,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2842,  2843,  2844,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   249,    -1,    -1,    -1,    -1,   569,    -1,
      -1,    -1,    -1,   574,    -1,    -1,   262,  2866,    -1,   265,
      -1,    -1,    -1,    -1,   585,    -1,    -1,  2876,    -1,  2878,
    2879,    -1,  2881,    -1,    -1,  2884,    -1,   176,    -1,    -1,
     601,    -1,   181,    -1,    -1,  2894,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   617,    -1,    -1,    -1,
      -1,    -1,   623,   202,   203,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   634,    -1,    -1,    -1,    -1,   217,    -1,
      -1,   642,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2939,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   344,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2958,
     249,    -1,    -1,    -1,    -1,  2964,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   262,    -1,    -1,   265,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2990,    -1,    -1,    -1,    -1,    -1,  2996,  2997,    -1,
      -1,    -1,    -1,    -1,  3003,    -1,  3005,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   727,    -1,  3017,    -1,
    3019,    -1,    -1,    -1,    -1,    20,    -1,    -1,    -1,    -1,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   437,    37,    -1,   440,   441,   442,    -1,   444,   445,
     446,   447,   448,   449,    -1,   344,    -1,  3056,    -1,    -1,
      -1,    -1,    -1,    58,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3073,  3074,    71,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3087,    -1,
      85,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   103,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     125,  3130,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   136,    -1,  3142,    -1,    -1,  3145,    -1,   437,   144,
      -1,   440,   441,   442,    -1,   444,   445,   446,   447,   448,
     449,   156,    -1,    -1,    -1,    -1,   161,    -1,  3167,    -1,
      -1,  3170,   167,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3187,   184,
      -1,  3190,    -1,    -1,    -1,    -1,    -1,  3196,    -1,    -1,
      -1,    -1,    -1,  3202,    -1,  3204,    -1,    -1,  3207,    -1,
      -1,    -1,  3211,  3212,  3213,  3214,  3215,    -1,    -1,  3218,
    3219,  3220,  3221,  3222,  3223,  3224,  3225,  3226,  3227,    -1,
      -1,    -1,  3231,  3232,    -1,   230,    -1,  3236,    -1,    -1,
      -1,    -1,  3241,    -1,    -1,    -1,  3245,    -1,  3247,    -1,
    3249,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3257,    -1,
      -1,  3260,    -1,  3262,    -1,    -1,    -1,   262,    -1,    -1,
      -1,  3270,  3271,    -1,    -1,  3274,  3275,    -1,   273,    -1,
    3279,  3280,    -1,    -1,    -1,    -1,    -1,  3286,   283,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3296,   293,  3298,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3310,    -1,    -1,    -1,    -1,    -1,  3316,  3317,  3318,
      -1,    -1,    -1,    -1,    -1,   320,    -1,    -1,    -1,    -1,
     325,    -1,   327,    -1,  1045,    -1,    -1,    -1,   333,    -1,
      -1,   336,    -1,    -1,  3343,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1065,    -1,    -1,  3356,    -1,    -1,
      -1,    -1,    -1,  3362,    -1,    -1,  1077,    -1,    -1,    -1,
     365,    -1,    -1,   368,    -1,    -1,    -1,   372,  3377,    -1,
      -1,    -1,    -1,    -1,   379,    -1,   381,    -1,    -1,     8,
      -1,   386,    11,    -1,  1105,    -1,    15,    16,    17,    -1,
      -1,    -1,    -1,   398,    -1,  1116,    -1,    -1,    -1,    -1,
      -1,  3410,    -1,    32,    -1,    -1,   411,    -1,    -1,    -1,
    1131,    40,    -1,  1134,    -1,    -1,    -1,    46,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     8,    -1,    -1,    11,    -1,    -1,    -1,    15,    16,
      17,    70,    -1,    -1,    -1,    -1,    -1,  3456,    -1,    -1,
      -1,    -1,  3461,  3462,  3463,    32,    -1,    -1,    35,    -1,
      -1,    -1,    -1,    40,    -1,    -1,    -1,    -1,    -1,    46,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    70,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3515,    -1,    -1,  3518,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1251,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1259,  1260,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   176,  1269,    -1,
      -1,    -1,   181,     8,    -1,    -1,    11,    -1,    -1,    -1,
      15,    16,    17,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3580,    -1,   202,   203,    -1,    -1,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    -1,    -1,   217,    -1,
      -1,    46,    -1,    -1,  3603,  3604,    -1,    -1,  3607,   176,
      -1,    -1,    -1,  1324,   181,    -1,    -1,  3616,    -1,  3618,
      -1,    -1,    -1,    -1,    -1,    70,    -1,    -1,    -1,    -1,
     249,    -1,    -1,    -1,    -1,   202,   203,    -1,    -1,    -1,
      -1,    -1,    -1,   262,    -1,    -1,   265,    -1,    -1,    -1,
     217,    -1,    -1,    -1,    -1,    -1,   200,  3656,  3657,  3658,
      -1,    -1,    -1,   207,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   218,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   249,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   262,    -1,    -1,   265,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3712,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   344,    -1,    -1,    -1,    -1,
      -1,   176,    -1,    -1,  3733,    -1,   181,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3744,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   373,    -1,    -1,   202,   203,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1480,
      -1,    -1,   217,    -1,    -1,  3774,    -1,   344,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3784,  3785,    -1,  3787,    -1,
      -1,    -1,  3791,  3792,    -1,    -1,    -1,  3796,  3797,    -1,
      -1,    -1,  3801,    -1,   249,  3804,  3805,    -1,    -1,    -1,
    3809,    -1,    -1,    -1,    -1,    -1,  3815,   262,   437,  1530,
     265,   440,   441,   442,    -1,   444,   445,   446,   447,   448,
     449,    -1,    -1,    -1,  3833,    -1,    -1,    -1,  3837,    -1,
    1551,    -1,    -1,    -1,  1555,    -1,    -1,    -1,    -1,    -1,
    3849,    -1,    -1,    -1,    -1,  3854,  1567,    -1,    -1,    -1,
      -1,  3860,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     437,    -1,    -1,   440,   441,   442,  3875,   444,   445,   446,
     447,   448,   449,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   344,
    3899,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3917,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,  1640,
    1641,    -1,    -1,    25,    -1,  3934,    -1,    -1,    -1,    -1,
    3939,    -1,  1653,    -1,    -1,    37,    -1,    -1,    -1,  3948,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1668,  1669,    -1,
      -1,    -1,    -1,    -1,    -1,  3964,    58,    -1,    -1,  1680,
    3969,    -1,    -1,    -1,    -1,    -1,    -1,  3976,    -1,    71,
      -1,    -1,    -1,    -1,  3983,  3984,    -1,    -1,  3987,    81,
      -1,    -1,   437,    85,    -1,   440,   441,   442,  3997,   444,
     445,   446,   447,   448,   449,    -1,    -1,    -1,    -1,    -1,
      -1,   103,    -1,    -1,    -1,    -1,    -1,   109,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   569,    -1,    -1,  4027,    -1,
     574,    -1,    -1,   125,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   585,    -1,    -1,   136,    -1,    -1,    -1,    -1,    -1,
    4049,    -1,   144,    -1,    -1,    -1,    -1,   601,    -1,    -1,
      -1,  4060,    -1,    -1,   156,    -1,    -1,    -1,    -1,    -1,
      -1,   163,    -1,   617,    -1,   167,    -1,    -1,    -1,   623,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1800,
     634,    -1,   184,    -1,    -1,    -1,    -1,    -1,   642,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4114,    -1,  4116,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   221,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   230,    -1,
      -1,    -1,    -1,  4142,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4158,
      -1,    -1,    -1,  4162,    -1,    -1,    -1,    -1,  4167,    -1,
     262,    -1,    -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   727,    -1,  4184,  4185,    -1,    -1,  4188,
      -1,   283,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4202,    -1,    -1,    -1,    -1,  4207,    -1,
     302,    -1,    -1,  4212,    -1,    -1,  4215,  4216,    -1,    -1,
      -1,    -1,    -1,    -1,  4223,  4224,    -1,    -1,   320,    -1,
      -1,    -1,    -1,    -1,    -1,   327,    -1,    -1,    -1,    -1,
    4239,   333,    -1,    -1,   336,    -1,    -1,  4246,    -1,  4248,
      -1,    -1,    -1,  4252,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   365,    -1,    -1,   368,   369,    -1,   371,
     372,    -1,    -1,    -1,    -1,    -1,    -1,  4286,  4287,   381,
      -1,    -1,    -1,    -1,   386,    -1,    -1,  4296,    -1,    -1,
     392,    -1,    -1,   395,    -1,    -1,   398,    -1,    -1,    -1,
      -1,    -1,    -1,  2024,    -1,    -1,    -1,  2028,  2029,   411,
      -1,    -1,  2033,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2041,    -1,    -1,    -1,  4333,    -1,    -1,    -1,    -1,    -1,
    4339,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2059,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2103,  4392,    -1,  4394,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2121,  2122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4421,  4422,    -1,  4424,    -1,  4426,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2152,  2153,    -1,    -1,  2156,    -1,    -1,    -1,    -1,
      -1,  4450,    -1,    -1,    -1,  4454,    -1,    -1,    -1,    -1,
      -1,  4460,    -1,    -1,    -1,    -1,  4465,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2185,    -1,    -1,    -1,  2189,    -1,
      -1,    -1,    -1,    -1,    -1,  4484,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2207,    -1,    -1,    -1,
      -1,  1045,    -1,    -1,    -1,    -1,    -1,  2218,  4507,    -1,
      -1,    -1,    -1,    -1,  4513,    -1,    -1,    -1,  4517,  4518,
    2231,  1065,    -1,  4522,    -1,    -1,    -1,    -1,  2239,    -1,
      -1,    -1,    -1,  1077,    -1,    -1,    -1,    -1,    -1,  4538,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1105,    -1,    -1,    -1,    -1,    -1,  4566,    -1,    -1,
      -1,    -1,  1116,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2293,    -1,    -1,    -1,    -1,  1131,  4587,    -1,
    1134,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4608,
    4609,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4629,    -1,    -1,  4632,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4641,    -1,    -1,    -1,    -1,  4646,  2359,  4648,
      -1,  4650,    -1,    -1,    -1,    -1,    -1,    -1,  4657,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4674,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4695,    -1,  4697,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1251,    -1,    -1,
    2421,    -1,    -1,    -1,    -1,  1259,  1260,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1269,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   721,   722,    -1,    -1,    -1,    -1,  4738,
      -1,    -1,    -1,    -1,    -1,    -1,  2457,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2475,   753,  4765,  4766,    -1,    -1,
      -1,    -1,  2483,    -1,    -1,    -1,    -1,  4776,    -1,    -1,
    1324,    -1,    -1,    -1,    -1,  4784,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4796,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4843,    -1,    -1,    -1,    -1,  2560,
    4849,  4850,  4851,    -1,    -1,  2566,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4870,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4882,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4896,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1480,    -1,    -1,    -1,
    2651,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4953,  4954,    -1,    -1,    -1,    -1,
    4959,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4967,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4978,
    4979,  4980,    -1,    -1,    -1,    -1,  1530,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2715,    -1,    -1,  1551,    -1,    -1,
      -1,  1555,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2731,  2732,    -1,  1567,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2758,    -1,    -1,
    2761,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1640,  1641,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1653,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1668,  1669,    -1,    -1,    -1,    -1,
      -1,  2842,  2843,  2844,    -1,    -1,  1680,    -1,    -1,    -1,
     612,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2866,    -1,    -1,  1146,    -1,
      -1,   633,    -1,    -1,    -1,    -1,    -1,    -1,  2879,    -1,
    2881,    -1,    -1,  2884,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2894,    -1,    -1,    -1,  1175,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1203,  1204,  1205,    -1,  1207,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1227,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2958,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1800,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1268,    -1,    -1,    -1,    -1,  2996,    -1,    -1,    -1,    -1,
      -1,    -1,  3003,    -1,  3005,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3017,    -1,  3019,    -1,
    1298,    -1,    -1,    -1,  1302,  1303,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3073,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3130,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   899,    -1,    -1,
      -1,    -1,    -1,    -1,  3145,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   919,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3167,    -1,    -1,  3170,
     612,   933,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2024,   633,    -1,    -1,  2028,  2029,    -1,    -1,    -1,  2033,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2041,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2059,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3247,    -1,  1010,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2103,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2121,  2122,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2152,  2153,
      -1,    -1,  2156,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2185,  1114,    -1,    -1,  2189,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2207,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2218,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2231,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2239,    -1,    -1,    -1,  3410,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3456,    -1,   899,    -1,  2293,
    3461,    -1,  3463,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1753,    -1,   919,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1766,    -1,
    1768,   933,    -1,  1771,  1772,  1773,    -1,    -1,    -1,    -1,
    1778,    -1,    -1,  1781,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3515,    -1,    -1,  3518,  1796,  1797,
    1798,  1799,    -1,    -1,    -1,  2359,  1804,    -1,    -1,    -1,
    1808,    -1,    -1,  1811,    -1,    -1,  1814,  1815,  1816,  1817,
    1818,  1819,  1820,  1821,  1822,    -1,  1824,    -1,    -1,    -1,
      -1,    -1,    -1,  1831,    -1,  1833,  1318,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1010,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2421,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3603,  3604,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3616,    -1,  3618,    -1,    -1,
      -1,  1383,    -1,  2457,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2475,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2483,
      -1,    -1,    -1,    -1,    -1,   612,    -1,    -1,  1420,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1114,    -1,    -1,    -1,   633,    -1,    -1,    -1,
      -1,    -1,    -1,  1961,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3712,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2560,    -1,    -1,    -1,
      -1,    -1,  2566,    -1,    -1,    -1,    -1,    -1,    -1,  1501,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1516,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1524,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1535,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2062,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2651,    -1,    -1,
    1582,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1595,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1607,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1619,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1318,    -1,    -1,    -1,
      -1,  2715,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2731,  2732,    -1,
      -1,  1663,    -1,    -1,  1666,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2758,    -1,    -1,  2761,    -1,    -1,
      -1,    -1,    -1,  3934,    -1,    -1,    -1,    -1,  3939,    -1,
      -1,  1383,   899,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   919,  3964,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   612,    -1,  3976,   933,    -1,  1420,    -1,
      -1,    -1,  3983,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   633,    -1,  3997,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2284,    -1,  2842,  2843,
    2844,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2866,  1795,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2879,    -1,  2881,    -1,    -1,
    2884,    -1,    -1,  1010,    -1,    -1,    -1,    -1,    -1,  1501,
    2894,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1833,    -1,    -1,  1516,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1524,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1535,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2958,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1582,  4142,    -1,    -1,    -1,    -1,    -1,    -1,  2426,    -1,
      -1,    -1,    -1,  1595,    -1,    -1,    -1,  1114,    -1,    -1,
      -1,    -1,  2996,    -1,    -1,  1607,    -1,    -1,    -1,  3003,
      -1,  3005,    -1,    -1,    -1,    -1,    -1,  1619,    -1,    -1,
      -1,    -1,    -1,  3017,    -1,  3019,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1663,    -1,    -1,  1666,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2511,    -1,    -1,    -1,    -1,  2516,  3073,
      -1,    -1,    -1,    -1,    -1,  4246,    -1,  4248,  2010,    -1,
      -1,    -1,  2014,  2015,    -1,    -1,    -1,    -1,    -1,    -1,
     899,    -1,    -1,  2541,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2552,    -1,  2554,  2555,    -1,    -1,
     919,    -1,    -1,    -1,    -1,    -1,  4287,  2565,    -1,    -1,
    2568,    -1,  2570,    -1,   933,    -1,  3130,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3145,    -1,    -1,    -1,    -1,  2078,    -1,    -1,    -1,
      -1,  2599,    -1,  2601,    -1,  2603,    -1,    -1,  2090,    -1,
      -1,    -1,  4333,  3167,    -1,    -1,  3170,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1795,    -1,    -1,    -1,    -1,  2636,  2637,
    2638,  1318,    -1,    -1,    -1,    -1,    -1,    -1,  2130,    -1,
      -1,  1010,    -1,    -1,    -1,    -1,  2654,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2666,    -1,
      -1,    -1,    -1,  2671,    -1,    -1,    -1,    -1,    -1,  2677,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3247,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1383,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2737,
      -1,    -1,    -1,  1420,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1114,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4507,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2285,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4538,    -1,    -1,
      -1,    -1,    -1,    -1,  1501,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1516,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1524,  2010,    -1,
      -1,    -1,  2014,  2015,    -1,    -1,  3410,    -1,  1535,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2355,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3456,    -1,    -1,  1582,    -1,  3461,    -1,  3463,
      -1,    -1,    -1,    -1,    -1,    -1,  2078,    -1,  1595,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2090,    -1,
    1607,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1619,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1318,
      -1,  3515,    -1,    -1,  3518,    -1,    -1,    -1,  2130,    -1,
      -1,    -1,    -1,    -1,  4695,    -1,  4697,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1663,    -1,    -1,  1666,
      -1,  2473,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2490,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2501,
      -1,    -1,    -1,    -1,  1383,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3603,
    3604,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1420,  3616,  4784,  3618,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1795,    -1,
      -1,    -1,    -1,  2285,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1501,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2636,  2637,  2638,  1516,  3712,    -1,
      -1,  4882,    -1,    -1,    -1,  1524,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4896,  1535,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3187,
      -1,    -1,    -1,  2355,    -1,    -1,    -1,    -1,  3196,    -1,
      -1,    -1,    -1,    -1,  3202,    -1,  3204,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2703,    -1,  1582,  2706,    -1,  2708,    -1,    -1,    -1,
      -1,  2713,    -1,  3231,  3232,    -1,  1595,    -1,  4959,    -1,
      -1,    -1,    -1,    -1,    -1,   612,    -1,    -1,  1607,    -1,
      -1,  3249,    -1,    -1,    -1,    -1,    -1,  4978,    -1,  3257,
    1619,    -1,  3260,    -1,  3262,    -1,   633,    -1,    -1,    -1,
      -1,    -1,   612,  3271,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3279,  3280,  2765,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   633,    -1,    -1,    -1,    -1,    -1,    -1,
    2782,    -1,    -1,    -1,  1663,    -1,    -1,  1666,    -1,    -1,
      -1,  2473,  3310,    -1,    -1,    -1,    -1,    -1,  3316,  3317,
    3318,    -1,    -1,    -1,    -1,  2807,    -1,    -1,  2490,    -1,
      -1,    -1,    -1,  2010,    -1,    -1,    -1,  2014,  2015,  2501,
      -1,    -1,    -1,    -1,    -1,  3343,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3356,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3934,    -1,    -1,    -1,    -1,  3939,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2876,    -1,  2878,    -1,    -1,    -1,
      -1,  2078,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3964,    -1,    -1,  2090,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3976,    -1,    -1,    -1,    -1,    -1,    -1,  3983,
      -1,    -1,    -1,    -1,    -1,    -1,  1795,    -1,    -1,    -1,
      -1,    -1,    -1,  3997,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2130,    -1,    -1,    -1,  2939,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2964,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2990,    -1,
      -1,    -1,    -1,    -1,    -1,  2997,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   899,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2703,    -1,    -1,  2706,    -1,  2708,    -1,    -1,    -1,
      -1,  2713,   919,    -1,    -1,    -1,    -1,    -1,    -1,   899,
      -1,    -1,    -1,    -1,    -1,    -1,   933,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3056,    -1,    -1,    -1,    -1,   919,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4142,    -1,
      -1,    -1,  3074,   933,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2765,    -1,  3087,    -1,    -1,  2285,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2782,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1010,    -1,  2807,    -1,    -1,    -1,    -1,
      -1,  2010,    -1,    -1,    -1,  2014,  2015,    -1,    -1,  3657,
    3658,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1010,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2355,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4246,    -1,  4248,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3190,    -1,
      -1,    -1,    -1,    -1,  2876,    -1,  2878,    -1,    -1,  2078,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3211,
      -1,  2090,    -1,  4287,    -1,  3733,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3744,  1114,    -1,    -1,
      -1,    -1,    -1,    -1,  3236,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2130,    -1,    -1,  1114,    -1,    -1,  2939,    -1,  4333,
      -1,    -1,    -1,    -1,    -1,    -1,  3784,  3785,  3270,    -1,
      -1,    -1,    -1,  3791,  3792,    -1,  2473,    -1,  3796,    -1,
      -1,    -1,  2964,  3801,    -1,    -1,  3804,  3805,    -1,    -1,
      -1,  3809,    -1,  2490,    -1,    -1,    -1,  3815,    -1,    -1,
      -1,    -1,    -1,    -1,  2501,    -1,    -1,    -1,  2990,    -1,
      -1,    -1,    -1,    -1,    -1,  2997,  3318,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3849,    -1,    -1,    -1,    -1,  3854,    -1,    -1,    -1,
      -1,    -1,  3860,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   612,    -1,    -1,    -1,    -1,    -1,  3875,    -1,    -1,
    3362,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   633,    -1,  3056,    -1,    -1,    -1,    -1,    -1,
      -1,  3899,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3074,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3087,  2285,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1318,    -1,  4507,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1318,    -1,
    3462,    -1,    -1,    -1,  4538,    -1,    -1,    -1,    -1,  3987,
      -1,    -1,    -1,    -1,    -1,    -1,  2355,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1383,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2703,    -1,  3190,  2706,
      -1,  2708,    -1,    -1,    -1,    -1,  2713,    -1,    -1,    -1,
      -1,    -1,    -1,  1383,    -1,    -1,    -1,    -1,    -1,  3211,
      -1,  4049,    -1,  1420,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3236,    -1,    -1,    -1,    -1,    -1,
    1420,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2765,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2782,    -1,    -1,  3270,    -1,
      -1,    -1,    -1,    -1,  2473,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3607,    -1,    -1,    -1,    -1,
    2807,  2490,    -1,    -1,  1501,    -1,    -1,    -1,    -1,    -1,
      -1,  4695,  2501,  4697,    -1,    -1,    -1,    -1,    -1,  1516,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1524,   899,    -1,
      -1,  1501,    -1,    -1,    -1,    -1,    -1,    -1,  1535,    -1,
      -1,    -1,    -1,    -1,  3656,    -1,  1516,    -1,   919,    -1,
      -1,    -1,    -1,    -1,  1524,    -1,  4184,  4185,    -1,    -1,
    4188,    -1,   933,    -1,    -1,  1535,    -1,    -1,    -1,  2876,
    3362,  2878,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1582,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4223,  4224,    -1,  1595,    -1,
    4784,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1607,    -1,  1582,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1619,    -1,    -1,  1595,    -1,    -1,    -1,    -1,
      -1,    -1,  2939,    -1,    -1,    -1,    -1,  1607,    -1,  1010,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1619,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2964,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1663,    -1,    -1,  1666,
    3462,    -1,    -1,    -1,    -1,  3787,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2990,    -1,  3797,    -1,    -1,    -1,    -1,
    2997,    -1,    -1,  1663,    -1,    -1,  1666,    -1,  4882,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4896,    -1,  2703,    -1,    -1,  2706,    -1,  2708,
      -1,    -1,    -1,    -1,  2713,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3849,    -1,    -1,
      -1,    -1,  3854,  1114,    -1,    -1,    -1,    -1,  3860,  3056,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3074,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4959,  2765,    -1,    -1,    -1,
    3087,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2782,  4978,    -1,  4424,    -1,  1795,    -1,
      -1,    -1,    -1,    -1,    -1,  3917,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3607,    -1,    -1,  2807,    -1,
      -1,    -1,  4450,    -1,    -1,  1795,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3948,  4465,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4484,  3969,    -1,    -1,
      -1,    -1,    -1,    -1,  3656,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3984,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3190,    -1,    -1,    -1,  2876,    -1,  2878,
      -1,    -1,    -1,    -1,  4522,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3211,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4027,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3236,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1318,    -1,    -1,
    2939,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4587,
      -1,    -1,    -1,  3270,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2964,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3787,    -1,    -1,    -1,    -1,
      -1,  2990,  4114,    -1,  4116,  3797,    -1,    -1,  2997,    -1,
      -1,    -1,  1383,  2010,    -1,    -1,    -1,  2014,  2015,    -1,
      -1,    -1,  4650,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2010,    -1,    -1,    -1,  2014,  2015,  4674,    -1,    -1,  1420,
    4162,    -1,    -1,    -1,    -1,  3362,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3056,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2078,    -1,    -1,    -1,  3074,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2090,    -1,    -1,    -1,    -1,  3087,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2078,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2090,    -1,    -1,    -1,    -1,  3917,    -1,    -1,    -1,    -1,
    1501,    -1,    -1,  2130,    -1,    -1,    -1,  4765,  4766,    -1,
      -1,    -1,    -1,    -1,    -1,  1516,    -1,    -1,  4776,    -1,
      -1,    -1,    -1,  1524,    -1,  3462,  3948,    -1,    -1,    -1,
    2130,    -1,    -1,    -1,  1535,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4286,    -1,    -1,  3969,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3984,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3190,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1582,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3211,  4851,  1595,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4027,  1607,    -1,    -1,    -1,
      -1,    -1,  4870,    -1,    -1,    -1,    -1,  3236,  1619,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3270,  4394,    -1,    -1,    -1,    -1,    -1,  2285,    -1,
      -1,    -1,  1663,    -1,    -1,  1666,    -1,    -1,    -1,    -1,
    3607,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4422,    -1,    -1,    -1,    -1,  2285,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4116,  4953,  4954,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4460,  3656,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2355,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4162,    -1,    -1,  3362,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1219,    -1,    -1,    -1,  2355,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4513,    -1,    -1,    -1,  4517,  4518,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1795,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1283,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3462,    -1,    -1,  2473,    -1,    -1,    -1,
    3787,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3797,    -1,    -1,  2490,  4286,    -1,  4608,  4609,    -1,    -1,
      -1,    -1,    -1,  2473,  2501,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2490,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2501,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4394,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3917,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3607,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4422,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2010,
      -1,  3948,    -1,  2014,  2015,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3969,    -1,    -1,    -1,    -1,  3656,  4460,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3984,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2703,  2078,    -1,  2706,
      -1,  2708,    -1,    -1,    -1,    -1,  2713,    -1,    -1,  2090,
    4027,  4513,    -1,    -1,    -1,  4517,  4518,    -1,    -1,    -1,
      -1,    -1,    -1,  2703,    -1,    -1,  2706,    -1,  2708,    -1,
      -1,    -1,    -1,  2713,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2130,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2765,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2782,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2765,    -1,    -1,  3787,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3797,  4116,
    2807,    -1,  2782,    -1,    -1,    -1,    -1,  4609,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2807,  1676,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4162,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2876,
      -1,  2878,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2876,    -1,  2878,    -1,
      -1,    -1,    -1,  1751,  2285,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1765,  3917,    -1,
      -1,  1769,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2939,    -1,    -1,  1783,  1784,  1785,    -1,  1787,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3948,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2964,    -1,  2939,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4286,
    3969,    -1,    -1,    -1,  2355,    -1,    -1,    -1,    -1,    -1,
      -1,  1829,    -1,  2990,  2964,  3984,    -1,    -1,    -1,    -1,
    2997,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2990,    -1,    -1,    -1,    -1,    -1,    -1,  2997,  1866,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4027,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3056,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3074,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3056,  4394,    -1,    -1,
    3087,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2473,    -1,  3074,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4422,    -1,  3087,    -1,  2490,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4116,    -1,    -1,
    2501,    -1,    -1,  1971,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1983,    -1,    -1,  1986,    -1,
      -1,    -1,    -1,  4460,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4162,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3190,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4513,    -1,    -1,    -1,
    4517,  4518,    -1,    -1,  3211,    -1,    -1,    -1,    -1,    -1,
    3190,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3236,
      -1,  3211,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3236,    -1,    -1,    -1,
      -1,    -1,    -1,  3270,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4286,    -1,    -1,
    3270,    -1,  4609,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2703,    -1,    -1,  2706,    -1,  2708,    -1,    -1,
      -1,    -1,  2713,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3362,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3362,    -1,  2765,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4394,    -1,    -1,    -1,    -1,
      -1,  2782,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4422,    -1,    -1,  2807,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3462,    -1,    -1,    -1,    -1,
      -1,  4460,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3462,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2876,    -1,  2878,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4513,    -1,    -1,    -1,  4517,  4518,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2939,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2964,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3607,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2990,
    4609,    -1,    -1,    -1,    -1,    -1,  2997,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3607,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3656,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2514,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3056,  3656,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2534,    -1,  2536,    -1,
      -1,  2539,  2540,  3074,  2542,    -1,  2544,    -1,    -1,    -1,
    2548,    -1,    -1,  2551,    -1,    -1,  3087,    -1,  2556,    -1,
      -1,    -1,    -1,    -1,  2562,    -1,    -1,    -1,    -1,  2567,
      -1,    -1,    -1,    -1,    -1,    -1,  2574,  2575,  2576,  2577,
      -1,    -1,    -1,  2581,  2582,    -1,  2584,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2596,    -1,
    2598,    -1,    -1,    -1,    -1,    -1,    -1,  2605,  2606,  2607,
    2608,  2609,  2610,  2611,  2612,  2613,  2614,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3787,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3797,    -1,    -1,    -1,  2642,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3787,    -1,  3190,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3797,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3211,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3236,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3270,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2752,    -1,    -1,    -1,    -1,    -1,
    3917,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3917,    -1,    -1,
      -1,  3948,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3969,    -1,    -1,    -1,    -1,    -1,  3948,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3984,    -1,    -1,
      -1,  3362,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3969,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3984,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4027,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4027,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3462,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4116,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4116,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2993,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4162,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4162,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3607,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3656,    -1,    -1,    -1,  4286,
      -1,    -1,    -1,    -1,    -1,  3133,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4286,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3186,    -1,
      -1,    -1,    -1,    -1,  3192,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3208,  3209,    -1,    -1,  3212,  3213,  3214,  3215,    -1,    -1,
    3218,  3219,  3220,  3221,  3222,  3223,  3224,  3225,  3226,  3227,
    3228,    -1,    -1,    -1,    -1,    -1,    -1,  4394,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3250,    -1,    -1,  3253,  3787,  3255,    -1,    -1,
    3258,  3259,    -1,    -1,  4394,  4422,  3797,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3273,  3274,  3275,  3276,    -1,
    3278,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4422,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4460,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3326,    -1,
    4460,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3337,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4513,    -1,    -1,    -1,
    4517,  4518,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3374,    -1,    -1,    -1,
      -1,    -1,    -1,  4513,    -1,    -1,  3917,  4517,  4518,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3948,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3969,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4609,  3984,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4609,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4027,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3580,    -1,    -1,  4116,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4162,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3734,    -1,    -1,    -1,
    3738,  3739,  3740,    -1,    -1,    -1,    -1,    -1,  3746,  3747,
    3748,  3749,    -1,    -1,    -1,  4286,  3754,  3755,  3756,  3757,
    3758,  3759,  3760,  3761,  3762,  3763,  3764,  3765,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3790,    -1,    -1,  3793,    -1,  3795,    -1,    -1,
      -1,  3799,    -1,    -1,  3802,  3803,    -1,    -1,  3806,  3807,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3851,    -1,    -1,    -1,    -1,    -1,    -1,
    3858,  3859,    -1,  4394,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3874,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4422,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4460,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4513,    -1,    -1,    -1,  4517,  4518,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4052,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4609,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4111,  4112,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4152,    -1,    -1,    -1,    -1,  4157,
    4158,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4172,    -1,  4174,    -1,    -1,    -1,
    4178,  4179,  4180,    -1,    -1,  4183,    -1,    -1,  4186,  4187,
      -1,    -1,    -1,  4191,    -1,    -1,    -1,  4195,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4250,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4310,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4344,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4420,  4421,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4436,  4437,
    4438,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4472,  4473,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4621,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4637,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4686,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4737,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4794,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    -1,    -1,    -1,    -1,    -1,  4854,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      -1,    -1,    -1,    34,    -1,    -1,    37,    38,    -1,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      -1,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    -1,    65,    66,    67,    68,    69,    -1,
      71,    -1,    73,    74,    75,    76,    77,    78,    79,    80,
      -1,    82,    83,    84,    85,    86,    87,  4925,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,    -1,   110,
      -1,   112,   113,   114,   115,   116,   117,    -1,   119,   120,
     121,   122,    -1,   124,   125,   126,   127,   128,  4966,   130,
     131,   132,    -1,   134,   135,   136,    -1,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,    -1,   150,
     151,   152,   153,    -1,   155,    -1,   157,   158,    -1,   160,
     161,   162,   163,    -1,   165,   166,    -1,   168,   169,    -1,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
      -1,   182,   183,   184,   185,   186,   187,    -1,   189,   190,
     191,   192,   193,   194,   195,   196,   197,    -1,   199,    -1,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
      -1,    -1,   213,   214,   215,   216,   217,    -1,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,    -1,   259,    -1,
      -1,   262,   263,   264,    -1,    -1,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
      -1,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,    -1,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,    -1,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,    -1,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,    -1,   363,   364,    -1,   366,   367,   368,   369,   370,
     371,   372,    -1,   374,   375,    -1,    -1,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
      -1,   392,   393,   394,   395,   396,   397,   398,    -1,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,    -1,    -1,   416,    -1,    -1,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,    -1,    -1,    -1,
      -1,    -1,    -1,   444,   445,   446,    -1,    -1,    -1,    -1,
      -1,    -1,   453,   454,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,    27,    28,
      29,    -1,    -1,    -1,    -1,    34,    -1,    -1,    37,    38,
      -1,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    -1,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    -1,    65,    66,    67,    68,
      69,    -1,    71,    -1,    73,    74,    75,    76,    77,    78,
      79,    80,    -1,    82,    83,    84,    85,    86,    87,    -1,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
      -1,   110,    -1,   112,   113,   114,   115,   116,   117,    -1,
     119,   120,   121,    -1,    -1,   124,   125,   126,   127,   128,
      -1,   130,   131,   132,    -1,   134,   135,   136,    -1,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
      -1,   150,   151,   152,   153,    -1,   155,    -1,   157,   158,
      -1,   160,   161,   162,   163,    -1,   165,   166,    -1,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,    -1,   182,   183,   184,   185,   186,   187,    -1,
     189,   190,   191,   192,   193,   194,   195,   196,   197,    -1,
     199,    -1,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,    -1,    -1,   213,   214,   215,   216,   217,    -1,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,    -1,
     259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,    -1,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
      -1,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,    -1,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,    -1,   374,   375,    -1,    -1,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,    -1,   392,   393,   394,   395,   396,   397,   398,
      -1,   400,   401,   402,   403,   404,   405,   406,    -1,   408,
     409,   410,   411,   412,   413,    -1,    -1,   416,    -1,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,    -1,
     439,    -1,    -1,    -1,    -1,   444,   445,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   453,   454,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    18,    19,    20,    21,    22,    23,    24,    25,    -1,
      27,    28,    29,    -1,    -1,    -1,    -1,    34,    -1,    -1,
      37,    38,    -1,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    -1,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    -1,    65,    66,
      67,    68,    69,    -1,    71,    -1,    73,    74,    75,    76,
      77,    78,    79,    80,    -1,    82,    83,    84,    85,    86,
      87,    -1,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,    -1,   110,    -1,   112,   113,   114,   115,   116,
     117,    -1,   119,   120,   121,    -1,    -1,   124,   125,   126,
     127,   128,    -1,   130,   131,   132,    -1,   134,   135,   136,
      -1,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,    -1,   150,   151,   152,   153,    -1,   155,    -1,
     157,   158,    -1,   160,   161,   162,   163,    -1,   165,   166,
      -1,   168,   169,    -1,   171,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,   183,   184,   185,   186,
     187,    -1,   189,   190,   191,   192,   193,   194,   195,   196,
     197,    -1,   199,    -1,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,    -1,    -1,   213,   214,   215,   216,
     217,    -1,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,    -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,    -1,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,    -1,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,    -1,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,    -1,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,    -1,   363,   364,    -1,   366,
     367,   368,   369,   370,   371,   372,    -1,   374,   375,    -1,
      -1,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,    -1,   392,   393,   394,   395,   396,
     397,   398,    -1,   400,   401,   402,   403,   404,   405,   406,
      -1,   408,   409,   410,   411,   412,   413,    -1,    -1,   416,
      -1,    -1,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,    -1,    -1,    -1,    -1,    -1,    -1,   444,   445,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   453,   454,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    18,    19,    20,    21,    22,    23,    24,
      25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,    34,
      -1,    -1,    37,    38,    -1,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    -1,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    -1,
      65,    66,    67,    68,    69,    -1,    71,    -1,    73,    74,
      75,    76,    77,    78,    79,    80,    -1,    82,    83,    84,
      85,    86,    87,    -1,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,    -1,   110,    -1,   112,   113,   114,
     115,   116,   117,    -1,   119,   120,   121,    -1,    -1,   124,
     125,   126,   127,   128,    -1,   130,   131,   132,    -1,   134,
     135,   136,    -1,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,    -1,   150,   151,   152,   153,    -1,
     155,    -1,   157,   158,    -1,   160,   161,   162,   163,    -1,
     165,   166,    -1,   168,   169,    -1,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,    -1,   182,   183,   184,
     185,   186,   187,    -1,   189,   190,   191,   192,   193,   194,
     195,   196,   197,    -1,   199,    -1,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,    -1,    -1,   213,   214,
     215,   216,   217,    -1,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,    -1,   259,    -1,    -1,   262,   263,   264,
      -1,    -1,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,    -1,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,    -1,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,    -1,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,    -1,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,   372,    -1,   374,
     375,    -1,    -1,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,    -1,   392,   393,   394,
     395,   396,   397,   398,    -1,   400,   401,   402,   403,   404,
     405,   406,    -1,   408,   409,   410,   411,   412,   413,    -1,
      -1,   416,    -1,    -1,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,    -1,    -1,    -1,    -1,    -1,    -1,   444,
     445,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   453,   454,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,
      -1,    34,    -1,    -1,    37,    38,    -1,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    -1,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    -1,    65,    66,    67,    68,    69,    -1,    71,    -1,
      73,    74,    75,    76,    77,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    -1,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,    -1,   110,    -1,   112,
     113,   114,   115,   116,   117,    -1,   119,   120,   121,    -1,
      -1,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
      -1,   134,   135,   136,    -1,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,    -1,   150,   151,   152,
     153,    -1,   155,    -1,   157,   158,    -1,   160,   161,   162,
     163,    -1,   165,   166,    -1,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,    -1,   182,
     183,   184,   185,   186,   187,    -1,   189,   190,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,    -1,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,    -1,    -1,
     213,   214,   215,   216,   217,    -1,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,    -1,   259,    -1,    -1,   262,
     263,   264,    -1,    -1,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,    -1,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,    -1,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,    -1,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,    -1,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,    -1,
     363,   364,    -1,   366,   367,   368,   369,   370,   371,   372,
      -1,   374,   375,    -1,    -1,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,    -1,   392,
     393,   394,   395,   396,   397,   398,    -1,   400,   401,   402,
     403,   404,   405,   406,    -1,   408,   409,   410,   411,   412,
     413,    -1,    -1,   416,    -1,    -1,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,    -1,    -1,     3,    -1,    -1,
      -1,   444,   445,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     453,   454,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    35,
      -1,    37,    38,    -1,    40,    41,    -1,    43,    44,    45,
      46,    47,    -1,    49,    50,    -1,    52,    53,    54,    55,
      56,    -1,    -1,    59,    60,    61,    62,    63,    -1,    65,
      66,    67,    68,    69,    -1,    -1,    -1,    73,    74,    75,
      76,    -1,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    -1,    89,    90,    91,    92,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   100,   101,   102,   103,   104,   105,
     106,   107,   108,    -1,   110,    -1,   112,   113,   114,   115,
     116,   117,    -1,   119,   120,   121,    -1,    -1,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,    -1,   134,   135,
     136,    -1,   138,   139,   140,   141,   142,   143,   144,   145,
     146,    -1,   148,    -1,   150,   151,   152,   153,    -1,   155,
      -1,   157,    -1,    -1,   160,   161,   162,   163,    -1,   165,
     166,    -1,   168,   169,    -1,   171,   172,   173,   174,   175,
      -1,   177,   178,   179,   180,    -1,   182,   183,   184,   185,
     186,   187,    -1,   189,   190,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,    -1,   201,    -1,    -1,   204,   205,
     206,   207,   208,   209,   210,    -1,    -1,   213,   214,   215,
     216,    -1,    -1,   219,   220,   221,    -1,    -1,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
      -1,   247,   248,    -1,   250,    -1,   252,   253,   254,   255,
     256,   257,    -1,   259,    -1,    -1,   262,   263,   264,    -1,
      -1,   267,   268,    -1,   270,    -1,   272,   273,   274,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,    -1,   333,   334,   335,
     336,   337,    -1,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,    -1,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,    -1,   363,   364,    -1,
     366,    -1,   368,   369,   370,   371,   372,    -1,   374,   375,
      -1,    -1,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,    -1,    -1,   393,   394,   395,
     396,   397,    -1,    -1,   400,   401,   402,   403,   404,   405,
     406,    -1,   408,    -1,   410,   411,   412,   413,    -1,    -1,
     416,    -1,    -1,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,    -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   454,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,    27,    28,
      29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,
      -1,    40,    41,    42,    43,    44,    45,    -1,    47,    48,
      49,    50,    -1,    52,    53,    54,    55,    56,    -1,    -1,
      59,    60,    61,    62,    63,    -1,    65,    66,    67,    68,
      -1,    -1,    71,    -1,    73,    74,    75,    76,    77,    78,
      79,    80,    -1,    82,    83,    84,    85,    86,    87,    -1,
      89,    90,    91,    92,    -1,    -1,    -1,    96,    -1,    -1,
      -1,   100,   101,   102,   103,   104,   105,   106,   107,   108,
      -1,   110,    -1,   112,   113,   114,   115,   116,   117,    -1,
     119,   120,   121,    -1,    -1,   124,   125,   126,   127,   128,
      -1,   130,   131,   132,    -1,   134,   135,   136,    -1,   138,
     139,   140,   141,    -1,   143,   144,   145,    -1,    -1,   148,
      -1,   150,   151,   152,   153,    -1,   155,    -1,   157,   158,
      -1,   160,   161,   162,   163,    -1,   165,    -1,    -1,    -1,
     169,    -1,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,    -1,
     189,   190,   191,   192,   193,   194,   195,   196,   197,    -1,
     199,    -1,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,    -1,    -1,   213,    -1,   215,   216,   217,    -1,
     219,   220,   221,    -1,    -1,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,    -1,    -1,   247,   248,
     249,   250,    -1,    -1,   253,   254,   255,   256,   257,    -1,
     259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,   268,
     269,   270,   271,    -1,   273,   274,   275,   276,   277,   278,
     279,   280,    -1,   282,   283,    -1,   285,    -1,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,   317,   318,
     319,   320,   321,   322,    -1,   324,   325,   326,   327,   328,
     329,   330,   331,    -1,   333,   334,   335,   336,   337,    -1,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
      -1,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,    -1,    -1,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,   372,    -1,   374,   375,    -1,    -1,   378,
     379,    -1,   381,    -1,    -1,   384,   385,   386,   387,   388,
     389,   390,    -1,    -1,   393,   394,   395,   396,   397,    -1,
      -1,   400,   401,   402,   403,   404,    -1,   406,   407,   408,
     409,   410,   411,   412,   413,    -1,    -1,   416,    -1,    -1,
     419,   420,   421,   422,   423,   424,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   434,   435,   436,    -1,    -1,
      -1,    18,    19,    20,    21,    22,    23,    24,    25,    -1,
      27,    28,    29,    -1,    -1,   454,    -1,    -1,    -1,    -1,
      37,    38,    -1,    40,    41,    42,    43,    44,    45,    -1,
      47,    48,    49,    50,    -1,    52,    53,    54,    55,    56,
      -1,    -1,    59,    60,    61,    62,    63,    -1,    65,    66,
      67,    68,    -1,    -1,    71,    -1,    73,    74,    75,    76,
      77,    78,    79,    80,    -1,    82,    83,    84,    85,    86,
      87,    -1,    89,    90,    91,    92,    -1,    -1,    -1,    96,
      -1,    -1,    -1,   100,   101,   102,   103,   104,   105,   106,
     107,   108,    -1,   110,    -1,   112,   113,   114,   115,   116,
     117,    -1,   119,   120,   121,    -1,    -1,   124,   125,   126,
     127,   128,    -1,   130,   131,   132,    -1,   134,   135,   136,
      -1,   138,   139,   140,   141,    -1,   143,   144,   145,    -1,
      -1,   148,    -1,   150,   151,   152,   153,    -1,   155,    -1,
     157,   158,    -1,   160,   161,   162,   163,    -1,   165,    -1,
      -1,    -1,   169,    -1,   171,   172,   173,   174,   175,   176,
     177,   178,   179,   180,   181,   182,   183,   184,   185,   186,
     187,    -1,   189,   190,   191,   192,   193,   194,   195,   196,
     197,    -1,   199,    -1,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,    -1,    -1,   213,    -1,   215,   216,
     217,    -1,   219,   220,   221,    -1,    -1,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,    -1,    -1,
     247,   248,   249,   250,    -1,    -1,   253,   254,   255,   256,
     257,    -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,
     267,   268,   269,   270,   271,    -1,   273,   274,   275,   276,
     277,   278,   279,   280,    -1,   282,   283,    -1,   285,    -1,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,    -1,
     317,   318,   319,   320,   321,   322,    -1,   324,   325,   326,
     327,   328,   329,   330,   331,    -1,   333,   334,   335,   336,
     337,    -1,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,    -1,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,    -1,    -1,   363,   364,    -1,   366,
     367,   368,   369,   370,   371,   372,    -1,   374,   375,    -1,
      -1,   378,   379,    -1,   381,    -1,    -1,   384,   385,   386,
     387,   388,   389,   390,    -1,    -1,   393,   394,   395,   396,
     397,    -1,    -1,   400,   401,   402,   403,   404,    -1,   406,
     407,   408,   409,   410,   411,   412,   413,    -1,    -1,   416,
      -1,    -1,   419,   420,   421,   422,   423,   424,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,   434,   435,   436,
      -1,    -1,    -1,    18,    19,    20,    21,    22,    23,    24,
      25,    -1,    27,    28,    29,    -1,    -1,   454,    -1,    34,
      -1,    -1,    37,    38,    -1,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    -1,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    -1,
      65,    66,    67,    68,    69,    -1,    71,    -1,    73,    74,
      75,    76,    77,    78,    79,    80,    -1,    82,    83,    84,
      85,    86,    87,    -1,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
     115,   116,   117,    -1,   119,   120,   121,    -1,    -1,   124,
     125,   126,   127,   128,    -1,   130,   131,   132,    -1,   134,
     135,   136,    -1,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,    -1,   150,   151,   152,   153,    -1,
     155,    -1,   157,   158,    -1,   160,   161,   162,   163,    -1,
     165,   166,    -1,   168,   169,    -1,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,    -1,   182,   183,   184,
     185,   186,   187,    -1,   189,   190,   191,   192,   193,   194,
     195,   196,   197,    -1,   199,    -1,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,    -1,    -1,   213,   214,
     215,   216,   217,    -1,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,    -1,   259,    -1,    -1,   262,   263,   264,
      -1,    -1,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,    -1,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,    -1,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,    -1,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,    -1,   374,
     375,    -1,    -1,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,    -1,   392,   393,   394,
     395,   396,   397,   398,    -1,   400,   401,   402,   403,   404,
     405,   406,    -1,   408,   409,   410,   411,   412,   413,    -1,
      -1,   416,    -1,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,    -1,   439,    -1,    -1,    -1,    -1,   444,
     445,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   453,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      34,    -1,    -1,    37,    38,    -1,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    -1,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      -1,    65,    66,    67,    68,    69,    -1,    71,    -1,    73,
      74,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    -1,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,    -1,   110,    -1,   112,   113,
     114,   115,   116,   117,    -1,   119,   120,   121,    -1,    -1,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,    -1,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,    -1,   150,   151,   152,   153,
      -1,   155,    -1,   157,   158,    -1,   160,   161,   162,   163,
      -1,   165,   166,    -1,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,   183,
     184,   185,   186,   187,    -1,   189,   190,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,    -1,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,    -1,    -1,   213,
     214,   215,   216,   217,    -1,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,    -1,   259,    -1,    -1,   262,   263,
     264,    -1,    -1,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,    -1,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,    -1,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,    -1,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,    -1,
     374,   375,    -1,    -1,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,    -1,   392,   393,
     394,   395,   396,   397,   398,    -1,   400,   401,   402,   403,
     404,   405,   406,    -1,   408,   409,   410,   411,   412,   413,
      -1,    -1,   416,    -1,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,    -1,   439,    -1,    -1,    -1,    -1,
     444,   445,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   453,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,
      -1,    34,    -1,    -1,    37,    38,    -1,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    -1,    65,    66,    67,    68,    69,    -1,    71,    -1,
      73,    74,    75,    76,    77,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    -1,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,    -1,   110,    -1,   112,
     113,   114,   115,   116,   117,    -1,   119,   120,   121,    -1,
      -1,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
      -1,   134,   135,   136,    -1,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,    -1,   150,   151,   152,
     153,    -1,   155,    -1,   157,   158,   159,   160,   161,   162,
     163,    -1,   165,   166,    -1,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,    -1,   182,
     183,   184,   185,   186,   187,    -1,   189,   190,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,    -1,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,    -1,   212,
     213,   214,   215,   216,   217,    -1,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,    -1,   259,    -1,    -1,   262,
     263,   264,    -1,    -1,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,    -1,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,    -1,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,    -1,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,    -1,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,    -1,
     363,   364,    -1,   366,   367,   368,   369,   370,   371,   372,
      -1,   374,   375,    -1,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,    -1,   392,
     393,   394,   395,   396,   397,   398,    -1,   400,   401,   402,
     403,   404,   405,   406,    -1,   408,   409,   410,   411,   412,
     413,    -1,    -1,   416,    -1,    -1,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,    -1,    -1,    -1,    -1,    -1,
      -1,   444,   445,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     453,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    34,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    -1,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    -1,    65,    66,    67,    68,    69,    -1,    71,
      -1,    73,    74,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    -1,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,    -1,   110,    -1,
     112,   113,   114,   115,   116,   117,    -1,   119,   120,   121,
      -1,    -1,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,    -1,   134,   135,   136,    -1,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,    -1,   150,   151,
     152,   153,    -1,   155,    -1,   157,   158,    -1,   160,   161,
     162,   163,    -1,   165,   166,    -1,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,   177,   178,   179,   180,    -1,
     182,   183,   184,   185,   186,   187,    -1,   189,   190,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,    -1,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,    -1,
      -1,   213,   214,   215,   216,   217,    -1,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,    -1,   259,    -1,    -1,
     262,   263,   264,    -1,    -1,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,    -1,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
      -1,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,    -1,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
      -1,   363,   364,    -1,   366,   367,   368,   369,   370,   371,
     372,    -1,   374,   375,    -1,    -1,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,    -1,
     392,   393,   394,   395,   396,   397,   398,    -1,   400,   401,
     402,   403,   404,   405,   406,    -1,   408,   409,   410,   411,
     412,   413,    -1,    -1,   416,    -1,    -1,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,    -1,    -1,    -1,    -1,
      -1,    -1,   444,   445,    -1,    -1,    -1,    -1,    -1,   451,
     452,   453,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    27,    28,    29,    -1,
      -1,    -1,    -1,    34,    -1,    -1,    37,    38,    -1,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      -1,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    -1,    65,    66,    67,    68,    69,    -1,
      71,    -1,    73,    74,    75,    76,    77,    78,    79,    80,
      -1,    82,    83,    84,    85,    86,    87,    -1,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,    -1,   110,
      -1,   112,   113,   114,   115,   116,   117,    -1,   119,   120,
     121,    -1,    -1,   124,   125,   126,   127,   128,    -1,   130,
     131,   132,    -1,   134,   135,   136,    -1,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,    -1,   150,
     151,   152,   153,    -1,   155,    -1,   157,   158,    -1,   160,
     161,   162,   163,    -1,   165,   166,    -1,   168,   169,    -1,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
      -1,   182,   183,   184,   185,   186,   187,    -1,   189,   190,
     191,   192,   193,   194,   195,   196,   197,    -1,   199,    -1,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
      -1,    -1,   213,   214,   215,   216,   217,    -1,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,    -1,   259,    -1,
      -1,   262,   263,   264,    -1,    -1,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
      -1,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,    -1,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,    -1,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,    -1,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,    -1,   363,   364,    -1,   366,   367,   368,   369,   370,
     371,   372,    -1,   374,   375,    -1,    -1,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
      -1,   392,   393,   394,   395,   396,   397,   398,    -1,   400,
     401,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,   412,   413,    -1,    -1,   416,    -1,    -1,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,    -1,    -1,    -1,
      -1,    -1,    -1,   444,   445,   446,    -1,    -1,    -1,    -1,
      -1,    -1,   453,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    34,    -1,    -1,    37,    38,    -1,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    -1,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    68,    69,
      -1,    71,    -1,    73,    74,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,    -1,   112,   113,   114,   115,   116,   117,    -1,   119,
     120,   121,    -1,    -1,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,    -1,   134,   135,   136,    -1,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,    -1,
     150,   151,   152,   153,    -1,   155,    -1,   157,   158,    -1,
     160,   161,   162,   163,    -1,   165,   166,    -1,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,    -1,   182,   183,   184,   185,   186,   187,    -1,   189,
     190,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
      -1,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,    -1,    -1,   213,   214,   215,   216,   217,    -1,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,    -1,   259,
      -1,    -1,   262,   263,   264,    -1,    -1,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,    -1,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,    -1,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,    -1,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,   372,    -1,   374,   375,    -1,    -1,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,    -1,   392,   393,   394,   395,   396,   397,   398,    -1,
     400,   401,   402,   403,   404,   405,   406,    -1,   408,   409,
     410,   411,   412,   413,    -1,    -1,   416,    -1,    -1,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,    -1,    -1,
      -1,    -1,    -1,    -1,   444,   445,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   453,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    -1,    -1,    -1,    34,    -1,    -1,    37,    38,
      -1,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    -1,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    -1,    65,    66,    67,    68,
      69,    -1,    71,    -1,    73,    74,    75,    76,    77,    78,
      79,    80,    -1,    82,    83,    84,    85,    86,    87,    -1,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
      -1,   110,    -1,   112,   113,   114,   115,   116,   117,    -1,
     119,   120,   121,    -1,    -1,   124,   125,   126,   127,   128,
      -1,   130,   131,   132,    -1,   134,   135,   136,    -1,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
      -1,   150,   151,   152,   153,    -1,   155,    -1,   157,   158,
      -1,   160,   161,   162,   163,    -1,   165,   166,    -1,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,    -1,   182,   183,   184,   185,   186,   187,    -1,
     189,   190,   191,   192,   193,   194,   195,   196,   197,    -1,
     199,    -1,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,    -1,    -1,   213,   214,   215,   216,   217,    -1,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,    -1,
     259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,    -1,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,    -1,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
      -1,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,    -1,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,   372,    -1,   374,   375,    -1,    -1,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,    -1,   392,   393,   394,   395,   396,   397,   398,
      -1,   400,   401,   402,   403,   404,   405,   406,    -1,   408,
     409,   410,   411,   412,   413,    -1,    -1,   416,    -1,    -1,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,    -1,
      -1,    -1,    -1,    -1,    -1,   444,   445,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   453,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    34,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    -1,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    71,    -1,    73,    74,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
     158,   159,   160,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,   190,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,   215,   216,   217,
      -1,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,    -1,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,    -1,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,    -1,   363,   364,    -1,   366,   367,
     368,   369,   370,   371,   372,    -1,   374,   375,    -1,    -1,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,    -1,   392,   393,   394,   395,   396,   397,
     398,    -1,   400,   401,   402,   403,   404,   405,   406,    -1,
     408,   409,   410,   411,   412,   413,    -1,    -1,   416,    -1,
      -1,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
      -1,    -1,    -1,    -1,    -1,    -1,   444,   445,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   453,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    18,    19,    20,    21,    22,    23,    24,    25,    -1,
      27,    28,    29,    -1,    -1,    -1,    -1,    34,    -1,    -1,
      37,    38,    -1,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    -1,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    -1,    65,    66,
      67,    68,    69,    -1,    71,    -1,    73,    74,    75,    76,
      77,    78,    79,    80,    -1,    82,    83,    84,    85,    86,
      87,    -1,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,    -1,   110,    -1,   112,   113,   114,   115,   116,
     117,    -1,   119,   120,   121,    -1,    -1,   124,   125,   126,
     127,   128,    -1,   130,   131,   132,    -1,   134,   135,   136,
      -1,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,    -1,   150,   151,   152,   153,    -1,   155,    -1,
     157,   158,    -1,   160,   161,   162,   163,    -1,   165,   166,
      -1,   168,   169,    -1,   171,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,   183,   184,   185,   186,
     187,    -1,   189,   190,   191,   192,   193,   194,   195,   196,
     197,    -1,   199,    -1,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,    -1,    -1,   213,   214,   215,   216,
     217,    -1,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,    -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,    -1,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,    -1,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,    -1,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,    -1,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,    -1,   363,   364,    -1,   366,
     367,   368,   369,   370,   371,   372,    -1,   374,   375,    -1,
      -1,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,    -1,   392,   393,   394,   395,   396,
     397,   398,    -1,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,    -1,    -1,   416,
      -1,    -1,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,    -1,    -1,    -1,    -1,    -1,    -1,   444,   445,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   453,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    34,    -1,
      -1,    37,    38,    -1,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    -1,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    -1,    65,
      66,    67,    68,    69,    -1,    71,    -1,    73,    74,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    -1,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,    -1,   110,    -1,   112,   113,   114,   115,
     116,   117,    -1,   119,   120,   121,    -1,    -1,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,    -1,   134,   135,
     136,    -1,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,    -1,   150,   151,   152,   153,    -1,   155,
      -1,   157,   158,    -1,   160,   161,   162,   163,    -1,   165,
     166,    -1,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,    -1,   182,   183,   184,   185,
     186,   187,    -1,   189,   190,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,    -1,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,    -1,    -1,   213,   214,   215,
     216,   217,    -1,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,    -1,   259,    -1,    -1,   262,   263,   264,    -1,
      -1,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,    -1,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,    -1,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,    -1,   363,   364,    -1,
     366,   367,   368,   369,   370,   371,   372,    -1,   374,   375,
      -1,    -1,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,    -1,   392,   393,   394,   395,
     396,   397,   398,    -1,   400,   401,   402,   403,   404,   405,
     406,    -1,   408,   409,   410,   411,   412,   413,    -1,    -1,
     416,    -1,    -1,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,    -1,    -1,    -1,    -1,    -1,    -1,   444,   445,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   453,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    18,    19,    20,    21,    22,    23,    24,
      25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,    34,
      -1,    -1,    37,    38,    -1,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    -1,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    -1,
      65,    66,    67,    68,    69,    -1,    71,    -1,    73,    74,
      75,    76,    77,    78,    79,    80,    -1,    82,    83,    84,
      85,    86,    87,    -1,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,    -1,   110,    -1,   112,   113,   114,
     115,   116,   117,    -1,   119,   120,   121,    -1,    -1,   124,
     125,   126,   127,   128,    -1,   130,   131,   132,    -1,   134,
     135,   136,    -1,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,    -1,   150,   151,   152,   153,    -1,
     155,    -1,   157,   158,    -1,   160,   161,   162,   163,    -1,
     165,   166,    -1,   168,   169,    -1,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,    -1,   182,   183,   184,
     185,   186,   187,    -1,   189,   190,   191,   192,   193,   194,
     195,   196,   197,    -1,   199,    -1,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,    -1,    -1,   213,   214,
     215,   216,   217,    -1,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,    -1,   259,    -1,    -1,   262,   263,   264,
      -1,    -1,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,    -1,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,    -1,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,    -1,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,    -1,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,   372,    -1,   374,
     375,    -1,    -1,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,    -1,   392,   393,   394,
     395,   396,   397,   398,    -1,   400,   401,   402,   403,   404,
     405,   406,    -1,   408,   409,   410,   411,   412,   413,    -1,
      -1,   416,    -1,    -1,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,    -1,    -1,    -1,    -1,    -1,    -1,   444,
     445,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   453,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      34,    -1,    -1,    37,    38,    -1,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    -1,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      -1,    65,    66,    67,    68,    69,    -1,    71,    -1,    73,
      74,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    -1,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,    -1,   110,    -1,   112,   113,
     114,   115,   116,   117,    -1,   119,   120,   121,    -1,    -1,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,    -1,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,    -1,   150,   151,   152,   153,
      -1,   155,    -1,   157,   158,    -1,   160,   161,   162,   163,
      -1,   165,   166,    -1,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,   183,
     184,   185,   186,   187,    -1,   189,   190,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,    -1,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,    -1,    -1,   213,
     214,   215,   216,   217,    -1,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,    -1,   259,    -1,    -1,   262,   263,
     264,    -1,    -1,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,    -1,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,    -1,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,    -1,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,    -1,   363,
     364,    -1,   366,   367,   368,   369,   370,   371,   372,    -1,
     374,   375,    -1,    -1,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,    -1,   392,   393,
     394,   395,   396,   397,   398,    -1,   400,   401,   402,   403,
     404,   405,   406,    -1,   408,   409,   410,   411,   412,   413,
      -1,    -1,   416,    -1,    -1,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,    -1,    -1,    -1,    -1,    -1,    -1,
     444,   445,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   453,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,
      -1,    34,    -1,    -1,    37,    38,    -1,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    -1,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    -1,    65,    66,    67,    68,    69,    -1,    71,    -1,
      73,    74,    75,    76,    77,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    -1,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,    -1,   110,    -1,   112,
     113,   114,   115,   116,   117,    -1,   119,   120,   121,    -1,
      -1,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
      -1,   134,   135,   136,    -1,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,    -1,   150,   151,   152,
     153,    -1,   155,    -1,   157,   158,    -1,   160,   161,   162,
     163,    -1,   165,   166,    -1,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,    -1,   182,
     183,   184,   185,   186,   187,    -1,   189,   190,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,    -1,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,    -1,    -1,
     213,   214,   215,   216,   217,    -1,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,    -1,   259,    -1,    -1,   262,
     263,   264,    -1,    -1,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,    -1,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,    -1,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,    -1,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,    -1,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,    -1,
     363,   364,    -1,   366,   367,   368,   369,   370,   371,   372,
      -1,   374,   375,    -1,    -1,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,    -1,   392,
     393,   394,   395,   396,   397,   398,    -1,   400,   401,   402,
     403,   404,   405,   406,    -1,   408,   409,   410,   411,   412,
     413,    -1,    -1,   416,    -1,    -1,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,    -1,    -1,    -1,    -1,    -1,
      -1,   444,   445,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     453,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    34,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    -1,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    -1,    65,    66,    67,    68,    69,    -1,    71,
      -1,    73,    74,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    -1,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,    -1,   110,    -1,
     112,   113,   114,   115,   116,   117,    -1,   119,   120,   121,
      -1,    -1,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,    -1,   134,   135,   136,    -1,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,    -1,   150,   151,
     152,   153,    -1,   155,    -1,   157,   158,    -1,   160,   161,
     162,   163,    -1,   165,   166,    -1,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,   177,   178,   179,   180,    -1,
     182,   183,   184,   185,   186,   187,    -1,   189,   190,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,    -1,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,    -1,
      -1,   213,   214,   215,   216,   217,    -1,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,    -1,   259,    -1,    -1,
     262,   263,   264,    -1,    -1,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,    -1,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
      -1,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,    -1,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
      -1,   363,   364,    -1,   366,   367,   368,   369,   370,   371,
     372,    -1,   374,   375,    -1,    -1,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,    -1,
     392,   393,   394,   395,   396,   397,   398,    -1,   400,   401,
     402,   403,   404,   405,   406,    -1,   408,   409,   410,   411,
     412,   413,    -1,    -1,   416,    -1,    -1,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,    -1,    -1,    -1,    -1,
      -1,    -1,   444,   445,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   453,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    27,    28,    29,    -1,
      -1,    -1,    -1,    34,    -1,    -1,    37,    38,    -1,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      -1,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    -1,    65,    66,    67,    68,    69,    -1,
      71,    -1,    73,    74,    75,    76,    77,    78,    79,    80,
      -1,    82,    83,    84,    85,    86,    87,    -1,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,    -1,   110,
      -1,   112,   113,   114,   115,   116,   117,    -1,   119,   120,
     121,    -1,    -1,   124,   125,   126,   127,   128,    -1,   130,
     131,   132,    -1,   134,   135,   136,    -1,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,    -1,   150,
     151,   152,   153,    -1,   155,    -1,   157,   158,    -1,   160,
     161,   162,   163,    -1,   165,   166,    -1,   168,   169,    -1,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
      -1,   182,   183,   184,   185,   186,   187,    -1,   189,   190,
     191,   192,   193,   194,   195,   196,   197,    -1,   199,    -1,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
      -1,    -1,   213,   214,   215,   216,   217,    -1,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,    -1,   259,    -1,
      -1,   262,   263,   264,    -1,    -1,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
      -1,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,    -1,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,    -1,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,    -1,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,    -1,   363,   364,    -1,   366,   367,   368,   369,   370,
     371,   372,    -1,   374,   375,    -1,    -1,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
      -1,   392,   393,   394,   395,   396,   397,   398,    -1,   400,
     401,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,   412,   413,    -1,    -1,   416,    -1,    -1,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,    -1,    -1,    -1,
      -1,    -1,    -1,   444,   445,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   453,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    34,    -1,    -1,    37,    38,    -1,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    -1,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    68,    69,
      -1,    71,    -1,    73,    74,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,    -1,
     110,    -1,   112,   113,   114,   115,   116,   117,    -1,   119,
     120,   121,    -1,    -1,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,    -1,   134,   135,   136,    -1,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,    -1,
     150,   151,   152,   153,    -1,   155,    -1,   157,   158,    -1,
     160,   161,   162,   163,    -1,   165,   166,    -1,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,    -1,   182,   183,   184,   185,   186,   187,    -1,   189,
     190,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
      -1,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,    -1,    -1,   213,   214,   215,   216,   217,    -1,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,    -1,   259,
      -1,    -1,   262,   263,   264,    -1,    -1,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,    -1,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,    -1,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,    -1,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,   372,    -1,   374,   375,    -1,    -1,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,    -1,   392,   393,   394,   395,   396,   397,   398,    -1,
     400,   401,   402,   403,   404,   405,   406,    -1,   408,   409,
     410,   411,   412,   413,    -1,    -1,   416,    -1,    -1,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,    -1,    -1,
      -1,    -1,    -1,    -1,   444,   445,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   453,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,    27,    28,
      29,    -1,    -1,    -1,    -1,    34,    -1,    -1,    37,    38,
      -1,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    -1,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    -1,    65,    66,    67,    68,
      69,    -1,    71,    -1,    73,    74,    75,    76,    77,    78,
      79,    80,    -1,    82,    83,    84,    85,    86,    87,    -1,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
      -1,   110,    -1,   112,   113,   114,   115,   116,   117,    -1,
     119,   120,   121,    -1,    -1,   124,   125,   126,   127,   128,
      -1,   130,   131,   132,    -1,   134,   135,   136,    -1,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
      -1,   150,   151,   152,   153,    -1,   155,    -1,   157,   158,
      -1,   160,   161,   162,   163,    -1,   165,   166,    -1,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,    -1,   182,   183,   184,   185,   186,   187,    -1,
     189,   190,   191,   192,   193,   194,   195,   196,   197,    -1,
     199,    -1,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,    -1,    -1,   213,   214,   215,   216,   217,    -1,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,    -1,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,    -1,
     259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,    -1,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,    -1,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
      -1,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,    -1,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,   372,    -1,   374,   375,    -1,    -1,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,    -1,    -1,   393,   394,   395,   396,   397,   398,
      -1,   400,   401,   402,   403,   404,   405,   406,    -1,   408,
     409,   410,   411,   412,   413,    -1,    -1,   416,    -1,    -1,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   444,   445,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   453,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    34,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    -1,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    71,    -1,    73,    74,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
     158,    -1,   160,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,   190,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,    -1,    -1,   204,   205,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,   215,   216,   217,
      -1,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,    -1,   250,   251,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,    -1,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,    -1,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,    -1,   363,   364,    -1,   366,   367,
     368,   369,   370,   371,   372,    -1,   374,   375,    -1,    -1,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,    -1,   392,   393,   394,   395,   396,   397,
     398,    -1,   400,   401,   402,   403,   404,   405,   406,    -1,
     408,   409,   410,   411,   412,   413,    -1,    -1,   416,    -1,
      -1,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
      -1,    -1,    -1,    -1,    -1,    -1,   444,   445,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   453,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    18,    19,    20,    21,    22,    23,    24,    25,    -1,
      27,    28,    29,    -1,    -1,    -1,    -1,    34,    -1,    -1,
      37,    38,    -1,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    -1,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    -1,    65,    66,
      67,    68,    69,    -1,    71,    -1,    73,    74,    75,    76,
      77,    78,    79,    80,    -1,    82,    83,    84,    85,    86,
      87,    -1,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,    -1,   110,    -1,   112,   113,   114,   115,   116,
     117,    -1,   119,   120,   121,    -1,    -1,   124,   125,   126,
     127,   128,    -1,   130,   131,   132,    -1,   134,   135,   136,
      -1,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,    -1,   150,   151,   152,   153,    -1,   155,    -1,
     157,   158,    -1,   160,   161,   162,   163,    -1,   165,   166,
      -1,   168,   169,    -1,   171,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,   183,   184,   185,   186,
     187,    -1,   189,   190,   191,   192,   193,   194,   195,   196,
     197,    -1,   199,    -1,   201,    -1,   203,   204,   205,   206,
     207,   208,   209,   210,    -1,    -1,   213,   214,   215,   216,
     217,    -1,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,    -1,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,    -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,    -1,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,    -1,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,    -1,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,    -1,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,    -1,   363,   364,    -1,   366,
     367,   368,   369,   370,   371,   372,    -1,   374,   375,    -1,
      -1,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,    -1,    -1,   393,   394,   395,   396,
     397,   398,    -1,   400,   401,   402,   403,   404,   405,   406,
      -1,   408,   409,   410,   411,   412,   413,    -1,    -1,   416,
      -1,    -1,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   444,   445,    -1,
      -1,     3,     4,     5,     6,     7,   453,     9,    10,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    34,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    -1,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    -1,    65,    66,    67,    68,    69,    -1,    71,
      -1,    73,    74,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    -1,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,    -1,   110,    -1,
     112,   113,   114,   115,   116,   117,    -1,   119,   120,   121,
      -1,    -1,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,    -1,   134,   135,   136,    -1,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,    -1,   150,   151,
     152,   153,    -1,   155,    -1,   157,   158,    -1,   160,   161,
     162,   163,    -1,   165,   166,    -1,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,   177,   178,   179,   180,    -1,
     182,   183,   184,   185,   186,   187,    -1,   189,   190,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,    -1,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,    -1,
      -1,   213,   214,   215,   216,   217,    -1,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,    -1,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,    -1,   259,    -1,    -1,
     262,   263,   264,    -1,    -1,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,    -1,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
      -1,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,    -1,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
      -1,   363,   364,    -1,   366,   367,   368,   369,   370,   371,
     372,    -1,   374,   375,    -1,    -1,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,    -1,
      -1,   393,   394,   395,   396,   397,   398,    -1,   400,   401,
     402,   403,   404,   405,   406,    -1,   408,   409,   410,   411,
     412,   413,    -1,    -1,   416,    -1,    -1,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,    -1,    -1,     3,     4,     5,
       6,     7,    -1,     9,    10,    -1,    -1,    -1,    -1,    -1,
      -1,   453,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    34,    -1,
      -1,    37,    38,    -1,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    -1,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    -1,    65,
      66,    67,    68,    69,    -1,    71,    -1,    73,    74,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    -1,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,    -1,   110,    -1,   112,   113,   114,   115,
     116,   117,    -1,   119,   120,   121,    -1,    -1,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,    -1,   134,   135,
     136,    -1,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,    -1,   150,   151,   152,   153,    -1,   155,
      -1,   157,   158,    -1,   160,   161,   162,   163,    -1,   165,
     166,    -1,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,    -1,   182,   183,   184,   185,
     186,   187,    -1,   189,   190,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,    -1,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,    -1,    -1,   213,   214,   215,
     216,   217,    -1,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
      -1,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,    -1,   259,    -1,    -1,   262,   263,   264,    -1,
      -1,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,    -1,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,    -1,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,    -1,   363,   364,    -1,
     366,   367,   368,   369,   370,   371,   372,    -1,   374,   375,
      -1,    -1,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,    -1,    -1,   393,   394,   395,
     396,   397,   398,    -1,   400,   401,   402,   403,   404,   405,
     406,    -1,   408,   409,   410,   411,   412,   413,    -1,    -1,
     416,    -1,    -1,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,    -1,    -1,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    -1,    -1,    -1,    -1,    -1,   453,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    34,    -1,    -1,    37,    38,    -1,
      40,    41,    42,    43,    44,    45,    -1,    47,    48,    49,
      50,    -1,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    68,    69,
      -1,    71,    -1,    73,    74,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,    -1,
     110,    -1,   112,   113,   114,   115,   116,   117,    -1,   119,
     120,   121,    -1,    -1,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,    -1,   134,    -1,   136,    -1,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,    -1,
     150,   151,   152,   153,    -1,   155,    -1,   157,   158,    -1,
     160,   161,   162,   163,    -1,   165,   166,    -1,   168,   169,
      -1,   171,   172,   173,   174,   175,    -1,   177,   178,   179,
     180,    -1,   182,   183,   184,   185,   186,   187,    -1,   189,
     190,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
      -1,   201,    -1,    -1,   204,   205,   206,   207,   208,   209,
     210,    -1,    -1,   213,   214,   215,   216,    -1,    -1,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,    -1,
     250,   251,   252,   253,   254,   255,   256,   257,    -1,   259,
      -1,    -1,   262,   263,   264,    -1,    -1,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,    -1,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,    -1,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,    -1,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,   372,    -1,   374,   375,    -1,    -1,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,    -1,   392,   393,   394,   395,   396,   397,   398,    -1,
     400,   401,   402,   403,   404,   405,   406,    -1,   408,   409,
     410,   411,   412,   413,    -1,    -1,   416,    -1,    -1,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,    -1,    -1,     3,
      -1,    -1,    -1,    -1,   444,   445,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   453,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    -1,    52,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      -1,    65,    66,    67,    68,    69,    -1,    71,    -1,    73,
      74,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    -1,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,    -1,   110,    -1,   112,   113,
     114,   115,   116,   117,    -1,   119,   120,   121,    -1,    -1,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,    -1,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,   143,
     144,   145,   146,    -1,   148,    -1,   150,   151,   152,   153,
      -1,   155,    -1,   157,   158,    -1,   160,   161,   162,   163,
      -1,   165,   166,    -1,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,   183,
     184,   185,   186,   187,    -1,   189,   190,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,    -1,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,    -1,   213,
     214,   215,   216,   217,    -1,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,    -1,   247,   248,   249,   250,    -1,   252,   253,
     254,   255,   256,   257,    -1,   259,    -1,   261,   262,   263,
     264,    -1,    -1,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,    -1,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,    -1,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,    -1,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,    -1,
     374,   375,    -1,    -1,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,   388,   389,   390,    -1,    -1,   393,
     394,   395,   396,   397,   398,    -1,   400,   401,   402,   403,
     404,   405,   406,    -1,   408,   409,   410,   411,   412,   413,
      -1,    -1,   416,    -1,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,    -1,    -1,   439,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   453,
      -1,    18,    19,    20,    21,    22,    23,    24,    25,    -1,
      27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      37,    38,    -1,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    -1,    52,    53,    54,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    -1,    65,    66,
      67,    68,    69,    -1,    71,    -1,    73,    74,    75,    76,
      77,    78,    79,    80,    -1,    82,    83,    84,    85,    86,
      87,    -1,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,    -1,   110,    -1,   112,   113,   114,   115,   116,
     117,    -1,   119,   120,   121,    -1,    -1,   124,   125,   126,
     127,   128,    -1,   130,   131,   132,    -1,   134,   135,   136,
      -1,   138,   139,   140,   141,   142,   143,   144,   145,   146,
      -1,   148,    -1,   150,   151,   152,   153,    -1,   155,    -1,
     157,   158,    -1,   160,   161,   162,   163,    -1,   165,   166,
      -1,   168,   169,    -1,   171,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,   183,   184,   185,   186,
     187,    -1,   189,   190,   191,   192,   193,   194,   195,   196,
     197,    -1,   199,    -1,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,   211,    -1,   213,   214,   215,   216,
     217,    -1,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,    -1,
     247,   248,   249,   250,    -1,   252,   253,   254,   255,   256,
     257,    -1,   259,    -1,   261,   262,   263,   264,    -1,    -1,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,    -1,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,    -1,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,    -1,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,    -1,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,    -1,   363,   364,    -1,   366,
     367,   368,   369,   370,   371,   372,    -1,   374,   375,    -1,
      -1,   378,   379,   380,   381,   382,    -1,   384,   385,   386,
     387,   388,   389,   390,    -1,    -1,   393,   394,   395,   396,
     397,   398,    -1,   400,   401,   402,   403,   404,   405,   406,
      -1,   408,   409,   410,   411,   412,   413,    -1,    -1,   416,
      -1,    -1,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
      -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   453,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    27,    28,    29,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      -1,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    -1,    65,    66,    67,    68,    69,    -1,
      71,    -1,    73,    74,    75,    76,    77,    78,    79,    80,
      -1,    82,    83,    84,    85,    86,    87,    -1,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,    -1,   110,
      -1,   112,   113,   114,   115,   116,   117,    -1,   119,   120,
     121,    -1,    -1,   124,   125,   126,   127,   128,    -1,   130,
     131,   132,    -1,   134,   135,   136,    -1,   138,   139,   140,
     141,   142,   143,   144,   145,   146,    -1,   148,    -1,   150,
     151,   152,   153,    -1,   155,    -1,   157,   158,    -1,   160,
     161,   162,   163,    -1,   165,   166,    -1,   168,   169,    -1,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
      -1,   182,   183,   184,   185,   186,   187,    -1,   189,   190,
     191,   192,   193,   194,   195,   196,   197,    -1,   199,    -1,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
      -1,    -1,   213,   214,   215,   216,   217,    -1,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,   247,   248,   249,   250,
      -1,   252,   253,   254,   255,   256,   257,    -1,   259,    -1,
      -1,   262,   263,   264,    -1,    -1,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
      -1,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,    -1,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,    -1,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,    -1,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,    -1,   363,   364,    -1,   366,   367,   368,   369,   370,
     371,   372,    -1,   374,   375,    -1,    -1,   378,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,   388,   389,   390,
      -1,    -1,   393,   394,   395,   396,   397,   398,    -1,   400,
     401,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,   412,   413,    -1,    -1,   416,    -1,    -1,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,    -1,    -1,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   453,    18,    19,    20,    21,    22,    23,    24,
      25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    37,    38,    -1,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    -1,    52,    53,    54,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    -1,
      65,    66,    67,    68,    69,    -1,    71,    -1,    73,    74,
      75,    76,    77,    78,    79,    80,    -1,    82,    83,    84,
      85,    86,    87,    -1,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,    -1,   110,    -1,   112,   113,   114,
     115,   116,   117,    -1,   119,   120,   121,    -1,    -1,   124,
     125,   126,   127,   128,    -1,   130,   131,   132,    -1,   134,
     135,   136,    -1,   138,   139,   140,   141,   142,   143,   144,
     145,   146,    -1,   148,    -1,   150,   151,   152,   153,    -1,
     155,    -1,   157,   158,    -1,   160,   161,   162,   163,    -1,
     165,   166,    -1,   168,   169,    -1,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,    -1,   182,   183,   184,
     185,   186,   187,    -1,   189,   190,   191,   192,   193,   194,
     195,   196,   197,    -1,   199,    -1,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,    -1,    -1,   213,   214,
     215,   216,   217,    -1,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,    -1,   247,   248,   249,   250,    -1,   252,   253,   254,
     255,   256,   257,    -1,   259,    -1,    -1,   262,   263,   264,
      -1,    -1,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,    -1,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,    -1,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,    -1,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,    -1,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,   372,    -1,   374,
     375,    -1,    -1,   378,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,   388,   389,   390,    -1,    -1,   393,   394,
     395,   396,   397,   398,    -1,   400,   401,   402,   403,   404,
     405,   406,    -1,   408,   409,   410,   411,   412,   413,    -1,
      -1,   416,    -1,    -1,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,    -1,    -1,     3,     4,     5,    -1,    -1,    -1,
       9,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   453,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,    27,    28,
      29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,
      -1,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    -1,    52,    53,    54,    55,    56,    -1,    -1,
      59,    60,    61,    62,    63,    -1,    65,    66,    67,    68,
      69,    -1,    71,    -1,    73,    74,    75,    76,    77,    78,
      79,    80,    -1,    82,    83,    84,    85,    86,    87,    -1,
      89,    90,    91,    92,    -1,    -1,    -1,    96,    -1,    -1,
      -1,   100,   101,   102,   103,   104,   105,   106,   107,   108,
      -1,   110,    -1,   112,   113,   114,   115,   116,   117,    -1,
     119,   120,   121,    -1,    -1,   124,   125,   126,   127,   128,
      -1,   130,   131,   132,    -1,   134,   135,   136,    -1,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
      -1,   150,   151,   152,   153,    -1,   155,    -1,   157,   158,
      -1,   160,   161,   162,   163,    -1,   165,   166,    -1,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,    -1,   182,   183,   184,   185,   186,   187,    -1,
     189,   190,   191,   192,   193,   194,   195,   196,   197,    -1,
     199,    -1,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,    -1,    -1,   213,   214,   215,   216,   217,    -1,
     219,   220,   221,    -1,    -1,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,    -1,   247,   248,
     249,   250,    -1,   252,   253,   254,   255,   256,   257,    -1,
     259,   260,    -1,   262,   263,   264,    -1,    -1,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,    -1,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,    -1,   333,   334,   335,   336,   337,    -1,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
      -1,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,    -1,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,   372,    -1,   374,   375,    -1,    -1,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,    -1,    -1,   393,   394,   395,   396,   397,    -1,
      -1,   400,   401,   402,   403,   404,   405,   406,    -1,   408,
     409,   410,   411,   412,   413,    -1,    -1,   416,    -1,    -1,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,    -1,    -1,
       3,    -1,    -1,    -1,    -1,   444,   445,   446,    -1,    -1,
      -1,    -1,    -1,    -1,   453,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    30,    31,    -1,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    -1,    65,    66,    67,    68,    69,    -1,    71,    -1,
      73,    74,    75,    76,    77,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    -1,    89,    90,    91,    92,
      -1,    -1,    -1,    96,    -1,    -1,    -1,   100,   101,   102,
     103,   104,   105,   106,   107,   108,    -1,   110,    -1,   112,
     113,   114,   115,   116,   117,    -1,   119,   120,   121,    -1,
      -1,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
      -1,   134,   135,   136,    -1,   138,   139,   140,   141,   142,
     143,   144,   145,   146,    -1,   148,    -1,   150,   151,   152,
     153,    -1,   155,    -1,   157,   158,    -1,   160,   161,   162,
     163,    -1,   165,   166,    -1,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,    -1,   182,
     183,   184,   185,   186,   187,    -1,   189,   190,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,    -1,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,    -1,    -1,
     213,   214,   215,   216,   217,    -1,   219,   220,   221,    -1,
      -1,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,    -1,   247,   248,   249,   250,    -1,   252,
     253,   254,   255,   256,   257,    -1,   259,    -1,    -1,   262,
     263,   264,    -1,    -1,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,    -1,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,    -1,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,    -1,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,    -1,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,    -1,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
      -1,   374,   375,    -1,    -1,   378,   379,   380,   381,   382,
      -1,   384,   385,   386,   387,   388,   389,   390,    -1,    -1,
     393,   394,   395,   396,   397,    -1,    -1,   400,   401,   402,
     403,   404,   405,   406,    -1,   408,   409,   410,   411,   412,
     413,    -1,    -1,   416,    -1,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,    -1,    -1,   439,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     453,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    -1,    52,    53,    54,    55,
      56,    -1,    -1,    59,    60,    61,    62,    63,    -1,    65,
      66,    67,    68,    69,    -1,    71,    -1,    73,    74,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    -1,    89,    90,    91,    92,    -1,    -1,    -1,
      96,    -1,    -1,    -1,   100,   101,   102,   103,   104,   105,
     106,   107,   108,    -1,   110,    -1,   112,   113,   114,   115,
     116,   117,    -1,   119,   120,   121,    -1,    -1,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,    -1,   134,   135,
     136,    -1,   138,   139,   140,   141,   142,   143,   144,   145,
     146,    -1,   148,    -1,   150,   151,   152,   153,    -1,   155,
      -1,   157,   158,    -1,   160,   161,   162,   163,    -1,   165,
     166,    -1,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,    -1,   182,   183,   184,   185,
     186,   187,    -1,   189,   190,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,    -1,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,    -1,    -1,   213,   214,   215,
     216,   217,    -1,   219,   220,   221,    -1,    -1,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
      -1,   247,   248,   249,   250,    -1,   252,   253,   254,   255,
     256,   257,    -1,   259,    -1,    -1,   262,   263,   264,    -1,
      -1,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,    -1,   333,   334,   335,
     336,   337,    -1,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,    -1,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,    -1,   363,   364,    -1,
     366,   367,   368,   369,   370,   371,   372,    -1,   374,   375,
      -1,    -1,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,    -1,    -1,   393,   394,   395,
     396,   397,    -1,    -1,   400,   401,   402,   403,   404,   405,
     406,    -1,   408,   409,   410,   411,   412,   413,    -1,    -1,
     416,    -1,    -1,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   453,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    -1,    43,    44,    45,    46,    47,    -1,    49,
      50,    -1,    52,    53,    54,    55,    56,    -1,    -1,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    68,    69,
      -1,    -1,    -1,    73,    74,    75,    76,    -1,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    -1,
      90,    91,    92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     100,   101,   102,   103,   104,   105,   106,   107,   108,    -1,
     110,    -1,   112,   113,   114,   115,   116,   117,    -1,   119,
     120,   121,    -1,    -1,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,    -1,   134,   135,   136,    -1,   138,   139,
     140,   141,   142,   143,   144,   145,   146,    -1,   148,    -1,
     150,   151,   152,   153,    -1,   155,    -1,   157,    -1,    -1,
      -1,   161,   162,   163,    -1,   165,   166,    -1,   168,   169,
      -1,   171,   172,   173,   174,   175,    -1,   177,   178,   179,
     180,    -1,   182,   183,   184,   185,   186,   187,    -1,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
      -1,   201,    -1,    -1,   204,    -1,   206,   207,   208,   209,
     210,    -1,    -1,   213,   214,    -1,   216,    -1,    -1,   219,
     220,   221,    -1,    -1,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,    -1,   242,   243,   244,   245,    -1,   247,   248,    -1,
     250,    -1,   252,   253,   254,   255,   256,   257,    -1,   259,
      -1,    -1,   262,   263,   264,    -1,    -1,   267,   268,    -1,
     270,    -1,   272,   273,   274,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,    -1,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,    -1,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,    -1,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,    -1,   363,   364,   365,   366,    -1,   368,   369,
     370,   371,   372,    -1,   374,   375,    -1,    -1,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,    -1,    -1,   393,   394,   395,   396,   397,    -1,    -1,
     400,   401,   402,   403,   404,   405,   406,    -1,   408,    -1,
     410,   411,   412,   413,    -1,    -1,   416,    -1,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,    -1,    -1,   439,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   453,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,
      43,    44,    45,    46,    47,    -1,    49,    50,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,
      73,    74,    75,    76,    -1,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    -1,    -1,    90,    91,    92,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,
     103,   104,   105,   106,   107,   108,    -1,   110,    -1,   112,
     113,   114,   115,   116,   117,    -1,   119,   120,   121,    -1,
      -1,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
      -1,   134,   135,   136,    -1,   138,   139,   140,   141,   142,
     143,   144,   145,   146,    -1,   148,    -1,   150,   151,   152,
     153,    -1,   155,    -1,   157,    -1,    -1,    -1,   161,   162,
     163,    -1,   165,   166,    -1,   168,   169,    -1,   171,   172,
     173,   174,   175,    -1,   177,   178,   179,   180,    -1,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,    -1,   201,    -1,
      -1,   204,    -1,   206,   207,   208,   209,   210,    -1,    -1,
     213,   214,    -1,   216,    -1,    -1,   219,   220,   221,    -1,
      -1,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,    -1,   242,
     243,   244,   245,    -1,   247,   248,    -1,   250,    -1,   252,
     253,   254,   255,   256,   257,    -1,   259,    -1,    -1,   262,
     263,   264,    -1,    -1,   267,   268,    -1,   270,    -1,   272,
     273,   274,   275,   276,   277,   278,   279,   280,    -1,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,    -1,   317,   318,    -1,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,    -1,
     333,   334,   335,   336,   337,    -1,   339,   340,   341,   342,
     343,    -1,   345,   346,   347,   348,    -1,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,    -1,
     363,   364,    -1,   366,    -1,   368,   369,   370,   371,   372,
      -1,   374,   375,    -1,    -1,   378,   379,   380,   381,   382,
      -1,   384,   385,   386,   387,   388,   389,   390,    -1,    -1,
     393,   394,   395,   396,   397,    -1,    -1,   400,   401,   402,
     403,   404,   405,   406,    -1,   408,    -1,   410,   411,   412,
     413,    -1,    -1,   416,    -1,    -1,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,    -1,    -1,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     453,    18,    19,    20,    21,    22,    23,    24,    25,    -1,
      27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      37,    38,    -1,    40,    41,    -1,    43,    44,    45,    46,
      47,    -1,    49,    50,    -1,    52,    53,    54,    55,    56,
      -1,    -1,    59,    60,    61,    62,    63,    -1,    65,    66,
      67,    68,    69,    -1,    -1,    -1,    73,    74,    75,    76,
      -1,    78,    79,    80,    -1,    82,    83,    84,    85,    86,
      87,    -1,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   100,   101,   102,   103,   104,   105,   106,
     107,   108,    -1,   110,    -1,   112,   113,   114,   115,   116,
     117,    -1,   119,   120,   121,    -1,    -1,   124,   125,   126,
     127,   128,    -1,   130,   131,   132,    -1,   134,   135,   136,
      -1,   138,   139,   140,   141,   142,   143,   144,   145,   146,
      -1,   148,    -1,   150,   151,   152,   153,    -1,   155,    -1,
     157,    -1,    -1,    -1,   161,   162,   163,    -1,   165,   166,
      -1,   168,   169,    -1,   171,   172,   173,   174,   175,    -1,
     177,   178,   179,   180,    -1,   182,   183,   184,   185,   186,
     187,    -1,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,    -1,   199,    -1,   201,    -1,    -1,   204,    -1,   206,
     207,   208,   209,   210,    -1,    -1,   213,   214,    -1,   216,
      -1,    -1,   219,   220,   221,    -1,    -1,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,    -1,   242,   243,   244,   245,    -1,
     247,   248,    -1,   250,    -1,   252,   253,   254,   255,   256,
     257,    -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,
     267,   268,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,   278,   279,   280,    -1,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,    -1,
     317,   318,    -1,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,    -1,   333,   334,   335,   336,
     337,    -1,   339,   340,   341,   342,   343,    -1,   345,   346,
     347,   348,    -1,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,    -1,   363,   364,    -1,   366,
      -1,   368,   369,   370,   371,   372,    -1,   374,   375,    -1,
      -1,   378,   379,   380,   381,   382,    -1,   384,   385,   386,
     387,   388,   389,   390,    -1,    -1,   393,   394,   395,   396,
     397,    -1,    -1,   400,   401,   402,   403,   404,   405,   406,
      -1,   408,    -1,   410,   411,   412,   413,    -1,    -1,   416,
      -1,    -1,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
      -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   453,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    27,    28,    29,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,
      41,    -1,    43,    44,    45,    46,    47,    -1,    49,    50,
      -1,    52,    53,    54,    55,    56,    -1,    -1,    59,    60,
      61,    62,    63,    -1,    65,    66,    67,    68,    69,    -1,
      -1,    -1,    73,    74,    75,    76,    -1,    78,    79,    80,
      -1,    82,    83,    84,    85,    86,    87,    -1,    -1,    90,
      91,    92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,
     101,   102,   103,   104,   105,   106,   107,   108,    -1,   110,
      -1,   112,   113,   114,   115,   116,   117,    -1,   119,   120,
     121,    -1,    -1,   124,   125,   126,   127,   128,    -1,   130,
     131,   132,    -1,   134,   135,   136,    -1,   138,   139,   140,
     141,   142,   143,   144,   145,   146,    -1,   148,    -1,   150,
     151,   152,   153,    -1,   155,    -1,   157,    -1,    -1,    -1,
     161,   162,   163,    -1,   165,   166,    -1,   168,   169,    -1,
     171,   172,   173,   174,   175,    -1,   177,   178,   179,   180,
      -1,   182,   183,   184,   185,   186,   187,    -1,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,    -1,   199,    -1,
     201,    -1,    -1,   204,    -1,   206,   207,   208,   209,   210,
      -1,    -1,   213,   214,    -1,   216,    -1,    -1,   219,   220,
     221,    -1,    -1,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
      -1,   242,   243,   244,   245,    -1,   247,   248,    -1,   250,
      -1,   252,   253,   254,   255,   256,   257,    -1,   259,    -1,
      -1,   262,   263,   264,    -1,    -1,   267,   268,    -1,   270,
      -1,   272,   273,   274,   275,   276,   277,   278,   279,   280,
      -1,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,    -1,   317,   318,    -1,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,    -1,   333,   334,   335,   336,   337,    -1,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,    -1,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,    -1,   363,   364,    -1,   366,    -1,   368,   369,   370,
     371,   372,    -1,   374,   375,    -1,    -1,   378,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,   388,   389,   390,
      -1,    -1,   393,   394,   395,   396,   397,    -1,    -1,   400,
     401,   402,   403,   404,   405,   406,    -1,   408,    -1,   410,
     411,   412,   413,    -1,    -1,   416,    -1,    -1,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,    -1,    -1,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   453,    18,    19,    20,    21,    22,    23,    24,
      25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    37,    38,    -1,    40,    41,    -1,    43,    44,
      45,    46,    47,    -1,    49,    50,    -1,    52,    53,    54,
      55,    56,    -1,    -1,    59,    60,    61,    62,    63,    -1,
      65,    66,    67,    68,    69,    -1,    -1,    -1,    73,    74,
      75,    76,    -1,    78,    79,    80,    -1,    82,    83,    84,
      85,    86,    87,    -1,    -1,    90,    91,    92,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   100,   101,   102,   103,   104,
     105,   106,   107,   108,    -1,   110,    -1,   112,   113,   114,
     115,   116,   117,    -1,   119,   120,   121,    -1,    -1,   124,
     125,   126,   127,   128,    -1,   130,   131,   132,    -1,   134,
     135,   136,    -1,   138,   139,   140,   141,   142,   143,   144,
     145,   146,    -1,   148,    -1,   150,   151,   152,   153,    -1,
     155,    -1,   157,    -1,    -1,    -1,   161,   162,   163,    -1,
     165,   166,    -1,   168,   169,    -1,   171,   172,   173,   174,
     175,    -1,   177,   178,   179,   180,    -1,   182,   183,   184,
     185,   186,   187,    -1,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,    -1,   199,    -1,   201,    -1,    -1,   204,
      -1,   206,   207,   208,   209,   210,    -1,    -1,   213,   214,
      -1,   216,    -1,    -1,   219,   220,   221,    -1,    -1,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,    -1,   242,   243,   244,
     245,    -1,   247,   248,    -1,   250,    -1,   252,   253,   254,
     255,   256,   257,    -1,   259,    -1,    -1,   262,   263,   264,
      -1,    -1,   267,   268,    -1,   270,    -1,   272,   273,   274,
     275,   276,   277,   278,   279,   280,    -1,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,   317,   318,    -1,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,    -1,   333,   334,
     335,   336,   337,    -1,   339,   340,   341,   342,   343,    -1,
     345,   346,   347,   348,    -1,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,    -1,   363,   364,
      -1,   366,    -1,   368,   369,   370,   371,   372,    -1,   374,
     375,    -1,    -1,   378,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,   388,   389,   390,    -1,    -1,   393,   394,
     395,   396,   397,    -1,    -1,   400,   401,   402,   403,   404,
     405,   406,    -1,   408,    -1,   410,   411,   412,   413,    -1,
      -1,   416,    -1,    -1,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,    -1,    -1,    -1,    -1,    -1,     3,     4,     5,
      -1,    -1,     8,     9,    -1,    -1,    -1,    -1,   453,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      -1,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    -1,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
      -1,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
      -1,   167,    -1,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,    -1,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,    -1,   269,   270,   271,    -1,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,    -1,   285,
      -1,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,    -1,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,    -1,   381,    -1,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,    -1,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   434,   435,
     436,    -1,    -1,    -1,   440,   441,   442,    -1,   444,   445,
     446,   447,   448,   449,     3,     4,     5,    -1,    -1,     8,
       9,    -1,    -1,    -1,    -1,    -1,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    -1,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      -1,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,    -1,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,    -1,   167,    -1,
     169,   170,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,    -1,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,    -1,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,    -1,   246,   247,   248,
     249,   250,   251,    -1,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,    -1,
     269,   270,   271,    -1,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,    -1,   285,    -1,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,    -1,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,    -1,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,    -1,   381,    -1,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,    -1,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   434,   435,   436,    -1,     3,
      -1,   440,   441,   442,     8,   444,   445,   446,   447,   448,
     449,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,    43,
      44,    45,    46,    47,    -1,    49,    50,    -1,    52,    53,
      54,    55,    56,    -1,    -1,    59,    60,    61,    62,    63,
      -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,    73,
      74,    75,    76,    -1,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    -1,    -1,    90,    91,    92,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,   103,
     104,   105,   106,   107,   108,    -1,   110,    -1,   112,   113,
     114,   115,   116,   117,    -1,   119,   120,   121,    -1,    -1,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,    -1,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,   143,
     144,   145,   146,    -1,   148,    -1,   150,   151,   152,   153,
      -1,   155,    -1,   157,    -1,    -1,    -1,   161,   162,   163,
      -1,   165,   166,    -1,   168,   169,    -1,   171,   172,   173,
     174,   175,    -1,   177,   178,   179,   180,    -1,   182,   183,
     184,   185,   186,   187,    -1,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,    -1,   201,    -1,    -1,
     204,    -1,   206,   207,   208,   209,   210,    -1,    -1,   213,
     214,    -1,   216,    -1,    -1,   219,   220,   221,    -1,    -1,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,    -1,   242,   243,
     244,   245,    -1,   247,   248,    -1,   250,    -1,   252,   253,
     254,   255,   256,   257,    -1,   259,    -1,    -1,   262,   263,
     264,    -1,    -1,   267,   268,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,   278,   279,   280,    -1,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,    -1,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,    -1,   333,
     334,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,    -1,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,    -1,   363,
     364,    -1,   366,    -1,   368,   369,   370,   371,   372,    -1,
     374,   375,    -1,    -1,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,   388,   389,   390,    -1,    -1,   393,
     394,   395,   396,   397,    -1,    -1,   400,   401,   402,   403,
     404,   405,   406,    -1,   408,    -1,   410,   411,   412,   413,
      -1,    -1,   416,    -1,    -1,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,    -1,     3,    -1,   440,   441,   442,     8,
     444,   445,   446,   447,   448,   449,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,    27,    28,
      29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,
      -1,    40,    41,    -1,    43,    44,    45,    46,    47,    -1,
      49,    50,    -1,    52,    53,    54,    55,    56,    -1,    -1,
      59,    60,    61,    62,    63,    -1,    65,    66,    67,    68,
      69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,    78,
      79,    80,    -1,    82,    83,    84,    85,    86,    87,    -1,
      -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   100,   101,   102,   103,   104,   105,   106,   107,   108,
      -1,   110,    -1,   112,   113,   114,   115,   116,   117,    -1,
     119,   120,   121,    -1,    -1,   124,   125,   126,   127,   128,
      -1,   130,   131,   132,    -1,   134,   135,   136,    -1,   138,
     139,   140,   141,   142,   143,   144,   145,   146,    -1,   148,
      -1,   150,   151,   152,   153,    -1,   155,    -1,   157,    -1,
      -1,    -1,   161,   162,   163,    -1,   165,   166,    -1,   168,
     169,    -1,   171,   172,   173,   174,   175,    -1,   177,   178,
     179,   180,    -1,   182,   183,   184,   185,   186,   187,    -1,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,    -1,
     199,    -1,   201,    -1,    -1,   204,    -1,   206,   207,   208,
     209,   210,    -1,    -1,   213,   214,    -1,   216,    -1,    -1,
     219,   220,   221,    -1,    -1,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,    -1,   242,   243,   244,   245,    -1,   247,   248,
      -1,   250,    -1,   252,   253,   254,   255,   256,   257,    -1,
     259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,   268,
      -1,   270,    -1,   272,   273,   274,   275,   276,   277,   278,
     279,   280,    -1,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,   317,   318,
      -1,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,    -1,   333,   334,   335,   336,   337,    -1,
     339,   340,   341,   342,   343,    -1,   345,   346,   347,   348,
      -1,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,    -1,   363,   364,    -1,   366,    -1,   368,
     369,   370,   371,   372,    -1,   374,   375,    -1,    -1,   378,
     379,   380,   381,   382,    -1,   384,   385,   386,   387,   388,
     389,   390,    -1,    -1,   393,   394,   395,   396,   397,    -1,
      -1,   400,   401,   402,   403,   404,   405,   406,    -1,   408,
      -1,   410,   411,   412,   413,    -1,    -1,   416,    -1,    -1,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,    -1,     3,
      -1,   440,   441,   442,     8,   444,   445,   446,   447,   448,
     449,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,    43,
      44,    45,    46,    47,    -1,    49,    50,    -1,    52,    53,
      54,    55,    56,    -1,    -1,    59,    60,    61,    62,    63,
      -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,    73,
      74,    75,    76,    -1,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    -1,    -1,    90,    91,    92,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,   103,
     104,   105,   106,   107,   108,    -1,   110,    -1,   112,   113,
     114,   115,   116,   117,    -1,   119,   120,   121,    -1,    -1,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,    -1,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,   143,
     144,   145,   146,    -1,   148,    -1,   150,   151,   152,   153,
      -1,   155,    -1,   157,    -1,    -1,    -1,   161,   162,   163,
      -1,   165,   166,    -1,   168,   169,    -1,   171,   172,   173,
     174,   175,    -1,   177,   178,   179,   180,    -1,   182,   183,
     184,   185,   186,   187,    -1,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,    -1,   201,    -1,    -1,
     204,    -1,   206,   207,   208,   209,   210,    -1,    -1,   213,
     214,    -1,   216,    -1,    -1,   219,   220,   221,    -1,    -1,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,    -1,   242,   243,
     244,   245,    -1,   247,   248,    -1,   250,    -1,   252,   253,
     254,   255,   256,   257,    -1,   259,    -1,    -1,   262,   263,
     264,    -1,    -1,   267,   268,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,   278,   279,   280,    -1,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,    -1,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,    -1,   333,
     334,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,    -1,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,    -1,   363,
     364,    -1,   366,    -1,   368,   369,   370,   371,   372,    -1,
     374,   375,    -1,    -1,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,   388,   389,   390,    -1,    -1,   393,
     394,   395,   396,   397,    -1,    -1,   400,   401,   402,   403,
     404,   405,   406,    -1,   408,    -1,   410,   411,   412,   413,
      -1,    -1,   416,    -1,    -1,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,    -1,     3,    -1,   440,   441,   442,     8,
     444,   445,   446,   447,   448,   449,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,    27,    28,
      29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,
      -1,    40,    41,    -1,    43,    44,    45,    46,    47,    -1,
      49,    50,    -1,    52,    53,    54,    55,    56,    -1,    -1,
      59,    60,    61,    62,    63,    -1,    65,    66,    67,    68,
      69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,    78,
      79,    80,    -1,    82,    83,    84,    85,    86,    87,    -1,
      -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   100,   101,   102,   103,   104,   105,   106,   107,   108,
      -1,   110,    -1,   112,   113,   114,   115,   116,   117,    -1,
     119,   120,   121,    -1,    -1,   124,   125,   126,   127,   128,
      -1,   130,   131,   132,    -1,   134,   135,   136,    -1,   138,
     139,   140,   141,   142,   143,   144,   145,   146,    -1,   148,
      -1,   150,   151,   152,   153,    -1,   155,    -1,   157,    -1,
      -1,    -1,   161,   162,   163,    -1,   165,   166,    -1,   168,
     169,    -1,   171,   172,   173,   174,   175,    -1,   177,   178,
     179,   180,    -1,   182,   183,   184,   185,   186,   187,    -1,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,    -1,
     199,    -1,   201,    -1,    -1,   204,    -1,   206,   207,   208,
     209,   210,    -1,    -1,   213,   214,    -1,   216,    -1,    -1,
     219,   220,   221,    -1,    -1,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,    -1,   242,   243,   244,   245,    -1,   247,   248,
      -1,   250,    -1,   252,   253,   254,   255,   256,   257,    -1,
     259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,   268,
      -1,   270,    -1,   272,   273,   274,   275,   276,   277,   278,
     279,   280,    -1,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,   317,   318,
      -1,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,    -1,   333,   334,   335,   336,   337,    -1,
     339,   340,   341,   342,   343,    -1,   345,   346,   347,   348,
      -1,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,    -1,   363,   364,    -1,   366,    -1,   368,
     369,   370,   371,   372,    -1,   374,   375,    -1,    -1,   378,
     379,   380,   381,   382,    -1,   384,   385,   386,   387,   388,
     389,   390,    -1,    -1,   393,   394,   395,   396,   397,    -1,
      -1,   400,   401,   402,   403,   404,   405,   406,    -1,   408,
      -1,   410,   411,   412,   413,    -1,    -1,   416,    -1,    -1,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,    -1,     3,
      -1,   440,   441,   442,     8,   444,   445,   446,   447,   448,
     449,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,    43,
      44,    45,    46,    47,    -1,    49,    50,    -1,    52,    53,
      54,    55,    56,    -1,    -1,    59,    60,    61,    62,    63,
      -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,    73,
      74,    75,    76,    -1,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    -1,    -1,    90,    91,    92,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,   103,
     104,   105,   106,   107,   108,    -1,   110,    -1,   112,   113,
     114,   115,   116,   117,    -1,   119,   120,   121,    -1,    -1,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,    -1,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,   143,
     144,   145,   146,    -1,   148,    -1,   150,   151,   152,   153,
      -1,   155,    -1,   157,    -1,    -1,    -1,   161,   162,   163,
      -1,   165,   166,    -1,   168,   169,    -1,   171,   172,   173,
     174,   175,    -1,   177,   178,   179,   180,    -1,   182,   183,
     184,   185,   186,   187,    -1,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,    -1,   201,    -1,    -1,
     204,    -1,   206,   207,   208,   209,   210,    -1,    -1,   213,
     214,    -1,   216,    -1,    -1,   219,   220,   221,    -1,    -1,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,    -1,   242,   243,
     244,   245,    -1,   247,   248,    -1,   250,    -1,   252,   253,
     254,   255,   256,   257,    -1,   259,    -1,    -1,   262,   263,
     264,    -1,    -1,   267,   268,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,   278,   279,   280,    -1,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,    -1,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,    -1,   333,
     334,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,    -1,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,    -1,   363,
     364,    -1,   366,    -1,   368,   369,   370,   371,   372,    -1,
     374,   375,    -1,    -1,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,   388,   389,   390,    -1,    -1,   393,
     394,   395,   396,   397,    -1,    -1,   400,   401,   402,   403,
     404,   405,   406,    -1,   408,    -1,   410,   411,   412,   413,
      -1,    -1,   416,    -1,    -1,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,    -1,     3,    -1,   440,   441,   442,     8,
     444,   445,   446,   447,   448,   449,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,    27,    28,
      29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,
      -1,    40,    41,    -1,    43,    44,    45,    46,    47,    -1,
      49,    50,    -1,    52,    53,    54,    55,    56,    -1,    -1,
      59,    60,    61,    62,    63,    -1,    65,    66,    67,    68,
      69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,    78,
      79,    80,    -1,    82,    83,    84,    85,    86,    87,    -1,
      -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   100,   101,   102,   103,   104,   105,   106,   107,   108,
      -1,   110,    -1,   112,   113,   114,   115,   116,   117,    -1,
     119,   120,   121,    -1,    -1,   124,   125,   126,   127,   128,
      -1,   130,   131,   132,    -1,   134,   135,   136,    -1,   138,
     139,   140,   141,   142,   143,   144,   145,   146,    -1,   148,
      -1,   150,   151,   152,   153,    -1,   155,    -1,   157,    -1,
      -1,    -1,   161,   162,   163,    -1,   165,   166,    -1,   168,
     169,    -1,   171,   172,   173,   174,   175,    -1,   177,   178,
     179,   180,    -1,   182,   183,   184,   185,   186,   187,    -1,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,    -1,
     199,    -1,   201,    -1,    -1,   204,    -1,   206,   207,   208,
     209,   210,    -1,    -1,   213,   214,    -1,   216,    -1,    -1,
     219,   220,   221,    -1,    -1,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,    -1,   242,   243,   244,   245,    -1,   247,   248,
      -1,   250,    -1,   252,   253,   254,   255,   256,   257,    -1,
     259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,   268,
      -1,   270,    -1,   272,   273,   274,   275,   276,   277,   278,
     279,   280,    -1,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,   317,   318,
      -1,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,    -1,   333,   334,   335,   336,   337,    -1,
     339,   340,   341,   342,   343,    -1,   345,   346,   347,   348,
      -1,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,    -1,   363,   364,    -1,   366,    -1,   368,
     369,   370,   371,   372,    -1,   374,   375,    -1,    -1,   378,
     379,   380,   381,   382,    -1,   384,   385,   386,   387,   388,
     389,   390,    -1,    -1,   393,   394,   395,   396,   397,    -1,
      -1,   400,   401,   402,   403,   404,   405,   406,    -1,   408,
      -1,   410,   411,   412,   413,    -1,    -1,   416,    -1,    -1,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,    -1,     3,
      -1,   440,   441,   442,     8,   444,   445,   446,   447,   448,
     449,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,    43,
      44,    45,    46,    47,    -1,    49,    50,    -1,    52,    53,
      54,    55,    56,    -1,    -1,    59,    60,    61,    62,    63,
      -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,    73,
      74,    75,    76,    -1,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    -1,    -1,    90,    91,    92,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,   103,
     104,   105,   106,   107,   108,    -1,   110,    -1,   112,   113,
     114,   115,   116,   117,    -1,   119,   120,   121,    -1,    -1,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,    -1,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,   143,
     144,   145,   146,    -1,   148,    -1,   150,   151,   152,   153,
      -1,   155,    -1,   157,    -1,    -1,    -1,   161,   162,   163,
      -1,   165,   166,    -1,   168,   169,    -1,   171,   172,   173,
     174,   175,    -1,   177,   178,   179,   180,    -1,   182,   183,
     184,   185,   186,   187,    -1,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,    -1,   201,    -1,    -1,
     204,    -1,   206,   207,   208,   209,   210,    -1,    -1,   213,
     214,    -1,   216,    -1,    -1,   219,   220,   221,    -1,    -1,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,    -1,   242,   243,
     244,   245,    -1,   247,   248,    -1,   250,    -1,   252,   253,
     254,   255,   256,   257,    -1,   259,    -1,    -1,   262,   263,
     264,    -1,    -1,   267,   268,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,   278,   279,   280,    -1,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,    -1,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,    -1,   333,
     334,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,    -1,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,    -1,   363,
     364,    -1,   366,    -1,   368,   369,   370,   371,   372,    -1,
     374,   375,    -1,    -1,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,   388,   389,   390,    -1,    -1,   393,
     394,   395,   396,   397,    -1,    -1,   400,   401,   402,   403,
     404,   405,   406,    -1,   408,    -1,   410,   411,   412,   413,
      -1,    -1,   416,    -1,    -1,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,     3,    -1,    -1,   440,   441,   442,    -1,
     444,   445,   446,   447,   448,   449,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   446,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    -1,    43,    44,    45,
      46,    47,    -1,    49,    50,    -1,    52,    53,    54,    55,
      56,    -1,    -1,    59,    60,    61,    62,    63,    -1,    65,
      66,    67,    68,    69,    -1,    -1,    -1,    73,    74,    75,
      76,    -1,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    -1,    -1,    90,    91,    92,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   100,   101,   102,   103,   104,   105,
     106,   107,   108,    -1,   110,    -1,   112,   113,   114,   115,
     116,   117,    -1,   119,   120,   121,    -1,    -1,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,    -1,   134,   135,
     136,    -1,   138,   139,   140,   141,   142,   143,   144,   145,
     146,    -1,   148,    -1,   150,   151,   152,   153,    -1,   155,
      -1,   157,    -1,    -1,    -1,   161,   162,   163,    -1,   165,
     166,    -1,   168,   169,    -1,   171,   172,   173,   174,   175,
      -1,   177,   178,   179,   180,    -1,   182,   183,   184,   185,
     186,   187,    -1,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,    -1,   201,    -1,    -1,   204,    -1,
     206,   207,   208,   209,   210,    -1,    -1,   213,   214,    -1,
     216,    -1,    -1,   219,   220,   221,    -1,    -1,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,    -1,   242,   243,   244,   245,
      -1,   247,   248,    -1,   250,    -1,   252,   253,   254,   255,
     256,   257,    -1,   259,    -1,    -1,   262,   263,   264,    -1,
      -1,   267,   268,    -1,   270,    -1,   272,   273,   274,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,    -1,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,    -1,   333,   334,   335,
     336,   337,    -1,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,    -1,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,    -1,   363,   364,    -1,
     366,    -1,   368,   369,   370,   371,   372,    -1,   374,   375,
      -1,    -1,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,    -1,    -1,   393,   394,   395,
     396,   397,    -1,    -1,   400,   401,   402,   403,   404,   405,
     406,    -1,   408,    -1,   410,   411,   412,   413,    -1,    -1,
     416,    -1,    -1,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     446,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    43,    44,    45,    -1,    47,    48,    49,    50,    -1,
      52,    53,    54,    55,    56,    -1,    -1,    59,    60,    61,
      62,    63,    -1,    65,    66,    67,    68,    -1,    -1,    71,
      -1,    73,    74,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    -1,    89,    90,    91,
      92,    -1,    -1,    -1,    96,    -1,    -1,    -1,   100,   101,
     102,   103,   104,   105,   106,   107,   108,    -1,   110,    -1,
     112,   113,   114,   115,   116,   117,    -1,   119,   120,   121,
      -1,    -1,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,    -1,   134,   135,   136,    -1,   138,   139,   140,   141,
      -1,   143,   144,   145,    -1,    -1,   148,    -1,   150,   151,
     152,   153,    -1,   155,    -1,   157,   158,    -1,   160,   161,
     162,   163,    -1,   165,    -1,    -1,    -1,   169,    -1,   171,
     172,   173,   174,   175,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,   187,    -1,   189,   190,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,    -1,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,    -1,
      -1,   213,    -1,   215,   216,   217,    -1,   219,   220,   221,
      -1,    -1,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,    -1,    -1,   247,   248,   249,   250,    -1,
      -1,   253,   254,   255,   256,   257,    -1,   259,    -1,    -1,
     262,   263,   264,    -1,   266,   267,   268,   269,   270,   271,
      -1,   273,   274,   275,   276,   277,   278,   279,   280,    -1,
     282,   283,    -1,   285,    -1,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,   319,   320,   321,
     322,    -1,   324,   325,   326,   327,   328,   329,   330,   331,
      -1,   333,   334,   335,   336,   337,    -1,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,    -1,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,    -1,
      -1,   363,   364,    -1,   366,   367,   368,   369,   370,   371,
     372,    -1,   374,   375,    -1,    -1,   378,   379,    -1,   381,
      -1,    -1,   384,   385,   386,   387,   388,   389,   390,    -1,
      -1,   393,   394,   395,   396,   397,    -1,    -1,   400,   401,
     402,   403,   404,    -1,   406,   407,   408,   409,   410,   411,
     412,   413,    -1,    -1,   416,    -1,    -1,   419,   420,   421,
     422,   423,   424,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       3,    -1,   434,   435,   436,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   446,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,
      43,    44,    45,    -1,    47,    48,    49,    50,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    -1,    65,    66,    67,    68,    -1,    -1,    71,    -1,
      73,    74,    75,    76,    77,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    -1,    89,    90,    91,    92,
      -1,    -1,    -1,    96,    -1,    -1,    -1,   100,   101,   102,
     103,   104,   105,   106,   107,   108,    -1,   110,    -1,   112,
     113,   114,   115,   116,   117,    -1,   119,   120,   121,    -1,
      -1,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
      -1,   134,   135,   136,    -1,   138,   139,   140,   141,    -1,
     143,   144,   145,    -1,    -1,   148,    -1,   150,   151,   152,
     153,    -1,   155,    -1,   157,   158,    -1,   160,   161,   162,
     163,    -1,   165,    -1,    -1,    -1,   169,    -1,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   186,   187,    -1,   189,   190,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,    -1,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,    -1,    -1,
     213,    -1,   215,   216,   217,    -1,   219,   220,   221,    -1,
      -1,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,    -1,    -1,   247,   248,   249,   250,    -1,    -1,
     253,   254,   255,   256,   257,    -1,   259,    -1,    -1,   262,
     263,   264,    -1,   266,   267,   268,   269,   270,   271,    -1,
     273,   274,   275,   276,   277,   278,   279,   280,    -1,   282,
     283,    -1,   285,    -1,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,    -1,   317,   318,   319,   320,   321,   322,
      -1,   324,   325,   326,   327,   328,   329,   330,   331,    -1,
     333,   334,   335,   336,   337,    -1,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,    -1,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,    -1,    -1,
     363,   364,    -1,   366,   367,   368,   369,   370,   371,   372,
      -1,   374,   375,    -1,    -1,   378,   379,    -1,   381,    -1,
      -1,   384,   385,   386,   387,   388,   389,   390,    -1,    -1,
     393,   394,   395,   396,   397,    -1,    -1,   400,   401,   402,
     403,   404,    -1,   406,   407,   408,   409,   410,   411,   412,
     413,    -1,    -1,   416,    -1,    -1,   419,   420,   421,   422,
     423,   424,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,
      -1,   434,   435,   436,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   446,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,    43,
      44,    45,    46,    47,    -1,    49,    50,    -1,    52,    53,
      54,    55,    56,    -1,    -1,    59,    60,    61,    62,    63,
      -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,    73,
      74,    75,    76,    -1,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    -1,    -1,    90,    91,    92,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,   103,
     104,   105,   106,   107,   108,    -1,   110,    -1,   112,   113,
     114,   115,   116,   117,    -1,   119,   120,   121,    -1,    -1,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,    -1,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,   143,
     144,   145,   146,    -1,   148,    -1,   150,   151,   152,   153,
      -1,   155,    -1,   157,    -1,    -1,    -1,   161,   162,   163,
      -1,   165,   166,    -1,   168,   169,    -1,   171,   172,   173,
     174,   175,    -1,   177,   178,   179,   180,    -1,   182,   183,
     184,   185,   186,   187,    -1,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,    -1,   201,    -1,    -1,
     204,    -1,   206,   207,   208,   209,   210,    -1,    -1,   213,
     214,    -1,   216,    -1,    -1,   219,   220,   221,    -1,    -1,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,    -1,   242,   243,
     244,   245,    -1,   247,   248,    -1,   250,    -1,   252,   253,
     254,   255,   256,   257,    -1,   259,    -1,    -1,   262,   263,
     264,    -1,    -1,   267,   268,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,   278,   279,   280,    -1,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,    -1,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,    -1,   333,
     334,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,    -1,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,    -1,   363,
     364,    -1,   366,    -1,   368,   369,   370,   371,   372,    -1,
     374,   375,    -1,    -1,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,   388,   389,   390,    -1,    -1,   393,
     394,   395,   396,   397,    -1,    -1,   400,   401,   402,   403,
     404,   405,   406,    -1,   408,    -1,   410,   411,   412,   413,
      -1,    -1,   416,    -1,    -1,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,     3,     4,     5,    -1,    -1,    -1,     9,
      -1,    -1,   446,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    -1,    52,    53,    54,    55,    56,    -1,    -1,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    68,    69,
      -1,    71,    -1,    73,    74,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    89,
      90,    91,    92,    -1,    -1,    -1,    96,    -1,    -1,    -1,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,    -1,   112,   113,   114,   115,   116,   117,    -1,   119,
     120,   121,    -1,    -1,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,    -1,   134,   135,   136,    -1,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,    -1,
     150,   151,   152,   153,    -1,   155,    -1,   157,   158,    -1,
     160,   161,   162,   163,    -1,   165,   166,    -1,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,    -1,   182,   183,   184,   185,   186,   187,    -1,   189,
     190,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
      -1,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,    -1,    -1,   213,   214,   215,   216,   217,    -1,   219,
     220,   221,    -1,    -1,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,    -1,   247,   248,   249,
     250,    -1,   252,   253,   254,   255,   256,   257,    -1,   259,
     260,    -1,   262,   263,   264,    -1,    -1,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,    -1,   333,   334,   335,   336,   337,    -1,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,    -1,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,    -1,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,   372,    -1,   374,   375,    -1,    -1,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,    -1,    -1,   393,   394,   395,   396,   397,    -1,    -1,
     400,   401,   402,   403,   404,   405,   406,    -1,   408,   409,
     410,   411,   412,   413,    -1,    -1,   416,    -1,    -1,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,     3,     4,     5,
      -1,    -1,    -1,     9,   444,   445,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    -1,    52,    53,    54,    55,
      56,    -1,    -1,    59,    60,    61,    62,    63,    -1,    65,
      66,    67,    68,    69,    -1,    71,    -1,    73,    74,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    -1,    89,    90,    91,    92,    -1,    -1,    -1,
      96,    -1,    -1,    -1,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,    -1,   112,   113,   114,   115,
     116,   117,    -1,   119,   120,   121,    -1,    -1,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,    -1,   134,   135,
     136,    -1,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,    -1,   150,   151,   152,   153,    -1,   155,
      -1,   157,   158,    -1,   160,   161,   162,   163,    -1,   165,
     166,    -1,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,    -1,   182,   183,   184,   185,
     186,   187,    -1,   189,   190,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,    -1,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,    -1,    -1,   213,   214,   215,
     216,   217,    -1,   219,   220,   221,    -1,    -1,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
      -1,   247,   248,   249,   250,    -1,   252,   253,   254,   255,
     256,   257,    -1,   259,   260,    -1,   262,   263,   264,    -1,
      -1,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,    -1,   333,   334,   335,
     336,   337,    -1,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,    -1,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,    -1,   363,   364,    -1,
     366,   367,   368,   369,   370,   371,   372,    -1,   374,   375,
      -1,    -1,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,    -1,    -1,   393,   394,   395,
     396,   397,    -1,    -1,   400,   401,   402,   403,   404,   405,
     406,    -1,   408,   409,   410,   411,   412,   413,    -1,    -1,
     416,    -1,    -1,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,     3,     4,     5,    -1,    -1,    -1,     9,   444,   445,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    -1,
      52,    53,    54,    55,    56,    -1,    -1,    59,    60,    61,
      62,    63,    -1,    65,    66,    67,    68,    69,    -1,    71,
      -1,    73,    74,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    -1,    89,    90,    91,
      92,    -1,    -1,    -1,    96,    -1,    -1,    -1,   100,   101,
     102,   103,   104,   105,   106,   107,   108,    -1,   110,    -1,
     112,   113,   114,   115,   116,   117,    -1,   119,   120,   121,
      -1,    -1,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,    -1,   134,   135,   136,    -1,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,    -1,   150,   151,
     152,   153,    -1,   155,    -1,   157,   158,    -1,   160,   161,
     162,   163,    -1,   165,   166,    -1,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,   177,   178,   179,   180,    -1,
     182,   183,   184,   185,   186,   187,    -1,   189,   190,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,    -1,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,    -1,
      -1,   213,   214,   215,   216,   217,    -1,   219,   220,   221,
      -1,    -1,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,    -1,   247,   248,   249,   250,    -1,
     252,   253,   254,   255,   256,   257,    -1,   259,   260,    -1,
     262,   263,   264,    -1,    -1,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,    -1,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
      -1,   333,   334,   335,   336,   337,    -1,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,    -1,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
      -1,   363,   364,    -1,   366,   367,   368,   369,   370,   371,
     372,    -1,   374,   375,    -1,    -1,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,    -1,
      -1,   393,   394,   395,   396,   397,    -1,    -1,   400,   401,
     402,   403,   404,   405,   406,    -1,   408,   409,   410,   411,
     412,   413,    -1,    -1,   416,    -1,    -1,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,     3,    -1,     5,    -1,    -1,
      -1,     9,   444,   445,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    71,    -1,    73,    74,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    89,    90,    91,    92,    -1,    -1,    -1,    96,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
     158,    -1,   160,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,   190,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,   215,   216,   217,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,    -1,   247,
     248,   249,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,   260,    -1,   262,   263,   264,    -1,    -1,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,    -1,   333,   334,   335,   336,   337,
      -1,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,    -1,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,    -1,   363,   364,    -1,   366,   367,
     368,   369,   370,   371,   372,    -1,   374,   375,    -1,    -1,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,    -1,    -1,   393,   394,   395,   396,   397,
      -1,    -1,   400,   401,   402,   403,   404,   405,   406,    -1,
     408,   409,   410,   411,   412,   413,    -1,    -1,   416,    -1,
      -1,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,     3,
      -1,    -1,    -1,    -1,    -1,     9,   444,   445,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,    43,
      44,    45,    46,    47,    -1,    49,    50,    -1,    52,    53,
      54,    55,    56,    -1,    -1,    59,    60,    61,    62,    63,
      -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,    73,
      74,    75,    76,    -1,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    -1,    -1,    90,    91,    92,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,   103,
     104,   105,   106,   107,   108,    -1,   110,    -1,   112,   113,
     114,   115,   116,   117,    -1,   119,   120,   121,    -1,    -1,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,    -1,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,   143,
     144,   145,   146,    -1,   148,    -1,   150,   151,   152,   153,
      -1,   155,    -1,   157,    -1,   159,    -1,   161,   162,   163,
      -1,   165,   166,    -1,   168,   169,    -1,   171,   172,   173,
     174,   175,    -1,   177,   178,   179,   180,   181,   182,   183,
     184,   185,   186,   187,    -1,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,    -1,   201,    -1,    -1,
     204,    -1,   206,   207,   208,   209,   210,    -1,    -1,   213,
     214,    -1,   216,    -1,    -1,   219,   220,   221,    -1,    -1,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,    -1,   242,   243,
     244,   245,    -1,   247,   248,    -1,   250,    -1,   252,   253,
     254,   255,   256,   257,    -1,   259,    -1,    -1,   262,   263,
     264,    -1,    -1,   267,   268,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,   278,   279,   280,    -1,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,    -1,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,    -1,   333,
     334,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,    -1,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,    -1,   363,
     364,    -1,   366,    -1,   368,   369,   370,   371,   372,    -1,
     374,   375,    -1,    -1,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,   388,   389,   390,    -1,    -1,   393,
     394,   395,   396,   397,    -1,    -1,   400,   401,   402,   403,
     404,   405,   406,    -1,   408,    -1,   410,   411,   412,   413,
      -1,    -1,   416,    -1,    -1,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,     3,     4,     5,    -1,    -1,    -1,     9,
     444,   445,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   171,
     172,   173,   174,   175,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    71,    -1,    73,    74,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
     158,    -1,   160,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,   190,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,   215,   216,   217,
      -1,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,    -1,   247,
     248,   249,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,    -1,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,    -1,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,    -1,   363,   364,    -1,   366,   367,
     368,   369,   370,   371,   372,    -1,   374,   375,    -1,    -1,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
     388,   389,   390,    -1,    -1,   393,   394,   395,   396,   397,
     398,    -1,   400,   401,   402,   403,   404,   405,   406,    -1,
     408,   409,   410,   411,   412,   413,    -1,    -1,   416,    -1,
      -1,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,     3,
      -1,     5,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    -1,    52,    53,
      54,    55,    56,    -1,    -1,    59,    60,    61,    62,    63,
      -1,    65,    66,    67,    68,    69,    -1,    71,    -1,    73,
      74,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    -1,    89,    90,    91,    92,    -1,
      -1,    -1,    96,    -1,    -1,    -1,   100,   101,   102,   103,
     104,   105,   106,   107,   108,    -1,   110,    -1,   112,   113,
     114,   115,   116,   117,    -1,   119,   120,   121,    -1,    -1,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,    -1,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,    -1,   150,   151,   152,   153,
      -1,   155,    -1,   157,   158,    -1,   160,   161,   162,   163,
      -1,   165,   166,    -1,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,   183,
     184,   185,   186,   187,    -1,   189,   190,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,    -1,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,    -1,    -1,   213,
     214,   215,   216,   217,    -1,   219,   220,   221,    -1,    -1,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,    -1,   247,   248,   249,   250,    -1,   252,   253,
     254,   255,   256,   257,    -1,   259,   260,    -1,   262,   263,
     264,    -1,    -1,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,    -1,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,    -1,   333,
     334,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,    -1,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,    -1,   363,
     364,    -1,   366,   367,   368,   369,   370,   371,   372,    -1,
     374,   375,    -1,    -1,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,    -1,    -1,   393,
     394,   395,   396,   397,    -1,    -1,   400,   401,   402,   403,
     404,   405,   406,    -1,   408,   409,   410,   411,   412,   413,
      -1,    -1,   416,    -1,    -1,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    -1,    52,    53,    54,    55,    56,    -1,    -1,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    68,    69,
      -1,    71,    -1,    73,    74,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    89,
      90,    91,    92,    -1,    -1,    -1,    96,    -1,    -1,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,    -1,
     110,    -1,   112,   113,   114,   115,   116,   117,    -1,   119,
     120,   121,    -1,    -1,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,    -1,   134,   135,   136,    -1,   138,   139,
     140,   141,   142,   143,   144,   145,   146,    -1,   148,    -1,
     150,   151,   152,   153,    -1,   155,    -1,   157,   158,    -1,
     160,   161,   162,   163,    -1,   165,   166,    -1,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,    -1,   182,   183,   184,   185,   186,   187,    -1,   189,
     190,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
      -1,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,    -1,    -1,   213,   214,   215,   216,   217,    -1,   219,
     220,   221,    -1,    -1,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,    -1,   247,   248,   249,
     250,    -1,   252,   253,   254,   255,   256,   257,    -1,   259,
      -1,    -1,   262,   263,   264,    -1,    -1,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,    -1,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,    -1,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,    -1,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,   372,    -1,   374,   375,    -1,    -1,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,    -1,    -1,   393,   394,   395,   396,   397,    -1,    -1,
     400,   401,   402,   403,   404,   405,   406,    -1,   408,   409,
     410,   411,   412,   413,    -1,    -1,   416,    -1,    -1,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    -1,    52,    53,    54,    55,
      56,    -1,    -1,    59,    60,    61,    62,    63,    -1,    65,
      66,    67,    68,    69,    -1,    71,    -1,    73,    74,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    -1,    89,    90,    91,    92,    -1,    -1,    -1,
      96,    -1,    -1,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,    -1,   110,    -1,   112,   113,   114,   115,
     116,   117,    -1,   119,   120,   121,    -1,    -1,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,    -1,   134,   135,
     136,    -1,   138,   139,   140,   141,   142,   143,   144,   145,
     146,    -1,   148,    -1,   150,   151,   152,   153,    -1,   155,
      -1,   157,   158,    -1,   160,   161,   162,   163,    -1,   165,
     166,    -1,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,    -1,   182,   183,   184,   185,
     186,   187,    -1,   189,   190,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,    -1,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,    -1,    -1,   213,   214,   215,
     216,   217,    -1,   219,   220,   221,    -1,    -1,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
      -1,   247,   248,   249,   250,    -1,   252,   253,   254,   255,
     256,   257,    -1,   259,    -1,    -1,   262,   263,   264,    -1,
      -1,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,    -1,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,    -1,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,    -1,   363,   364,    -1,
     366,   367,   368,   369,   370,   371,   372,    -1,   374,   375,
      -1,    -1,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,    -1,    -1,   393,   394,   395,
     396,   397,   398,    -1,   400,   401,   402,   403,   404,   405,
     406,    -1,   408,   409,   410,   411,   412,   413,    -1,    -1,
     416,    -1,    -1,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    -1,
      52,    53,    54,    55,    56,    -1,    -1,    59,    60,    61,
      62,    63,    -1,    65,    66,    67,    68,    69,    -1,    71,
      -1,    73,    74,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    -1,    89,    90,    91,
      92,    -1,    -1,    -1,    96,    -1,    -1,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,    -1,   110,    -1,
     112,   113,   114,   115,   116,   117,    -1,   119,   120,   121,
      -1,    -1,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,    -1,   134,   135,   136,    -1,   138,   139,   140,   141,
     142,   143,   144,   145,   146,    -1,   148,    -1,   150,   151,
     152,   153,    -1,   155,    -1,   157,   158,    -1,   160,   161,
     162,   163,    -1,   165,   166,   167,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,   177,   178,   179,   180,    -1,
     182,   183,   184,   185,   186,   187,    -1,   189,   190,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,    -1,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,    -1,
      -1,   213,   214,   215,   216,   217,    -1,   219,   220,   221,
      -1,    -1,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,    -1,   247,   248,   249,   250,    -1,
     252,   253,   254,   255,   256,   257,    -1,   259,    -1,    -1,
     262,   263,   264,    -1,    -1,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,    -1,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
      -1,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,    -1,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
      -1,   363,   364,    -1,   366,   367,   368,   369,   370,   371,
     372,    -1,   374,   375,    -1,    -1,   378,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,   388,   389,   390,    -1,
      -1,   393,   394,   395,   396,   397,    -1,    -1,   400,   401,
     402,   403,   404,   405,   406,    -1,   408,   409,   410,   411,
     412,   413,    -1,    -1,   416,    -1,    -1,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    71,    -1,    73,    74,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    89,    90,    91,    92,    -1,    -1,    -1,    96,    -1,
      -1,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
     158,    -1,   160,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,   190,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,   215,   216,   217,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,    -1,   247,
     248,   249,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,    -1,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,    -1,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,    -1,   363,   364,    -1,   366,   367,
     368,   369,   370,   371,   372,    -1,   374,   375,    -1,    -1,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
     388,   389,   390,    -1,    -1,   393,   394,   395,   396,   397,
      -1,    -1,   400,   401,   402,   403,   404,   405,   406,    -1,
     408,   409,   410,   411,   412,   413,    -1,    -1,   416,    -1,
      -1,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    -1,    52,    53,
      54,    55,    56,    -1,    -1,    59,    60,    61,    62,    63,
      -1,    65,    66,    67,    68,    69,    -1,    71,    -1,    73,
      74,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    -1,    89,    90,    91,    92,    -1,
      -1,    -1,    96,    -1,    -1,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,    -1,   110,    -1,   112,   113,
     114,   115,   116,   117,    -1,   119,   120,   121,    -1,    -1,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,    -1,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,   143,
     144,   145,   146,    -1,   148,    -1,   150,   151,   152,   153,
      -1,   155,    -1,   157,   158,    -1,   160,   161,   162,   163,
      -1,   165,   166,    -1,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,   183,
     184,   185,   186,   187,    -1,   189,   190,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,    -1,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,    -1,    -1,   213,
     214,   215,   216,   217,    -1,   219,   220,   221,    -1,    -1,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,    -1,   247,   248,   249,   250,    -1,   252,   253,
     254,   255,   256,   257,    -1,   259,    -1,    -1,   262,   263,
     264,    -1,    -1,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,    -1,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,    -1,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,    -1,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,    -1,   363,
     364,    -1,   366,   367,   368,   369,   370,   371,   372,    -1,
     374,   375,    -1,    -1,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,   388,   389,   390,    -1,    -1,   393,
     394,   395,   396,   397,    -1,    -1,   400,   401,   402,   403,
     404,   405,   406,    -1,   408,   409,   410,   411,   412,   413,
      -1,    -1,   416,    -1,    -1,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    -1,    52,    53,    54,    55,    56,    -1,    -1,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    68,    69,
      -1,    71,    -1,    73,    74,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    89,
      90,    91,    92,    -1,    -1,    -1,    96,    -1,    -1,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,    -1,
     110,    -1,   112,   113,   114,   115,   116,   117,    -1,   119,
     120,   121,    -1,    -1,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,    -1,   134,   135,   136,    -1,   138,   139,
     140,   141,   142,   143,   144,   145,   146,    -1,   148,    -1,
     150,   151,   152,   153,    -1,   155,    -1,   157,   158,    -1,
     160,   161,   162,   163,    -1,   165,   166,    -1,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,    -1,   182,   183,   184,   185,   186,   187,    -1,   189,
     190,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
      -1,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,    -1,    -1,   213,   214,   215,   216,   217,    -1,   219,
     220,   221,    -1,    -1,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,    -1,   247,   248,   249,
     250,    -1,   252,   253,   254,   255,   256,   257,    -1,   259,
      -1,    -1,   262,   263,   264,    -1,    -1,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,    -1,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,    -1,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,    -1,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,   372,    -1,   374,   375,    -1,    -1,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,    -1,    -1,   393,   394,   395,   396,   397,    -1,    -1,
     400,   401,   402,   403,   404,   405,   406,    -1,   408,   409,
     410,   411,   412,   413,    -1,    -1,   416,    -1,    -1,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    -1,    52,    53,    54,    55,
      56,    -1,    -1,    59,    60,    61,    62,    63,    -1,    65,
      66,    67,    68,    69,    -1,    71,    -1,    73,    74,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    -1,    89,    90,    91,    92,    -1,    -1,    -1,
      96,    -1,    -1,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,    -1,   110,    -1,   112,   113,   114,   115,
     116,   117,    -1,   119,   120,   121,    -1,    -1,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,    -1,   134,   135,
     136,    -1,   138,   139,   140,   141,   142,   143,   144,   145,
     146,    -1,   148,    -1,   150,   151,   152,   153,    -1,   155,
      -1,   157,   158,    -1,   160,   161,   162,   163,    -1,   165,
     166,    -1,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,    -1,   182,   183,   184,   185,
     186,   187,    -1,   189,   190,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,    -1,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,    -1,    -1,   213,   214,   215,
     216,   217,    -1,   219,   220,   221,    -1,    -1,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
      -1,   247,   248,   249,   250,    -1,   252,   253,   254,   255,
     256,   257,    -1,   259,    -1,    -1,   262,   263,   264,    -1,
      -1,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,    -1,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,    -1,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,    -1,   363,   364,    -1,
     366,   367,   368,   369,   370,   371,   372,    -1,   374,   375,
      -1,    -1,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,    -1,    -1,   393,   394,   395,
     396,   397,    -1,    -1,   400,   401,   402,   403,   404,   405,
     406,    -1,   408,   409,   410,   411,   412,   413,    -1,    -1,
     416,    -1,    -1,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    -1,
      52,    53,    54,    55,    56,    -1,    -1,    59,    60,    61,
      62,    63,    -1,    65,    66,    67,    68,    69,    -1,    71,
      -1,    73,    74,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    -1,    89,    90,    91,
      92,    -1,    -1,    -1,    96,    -1,    -1,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,    -1,   110,    -1,
     112,   113,   114,   115,   116,   117,    -1,   119,   120,   121,
      -1,    -1,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,    -1,   134,   135,   136,    -1,   138,   139,   140,   141,
     142,   143,   144,   145,   146,    -1,   148,    -1,   150,   151,
     152,   153,    -1,   155,    -1,   157,   158,    -1,   160,   161,
     162,   163,    -1,   165,   166,    -1,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,   177,   178,   179,   180,    -1,
     182,   183,   184,   185,   186,   187,    -1,   189,   190,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,    -1,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,    -1,
      -1,   213,   214,   215,   216,   217,    -1,   219,   220,   221,
      -1,    -1,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,    -1,   247,   248,   249,   250,    -1,
     252,   253,   254,   255,   256,   257,    -1,   259,    -1,    -1,
     262,   263,   264,    -1,    -1,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,    -1,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
      -1,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,    -1,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
      -1,   363,   364,    -1,   366,   367,   368,   369,   370,   371,
     372,    -1,   374,   375,    -1,    -1,   378,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,   388,   389,   390,    -1,
      -1,   393,   394,   395,   396,   397,    -1,    -1,   400,   401,
     402,   403,   404,   405,   406,    -1,   408,   409,   410,   411,
     412,   413,    -1,    -1,   416,    -1,    -1,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    71,    -1,    73,    74,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    89,    90,    91,    92,    -1,    -1,    -1,    96,    -1,
      -1,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
     158,    -1,   160,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,   190,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,   215,   216,   217,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,    -1,   247,
     248,   249,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,    -1,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,    -1,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,    -1,   363,   364,    -1,   366,   367,
     368,   369,   370,   371,   372,    -1,   374,   375,    -1,    -1,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
     388,   389,   390,    -1,    -1,   393,   394,   395,   396,   397,
      -1,    -1,   400,   401,   402,   403,   404,   405,   406,    -1,
     408,   409,   410,   411,   412,   413,    -1,    -1,   416,    -1,
      -1,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,     3,
      -1,     5,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    -1,    52,    53,
      54,    55,    56,    -1,    -1,    59,    60,    61,    62,    63,
      -1,    65,    66,    67,    68,    69,    -1,    71,    -1,    73,
      74,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    -1,    89,    90,    91,    92,    -1,
      -1,    -1,    96,    -1,    -1,    -1,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,    -1,   112,   113,
     114,   115,   116,   117,    -1,   119,   120,   121,    -1,    -1,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,    -1,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,   143,
     144,   145,   146,    -1,   148,    -1,   150,   151,   152,   153,
      -1,   155,    -1,   157,   158,    -1,   160,   161,   162,   163,
      -1,   165,   166,    -1,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,   183,
     184,   185,   186,   187,    -1,   189,   190,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,    -1,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,    -1,    -1,   213,
     214,   215,   216,   217,    -1,   219,   220,   221,    -1,    -1,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,    -1,   247,   248,   249,   250,    -1,   252,   253,
     254,   255,   256,   257,    -1,   259,    -1,    -1,   262,   263,
     264,    -1,    -1,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,    -1,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,    -1,   333,
     334,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,    -1,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,    -1,   363,
     364,    -1,   366,   367,   368,   369,   370,   371,   372,    -1,
     374,   375,    -1,    -1,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,   388,   389,   390,    -1,    -1,   393,
     394,   395,   396,   397,    -1,    -1,   400,   401,   402,   403,
     404,   405,   406,    -1,   408,   409,   410,   411,   412,   413,
      -1,    -1,   416,    -1,    -1,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    -1,    52,    53,    54,    55,    56,    -1,    -1,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    68,    69,
      -1,    71,    -1,    73,    74,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    89,
      90,    91,    92,    -1,    -1,    -1,    96,    -1,    -1,    -1,
     100,   101,   102,   103,   104,   105,   106,   107,   108,    -1,
     110,    -1,   112,   113,   114,   115,   116,   117,    -1,   119,
     120,   121,    -1,    -1,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,    -1,   134,   135,   136,    -1,   138,   139,
     140,   141,   142,   143,   144,   145,   146,    -1,   148,    -1,
     150,   151,   152,   153,    -1,   155,    -1,   157,   158,    -1,
     160,   161,   162,   163,    -1,   165,   166,    -1,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,    -1,   182,   183,   184,   185,   186,   187,    -1,   189,
     190,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
      -1,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,    -1,    -1,   213,   214,   215,   216,   217,    -1,   219,
     220,   221,    -1,    -1,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,    -1,   247,   248,   249,
     250,    -1,   252,   253,   254,   255,   256,   257,    -1,   259,
      -1,    -1,   262,   263,   264,    -1,    -1,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,    -1,   333,   334,   335,   336,   337,    -1,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,    -1,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,    -1,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,   372,    -1,   374,   375,    -1,    -1,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,    -1,    -1,   393,   394,   395,   396,   397,    -1,    -1,
     400,   401,   402,   403,   404,   405,   406,    -1,   408,   409,
     410,   411,   412,   413,    -1,    -1,   416,    -1,    -1,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,     3,    -1,     5,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    -1,    52,    53,    54,    55,
      56,    -1,    -1,    59,    60,    61,    62,    63,    -1,    65,
      66,    67,    68,    69,    -1,    71,    -1,    73,    74,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    -1,    89,    90,    91,    92,    -1,    -1,    -1,
      96,    -1,    -1,    -1,   100,   101,   102,   103,   104,   105,
     106,   107,   108,    -1,   110,    -1,   112,   113,   114,   115,
     116,   117,    -1,   119,   120,   121,    -1,    -1,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,    -1,   134,   135,
     136,    -1,   138,   139,   140,   141,   142,   143,   144,   145,
     146,    -1,   148,    -1,   150,   151,   152,   153,    -1,   155,
      -1,   157,   158,    -1,   160,   161,   162,   163,    -1,   165,
     166,    -1,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,    -1,   182,   183,   184,   185,
     186,   187,    -1,   189,   190,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,    -1,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,    -1,    -1,   213,   214,   215,
     216,   217,    -1,   219,   220,   221,    -1,    -1,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
      -1,   247,   248,   249,   250,    -1,   252,   253,   254,   255,
     256,   257,    -1,   259,    -1,    -1,   262,   263,   264,    -1,
      -1,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,    -1,   333,   334,   335,
     336,   337,    -1,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,    -1,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,    -1,   363,   364,    -1,
     366,   367,   368,   369,   370,   371,   372,    -1,   374,   375,
      -1,    -1,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,    -1,    -1,   393,   394,   395,
     396,   397,    -1,    -1,   400,   401,   402,   403,   404,   405,
     406,    -1,   408,   409,   410,   411,   412,   413,    -1,    -1,
     416,    -1,    -1,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,     3,    -1,     5,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    -1,
      52,    53,    54,    55,    56,    -1,    -1,    59,    60,    61,
      62,    63,    -1,    65,    66,    67,    68,    69,    -1,    71,
      -1,    73,    74,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    -1,    89,    90,    91,
      92,    -1,    -1,    -1,    96,    -1,    -1,    -1,   100,   101,
     102,   103,   104,   105,   106,   107,   108,    -1,   110,    -1,
     112,   113,   114,   115,   116,   117,    -1,   119,   120,   121,
      -1,    -1,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,    -1,   134,   135,   136,    -1,   138,   139,   140,   141,
     142,   143,   144,   145,   146,    -1,   148,    -1,   150,   151,
     152,   153,    -1,   155,    -1,   157,   158,    -1,   160,   161,
     162,   163,    -1,   165,   166,    -1,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,   177,   178,   179,   180,    -1,
     182,   183,   184,   185,   186,   187,    -1,   189,   190,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,    -1,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,    -1,
      -1,   213,   214,   215,   216,   217,    -1,   219,   220,   221,
      -1,    -1,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,    -1,   247,   248,   249,   250,    -1,
     252,   253,   254,   255,   256,   257,    -1,   259,    -1,    -1,
     262,   263,   264,    -1,    -1,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,    -1,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
      -1,   333,   334,   335,   336,   337,    -1,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,    -1,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
      -1,   363,   364,    -1,   366,   367,   368,   369,   370,   371,
     372,    -1,   374,   375,    -1,    -1,   378,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,   388,   389,   390,    -1,
      -1,   393,   394,   395,   396,   397,    -1,    -1,   400,   401,
     402,   403,   404,   405,   406,    -1,   408,   409,   410,   411,
     412,   413,    -1,    -1,   416,    -1,    -1,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    71,    -1,    73,    74,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    89,    90,    91,    92,    -1,    -1,    -1,    96,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
     158,    -1,   160,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,   190,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,   215,   216,   217,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,    -1,   247,
     248,   249,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,    -1,   333,   334,   335,   336,   337,
      -1,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,    -1,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,    -1,   363,   364,    -1,   366,   367,
     368,   369,   370,   371,   372,    -1,   374,   375,    -1,    -1,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
     388,   389,   390,    -1,    -1,   393,   394,   395,   396,   397,
      -1,    -1,   400,   401,   402,   403,   404,   405,   406,    -1,
     408,   409,   410,   411,   412,   413,    -1,    -1,   416,    -1,
      -1,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    -1,    52,    53,
      54,    55,    56,    -1,    -1,    59,    60,    61,    62,    63,
      -1,    65,    66,    67,    68,    69,    -1,    71,    -1,    73,
      74,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    -1,    89,    90,    91,    92,    -1,
      -1,    -1,    96,    -1,    -1,    -1,   100,   101,   102,   103,
     104,   105,   106,   107,   108,    -1,   110,    -1,   112,   113,
     114,   115,   116,   117,    -1,   119,   120,   121,    -1,    -1,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,    -1,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,   143,
     144,   145,   146,    -1,   148,    -1,   150,   151,   152,   153,
      -1,   155,    -1,   157,   158,    -1,   160,   161,   162,   163,
      -1,   165,   166,    -1,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,   183,
     184,   185,   186,   187,    -1,   189,   190,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,    -1,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,    -1,    -1,   213,
     214,   215,   216,   217,    -1,   219,   220,   221,    -1,    -1,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,    -1,   247,   248,   249,   250,    -1,   252,   253,
     254,   255,   256,   257,    -1,   259,    -1,    -1,   262,   263,
     264,    -1,    -1,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,    -1,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,    -1,   333,
     334,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,    -1,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,    -1,   363,
     364,    -1,   366,   367,   368,   369,   370,   371,   372,    -1,
     374,   375,    -1,    -1,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,   388,   389,   390,    -1,    -1,   393,
     394,   395,   396,   397,    -1,    -1,   400,   401,   402,   403,
     404,   405,   406,    -1,   408,   409,   410,   411,   412,   413,
      -1,    -1,   416,    -1,    -1,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    -1,    52,    53,    54,    55,    56,    -1,    -1,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    68,    69,
      -1,    71,    -1,    73,    74,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    89,
      90,    91,    92,    -1,    -1,    -1,    96,    -1,    -1,    -1,
     100,   101,   102,   103,   104,   105,   106,   107,   108,    -1,
     110,    -1,   112,   113,   114,   115,   116,   117,    -1,   119,
     120,   121,    -1,    -1,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,    -1,   134,   135,   136,    -1,   138,   139,
     140,   141,   142,   143,   144,   145,   146,    -1,   148,    -1,
     150,   151,   152,   153,    -1,   155,    -1,   157,   158,    -1,
     160,   161,   162,   163,    -1,   165,   166,    -1,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,    -1,   182,   183,   184,   185,   186,   187,    -1,   189,
     190,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
      -1,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,    -1,    -1,   213,   214,   215,   216,   217,    -1,   219,
     220,   221,    -1,    -1,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,    -1,   247,   248,   249,
     250,    -1,   252,   253,   254,   255,   256,   257,    -1,   259,
      -1,    -1,   262,   263,   264,    -1,    -1,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,    -1,   333,   334,   335,   336,   337,    -1,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,    -1,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,    -1,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,   372,    -1,   374,   375,    -1,    -1,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,    -1,    -1,   393,   394,   395,   396,   397,    -1,    -1,
     400,   401,   402,   403,   404,   405,   406,    -1,   408,   409,
     410,   411,   412,   413,    -1,    -1,   416,    -1,    -1,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    -1,    43,    44,    45,
      46,    47,    -1,    49,    50,    -1,    52,    53,    54,    55,
      56,    -1,    -1,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    -1,    -1,    72,    73,    74,    75,
      76,    -1,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    -1,    -1,    90,    91,    92,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   100,   101,   102,   103,   104,   105,
     106,   107,   108,    -1,   110,    -1,   112,   113,   114,   115,
     116,   117,    -1,   119,   120,   121,    -1,    -1,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,    -1,   134,   135,
     136,    -1,   138,   139,   140,   141,   142,   143,   144,   145,
     146,    -1,   148,    -1,   150,   151,   152,   153,    -1,   155,
     156,   157,    -1,    -1,    -1,   161,   162,   163,    -1,   165,
     166,    -1,   168,   169,    -1,   171,   172,   173,   174,   175,
      -1,   177,   178,   179,   180,    -1,   182,   183,   184,   185,
     186,   187,    -1,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,    -1,   201,    -1,    -1,   204,    -1,
     206,   207,   208,   209,   210,    -1,    -1,   213,   214,    -1,
     216,    -1,    -1,   219,   220,   221,    -1,    -1,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,    -1,   242,   243,   244,   245,
      -1,   247,   248,    -1,   250,    -1,   252,   253,   254,   255,
     256,   257,    -1,   259,    -1,    -1,   262,   263,   264,    -1,
      -1,   267,   268,    -1,   270,    -1,   272,   273,   274,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,    -1,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,    -1,   333,   334,   335,
     336,   337,    -1,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,    -1,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,    -1,   363,   364,    -1,
     366,    -1,   368,   369,   370,   371,   372,    -1,   374,   375,
      -1,    -1,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,    -1,   392,   393,   394,   395,
     396,   397,    -1,    -1,   400,   401,   402,   403,   404,   405,
     406,    -1,   408,    -1,   410,   411,   412,   413,    -1,    -1,
     416,    -1,    -1,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      -1,    43,    44,    45,    46,    47,    -1,    49,    50,    -1,
      52,    53,    54,    55,    56,    -1,    -1,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    -1,    -1,
      -1,    73,    74,    75,    76,    -1,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    -1,    -1,    90,    91,
      92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,
     102,   103,   104,   105,   106,   107,   108,    -1,   110,    -1,
     112,   113,   114,   115,   116,   117,    -1,   119,   120,   121,
      -1,    -1,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,    -1,   134,   135,   136,    -1,   138,   139,   140,   141,
     142,   143,   144,   145,   146,    -1,   148,    -1,   150,   151,
     152,   153,    -1,   155,   156,   157,    -1,    -1,    -1,   161,
     162,   163,    -1,   165,   166,    -1,   168,   169,    -1,   171,
     172,   173,   174,   175,    -1,   177,   178,   179,   180,    -1,
     182,   183,   184,   185,   186,   187,    -1,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,    -1,   201,
      -1,    -1,   204,    -1,   206,   207,   208,   209,   210,    -1,
      -1,   213,   214,    -1,   216,   217,    -1,   219,   220,   221,
      -1,    -1,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,    -1,
     242,   243,   244,   245,    -1,   247,   248,    -1,   250,    -1,
     252,   253,   254,   255,   256,   257,    -1,   259,    -1,    -1,
     262,   263,   264,    -1,    -1,   267,   268,    -1,   270,    -1,
     272,   273,   274,   275,   276,   277,   278,   279,   280,    -1,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,    -1,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
      -1,   333,   334,   335,   336,   337,    -1,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,    -1,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
      -1,   363,   364,    -1,   366,    -1,   368,   369,   370,   371,
     372,    -1,   374,   375,    -1,    -1,   378,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,   388,   389,   390,    -1,
     392,   393,   394,   395,   396,   397,    -1,    -1,   400,   401,
     402,   403,   404,   405,   406,    -1,   408,    -1,   410,   411,
     412,   413,    -1,    -1,   416,    -1,    -1,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      88,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
      -1,    -1,    -1,   161,   162,   163,   164,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,    -1,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,    -1,    -1,   204,    -1,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,    -1,   216,    -1,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,    -1,   242,   243,   244,   245,    -1,   247,
     248,    -1,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,    -1,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,   317,
     318,    -1,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
      -1,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,    -1,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,    -1,   363,   364,    -1,   366,    -1,
     368,   369,   370,   371,   372,    -1,   374,   375,    -1,    -1,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
     388,   389,   390,    -1,    -1,   393,   394,   395,   396,   397,
      -1,    -1,   400,   401,   402,   403,   404,   405,   406,    -1,
     408,    -1,   410,   411,   412,   413,    -1,    -1,   416,    -1,
      -1,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,    43,
      44,    45,    46,    47,    -1,    49,    50,    -1,    52,    53,
      54,    55,    56,    -1,    -1,    59,    60,    61,    62,    63,
      -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,    73,
      74,    75,    76,    -1,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    88,    -1,    90,    91,    92,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,   103,
     104,   105,   106,   107,   108,    -1,   110,    -1,   112,   113,
     114,   115,   116,   117,    -1,   119,   120,   121,    -1,    -1,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,    -1,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,   143,
     144,   145,   146,    -1,   148,    -1,   150,   151,   152,   153,
      -1,   155,    -1,   157,    -1,    -1,    -1,   161,   162,   163,
     164,   165,   166,    -1,   168,   169,    -1,   171,   172,   173,
     174,   175,    -1,   177,   178,   179,   180,    -1,   182,   183,
     184,   185,   186,   187,    -1,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,    -1,   201,    -1,    -1,
     204,    -1,   206,   207,   208,   209,   210,    -1,    -1,   213,
     214,    -1,   216,    -1,    -1,   219,   220,   221,    -1,    -1,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,    -1,   242,   243,
     244,   245,    -1,   247,   248,    -1,   250,    -1,   252,   253,
     254,   255,   256,   257,    -1,   259,    -1,    -1,   262,   263,
     264,    -1,    -1,   267,   268,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,   278,   279,   280,    -1,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,    -1,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,    -1,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,    -1,   363,
     364,    -1,   366,    -1,   368,   369,   370,   371,   372,    -1,
     374,   375,    -1,    -1,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,   388,   389,   390,    -1,    -1,   393,
     394,   395,   396,   397,    -1,    -1,   400,   401,   402,   403,
     404,   405,   406,    -1,   408,    -1,   410,   411,   412,   413,
      -1,    -1,   416,    -1,    -1,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    -1,    43,    44,    45,    46,    47,    -1,    49,
      50,    -1,    52,    53,    54,    55,    56,    -1,    -1,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      -1,    -1,    -1,    73,    74,    75,    76,    -1,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    -1,    -1,
      90,    91,    92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     100,   101,   102,   103,   104,   105,   106,   107,   108,    -1,
     110,    -1,   112,   113,   114,   115,   116,   117,    -1,   119,
     120,   121,    -1,    -1,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,    -1,   134,   135,   136,    -1,   138,   139,
     140,   141,   142,   143,   144,   145,   146,    -1,   148,    -1,
     150,   151,   152,   153,    -1,   155,   156,   157,    -1,    -1,
      -1,   161,   162,   163,    -1,   165,   166,    -1,   168,   169,
      -1,   171,   172,   173,   174,   175,    -1,   177,   178,   179,
     180,    -1,   182,   183,   184,   185,   186,   187,    -1,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
      -1,   201,    -1,    -1,   204,    -1,   206,   207,   208,   209,
     210,    -1,    -1,   213,   214,    -1,   216,    -1,    -1,   219,
     220,   221,    -1,    -1,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,    -1,   242,   243,   244,   245,    -1,   247,   248,    -1,
     250,    -1,   252,   253,   254,   255,   256,   257,    -1,   259,
      -1,    -1,   262,   263,   264,    -1,    -1,   267,   268,    -1,
     270,    -1,   272,   273,   274,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,    -1,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,    -1,   333,   334,   335,   336,   337,    -1,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,    -1,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,    -1,   363,   364,    -1,   366,    -1,   368,   369,
     370,   371,   372,    -1,   374,   375,    -1,    -1,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,    -1,   392,   393,   394,   395,   396,   397,    -1,    -1,
     400,   401,   402,   403,   404,   405,   406,    -1,   408,    -1,
     410,   411,   412,   413,    -1,    -1,   416,    -1,    -1,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    -1,    43,    44,    45,
      46,    47,    -1,    49,    50,    -1,    52,    53,    54,    55,
      56,    -1,    -1,    59,    60,    61,    62,    63,    -1,    65,
      66,    67,    68,    69,    -1,    -1,    -1,    73,    74,    75,
      76,    -1,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    88,    -1,    90,    91,    92,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   100,   101,   102,   103,   104,   105,
     106,   107,   108,    -1,   110,    -1,   112,   113,   114,   115,
     116,   117,    -1,   119,   120,   121,    -1,    -1,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,    -1,   134,   135,
     136,    -1,   138,   139,   140,   141,   142,   143,   144,   145,
     146,    -1,   148,    -1,   150,   151,   152,   153,    -1,   155,
      -1,   157,    -1,    -1,    -1,   161,   162,   163,    -1,   165,
     166,    -1,   168,   169,    -1,   171,   172,   173,   174,   175,
      -1,   177,   178,   179,   180,    -1,   182,   183,   184,   185,
     186,   187,    -1,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,    -1,   201,    -1,    -1,   204,    -1,
     206,   207,   208,   209,   210,    -1,    -1,   213,   214,    -1,
     216,    -1,    -1,   219,   220,   221,    -1,    -1,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,    -1,   242,   243,   244,   245,
      -1,   247,   248,    -1,   250,    -1,   252,   253,   254,   255,
     256,   257,    -1,   259,    -1,    -1,   262,   263,   264,    -1,
      -1,   267,   268,    -1,   270,    -1,   272,   273,   274,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,    -1,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,    -1,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,    -1,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,    -1,   363,   364,    -1,
     366,    -1,   368,   369,   370,   371,   372,    -1,   374,   375,
      -1,    -1,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,    -1,    -1,   393,   394,   395,
     396,   397,    -1,    -1,   400,   401,   402,   403,   404,   405,
     406,    -1,   408,    -1,   410,   411,   412,   413,    -1,    -1,
     416,    -1,    -1,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      -1,    43,    44,    45,    46,    47,    -1,    49,    50,    -1,
      52,    53,    54,    55,    56,    -1,    -1,    59,    60,    61,
      62,    63,    -1,    65,    66,    67,    68,    69,    -1,    -1,
      -1,    73,    74,    75,    76,    -1,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    -1,    -1,    90,    91,
      92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,
     102,   103,   104,   105,   106,   107,   108,    -1,   110,    -1,
     112,   113,   114,   115,   116,   117,    -1,   119,   120,   121,
      -1,    -1,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,    -1,   134,   135,   136,    -1,   138,   139,   140,   141,
     142,   143,   144,   145,   146,    -1,   148,    -1,   150,   151,
     152,   153,    -1,   155,   156,   157,    -1,    -1,    -1,   161,
     162,   163,    -1,   165,   166,    -1,   168,   169,    -1,   171,
     172,   173,   174,   175,    -1,   177,   178,   179,   180,    -1,
     182,   183,   184,   185,   186,   187,    -1,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,    -1,   201,
      -1,    -1,   204,    -1,   206,   207,   208,   209,   210,    -1,
      -1,   213,   214,    -1,   216,    -1,    -1,   219,   220,   221,
      -1,    -1,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,    -1,
     242,   243,   244,   245,    -1,   247,   248,    -1,   250,    -1,
     252,   253,   254,   255,   256,   257,    -1,   259,    -1,    -1,
     262,   263,   264,    -1,    -1,   267,   268,    -1,   270,    -1,
     272,   273,   274,   275,   276,   277,   278,   279,   280,    -1,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,    -1,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
      -1,   333,   334,   335,   336,   337,    -1,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,    -1,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
      -1,   363,   364,   365,   366,    -1,   368,   369,   370,   371,
     372,    -1,   374,   375,    -1,    -1,   378,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,   388,   389,   390,    -1,
      -1,   393,   394,   395,   396,   397,    -1,    -1,   400,   401,
     402,   403,   404,   405,   406,    -1,   408,    -1,   410,   411,
     412,   413,    -1,    -1,   416,    -1,    -1,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      88,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
      -1,    -1,    -1,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,    -1,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,    -1,    -1,   204,    -1,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,    -1,   216,    -1,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,    -1,   242,   243,   244,   245,    -1,   247,
     248,    -1,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,    -1,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,   317,
     318,    -1,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
      -1,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,    -1,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,    -1,   363,   364,    -1,   366,    -1,
     368,   369,   370,   371,   372,    -1,   374,   375,    -1,    -1,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
     388,   389,   390,    -1,    -1,   393,   394,   395,   396,   397,
      -1,    -1,   400,   401,   402,   403,   404,   405,   406,    -1,
     408,    -1,   410,   411,   412,   413,    -1,    -1,   416,    -1,
      -1,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,    43,
      44,    45,    46,    47,    -1,    49,    50,    -1,    52,    53,
      54,    55,    56,    -1,    -1,    59,    60,    61,    62,    63,
      -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,    73,
      74,    75,    76,    -1,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    -1,    -1,    90,    91,    92,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,   103,
     104,   105,   106,   107,   108,    -1,   110,    -1,   112,   113,
     114,   115,   116,   117,    -1,   119,   120,   121,    -1,    -1,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,    -1,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,   143,
     144,   145,   146,    -1,   148,    -1,   150,   151,   152,   153,
      -1,   155,    -1,   157,    -1,    -1,    -1,   161,   162,   163,
      -1,   165,   166,    -1,   168,   169,    -1,   171,   172,   173,
     174,   175,    -1,   177,   178,   179,   180,    -1,   182,   183,
     184,   185,   186,   187,    -1,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,    -1,   201,    -1,    -1,
     204,    -1,   206,   207,   208,   209,   210,    -1,    -1,   213,
     214,    -1,   216,    -1,    -1,   219,   220,   221,    -1,    -1,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,    -1,   242,   243,
     244,   245,    -1,   247,   248,    -1,   250,    -1,   252,   253,
     254,   255,   256,   257,    -1,   259,    -1,   261,   262,   263,
     264,    -1,    -1,   267,   268,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,   278,   279,   280,    -1,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,    -1,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,    -1,   333,
     334,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,    -1,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,    -1,   363,
     364,    -1,   366,    -1,   368,   369,   370,   371,   372,    -1,
     374,   375,    -1,    -1,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,   388,   389,   390,    -1,    -1,   393,
     394,   395,   396,   397,    -1,    -1,   400,   401,   402,   403,
     404,   405,   406,    -1,   408,    -1,   410,   411,   412,   413,
      -1,    -1,   416,    -1,    -1,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    -1,    43,    44,    45,    46,    47,    -1,    49,
      50,    -1,    52,    53,    54,    55,    56,    -1,    -1,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    68,    69,
      -1,    -1,    -1,    73,    74,    75,    76,    -1,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    -1,
      90,    91,    92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     100,   101,   102,   103,   104,   105,   106,   107,   108,    -1,
     110,    -1,   112,   113,   114,   115,   116,   117,    -1,   119,
     120,   121,    -1,    -1,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,    -1,   134,   135,   136,    -1,   138,   139,
     140,   141,   142,   143,   144,   145,   146,    -1,   148,    -1,
     150,   151,   152,   153,    -1,   155,    -1,   157,    -1,    -1,
      -1,   161,   162,   163,    -1,   165,   166,    -1,   168,   169,
      -1,   171,   172,   173,   174,   175,    -1,   177,   178,   179,
     180,    -1,   182,   183,   184,   185,   186,   187,    -1,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
      -1,   201,    -1,    -1,   204,    -1,   206,   207,   208,   209,
     210,    -1,    -1,   213,   214,    -1,   216,    -1,    -1,   219,
     220,   221,    -1,    -1,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,    -1,   242,   243,   244,   245,    -1,   247,   248,    -1,
     250,    -1,   252,   253,   254,   255,   256,   257,    -1,   259,
      -1,    -1,   262,   263,   264,    -1,    -1,   267,   268,    -1,
     270,    -1,   272,   273,   274,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,    -1,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,    -1,   333,   334,   335,   336,   337,    -1,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,    -1,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,    -1,   363,   364,    -1,   366,    -1,   368,   369,
     370,   371,   372,    -1,   374,   375,    -1,    -1,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,    -1,    -1,   393,   394,   395,   396,   397,    -1,    -1,
     400,   401,   402,   403,   404,   405,   406,    -1,   408,    -1,
     410,   411,   412,   413,    -1,    -1,   416,    -1,    -1,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    -1,    43,    44,    45,
      46,    47,    -1,    49,    50,    -1,    52,    53,    54,    55,
      56,    -1,    -1,    59,    60,    61,    62,    63,    -1,    65,
      66,    67,    68,    69,    -1,    -1,    -1,    73,    74,    75,
      76,    -1,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    -1,    -1,    90,    91,    92,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   100,   101,   102,   103,   104,   105,
     106,   107,   108,    -1,   110,    -1,   112,   113,   114,   115,
     116,   117,    -1,   119,   120,   121,    -1,    -1,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,    -1,   134,   135,
     136,    -1,   138,   139,   140,   141,   142,   143,   144,   145,
     146,    -1,   148,    -1,   150,   151,   152,   153,    -1,   155,
      -1,   157,    -1,    -1,    -1,   161,   162,   163,    -1,   165,
     166,    -1,   168,   169,    -1,   171,   172,   173,   174,   175,
      -1,   177,   178,   179,   180,    -1,   182,   183,   184,   185,
     186,   187,    -1,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,    -1,   201,    -1,    -1,   204,    -1,
     206,   207,   208,   209,   210,    -1,    -1,   213,   214,    -1,
     216,    -1,    -1,   219,   220,   221,    -1,    -1,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,    -1,   242,   243,   244,   245,
      -1,   247,   248,    -1,   250,    -1,   252,   253,   254,   255,
     256,   257,    -1,   259,    -1,    -1,   262,   263,   264,    -1,
      -1,   267,   268,    -1,   270,    -1,   272,   273,   274,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,    -1,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,    -1,   333,   334,   335,
     336,   337,    -1,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,    -1,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,    -1,   363,   364,    -1,
     366,    -1,   368,   369,   370,   371,   372,    -1,   374,   375,
      -1,    -1,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,    -1,    -1,   393,   394,   395,
     396,   397,   398,    -1,   400,   401,   402,   403,   404,   405,
     406,    -1,   408,    -1,   410,   411,   412,   413,    -1,    -1,
     416,    -1,    -1,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      -1,    43,    44,    45,    46,    47,    -1,    49,    50,    -1,
      52,    53,    54,    55,    56,    -1,    -1,    59,    60,    61,
      62,    63,    -1,    65,    66,    67,    68,    69,    -1,    -1,
      -1,    73,    74,    75,    76,    -1,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    -1,    -1,    90,    91,
      92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,
     102,   103,   104,   105,   106,   107,   108,    -1,   110,    -1,
     112,   113,   114,   115,   116,   117,    -1,   119,   120,   121,
      -1,    -1,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,    -1,   134,   135,   136,    -1,   138,   139,   140,   141,
     142,   143,   144,   145,   146,    -1,   148,    -1,   150,   151,
     152,   153,    -1,   155,    -1,   157,    -1,    -1,    -1,   161,
     162,   163,    -1,   165,   166,    -1,   168,   169,    -1,   171,
     172,   173,   174,   175,    -1,   177,   178,   179,   180,    -1,
     182,   183,   184,   185,   186,   187,    -1,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,    -1,   201,
      -1,    -1,   204,    -1,   206,   207,   208,   209,   210,    -1,
      -1,   213,   214,    -1,   216,    -1,    -1,   219,   220,   221,
      -1,    -1,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,    -1,
     242,   243,   244,   245,    -1,   247,   248,    -1,   250,    -1,
     252,   253,   254,   255,   256,   257,    -1,   259,    -1,    -1,
     262,   263,   264,    -1,    -1,   267,   268,    -1,   270,    -1,
     272,   273,   274,   275,   276,   277,   278,   279,   280,    -1,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,    -1,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
      -1,   333,   334,   335,   336,   337,    -1,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,    -1,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
      -1,   363,   364,    -1,   366,    -1,   368,   369,   370,   371,
     372,    -1,   374,   375,    -1,    -1,   378,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,   388,   389,   390,    -1,
      -1,   393,   394,   395,   396,   397,   398,    -1,   400,   401,
     402,   403,   404,   405,   406,    -1,   408,    -1,   410,   411,
     412,   413,    -1,    -1,   416,    -1,    -1,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
      -1,    -1,    -1,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,    -1,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,    -1,    -1,   204,    -1,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,    -1,   216,    -1,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,    -1,   242,   243,   244,   245,    -1,   247,
     248,    -1,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,    -1,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,   317,
     318,    -1,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,    -1,   333,   334,   335,   336,   337,
      -1,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,    -1,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,    -1,   363,   364,    -1,   366,    -1,
     368,   369,   370,   371,   372,    -1,   374,   375,    -1,    -1,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
     388,   389,   390,    -1,    -1,   393,   394,   395,   396,   397,
      -1,    -1,   400,   401,   402,   403,   404,   405,   406,    -1,
     408,    -1,   410,   411,   412,   413,    -1,    -1,   416,    -1,
      -1,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,    43,
      44,    45,    46,    47,    -1,    49,    50,    -1,    52,    53,
      54,    55,    56,    -1,    -1,    59,    60,    61,    62,    63,
      -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,    73,
      74,    75,    76,    -1,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    -1,    -1,    90,    91,    92,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,   103,
     104,   105,   106,   107,   108,    -1,   110,    -1,   112,   113,
     114,   115,   116,   117,    -1,   119,   120,   121,    -1,    -1,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,    -1,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,   143,
     144,   145,   146,    -1,   148,    -1,   150,   151,   152,   153,
      -1,   155,    -1,   157,    -1,    -1,    -1,   161,   162,   163,
      -1,   165,   166,    -1,   168,   169,    -1,   171,   172,   173,
     174,   175,    -1,   177,   178,   179,   180,    -1,   182,   183,
     184,   185,   186,   187,    -1,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,    -1,   201,    -1,    -1,
     204,    -1,   206,   207,   208,   209,   210,    -1,    -1,   213,
     214,    -1,   216,    -1,    -1,   219,   220,   221,    -1,    -1,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,    -1,   242,   243,
     244,   245,    -1,   247,   248,    -1,   250,    -1,   252,   253,
     254,   255,   256,   257,    -1,   259,    -1,    -1,   262,   263,
     264,    -1,    -1,   267,   268,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,   278,   279,   280,    -1,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,    -1,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,    -1,   333,
     334,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,    -1,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,    -1,   363,
     364,    -1,   366,    -1,   368,   369,   370,   371,   372,    -1,
     374,   375,    -1,    -1,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,   388,   389,   390,    -1,    -1,   393,
     394,   395,   396,   397,    -1,    -1,   400,   401,   402,   403,
     404,   405,   406,    -1,   408,    -1,   410,   411,   412,   413,
      -1,    -1,   416,    -1,    -1,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    -1,    43,    44,    45,    46,    47,    -1,    49,
      50,    -1,    52,    53,    54,    55,    56,    -1,    -1,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    68,    69,
      -1,    -1,    -1,    73,    74,    75,    76,    -1,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    -1,
      90,    91,    92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     100,   101,   102,   103,   104,   105,   106,   107,   108,    -1,
     110,    -1,   112,   113,   114,   115,   116,   117,    -1,   119,
     120,   121,    -1,    -1,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,    -1,   134,   135,   136,    -1,   138,   139,
     140,   141,   142,   143,   144,   145,   146,    -1,   148,    -1,
     150,   151,   152,   153,    -1,   155,    -1,   157,    -1,    -1,
      -1,   161,   162,   163,    -1,   165,   166,    -1,   168,   169,
      -1,   171,   172,   173,   174,   175,    -1,   177,   178,   179,
     180,    -1,   182,   183,   184,   185,   186,   187,    -1,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
      -1,   201,    -1,    -1,   204,    -1,   206,   207,   208,   209,
     210,    -1,    -1,   213,   214,    -1,   216,    -1,    -1,   219,
     220,   221,    -1,    -1,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,    -1,   242,   243,   244,   245,    -1,   247,   248,    -1,
     250,    -1,   252,   253,   254,   255,   256,   257,    -1,   259,
      -1,    -1,   262,   263,   264,    -1,    -1,   267,   268,    -1,
     270,    -1,   272,   273,   274,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,    -1,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,    -1,   333,   334,   335,   336,   337,    -1,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,    -1,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,    -1,   363,   364,    -1,   366,    -1,   368,   369,
     370,   371,   372,    -1,   374,   375,    -1,    -1,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,    -1,    -1,   393,   394,   395,   396,   397,    -1,    -1,
     400,   401,   402,   403,   404,   405,   406,    -1,   408,    -1,
     410,   411,   412,   413,    -1,    -1,   416,    -1,    -1,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    -1,    43,    44,    45,
      46,    47,    -1,    49,    50,    -1,    52,    53,    54,    55,
      56,    -1,    -1,    59,    60,    61,    62,    63,    -1,    65,
      66,    67,    68,    69,    -1,    -1,    -1,    73,    74,    75,
      76,    -1,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    -1,    -1,    90,    91,    92,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   100,   101,   102,   103,   104,   105,
     106,   107,   108,    -1,   110,    -1,   112,   113,   114,   115,
     116,   117,    -1,   119,   120,   121,    -1,    -1,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,    -1,   134,   135,
     136,    -1,   138,   139,   140,   141,   142,   143,   144,   145,
     146,    -1,   148,    -1,   150,   151,   152,   153,    -1,   155,
      -1,   157,    -1,    -1,    -1,   161,   162,   163,    -1,   165,
     166,    -1,   168,   169,    -1,   171,   172,   173,   174,   175,
      -1,   177,   178,   179,   180,    -1,   182,   183,   184,   185,
     186,   187,    -1,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,    -1,   201,    -1,    -1,   204,    -1,
     206,   207,   208,   209,   210,    -1,    -1,   213,   214,    -1,
     216,    -1,    -1,   219,   220,   221,    -1,    -1,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,    -1,   242,   243,   244,   245,
      -1,   247,   248,    -1,   250,    -1,   252,   253,   254,   255,
     256,   257,    -1,   259,    -1,    -1,   262,   263,   264,    -1,
      -1,   267,   268,    -1,   270,    -1,   272,   273,   274,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,    -1,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,    -1,   333,   334,   335,
     336,   337,    -1,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,    -1,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,    -1,   363,   364,    -1,
     366,    -1,   368,   369,   370,   371,   372,    -1,   374,   375,
      -1,    -1,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,    -1,    -1,   393,   394,   395,
     396,   397,    -1,    -1,   400,   401,   402,   403,   404,   405,
     406,    -1,   408,    -1,   410,   411,   412,   413,    -1,    -1,
     416,    -1,    -1,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      -1,    43,    44,    45,    46,    47,    -1,    49,    50,    -1,
      52,    53,    54,    55,    56,    -1,    -1,    59,    60,    61,
      62,    63,    -1,    65,    66,    67,    68,    69,    -1,    -1,
      -1,    73,    74,    75,    76,    -1,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    -1,    -1,    90,    91,
      92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,
     102,   103,   104,   105,   106,   107,   108,    -1,   110,    -1,
     112,   113,   114,   115,   116,   117,    -1,   119,   120,   121,
      -1,    -1,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,    -1,   134,   135,   136,    -1,   138,   139,   140,   141,
     142,   143,   144,   145,   146,    -1,   148,    -1,   150,   151,
     152,   153,    -1,   155,    -1,   157,    -1,    -1,    -1,   161,
     162,   163,    -1,   165,   166,    -1,   168,   169,    -1,   171,
     172,   173,   174,   175,    -1,   177,   178,   179,   180,    -1,
     182,   183,   184,   185,   186,   187,    -1,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,    -1,   201,
      -1,    -1,   204,    -1,   206,   207,   208,   209,   210,    -1,
      -1,   213,   214,    -1,   216,    -1,    -1,   219,   220,   221,
      -1,    -1,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,    -1,
     242,   243,   244,   245,    -1,   247,   248,    -1,   250,    -1,
     252,   253,   254,   255,   256,   257,    -1,   259,    -1,   261,
     262,   263,   264,    -1,    -1,   267,   268,    -1,   270,    -1,
     272,   273,   274,   275,   276,   277,   278,   279,   280,    -1,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,    -1,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
      -1,   333,   334,   335,   336,   337,    -1,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,    -1,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
      -1,   363,   364,    -1,   366,    -1,   368,   369,   370,   371,
     372,    -1,   374,   375,    -1,    -1,   378,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,   388,   389,   390,    -1,
      -1,   393,   394,   395,   396,   397,    -1,    -1,   400,   401,
     402,   403,   404,   405,   406,    -1,   408,    -1,   410,   411,
     412,   413,    -1,    -1,   416,    -1,    -1,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
      -1,    -1,    -1,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,    -1,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,    -1,    -1,   204,    -1,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,    -1,   216,    -1,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,    -1,   242,   243,   244,   245,    -1,   247,
     248,    -1,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,    -1,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,   317,
     318,    -1,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,    -1,   333,   334,   335,   336,   337,
      -1,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,    -1,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,    -1,   363,   364,    -1,   366,    -1,
     368,   369,   370,   371,   372,    -1,   374,   375,    -1,    -1,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
     388,   389,   390,    -1,    -1,   393,   394,   395,   396,   397,
      -1,    -1,   400,   401,   402,   403,   404,   405,   406,    -1,
     408,    -1,   410,   411,   412,   413,    -1,    -1,   416,    -1,
      -1,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,    43,
      44,    45,    46,    47,    -1,    49,    50,    -1,    52,    53,
      54,    55,    56,    -1,    -1,    59,    60,    61,    62,    63,
      -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,    73,
      74,    75,    76,    -1,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    -1,    -1,    90,    91,    92,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,   103,
     104,   105,   106,   107,   108,    -1,   110,    -1,   112,   113,
     114,   115,   116,   117,    -1,   119,   120,   121,    -1,    -1,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,    -1,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,   143,
     144,   145,   146,    -1,   148,    -1,   150,   151,   152,   153,
      -1,   155,    -1,   157,    -1,    -1,    -1,   161,   162,   163,
      -1,   165,   166,    -1,   168,   169,    -1,   171,   172,   173,
     174,   175,    -1,   177,   178,   179,   180,    -1,   182,   183,
     184,   185,   186,   187,    -1,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,    -1,   201,    -1,    -1,
     204,    -1,   206,   207,   208,   209,   210,    -1,    -1,   213,
     214,    -1,   216,    -1,    -1,   219,   220,   221,    -1,    -1,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,    -1,   242,   243,
     244,   245,    -1,   247,   248,    -1,   250,    -1,   252,   253,
     254,   255,   256,   257,    -1,   259,    -1,    -1,   262,   263,
     264,    -1,    -1,   267,   268,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,   278,   279,   280,    -1,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,    -1,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,    -1,   333,
     334,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,    -1,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,    -1,   363,
     364,    -1,   366,    -1,   368,   369,   370,   371,   372,    -1,
     374,   375,    -1,    -1,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,   388,   389,   390,    -1,    -1,   393,
     394,   395,   396,   397,    -1,    -1,   400,   401,   402,   403,
     404,   405,   406,    -1,   408,    -1,   410,   411,   412,   413,
      -1,    -1,   416,    -1,    -1,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    -1,    43,    44,    45,    46,    47,    -1,    49,
      50,    -1,    52,    53,    54,    55,    56,    -1,    -1,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    68,    69,
      -1,    -1,    -1,    73,    74,    75,    76,    -1,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    -1,
      90,    91,    92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     100,   101,   102,   103,   104,   105,   106,   107,   108,    -1,
     110,    -1,   112,   113,   114,   115,   116,   117,    -1,   119,
     120,   121,    -1,    -1,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,    -1,   134,   135,   136,    -1,   138,   139,
     140,   141,   142,   143,   144,   145,   146,    -1,   148,    -1,
     150,   151,   152,   153,    -1,   155,    -1,   157,    -1,    -1,
      -1,   161,   162,   163,    -1,   165,   166,    -1,   168,   169,
      -1,   171,   172,   173,   174,   175,    -1,   177,   178,   179,
     180,    -1,   182,   183,   184,   185,   186,   187,    -1,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
      -1,   201,    -1,    -1,   204,    -1,   206,   207,   208,   209,
     210,    -1,    -1,   213,   214,    -1,   216,    -1,    -1,   219,
     220,   221,    -1,    -1,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,    -1,   242,   243,   244,   245,    -1,   247,   248,    -1,
     250,    -1,   252,   253,   254,   255,   256,   257,    -1,   259,
      -1,    -1,   262,   263,   264,    -1,    -1,   267,   268,    -1,
     270,    -1,   272,   273,   274,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,    -1,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,    -1,   333,   334,   335,   336,   337,    -1,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,    -1,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,    -1,   363,   364,    -1,   366,    -1,   368,   369,
     370,   371,   372,    -1,   374,   375,    -1,    -1,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,    -1,    -1,   393,   394,   395,   396,   397,    -1,    -1,
     400,   401,   402,   403,   404,   405,   406,    -1,   408,    -1,
     410,   411,   412,   413,    -1,    -1,   416,    -1,    -1,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    42,    43,    44,    45,
      46,    47,    -1,    49,    50,    -1,    52,    53,    54,    55,
      56,    -1,    -1,    59,    60,    61,    62,    63,    -1,    65,
      66,    67,    68,    69,    -1,    -1,    -1,    73,    74,    75,
      76,    -1,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    -1,    -1,    90,    91,    92,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   100,   101,   102,   103,   104,   105,
     106,   107,   108,    -1,   110,    -1,   112,   113,   114,   115,
     116,   117,    -1,   119,   120,   121,    -1,    -1,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,    -1,   134,   135,
     136,    -1,   138,   139,   140,   141,   142,   143,   144,   145,
     146,    -1,   148,    -1,   150,   151,   152,   153,    -1,   155,
      -1,   157,    -1,    -1,    -1,   161,   162,   163,    -1,   165,
     166,    -1,   168,   169,    -1,   171,   172,   173,   174,   175,
      -1,   177,   178,   179,   180,    -1,   182,   183,   184,   185,
     186,   187,    -1,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,    -1,   201,    -1,    -1,   204,    -1,
     206,   207,   208,   209,   210,    -1,    -1,   213,   214,    -1,
     216,    -1,    -1,   219,   220,   221,    -1,    -1,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,    -1,   242,   243,   244,   245,
      -1,   247,   248,    -1,   250,    -1,   252,   253,   254,   255,
     256,   257,    -1,   259,    -1,    -1,   262,   263,   264,    -1,
      -1,   267,   268,    -1,   270,    -1,   272,   273,   274,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,    -1,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,    -1,   333,   334,   335,
     336,   337,    -1,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,    -1,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,    -1,   363,   364,    -1,
     366,    -1,   368,   369,   370,   371,   372,    -1,   374,   375,
      -1,    -1,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,    -1,    -1,   393,   394,   395,
     396,   397,    -1,    -1,   400,   401,   402,   403,   404,   405,
     406,    -1,   408,    -1,   410,   411,   412,   413,    -1,    -1,
     416,    -1,    -1,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      -1,    43,    44,    45,    46,    47,    -1,    49,    50,    -1,
      52,    53,    54,    55,    56,    -1,    -1,    59,    60,    61,
      62,    63,    -1,    65,    66,    67,    68,    69,    -1,    -1,
      -1,    73,    74,    75,    76,    -1,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    -1,    -1,    90,    91,
      92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,
     102,   103,   104,   105,   106,   107,   108,    -1,   110,    -1,
     112,   113,   114,   115,   116,   117,    -1,   119,   120,   121,
      -1,    -1,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,    -1,   134,   135,   136,    -1,   138,   139,   140,   141,
     142,   143,   144,   145,   146,    -1,   148,    -1,   150,   151,
     152,   153,    -1,   155,    -1,   157,    -1,    -1,    -1,   161,
     162,   163,    -1,   165,   166,    -1,   168,   169,    -1,   171,
     172,   173,   174,   175,    -1,   177,   178,   179,   180,    -1,
     182,   183,   184,   185,   186,   187,    -1,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,    -1,   201,
      -1,    -1,   204,    -1,   206,   207,   208,   209,   210,    -1,
      -1,   213,   214,    -1,   216,    -1,    -1,   219,   220,   221,
      -1,    -1,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,    -1,
     242,   243,   244,   245,    -1,   247,   248,    -1,   250,    -1,
     252,   253,   254,   255,   256,   257,    -1,   259,    -1,   261,
     262,   263,   264,    -1,    -1,   267,   268,    -1,   270,    -1,
     272,   273,   274,   275,   276,   277,   278,   279,   280,    -1,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,    -1,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
      -1,   333,   334,   335,   336,   337,    -1,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,    -1,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
      -1,   363,   364,    -1,   366,    -1,   368,   369,   370,   371,
     372,    -1,   374,   375,    -1,    -1,   378,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,   388,   389,   390,    -1,
      -1,   393,   394,   395,   396,   397,    -1,    -1,   400,   401,
     402,   403,   404,   405,   406,    -1,   408,    -1,   410,   411,
     412,   413,    -1,    -1,   416,    -1,    -1,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
      -1,    -1,    -1,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,    -1,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,    -1,    -1,   204,    -1,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,    -1,   216,    -1,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,    -1,   242,   243,   244,   245,    -1,   247,
     248,    -1,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,    -1,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,   317,
     318,    -1,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,    -1,   333,   334,   335,   336,   337,
      -1,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,    -1,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,    -1,   363,   364,    -1,   366,    -1,
     368,   369,   370,   371,   372,    -1,   374,   375,    -1,    -1,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
     388,   389,   390,    -1,    -1,   393,   394,   395,   396,   397,
      -1,    -1,   400,   401,   402,   403,   404,   405,   406,    -1,
     408,    -1,   410,   411,   412,   413,    -1,    -1,   416,    -1,
      -1,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,    43,
      44,    45,    46,    47,    -1,    49,    50,    -1,    52,    53,
      54,    55,    56,    -1,    -1,    59,    60,    61,    62,    63,
      -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,    73,
      74,    75,    76,    -1,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    -1,    -1,    90,    91,    92,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,   103,
     104,   105,   106,   107,   108,    -1,   110,    -1,   112,   113,
     114,   115,   116,   117,    -1,   119,   120,   121,    -1,    -1,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,    -1,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,   143,
     144,   145,   146,    -1,   148,    -1,   150,   151,   152,   153,
      -1,   155,    -1,   157,    -1,    -1,    -1,   161,   162,   163,
      -1,   165,   166,    -1,   168,   169,    -1,   171,   172,   173,
     174,   175,    -1,   177,   178,   179,   180,    -1,   182,   183,
     184,   185,   186,   187,    -1,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,    -1,   201,    -1,    -1,
     204,    -1,   206,   207,   208,   209,   210,    -1,    -1,   213,
     214,    -1,   216,    -1,    -1,   219,   220,   221,    -1,    -1,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,    -1,   242,   243,
     244,   245,    -1,   247,   248,    -1,   250,    -1,   252,   253,
     254,   255,   256,   257,    -1,   259,    -1,    -1,   262,   263,
     264,    -1,    -1,   267,   268,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,   278,   279,   280,    -1,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,    -1,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,    -1,   333,
     334,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,    -1,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,    -1,   363,
     364,    -1,   366,    -1,   368,   369,   370,   371,   372,    -1,
     374,   375,    -1,    -1,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,   388,   389,   390,    -1,    -1,   393,
     394,   395,   396,   397,    -1,    -1,   400,   401,   402,   403,
     404,   405,   406,    -1,   408,    -1,   410,   411,   412,   413,
      -1,    -1,   416,    -1,    -1,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    -1,    43,    44,    45,    46,    47,    -1,    49,
      50,    -1,    52,    53,    54,    55,    56,    -1,    -1,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    68,    69,
      -1,    -1,    -1,    73,    74,    75,    76,    -1,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    -1,
      90,    91,    92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     100,   101,   102,   103,   104,   105,   106,   107,   108,    -1,
     110,    -1,   112,   113,   114,   115,   116,   117,    -1,   119,
     120,   121,    -1,    -1,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,    -1,   134,   135,   136,    -1,   138,   139,
     140,   141,   142,   143,   144,   145,   146,    -1,   148,    -1,
     150,   151,   152,   153,    -1,   155,    -1,   157,    -1,    -1,
      -1,   161,   162,   163,    -1,   165,   166,    -1,   168,   169,
      -1,   171,   172,   173,   174,   175,    -1,   177,   178,   179,
     180,    -1,   182,   183,   184,   185,   186,   187,    -1,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
      -1,   201,    -1,    -1,   204,    -1,   206,   207,   208,   209,
     210,    -1,    -1,   213,   214,    -1,   216,    -1,    -1,   219,
     220,   221,    -1,    -1,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,    -1,   242,   243,   244,   245,    -1,   247,   248,    -1,
     250,    -1,   252,   253,   254,   255,   256,   257,    -1,   259,
      -1,    -1,   262,   263,   264,    -1,    -1,   267,   268,    -1,
     270,    -1,   272,   273,   274,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,    -1,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,    -1,   333,   334,   335,   336,   337,    -1,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,    -1,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,    -1,   363,   364,   365,   366,    -1,   368,   369,
     370,   371,   372,    -1,   374,   375,    -1,    -1,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,    -1,    -1,   393,   394,   395,   396,   397,    -1,    -1,
     400,   401,   402,   403,   404,   405,   406,    -1,   408,    -1,
     410,   411,   412,   413,    -1,    -1,   416,    -1,    -1,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,     3,    -1,     5,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    -1,    43,    44,    45,
      46,    47,    -1,    49,    50,    -1,    52,    53,    54,    55,
      56,    -1,    -1,    59,    60,    61,    62,    63,    -1,    65,
      66,    67,    68,    69,    -1,    -1,    -1,    73,    74,    75,
      76,    -1,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    -1,    -1,    90,    91,    92,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   100,   101,   102,   103,   104,   105,
     106,   107,   108,    -1,   110,    -1,   112,   113,   114,   115,
     116,   117,    -1,   119,   120,   121,    -1,    -1,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,    -1,   134,   135,
     136,    -1,   138,   139,   140,   141,   142,   143,   144,   145,
     146,    -1,   148,    -1,   150,   151,   152,   153,    -1,   155,
      -1,   157,    -1,    -1,    -1,   161,   162,   163,    -1,   165,
     166,    -1,   168,   169,    -1,   171,   172,   173,   174,   175,
      -1,   177,   178,   179,   180,    -1,   182,   183,   184,   185,
     186,   187,    -1,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,    -1,   201,    -1,    -1,   204,    -1,
     206,   207,   208,   209,   210,    -1,    -1,   213,   214,    -1,
     216,    -1,    -1,   219,   220,   221,    -1,    -1,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,    -1,   242,   243,   244,   245,
      -1,   247,   248,    -1,   250,    -1,   252,   253,   254,   255,
     256,   257,    -1,   259,    -1,    -1,   262,   263,   264,    -1,
      -1,   267,   268,    -1,   270,    -1,   272,   273,   274,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,    -1,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,    -1,   333,   334,   335,
     336,   337,    -1,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,    -1,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,    -1,   363,   364,    -1,
     366,    -1,   368,   369,   370,   371,   372,    -1,   374,   375,
      -1,    -1,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,    -1,    -1,   393,   394,   395,
     396,   397,    -1,    -1,   400,   401,   402,   403,   404,   405,
     406,    -1,   408,    -1,   410,   411,   412,   413,    -1,    -1,
     416,    -1,    -1,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    35,    -1,    37,    38,    -1,    40,    41,
      -1,    43,    44,    45,    46,    47,    -1,    49,    50,    -1,
      52,    53,    54,    55,    56,    -1,    -1,    59,    60,    61,
      62,    63,    -1,    65,    66,    67,    68,    69,    -1,    -1,
      -1,    73,    74,    75,    76,    -1,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    -1,    -1,    90,    91,
      92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,
     102,   103,   104,   105,   106,   107,   108,    -1,   110,    -1,
     112,   113,   114,   115,   116,   117,    -1,   119,   120,   121,
      -1,    -1,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,    -1,   134,   135,   136,    -1,   138,   139,   140,   141,
     142,   143,   144,   145,   146,    -1,   148,    -1,   150,   151,
     152,   153,    -1,   155,    -1,   157,    -1,    -1,    -1,   161,
     162,   163,    -1,   165,   166,    -1,   168,   169,    -1,   171,
     172,   173,   174,   175,    -1,   177,   178,   179,   180,    -1,
     182,   183,   184,   185,   186,   187,    -1,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,    -1,   201,
      -1,    -1,   204,    -1,   206,   207,   208,   209,   210,    -1,
      -1,   213,   214,    -1,   216,    -1,    -1,   219,   220,   221,
      -1,    -1,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,    -1,
     242,   243,   244,   245,    -1,   247,   248,    -1,   250,    -1,
     252,   253,   254,   255,   256,   257,    -1,   259,    -1,    -1,
     262,   263,   264,    -1,    -1,   267,   268,    -1,   270,    -1,
     272,   273,   274,   275,   276,   277,   278,   279,   280,    -1,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,    -1,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
      -1,   333,   334,   335,   336,   337,    -1,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,    -1,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
      -1,   363,   364,    -1,   366,    -1,   368,   369,   370,   371,
     372,    -1,   374,   375,    -1,    -1,   378,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,   388,   389,   390,    -1,
      -1,   393,   394,   395,   396,   397,    -1,    -1,   400,   401,
     402,   403,   404,   405,   406,    -1,   408,    -1,   410,   411,
     412,   413,    -1,    -1,   416,    -1,    -1,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    35,    -1,    37,
      38,    -1,    40,    41,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
      -1,    -1,    -1,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,    -1,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,    -1,    -1,   204,    -1,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,    -1,   216,    -1,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,    -1,   242,   243,   244,   245,    -1,   247,
     248,    -1,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,    -1,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,   317,
     318,    -1,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,    -1,   333,   334,   335,   336,   337,
      -1,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,    -1,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,    -1,   363,   364,    -1,   366,    -1,
     368,   369,   370,   371,   372,    -1,   374,   375,    -1,    -1,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
     388,   389,   390,    -1,    -1,   393,   394,   395,   396,   397,
      -1,    -1,   400,   401,   402,   403,   404,   405,   406,    -1,
     408,    -1,   410,   411,   412,   413,    -1,    -1,   416,    -1,
      -1,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,    43,
      44,    45,    46,    47,    -1,    49,    50,    -1,    52,    53,
      54,    55,    56,    -1,    -1,    59,    60,    61,    62,    63,
      -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,    73,
      74,    75,    76,    -1,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    -1,    -1,    90,    91,    92,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,   103,
     104,   105,   106,   107,   108,    -1,   110,    -1,   112,   113,
     114,   115,   116,   117,    -1,   119,   120,   121,    -1,    -1,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,    -1,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,   143,
     144,   145,   146,    -1,   148,    -1,   150,   151,   152,   153,
      -1,   155,    -1,   157,    -1,    -1,    -1,   161,   162,   163,
      -1,   165,   166,    -1,   168,   169,    -1,   171,   172,   173,
     174,   175,    -1,   177,   178,   179,   180,    -1,   182,   183,
     184,   185,   186,   187,    -1,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,    -1,   201,    -1,    -1,
     204,    -1,   206,   207,   208,   209,   210,    -1,    -1,   213,
     214,    -1,   216,    -1,    -1,   219,   220,   221,    -1,    -1,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,    -1,   242,   243,
     244,   245,    -1,   247,   248,    -1,   250,    -1,   252,   253,
     254,   255,   256,   257,    -1,   259,    -1,    -1,   262,   263,
     264,    -1,    -1,   267,   268,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,   278,   279,   280,    -1,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,    -1,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,    -1,   333,
     334,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,    -1,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,    -1,   363,
     364,    -1,   366,    -1,   368,   369,   370,   371,   372,    -1,
     374,   375,    -1,    -1,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,   388,   389,   390,    -1,    -1,   393,
     394,   395,   396,   397,    -1,    -1,   400,   401,   402,   403,
     404,   405,   406,    -1,   408,    -1,   410,   411,   412,   413,
      -1,    -1,   416,    -1,    -1,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    -1,    43,    44,    45,    46,    47,    -1,    49,
      50,    -1,    52,    53,    54,    55,    56,    -1,    -1,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    68,    69,
      -1,    -1,    -1,    73,    74,    75,    76,    -1,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    -1,
      90,    91,    92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     100,   101,   102,   103,   104,   105,   106,   107,   108,    -1,
     110,    -1,   112,   113,   114,   115,   116,   117,    -1,   119,
     120,   121,    -1,    -1,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,    -1,   134,   135,   136,    -1,   138,   139,
     140,   141,   142,   143,   144,   145,   146,    -1,   148,    -1,
     150,   151,   152,   153,    -1,   155,    -1,   157,    -1,    -1,
      -1,   161,   162,   163,    -1,   165,   166,    -1,   168,   169,
      -1,   171,   172,   173,   174,   175,    -1,   177,   178,   179,
     180,    -1,   182,   183,   184,   185,   186,   187,    -1,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
      -1,   201,    -1,    -1,   204,    -1,   206,   207,   208,   209,
     210,    -1,    -1,   213,   214,    -1,   216,    -1,    -1,   219,
     220,   221,    -1,    -1,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,    -1,   242,   243,   244,   245,    -1,   247,   248,    -1,
     250,    -1,   252,   253,   254,   255,   256,   257,    -1,   259,
      -1,    -1,   262,   263,   264,    -1,    -1,   267,   268,    -1,
     270,    -1,   272,   273,   274,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,    -1,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,    -1,   333,   334,   335,   336,   337,    -1,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,    -1,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,    -1,   363,   364,    -1,   366,    -1,   368,   369,
     370,   371,   372,    -1,   374,   375,    -1,    -1,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,    -1,    -1,   393,   394,   395,   396,   397,    -1,    -1,
     400,   401,   402,   403,   404,   405,   406,    -1,   408,    -1,
     410,   411,   412,   413,    -1,    -1,   416,    -1,    -1,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    -1,    43,    44,    45,
      46,    47,    -1,    49,    50,    -1,    52,    53,    54,    55,
      56,    -1,    -1,    59,    60,    61,    62,    63,    -1,    65,
      66,    67,    68,    69,    -1,    -1,    -1,    73,    74,    75,
      76,    -1,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    -1,    -1,    90,    91,    92,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   100,   101,   102,   103,   104,   105,
     106,   107,   108,    -1,   110,    -1,   112,   113,   114,   115,
     116,   117,    -1,   119,   120,   121,    -1,    -1,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,    -1,   134,   135,
     136,    -1,   138,   139,   140,   141,   142,   143,   144,   145,
     146,    -1,   148,    -1,   150,   151,   152,   153,    -1,   155,
      -1,   157,    -1,    -1,    -1,   161,   162,   163,    -1,   165,
     166,    -1,   168,   169,    -1,   171,   172,   173,   174,   175,
      -1,   177,   178,   179,   180,    -1,   182,   183,   184,   185,
     186,   187,    -1,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,    -1,   201,    -1,    -1,   204,    -1,
     206,   207,   208,   209,   210,    -1,    -1,   213,   214,    -1,
     216,    -1,    -1,   219,   220,   221,    -1,    -1,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,    -1,   242,   243,   244,   245,
      -1,   247,   248,    -1,   250,    -1,   252,   253,   254,   255,
     256,   257,    -1,   259,    -1,    -1,   262,   263,   264,    -1,
      -1,   267,   268,    -1,   270,    -1,   272,   273,   274,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,    -1,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,    -1,   333,   334,   335,
     336,   337,    -1,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,    -1,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,    -1,   363,   364,    -1,
     366,    -1,   368,   369,   370,   371,   372,    -1,   374,   375,
      -1,    -1,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,    -1,    -1,   393,   394,   395,
     396,   397,    -1,    -1,   400,   401,   402,   403,   404,   405,
     406,    -1,   408,    -1,   410,   411,   412,   413,    -1,    -1,
     416,    -1,    -1,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      -1,    43,    44,    45,    46,    47,    -1,    49,    50,    -1,
      52,    53,    54,    55,    56,    -1,    -1,    59,    60,    61,
      62,    63,    -1,    65,    66,    67,    68,    69,    -1,    -1,
      -1,    73,    74,    75,    76,    -1,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    -1,    -1,    90,    91,
      92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,
     102,   103,   104,   105,   106,   107,   108,    -1,   110,    -1,
     112,   113,   114,   115,   116,   117,    -1,   119,   120,   121,
      -1,    -1,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,    -1,   134,   135,   136,    -1,   138,   139,   140,   141,
     142,   143,   144,   145,   146,    -1,   148,    -1,   150,   151,
     152,   153,    -1,   155,    -1,   157,    -1,    -1,    -1,   161,
     162,   163,    -1,   165,   166,    -1,   168,   169,    -1,   171,
     172,   173,   174,   175,    -1,   177,   178,   179,   180,    -1,
     182,   183,   184,   185,   186,   187,    -1,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,    -1,   201,
      -1,    -1,   204,    -1,   206,   207,   208,   209,   210,    -1,
      -1,   213,   214,    -1,   216,    -1,    -1,   219,   220,   221,
      -1,    -1,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,    -1,
     242,   243,   244,   245,    -1,   247,   248,    -1,   250,    -1,
     252,   253,   254,   255,   256,   257,    -1,   259,    -1,    -1,
     262,   263,   264,    -1,    -1,   267,   268,    -1,   270,    -1,
     272,   273,   274,   275,   276,   277,   278,   279,   280,    -1,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,    -1,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
      -1,   333,   334,   335,   336,   337,    -1,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,    -1,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
      -1,   363,   364,    -1,   366,    -1,   368,   369,   370,   371,
     372,    -1,   374,   375,    -1,    -1,   378,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,   388,   389,   390,    -1,
      -1,   393,   394,   395,   396,   397,    -1,    -1,   400,   401,
     402,   403,   404,   405,   406,    -1,   408,    -1,   410,   411,
     412,   413,    -1,    -1,   416,    -1,    -1,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
      -1,    -1,    -1,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,    -1,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,    -1,    -1,   204,    -1,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,    -1,   216,    -1,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,    -1,   242,   243,   244,   245,    -1,   247,
     248,    -1,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,    -1,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,   317,
     318,    -1,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,    -1,   333,   334,   335,   336,   337,
      -1,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,    -1,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,    -1,   363,   364,    -1,   366,    -1,
     368,   369,   370,   371,   372,    -1,   374,   375,    -1,    -1,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
     388,   389,   390,    -1,    -1,   393,   394,   395,   396,   397,
      -1,    -1,   400,   401,   402,   403,   404,   405,   406,    -1,
     408,    -1,   410,   411,   412,   413,    -1,    -1,   416,    -1,
      -1,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,    43,
      44,    45,    46,    47,    -1,    49,    50,    -1,    52,    53,
      54,    55,    56,    -1,    -1,    59,    60,    61,    62,    63,
      -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,    73,
      74,    75,    76,    -1,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    -1,    -1,    90,    91,    92,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,   103,
     104,   105,   106,   107,   108,    -1,   110,    -1,   112,   113,
     114,   115,   116,   117,    -1,   119,   120,   121,    -1,    -1,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,    -1,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,   143,
     144,   145,   146,    -1,   148,    -1,   150,   151,   152,   153,
      -1,   155,    -1,   157,    -1,    -1,    -1,   161,   162,   163,
      -1,   165,   166,    -1,   168,   169,    -1,   171,   172,   173,
     174,   175,    -1,   177,   178,   179,   180,    -1,   182,   183,
     184,   185,   186,   187,    -1,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,    -1,   201,    -1,    -1,
     204,    -1,   206,   207,   208,   209,   210,    -1,    -1,   213,
     214,    -1,   216,    -1,    -1,   219,   220,   221,    -1,    -1,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,    -1,   242,   243,
     244,   245,    -1,   247,   248,    -1,   250,    -1,   252,   253,
     254,   255,   256,   257,    -1,   259,    -1,    -1,   262,   263,
     264,    -1,    -1,   267,   268,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,   278,   279,   280,    -1,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,    -1,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,    -1,   333,
     334,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,    -1,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,    -1,   363,
     364,    -1,   366,    -1,   368,   369,   370,   371,   372,    -1,
     374,   375,    -1,    -1,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,   388,   389,   390,    -1,    -1,   393,
     394,   395,   396,   397,    -1,    -1,   400,   401,   402,   403,
     404,   405,   406,    -1,   408,    -1,   410,   411,   412,   413,
      -1,    -1,   416,    -1,    -1,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    -1,    43,    44,    45,    46,    47,    -1,    49,
      50,    -1,    52,    53,    54,    55,    56,    -1,    -1,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    68,    69,
      -1,    -1,    -1,    73,    74,    75,    76,    -1,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    -1,
      90,    91,    92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     100,   101,   102,   103,   104,   105,   106,   107,   108,    -1,
     110,    -1,   112,   113,   114,   115,   116,   117,    -1,   119,
     120,   121,    -1,    -1,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,    -1,   134,   135,   136,    -1,   138,   139,
     140,   141,   142,   143,   144,   145,   146,    -1,   148,    -1,
     150,   151,   152,   153,    -1,   155,    -1,   157,    -1,    -1,
      -1,   161,   162,   163,    -1,   165,   166,    -1,   168,   169,
      -1,   171,   172,   173,   174,   175,    -1,   177,   178,   179,
     180,    -1,   182,   183,   184,   185,   186,   187,    -1,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
      -1,   201,    -1,    -1,   204,    -1,   206,   207,   208,   209,
     210,    -1,    -1,   213,   214,    -1,   216,    -1,    -1,   219,
     220,   221,    -1,    -1,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,    -1,   242,   243,   244,   245,    -1,   247,   248,    -1,
     250,    -1,   252,   253,   254,   255,   256,   257,    -1,   259,
      -1,    -1,   262,   263,   264,    -1,    -1,   267,   268,    -1,
     270,    -1,   272,   273,   274,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,    -1,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,    -1,   333,   334,   335,   336,   337,    -1,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,    -1,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,    -1,   363,   364,    -1,   366,    -1,   368,   369,
     370,   371,   372,    -1,   374,   375,    -1,    -1,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,    -1,    -1,   393,   394,   395,   396,   397,    -1,    -1,
     400,   401,   402,   403,   404,   405,   406,    -1,   408,    -1,
     410,   411,   412,   413,    -1,    -1,   416,    -1,    -1,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    -1,    43,    44,    45,
      46,    47,    -1,    49,    50,    -1,    52,    53,    54,    55,
      56,    -1,    -1,    59,    60,    61,    62,    63,    -1,    65,
      66,    67,    68,    69,    -1,    -1,    -1,    73,    74,    75,
      76,    -1,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    -1,    -1,    90,    91,    92,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   100,   101,   102,   103,   104,   105,
     106,   107,   108,    -1,   110,    -1,   112,   113,   114,   115,
     116,   117,    -1,   119,   120,   121,    -1,    -1,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,    -1,   134,   135,
     136,    -1,   138,   139,   140,   141,   142,   143,   144,   145,
     146,    -1,   148,    -1,   150,   151,   152,   153,    -1,   155,
      -1,   157,    -1,    -1,    -1,   161,   162,   163,    -1,   165,
     166,    -1,   168,   169,    -1,   171,   172,   173,   174,   175,
      -1,   177,   178,   179,   180,    -1,   182,   183,   184,   185,
     186,   187,    -1,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,    -1,   201,    -1,    -1,   204,    -1,
     206,   207,   208,   209,   210,    -1,    -1,   213,   214,    -1,
     216,    -1,    -1,   219,   220,   221,    -1,    -1,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,    -1,   242,   243,   244,   245,
      -1,   247,   248,    -1,   250,    -1,   252,   253,   254,   255,
     256,   257,    -1,   259,    -1,    -1,   262,   263,   264,    -1,
      -1,   267,   268,    -1,   270,    -1,   272,   273,   274,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,    -1,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,    -1,   333,   334,   335,
     336,   337,    -1,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,    -1,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,    -1,   363,   364,    -1,
     366,    -1,   368,   369,   370,   371,   372,    -1,   374,   375,
      -1,    -1,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,    -1,    -1,   393,   394,   395,
     396,   397,    -1,    -1,   400,   401,   402,   403,   404,   405,
     406,    -1,   408,    -1,   410,   411,   412,   413,    -1,    -1,
     416,    -1,    -1,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      -1,    43,    44,    45,    46,    47,    -1,    49,    50,    -1,
      52,    53,    54,    55,    56,    -1,    -1,    59,    60,    61,
      62,    63,    -1,    65,    66,    67,    68,    69,    -1,    -1,
      -1,    73,    74,    75,    76,    -1,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    -1,    -1,    90,    91,
      92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,
     102,   103,   104,   105,   106,   107,   108,    -1,   110,    -1,
     112,   113,   114,   115,   116,   117,    -1,   119,   120,   121,
      -1,    -1,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,    -1,   134,   135,   136,    -1,   138,   139,   140,   141,
     142,   143,   144,   145,   146,    -1,   148,    -1,   150,   151,
     152,   153,    -1,   155,    -1,   157,    -1,    -1,    -1,   161,
     162,   163,    -1,   165,   166,    -1,   168,   169,    -1,   171,
     172,   173,   174,   175,    -1,   177,   178,   179,   180,    -1,
     182,   183,   184,   185,   186,   187,    -1,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,    -1,   201,
      -1,    -1,   204,    -1,   206,   207,   208,   209,   210,    -1,
      -1,   213,   214,    -1,   216,    -1,    -1,   219,   220,   221,
      -1,    -1,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,    -1,
     242,   243,   244,   245,    -1,   247,   248,    -1,   250,    -1,
     252,   253,   254,   255,   256,   257,    -1,   259,    -1,    -1,
     262,   263,   264,    -1,    -1,   267,   268,    -1,   270,    -1,
     272,   273,   274,   275,   276,   277,   278,   279,   280,    -1,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,    -1,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
      -1,   333,   334,   335,   336,   337,    -1,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,    -1,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
      -1,   363,   364,    -1,   366,    -1,   368,   369,   370,   371,
     372,    -1,   374,   375,    -1,    -1,   378,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,   388,   389,   390,    -1,
      -1,   393,   394,   395,   396,   397,    -1,    -1,   400,   401,
     402,   403,   404,   405,   406,    -1,   408,    -1,   410,   411,
     412,   413,    -1,    -1,   416,    -1,    -1,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
      -1,    -1,    -1,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,    -1,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,    -1,    -1,   204,    -1,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,    -1,   216,    -1,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,    -1,   242,   243,   244,   245,    -1,   247,
     248,    -1,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,    -1,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,   317,
     318,    -1,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,    -1,   333,   334,   335,   336,   337,
      -1,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,    -1,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,    -1,   363,   364,    -1,   366,    -1,
     368,   369,   370,   371,   372,    -1,   374,   375,    -1,    -1,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
     388,   389,   390,    -1,    -1,   393,   394,   395,   396,   397,
      -1,    -1,   400,   401,   402,   403,   404,   405,   406,    -1,
     408,    -1,   410,   411,   412,   413,    -1,    -1,   416,    -1,
      -1,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,    43,
      44,    45,    46,    47,    -1,    49,    50,    -1,    52,    53,
      54,    55,    56,    -1,    -1,    59,    60,    61,    62,    63,
      -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,    73,
      74,    75,    76,    -1,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    -1,    -1,    90,    91,    92,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,   103,
     104,   105,   106,   107,   108,    -1,   110,    -1,   112,   113,
     114,   115,   116,   117,    -1,   119,   120,   121,    -1,    -1,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,    -1,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,   143,
     144,   145,   146,    -1,   148,    -1,   150,   151,   152,   153,
      -1,   155,    -1,   157,    -1,    -1,    -1,   161,   162,   163,
      -1,   165,   166,    -1,   168,   169,    -1,   171,   172,   173,
     174,   175,    -1,   177,   178,   179,   180,    -1,   182,   183,
     184,   185,   186,   187,    -1,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,    -1,   201,    -1,    -1,
     204,    -1,   206,   207,   208,   209,   210,    -1,    -1,   213,
     214,    -1,   216,    -1,    -1,   219,   220,   221,    -1,    -1,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,    -1,   242,   243,
     244,   245,    -1,   247,   248,    -1,   250,    -1,   252,   253,
     254,   255,   256,   257,    -1,   259,    -1,    -1,   262,   263,
     264,    -1,    -1,   267,   268,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,   278,   279,   280,    -1,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,    -1,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,    -1,   333,
     334,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,    -1,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,    -1,   363,
     364,    -1,   366,    -1,   368,   369,   370,   371,   372,    -1,
     374,   375,    -1,    -1,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,   388,   389,   390,    -1,    -1,   393,
     394,   395,   396,   397,    -1,    -1,   400,   401,   402,   403,
     404,   405,   406,    -1,   408,    -1,   410,   411,   412,   413,
      -1,    -1,   416,    -1,    -1,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    -1,    43,    44,    45,    46,    47,    -1,    49,
      50,    -1,    52,    53,    54,    55,    56,    -1,    -1,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    68,    69,
      -1,    -1,    -1,    73,    74,    75,    76,    -1,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    -1,
      90,    91,    92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     100,   101,   102,   103,   104,   105,   106,   107,   108,    -1,
     110,    -1,   112,   113,   114,   115,   116,   117,    -1,   119,
     120,   121,    -1,    -1,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,    -1,   134,   135,   136,    -1,   138,   139,
     140,   141,   142,   143,   144,   145,   146,    -1,   148,    -1,
     150,   151,   152,   153,    -1,   155,    -1,   157,    -1,    -1,
      -1,   161,   162,   163,    -1,   165,   166,    -1,   168,   169,
      -1,   171,   172,   173,   174,   175,    -1,   177,   178,   179,
     180,    -1,   182,   183,   184,   185,   186,   187,    -1,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
      -1,   201,    -1,    -1,   204,    -1,   206,   207,   208,   209,
     210,    -1,    -1,   213,   214,    -1,   216,    -1,    -1,   219,
     220,   221,    -1,    -1,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,    -1,   242,   243,   244,   245,    -1,   247,   248,    -1,
     250,    -1,   252,   253,   254,   255,   256,   257,    -1,   259,
      -1,    -1,   262,   263,   264,    -1,    -1,   267,   268,    -1,
     270,    -1,   272,   273,   274,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,    -1,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,    -1,   333,   334,   335,   336,   337,    -1,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,    -1,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,    -1,   363,   364,    -1,   366,    -1,   368,   369,
     370,   371,   372,    -1,   374,   375,    -1,    -1,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,    -1,    -1,   393,   394,   395,   396,   397,    -1,    -1,
     400,   401,   402,   403,   404,   405,   406,    -1,   408,    -1,
     410,   411,   412,   413,    -1,    -1,   416,    -1,    -1,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    -1,    43,    44,    45,
      46,    47,    -1,    49,    50,    -1,    52,    53,    54,    55,
      56,    -1,    -1,    59,    60,    61,    62,    63,    -1,    65,
      66,    67,    68,    69,    -1,    -1,    -1,    73,    74,    75,
      76,    -1,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    -1,    -1,    90,    91,    92,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   100,   101,   102,   103,   104,   105,
     106,   107,   108,    -1,   110,    -1,   112,   113,   114,   115,
     116,   117,    -1,   119,   120,   121,    -1,    -1,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,    -1,   134,   135,
     136,    -1,   138,   139,   140,   141,   142,   143,   144,   145,
     146,    -1,   148,    -1,   150,   151,   152,   153,    -1,   155,
      -1,   157,    -1,    -1,    -1,   161,   162,   163,    -1,   165,
     166,    -1,   168,   169,    -1,   171,   172,   173,   174,   175,
      -1,   177,   178,   179,   180,    -1,   182,   183,   184,   185,
     186,   187,    -1,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,    -1,   201,    -1,    -1,   204,    -1,
     206,   207,   208,   209,   210,    -1,    -1,   213,   214,    -1,
     216,    -1,    -1,   219,   220,   221,    -1,    -1,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,    -1,   242,   243,   244,   245,
      -1,   247,   248,    -1,   250,    -1,   252,   253,   254,   255,
     256,   257,    -1,   259,    -1,    -1,   262,   263,   264,    -1,
      -1,   267,   268,    -1,   270,    -1,   272,   273,   274,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,    -1,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,    -1,   333,   334,   335,
     336,   337,    -1,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,    -1,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,    -1,   363,   364,    -1,
     366,    -1,   368,   369,   370,   371,   372,    -1,   374,   375,
      -1,    -1,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,    -1,    -1,   393,   394,   395,
     396,   397,    -1,    -1,   400,   401,   402,   403,   404,   405,
     406,    -1,   408,    -1,   410,   411,   412,   413,    -1,    -1,
     416,    -1,    -1,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      -1,    43,    44,    45,    46,    47,    -1,    49,    50,    -1,
      52,    53,    54,    55,    56,    -1,    -1,    59,    60,    61,
      62,    63,    -1,    65,    66,    67,    68,    69,    -1,    -1,
      -1,    73,    74,    75,    76,    -1,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    -1,    -1,    90,    91,
      92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,
     102,   103,   104,   105,   106,   107,   108,    -1,   110,    -1,
     112,   113,   114,   115,   116,   117,    -1,   119,   120,   121,
      -1,    -1,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,    -1,   134,   135,   136,    -1,   138,   139,   140,   141,
     142,   143,   144,   145,   146,    -1,   148,    -1,   150,   151,
     152,   153,    -1,   155,    -1,   157,    -1,    -1,    -1,   161,
     162,   163,    -1,   165,   166,    -1,   168,   169,    -1,   171,
     172,   173,   174,   175,    -1,   177,   178,   179,   180,    -1,
     182,   183,   184,   185,   186,   187,    -1,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,    -1,   201,
      -1,    -1,   204,    -1,   206,   207,   208,   209,   210,    -1,
      -1,   213,   214,    -1,   216,    -1,    -1,   219,   220,   221,
      -1,    -1,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,    -1,
     242,   243,   244,   245,    -1,   247,   248,    -1,   250,    -1,
     252,   253,   254,   255,   256,   257,    -1,   259,    -1,    -1,
     262,   263,   264,    -1,    -1,   267,   268,    -1,   270,    -1,
     272,   273,   274,   275,   276,   277,   278,   279,   280,    -1,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,    -1,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
      -1,   333,   334,   335,   336,   337,    -1,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,    -1,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
      -1,   363,   364,    -1,   366,    -1,   368,   369,   370,   371,
     372,    -1,   374,   375,    -1,    -1,   378,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,   388,   389,   390,    -1,
      -1,   393,   394,   395,   396,   397,    -1,    -1,   400,   401,
     402,   403,   404,   405,   406,    -1,   408,    -1,   410,   411,
     412,   413,    -1,    -1,   416,    -1,    -1,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
      -1,    -1,    -1,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,    -1,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,    -1,    -1,   204,    -1,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,    -1,   216,    -1,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,    -1,   242,   243,   244,   245,    -1,   247,
     248,    -1,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,    -1,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,   317,
     318,    -1,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,    -1,   333,   334,   335,   336,   337,
      -1,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,    -1,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,    -1,   363,   364,    -1,   366,    -1,
     368,   369,   370,   371,   372,    -1,   374,   375,    -1,    -1,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
     388,   389,   390,    -1,    -1,   393,   394,   395,   396,   397,
      -1,    -1,   400,   401,   402,   403,   404,   405,   406,    -1,
     408,    -1,   410,   411,   412,   413,    -1,    -1,   416,    -1,
      -1,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,    43,
      44,    45,    46,    47,    -1,    49,    50,    -1,    52,    53,
      54,    55,    56,    -1,    -1,    59,    60,    61,    62,    63,
      -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,    73,
      74,    75,    76,    -1,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    -1,    -1,    90,    91,    92,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,   103,
     104,   105,   106,   107,   108,    -1,   110,    -1,   112,   113,
     114,   115,   116,   117,    -1,   119,   120,   121,    -1,    -1,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,    -1,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,   143,
     144,   145,   146,    -1,   148,    -1,   150,   151,   152,   153,
      -1,   155,    -1,   157,    -1,    -1,    -1,   161,   162,   163,
      -1,   165,   166,    -1,   168,   169,    -1,   171,   172,   173,
     174,   175,    -1,   177,   178,   179,   180,    -1,   182,   183,
     184,   185,   186,   187,    -1,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,    -1,   201,    -1,    -1,
     204,    -1,   206,   207,   208,   209,   210,    -1,    -1,   213,
     214,    -1,   216,    -1,    -1,   219,   220,   221,    -1,    -1,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,    -1,   242,   243,
     244,   245,    -1,   247,   248,    -1,   250,    -1,   252,   253,
     254,   255,   256,   257,    -1,   259,    -1,    -1,   262,   263,
     264,    -1,    -1,   267,   268,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,   278,   279,   280,    -1,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,    -1,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,    -1,   333,
     334,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,    -1,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,    -1,   363,
     364,    -1,   366,    -1,   368,   369,   370,   371,   372,    -1,
     374,   375,    -1,    -1,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,   388,   389,   390,    -1,    -1,   393,
     394,   395,   396,   397,    -1,    -1,   400,   401,   402,   403,
     404,   405,   406,    -1,   408,    -1,   410,   411,   412,   413,
      -1,    -1,   416,    -1,    -1,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    -1,    43,    44,    45,    46,    47,    -1,    49,
      50,    -1,    52,    53,    54,    55,    56,    -1,    -1,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    68,    69,
      -1,    -1,    -1,    73,    74,    75,    76,    -1,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    -1,
      90,    91,    92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     100,   101,   102,   103,   104,   105,   106,   107,   108,    -1,
     110,    -1,   112,   113,   114,   115,   116,   117,    -1,   119,
     120,   121,    -1,    -1,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,    -1,   134,   135,   136,    -1,   138,   139,
     140,   141,   142,   143,   144,   145,   146,    -1,   148,    -1,
     150,   151,   152,   153,    -1,   155,    -1,   157,    -1,    -1,
      -1,   161,   162,   163,    -1,   165,   166,    -1,   168,   169,
      -1,   171,   172,   173,   174,   175,    -1,   177,   178,   179,
     180,    -1,   182,   183,   184,   185,   186,   187,    -1,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
      -1,   201,    -1,    -1,   204,    -1,   206,   207,   208,   209,
     210,    -1,    -1,   213,   214,    -1,   216,    -1,    -1,   219,
     220,   221,    -1,    -1,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,    -1,   242,   243,   244,   245,    -1,   247,   248,    -1,
     250,    -1,   252,   253,   254,   255,   256,   257,    -1,   259,
      -1,    -1,   262,   263,   264,    -1,    -1,   267,   268,    -1,
     270,    -1,   272,   273,   274,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,    -1,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,    -1,   333,   334,   335,   336,   337,    -1,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,    -1,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,    -1,   363,   364,    -1,   366,    -1,   368,   369,
     370,   371,   372,    -1,   374,   375,    -1,    -1,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,    -1,    -1,   393,   394,   395,   396,   397,    -1,    -1,
     400,   401,   402,   403,   404,   405,   406,    -1,   408,    -1,
     410,   411,   412,   413,    -1,    -1,   416,    -1,    -1,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    -1,    43,    44,    45,
      46,    47,    -1,    49,    50,    -1,    52,    53,    54,    55,
      56,    -1,    -1,    59,    60,    61,    62,    63,    -1,    65,
      66,    67,    68,    69,    -1,    -1,    -1,    73,    74,    75,
      76,    -1,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    -1,    -1,    90,    91,    92,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   100,   101,   102,   103,   104,   105,
     106,   107,   108,    -1,   110,    -1,   112,   113,   114,   115,
     116,   117,    -1,   119,   120,   121,    -1,    -1,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,    -1,   134,   135,
     136,    -1,   138,   139,   140,   141,   142,   143,   144,   145,
     146,    -1,   148,    -1,   150,   151,   152,   153,    -1,   155,
      -1,   157,    -1,    -1,    -1,   161,   162,   163,    -1,   165,
     166,    -1,   168,   169,    -1,   171,   172,   173,   174,   175,
      -1,   177,   178,   179,   180,    -1,   182,   183,   184,   185,
     186,   187,    -1,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,    -1,   201,    -1,    -1,   204,    -1,
     206,   207,   208,   209,   210,    -1,    -1,   213,   214,    -1,
     216,    -1,    -1,   219,   220,   221,    -1,    -1,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,    -1,   242,   243,   244,   245,
      -1,   247,   248,    -1,   250,    -1,   252,   253,   254,   255,
     256,   257,    -1,   259,    -1,    -1,   262,   263,   264,    -1,
      -1,   267,   268,    -1,   270,    -1,   272,   273,   274,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,    -1,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,    -1,   333,   334,   335,
     336,   337,    -1,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,    -1,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,    -1,   363,   364,    -1,
     366,    -1,   368,   369,   370,   371,   372,    -1,   374,   375,
      -1,    -1,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,    -1,    -1,   393,   394,   395,
     396,   397,    -1,    -1,   400,   401,   402,   403,   404,   405,
     406,    -1,   408,    -1,   410,   411,   412,   413,    -1,    -1,
     416,    -1,    -1,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      -1,    43,    44,    45,    46,    47,    -1,    49,    50,    -1,
      52,    53,    54,    55,    56,    -1,    -1,    59,    60,    61,
      62,    63,    -1,    65,    66,    67,    68,    69,    -1,    -1,
      -1,    73,    74,    75,    76,    -1,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    -1,    -1,    90,    91,
      92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,
     102,   103,   104,   105,   106,   107,   108,    -1,   110,    -1,
     112,   113,   114,   115,   116,   117,    -1,   119,   120,   121,
      -1,    -1,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,    -1,   134,   135,   136,    -1,   138,   139,   140,   141,
     142,   143,   144,   145,   146,    -1,   148,    -1,   150,   151,
     152,   153,    -1,   155,    -1,   157,    -1,    -1,    -1,   161,
     162,   163,    -1,   165,   166,    -1,   168,   169,    -1,   171,
     172,   173,   174,   175,    -1,   177,   178,   179,   180,    -1,
     182,   183,   184,   185,   186,   187,    -1,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,    -1,   201,
      -1,    -1,   204,    -1,   206,   207,   208,   209,   210,    -1,
      -1,   213,   214,    -1,   216,    -1,    -1,   219,   220,   221,
      -1,    -1,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,    -1,
     242,   243,   244,   245,    -1,   247,   248,    -1,   250,    -1,
     252,   253,   254,   255,   256,   257,    -1,   259,    -1,    -1,
     262,   263,   264,    -1,    -1,   267,   268,    -1,   270,    -1,
     272,   273,   274,   275,   276,   277,   278,   279,   280,    -1,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,    -1,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
      -1,   333,   334,   335,   336,   337,    -1,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,    -1,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
      -1,   363,   364,    -1,   366,    -1,   368,   369,   370,   371,
     372,    -1,   374,   375,    -1,    -1,   378,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,   388,   389,   390,    -1,
      -1,   393,   394,   395,   396,   397,    -1,    -1,   400,   401,
     402,   403,   404,   405,   406,    -1,   408,    -1,   410,   411,
     412,   413,    -1,    -1,   416,    -1,    -1,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
      -1,    -1,    -1,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,    -1,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,    -1,    -1,   204,    -1,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,    -1,   216,    -1,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,    -1,   242,   243,   244,   245,    -1,   247,
     248,    -1,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,    -1,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,   317,
     318,    -1,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,    -1,   333,   334,   335,   336,   337,
      -1,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,    -1,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,    -1,   363,   364,    -1,   366,    -1,
     368,   369,   370,   371,   372,    -1,   374,   375,    -1,    -1,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
     388,   389,   390,    -1,    -1,   393,   394,   395,   396,   397,
      -1,    -1,   400,   401,   402,   403,   404,   405,   406,    -1,
     408,    -1,   410,   411,   412,   413,    -1,    -1,   416,    -1,
      -1,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,    43,
      44,    45,    46,    47,    -1,    49,    50,    -1,    52,    53,
      54,    55,    56,    -1,    -1,    59,    60,    61,    62,    63,
      -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,    73,
      74,    75,    76,    -1,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    -1,    -1,    90,    91,    92,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,   103,
     104,   105,   106,   107,   108,    -1,   110,    -1,   112,   113,
     114,   115,   116,   117,    -1,   119,   120,   121,    -1,    -1,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,    -1,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,   143,
     144,   145,   146,    -1,   148,    -1,   150,   151,   152,   153,
      -1,   155,    -1,   157,    -1,    -1,    -1,   161,   162,   163,
      -1,   165,   166,    -1,   168,   169,    -1,   171,   172,   173,
     174,   175,    -1,   177,   178,   179,   180,    -1,   182,   183,
     184,   185,   186,   187,    -1,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,    -1,   201,    -1,    -1,
     204,    -1,   206,   207,   208,   209,   210,    -1,    -1,   213,
     214,    -1,   216,    -1,    -1,   219,   220,   221,    -1,    -1,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,    -1,   242,   243,
     244,   245,    -1,   247,   248,    -1,   250,    -1,   252,   253,
     254,   255,   256,   257,    -1,   259,    -1,    -1,   262,   263,
     264,    -1,    -1,   267,   268,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,   278,   279,   280,    -1,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,    -1,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,    -1,   333,
     334,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,    -1,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,    -1,   363,
     364,    -1,   366,    -1,   368,   369,   370,   371,   372,    -1,
     374,   375,    -1,    -1,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,   388,   389,   390,    -1,    -1,   393,
     394,   395,   396,   397,    -1,    -1,   400,   401,   402,   403,
     404,   405,   406,    -1,   408,    -1,   410,   411,   412,   413,
      -1,    -1,   416,    -1,    -1,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    -1,    43,    44,    45,    46,    47,    -1,    49,
      50,    -1,    52,    53,    54,    55,    56,    -1,    -1,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    68,    69,
      -1,    -1,    -1,    73,    74,    75,    76,    -1,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    -1,
      90,    91,    92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     100,   101,   102,   103,   104,   105,   106,   107,   108,    -1,
     110,    -1,   112,   113,   114,   115,   116,   117,    -1,   119,
     120,   121,    -1,    -1,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,    -1,   134,   135,   136,    -1,   138,   139,
     140,   141,   142,   143,   144,   145,   146,    -1,   148,    -1,
     150,   151,   152,   153,    -1,   155,    -1,   157,    -1,    -1,
      -1,   161,   162,   163,    -1,   165,   166,    -1,   168,   169,
      -1,   171,   172,   173,   174,   175,    -1,   177,   178,   179,
     180,    -1,   182,   183,   184,   185,   186,   187,    -1,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
      -1,   201,    -1,    -1,   204,    -1,   206,   207,   208,   209,
     210,    -1,    -1,   213,   214,    -1,   216,    -1,    -1,   219,
     220,   221,    -1,    -1,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,    -1,   242,   243,   244,   245,    -1,   247,   248,    -1,
     250,    -1,   252,   253,   254,   255,   256,   257,    -1,   259,
      -1,    -1,   262,   263,   264,    -1,    -1,   267,   268,    -1,
     270,    -1,   272,   273,   274,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,    -1,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,    -1,   333,   334,   335,   336,   337,    -1,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,    -1,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,    -1,   363,   364,    -1,   366,    -1,   368,   369,
     370,   371,   372,    -1,   374,   375,    -1,    -1,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,    -1,    -1,   393,   394,   395,   396,   397,    -1,    -1,
     400,   401,   402,   403,   404,   405,   406,    -1,   408,    -1,
     410,   411,   412,   413,    -1,    -1,   416,    -1,    -1,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    -1,    43,    44,    45,
      46,    47,    -1,    49,    50,    -1,    52,    53,    54,    55,
      56,    -1,    -1,    59,    60,    61,    62,    63,    -1,    65,
      66,    67,    68,    69,    -1,    -1,    -1,    73,    74,    75,
      76,    -1,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    -1,    -1,    90,    91,    92,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   100,   101,   102,   103,   104,   105,
     106,   107,   108,    -1,   110,    -1,   112,   113,   114,   115,
     116,   117,    -1,   119,   120,   121,    -1,    -1,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,    -1,   134,   135,
     136,    -1,   138,   139,   140,   141,   142,   143,   144,   145,
     146,    -1,   148,    -1,   150,   151,   152,   153,    -1,   155,
      -1,   157,    -1,    -1,    -1,   161,   162,   163,    -1,   165,
     166,    -1,   168,   169,    -1,   171,   172,   173,   174,   175,
      -1,   177,   178,   179,   180,    -1,   182,   183,   184,   185,
     186,   187,    -1,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,    -1,   201,    -1,    -1,   204,    -1,
     206,   207,   208,   209,   210,    -1,    -1,   213,   214,    -1,
     216,    -1,    -1,   219,   220,   221,    -1,    -1,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,    -1,   242,   243,   244,   245,
      -1,   247,   248,    -1,   250,    -1,   252,   253,   254,   255,
     256,   257,    -1,   259,    -1,    -1,   262,   263,   264,    -1,
      -1,   267,   268,    -1,   270,    -1,   272,   273,   274,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,    -1,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,    -1,   333,   334,   335,
     336,   337,    -1,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,    -1,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,    -1,   363,   364,    -1,
     366,    -1,   368,   369,   370,   371,   372,    -1,   374,   375,
      -1,    -1,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,    -1,    -1,   393,   394,   395,
     396,   397,    -1,    -1,   400,   401,   402,   403,   404,   405,
     406,    -1,   408,    -1,   410,   411,   412,   413,    -1,    -1,
     416,    -1,    -1,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      -1,    43,    44,    45,    46,    47,    -1,    49,    50,    -1,
      52,    53,    54,    55,    56,    -1,    -1,    59,    60,    61,
      62,    63,    -1,    65,    66,    67,    68,    69,    -1,    -1,
      -1,    73,    74,    75,    76,    -1,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    -1,    -1,    90,    91,
      92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,
     102,   103,   104,   105,   106,   107,   108,    -1,   110,    -1,
     112,   113,   114,   115,   116,   117,    -1,   119,   120,   121,
      -1,    -1,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,    -1,   134,   135,   136,    -1,   138,   139,   140,   141,
     142,   143,   144,   145,   146,    -1,   148,    -1,   150,   151,
     152,   153,    -1,   155,    -1,   157,    -1,    -1,    -1,   161,
     162,   163,    -1,   165,   166,    -1,   168,   169,    -1,   171,
     172,   173,   174,   175,    -1,   177,   178,   179,   180,    -1,
     182,   183,   184,   185,   186,   187,    -1,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,    -1,   201,
      -1,    -1,   204,    -1,   206,   207,   208,   209,   210,    -1,
      -1,   213,   214,    -1,   216,    -1,    -1,   219,   220,   221,
      -1,    -1,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,    -1,
     242,   243,   244,   245,    -1,   247,   248,    -1,   250,    -1,
     252,   253,   254,   255,   256,   257,    -1,   259,    -1,    -1,
     262,   263,   264,    -1,    -1,   267,   268,    -1,   270,    -1,
     272,   273,   274,   275,   276,   277,   278,   279,   280,    -1,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,    -1,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
      -1,   333,   334,   335,   336,   337,    -1,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,    -1,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
      -1,   363,   364,    -1,   366,    -1,   368,   369,   370,   371,
     372,    -1,   374,   375,    -1,    -1,   378,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,   388,   389,   390,    -1,
      -1,   393,   394,   395,   396,   397,    -1,    -1,   400,   401,
     402,   403,   404,   405,   406,    -1,   408,    -1,   410,   411,
     412,   413,    -1,    -1,   416,    -1,    -1,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
      -1,    -1,    -1,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,    -1,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,    -1,    -1,   204,    -1,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,    -1,   216,    -1,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,    -1,   242,   243,   244,   245,    -1,   247,
     248,    -1,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,    -1,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,   317,
     318,    -1,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,    -1,   333,   334,   335,   336,   337,
      -1,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,    -1,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,    -1,   363,   364,    -1,   366,    -1,
     368,   369,   370,   371,   372,    -1,   374,   375,    -1,    -1,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
     388,   389,   390,    -1,    -1,   393,   394,   395,   396,   397,
      -1,    -1,   400,   401,   402,   403,   404,   405,   406,    -1,
     408,    -1,   410,   411,   412,   413,    -1,    -1,   416,    -1,
      -1,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    35,    -1,    37,    38,    -1,    40,    41,    -1,    43,
      44,    45,    46,    47,    -1,    49,    50,    -1,    52,    53,
      54,    55,    56,    -1,    -1,    59,    60,    61,    62,    63,
      -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,    73,
      74,    75,    76,    -1,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    -1,    -1,    90,    91,    92,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,   103,
     104,   105,   106,   107,   108,    -1,   110,    -1,   112,   113,
     114,   115,   116,   117,    -1,   119,   120,   121,    -1,    -1,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,    -1,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,   143,
     144,   145,   146,    -1,   148,    -1,   150,   151,   152,   153,
      -1,   155,    -1,   157,    -1,    -1,    -1,   161,   162,   163,
      -1,   165,   166,    -1,   168,   169,    -1,   171,   172,   173,
     174,   175,    -1,   177,   178,   179,   180,    -1,   182,   183,
     184,   185,   186,   187,    -1,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,    -1,   201,    -1,    -1,
     204,    -1,   206,   207,   208,   209,   210,    -1,    -1,   213,
     214,    -1,   216,    -1,    -1,   219,   220,   221,    -1,    -1,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,    -1,   242,   243,
     244,   245,    -1,   247,   248,    -1,   250,    -1,   252,   253,
     254,   255,   256,   257,    -1,   259,    -1,    -1,   262,   263,
     264,    -1,    -1,   267,   268,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,   278,   279,   280,    -1,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,    -1,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,    -1,   333,
     334,   335,   336,   337,    -1,    -1,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,    -1,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,    -1,   363,
     364,    -1,   366,    -1,   368,   369,   370,   371,   372,    -1,
     374,   375,    -1,    -1,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,   388,   389,   390,    -1,    -1,   393,
     394,   395,   396,   397,    -1,    -1,   400,   401,   402,   403,
     404,   405,   406,    -1,   408,    -1,   410,   411,   412,   413,
      -1,    -1,   416,    -1,    -1,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    -1,    43,    44,    45,    46,    47,    -1,    49,
      50,    -1,    52,    53,    54,    55,    56,    -1,    -1,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    68,    69,
      -1,    -1,    -1,    73,    74,    75,    76,    -1,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    -1,
      90,    91,    92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     100,   101,   102,   103,   104,   105,   106,   107,   108,    -1,
     110,    -1,   112,   113,   114,   115,   116,   117,    -1,   119,
     120,   121,    -1,    -1,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,    -1,   134,   135,   136,    -1,   138,   139,
     140,   141,   142,   143,   144,   145,   146,    -1,   148,    -1,
     150,   151,   152,   153,    -1,   155,    -1,   157,    -1,    -1,
      -1,   161,   162,   163,    -1,   165,   166,    -1,   168,   169,
      -1,   171,   172,   173,   174,   175,    -1,   177,   178,   179,
     180,    -1,   182,   183,   184,   185,   186,   187,    -1,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
      -1,   201,    -1,    -1,   204,    -1,   206,   207,   208,   209,
     210,    -1,    -1,   213,   214,    -1,   216,    -1,    -1,   219,
     220,   221,    -1,    -1,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,    -1,   242,   243,   244,   245,    -1,   247,   248,    -1,
     250,    -1,   252,   253,   254,   255,   256,   257,    -1,   259,
      -1,    -1,   262,   263,   264,    -1,    -1,   267,   268,    -1,
     270,    -1,   272,   273,   274,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,    -1,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,    -1,   333,   334,   335,   336,   337,    -1,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,    -1,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,    -1,   363,   364,    -1,   366,    -1,   368,   369,
     370,   371,   372,    -1,   374,   375,    -1,    -1,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,    -1,    -1,   393,   394,   395,   396,   397,    -1,    -1,
     400,   401,   402,   403,   404,   405,   406,    -1,   408,    -1,
     410,   411,   412,   413,    -1,    -1,   416,    -1,    -1,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    -1,    43,    44,    45,
      46,    47,    -1,    49,    50,    -1,    52,    53,    54,    55,
      56,    -1,    -1,    59,    60,    61,    62,    63,    -1,    65,
      66,    67,    68,    69,    -1,    -1,    -1,    73,    74,    75,
      76,    -1,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    -1,    -1,    90,    91,    92,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   100,   101,   102,   103,   104,   105,
     106,   107,   108,    -1,   110,    -1,   112,   113,   114,   115,
     116,   117,    -1,   119,   120,   121,    -1,    -1,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,    -1,   134,   135,
     136,    -1,   138,   139,   140,   141,   142,   143,   144,   145,
     146,    -1,   148,    -1,   150,   151,   152,   153,    -1,   155,
      -1,   157,    -1,    -1,    -1,   161,   162,   163,    -1,   165,
     166,    -1,   168,   169,    -1,   171,   172,   173,   174,   175,
      -1,   177,   178,   179,   180,    -1,   182,   183,   184,   185,
     186,   187,    -1,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,    -1,   201,    -1,    -1,   204,    -1,
     206,   207,   208,   209,   210,    -1,    -1,   213,   214,    -1,
     216,    -1,    -1,   219,   220,   221,    -1,    -1,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,    -1,   242,   243,   244,   245,
      -1,   247,   248,    -1,   250,    -1,   252,   253,   254,   255,
     256,   257,    -1,   259,    -1,    -1,   262,   263,   264,    -1,
      -1,   267,   268,    -1,   270,    -1,   272,   273,   274,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,    -1,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,    -1,   333,   334,   335,
     336,   337,    -1,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,    -1,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,    -1,   363,   364,    -1,
     366,    -1,   368,   369,   370,   371,   372,    -1,   374,   375,
      -1,    -1,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,    -1,    -1,   393,   394,   395,
     396,   397,    -1,    -1,   400,   401,   402,   403,   404,   405,
     406,    -1,   408,    -1,   410,   411,   412,   413,    -1,    -1,
     416,    -1,    -1,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      -1,    43,    44,    45,    46,    47,    -1,    49,    50,    -1,
      52,    53,    54,    55,    56,    -1,    -1,    59,    60,    61,
      62,    63,    -1,    65,    66,    67,    68,    69,    -1,    -1,
      -1,    73,    74,    75,    76,    -1,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    -1,    -1,    90,    91,
      92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,
     102,   103,   104,   105,   106,   107,   108,    -1,   110,    -1,
     112,   113,   114,   115,   116,   117,    -1,   119,   120,   121,
      -1,    -1,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,    -1,   134,   135,   136,    -1,   138,   139,   140,   141,
     142,   143,   144,   145,   146,    -1,   148,    -1,   150,   151,
     152,   153,    -1,   155,    -1,   157,    -1,    -1,    -1,   161,
     162,   163,    -1,   165,   166,    -1,   168,   169,    -1,   171,
     172,   173,   174,   175,    -1,   177,   178,   179,   180,    -1,
     182,   183,   184,   185,   186,   187,    -1,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,    -1,   201,
      -1,    -1,   204,    -1,   206,   207,   208,   209,   210,    -1,
      -1,   213,   214,    -1,   216,    -1,    -1,   219,   220,   221,
      -1,    -1,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,    -1,
     242,   243,   244,   245,    -1,   247,   248,    -1,   250,    -1,
     252,   253,   254,   255,   256,   257,    -1,   259,    -1,    -1,
     262,   263,   264,    -1,    -1,   267,   268,    -1,   270,    -1,
     272,   273,   274,   275,   276,   277,   278,   279,   280,    -1,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,    -1,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
      -1,   333,   334,   335,   336,   337,    -1,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,    -1,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
      -1,   363,   364,    -1,   366,    -1,   368,   369,   370,   371,
     372,    -1,   374,   375,    -1,    -1,   378,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,   388,   389,   390,    -1,
      -1,   393,   394,   395,   396,   397,    -1,    -1,   400,   401,
     402,   403,   404,   405,   406,    -1,   408,    -1,   410,   411,
     412,   413,    -1,    -1,   416,    -1,    -1,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
      -1,    -1,    -1,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,    -1,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,    -1,    -1,   204,    -1,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,    -1,   216,    -1,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,    -1,   242,   243,   244,   245,    -1,   247,
     248,    -1,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,    -1,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,   317,
     318,    -1,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,    -1,   333,   334,   335,   336,   337,
      -1,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,    -1,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,    -1,   363,   364,    -1,   366,    -1,
     368,   369,   370,   371,   372,    -1,   374,   375,    -1,    -1,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
     388,   389,   390,    -1,    -1,   393,   394,   395,   396,   397,
      -1,    -1,   400,   401,   402,   403,   404,   405,   406,    -1,
     408,    -1,   410,   411,   412,   413,    -1,    -1,   416,    -1,
      -1,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,    43,
      44,    45,    46,    47,    -1,    49,    50,    -1,    52,    53,
      54,    55,    56,    -1,    -1,    59,    60,    61,    62,    63,
      -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,    73,
      74,    75,    76,    -1,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    -1,    -1,    90,    91,    92,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,   103,
     104,   105,   106,   107,   108,    -1,   110,    -1,   112,   113,
     114,   115,   116,   117,    -1,   119,   120,   121,    -1,    -1,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,    -1,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,   143,
     144,   145,   146,    -1,   148,    -1,   150,   151,   152,   153,
      -1,   155,    -1,   157,    -1,    -1,    -1,   161,   162,   163,
      -1,   165,   166,    -1,   168,   169,    -1,   171,   172,   173,
     174,   175,    -1,   177,   178,   179,   180,    -1,   182,   183,
     184,   185,   186,   187,    -1,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,    -1,   201,    -1,    -1,
     204,    -1,   206,   207,   208,   209,   210,    -1,    -1,   213,
     214,    -1,   216,    -1,    -1,   219,   220,   221,    -1,    -1,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,    -1,   242,   243,
     244,   245,    -1,   247,   248,    -1,   250,    -1,   252,   253,
     254,   255,   256,   257,    -1,   259,    -1,    -1,   262,   263,
     264,    -1,    -1,   267,   268,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,   278,   279,   280,    -1,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,    -1,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,    -1,   333,
     334,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,    -1,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,    -1,   363,
     364,    -1,   366,    -1,   368,   369,   370,   371,   372,    -1,
     374,   375,    -1,    -1,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,   388,   389,   390,    -1,    -1,   393,
     394,   395,   396,   397,    -1,    -1,   400,   401,   402,   403,
     404,   405,   406,    -1,   408,    -1,   410,   411,   412,   413,
      -1,    -1,   416,    -1,    -1,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    -1,    43,    44,    45,    46,    47,    -1,    49,
      50,    -1,    52,    53,    54,    55,    56,    -1,    -1,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    68,    69,
      -1,    -1,    -1,    73,    74,    75,    76,    -1,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    -1,
      90,    91,    92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     100,   101,   102,   103,   104,   105,   106,   107,   108,    -1,
     110,    -1,   112,   113,   114,   115,   116,   117,    -1,   119,
     120,   121,    -1,    -1,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,    -1,   134,   135,   136,    -1,   138,   139,
     140,   141,   142,   143,   144,   145,   146,    -1,   148,    -1,
     150,   151,   152,   153,    -1,   155,    -1,   157,    -1,    -1,
      -1,   161,   162,   163,    -1,   165,   166,    -1,   168,   169,
      -1,   171,   172,   173,   174,   175,    -1,   177,   178,   179,
     180,    -1,   182,   183,   184,   185,   186,   187,    -1,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
      -1,   201,    -1,    -1,   204,    -1,   206,   207,   208,   209,
     210,    -1,    -1,   213,   214,    -1,   216,    -1,    -1,   219,
     220,   221,    -1,    -1,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,    -1,   242,   243,   244,   245,    -1,   247,   248,    -1,
     250,    -1,   252,   253,   254,   255,   256,   257,    -1,   259,
      -1,    -1,   262,   263,   264,    -1,    -1,   267,   268,    -1,
     270,    -1,   272,   273,   274,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,    -1,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,    -1,   333,   334,   335,   336,   337,    -1,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,    -1,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,    -1,   363,   364,    -1,   366,    -1,   368,   369,
     370,   371,   372,    -1,   374,   375,    -1,    -1,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,    -1,    -1,   393,   394,   395,   396,   397,    -1,    -1,
     400,   401,   402,   403,   404,   405,   406,    -1,   408,    -1,
     410,   411,   412,   413,    -1,    -1,   416,    -1,    -1,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    -1,    43,    44,    45,
      46,    47,    -1,    49,    50,    -1,    52,    53,    54,    55,
      56,    -1,    -1,    59,    60,    61,    62,    63,    -1,    65,
      66,    67,    68,    69,    -1,    -1,    -1,    73,    74,    75,
      76,    -1,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    -1,    -1,    90,    91,    92,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   100,   101,   102,   103,   104,   105,
     106,   107,   108,    -1,   110,    -1,   112,   113,   114,   115,
     116,   117,    -1,   119,   120,   121,    -1,    -1,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,    -1,   134,   135,
     136,    -1,   138,   139,   140,   141,   142,   143,   144,   145,
     146,    -1,   148,    -1,   150,   151,   152,   153,    -1,   155,
      -1,   157,    -1,    -1,    -1,   161,   162,   163,    -1,   165,
     166,    -1,   168,   169,    -1,   171,   172,   173,   174,   175,
      -1,   177,   178,   179,   180,    -1,   182,   183,   184,   185,
     186,   187,    -1,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,    -1,   201,    -1,    -1,   204,    -1,
     206,   207,   208,   209,   210,    -1,    -1,   213,   214,    -1,
     216,    -1,    -1,   219,   220,   221,    -1,    -1,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,    -1,   242,   243,   244,   245,
      -1,   247,   248,    -1,   250,    -1,   252,   253,   254,   255,
     256,   257,    -1,   259,    -1,    -1,   262,   263,   264,    -1,
      -1,   267,   268,    -1,   270,    -1,   272,   273,   274,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,    -1,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,    -1,   333,   334,   335,
     336,   337,    -1,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,    -1,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,    -1,   363,   364,    -1,
     366,    -1,   368,   369,   370,   371,   372,    -1,   374,   375,
      -1,    -1,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,    -1,    -1,   393,   394,   395,
     396,   397,    -1,    -1,   400,   401,   402,   403,   404,   405,
     406,    -1,   408,    -1,   410,   411,   412,   413,    -1,    -1,
     416,    -1,    -1,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      -1,    43,    44,    45,    46,    47,    -1,    49,    50,    -1,
      52,    53,    54,    55,    56,    -1,    -1,    59,    60,    61,
      62,    63,    -1,    65,    66,    67,    68,    69,    -1,    -1,
      -1,    73,    74,    75,    76,    -1,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    -1,    -1,    90,    91,
      92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,
     102,   103,   104,   105,   106,   107,   108,    -1,   110,    -1,
     112,   113,   114,   115,   116,   117,    -1,   119,   120,   121,
      -1,    -1,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,    -1,   134,   135,   136,    -1,   138,   139,   140,   141,
     142,   143,   144,   145,   146,    -1,   148,    -1,   150,   151,
     152,   153,    -1,   155,    -1,   157,    -1,    -1,    -1,   161,
     162,   163,    -1,   165,   166,    -1,   168,   169,    -1,   171,
     172,   173,   174,   175,    -1,   177,   178,   179,   180,    -1,
     182,   183,   184,   185,   186,   187,    -1,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,    -1,   201,
      -1,    -1,   204,    -1,   206,   207,   208,   209,   210,    -1,
      -1,   213,   214,    -1,   216,    -1,    -1,   219,   220,   221,
      -1,    -1,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,    -1,
     242,   243,   244,   245,    -1,   247,   248,    -1,   250,    -1,
     252,   253,   254,   255,   256,   257,    -1,   259,    -1,    -1,
     262,   263,   264,    -1,    -1,   267,   268,    -1,   270,    -1,
     272,   273,   274,   275,   276,   277,   278,   279,   280,    -1,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,    -1,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
      -1,   333,   334,   335,   336,   337,    -1,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,    -1,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
      -1,   363,   364,    -1,   366,    -1,   368,   369,   370,   371,
     372,    -1,   374,   375,    -1,    -1,   378,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,   388,   389,   390,    -1,
      -1,   393,   394,   395,   396,   397,    -1,    -1,   400,   401,
     402,   403,   404,   405,   406,    -1,   408,    -1,   410,   411,
     412,   413,    -1,    -1,   416,    -1,    -1,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
      -1,    -1,    -1,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,    -1,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,    -1,    -1,   204,    -1,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,    -1,   216,    -1,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,    -1,   242,   243,   244,   245,    -1,   247,
     248,    -1,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,    -1,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,   317,
     318,    -1,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,    -1,   333,   334,   335,   336,   337,
      -1,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,    -1,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,    -1,   363,   364,    -1,   366,    -1,
     368,   369,   370,   371,   372,    -1,   374,   375,    -1,    -1,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
     388,   389,   390,    -1,    -1,   393,   394,   395,   396,   397,
      -1,    -1,   400,   401,   402,   403,   404,   405,   406,    -1,
     408,    -1,   410,   411,   412,   413,    -1,    -1,   416,    -1,
      -1,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,    43,
      44,    45,    46,    47,    -1,    49,    50,    -1,    52,    53,
      54,    55,    56,    -1,    -1,    59,    60,    61,    62,    63,
      -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,    73,
      74,    75,    76,    -1,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    -1,    -1,    90,    91,    92,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,   103,
     104,   105,   106,   107,   108,    -1,   110,    -1,   112,   113,
     114,   115,   116,   117,    -1,   119,   120,   121,    -1,    -1,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,    -1,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,   143,
     144,   145,   146,    -1,   148,    -1,   150,   151,   152,   153,
      -1,   155,    -1,   157,    -1,    -1,    -1,   161,   162,   163,
      -1,   165,   166,    -1,   168,   169,    -1,   171,   172,   173,
     174,   175,    -1,   177,   178,   179,   180,    -1,   182,   183,
     184,   185,   186,   187,    -1,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,    -1,   201,    -1,    -1,
     204,    -1,   206,   207,   208,   209,   210,    -1,    -1,   213,
     214,    -1,   216,    -1,    -1,   219,   220,   221,    -1,    -1,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,    -1,   242,   243,
     244,   245,    -1,   247,   248,    -1,   250,    -1,   252,   253,
     254,   255,   256,   257,    -1,   259,    -1,    -1,   262,   263,
     264,    -1,    -1,   267,   268,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,   278,   279,   280,    -1,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,    -1,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,    -1,   333,
     334,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,    -1,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,    -1,   363,
     364,    -1,   366,    -1,   368,   369,   370,   371,   372,    -1,
     374,   375,    -1,    -1,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,   388,   389,   390,    -1,    -1,   393,
     394,   395,   396,   397,    -1,    -1,   400,   401,   402,   403,
     404,   405,   406,    -1,   408,    -1,   410,   411,   412,   413,
      -1,    -1,   416,    -1,    -1,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    -1,    43,    44,    45,    46,    47,    -1,    49,
      50,    -1,    52,    53,    54,    55,    56,    -1,    -1,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    68,    69,
      -1,    -1,    -1,    73,    74,    75,    76,    -1,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    -1,
      90,    91,    92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     100,   101,   102,   103,   104,   105,   106,   107,   108,    -1,
     110,    -1,   112,   113,   114,   115,   116,   117,    -1,   119,
     120,   121,    -1,    -1,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,    -1,   134,   135,   136,    -1,   138,   139,
     140,   141,   142,   143,   144,   145,   146,    -1,   148,    -1,
     150,   151,   152,   153,    -1,   155,    -1,   157,    -1,    -1,
      -1,   161,   162,   163,    -1,   165,   166,    -1,   168,   169,
      -1,   171,   172,   173,   174,   175,    -1,   177,   178,   179,
     180,    -1,   182,   183,   184,   185,   186,   187,    -1,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
      -1,   201,    -1,    -1,   204,    -1,   206,   207,   208,   209,
     210,    -1,    -1,   213,   214,    -1,   216,    -1,    -1,   219,
     220,   221,    -1,    -1,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,    -1,   242,   243,   244,   245,    -1,   247,   248,    -1,
     250,    -1,   252,   253,   254,   255,   256,   257,    -1,   259,
      -1,    -1,   262,   263,   264,    -1,    -1,   267,   268,    -1,
     270,    -1,   272,   273,   274,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,    -1,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,    -1,   333,   334,   335,   336,   337,    -1,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,    -1,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,    -1,   363,   364,    -1,   366,    -1,   368,   369,
     370,   371,   372,    -1,   374,   375,    -1,    -1,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,    -1,    -1,   393,   394,   395,   396,   397,    -1,    -1,
     400,   401,   402,   403,   404,   405,   406,    -1,   408,    -1,
     410,   411,   412,   413,    -1,    -1,   416,    -1,    -1,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    -1,    43,    44,    45,
      46,    47,    -1,    49,    50,    -1,    52,    53,    54,    55,
      56,    -1,    -1,    59,    60,    61,    62,    63,    -1,    65,
      66,    67,    68,    69,    -1,    -1,    -1,    73,    74,    75,
      76,    -1,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    -1,    -1,    90,    91,    92,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   100,   101,   102,   103,   104,   105,
     106,   107,   108,    -1,   110,    -1,   112,   113,   114,   115,
     116,   117,    -1,   119,   120,   121,    -1,    -1,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,    -1,   134,   135,
     136,    -1,   138,   139,   140,   141,   142,   143,   144,   145,
     146,    -1,   148,    -1,   150,   151,   152,   153,    -1,   155,
      -1,   157,    -1,    -1,    -1,   161,   162,   163,    -1,   165,
     166,    -1,   168,   169,    -1,   171,   172,   173,   174,   175,
      -1,   177,   178,   179,   180,    -1,   182,   183,   184,   185,
     186,   187,    -1,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,    -1,   201,    -1,    -1,   204,    -1,
     206,   207,   208,   209,   210,    -1,    -1,   213,   214,    -1,
     216,    -1,    -1,   219,   220,   221,    -1,    -1,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,    -1,   242,   243,   244,   245,
      -1,   247,   248,    -1,   250,    -1,   252,   253,   254,   255,
     256,   257,    -1,   259,    -1,    -1,   262,   263,   264,    -1,
      -1,   267,   268,    -1,   270,    -1,   272,   273,   274,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,    -1,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,    -1,   333,   334,   335,
     336,   337,    -1,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,    -1,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,    -1,   363,   364,    -1,
     366,    -1,   368,   369,   370,   371,   372,    -1,   374,   375,
      -1,    -1,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,    -1,    -1,   393,   394,   395,
     396,   397,    -1,    -1,   400,   401,   402,   403,   404,   405,
     406,    -1,   408,    -1,   410,   411,   412,   413,    -1,    -1,
     416,    -1,    -1,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      -1,    43,    44,    45,    46,    47,    -1,    49,    50,    -1,
      52,    53,    54,    55,    56,    -1,    -1,    59,    60,    61,
      62,    63,    -1,    65,    66,    67,    68,    69,    -1,    -1,
      -1,    73,    74,    75,    76,    -1,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    -1,    -1,    90,    91,
      92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,
     102,   103,   104,   105,   106,   107,   108,    -1,   110,    -1,
     112,   113,   114,   115,   116,   117,    -1,   119,   120,   121,
      -1,    -1,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,    -1,   134,   135,   136,    -1,   138,   139,   140,   141,
     142,   143,   144,   145,   146,    -1,   148,    -1,   150,   151,
     152,   153,    -1,   155,    -1,   157,    -1,    -1,    -1,   161,
     162,   163,    -1,   165,   166,    -1,   168,   169,    -1,   171,
     172,   173,   174,   175,    -1,   177,   178,   179,   180,    -1,
     182,   183,   184,   185,   186,   187,    -1,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,    -1,   201,
      -1,    -1,   204,    -1,   206,   207,   208,   209,   210,    -1,
      -1,   213,   214,    -1,   216,    -1,    -1,   219,   220,   221,
      -1,    -1,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,    -1,
     242,   243,   244,   245,    -1,   247,   248,    -1,   250,    -1,
     252,   253,   254,   255,   256,   257,    -1,   259,    -1,    -1,
     262,   263,   264,    -1,    -1,   267,   268,    -1,   270,    -1,
     272,   273,   274,   275,   276,   277,   278,   279,   280,    -1,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,    -1,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
      -1,   333,   334,   335,   336,   337,    -1,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,    -1,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
      -1,   363,   364,    -1,   366,    -1,   368,   369,   370,   371,
     372,    -1,   374,   375,    -1,    -1,   378,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,   388,   389,   390,    -1,
      -1,   393,   394,   395,   396,   397,    -1,    -1,   400,   401,
     402,   403,   404,   405,   406,    -1,   408,    -1,   410,   411,
     412,   413,    -1,    -1,   416,    -1,    -1,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
      -1,    -1,    -1,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,    -1,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,    -1,    -1,   204,    -1,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,    -1,   216,    -1,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,    -1,   242,   243,   244,   245,    -1,   247,
     248,    -1,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,    -1,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,   317,
     318,    -1,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,    -1,   333,   334,   335,   336,   337,
      -1,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,    -1,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,    -1,   363,   364,    -1,   366,    -1,
     368,   369,   370,   371,   372,    -1,   374,   375,    -1,    -1,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
     388,   389,   390,    -1,    -1,   393,   394,   395,   396,   397,
      -1,    -1,   400,   401,   402,   403,   404,   405,   406,    -1,
     408,    -1,   410,   411,   412,   413,    -1,    -1,   416,    -1,
      -1,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,    43,
      44,    45,    -1,    47,    48,    49,    50,    -1,    52,    53,
      54,    55,    56,    -1,    -1,    59,    60,    61,    62,    63,
      -1,    65,    66,    67,    68,    -1,    -1,    71,    -1,    73,
      74,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    -1,    89,    90,    91,    92,    -1,
      -1,    -1,    96,    -1,    -1,    -1,   100,   101,   102,   103,
     104,   105,   106,   107,   108,    -1,   110,    -1,   112,   113,
     114,   115,   116,   117,    -1,   119,   120,   121,    -1,    -1,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,    -1,
     134,   135,   136,    -1,   138,   139,   140,   141,    -1,   143,
     144,   145,    -1,    -1,   148,    -1,   150,   151,   152,   153,
      -1,   155,    -1,   157,   158,    -1,   160,   161,   162,   163,
      -1,   165,    -1,    -1,    -1,   169,    -1,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,   181,   182,   183,
     184,   185,   186,   187,    -1,   189,   190,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,    -1,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,    -1,    -1,   213,
      -1,   215,   216,   217,    -1,   219,   220,   221,    -1,    -1,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,    -1,    -1,   247,   248,   249,   250,    -1,    -1,   253,
     254,   255,   256,   257,    -1,   259,    -1,    -1,   262,   263,
     264,    -1,    -1,   267,   268,   269,   270,   271,    -1,   273,
     274,   275,   276,   277,   278,   279,   280,    -1,   282,   283,
      -1,   285,    -1,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,   319,   320,   321,   322,    -1,
     324,   325,   326,   327,   328,   329,   330,   331,    -1,   333,
     334,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,    -1,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,    -1,    -1,   363,
     364,    -1,   366,   367,   368,   369,   370,   371,   372,    -1,
     374,   375,    -1,    -1,   378,   379,    -1,   381,    -1,    -1,
     384,   385,   386,   387,   388,   389,   390,    -1,    -1,   393,
     394,   395,   396,   397,    -1,    -1,   400,   401,   402,   403,
     404,    -1,   406,   407,   408,   409,   410,   411,   412,   413,
      -1,    -1,   416,    -1,    -1,   419,   420,   421,   422,   423,
     424,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     434,   435,   436,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    43,    44,    45,    -1,    47,    48,    49,    50,    -1,
      52,    53,    54,    55,    56,    -1,    -1,    59,    60,    61,
      62,    63,    -1,    65,    66,    67,    68,    -1,    -1,    71,
      -1,    73,    74,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    -1,    89,    90,    91,
      92,    -1,    -1,    -1,    96,    -1,    -1,    -1,   100,   101,
     102,   103,   104,   105,   106,   107,   108,    -1,   110,    -1,
     112,   113,   114,   115,   116,   117,    -1,   119,   120,   121,
      -1,    -1,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,    -1,   134,   135,   136,    -1,   138,   139,   140,   141,
      -1,   143,   144,   145,    -1,    -1,   148,    -1,   150,   151,
     152,   153,    -1,   155,    -1,   157,   158,    -1,   160,   161,
     162,   163,    -1,   165,    -1,    -1,    -1,   169,    -1,   171,
     172,   173,   174,   175,   176,   177,   178,   179,   180,    -1,
     182,   183,   184,   185,   186,   187,    -1,   189,   190,    -1,
     192,   193,   194,   195,   196,   197,    -1,   199,    -1,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,    -1,
      -1,   213,    -1,   215,   216,   217,    -1,   219,   220,   221,
      -1,    -1,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,    -1,    -1,   247,   248,   249,   250,   251,
      -1,   253,   254,   255,   256,   257,    -1,   259,    -1,    -1,
     262,   263,   264,    -1,    -1,   267,    -1,   269,   270,   271,
      -1,   273,   274,   275,   276,   277,   278,   279,   280,    -1,
     282,   283,    -1,   285,    -1,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,   319,   320,   321,
     322,    -1,   324,   325,   326,   327,   328,   329,   330,   331,
      -1,   333,   334,   335,   336,   337,    -1,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,    -1,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,    -1,
      -1,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,    -1,   374,   375,    -1,    -1,   378,   379,    -1,   381,
      -1,    -1,   384,   385,   386,   387,   388,   389,   390,    -1,
      -1,   393,   394,   395,   396,   397,    -1,    -1,   400,   401,
     402,   403,   404,    -1,   406,    -1,   408,   409,   410,   411,
     412,   413,    -1,    -1,   416,    -1,    -1,   419,   420,   421,
     422,   423,   424,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   434,   435,   436,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    -1,    43,    44,    45,    46,    47,    -1,    49,
      50,    -1,    52,    53,    54,    55,    56,    -1,    -1,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    68,    69,
      -1,    -1,    -1,    73,    74,    75,    76,    -1,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    -1,
      90,    91,    92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     100,   101,   102,   103,   104,   105,   106,   107,   108,    -1,
     110,    -1,   112,   113,   114,   115,   116,   117,    -1,   119,
     120,   121,    -1,    -1,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,    -1,   134,   135,   136,    -1,   138,   139,
     140,   141,   142,   143,   144,   145,   146,    -1,   148,    -1,
     150,   151,   152,   153,    -1,   155,    -1,   157,    -1,    -1,
      -1,   161,   162,   163,    -1,   165,   166,    -1,   168,   169,
      -1,   171,   172,   173,   174,   175,    -1,   177,   178,   179,
     180,    -1,   182,   183,   184,   185,   186,   187,    -1,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
      -1,   201,    -1,    -1,   204,    -1,   206,   207,   208,   209,
     210,    -1,    -1,   213,   214,    -1,   216,    -1,    -1,   219,
     220,   221,    -1,    -1,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,    -1,   242,   243,   244,   245,    -1,   247,   248,    -1,
     250,    -1,   252,   253,   254,   255,   256,   257,    -1,   259,
      -1,    -1,   262,   263,   264,    -1,    -1,   267,   268,    -1,
     270,    -1,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,    -1,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,    -1,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,    -1,
     320,   321,   322,   323,    -1,   325,   326,   327,   328,   329,
     330,   331,    -1,   333,   334,   335,   336,   337,    -1,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,    -1,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,    -1,   363,   364,    -1,   366,    -1,   368,   369,
     370,   371,   372,    -1,   374,   375,    -1,    -1,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,    -1,    -1,   393,   394,   395,   396,   397,    -1,    -1,
     400,   401,   402,   403,   404,   405,   406,    -1,   408,    -1,
     410,   411,   412,   413,    -1,    -1,   416,    -1,    -1,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    42,    43,    44,    45,
      -1,    47,    48,    49,    50,    -1,    52,    53,    54,    55,
      56,    -1,    -1,    59,    60,    61,    62,    63,    -1,    65,
      66,    67,    68,    -1,    -1,    71,    -1,    73,    74,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    -1,    89,    90,    91,    92,    -1,    -1,    -1,
      96,    -1,    -1,    -1,   100,   101,   102,   103,   104,   105,
     106,   107,   108,    -1,   110,    -1,   112,   113,   114,   115,
     116,   117,    -1,   119,   120,   121,    -1,    -1,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,    -1,   134,   135,
     136,    -1,   138,   139,   140,   141,    -1,   143,   144,   145,
      -1,    -1,   148,    -1,   150,   151,   152,   153,    -1,   155,
      -1,   157,   158,    -1,   160,   161,   162,   163,    -1,   165,
      -1,    -1,    -1,   169,    -1,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,    -1,   182,   183,   184,   185,
     186,   187,    -1,   189,   190,    -1,   192,   193,   194,   195,
     196,   197,    -1,   199,    -1,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,    -1,    -1,   213,    -1,   215,
     216,   217,    -1,   219,   220,   221,    -1,    -1,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
      -1,   247,   248,   249,   250,    -1,    -1,   253,   254,   255,
     256,   257,    -1,   259,    -1,    -1,   262,   263,   264,    -1,
      -1,   267,    -1,   269,   270,   271,    -1,   273,   274,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,    -1,   285,
      -1,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,   319,   320,   321,   322,    -1,   324,   325,
     326,   327,   328,   329,   330,   331,    -1,   333,   334,   335,
     336,   337,    -1,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,    -1,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,    -1,    -1,   363,   364,    -1,
     366,   367,   368,   369,   370,   371,   372,    -1,   374,   375,
      -1,    -1,   378,   379,    -1,   381,    -1,    -1,   384,   385,
     386,   387,   388,   389,   390,    -1,    -1,   393,   394,   395,
     396,   397,    -1,    -1,   400,   401,   402,   403,   404,    -1,
     406,    -1,   408,   409,   410,   411,   412,   413,    -1,    -1,
     416,    -1,    -1,   419,   420,   421,   422,   423,   424,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   434,   435,
     436,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,    43,
      44,    45,    -1,    47,    48,    49,    50,    -1,    52,    53,
      54,    55,    56,    -1,    -1,    59,    60,    61,    62,    63,
      -1,    65,    66,    67,    68,    -1,    -1,    71,    -1,    73,
      74,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    -1,    89,    90,    91,    92,    -1,
      -1,    -1,    96,    -1,    -1,    -1,   100,   101,   102,   103,
     104,   105,   106,   107,   108,    -1,   110,    -1,   112,   113,
     114,   115,   116,   117,    -1,   119,   120,   121,    -1,    -1,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,    -1,
     134,   135,   136,    -1,   138,   139,   140,   141,    -1,   143,
     144,   145,    -1,    -1,   148,    -1,   150,   151,   152,   153,
      -1,   155,    -1,   157,   158,    -1,   160,   161,   162,   163,
      -1,   165,    -1,    -1,    -1,   169,    -1,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,   183,
     184,   185,   186,   187,    -1,   189,   190,    -1,   192,   193,
     194,   195,   196,   197,    -1,   199,    -1,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,    -1,    -1,   213,
      -1,   215,   216,   217,    -1,   219,   220,   221,    -1,    -1,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,    -1,   247,   248,   249,   250,    -1,    -1,   253,
     254,   255,   256,   257,    -1,   259,    -1,    -1,   262,   263,
     264,    -1,    -1,   267,    -1,   269,   270,   271,    -1,   273,
     274,   275,   276,   277,   278,   279,   280,    -1,   282,   283,
      -1,   285,    -1,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,   319,   320,   321,   322,    -1,
     324,   325,   326,   327,   328,   329,   330,   331,    -1,   333,
     334,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,    -1,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,    -1,    -1,   363,
     364,    -1,   366,   367,   368,   369,   370,   371,   372,    -1,
     374,   375,    -1,    -1,   378,   379,    -1,   381,    -1,    -1,
     384,   385,   386,   387,   388,   389,   390,    -1,    -1,   393,
     394,   395,   396,   397,    -1,    -1,   400,   401,   402,   403,
     404,    -1,   406,    -1,   408,   409,   410,   411,   412,   413,
      -1,    -1,   416,    -1,    -1,   419,   420,   421,   422,   423,
     424,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     434,   435,   436,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    43,    44,    45,    -1,    47,    48,    49,    50,    -1,
      52,    53,    54,    55,    56,    -1,    -1,    59,    60,    61,
      62,    63,    -1,    65,    66,    67,    68,    -1,    -1,    71,
      -1,    73,    74,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    -1,    89,    90,    91,
      92,    -1,    -1,    -1,    96,    -1,    -1,    -1,   100,   101,
     102,   103,   104,   105,   106,   107,   108,    -1,   110,    -1,
     112,   113,   114,   115,   116,   117,    -1,   119,   120,   121,
      -1,    -1,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,    -1,   134,   135,   136,    -1,   138,   139,   140,   141,
      -1,   143,   144,   145,    -1,    -1,   148,    -1,   150,   151,
     152,   153,    -1,   155,    -1,   157,   158,    -1,   160,   161,
     162,   163,    -1,   165,    -1,    -1,    -1,   169,    -1,   171,
     172,   173,   174,   175,   176,   177,   178,   179,   180,    -1,
     182,   183,   184,   185,   186,   187,    -1,   189,   190,    -1,
     192,   193,   194,   195,   196,   197,    -1,   199,    -1,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,    -1,
      -1,   213,    -1,   215,   216,   217,    -1,   219,   220,   221,
      -1,    -1,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,    -1,    -1,   247,   248,   249,   250,    -1,
      -1,   253,   254,   255,   256,   257,    -1,   259,    -1,    -1,
     262,   263,   264,    -1,    -1,   267,    -1,   269,   270,   271,
      -1,   273,   274,   275,   276,   277,   278,   279,   280,    -1,
     282,   283,    -1,   285,    -1,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,   319,   320,   321,
     322,    -1,   324,   325,   326,   327,   328,   329,   330,   331,
      -1,   333,   334,   335,   336,   337,    -1,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,    -1,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,    -1,
      -1,   363,   364,    -1,   366,   367,   368,   369,   370,   371,
     372,    -1,   374,   375,    -1,    -1,   378,   379,    -1,   381,
      -1,    -1,   384,   385,   386,   387,   388,   389,   390,    -1,
      -1,   393,   394,   395,   396,   397,    -1,    -1,   400,   401,
     402,   403,   404,    -1,   406,    -1,   408,   409,   410,   411,
     412,   413,    -1,    -1,   416,    -1,    -1,   419,   420,   421,
     422,   423,   424,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   434,   435,   436,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    42,    43,    44,    45,    -1,    47,    48,    49,
      50,    -1,    52,    53,    54,    55,    56,    -1,    -1,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    68,    -1,
      -1,    71,    -1,    73,    74,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    89,
      90,    91,    92,    -1,    -1,    -1,    96,    -1,    -1,    -1,
     100,   101,   102,   103,   104,   105,   106,   107,   108,    -1,
     110,    -1,   112,   113,   114,   115,   116,   117,    -1,   119,
     120,   121,    -1,    -1,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,    -1,   134,   135,   136,    -1,   138,   139,
     140,   141,    -1,   143,   144,   145,    -1,    -1,   148,    -1,
     150,   151,   152,   153,    -1,   155,    -1,   157,   158,    -1,
     160,   161,   162,   163,    -1,   165,    -1,    -1,    -1,   169,
      -1,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,    -1,   182,   183,   184,   185,   186,   187,    -1,   189,
     190,    -1,   192,   193,   194,   195,   196,   197,    -1,   199,
      -1,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,    -1,    -1,   213,    -1,   215,   216,   217,    -1,   219,
     220,   221,    -1,    -1,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,    -1,    -1,   247,   248,   249,
     250,    -1,    -1,   253,   254,   255,   256,   257,    -1,   259,
      -1,    -1,   262,   263,   264,    -1,    -1,   267,    -1,   269,
     270,   271,    -1,   273,   274,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,    -1,   285,    -1,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,   319,
     320,   321,   322,    -1,   324,   325,   326,   327,   328,   329,
     330,   331,    -1,   333,   334,   335,   336,   337,    -1,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,    -1,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,    -1,    -1,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,   372,    -1,   374,   375,    -1,    -1,   378,   379,
      -1,   381,    -1,    -1,   384,   385,   386,   387,   388,   389,
     390,    -1,    -1,   393,   394,   395,   396,   397,    -1,    -1,
     400,   401,   402,   403,   404,    -1,   406,    -1,   408,   409,
     410,   411,   412,   413,    -1,    -1,   416,    -1,    -1,   419,
     420,   421,   422,   423,   424,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   434,   435,   436,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    45,    -1,    47,
      48,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    -1,    -1,    71,    -1,    73,    74,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    89,    90,    91,    92,    -1,    -1,    -1,    96,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,    -1,   143,   144,   145,    -1,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
     158,    -1,   160,   161,   162,   163,    -1,   165,    -1,    -1,
      -1,   169,    -1,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,   190,    -1,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,    -1,    -1,   213,    -1,   215,   216,   217,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,    -1,    -1,   247,
     248,   249,   250,    -1,    -1,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
      -1,   269,   270,   271,    -1,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,   282,   283,    -1,   285,    -1,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,   317,
     318,   319,   320,   321,   322,    -1,   324,   325,   326,   327,
     328,   329,   330,   331,    -1,   333,   334,   335,   336,   337,
      -1,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,    -1,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,    -1,    -1,   363,   364,    -1,   366,   367,
     368,   369,   370,   371,   372,    -1,   374,   375,    -1,    -1,
     378,   379,    -1,   381,    -1,    -1,   384,   385,   386,   387,
     388,   389,   390,    -1,    -1,   393,   394,   395,   396,   397,
      -1,    -1,   400,   401,   402,   403,   404,    -1,   406,    -1,
     408,   409,   410,   411,   412,   413,    -1,    -1,   416,    -1,
      -1,   419,   420,   421,   422,   423,   424,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   434,   435,   436,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    42,    43,    44,    45,
      -1,    47,    48,    49,    50,    -1,    52,    53,    54,    55,
      56,    -1,    -1,    59,    60,    61,    62,    63,    -1,    65,
      66,    67,    68,    -1,    -1,    71,    -1,    73,    74,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    -1,    89,    90,    91,    92,    -1,    -1,    -1,
      96,    -1,    -1,    -1,   100,   101,   102,   103,   104,   105,
     106,   107,   108,    -1,   110,    -1,   112,   113,   114,   115,
     116,   117,    -1,   119,   120,   121,    -1,    -1,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,    -1,   134,   135,
     136,    -1,   138,   139,   140,   141,    -1,   143,   144,   145,
      -1,    -1,   148,    -1,   150,   151,   152,   153,    -1,   155,
      -1,   157,   158,    -1,   160,   161,   162,   163,    -1,   165,
      -1,    -1,    -1,   169,    -1,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,    -1,   182,   183,   184,   185,
     186,   187,    -1,   189,   190,    -1,   192,   193,   194,   195,
     196,   197,    -1,   199,    -1,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,    -1,    -1,   213,    -1,   215,
     216,   217,    -1,   219,   220,   221,    -1,    -1,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,    -1,
      -1,   247,   248,   249,   250,    -1,    -1,   253,   254,   255,
     256,   257,    -1,   259,    -1,    -1,   262,   263,   264,    -1,
      -1,   267,    -1,   269,   270,   271,    -1,   273,   274,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,    -1,   285,
      -1,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,   319,   320,   321,   322,    -1,   324,   325,
     326,   327,   328,   329,   330,   331,    -1,   333,   334,   335,
     336,   337,    -1,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,    -1,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,    -1,    -1,   363,   364,    -1,
     366,   367,   368,   369,   370,   371,   372,    -1,   374,   375,
      -1,    -1,   378,   379,    -1,   381,    -1,    -1,   384,   385,
     386,   387,   388,   389,   390,    -1,    -1,   393,   394,   395,
     396,   397,    -1,    -1,   400,   401,   402,   403,   404,    -1,
     406,    -1,   408,   409,   410,   411,   412,   413,    -1,    -1,
     416,    -1,    -1,   419,   420,   421,   422,   423,   424,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   434,   435,
     436,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,    43,
      44,    45,    -1,    47,    48,    49,    50,    -1,    52,    53,
      54,    55,    56,    -1,    -1,    59,    60,    61,    62,    63,
      -1,    65,    66,    67,    68,    -1,    -1,    71,    -1,    73,
      74,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    -1,    89,    90,    91,    92,    -1,
      -1,    -1,    96,    -1,    -1,    -1,   100,   101,   102,   103,
     104,   105,   106,   107,   108,    -1,   110,    -1,   112,   113,
     114,   115,   116,   117,    -1,   119,   120,   121,    -1,    -1,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,    -1,
     134,   135,   136,    -1,   138,   139,   140,   141,    -1,   143,
     144,   145,    -1,    -1,   148,    -1,   150,   151,   152,   153,
      -1,   155,    -1,   157,   158,    -1,   160,   161,   162,   163,
      -1,   165,    -1,    -1,    -1,   169,    -1,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,   183,
     184,   185,   186,   187,    -1,   189,   190,    -1,   192,   193,
     194,   195,   196,   197,    -1,   199,    -1,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,    -1,    -1,   213,
      -1,   215,   216,   217,    -1,   219,   220,   221,    -1,    -1,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,    -1,    -1,   247,   248,   249,   250,    -1,    -1,   253,
     254,   255,   256,   257,    -1,   259,    -1,    -1,   262,   263,
     264,    -1,    -1,   267,    -1,   269,   270,   271,    -1,   273,
     274,   275,   276,   277,   278,   279,   280,    -1,   282,   283,
      -1,   285,    -1,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,   319,   320,   321,   322,    -1,
     324,   325,   326,   327,   328,   329,   330,   331,    -1,   333,
     334,   335,   336,   337,    -1,   339,   340,    -1,   342,   343,
     344,   345,   346,   347,   348,    -1,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,    -1,    -1,   363,
     364,    -1,   366,   367,   368,   369,   370,   371,   372,    -1,
     374,   375,    -1,    -1,   378,   379,    -1,   381,    -1,    -1,
     384,   385,   386,   387,   388,   389,   390,    -1,    -1,   393,
     394,   395,   396,   397,    -1,    -1,   400,   401,   402,   403,
     404,    -1,   406,    -1,   408,   409,   410,   411,   412,   413,
      -1,    -1,   416,    -1,    -1,   419,   420,   421,   422,   423,
     424,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     434,   435,   436,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    43,    44,    45,    -1,    -1,    48,    -1,    -1,    -1,
      52,    53,    54,    55,    56,    -1,    -1,    59,    60,    -1,
      -1,    63,    -1,    65,    66,    67,    68,    -1,    -1,    71,
      -1,    73,    74,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    -1,    89,    90,    91,
      92,    -1,    -1,    -1,    96,    -1,    -1,    -1,   100,   101,
     102,   103,   104,   105,    -1,    -1,   108,    -1,   110,    -1,
     112,   113,   114,   115,   116,   117,    -1,   119,   120,   121,
      -1,    -1,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,    -1,   134,   135,   136,    -1,   138,   139,   140,   141,
      -1,   143,   144,   145,    -1,    -1,   148,    -1,   150,   151,
      -1,   153,    -1,   155,    -1,   157,   158,    -1,   160,   161,
     162,   163,    -1,   165,    -1,    -1,    -1,   169,    -1,   171,
     172,   173,   174,   175,   176,   177,   178,   179,   180,    -1,
     182,   183,   184,   185,   186,   187,    -1,   189,   190,    -1,
     192,   193,   194,   195,    -1,    -1,    -1,    -1,    -1,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,    -1,
      -1,   213,    -1,   215,   216,   217,    -1,   219,   220,   221,
      -1,    -1,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,    -1,   241,
      -1,   243,   244,    -1,    -1,   247,   248,   249,   250,    -1,
      -1,   253,    -1,   255,   256,   257,    -1,   259,    -1,    -1,
     262,   263,   264,    -1,    -1,   267,    -1,   269,   270,   271,
      -1,   273,   274,   275,   276,   277,   278,   279,   280,    -1,
     282,   283,    -1,   285,    -1,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,    -1,   300,   301,
     302,   303,    -1,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,   319,   320,   321,
     322,    -1,   324,   325,   326,   327,   328,   329,   330,   331,
      -1,   333,   334,   335,   336,   337,    -1,   339,   340,    -1,
     342,   343,   344,   345,   346,    -1,   348,    -1,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,    -1,
      -1,   363,   364,    -1,   366,   367,   368,   369,   370,   371,
     372,    -1,    -1,    -1,    -1,    -1,   378,   379,    -1,   381,
      -1,    -1,   384,   385,   386,   387,   388,   389,   390,    -1,
      -1,   393,   394,   395,   396,   397,    -1,    -1,   400,   401,
     402,   403,   404,    -1,    -1,    -1,   408,   409,   410,   411,
     412,   413,    -1,    -1,   416,    -1,    -1,   419,   420,   421,
     422,   423,   424,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   434,   435,   436
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,    18,    28,    30,    31,    45,    65,    67,    68,    73,
      75,    86,    88,   105,   108,   121,   123,   127,   133,   141,
     143,   149,   164,   180,   219,   220,   225,   237,   248,   288,
     300,   305,   306,   308,   313,   318,   321,   326,   331,   332,
     339,   343,   353,   365,   384,   394,   400,   405,   418,   439,
     453,   460,   461,   462,   463,   469,   470,   472,   473,   474,
     475,   476,   477,   478,   480,   481,   485,   497,   502,   503,
     506,   507,   508,   520,   523,   524,   540,   577,   580,   583,
     584,   585,   592,   598,   600,   602,   603,   606,   609,   610,
     614,   615,   624,   628,   629,   630,   631,   632,   635,   637,
     638,   639,   640,   641,   648,   649,   662,   663,   667,   669,
     670,   671,   681,   683,   690,   691,   694,   695,   696,   697,
     698,   704,   706,   709,   713,   717,   718,   728,   729,   732,
     737,   748,   771,   774,   775,   776,   779,   782,   784,   786,
     788,   789,   794,   795,   798,   799,   800,   803,   804,   811,
     812,   814,   815,   816,   821,   823,   824,   830,   831,   832,
     833,   834,   835,   837,   838,   840,   841,   843,   846,   847,
     852,   858,   861,   863,   864,   872,   874,   879,   886,   890,
     891,   892,   893,   894,   895,   898,   933,   378,   421,   817,
      25,    71,    85,   103,   109,   125,   136,   144,   156,   161,
     167,   184,   209,   230,   262,   283,   293,   320,   325,   327,
     333,   336,   364,   365,   368,   372,   381,   386,   398,   411,
     599,   817,     3,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    37,    38,    40,    41,    43,
      44,    45,    46,    47,    49,    50,    52,    53,    54,    55,
      56,    59,    60,    61,    62,    63,    65,    66,    67,    68,
      69,    73,    74,    75,    76,    78,    79,    80,    82,    83,
      84,    85,    86,    87,    90,    91,    92,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   110,   112,   113,   114,
     115,   116,   117,   119,   120,   121,   124,   125,   126,   127,
     128,   130,   131,   132,   134,   135,   136,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   148,   150,   151,   152,
     153,   155,   157,   161,   162,   163,   165,   166,   168,   169,
     171,   172,   173,   174,   175,   177,   178,   179,   180,   182,
     183,   184,   185,   186,   187,   189,   191,   192,   193,   194,
     195,   196,   197,   199,   201,   204,   206,   207,   208,   209,
     210,   213,   214,   216,   219,   220,   221,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   242,   243,   244,   245,   247,   248,
     250,   252,   253,   254,   255,   256,   257,   259,   262,   263,
     264,   267,   268,   270,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   282,   283,   284,   285,   286,   287,   288,
     289,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   317,   318,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   333,
     334,   335,   336,   337,   339,   340,   341,   342,   343,   345,
     346,   347,   348,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   363,   364,   366,   368,   369,
     370,   371,   372,   374,   375,   378,   379,   380,   381,   382,
     384,   385,   386,   387,   388,   389,   390,   393,   394,   395,
     396,   397,   400,   401,   402,   403,   404,   405,   406,   408,
     410,   411,   412,   413,   416,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   887,  1055,  1069,  1073,  1074,   409,   848,
     260,   289,   817,    48,   453,   531,    20,    25,    37,    58,
      71,    81,   103,   109,   125,   136,   144,   156,   163,   167,
     221,   262,   265,   283,   320,   327,   336,   368,   369,   371,
     372,   381,   386,   392,   395,   398,   541,   582,   686,   738,
     749,    26,   288,  1055,   887,    26,   282,   334,   369,   371,
       5,   208,   780,   781,  1064,    20,    25,    37,    58,    71,
      85,   103,   125,   136,   144,   156,   161,   167,   184,   230,
     262,   273,   283,   320,   325,   327,   333,   336,   365,   368,
     372,   379,   381,   386,   398,   411,   599,   699,   817,  1055,
      88,   409,   453,   577,   580,   583,   847,   853,   861,   864,
     872,   879,   886,   890,     9,    19,    26,    43,   151,   157,
     159,   181,   210,   243,   291,   307,   444,   445,   714,   715,
     887,  1063,  1065,    26,    88,   304,   332,   719,   720,   721,
    1069,   156,  1069,  1060,  1064,   365,   901,   714,  1069,   378,
    1055,   273,   230,   103,   184,   327,   364,   365,   453,   790,
     791,   326,  1069,    26,   337,   374,   378,   489,   498,   499,
    1069,    23,   164,   719,   720,   289,   817,  1069,   207,    26,
     122,   903,   904,    59,    82,   221,   239,   320,   327,   337,
     374,   378,   424,   486,   487,   488,   489,    26,   337,   374,
     378,   489,   378,   261,   944,  1053,  1069,   901,   446,  1069,
     160,   453,   849,   453,  1048,   302,   896,   897,  1055,   896,
     891,   892,   895,     0,   456,   848,   137,   198,   266,   391,
     905,   906,   891,   893,   894,   114,   194,   397,   457,     3,
      42,    48,    71,    77,    89,    96,   158,   160,   176,   190,
     202,   203,   205,   215,   217,   241,   249,   269,   271,   319,
     344,   367,   409,  1061,  1069,  1070,  1073,  1075,   701,  1069,
     701,  1056,  1069,   292,   701,   381,   701,  1055,  1069,   102,
     365,   727,  1061,     3,    99,   338,  1066,  1067,  1071,  1073,
    1074,  1075,    26,   175,  1053,   255,   411,     8,    15,    16,
      17,    66,   148,   440,   441,   442,   444,   445,   446,   447,
     448,   449,   778,  1014,  1015,  1069,   175,  1055,    26,  1066,
    1067,  1055,  1055,   175,  1053,  1055,   313,   339,    26,   175,
     944,  1055,   329,  1055,   701,   228,  1066,  1067,   175,  1053,
     208,   111,   204,   246,   298,   818,   819,   820,  1053,  1059,
    1069,    20,    25,    58,    71,    72,    81,    85,   103,   125,
     136,   144,   156,   161,   184,   209,   230,   262,   283,   320,
     325,   327,   333,   336,   365,   368,   372,   379,   381,   386,
     411,   599,   707,  1064,   860,   864,   872,   879,   890,  1053,
     232,  1061,  1055,   453,   701,   381,  1056,   701,   381,   175,
    1055,   102,   365,   369,   371,  1066,  1067,   369,   371,    66,
     148,   778,   311,  1055,  1066,   175,   482,  1069,  1055,  1055,
     329,  1055,   701,   228,  1066,   302,   333,   365,   411,   230,
      85,   184,   161,   325,   379,   385,   593,    26,  1055,   888,
     496,  1064,  1071,   781,   232,   175,  1061,  1055,   175,   785,
     175,  1056,     3,    47,    49,    50,    61,    62,   106,   107,
     126,   152,   175,   196,   197,   199,   240,   242,   254,   299,
     341,   347,   374,   375,   406,   703,   959,   961,   963,   965,
     967,   969,   970,   971,   973,   974,   975,   978,   979,  1070,
    1073,   381,   102,   365,   175,  1061,   175,  1067,  1068,    77,
     411,    66,   148,   175,   778,    52,   175,  1055,   175,  1068,
     175,  1055,   175,  1055,   175,  1055,   329,   785,   175,  1055,
     175,   703,   175,   228,  1068,   208,   175,   700,   701,   453,
     862,   541,   853,   405,   847,   854,   855,   856,  1071,   848,
    1065,   715,   716,    26,   716,  1065,   716,    26,   716,  1065,
     716,   716,   716,  1065,  1063,  1063,   887,   716,   292,   453,
     453,   560,   560,   560,   260,   376,   457,   560,   327,   944,
     945,   457,   813,  1064,   453,   859,    52,   411,   409,   792,
     793,  1053,  1055,  1069,    42,   436,   204,   455,   263,   263,
     260,   159,  1064,   376,   154,   710,   260,     4,     6,     7,
       8,    10,    34,    47,    49,    50,    57,    58,    61,    62,
      69,    71,    93,    94,    95,    96,    97,    98,    99,   106,
     107,   142,   146,   147,   152,   166,   168,   196,   197,   199,
     214,   222,   223,   240,   242,   246,   251,   252,   254,   262,
     272,   284,   299,   323,   338,   347,   361,   374,   375,   380,
     382,   383,   392,   398,   406,   426,   427,   428,   429,   430,
     431,   432,   433,   437,   444,   445,   446,   453,   891,   962,
     965,   968,   969,   970,   972,   973,   974,   978,   979,   983,
     985,   986,   987,   989,  1010,  1011,  1012,  1016,  1035,  1040,
    1050,  1051,  1061,  1062,  1063,  1064,  1069,  1049,  1050,  1064,
      26,   504,  1052,  1053,   337,   486,   109,   495,  1064,   496,
    1064,    42,    63,   486,   436,   348,   819,   263,   159,   376,
     442,    42,   436,   204,   820,   453,  1053,   446,   451,   455,
    1041,  1043,   945,     3,   158,   160,   409,   844,   845,   847,
     158,   850,   109,   983,  1046,  1047,   896,   457,   453,   851,
     454,   454,   462,  1053,    26,   122,   902,   902,    52,   902,
     149,   154,   218,   258,   909,   911,   912,   927,   929,   930,
     931,   905,   906,   159,   200,   944,   946,  1048,   453,   761,
    1043,   274,   309,   339,   455,   702,   274,   309,   339,     3,
      80,   131,   224,   274,   309,   339,   368,   370,   418,   497,
     500,   825,   826,   827,   828,   733,    22,   127,   274,   309,
     339,   402,   511,  1055,   339,    22,   127,   397,   479,   422,
     175,   944,    54,    87,   117,   145,   178,   213,   246,   274,
     275,   309,   317,   324,   331,   339,   351,   359,   413,   497,
     501,   764,   772,   453,   750,   309,   479,   181,   142,    22,
      28,    68,   117,   120,   127,   130,   155,   186,   244,   246,
     256,   264,   274,   309,   312,   313,   339,   402,   509,   510,
     618,     4,   445,   590,  1065,    26,   175,  1053,   701,   701,
     453,   777,   455,   142,   260,   181,   471,   309,   418,   439,
     464,   471,   260,   274,   309,   142,    53,   101,   183,   231,
     234,   244,   273,   309,   314,   339,   353,   509,   587,   588,
     274,   309,   410,   618,   626,   499,   487,   489,   181,   142,
     309,   339,   509,   274,   309,   313,   339,    78,   119,   276,
     370,   260,    22,    28,   127,   274,   309,   339,   521,   522,
     154,   309,   339,   464,   500,   142,   309,   339,   509,  1055,
     216,   111,   261,   423,   457,   818,   399,   842,   260,   232,
    1061,   453,  1055,   959,   381,   102,   365,  1061,   255,   411,
      66,   148,   778,  1055,  1055,   329,   154,  1055,   959,   208,
     701,   454,   560,  1055,   453,   676,   761,    64,   959,   159,
     453,   672,  1055,   464,    35,   836,  1055,   246,   464,   422,
     175,  1053,   464,   701,   701,   672,   395,   541,   260,   464,
     246,    42,   483,   386,   625,   274,   601,    78,   119,   276,
     370,    24,    44,   195,   650,    35,   672,   154,   464,   411,
     175,  1053,   175,   578,  1053,  1053,   411,   701,    77,   739,
    1061,  1055,   154,   599,    48,   100,   193,   244,   328,   142,
     761,    55,   315,   512,   142,   453,   142,   408,   976,   976,
     976,   453,   964,   964,   286,   453,   966,   142,    61,    62,
     976,   964,   961,   420,   439,   453,   980,   453,   980,   457,
     512,    34,   960,    62,   453,   977,   104,   173,   233,   236,
     330,   434,   453,   981,   982,   702,   964,   422,   142,   750,
     142,   457,   175,   700,   175,   701,   175,   701,   142,   777,
    1068,   142,   260,   142,   142,   260,   142,   512,   142,    78,
     119,   276,   370,   154,   142,   260,   142,   512,   142,   154,
     175,   175,   496,   142,   457,   512,   983,  1019,   365,   454,
     457,   147,   260,   383,   493,   496,   590,   857,   853,   716,
     887,   716,   887,   716,   887,   716,   887,   716,   887,   887,
     887,   716,   887,   453,   561,   562,  1069,   561,    26,   103,
     125,   156,   161,   208,   209,   327,   333,   365,   368,   386,
     722,  1052,  1068,   721,  1055,   181,   457,   875,  1064,   959,
    1022,    35,  1068,   739,   454,   457,   216,  1069,   154,   154,
     722,  1068,   326,  1069,   496,   260,   453,  1044,   451,   891,
    1023,   983,  1039,   453,   453,   154,   453,   453,   891,   453,
     453,   453,   453,   453,   453,   983,   453,   453,   453,   453,
     453,   453,   453,   453,   891,   453,   453,   453,   453,   453,
     453,   453,   453,   983,   983,   983,   891,   983,  1019,  1043,
    1064,   453,  1064,     3,     8,    11,    15,    16,    17,    32,
      35,    40,    46,    70,   176,   181,   202,   203,   217,   249,
     262,   265,   344,   437,   440,   441,   442,   444,   445,   446,
     447,   448,   449,  1014,  1016,  1018,   419,   998,   271,   983,
     200,   457,   899,   453,  1064,  1043,   899,   112,   177,   505,
     457,    63,   109,   496,    35,     3,   109,   221,   494,   590,
     979,  1064,  1064,    83,   124,   995,    92,   109,   490,   491,
     493,   590,   109,   490,   216,  1053,   983,  1042,     3,    26,
      30,    31,    32,    33,    34,    35,    36,    39,    51,    57,
      58,    64,    70,    72,    81,    88,    93,    94,    95,    97,
      98,    99,   109,   111,   118,   122,   123,   129,   133,   137,
     147,   149,   154,   156,   159,   164,   167,   170,   181,   188,
     198,   200,   211,   212,   218,   222,   223,   246,   251,   258,
     260,   261,   265,   266,   281,   290,   304,   316,   332,   338,
     349,   362,   365,   373,   376,   377,   383,   391,   392,   398,
     399,   407,   414,   415,   417,   418,   446,  1058,  1072,  1073,
    1074,  1075,  1076,  1041,    84,   314,   705,   454,   457,   848,
     454,   457,   897,  1054,  1055,    35,   851,   893,   893,   907,
     908,   983,   893,   151,   243,   918,   206,   244,   298,   342,
     397,    26,   913,   983,   914,   916,   983,   985,   927,   928,
     912,   911,   909,   910,   154,   930,   256,   932,   909,   927,
     946,   865,  1053,    35,  1069,   339,   181,   191,   266,   268,
     341,   407,   446,   754,   755,   756,   758,   760,   762,   959,
    1070,   274,   309,   339,   376,   376,   327,  1058,   455,   376,
     376,   327,   218,   376,   376,   368,   486,   274,   825,   827,
     442,   829,   154,   164,   181,   318,   734,   735,    64,    81,
     138,   156,   290,   392,   557,   558,    81,   109,   246,   376,
      81,   376,   109,   246,   327,    81,   120,   130,   274,   309,
     668,   327,   607,    20,    25,    58,    71,    85,   125,   136,
     156,   161,   230,   262,   327,   333,   336,   365,   372,   379,
     386,   411,   599,  1055,   142,   309,   339,   509,   260,   590,
     260,   331,   213,   376,  1069,   376,   251,   590,   113,   201,
     327,   337,   378,   488,   315,   339,   764,   773,   454,   751,
     754,   376,   398,   368,  1053,    72,   138,   175,   548,   557,
    1069,    72,    81,   796,   260,   260,   323,   325,   381,    81,
     796,    29,   312,   323,   325,   381,   323,  1053,   155,   186,
     256,   701,   453,   376,   376,   174,   453,   516,   227,   368,
     395,   418,   420,   516,    81,   457,     4,   274,   181,   142,
     117,   309,   339,   509,   399,   399,   245,   959,   274,   339,
     778,  1055,  1053,   103,   500,   376,   466,   500,  1053,   376,
     376,  1053,   590,    52,   589,   590,   590,   101,   231,   234,
      52,   376,   464,   327,   464,   244,   588,   376,   376,   251,
    1064,   618,   368,   944,    81,   376,   796,   327,   376,   376,
     516,   516,   701,   701,   701,   701,  1053,    41,   404,    41,
      41,   376,    41,   376,   327,   457,   398,   636,  1067,   376,
     466,  1053,   376,   327,   274,   309,   298,   310,   335,   492,
     818,  1059,  1069,  1053,   761,   959,   260,   202,   422,   750,
     590,   701,   701,   777,   260,   202,   260,    78,   119,   276,
     370,   959,   260,   202,   701,   202,   376,   418,   532,   386,
       3,   677,   678,   672,   453,    35,   701,   673,   674,  1072,
      24,   825,   959,   260,   142,   604,  1055,   246,   453,   465,
     686,   399,   302,   411,  1053,   465,   142,  1067,    88,   164,
     484,   540,   584,   649,   717,   737,   821,  1064,   626,   627,
    1067,   224,   701,   701,   701,   701,   256,   114,   194,   384,
     397,   651,   652,   134,   297,   453,   636,   465,  1053,   246,
     586,   587,   246,    35,   256,   453,   560,   560,   175,   581,
    1053,   154,   175,   740,  1059,   453,   752,    35,   959,   208,
     418,   420,   889,   328,  1061,   512,   959,  1056,   453,  1019,
    1063,   703,   976,   976,    34,   960,   374,   374,  1063,  1063,
     959,   451,   451,   339,  1063,   376,   376,   376,   453,   376,
    1063,   964,   175,  1055,  1061,   512,  1068,  1067,   142,   512,
     142,   399,   142,   399,   778,   512,   512,  1055,   701,  1068,
    1055,   701,  1055,  1055,   959,  1055,   701,   703,  1068,   636,
     142,   142,   512,   700,   701,   454,   457,   175,  1053,   853,
     855,   887,   887,   887,   887,   887,   887,   561,   454,   457,
     454,   162,   334,   366,  1054,   700,   102,   336,   726,   727,
    1054,   255,  1054,  1052,  1052,  1054,   700,   376,   418,   730,
     137,   218,   633,   634,    20,   140,   323,   342,   876,   944,
     250,   877,   454,   457,   860,   376,  1053,   790,   791,   793,
     720,   719,   720,   159,   165,   731,  1069,    25,    72,   103,
     125,   136,   156,   161,   209,   230,   320,   327,   333,   365,
     368,   386,   411,   599,   711,  1019,  1041,   452,  1019,  1023,
    1024,   414,  1036,  1037,   983,  1019,   453,  1063,  1063,     3,
     104,   173,   233,   236,   330,   434,  1025,  1026,  1064,  1019,
    1019,  1019,  1063,  1063,   983,   778,   983,  1027,   323,   444,
     445,   453,   984,   985,  1016,  1029,   454,  1019,   983,  1019,
    1030,   983,    51,   159,   212,   377,   983,  1019,  1033,  1019,
     238,   985,   983,   993,   994,   995,   238,   983,   995,   454,
     457,  1063,   981,   959,   983,   983,   983,   983,  1072,   374,
      39,   362,  1045,   701,   983,   453,   891,  1034,   122,   124,
     147,   246,   251,   256,   383,   393,   983,   453,   983,   376,
      46,   176,   181,   217,   344,   983,   983,   983,   983,   983,
     983,   983,   983,   983,   983,    26,    33,   349,  1013,   167,
     150,   999,   323,   453,  1010,   163,   221,   365,   369,   371,
     395,   900,  1053,  1051,   159,   934,    26,   122,   407,   446,
     454,   756,   983,  1020,  1021,  1070,   934,  1053,   378,   453,
    1064,   457,   454,   452,   458,   174,   174,   512,  1053,   845,
     846,  1053,  1046,   454,   457,   453,   457,    36,   118,   399,
     746,   453,   915,  1065,   342,   206,   261,   457,   323,   324,
     917,  1052,   250,   346,   878,   928,   910,   399,   873,   109,
     453,   866,   890,    35,  1069,   453,   880,   881,   882,   883,
     884,  1069,   268,    52,  1070,   454,   756,   758,   755,   758,
    1070,   266,   454,   457,   702,   376,   376,   327,  1067,  1055,
    1055,  1058,  1067,  1055,  1055,  1067,  1056,  1055,   109,   493,
    1065,   320,   398,   719,   327,   164,   719,   453,  1055,   399,
     741,   206,   206,   399,   453,   576,   175,  1055,   251,  1067,
    1055,  1055,   983,   251,  1055,  1055,    29,   312,   376,   376,
    1055,   376,   608,   232,  1061,   453,   701,   701,   959,   381,
     102,   365,   727,   411,    66,   148,   778,  1055,   701,  1055,
     701,   329,   154,   959,   701,   208,   169,   244,   274,   309,
     403,   611,   612,   613,   944,   376,   796,   327,   251,   144,
     113,   201,  1067,  1055,   260,  1055,   454,   457,  1066,  1068,
    1055,   309,   509,   175,   548,   246,   959,  1055,  1069,  1055,
     144,   216,  1055,    26,   398,  1055,   175,  1055,   175,  1069,
     325,   381,   325,   381,   216,  1055,    26,   398,  1055,   216,
     323,  1053,    22,   127,   339,   619,   620,   621,   622,  1072,
    1067,  1055,   109,   160,   247,   399,   515,   518,   519,  1072,
    1055,   259,    68,   259,  1055,   510,   376,   368,  1053,   260,
     376,   796,   327,  1057,  1069,  1057,   457,   454,   457,   376,
     327,   453,   260,   309,   376,   645,  1056,  1066,     3,    80,
     132,   186,   280,   390,   398,   401,   467,   309,  1067,  1055,
     309,   339,   509,   587,   590,   701,  1055,   590,  1055,   590,
    1067,  1055,  1055,   309,   339,   509,  1055,  1055,  1055,  1055,
    1067,  1055,    22,    28,   127,   274,   309,   339,   274,   309,
     339,   672,   309,   339,   309,   339,   117,   309,   958,  1069,
     175,   682,  1069,   175,  1069,  1067,  1055,  1055,  1055,    22,
     522,   336,  1066,   309,   339,   509,  1055,  1055,   376,   376,
      76,   389,   298,   202,    35,   125,   701,   251,   708,  1064,
     202,   202,   399,   399,   202,   701,   708,   701,   208,   701,
     708,   202,   708,   295,   526,   259,   159,   376,   525,   184,
     442,   454,   457,   983,   959,   454,   457,   442,   651,   550,
    1072,  1055,    55,   159,   327,   410,   605,   612,   613,   142,
     217,   542,   544,   546,   548,   554,   557,    23,   181,   320,
     363,   467,   468,   154,  1057,   411,  1053,   154,   646,   482,
    1069,   483,   265,   541,   156,  1064,   672,   672,   672,   672,
     256,   260,   265,   453,   672,   956,   957,   958,   336,   453,
     142,   142,   141,   890,   701,   542,  1069,   418,   420,   572,
     418,   517,   246,    35,   560,  1064,   246,   260,   454,   753,
     754,   759,    35,   208,   317,   379,   417,   763,   764,   765,
     260,   208,   496,   172,   172,   154,   761,    35,  1019,   454,
     454,   512,   451,   436,   436,   454,   454,  1063,   452,  1063,
    1069,   454,   173,   233,   982,   233,   982,   982,  1063,   236,
     454,   142,   512,   750,   700,   701,  1057,   701,  1057,   777,
     260,   512,   260,   512,   512,   208,   260,   512,   512,   336,
     154,   496,   512,   983,   246,   454,   562,   181,   181,   181,
     422,  1054,   457,   590,   591,   167,   723,   724,  1067,    23,
     731,   376,   453,   159,   140,   342,   140,   342,   323,   397,
     235,   959,  1067,   418,   579,  1053,  1055,   159,   260,   723,
      52,   512,  1061,   959,   381,   365,  1061,   255,   411,   959,
     208,   701,   454,   452,   452,   457,   983,   129,  1037,  1038,
      35,   454,   983,   454,   454,   454,   159,   454,   454,   454,
     454,   454,   457,   454,   281,  1028,   454,   453,   984,   984,
    1019,    11,    15,    16,    17,   181,   202,   262,   440,   441,
     442,   444,   445,   446,   447,   448,   449,  1016,   984,   454,
     454,   154,   159,  1031,  1032,   454,    35,  1033,  1019,  1033,
    1033,   159,   454,   454,  1072,   279,   997,    35,   454,   457,
     983,  1072,   457,   983,  1044,   983,   454,   436,   984,   984,
     135,  1019,   159,   122,   124,   147,   251,   256,   383,   393,
     453,   135,   778,   983,   362,  1045,   983,  1034,   983,   376,
     453,   891,   453,   453,   270,  1003,   453,  1019,   369,   371,
     369,   371,  1053,   901,   901,   901,   211,   324,   453,   891,
     935,   936,   937,   944,   949,   986,   988,   989,  1061,  1069,
     415,   954,  1020,  1020,  1021,   454,    13,    14,   457,   905,
     906,   954,   819,  1063,   981,   491,   983,  1042,   851,  1055,
     860,   908,   262,  1014,  1017,   438,   747,   983,   917,   397,
     914,   226,   935,   415,   955,   405,   867,   868,  1069,   260,
     869,  1069,   884,   885,   457,   934,   442,  1044,   762,   702,
     758,   758,    52,   760,   448,  1067,  1055,  1055,  1068,  1068,
     260,  1054,   263,   260,   983,   558,  1057,   453,   453,   453,
     576,   184,   561,   660,   142,   512,   376,  1067,  1055,   496,
    1055,   761,   959,  1055,   422,   701,   701,   701,   701,   777,
      78,   119,   276,   370,   959,  1055,   594,  1055,   169,   403,
     376,   376,   594,   611,   618,   309,   339,   509,  1055,  1055,
    1055,   192,  1055,   251,   754,   273,   339,   376,   246,   142,
     264,   616,   660,   127,   313,   339,   511,   618,   797,  1055,
     331,   142,   512,   142,   512,  1055,  1055,  1055,  1055,   331,
     331,   216,   621,   622,   621,   454,   457,   623,  1064,   184,
     454,   457,   442,   455,  1067,  1055,   309,   339,   509,   144,
    1055,  1055,  1055,   274,   309,   339,    22,   127,   274,   309,
     339,   959,   245,   959,  1067,  1055,   801,   802,  1072,  1053,
     376,  1068,   399,   642,   218,   280,   251,  1064,   280,  1068,
     396,   376,   376,   327,   273,   339,    81,   376,   796,   327,
     376,   376,   228,   228,   228,   376,   376,   327,   376,   376,
     327,   376,   327,   376,   327,   260,   376,   512,   959,   246,
    1064,   339,   797,   142,   512,   376,  1055,   376,   327,  1067,
    1055,   708,   959,   701,   202,   708,   708,  1057,  1057,   708,
     202,   202,  1055,   202,   708,   356,   357,   527,  1064,   526,
     169,   262,   444,   445,   590,   675,   758,  1017,  1064,  1076,
       3,   678,   454,   454,   674,   675,   260,    64,    70,    81,
     109,   111,   188,   246,   251,   290,   304,   392,   551,   552,
     553,   141,   414,   464,   496,  1055,   496,   616,  1053,  1053,
     454,   457,  1068,   167,   320,  1068,  1063,   386,  1053,   560,
      26,   114,   194,   332,   397,   647,   376,   644,    42,   483,
     311,   365,   102,   517,   561,  1053,   652,   679,   680,  1064,
     454,   457,  1055,   561,  1053,   578,  1053,  1055,   579,   453,
     543,   454,   259,   516,   259,   260,   573,   516,    35,   142,
     890,   517,   376,   142,  1053,   454,   457,   109,   442,   766,
    1064,   496,   365,   757,   758,   154,   767,   418,   765,   768,
     114,   194,   332,   397,   809,  1055,   169,   890,   512,   959,
     454,  1063,   980,   980,   452,   452,   977,   454,  1055,   512,
     512,   399,   512,   399,   512,   512,   701,   701,  1055,   701,
    1055,   636,   512,   142,   327,   327,   327,  1054,   727,   457,
    1067,   418,   457,   725,   263,   945,   336,   140,   140,   102,
     244,  1068,   722,   512,  1067,   761,   202,   750,   590,   202,
     701,   202,  1023,   373,   983,   133,   959,   454,   983,   983,
     983,  1031,   454,  1019,   457,   959,   984,   984,   984,   984,
     122,   124,   246,   256,   984,   984,   984,   984,   984,   984,
     984,   984,   984,   984,   983,   983,  1032,  1031,   959,   454,
     454,   454,  1019,   454,   457,    52,   985,   454,  1072,   994,
     287,   360,   996,   454,   457,   410,   990,    35,   454,  1064,
     983,    32,    32,   983,   454,   983,   159,   453,  1022,   983,
     454,   135,   984,   984,   135,   135,   983,   983,   906,   415,
     453,  1004,  1069,   454,  1019,   457,   901,   901,   901,   901,
    1053,  1053,  1053,   891,   949,   159,   891,   936,   937,    35,
     938,   939,  1069,   457,    89,   160,   190,   205,   215,   241,
     319,   941,   939,    35,   938,   940,  1069,   439,   953,   453,
    1043,   983,   167,   919,   457,   905,   905,   905,   983,   983,
     407,  1021,   454,   919,   454,   452,   454,   453,   747,   151,
     210,   454,   261,    92,   983,   316,   871,   454,   457,  1044,
      79,   871,   454,   457,   881,   955,  1046,   454,   448,   762,
     386,   162,   334,   366,   387,   736,   154,   736,   454,   453,
     564,   565,   743,   988,  1069,   561,   561,   660,  1059,   454,
     111,   188,   244,   246,   661,  1055,  1055,    35,  1055,   399,
     399,   701,   701,   701,   701,   208,   702,  1067,  1055,   376,
     796,   327,   376,   192,    52,   368,  1055,   142,   548,   453,
     550,   246,   516,   102,   246,   355,   358,   516,   386,  1055,
    1069,   331,   620,  1055,   519,   675,  1072,   273,   339,   376,
     796,   327,  1055,   376,   376,   376,   327,   161,   262,   358,
     684,   685,   161,   262,   692,   693,   376,   376,   327,   454,
     454,   454,   454,   457,   442,   309,  1055,   453,   418,   643,
    1065,  1064,  1064,  1064,  1055,  1055,  1055,    52,   368,  1055,
    1055,  1055,  1055,  1055,  1055,   154,   154,   311,   154,   175,
    1067,  1055,  1055,  1067,  1055,  1055,  1055,  1055,  1055,  1055,
     144,  1055,    70,   513,   142,    24,    44,   386,  1069,  1055,
     618,  1055,  1055,   454,   202,   708,   202,   202,   708,   708,
     202,   708,   464,   527,   594,   660,   418,   420,  1053,   453,
     701,  1055,   984,   112,   177,   111,   251,   206,  1053,   768,
     294,   664,   665,  1069,   604,   453,   555,   187,   571,   546,
    1068,  1068,   959,   453,   517,  1068,   642,  1067,   175,  1053,
     422,   154,   653,   454,   457,   958,   616,   454,   586,    35,
     256,   453,   862,   545,   547,   549,   557,  1069,   572,   571,
      75,   368,   574,   890,   581,   579,   574,  1064,  1059,   741,
     759,   983,   983,   457,   453,   763,   386,   457,   672,   376,
     453,   594,   454,   452,   512,  1057,  1057,   512,   512,   512,
     512,   336,  1054,  1054,  1054,   590,   164,   724,   454,  1055,
     102,   731,   159,   202,   251,   712,  1064,   202,   202,   712,
     202,   712,   983,   454,   454,  1032,   454,   983,   159,   122,
     124,   256,   453,   454,   425,   992,  1019,   303,    52,   416,
     416,   454,   983,   244,   983,   457,   991,   961,   983,   983,
     983,  1022,   454,   983,    32,    32,   983,   983,   135,   454,
     454,   983,  1005,  1069,   454,   983,  1053,  1053,  1053,  1053,
     939,   940,   453,   454,  1069,   453,   936,   205,   269,   942,
     936,   942,   205,   941,   942,   205,   367,   947,   453,  1069,
     453,   267,  1020,    52,   170,   926,   454,   454,   454,  1021,
    1064,   926,  1064,   778,   256,  1050,   890,   868,   260,   453,
     870,   442,   884,   871,   386,   454,   376,   719,   159,   660,
     983,   454,   457,   418,    70,   744,   744,   454,   454,   768,
     112,   177,   186,   111,   401,   512,   959,  1057,  1057,  1055,
    1055,  1055,  1055,  1055,  1068,  1055,   548,   617,   621,   251,
     251,  1065,  1069,   959,   512,   512,   442,    52,   368,  1055,
    1055,  1055,  1055,  1067,  1055,  1055,  1063,  1063,   959,   457,
    1063,  1063,   457,  1067,  1055,  1055,   802,   245,   675,   376,
     983,    64,  1068,  1055,   376,   376,  1054,  1054,   701,  1054,
     142,  1055,   701,  1064,  1064,   959,   512,   512,   202,   708,
     708,   708,   708,   453,   528,   529,   399,   533,   534,   161,
     191,   161,   159,   659,   983,   246,   552,   768,   560,   399,
     575,  1061,    32,   141,   181,   542,   139,   182,   453,   336,
     399,   561,    35,   643,   483,   246,   453,  1055,   128,   654,
     414,   656,  1064,   517,   890,   701,   542,   579,   454,   457,
     418,   573,   572,   114,   127,   287,  1055,   418,   822,    35,
     159,   260,   453,  1064,   756,   769,   770,  1070,   768,   959,
     154,  1053,   159,   376,   787,   189,   595,   512,   512,   512,
    1055,   263,   200,   512,   723,   712,   712,   712,   712,   454,
     984,   159,   453,  1022,   453,   454,   457,   454,   985,   303,
     454,   404,   352,   454,   454,   454,   983,   983,   983,   454,
     278,  1006,   454,   950,   951,   988,   938,   453,  1054,   936,
     260,   399,   943,   936,   205,   936,  1061,   957,   453,   957,
    1069,   905,    91,   168,   322,   453,   920,   921,   922,   923,
     924,   925,   983,   983,   417,  1000,   905,  1000,   454,   887,
      81,   742,   743,   123,   453,   891,  1048,   723,   260,   723,
     454,   768,   565,   262,   778,   701,   701,   745,   745,   304,
     768,   575,   454,   376,   339,   877,   454,   457,   513,   675,
    1068,  1055,   376,   453,  1061,   778,   685,   453,   453,   693,
    1055,   454,   453,   339,   877,  1055,  1055,   418,   439,   839,
     311,   839,   839,   154,   513,   708,   535,   536,  1072,    48,
      90,   115,   131,   135,   155,   158,   171,   251,   259,   296,
     530,   464,   116,   727,    35,   783,   783,  1053,   660,   454,
     575,   229,   563,   184,   453,   665,   294,   453,   454,    26,
      74,    82,   110,   185,   358,   556,   556,  1052,  1055,  1057,
     454,   890,   142,   616,   323,   354,   655,   453,   141,    35,
     579,   543,   454,   547,   264,   574,   573,   324,   324,    56,
      64,   221,   890,   701,  1053,   742,   758,   454,   457,   386,
     954,   350,   350,   454,   594,   244,   403,   596,   597,  1055,
     512,   984,  1022,   454,   993,  1019,    52,   244,   435,    52,
     905,   454,   457,    35,   952,  1054,   454,   983,   453,   936,
     943,   453,   454,   957,   454,   454,   453,   340,   453,   454,
     457,  1001,  1002,  1069,   454,  1055,   454,   457,   247,   397,
     725,   736,   512,   744,   575,   453,   746,   746,  1053,   575,
     660,  1055,   368,   621,   399,   514,   339,   877,  1055,  1022,
     750,   154,   688,   777,  1022,  1022,   983,   368,   700,   701,
     700,   701,  1054,   512,   454,   457,   446,   453,   493,   537,
     590,   836,  1064,   836,   246,   251,   296,   836,   836,   528,
    1064,   783,    38,   179,   154,   244,   559,   160,   277,   345,
     260,   567,   568,   569,   368,   454,  1061,     5,   666,   571,
     454,   616,   148,   687,   517,   822,  1053,   983,   294,   890,
     572,   571,   550,   574,    64,   263,    64,   579,   741,   454,
     763,   769,   959,   123,   418,   418,   403,   594,   616,   454,
     454,   454,   303,   404,  1019,   297,   324,  1007,   953,   950,
     453,   454,  1054,  1019,   454,  1019,   453,  1019,   921,   457,
      35,   954,   743,   339,   159,   745,   415,   566,   778,   747,
     747,   560,   660,  1055,   983,   368,   454,   266,   329,   301,
     689,   688,   454,   454,   454,  1055,   839,   536,   493,   538,
     539,  1064,  1064,   251,   561,   446,   561,  1064,  1064,   128,
     186,   114,   397,   260,   569,   260,   568,  1055,   453,   454,
     457,   336,   701,    35,    35,   453,   454,  1061,   822,   573,
     572,   263,   263,   453,   517,   768,    27,   195,   810,   161,
     161,    46,    92,   388,   983,  1008,  1009,  1008,   454,   957,
     454,   454,   454,   920,   454,  1002,  1004,   880,   723,   746,
     453,   660,   454,   563,   877,  1055,  1061,    52,   689,   877,
     701,   454,   457,   561,   323,    55,   244,   315,   339,   570,
     570,   454,     5,  1055,   684,   890,   453,   574,   573,   742,
     574,   247,   453,   805,   807,   812,   864,   872,   879,   890,
     727,   727,  1009,   323,   153,   285,   153,   285,   454,   310,
     948,   454,   954,   512,   747,   983,   567,   877,   750,   701,
     539,   656,    21,   109,   251,   616,   822,     4,   657,   658,
    1063,  1064,  1072,   574,   454,   954,   806,   807,   808,   891,
     892,   457,   457,    32,   453,   454,   660,   141,   454,   457,
     517,   454,   456,   376,   159,  1009,   983,   294,   658,   574,
     808,   350,   350,   454,  1061,   954,   418,   418,   453,   161,
     161,   657,   727,   727,   454
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   459,   460,   461,   461,   462,   462,   462,   462,   462,
     462,   462,   462,   462,   462,   462,   462,   462,   462,   462,
     462,   462,   462,   462,   462,   462,   462,   462,   462,   462,
     462,   462,   462,   462,   462,   462,   462,   462,   462,   462,
     462,   462,   462,   462,   462,   462,   462,   462,   462,   462,
     462,   462,   462,   462,   462,   462,   462,   462,   462,   462,
     462,   462,   462,   462,   462,   462,   462,   462,   462,   462,
     462,   462,   462,   462,   462,   462,   462,   462,   462,   462,
     462,   462,   462,   462,   462,   462,   462,   462,   462,   462,
     462,   462,   462,   462,   462,   462,   462,   462,   462,   462,
     462,   462,   462,   462,   462,   462,   462,   462,   462,   462,
     462,   462,   462,   462,   462,   462,   462,   462,   462,   462,
     462,   462,   462,   462,   462,   462,   462,   462,   462,   462,
     462,   463,   464,   464,   464,   465,   465,   466,   466,   467,
     467,   467,   467,   467,   467,   467,   467,   467,   468,   468,
     468,   468,   468,   468,   469,   470,   471,   471,   472,   472,
     473,   474,   475,   475,   476,   476,   477,   478,   479,   479,
     480,   480,   481,   481,   481,   481,   482,   482,   483,   483,
     484,   484,   484,   484,   484,   484,   485,   485,   485,   486,
     486,   486,   487,   487,   487,   487,   488,   488,   488,   488,
     488,   488,   488,   488,   488,   488,   488,   489,   489,   490,
     490,   491,   491,   492,   492,   492,   492,   493,   493,   493,
     493,   494,   494,   494,   494,   494,   494,   494,   495,   495,
     495,   496,   496,   497,   498,   498,   498,   498,   499,   499,
     500,   500,   501,   501,   502,   502,   502,   502,   502,   503,
     504,   504,   505,   505,   506,   507,   507,   507,   507,   507,
     508,   508,   508,   508,   508,   508,   508,   508,   508,   508,
     508,   508,   508,   508,   508,   508,   509,   509,   510,   510,
     510,   510,   510,   510,   510,   510,   510,   510,   510,   510,
     510,   510,   510,   510,   510,   510,   510,   510,   510,   510,
     510,   510,   510,   510,   510,   510,   510,   510,   510,   510,
     510,   510,   510,   510,   510,   510,   510,   510,   510,   510,
     510,   510,   510,   510,   510,   510,   510,   510,   510,   510,
     511,   511,   512,   512,   512,   513,   513,   514,   514,   515,
     515,   515,   515,   516,   517,   517,   518,   518,   519,   519,
     519,   519,   520,   521,   521,   522,   522,   522,   522,   523,
     523,   524,   524,   525,   525,   526,   526,   527,   527,   527,
     528,   528,   529,   529,   530,   530,   530,   530,   530,   530,
     530,   530,   530,   530,   530,   530,   530,   530,   531,   531,
     532,   532,   533,   533,   534,   534,   535,   535,   536,   537,
     537,   537,   537,   537,   538,   538,   539,   540,   540,   540,
     540,   541,   541,   541,   541,   541,   541,   541,   541,   542,
     542,   543,   543,   544,   544,   545,   545,   546,   546,   546,
     547,   547,   548,   549,   550,   550,   551,   551,   551,   551,
     552,   552,   552,   552,   552,   552,   552,   553,   553,   553,
     553,   554,   555,   555,   555,   556,   556,   556,   556,   556,
     556,   557,   557,   558,   558,   558,   558,   558,   558,   558,
     559,   559,   560,   560,   561,   561,   562,   563,   563,   563,
     563,   564,   564,   565,   565,   566,   566,   567,   567,   567,
     567,   567,   568,   569,   570,   570,   570,   570,   570,   571,
     571,   572,   572,   572,   572,   573,   573,   573,   573,   574,
     574,   575,   575,   576,   577,   577,   578,   579,   579,   579,
     580,   580,   581,   582,   582,   583,   584,   584,   585,   585,
     586,   586,   587,   587,   588,   588,   588,   588,   588,   588,
     588,   588,   588,   588,   588,   588,   589,   589,   590,   590,
     590,   591,   591,   592,   592,   593,   593,   594,   594,   595,
     595,   596,   596,   597,   597,   598,   598,   599,   599,   600,
     601,   601,   602,   602,   603,   603,   604,   604,   605,   605,
     605,   605,   606,   607,   607,   608,   609,   609,   609,   609,
     609,   609,   609,   609,   609,   609,   609,   609,   609,   609,
     609,   609,   609,   609,   609,   609,   609,   609,   609,   609,
     609,   609,   610,   611,   611,   611,   611,   612,   612,   613,
     613,   614,   614,   615,   615,   616,   616,   617,   617,   618,
     619,   619,   620,   620,   620,   620,   621,   622,   623,   624,
     625,   625,   626,   626,   627,   627,   628,   628,   629,   629,
     629,   630,   630,   631,   631,   632,   633,   633,   634,   634,
     635,   636,   636,   637,   637,   638,   639,   640,   641,   641,
     642,   642,   643,   643,   644,   644,   645,   645,   646,   646,
     647,   647,   647,   647,   647,   648,   649,   649,   650,   650,
     650,   651,   651,   652,   652,   652,   652,   652,   653,   653,
     654,   654,   655,   655,   656,   656,   657,   657,   657,   658,
     658,   658,   658,   659,   659,   660,   660,   661,   661,   661,
     661,   661,   661,   662,   662,   663,   663,   664,   664,   665,
     666,   666,   667,   668,   668,   668,   668,   669,   670,   671,
     671,   671,   671,   671,   671,   671,   671,   671,   671,   671,
     671,   671,   671,   672,   673,   673,   674,   674,   675,   675,
     675,   675,   675,   676,   677,   677,   678,   679,   679,   680,
     680,   681,   681,   681,   682,   682,   683,   684,   684,   685,
     685,   685,   685,   685,   686,   686,   687,   687,   688,   688,
     688,   689,   689,   690,   691,   691,   692,   692,   693,   693,
     694,   694,   695,   695,   696,   697,   698,   698,   698,   698,
     698,   698,   698,   698,   699,   699,   699,   699,   699,   699,
     699,   699,   699,   699,   699,   699,   699,   699,   699,   699,
     700,   700,   701,   701,   702,   702,   703,   703,   704,   705,
     705,   705,   706,   706,   706,   706,   706,   706,   706,   706,
     706,   706,   706,   706,   706,   706,   706,   706,   706,   706,
     707,   707,   707,   707,   707,   707,   707,   707,   707,   707,
     707,   707,   707,   707,   707,   707,   707,   707,   707,   707,
     707,   707,   708,   708,   709,   709,   709,   709,   709,   709,
     709,   710,   710,   711,   711,   711,   711,   711,   711,   711,
     711,   711,   711,   711,   712,   712,   713,   713,   714,   714,
     714,   714,   714,   714,   714,   714,   714,   714,   714,   714,
     714,   714,   714,   714,   715,   715,   716,   716,   717,   718,
     718,   719,   719,   719,   719,   719,   720,   720,   721,   721,
     721,   721,   722,   722,   722,   722,   722,   722,   722,   722,
     722,   722,   722,   722,   722,   722,   722,   722,   723,   723,
     724,   724,   725,   725,   726,   726,   727,   728,   729,   729,
     730,   730,   731,   731,   732,   733,   733,   734,   734,   734,
     735,   735,   735,   736,   736,   736,   736,   737,   737,   738,
     738,   739,   739,   740,   740,   741,   741,   742,   742,   743,
     743,   743,   744,   744,   745,   745,   746,   746,   746,   747,
     747,   747,   748,   748,   748,   749,   749,   750,   750,   751,
     751,   752,   752,   753,   753,   754,   754,   754,   754,   754,
     755,   755,   755,   755,   755,   756,   757,   758,   758,   758,
     759,   759,   759,   760,   761,   761,   761,   761,   762,   762,
     763,   763,   764,   764,   764,   764,   764,   764,   764,   764,
     764,   764,   764,   764,   764,   764,   764,   764,   765,   765,
     765,   765,   765,   766,   766,   767,   767,   768,   768,   769,
     770,   770,   771,   772,   772,   773,   773,   774,   774,   775,
     775,   776,   776,   777,   777,   777,   777,   778,   778,   779,
     780,   780,   781,   781,   782,   782,   782,   783,   783,   783,
     784,   785,   785,   786,   787,   787,   787,   787,   788,   789,
     789,   789,   789,   790,   790,   791,   791,   791,   792,   792,
     793,   794,   794,   795,   795,   795,   795,   795,   795,   795,
     795,   795,   795,   795,   795,   795,   795,   795,   795,   795,
     795,   795,   795,   795,   795,   795,   795,   795,   795,   795,
     795,   795,   795,   795,   795,   795,   795,   795,   795,   795,
     795,   795,   795,   795,   795,   795,   795,   795,   795,   795,
     795,   796,   796,   797,   797,   798,   798,   798,   798,   799,
     799,   799,   799,   799,   799,   799,   799,   799,   799,   799,
     799,   799,   799,   799,   799,   799,   799,   799,   799,   799,
     799,   799,   799,   800,   801,   801,   802,   802,   803,   803,
     803,   803,   803,   803,   803,   803,   803,   803,   803,   803,
     803,   803,   803,   803,   803,   803,   803,   804,   805,   805,
     805,   806,   806,   807,   807,   807,   807,   807,   808,   808,
     809,   809,   809,   809,   810,   810,   810,   811,   811,   812,
     813,   813,   814,   815,   815,   816,   816,   816,   816,   816,
     816,   816,   816,   816,   816,   816,   816,   816,   816,   817,
     817,   817,   818,   818,   818,   818,   818,   819,   819,   819,
     820,   820,   821,   821,   821,   821,   822,   822,   822,   822,
     823,   824,   825,   825,   826,   826,   827,   827,   827,   828,
     828,   828,   828,   828,   828,   828,   829,   829,   830,   830,
     830,   831,   832,   832,   833,   833,   834,   835,   835,   835,
     835,   835,   835,   835,   836,   836,   837,   838,   838,   838,
     838,   838,   838,   839,   839,   840,   841,   841,   841,   842,
     842,   843,   843,   843,   843,   843,   844,   844,   845,   845,
     845,   845,   845,   846,   846,   847,   847,   848,   848,   849,
     849,   850,   850,   851,   851,   852,   852,   852,   852,   853,
     853,   853,   853,   853,   853,   853,   853,   853,   854,   854,
     855,   856,   856,   857,   857,   857,   858,   859,   859,   860,
     860,   860,   860,   861,   861,   862,   862,   863,   863,   863,
     863,   864,   865,   865,   866,   866,   866,   867,   867,   868,
     869,   869,   869,   870,   870,   870,   871,   871,   872,   873,
     873,   874,   875,   875,   876,   876,   876,   876,   876,   876,
     876,   876,   877,   877,   878,   878,   878,   879,   880,   880,
     881,   881,   882,   883,   883,   884,   885,   885,   886,   887,
     888,   888,   888,   888,   888,   889,   889,   889,   890,   890,
     891,   891,   892,   892,   892,   892,   892,   892,   892,   892,
     893,   893,   894,   894,   894,   894,   894,   894,   894,   895,
     895,   895,   896,   896,   897,   898,   898,   899,   899,   900,
     900,   900,   900,   900,   900,   900,   900,   900,   901,   901,
     902,   902,   902,   903,   903,   904,   904,   905,   905,   906,
     907,   907,   908,   908,   909,   909,   909,   909,   910,   910,
     911,   911,   911,   912,   912,   913,   913,   914,   915,   915,
     915,   916,   917,   917,   918,   918,   919,   919,   920,   920,
     921,   921,   921,   921,   921,   922,   923,   924,   925,   926,
     926,   927,   927,   928,   928,   929,   929,   930,   931,   931,
     931,   931,   932,   932,   933,   933,   934,   934,   935,   935,
     936,   936,   936,   936,   936,   936,   936,   936,   937,   937,
     937,   937,   937,   937,   938,   938,   938,   938,   939,   939,
     940,   940,   940,   940,   940,   941,   941,   941,   941,   942,
     942,   943,   943,   944,   944,   944,   944,   945,   945,   946,
     946,   946,   947,   948,   948,   949,   949,   950,   951,   951,
     952,   952,   953,   953,   954,   954,   955,   955,   955,   956,
     956,   957,   957,   958,   959,   959,   959,   959,   959,   959,
     960,   960,   960,   961,   961,   961,   961,   961,   961,   961,
     962,   962,   962,   962,   963,   963,   964,   964,   965,   965,
     965,   965,   965,   965,   965,   965,   965,   965,   965,   966,
     966,   967,   967,   968,   968,   969,   970,   971,   971,   972,
     972,   973,   974,   975,   975,   975,   975,   975,   975,   976,
     976,   977,   977,   978,   978,   978,   978,   979,   980,   980,
     980,   981,   981,   981,   981,   981,   981,   981,   981,   981,
     981,   981,   981,   981,   981,   982,   982,   983,   983,   983,
     983,   983,   983,   983,   983,   983,   983,   983,   983,   983,
     983,   983,   983,   983,   983,   983,   983,   983,   983,   983,
     983,   983,   983,   983,   983,   983,   983,   983,   983,   983,
     983,   983,   983,   983,   983,   983,   983,   983,   983,   983,
     983,   983,   983,   983,   983,   983,   983,   983,   983,   983,
     983,   983,   983,   983,   983,   983,   983,   983,   983,   983,
     984,   984,   984,   984,   984,   984,   984,   984,   984,   984,
     984,   984,   984,   984,   984,   984,   984,   984,   984,   984,
     984,   984,   984,   984,   984,   985,   985,   985,   985,   985,
     985,   985,   985,   985,   985,   985,   985,   985,   985,   986,
     986,   986,   986,   986,   986,   986,   987,   987,   988,   988,
     989,   989,   989,   989,   989,   989,   989,   989,   989,   989,
     989,   989,   989,   989,   989,   989,   989,   989,   989,   989,
     989,   989,   989,   989,   989,   989,   989,   989,   989,   989,
     989,   989,   989,   989,   989,   989,   989,   989,   989,   989,
     989,   989,   990,   990,   991,   991,   991,   991,   992,   993,
     993,   994,   994,   995,   995,   996,   996,   996,   997,   997,
     997,   997,   998,   998,   999,   999,  1000,  1000,  1001,  1001,
    1002,  1003,  1003,  1003,  1004,  1005,  1005,  1006,  1006,  1007,
    1007,  1007,  1008,  1008,  1009,  1009,  1009,  1009,  1009,  1010,
    1010,  1010,  1011,  1011,  1012,  1013,  1013,  1013,  1014,  1014,
    1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,
    1015,  1015,  1016,  1016,  1017,  1017,  1018,  1018,  1018,  1018,
    1018,  1018,  1019,  1019,  1020,  1020,  1021,  1021,  1021,  1022,
    1022,  1023,  1023,  1023,  1024,  1024,  1025,  1025,  1026,  1026,
    1026,  1026,  1026,  1026,  1026,  1026,  1027,  1027,  1028,  1029,
    1029,  1030,  1030,  1030,  1030,  1030,  1030,  1031,  1032,  1033,
    1033,  1033,  1034,  1034,  1035,  1036,  1036,  1037,  1038,  1038,
    1039,  1039,  1040,  1040,  1041,  1041,  1041,  1041,  1042,  1042,
    1043,  1043,  1044,  1044,  1045,  1045,  1046,  1046,  1047,  1047,
    1048,  1049,  1049,  1050,  1050,  1051,  1051,  1051,  1051,  1052,
    1052,  1053,  1053,  1054,  1054,  1055,  1056,  1057,  1058,  1059,
    1060,  1061,  1061,  1062,  1062,  1062,  1062,  1062,  1062,  1062,
    1062,  1062,  1062,  1062,  1062,  1062,  1063,  1064,  1065,  1065,
    1065,  1066,  1067,  1067,  1067,  1068,  1068,  1069,  1069,  1069,
    1070,  1070,  1070,  1071,  1071,  1071,  1071,  1072,  1072,  1072,
    1072,  1072,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,
    1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,
    1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,
    1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,
    1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,
    1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,
    1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,
    1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,
    1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,
    1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,
    1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,
    1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,
    1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,
    1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,
    1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,
    1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,
    1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,
    1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,
    1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,
    1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,
    1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,
    1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,
    1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,
    1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,
    1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,
    1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,
    1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,
    1073,  1073,  1073,  1074,  1074,  1074,  1074,  1074,  1074,  1074,
    1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,
    1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,
    1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,
    1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,
    1074,  1075,  1075,  1075,  1075,  1075,  1075,  1075,  1075,  1075,
    1075,  1075,  1075,  1075,  1075,  1075,  1075,  1075,  1075,  1075,
    1075,  1075,  1075,  1075,  1076,  1076,  1076,  1076,  1076,  1076,
    1076,  1076,  1076,  1076,  1076,  1076,  1076,  1076,  1076,  1076,
    1076,  1076,  1076,  1076,  1076,  1076,  1076,  1076,  1076,  1076,
    1076,  1076,  1076,  1076,  1076,  1076,  1076,  1076,  1076,  1076,
    1076,  1076,  1076,  1076,  1076,  1076,  1076,  1076,  1076,  1076,
    1076,  1076,  1076,  1076,  1076,  1076,  1076,  1076,  1076,  1076,
    1076,  1076,  1076,  1076,  1076,  1076,  1076,  1076,  1076,  1076,
    1076,  1076,  1076,  1076,  1076,  1076,  1076,  1076,  1076,  1076,
    1076
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       0,     5,     1,     1,     0,     2,     0,     2,     0,     2,
       2,     3,     3,     1,     3,     3,     2,     1,     1,     2,
       2,     2,     3,     3,     5,     5,     0,     3,     5,     5,
       5,     4,     3,     5,     3,     5,     5,     6,     1,     1,
       3,     5,     6,     4,     9,     7,     1,     0,     2,     0,
       1,     1,     1,     1,     1,     1,     2,     3,     3,     2,
       5,     1,     3,     3,     3,     3,     1,     3,     3,     2,
       2,     2,     2,     3,     3,     3,     3,     1,     3,     1,
       3,     1,     1,     2,     2,     2,     1,     1,     1,     1,
       1,     1,     1,     3,     5,     1,     1,     1,     1,     1,
       0,     1,     1,     2,     1,     2,     3,     2,     1,     1,
       2,     1,     2,     1,     2,     3,     4,     3,     2,     4,
       1,     1,     1,     1,     1,     2,     2,     2,     2,     2,
       4,     6,    10,    13,     4,     6,    10,    13,     4,     6,
       4,     6,     5,     7,    11,    14,     1,     3,     2,     5,
       3,     6,     4,     6,     6,     6,     5,     5,     6,     6,
       4,     8,     4,     2,     4,     3,     6,     4,     3,     3,
       3,     3,     2,     2,     3,     4,     4,     3,     3,     3,
       3,     3,     3,     4,     4,     3,     2,     3,     2,     2,
       3,     3,     2,     2,     3,     4,     4,     4,     5,     1,
       3,     2,     1,     1,     0,     2,     0,     2,     0,     1,
       1,     1,     3,     3,     2,     0,     1,     3,     3,     1,
       5,     3,     4,     1,     3,     4,     6,     4,     8,     2,
       2,    11,     9,     1,     1,     1,     0,     1,     1,     1,
       1,     3,     2,     0,     1,     1,     1,     3,     3,     1,
       1,     3,     3,     3,     3,     4,     3,     2,     1,     0,
       2,     0,     3,     0,     1,     0,     1,     3,     2,     1,
       1,     1,     3,     0,     1,     3,     1,    11,    14,    10,
      13,     1,     1,     2,     2,     2,     2,     1,     0,     1,
       0,     3,     0,     1,     3,     1,     3,     1,     1,     1,
       1,     1,     4,     4,     2,     0,     3,     1,     1,     2,
       2,     1,     3,     4,     5,     2,     5,     1,     2,     2,
       2,     3,     3,     3,     0,     1,     1,     1,     1,     1,
       1,     3,     1,     5,     7,     3,     8,     4,     9,    11,
       2,     0,     3,     0,     1,     3,     1,     2,     2,     2,
       0,     1,     3,     3,     6,     4,     0,     1,     1,     2,
       2,     0,     3,     3,     2,     1,     1,     2,     2,     4,
       0,     2,     2,     2,     0,     3,     4,     4,     0,     2,
       0,     4,     0,     3,     7,    10,     5,     2,     3,     0,
       8,    11,     4,     1,     0,     6,     5,     8,     4,     6,
       1,     0,     1,     2,     2,     1,     2,     3,     2,     2,
       2,     2,     3,     3,     1,     3,     1,     0,     1,     2,
       1,     1,     3,     6,    10,     1,     0,     1,     2,     2,
       0,     2,     2,     1,     0,     5,     7,     1,     0,     7,
       2,     0,     3,     5,     5,     8,     2,     0,     2,     2,
       2,     1,     5,     2,     0,     2,     7,     7,    10,     6,
       6,     6,     6,     7,     7,     9,     9,     6,     7,     6,
       8,     8,     8,     8,     6,     6,     7,     7,     8,     6,
       9,     6,     7,     2,     2,     2,     2,     1,     2,     1,
       0,     6,     8,     7,     6,     4,     0,     1,     3,     4,
       1,     3,     1,     2,     2,     2,     2,     1,     1,    10,
       2,     0,     2,     2,     1,     0,     4,     6,     5,     4,
       4,    11,    14,     5,     7,    11,     2,     1,     4,     0,
       8,     1,     1,     7,     9,     8,     9,     8,     6,     8,
       4,     0,     5,     0,     2,     0,     2,     0,     2,     0,
       1,     1,     1,     1,     1,     8,    15,    20,     1,     1,
       2,     1,     3,     1,     1,     1,     3,     1,     3,     0,
       1,     0,     1,     1,     4,     0,     1,     3,     0,     1,
       1,     1,     1,     2,     0,     0,     2,     2,     1,     2,
       2,     2,     2,     6,     8,    11,    13,     1,     3,     5,
       1,     3,     5,     1,     2,     2,     1,     8,     4,     5,
       4,     4,     4,     3,     7,     8,     6,     6,     6,     6,
       6,     4,     5,     3,     1,     3,     3,     1,     1,     1,
       1,     1,     1,     3,     1,     3,     3,     1,     0,     1,
       3,     7,     9,     9,     3,     0,    13,     1,     3,     5,
       6,     4,     7,     2,     1,     0,     2,     0,     2,     4,
       0,     1,     0,     6,     8,     8,     1,     3,     5,     5,
       7,     9,     7,     9,     5,     6,     6,     4,     4,     6,
       4,     6,     5,     7,     1,     1,     1,     2,     1,     2,
       2,     2,     1,     1,     1,     1,     3,     3,     3,     3,
       1,     3,     1,     2,     2,     3,     1,     3,     5,     2,
       2,     0,     6,     6,     6,     7,     7,     7,     8,     9,
       8,     8,     6,     9,     8,     9,     9,     7,    10,     7,
       2,     1,     1,     1,     1,     1,     1,     1,     2,     1,
       1,     1,     1,     1,     2,     1,     3,     2,     3,     3,
       3,     3,     1,     1,     8,     8,     8,     9,     9,     9,
       9,     2,     0,     1,     1,     2,     2,     1,     1,     1,
       1,     1,     1,     2,     1,     1,     2,     2,     1,     2,
       3,     3,     3,     3,     4,     4,     3,     3,     3,     4,
       4,     3,     4,     4,     1,     1,     1,     0,     7,     7,
      10,     1,     1,     2,     4,     5,     1,     3,     2,     2,
       2,     2,     1,     2,     2,     4,     3,     2,     2,     2,
       2,     3,     2,     2,     2,     5,     5,     5,     1,     3,
       1,     2,     3,     0,     1,     3,     2,     6,     6,     9,
       3,     0,     3,     0,     5,     2,     0,     3,     3,     3,
       7,     7,    10,     1,     1,     1,     1,    14,    17,     1,
       0,     1,     0,     1,     0,     2,     0,     1,     3,     5,
       5,     7,     2,     0,     1,     0,     1,     1,     0,     2,
       2,     0,     9,    12,     7,     2,     0,     3,     2,     1,
       3,     3,     2,     1,     3,     3,     3,     2,     2,     1,
       1,     1,     1,     2,     1,     1,     1,     1,     4,     5,
       1,     3,     3,     1,     3,     3,     5,     6,     1,     3,
       1,     2,     4,     5,     1,     1,     1,     1,     3,     3,
       2,     2,     1,     2,     2,     2,     1,     2,     2,     2,
       2,     1,     1,     1,     3,     3,     5,     2,     0,     2,
       1,     3,     5,     1,     2,     1,     0,     5,     7,     5,
       7,     5,     7,     3,     5,     5,     5,     1,     3,     2,
       1,     2,     1,     2,    11,    10,    10,     2,     2,     0,
       9,     2,     0,    10,    11,    11,     5,     5,     8,     3,
       3,     6,     6,     1,     1,     1,     1,     1,     1,     3,
       1,     5,     5,     7,     6,     6,     6,     6,     8,     8,
       6,     6,     7,     9,     9,     8,    10,     6,     6,     6,
       8,     6,     8,     6,     8,     7,     9,     6,     8,     7,
       9,     8,    10,     9,    11,     8,    10,     9,    11,     8,
       8,     7,     6,     6,     6,     8,     8,     8,     8,     6,
       9,     1,     0,     2,     0,     7,     9,     8,     7,     7,
       6,     6,     6,     6,     6,     7,     9,     9,     6,     8,
       8,     8,     8,     8,     6,     8,     6,     8,     7,     9,
       7,     9,     6,     8,     1,     3,     3,     3,     7,     6,
       6,     6,     6,     6,     7,     7,     7,     9,     9,     6,
       6,     6,     8,     8,     8,     6,     7,    13,     1,     1,
       3,     3,     1,     1,     1,     1,     1,     1,     1,     0,
       1,     1,     1,     1,     1,     1,     0,     6,     8,     3,
       2,     0,     2,     2,     2,     2,     3,     3,     2,     2,
       2,     2,     3,     2,     5,     4,     3,     3,     3,     1,
       1,     0,     3,     2,     2,     1,     2,     1,     3,     2,
       1,     0,     9,    11,    12,    14,     3,     4,     4,     0,
       2,     5,     1,     0,     1,     2,     3,     3,     3,     1,
       2,     1,     1,     1,     1,     1,     1,     0,     5,     4,
       6,     4,     3,     5,     4,     4,     6,     4,     6,     6,
       5,     7,     9,     6,     1,     0,     6,    11,    11,    11,
      13,     9,    11,     1,     1,    10,     4,     2,     5,     2,
       0,     4,     5,     5,     4,     6,     1,     3,     1,     1,
       1,     1,     1,     2,     4,     1,     1,     1,     0,     1,
       0,     1,     0,     3,     0,     2,     4,     3,     5,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     3,
       2,     1,     1,     1,     1,     0,     5,     3,     0,     1,
       1,     1,     1,     3,     9,     3,     0,     2,     3,     2,
       3,     7,     1,     3,     1,     4,     2,     1,     3,     2,
       8,     5,     0,     4,     3,     0,     2,     0,     7,     2,
       0,     5,     3,     0,     2,     2,     2,     3,     1,     3,
       1,     2,     1,     0,     1,     2,     0,     8,     1,     3,
       1,     1,     3,     5,     5,     2,     1,     3,     7,     1,
       0,     3,     2,     2,     2,     0,     2,     2,     1,     1,
       3,     3,     1,     2,     4,     4,     2,     3,     5,     5,
       1,     1,     9,     9,     1,     2,     4,     4,     4,     2,
       2,     3,     1,     3,     6,     1,     0,     2,     0,     3,
       3,     4,     4,     4,     4,     3,     2,     1,     1,     0,
       1,     1,     0,     1,     5,     1,     0,     1,     0,     3,
       1,     3,     4,     3,     2,     2,     1,     1,     1,     0,
       2,     4,     5,     2,     3,     1,     1,     1,     1,     3,
       0,     1,     1,     1,     1,     1,     3,     0,     1,     3,
       1,     1,     1,     1,     1,     2,     4,     4,     5,     2,
       0,     1,     3,     1,     0,     1,     2,     3,     2,     4,
       2,     3,     2,     0,     2,     3,     2,     0,     1,     3,
       2,     3,     2,     3,     2,     3,     1,     4,     3,     4,
       5,     4,     5,     4,     5,     2,     4,     1,     1,     0,
       1,     4,     5,     4,     0,     2,     2,     2,     1,     1,
       0,     4,     2,     1,     2,     2,     4,     1,     3,     1,
       2,     3,     6,     4,     0,     2,     6,     2,     1,     3,
       4,     0,     2,     0,     2,     0,     2,     4,     0,     1,
       0,     1,     3,     3,     2,     3,     5,     6,     2,     3,
       3,     4,     0,     1,     1,     1,     1,     1,     2,     4,
       1,     1,     1,     1,     2,     3,     3,     0,     1,     1,
       1,     1,     1,     2,     2,     2,     2,     2,     1,     3,
       0,     1,     1,     1,     1,     5,     2,     1,     1,     1,
       1,     5,     2,     2,     2,     1,     3,     3,     2,     1,
       0,     3,     0,     5,     2,     5,     2,     1,     3,     3,
       0,     1,     1,     1,     1,     1,     1,     3,     3,     3,
       3,     3,     3,     3,     0,     1,     4,     1,     3,     3,
       5,     2,     2,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     2,     2,     3,     3,
       2,     2,     3,     5,     4,     6,     3,     5,     4,     6,
       4,     6,     5,     7,     3,     2,     4,     2,     3,     3,
       4,     3,     4,     3,     4,     5,     6,     6,     7,     6,
       7,     6,     7,     3,     4,     4,     6,     2,     3,     4,
       1,     3,     2,     2,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     2,     2,     5,
       6,     6,     7,     3,     4,     1,     1,     2,     4,     1,
       1,     1,     2,     2,     2,     2,     1,     1,     4,     3,
       5,     6,     8,     6,     6,     4,     4,     1,     1,     1,
       5,     1,     1,     4,     1,     4,     1,     4,     1,     4,
       1,     1,     1,     1,     1,     1,     6,     4,     4,     4,
       4,     6,     5,     5,     5,     4,     6,     4,     4,     4,
       4,     5,     7,     7,     9,     5,     4,     6,     5,     7,
       7,     7,     2,     3,     3,     3,     4,     0,     4,     1,
       3,     3,     1,     1,     1,     2,     2,     0,     2,     4,
       4,     6,     5,     0,     5,     0,     2,     0,     1,     3,
       3,     2,     2,     0,     6,     1,     0,     3,     0,     2,
       2,     0,     1,     4,     2,     2,     2,     2,     2,     4,
       3,     5,     4,     3,     5,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     4,     1,     4,     1,     4,     1,     2,
       1,     2,     1,     3,     1,     3,     1,     3,     3,     1,
       3,     3,     3,     2,     1,     3,     3,     0,     1,     1,
       1,     1,     1,     1,     1,     1,     4,     3,     2,     3,
       0,     3,     3,     2,     2,     1,     0,     2,     2,     3,
       2,     1,     1,     3,     5,     1,     2,     4,     2,     0,
       1,     0,     1,     2,     2,     2,     3,     5,     1,     0,
       1,     2,     0,     2,     1,     0,     1,     1,     1,     3,
       3,     1,     0,     1,     3,     3,     2,     1,     1,     1,
       3,     1,     2,     1,     3,     1,     1,     1,     1,     1,
       1,     1,     2,     1,     1,     1,     1,     1,     2,     6,
       2,     3,     5,     1,     1,     1,     1,     1,     1,     2,
       2,     1,     1,     1,     1,     1,     3,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (&yylloc, yyscanner, YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static unsigned
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  unsigned res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
 }

#  define YY_LOCATION_PRINT(File, Loc)          \
  yy_location_print_ (File, &(Loc))

# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value, Location, yyscanner); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, core_yyscan_t yyscanner)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  YYUSE (yylocationp);
  YYUSE (yyscanner);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, core_yyscan_t yyscanner)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp, yyscanner);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule, core_yyscan_t yyscanner)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                       , &(yylsp[(yyi + 1) - (yynrhs)])                       , yyscanner);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule, yyscanner); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp, core_yyscan_t yyscanner)
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);
  YYUSE (yyscanner);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/*----------.
| yyparse.  |
`----------*/

int
yyparse (core_yyscan_t yyscanner)
{
/* The lookahead symbol.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

/* Location data for the lookahead symbol.  */
static YYLTYPE yyloc_default
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
YYLTYPE yylloc = yyloc_default;

    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.
       'yyls': related to locations.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[3];

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yylsp = yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  yylsp[0] = yylloc;
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yyls1, yysize * sizeof (*yylsp),
                    &yystacksize);

        yyls = yyls1;
        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex (&yylval, &yylloc, yyscanner);
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location.  */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 735 "gram.y" /* yacc.c:1646  */
    {
				pg_yyget_extra(yyscanner)->parsetree = (yyvsp[0].list);
			}
#line 23161 "gram.c" /* yacc.c:1646  */
    break;

  case 3:
#line 742 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].node) != NULL)
						(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
					else
						(yyval.list) = (yyvsp[-2].list);
				}
#line 23172 "gram.c" /* yacc.c:1646  */
    break;

  case 4:
#line 749 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].node) != NULL)
						(yyval.list) = list_make1((yyvsp[0].node));
					else
						(yyval.list) = NIL;
				}
#line 23183 "gram.c" /* yacc.c:1646  */
    break;

  case 130:
#line 884 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 23189 "gram.c" /* yacc.c:1646  */
    break;

  case 131:
#line 895 "gram.y" /* yacc.c:1646  */
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_ROLE;
					n->role = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 23201 "gram.c" /* yacc.c:1646  */
    break;

  case 132:
#line 905 "gram.y" /* yacc.c:1646  */
    {}
#line 23207 "gram.c" /* yacc.c:1646  */
    break;

  case 133:
#line 906 "gram.y" /* yacc.c:1646  */
    {}
#line 23213 "gram.c" /* yacc.c:1646  */
    break;

  case 134:
#line 907 "gram.y" /* yacc.c:1646  */
    {}
#line 23219 "gram.c" /* yacc.c:1646  */
    break;

  case 135:
#line 916 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 23225 "gram.c" /* yacc.c:1646  */
    break;

  case 136:
#line 917 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 23231 "gram.c" /* yacc.c:1646  */
    break;

  case 137:
#line 921 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 23237 "gram.c" /* yacc.c:1646  */
    break;

  case 138:
#line 922 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 23243 "gram.c" /* yacc.c:1646  */
    break;

  case 139:
#line 927 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("password",
									 (Node *)makeString((yyvsp[0].str)));
				}
#line 23252 "gram.c" /* yacc.c:1646  */
    break;

  case 140:
#line 932 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("password", NULL);
				}
#line 23260 "gram.c" /* yacc.c:1646  */
    break;

  case 141:
#line 936 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("encryptedPassword",
									 (Node *)makeString((yyvsp[0].str)));
				}
#line 23269 "gram.c" /* yacc.c:1646  */
    break;

  case 142:
#line 941 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("unencryptedPassword",
									 (Node *)makeString((yyvsp[0].str)));
				}
#line 23278 "gram.c" /* yacc.c:1646  */
    break;

  case 143:
#line 946 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("inherit", (Node *)makeInteger(TRUE));
				}
#line 23286 "gram.c" /* yacc.c:1646  */
    break;

  case 144:
#line 950 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("connectionlimit", (Node *)makeInteger((yyvsp[0].ival)));
				}
#line 23294 "gram.c" /* yacc.c:1646  */
    break;

  case 145:
#line 954 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("validUntil", (Node *)makeString((yyvsp[0].str)));
				}
#line 23302 "gram.c" /* yacc.c:1646  */
    break;

  case 146:
#line 959 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("rolemembers", (Node *)(yyvsp[0].list));
				}
#line 23310 "gram.c" /* yacc.c:1646  */
    break;

  case 147:
#line 963 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * We handle identifiers that aren't parser keywords with
					 * the following special-case codes, to avoid bloating the
					 * size of the main parser.
					 */
					if (strcmp((yyvsp[0].str), "superuser") == 0)
						(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(TRUE));
					else if (strcmp((yyvsp[0].str), "nosuperuser") == 0)
						(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(FALSE));
					else if (strcmp((yyvsp[0].str), "createrole") == 0)
						(yyval.defelt) = makeDefElem("createrole", (Node *)makeInteger(TRUE));
					else if (strcmp((yyvsp[0].str), "nocreaterole") == 0)
						(yyval.defelt) = makeDefElem("createrole", (Node *)makeInteger(FALSE));
					else if (strcmp((yyvsp[0].str), "replication") == 0)
						(yyval.defelt) = makeDefElem("isreplication", (Node *)makeInteger(TRUE));
					else if (strcmp((yyvsp[0].str), "noreplication") == 0)
						(yyval.defelt) = makeDefElem("isreplication", (Node *)makeInteger(FALSE));
					else if (strcmp((yyvsp[0].str), "createdb") == 0)
						(yyval.defelt) = makeDefElem("createdb", (Node *)makeInteger(TRUE));
					else if (strcmp((yyvsp[0].str), "nocreatedb") == 0)
						(yyval.defelt) = makeDefElem("createdb", (Node *)makeInteger(FALSE));
					else if (strcmp((yyvsp[0].str), "login") == 0)
						(yyval.defelt) = makeDefElem("canlogin", (Node *)makeInteger(TRUE));
					else if (strcmp((yyvsp[0].str), "nologin") == 0)
						(yyval.defelt) = makeDefElem("canlogin", (Node *)makeInteger(FALSE));
					else if (strcmp((yyvsp[0].str), "bypassrls") == 0)
						(yyval.defelt) = makeDefElem("bypassrls", (Node *)makeInteger(TRUE));
					else if (strcmp((yyvsp[0].str), "nobypassrls") == 0)
						(yyval.defelt) = makeDefElem("bypassrls", (Node *)makeInteger(FALSE));
					else if (strcmp((yyvsp[0].str), "noinherit") == 0)
					{
						/*
						 * Note that INHERIT is a keyword, so it's handled by main parser, but
						 * NOINHERIT is handled here.
						 */
						(yyval.defelt) = makeDefElem("inherit", (Node *)makeInteger(FALSE));
					}
					else
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("unrecognized role option \"%s\"", (yyvsp[0].str)),
									 parser_errposition((yylsp[0]))));
				}
#line 23359 "gram.c" /* yacc.c:1646  */
    break;

  case 148:
#line 1010 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = (yyvsp[0].defelt); }
#line 23365 "gram.c" /* yacc.c:1646  */
    break;

  case 149:
#line 1013 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("sysid", (Node *)makeInteger((yyvsp[0].ival)));
				}
#line 23373 "gram.c" /* yacc.c:1646  */
    break;

  case 150:
#line 1017 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("adminmembers", (Node *)(yyvsp[0].list));
				}
#line 23381 "gram.c" /* yacc.c:1646  */
    break;

  case 151:
#line 1021 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("rolemembers", (Node *)(yyvsp[0].list));
				}
#line 23389 "gram.c" /* yacc.c:1646  */
    break;

  case 152:
#line 1025 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("addroleto", (Node *)(yyvsp[0].list));
				}
#line 23397 "gram.c" /* yacc.c:1646  */
    break;

  case 153:
#line 1029 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("addroleto", (Node *)(yyvsp[0].list));
				}
#line 23405 "gram.c" /* yacc.c:1646  */
    break;

  case 154:
#line 1043 "gram.y" /* yacc.c:1646  */
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_USER;
					n->role = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 23417 "gram.c" /* yacc.c:1646  */
    break;

  case 155:
#line 1061 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
					n->role = (yyvsp[-2].node);
					n->action = +1;	/* add, if there are members */
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				 }
#line 23429 "gram.c" /* yacc.c:1646  */
    break;

  case 156:
#line 1071 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 23435 "gram.c" /* yacc.c:1646  */
    break;

  case 157:
#line 1072 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 23441 "gram.c" /* yacc.c:1646  */
    break;

  case 158:
#line 1077 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
					n->role = (yyvsp[-2].node);
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 23453 "gram.c" /* yacc.c:1646  */
    break;

  case 159:
#line 1085 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
					n->role = NULL;
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 23465 "gram.c" /* yacc.c:1646  */
    break;

  case 160:
#line 1103 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
					n->role = (yyvsp[-2].node);
					n->action = +1;	/* add, if there are members */
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				 }
#line 23477 "gram.c" /* yacc.c:1646  */
    break;

  case 161:
#line 1115 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
					n->role = (yyvsp[-1].node);
					n->database = NULL;
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 23489 "gram.c" /* yacc.c:1646  */
    break;

  case 162:
#line 1136 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = FALSE;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 23500 "gram.c" /* yacc.c:1646  */
    break;

  case 163:
#line 1143 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = TRUE;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 23511 "gram.c" /* yacc.c:1646  */
    break;

  case 164:
#line 1160 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = FALSE;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 23522 "gram.c" /* yacc.c:1646  */
    break;

  case 165:
#line 1167 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->roles = (yyvsp[0].list);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 23533 "gram.c" /* yacc.c:1646  */
    break;

  case 166:
#line 1184 "gram.y" /* yacc.c:1646  */
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_GROUP;
					n->role = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 23545 "gram.c" /* yacc.c:1646  */
    break;

  case 167:
#line 1202 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
					n->role = (yyvsp[-3].node);
					n->action = (yyvsp[-2].ival);
					n->options = list_make1(makeDefElem("rolemembers",
														(Node *)(yyvsp[0].list)));
					(yyval.node) = (Node *)n;
				}
#line 23558 "gram.c" /* yacc.c:1646  */
    break;

  case 168:
#line 1212 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = +1; }
#line 23564 "gram.c" /* yacc.c:1646  */
    break;

  case 169:
#line 1213 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = -1; }
#line 23570 "gram.c" /* yacc.c:1646  */
    break;

  case 170:
#line 1226 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = FALSE;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 23581 "gram.c" /* yacc.c:1646  */
    break;

  case 171:
#line 1233 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = TRUE;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 23592 "gram.c" /* yacc.c:1646  */
    break;

  case 172:
#line 1250 "gram.y" /* yacc.c:1646  */
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* One can omit the schema name or the authorization id. */
					n->schemaname = (yyvsp[-3].str);
					n->authrole = (yyvsp[-1].node);
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
#line 23606 "gram.c" /* yacc.c:1646  */
    break;

  case 173:
#line 1260 "gram.y" /* yacc.c:1646  */
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* ...but not both */
					n->schemaname = (yyvsp[-1].str);
					n->authrole = NULL;
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
#line 23620 "gram.c" /* yacc.c:1646  */
    break;

  case 174:
#line 1270 "gram.y" /* yacc.c:1646  */
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* schema name can be omitted here, too */
					n->schemaname = (yyvsp[-3].str);
					n->authrole = (yyvsp[-1].node);
					if ((yyvsp[0].list) != NIL)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("CREATE SCHEMA IF NOT EXISTS cannot include schema elements"),
								 parser_errposition((yylsp[0]))));
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
#line 23639 "gram.c" /* yacc.c:1646  */
    break;

  case 175:
#line 1285 "gram.y" /* yacc.c:1646  */
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* ...but not here */
					n->schemaname = (yyvsp[-1].str);
					n->authrole = NULL;
					if ((yyvsp[0].list) != NIL)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("CREATE SCHEMA IF NOT EXISTS cannot include schema elements"),
								 parser_errposition((yylsp[0]))));
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
#line 23658 "gram.c" /* yacc.c:1646  */
    break;

  case 176:
#line 1302 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 23664 "gram.c" /* yacc.c:1646  */
    break;

  case 177:
#line 1303 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 23670 "gram.c" /* yacc.c:1646  */
    break;

  case 178:
#line 1308 "gram.y" /* yacc.c:1646  */
    {
					if ((yyloc) < 0)			/* see comments for YYLLOC_DEFAULT */
						(yyloc) = (yylsp[0]);
					(yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node));
				}
#line 23680 "gram.c" /* yacc.c:1646  */
    break;

  case 179:
#line 1314 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 23686 "gram.c" /* yacc.c:1646  */
    break;

  case 186:
#line 1342 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);
					n->is_local = false;
					(yyval.node) = (Node *) n;
				}
#line 23696 "gram.c" /* yacc.c:1646  */
    break;

  case 187:
#line 1348 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);
					n->is_local = true;
					(yyval.node) = (Node *) n;
				}
#line 23706 "gram.c" /* yacc.c:1646  */
    break;

  case 188:
#line 1354 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);
					n->is_local = false;
					(yyval.node) = (Node *) n;
				}
#line 23716 "gram.c" /* yacc.c:1646  */
    break;

  case 189:
#line 1363 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_MULTI;
					n->name = "TRANSACTION";
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 23728 "gram.c" /* yacc.c:1646  */
    break;

  case 190:
#line 1371 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_MULTI;
					n->name = "SESSION CHARACTERISTICS";
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 23740 "gram.c" /* yacc.c:1646  */
    break;

  case 192:
#line 1383 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = (yyvsp[-2].str);
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 23752 "gram.c" /* yacc.c:1646  */
    break;

  case 193:
#line 1391 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = (yyvsp[-2].str);
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 23764 "gram.c" /* yacc.c:1646  */
    break;

  case 194:
#line 1399 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_DEFAULT;
					n->name = (yyvsp[-2].str);
					(yyval.vsetstmt) = n;
				}
#line 23775 "gram.c" /* yacc.c:1646  */
    break;

  case 195:
#line 1406 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_DEFAULT;
					n->name = (yyvsp[-2].str);
					(yyval.vsetstmt) = n;
				}
#line 23786 "gram.c" /* yacc.c:1646  */
    break;

  case 196:
#line 1414 "gram.y" /* yacc.c:1646  */
    {(yyval.vsetstmt) = (yyvsp[0].vsetstmt);}
#line 23792 "gram.c" /* yacc.c:1646  */
    break;

  case 197:
#line 1416 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_CURRENT;
					n->name = (yyvsp[-2].str);
					(yyval.vsetstmt) = n;
				}
#line 23803 "gram.c" /* yacc.c:1646  */
    break;

  case 198:
#line 1424 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "timezone";
					if ((yyvsp[0].node) != NULL)
						n->args = list_make1((yyvsp[0].node));
					else
						n->kind = VAR_SET_DEFAULT;
					(yyval.vsetstmt) = n;
				}
#line 23818 "gram.c" /* yacc.c:1646  */
    break;

  case 199:
#line 1435 "gram.y" /* yacc.c:1646  */
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("current database cannot be changed"),
							 parser_errposition((yylsp[0]))));
					(yyval.vsetstmt) = NULL; /*not reached*/
				}
#line 23830 "gram.c" /* yacc.c:1646  */
    break;

  case 200:
#line 1443 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "search_path";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 23842 "gram.c" /* yacc.c:1646  */
    break;

  case 201:
#line 1451 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "client_encoding";
					if ((yyvsp[0].str) != NULL)
						n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					else
						n->kind = VAR_SET_DEFAULT;
					(yyval.vsetstmt) = n;
				}
#line 23857 "gram.c" /* yacc.c:1646  */
    break;

  case 202:
#line 1462 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "role";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 23869 "gram.c" /* yacc.c:1646  */
    break;

  case 203:
#line 1470 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "session_authorization";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 23881 "gram.c" /* yacc.c:1646  */
    break;

  case 204:
#line 1478 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_DEFAULT;
					n->name = "session_authorization";
					(yyval.vsetstmt) = n;
				}
#line 23892 "gram.c" /* yacc.c:1646  */
    break;

  case 205:
#line 1485 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "xmloption";
					n->args = list_make1(makeStringConst((yyvsp[0].ival) == XMLOPTION_DOCUMENT ? "DOCUMENT" : "CONTENT", (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 23904 "gram.c" /* yacc.c:1646  */
    break;

  case 206:
#line 1494 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_MULTI;
					n->name = "TRANSACTION SNAPSHOT";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 23916 "gram.c" /* yacc.c:1646  */
    break;

  case 207:
#line 1503 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 23922 "gram.c" /* yacc.c:1646  */
    break;

  case 208:
#line 1505 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = psprintf("%s.%s", (yyvsp[-2].str), (yyvsp[0].str)); }
#line 23928 "gram.c" /* yacc.c:1646  */
    break;

  case 209:
#line 1508 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 23934 "gram.c" /* yacc.c:1646  */
    break;

  case 210:
#line 1509 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 23940 "gram.c" /* yacc.c:1646  */
    break;

  case 211:
#line 1513 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0])); }
#line 23946 "gram.c" /* yacc.c:1646  */
    break;

  case 212:
#line 1515 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeAConst((yyvsp[0].value), (yylsp[0])); }
#line 23952 "gram.c" /* yacc.c:1646  */
    break;

  case 213:
#line 1518 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "read uncommitted"; }
#line 23958 "gram.c" /* yacc.c:1646  */
    break;

  case 214:
#line 1519 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "read committed"; }
#line 23964 "gram.c" /* yacc.c:1646  */
    break;

  case 215:
#line 1520 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "repeatable read"; }
#line 23970 "gram.c" /* yacc.c:1646  */
    break;

  case 216:
#line 1521 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "serializable"; }
#line 23976 "gram.c" /* yacc.c:1646  */
    break;

  case 217:
#line 1525 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "true"; }
#line 23982 "gram.c" /* yacc.c:1646  */
    break;

  case 218:
#line 1526 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "false"; }
#line 23988 "gram.c" /* yacc.c:1646  */
    break;

  case 219:
#line 1527 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "on"; }
#line 23994 "gram.c" /* yacc.c:1646  */
    break;

  case 220:
#line 1533 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 24000 "gram.c" /* yacc.c:1646  */
    break;

  case 221:
#line 1546 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 24008 "gram.c" /* yacc.c:1646  */
    break;

  case 222:
#line 1550 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 24016 "gram.c" /* yacc.c:1646  */
    break;

  case 223:
#line 1554 "gram.y" /* yacc.c:1646  */
    {
					TypeName *t = (yyvsp[-2].typnam);
					if ((yyvsp[0].list) != NIL)
					{
						A_Const *n = (A_Const *) linitial((yyvsp[0].list));
						if ((n->val.val.ival & ~(INTERVAL_MASK(HOUR) | INTERVAL_MASK(MINUTE))) != 0)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("time zone interval must be HOUR or HOUR TO MINUTE"),
									 parser_errposition((yylsp[0]))));
					}
					t->typmods = (yyvsp[0].list);
					(yyval.node) = makeStringConstCast((yyvsp[-1].str), (yylsp[-1]), t);
				}
#line 24035 "gram.c" /* yacc.c:1646  */
    break;

  case 224:
#line 1569 "gram.y" /* yacc.c:1646  */
    {
					TypeName *t = (yyvsp[-4].typnam);
					t->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
											makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 24046 "gram.c" /* yacc.c:1646  */
    break;

  case 225:
#line 1575 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeAConst((yyvsp[0].value), (yylsp[0])); }
#line 24052 "gram.c" /* yacc.c:1646  */
    break;

  case 226:
#line 1576 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 24058 "gram.c" /* yacc.c:1646  */
    break;

  case 227:
#line 1577 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 24064 "gram.c" /* yacc.c:1646  */
    break;

  case 228:
#line 1581 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 24070 "gram.c" /* yacc.c:1646  */
    break;

  case 229:
#line 1582 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 24076 "gram.c" /* yacc.c:1646  */
    break;

  case 230:
#line 1583 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 24082 "gram.c" /* yacc.c:1646  */
    break;

  case 231:
#line 1587 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 24088 "gram.c" /* yacc.c:1646  */
    break;

  case 232:
#line 1588 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 24094 "gram.c" /* yacc.c:1646  */
    break;

  case 233:
#line 1592 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].vsetstmt); }
#line 24100 "gram.c" /* yacc.c:1646  */
    break;

  case 234:
#line 1596 "gram.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (yyvsp[0].vsetstmt); }
#line 24106 "gram.c" /* yacc.c:1646  */
    break;

  case 235:
#line 1598 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = "timezone";
					(yyval.vsetstmt) = n;
				}
#line 24117 "gram.c" /* yacc.c:1646  */
    break;

  case 236:
#line 1605 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = "transaction_isolation";
					(yyval.vsetstmt) = n;
				}
#line 24128 "gram.c" /* yacc.c:1646  */
    break;

  case 237:
#line 1612 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = "session_authorization";
					(yyval.vsetstmt) = n;
				}
#line 24139 "gram.c" /* yacc.c:1646  */
    break;

  case 238:
#line 1622 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = (yyvsp[0].str);
					(yyval.vsetstmt) = n;
				}
#line 24150 "gram.c" /* yacc.c:1646  */
    break;

  case 239:
#line 1629 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET_ALL;
					(yyval.vsetstmt) = n;
				}
#line 24160 "gram.c" /* yacc.c:1646  */
    break;

  case 240:
#line 1638 "gram.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (yyvsp[0].vsetstmt); }
#line 24166 "gram.c" /* yacc.c:1646  */
    break;

  case 241:
#line 1639 "gram.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (VariableSetStmt *) (yyvsp[0].node); }
#line 24172 "gram.c" /* yacc.c:1646  */
    break;

  case 242:
#line 1644 "gram.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (yyvsp[0].vsetstmt); }
#line 24178 "gram.c" /* yacc.c:1646  */
    break;

  case 243:
#line 1645 "gram.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (VariableSetStmt *) (yyvsp[0].node); }
#line 24184 "gram.c" /* yacc.c:1646  */
    break;

  case 244:
#line 1651 "gram.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 24194 "gram.c" /* yacc.c:1646  */
    break;

  case 245:
#line 1657 "gram.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "timezone";
					(yyval.node) = (Node *) n;
				}
#line 24204 "gram.c" /* yacc.c:1646  */
    break;

  case 246:
#line 1663 "gram.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "transaction_isolation";
					(yyval.node) = (Node *) n;
				}
#line 24214 "gram.c" /* yacc.c:1646  */
    break;

  case 247:
#line 1669 "gram.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "session_authorization";
					(yyval.node) = (Node *) n;
				}
#line 24224 "gram.c" /* yacc.c:1646  */
    break;

  case 248:
#line 1675 "gram.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "all";
					(yyval.node) = (Node *) n;
				}
#line 24234 "gram.c" /* yacc.c:1646  */
    break;

  case 249:
#line 1685 "gram.y" /* yacc.c:1646  */
    {
					ConstraintsSetStmt *n = makeNode(ConstraintsSetStmt);
					n->constraints = (yyvsp[-1].list);
					n->deferred = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 24245 "gram.c" /* yacc.c:1646  */
    break;

  case 250:
#line 1694 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 24251 "gram.c" /* yacc.c:1646  */
    break;

  case 251:
#line 1695 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 24257 "gram.c" /* yacc.c:1646  */
    break;

  case 252:
#line 1699 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 24263 "gram.c" /* yacc.c:1646  */
    break;

  case 253:
#line 1700 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 24269 "gram.c" /* yacc.c:1646  */
    break;

  case 254:
#line 1709 "gram.y" /* yacc.c:1646  */
    {
					CheckPointStmt *n = makeNode(CheckPointStmt);
					(yyval.node) = (Node *)n;
				}
#line 24278 "gram.c" /* yacc.c:1646  */
    break;

  case 255:
#line 1724 "gram.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_ALL;
					(yyval.node) = (Node *) n;
				}
#line 24288 "gram.c" /* yacc.c:1646  */
    break;

  case 256:
#line 1730 "gram.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_TEMP;
					(yyval.node) = (Node *) n;
				}
#line 24298 "gram.c" /* yacc.c:1646  */
    break;

  case 257:
#line 1736 "gram.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_TEMP;
					(yyval.node) = (Node *) n;
				}
#line 24308 "gram.c" /* yacc.c:1646  */
    break;

  case 258:
#line 1742 "gram.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_PLANS;
					(yyval.node) = (Node *) n;
				}
#line 24318 "gram.c" /* yacc.c:1646  */
    break;

  case 259:
#line 1748 "gram.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_SEQUENCES;
					(yyval.node) = (Node *) n;
				}
#line 24328 "gram.c" /* yacc.c:1646  */
    break;

  case 260:
#line 1767 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_TABLE;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 24341 "gram.c" /* yacc.c:1646  */
    break;

  case 261:
#line 1776 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_TABLE;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 24354 "gram.c" /* yacc.c:1646  */
    break;

  case 262:
#line 1785 "gram.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[-4].str);
					n->objtype = OBJECT_TABLE;
					n->roles = NIL;
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 24369 "gram.c" /* yacc.c:1646  */
    break;

  case 263:
#line 1796 "gram.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[-7].str);
					n->objtype = OBJECT_TABLE;
					n->roles = (yyvsp[-4].list);
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 24384 "gram.c" /* yacc.c:1646  */
    break;

  case 264:
#line 1807 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_INDEX;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 24397 "gram.c" /* yacc.c:1646  */
    break;

  case 265:
#line 1816 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_INDEX;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 24410 "gram.c" /* yacc.c:1646  */
    break;

  case 266:
#line 1825 "gram.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[-4].str);
					n->objtype = OBJECT_INDEX;
					n->roles = NIL;
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 24425 "gram.c" /* yacc.c:1646  */
    break;

  case 267:
#line 1836 "gram.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[-7].str);
					n->objtype = OBJECT_INDEX;
					n->roles = (yyvsp[-4].list);
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 24440 "gram.c" /* yacc.c:1646  */
    break;

  case 268:
#line 1847 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_SEQUENCE;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 24453 "gram.c" /* yacc.c:1646  */
    break;

  case 269:
#line 1856 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_SEQUENCE;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 24466 "gram.c" /* yacc.c:1646  */
    break;

  case 270:
#line 1865 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_VIEW;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 24479 "gram.c" /* yacc.c:1646  */
    break;

  case 271:
#line 1874 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_VIEW;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 24492 "gram.c" /* yacc.c:1646  */
    break;

  case 272:
#line 1883 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_MATVIEW;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 24505 "gram.c" /* yacc.c:1646  */
    break;

  case 273:
#line 1892 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_MATVIEW;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 24518 "gram.c" /* yacc.c:1646  */
    break;

  case 274:
#line 1901 "gram.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[-4].str);
					n->objtype = OBJECT_MATVIEW;
					n->roles = NIL;
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 24533 "gram.c" /* yacc.c:1646  */
    break;

  case 275:
#line 1912 "gram.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[-7].str);
					n->objtype = OBJECT_MATVIEW;
					n->roles = (yyvsp[-4].list);
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 24548 "gram.c" /* yacc.c:1646  */
    break;

  case 276:
#line 1925 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 24554 "gram.c" /* yacc.c:1646  */
    break;

  case 277:
#line 1926 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 24560 "gram.c" /* yacc.c:1646  */
    break;

  case 278:
#line 1932 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 24572 "gram.c" /* yacc.c:1646  */
    break;

  case 279:
#line 1941 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 24584 "gram.c" /* yacc.c:1646  */
    break;

  case 280:
#line 1950 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 24596 "gram.c" /* yacc.c:1646  */
    break;

  case 281:
#line 1959 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 24608 "gram.c" /* yacc.c:1646  */
    break;

  case 282:
#line 1968 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ColumnDefault;
					n->name = (yyvsp[-1].str);
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 24620 "gram.c" /* yacc.c:1646  */
    break;

  case 283:
#line 1977 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropNotNull;
					n->name = (yyvsp[-3].str);
					(yyval.node) = (Node *)n;
				}
#line 24631 "gram.c" /* yacc.c:1646  */
    break;

  case 284:
#line 1985 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetNotNull;
					n->name = (yyvsp[-3].str);
					(yyval.node) = (Node *)n;
				}
#line 24642 "gram.c" /* yacc.c:1646  */
    break;

  case 285:
#line 1993 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetStatistics;
					n->name = (yyvsp[-3].str);
					n->def = (Node *) makeInteger((yyvsp[0].ival));
					(yyval.node) = (Node *)n;
				}
#line 24654 "gram.c" /* yacc.c:1646  */
    break;

  case 286:
#line 2002 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetOptions;
					n->name = (yyvsp[-2].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 24666 "gram.c" /* yacc.c:1646  */
    break;

  case 287:
#line 2011 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ResetOptions;
					n->name = (yyvsp[-2].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 24678 "gram.c" /* yacc.c:1646  */
    break;

  case 288:
#line 2020 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetStorage;
					n->name = (yyvsp[-3].str);
					n->def = (Node *) makeString((yyvsp[0].str));
					(yyval.node) = (Node *)n;
				}
#line 24690 "gram.c" /* yacc.c:1646  */
    break;

  case 289:
#line 2029 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 24703 "gram.c" /* yacc.c:1646  */
    break;

  case 290:
#line 2039 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = FALSE;
					(yyval.node) = (Node *)n;
				}
#line 24716 "gram.c" /* yacc.c:1646  */
    break;

  case 291:
#line 2052 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					ColumnDef *def = makeNode(ColumnDef);
					n->subtype = AT_AlterColumnType;
					n->name = (yyvsp[-5].str);
					n->def = (Node *) def;
					/* We only use these fields of the ColumnDef node */
					def->typeName = (yyvsp[-2].typnam);
					def->collClause = (CollateClause *) (yyvsp[-1].node);
					def->raw_default = (yyvsp[0].node);
					def->location = (yylsp[-5]);
					(yyval.node) = (Node *)n;
				}
#line 24734 "gram.c" /* yacc.c:1646  */
    break;

  case 292:
#line 2067 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AlterColumnGenericOptions;
					n->name = (yyvsp[-1].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 24746 "gram.c" /* yacc.c:1646  */
    break;

  case 293:
#line 2076 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddConstraint;
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 24757 "gram.c" /* yacc.c:1646  */
    break;

  case 294:
#line 2084 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					Constraint *c = makeNode(Constraint);
					n->subtype = AT_AlterConstraint;
					n->def = (Node *) c;
					c->contype = CONSTR_FOREIGN; /* others not supported, yet */
					c->conname = (yyvsp[-1].str);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "ALTER CONSTRAINT statement",
									&c->deferrable,
									&c->initdeferred,
									NULL, NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 24775 "gram.c" /* yacc.c:1646  */
    break;

  case 295:
#line 2099 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ValidateConstraint;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 24786 "gram.c" /* yacc.c:1646  */
    break;

  case 296:
#line 2107 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropConstraint;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 24799 "gram.c" /* yacc.c:1646  */
    break;

  case 297:
#line 2117 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropConstraint;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = FALSE;
					(yyval.node) = (Node *)n;
				}
#line 24812 "gram.c" /* yacc.c:1646  */
    break;

  case 298:
#line 2127 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddOids;
					(yyval.node) = (Node *)n;
				}
#line 24822 "gram.c" /* yacc.c:1646  */
    break;

  case 299:
#line 2134 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropOids;
					(yyval.node) = (Node *)n;
				}
#line 24832 "gram.c" /* yacc.c:1646  */
    break;

  case 300:
#line 2141 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ClusterOn;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 24843 "gram.c" /* yacc.c:1646  */
    break;

  case 301:
#line 2149 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropCluster;
					n->name = NULL;
					(yyval.node) = (Node *)n;
				}
#line 24854 "gram.c" /* yacc.c:1646  */
    break;

  case 302:
#line 2157 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetLogged;
					(yyval.node) = (Node *)n;
				}
#line 24864 "gram.c" /* yacc.c:1646  */
    break;

  case 303:
#line 2164 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetUnLogged;
					(yyval.node) = (Node *)n;
				}
#line 24874 "gram.c" /* yacc.c:1646  */
    break;

  case 304:
#line 2171 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 24885 "gram.c" /* yacc.c:1646  */
    break;

  case 305:
#line 2179 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableAlwaysTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 24896 "gram.c" /* yacc.c:1646  */
    break;

  case 306:
#line 2187 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableReplicaTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 24907 "gram.c" /* yacc.c:1646  */
    break;

  case 307:
#line 2195 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrigAll;
					(yyval.node) = (Node *)n;
				}
#line 24917 "gram.c" /* yacc.c:1646  */
    break;

  case 308:
#line 2202 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrigUser;
					(yyval.node) = (Node *)n;
				}
#line 24927 "gram.c" /* yacc.c:1646  */
    break;

  case 309:
#line 2209 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 24938 "gram.c" /* yacc.c:1646  */
    break;

  case 310:
#line 2217 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrigAll;
					(yyval.node) = (Node *)n;
				}
#line 24948 "gram.c" /* yacc.c:1646  */
    break;

  case 311:
#line 2224 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrigUser;
					(yyval.node) = (Node *)n;
				}
#line 24958 "gram.c" /* yacc.c:1646  */
    break;

  case 312:
#line 2231 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 24969 "gram.c" /* yacc.c:1646  */
    break;

  case 313:
#line 2239 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableAlwaysRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 24980 "gram.c" /* yacc.c:1646  */
    break;

  case 314:
#line 2247 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableReplicaRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 24991 "gram.c" /* yacc.c:1646  */
    break;

  case 315:
#line 2255 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 25002 "gram.c" /* yacc.c:1646  */
    break;

  case 316:
#line 2263 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddInherit;
					n->def = (Node *) (yyvsp[0].range);
					(yyval.node) = (Node *)n;
				}
#line 25013 "gram.c" /* yacc.c:1646  */
    break;

  case 317:
#line 2271 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropInherit;
					n->def = (Node *) (yyvsp[0].range);
					(yyval.node) = (Node *)n;
				}
#line 25024 "gram.c" /* yacc.c:1646  */
    break;

  case 318:
#line 2279 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					TypeName *def = makeTypeNameFromNameList((yyvsp[0].list));
					def->location = (yylsp[0]);
					n->subtype = AT_AddOf;
					n->def = (Node *) def;
					(yyval.node) = (Node *)n;
				}
#line 25037 "gram.c" /* yacc.c:1646  */
    break;

  case 319:
#line 2289 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropOf;
					(yyval.node) = (Node *)n;
				}
#line 25047 "gram.c" /* yacc.c:1646  */
    break;

  case 320:
#line 2296 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ChangeOwner;
					n->newowner = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 25058 "gram.c" /* yacc.c:1646  */
    break;

  case 321:
#line 2304 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetTableSpace;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 25069 "gram.c" /* yacc.c:1646  */
    break;

  case 322:
#line 2312 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetRelOptions;
					n->def = (Node *)(yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 25080 "gram.c" /* yacc.c:1646  */
    break;

  case 323:
#line 2320 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ResetRelOptions;
					n->def = (Node *)(yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 25091 "gram.c" /* yacc.c:1646  */
    break;

  case 324:
#line 2328 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ReplicaIdentity;
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 25102 "gram.c" /* yacc.c:1646  */
    break;

  case 325:
#line 2336 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableRowSecurity;
					(yyval.node) = (Node *)n;
				}
#line 25112 "gram.c" /* yacc.c:1646  */
    break;

  case 326:
#line 2343 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableRowSecurity;
					(yyval.node) = (Node *)n;
				}
#line 25122 "gram.c" /* yacc.c:1646  */
    break;

  case 327:
#line 2350 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ForceRowSecurity;
					(yyval.node) = (Node *)n;
				}
#line 25132 "gram.c" /* yacc.c:1646  */
    break;

  case 328:
#line 2357 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_NoForceRowSecurity;
					(yyval.node) = (Node *)n;
				}
#line 25142 "gram.c" /* yacc.c:1646  */
    break;

  case 329:
#line 2363 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_GenericOptions;
					n->def = (Node *)(yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 25153 "gram.c" /* yacc.c:1646  */
    break;

  case 330:
#line 2372 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 25159 "gram.c" /* yacc.c:1646  */
    break;

  case 331:
#line 2373 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 25165 "gram.c" /* yacc.c:1646  */
    break;

  case 332:
#line 2377 "gram.y" /* yacc.c:1646  */
    { (yyval.dbehavior) = DROP_CASCADE; }
#line 25171 "gram.c" /* yacc.c:1646  */
    break;

  case 333:
#line 2378 "gram.y" /* yacc.c:1646  */
    { (yyval.dbehavior) = DROP_RESTRICT; }
#line 25177 "gram.c" /* yacc.c:1646  */
    break;

  case 334:
#line 2379 "gram.y" /* yacc.c:1646  */
    { (yyval.dbehavior) = DROP_RESTRICT; /* default */ }
#line 25183 "gram.c" /* yacc.c:1646  */
    break;

  case 335:
#line 2384 "gram.y" /* yacc.c:1646  */
    {
					CollateClause *n = makeNode(CollateClause);
					n->arg = NULL;
					n->collname = (yyvsp[0].list);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 25195 "gram.c" /* yacc.c:1646  */
    break;

  case 336:
#line 2391 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 25201 "gram.c" /* yacc.c:1646  */
    break;

  case 337:
#line 2395 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 25207 "gram.c" /* yacc.c:1646  */
    break;

  case 338:
#line 2396 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 25213 "gram.c" /* yacc.c:1646  */
    break;

  case 339:
#line 2401 "gram.y" /* yacc.c:1646  */
    {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);
					n->identity_type = REPLICA_IDENTITY_NOTHING;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
#line 25224 "gram.c" /* yacc.c:1646  */
    break;

  case 340:
#line 2408 "gram.y" /* yacc.c:1646  */
    {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);
					n->identity_type = REPLICA_IDENTITY_FULL;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
#line 25235 "gram.c" /* yacc.c:1646  */
    break;

  case 341:
#line 2415 "gram.y" /* yacc.c:1646  */
    {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);
					n->identity_type = REPLICA_IDENTITY_DEFAULT;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
#line 25246 "gram.c" /* yacc.c:1646  */
    break;

  case 342:
#line 2422 "gram.y" /* yacc.c:1646  */
    {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);
					n->identity_type = REPLICA_IDENTITY_INDEX;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 25257 "gram.c" /* yacc.c:1646  */
    break;

  case 343:
#line 2431 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 25263 "gram.c" /* yacc.c:1646  */
    break;

  case 344:
#line 2434 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 25269 "gram.c" /* yacc.c:1646  */
    break;

  case 345:
#line 2435 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 25275 "gram.c" /* yacc.c:1646  */
    break;

  case 346:
#line 2439 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 25281 "gram.c" /* yacc.c:1646  */
    break;

  case 347:
#line 2440 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 25287 "gram.c" /* yacc.c:1646  */
    break;

  case 348:
#line 2446 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) (yyvsp[0].node));
				}
#line 25295 "gram.c" /* yacc.c:1646  */
    break;

  case 349:
#line 2450 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[0].str), NULL);
				}
#line 25303 "gram.c" /* yacc.c:1646  */
    break;

  case 350:
#line 2454 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElemExtended((yyvsp[-4].str), (yyvsp[-2].str), (Node *) (yyvsp[0].node),
											 DEFELEM_UNSPEC);
				}
#line 25312 "gram.c" /* yacc.c:1646  */
    break;

  case 351:
#line 2459 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElemExtended((yyvsp[-2].str), (yyvsp[0].str), NULL, DEFELEM_UNSPEC);
				}
#line 25320 "gram.c" /* yacc.c:1646  */
    break;

  case 352:
#line 2474 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					/* can't use qualified_name, sigh */
					n->relation = makeRangeVarFromAnyName((yyvsp[-1].list), (yylsp[-1]), yyscanner);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_TYPE;
					(yyval.node) = (Node *)n;
				}
#line 25334 "gram.c" /* yacc.c:1646  */
    break;

  case 353:
#line 2486 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 25340 "gram.c" /* yacc.c:1646  */
    break;

  case 354:
#line 2487 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 25346 "gram.c" /* yacc.c:1646  */
    break;

  case 355:
#line 2493 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[-1].node);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 25358 "gram.c" /* yacc.c:1646  */
    break;

  case 356:
#line 2502 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 25371 "gram.c" /* yacc.c:1646  */
    break;

  case 357:
#line 2512 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = FALSE;
					(yyval.node) = (Node *)n;
				}
#line 25384 "gram.c" /* yacc.c:1646  */
    break;

  case 358:
#line 2522 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					ColumnDef *def = makeNode(ColumnDef);
					n->subtype = AT_AlterColumnType;
					n->name = (yyvsp[-5].str);
					n->def = (Node *) def;
					n->behavior = (yyvsp[0].dbehavior);
					/* We only use these fields of the ColumnDef node */
					def->typeName = (yyvsp[-2].typnam);
					def->collClause = (CollateClause *) (yyvsp[-1].node);
					def->raw_default = NULL;
					def->location = (yylsp[-5]);
					(yyval.node) = (Node *)n;
				}
#line 25403 "gram.c" /* yacc.c:1646  */
    break;

  case 359:
#line 2548 "gram.y" /* yacc.c:1646  */
    {
					ClosePortalStmt *n = makeNode(ClosePortalStmt);
					n->portalname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 25413 "gram.c" /* yacc.c:1646  */
    break;

  case 360:
#line 2554 "gram.y" /* yacc.c:1646  */
    {
					ClosePortalStmt *n = makeNode(ClosePortalStmt);
					n->portalname = NULL;
					(yyval.node) = (Node *)n;
				}
#line 25423 "gram.c" /* yacc.c:1646  */
    break;

  case 361:
#line 2588 "gram.y" /* yacc.c:1646  */
    {
					CopyStmt *n = makeNode(CopyStmt);
					n->relation = (yyvsp[-8].range);
					n->query = NULL;
					n->attlist = (yyvsp[-7].list);
					n->is_from = (yyvsp[-5].boolean);
					n->is_program = (yyvsp[-4].boolean);
					n->filename = (yyvsp[-3].str);

					if (n->is_program && n->filename == NULL)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("STDIN/STDOUT not allowed with PROGRAM"),
								 parser_errposition((yylsp[-3]))));

					n->options = NIL;
					/* Concatenate user-supplied flags */
					if ((yyvsp[-9].defelt))
						n->options = lappend(n->options, (yyvsp[-9].defelt));
					if ((yyvsp[-6].defelt))
						n->options = lappend(n->options, (yyvsp[-6].defelt));
					if ((yyvsp[-2].defelt))
						n->options = lappend(n->options, (yyvsp[-2].defelt));
					if ((yyvsp[0].list))
						n->options = list_concat(n->options, (yyvsp[0].list));
					(yyval.node) = (Node *)n;
				}
#line 25455 "gram.c" /* yacc.c:1646  */
    break;

  case 362:
#line 2616 "gram.y" /* yacc.c:1646  */
    {
					CopyStmt *n = makeNode(CopyStmt);
					n->relation = NULL;
					n->query = (yyvsp[-6].node);
					n->attlist = NIL;
					n->is_from = false;
					n->is_program = (yyvsp[-3].boolean);
					n->filename = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);

					if (n->is_program && n->filename == NULL)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("STDIN/STDOUT not allowed with PROGRAM"),
								 parser_errposition((yylsp[-4]))));

					(yyval.node) = (Node *)n;
				}
#line 25478 "gram.c" /* yacc.c:1646  */
    break;

  case 363:
#line 2637 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 25484 "gram.c" /* yacc.c:1646  */
    break;

  case 364:
#line 2638 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 25490 "gram.c" /* yacc.c:1646  */
    break;

  case 365:
#line 2642 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 25496 "gram.c" /* yacc.c:1646  */
    break;

  case 366:
#line 2643 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 25502 "gram.c" /* yacc.c:1646  */
    break;

  case 367:
#line 2652 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 25508 "gram.c" /* yacc.c:1646  */
    break;

  case 368:
#line 2653 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 25514 "gram.c" /* yacc.c:1646  */
    break;

  case 369:
#line 2654 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 25520 "gram.c" /* yacc.c:1646  */
    break;

  case 370:
#line 2657 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 25526 "gram.c" /* yacc.c:1646  */
    break;

  case 371:
#line 2658 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 25532 "gram.c" /* yacc.c:1646  */
    break;

  case 372:
#line 2663 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 25538 "gram.c" /* yacc.c:1646  */
    break;

  case 373:
#line 2664 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 25544 "gram.c" /* yacc.c:1646  */
    break;

  case 374:
#line 2669 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("format", (Node *)makeString("binary"));
				}
#line 25552 "gram.c" /* yacc.c:1646  */
    break;

  case 375:
#line 2673 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("oids", (Node *)makeInteger(TRUE));
				}
#line 25560 "gram.c" /* yacc.c:1646  */
    break;

  case 376:
#line 2677 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("freeze", (Node *)makeInteger(TRUE));
				}
#line 25568 "gram.c" /* yacc.c:1646  */
    break;

  case 377:
#line 2681 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("delimiter", (Node *)makeString((yyvsp[0].str)));
				}
#line 25576 "gram.c" /* yacc.c:1646  */
    break;

  case 378:
#line 2685 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("null", (Node *)makeString((yyvsp[0].str)));
				}
#line 25584 "gram.c" /* yacc.c:1646  */
    break;

  case 379:
#line 2689 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("format", (Node *)makeString("csv"));
				}
#line 25592 "gram.c" /* yacc.c:1646  */
    break;

  case 380:
#line 2693 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("header", (Node *)makeInteger(TRUE));
				}
#line 25600 "gram.c" /* yacc.c:1646  */
    break;

  case 381:
#line 2697 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("quote", (Node *)makeString((yyvsp[0].str)));
				}
#line 25608 "gram.c" /* yacc.c:1646  */
    break;

  case 382:
#line 2701 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("escape", (Node *)makeString((yyvsp[0].str)));
				}
#line 25616 "gram.c" /* yacc.c:1646  */
    break;

  case 383:
#line 2705 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force_quote", (Node *)(yyvsp[0].list));
				}
#line 25624 "gram.c" /* yacc.c:1646  */
    break;

  case 384:
#line 2709 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force_quote", (Node *)makeNode(A_Star));
				}
#line 25632 "gram.c" /* yacc.c:1646  */
    break;

  case 385:
#line 2713 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force_not_null", (Node *)(yyvsp[0].list));
				}
#line 25640 "gram.c" /* yacc.c:1646  */
    break;

  case 386:
#line 2717 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force_null", (Node *)(yyvsp[0].list));
				}
#line 25648 "gram.c" /* yacc.c:1646  */
    break;

  case 387:
#line 2721 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("encoding", (Node *)makeString((yyvsp[0].str)));
				}
#line 25656 "gram.c" /* yacc.c:1646  */
    break;

  case 388:
#line 2730 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("format", (Node *)makeString("binary"));
				}
#line 25664 "gram.c" /* yacc.c:1646  */
    break;

  case 389:
#line 2733 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = NULL; }
#line 25670 "gram.c" /* yacc.c:1646  */
    break;

  case 390:
#line 2738 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("oids", (Node *)makeInteger(TRUE));
				}
#line 25678 "gram.c" /* yacc.c:1646  */
    break;

  case 391:
#line 2741 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = NULL; }
#line 25684 "gram.c" /* yacc.c:1646  */
    break;

  case 392:
#line 2746 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("delimiter", (Node *)makeString((yyvsp[0].str)));
				}
#line 25692 "gram.c" /* yacc.c:1646  */
    break;

  case 393:
#line 2749 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = NULL; }
#line 25698 "gram.c" /* yacc.c:1646  */
    break;

  case 394:
#line 2753 "gram.y" /* yacc.c:1646  */
    {}
#line 25704 "gram.c" /* yacc.c:1646  */
    break;

  case 395:
#line 2754 "gram.y" /* yacc.c:1646  */
    {}
#line 25710 "gram.c" /* yacc.c:1646  */
    break;

  case 396:
#line 2760 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 25718 "gram.c" /* yacc.c:1646  */
    break;

  case 397:
#line 2764 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 25726 "gram.c" /* yacc.c:1646  */
    break;

  case 398:
#line 2771 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node));
				}
#line 25734 "gram.c" /* yacc.c:1646  */
    break;

  case 399:
#line 2777 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 25740 "gram.c" /* yacc.c:1646  */
    break;

  case 400:
#line 2778 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].value); }
#line 25746 "gram.c" /* yacc.c:1646  */
    break;

  case 401:
#line 2779 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeNode(A_Star); }
#line 25752 "gram.c" /* yacc.c:1646  */
    break;

  case 402:
#line 2780 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[-1].list); }
#line 25758 "gram.c" /* yacc.c:1646  */
    break;

  case 403:
#line 2781 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 25764 "gram.c" /* yacc.c:1646  */
    break;

  case 404:
#line 2786 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 25772 "gram.c" /* yacc.c:1646  */
    break;

  case 405:
#line 2790 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 25780 "gram.c" /* yacc.c:1646  */
    break;

  case 406:
#line 2797 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 25786 "gram.c" /* yacc.c:1646  */
    break;

  case 407:
#line 2810 "gram.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[-7].range)->relpersistence = (yyvsp[-9].ival);
					n->relation = (yyvsp[-7].range);
					n->tableElts = (yyvsp[-5].list);
					n->inhRelations = (yyvsp[-3].list);
					n->ofTypename = NULL;
					n->constraints = NIL;
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
#line 25805 "gram.c" /* yacc.c:1646  */
    break;

  case 408:
#line 2827 "gram.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[-7].range)->relpersistence = (yyvsp[-12].ival);
					n->relation = (yyvsp[-7].range);
					n->tableElts = (yyvsp[-5].list);
					n->inhRelations = (yyvsp[-3].list);
					n->ofTypename = NULL;
					n->constraints = NIL;
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
#line 25824 "gram.c" /* yacc.c:1646  */
    break;

  case 409:
#line 2843 "gram.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[-6].range)->relpersistence = (yyvsp[-8].ival);
					n->relation = (yyvsp[-6].range);
					n->tableElts = (yyvsp[-3].list);
					n->inhRelations = NIL;
					n->ofTypename = makeTypeNameFromNameList((yyvsp[-4].list));
					n->ofTypename->location = (yylsp[-4]);
					n->constraints = NIL;
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
#line 25844 "gram.c" /* yacc.c:1646  */
    break;

  case 410:
#line 2860 "gram.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[-6].range)->relpersistence = (yyvsp[-11].ival);
					n->relation = (yyvsp[-6].range);
					n->tableElts = (yyvsp[-3].list);
					n->inhRelations = NIL;
					n->ofTypename = makeTypeNameFromNameList((yyvsp[-4].list));
					n->ofTypename->location = (yylsp[-4]);
					n->constraints = NIL;
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
#line 25864 "gram.c" /* yacc.c:1646  */
    break;

  case 411:
#line 2888 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 25870 "gram.c" /* yacc.c:1646  */
    break;

  case 412:
#line 2889 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 25876 "gram.c" /* yacc.c:1646  */
    break;

  case 413:
#line 2890 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 25882 "gram.c" /* yacc.c:1646  */
    break;

  case 414:
#line 2891 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 25888 "gram.c" /* yacc.c:1646  */
    break;

  case 415:
#line 2893 "gram.y" /* yacc.c:1646  */
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-1]))));
					(yyval.ival) = RELPERSISTENCE_TEMP;
				}
#line 25899 "gram.c" /* yacc.c:1646  */
    break;

  case 416:
#line 2900 "gram.y" /* yacc.c:1646  */
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-1]))));
					(yyval.ival) = RELPERSISTENCE_TEMP;
				}
#line 25910 "gram.c" /* yacc.c:1646  */
    break;

  case 417:
#line 2906 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_UNLOGGED; }
#line 25916 "gram.c" /* yacc.c:1646  */
    break;

  case 418:
#line 2907 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_PERMANENT; }
#line 25922 "gram.c" /* yacc.c:1646  */
    break;

  case 419:
#line 2911 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 25928 "gram.c" /* yacc.c:1646  */
    break;

  case 420:
#line 2912 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 25934 "gram.c" /* yacc.c:1646  */
    break;

  case 421:
#line 2916 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 25940 "gram.c" /* yacc.c:1646  */
    break;

  case 422:
#line 2917 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 25946 "gram.c" /* yacc.c:1646  */
    break;

  case 423:
#line 2922 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 25954 "gram.c" /* yacc.c:1646  */
    break;

  case 424:
#line 2926 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 25962 "gram.c" /* yacc.c:1646  */
    break;

  case 425:
#line 2933 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 25970 "gram.c" /* yacc.c:1646  */
    break;

  case 426:
#line 2937 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 25978 "gram.c" /* yacc.c:1646  */
    break;

  case 427:
#line 2943 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 25984 "gram.c" /* yacc.c:1646  */
    break;

  case 428:
#line 2944 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 25990 "gram.c" /* yacc.c:1646  */
    break;

  case 429:
#line 2945 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 25996 "gram.c" /* yacc.c:1646  */
    break;

  case 430:
#line 2949 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 26002 "gram.c" /* yacc.c:1646  */
    break;

  case 431:
#line 2950 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 26008 "gram.c" /* yacc.c:1646  */
    break;

  case 432:
#line 2954 "gram.y" /* yacc.c:1646  */
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[-3].str);
					n->typeName = (yyvsp[-2].typnam);
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collOid = InvalidOid;
					n->fdwoptions = (yyvsp[-1].list);
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *)n;
				}
#line 26031 "gram.c" /* yacc.c:1646  */
    break;

  case 433:
#line 2975 "gram.y" /* yacc.c:1646  */
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[-3].str);
					n->typeName = NULL;
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collOid = InvalidOid;
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *)n;
				}
#line 26053 "gram.c" /* yacc.c:1646  */
    break;

  case 434:
#line 2995 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 26059 "gram.c" /* yacc.c:1646  */
    break;

  case 435:
#line 2996 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 26065 "gram.c" /* yacc.c:1646  */
    break;

  case 436:
#line 3001 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = (Constraint *) (yyvsp[0].node);
					Assert(IsA(n, Constraint));
					n->conname = (yyvsp[-1].str);
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 26077 "gram.c" /* yacc.c:1646  */
    break;

  case 437:
#line 3008 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 26083 "gram.c" /* yacc.c:1646  */
    break;

  case 438:
#line 3009 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 26089 "gram.c" /* yacc.c:1646  */
    break;

  case 439:
#line 3011 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Note: the CollateClause is momentarily included in
					 * the list built by ColQualList, but we split it out
					 * again in SplitColQualList.
					 */
					CollateClause *n = makeNode(CollateClause);
					n->arg = NULL;
					n->collname = (yyvsp[0].list);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 26106 "gram.c" /* yacc.c:1646  */
    break;

  case 440:
#line 3042 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_NOTNULL;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 26117 "gram.c" /* yacc.c:1646  */
    break;

  case 441:
#line 3049 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_NULL;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 26128 "gram.c" /* yacc.c:1646  */
    break;

  case 442:
#line 3056 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[-2]);
					n->keys = NULL;
					n->options = (yyvsp[-1].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 26143 "gram.c" /* yacc.c:1646  */
    break;

  case 443:
#line 3067 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[-3]);
					n->keys = NULL;
					n->options = (yyvsp[-1].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 26158 "gram.c" /* yacc.c:1646  */
    break;

  case 444:
#line 3078 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_CHECK;
					n->location = (yylsp[-4]);
					n->is_no_inherit = (yyvsp[0].boolean);
					n->raw_expr = (yyvsp[-2].node);
					n->cooked_expr = NULL;
					n->skip_validation = false;
					n->initially_valid = true;
					(yyval.node) = (Node *)n;
				}
#line 26174 "gram.c" /* yacc.c:1646  */
    break;

  case 445:
#line 3090 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_DEFAULT;
					n->location = (yylsp[-1]);
					n->raw_expr = (yyvsp[0].node);
					n->cooked_expr = NULL;
					(yyval.node) = (Node *)n;
				}
#line 26187 "gram.c" /* yacc.c:1646  */
    break;

  case 446:
#line 3099 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_FOREIGN;
					n->location = (yylsp[-4]);
					n->pktable			= (yyvsp[-3].range);
					n->fk_attrs			= NIL;
					n->pk_attrs			= (yyvsp[-2].list);
					n->fk_matchtype		= (yyvsp[-1].ival);
					n->fk_upd_action	= (char) ((yyvsp[0].ival) >> 8);
					n->fk_del_action	= (char) ((yyvsp[0].ival) & 0xFF);
					n->skip_validation  = false;
					n->initially_valid  = true;
					(yyval.node) = (Node *)n;
				}
#line 26206 "gram.c" /* yacc.c:1646  */
    break;

  case 447:
#line 3132 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_DEFERRABLE;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 26217 "gram.c" /* yacc.c:1646  */
    break;

  case 448:
#line 3139 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_NOT_DEFERRABLE;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 26228 "gram.c" /* yacc.c:1646  */
    break;

  case 449:
#line 3146 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_DEFERRED;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 26239 "gram.c" /* yacc.c:1646  */
    break;

  case 450:
#line 3153 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_IMMEDIATE;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 26250 "gram.c" /* yacc.c:1646  */
    break;

  case 451:
#line 3164 "gram.y" /* yacc.c:1646  */
    {
					TableLikeClause *n = makeNode(TableLikeClause);
					n->relation = (yyvsp[-1].range);
					n->options = (yyvsp[0].ival);
					(yyval.node) = (Node *)n;
				}
#line 26261 "gram.c" /* yacc.c:1646  */
    break;

  case 452:
#line 3173 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-2].ival) | (yyvsp[0].ival); }
#line 26267 "gram.c" /* yacc.c:1646  */
    break;

  case 453:
#line 3174 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-2].ival) & ~(yyvsp[0].ival); }
#line 26273 "gram.c" /* yacc.c:1646  */
    break;

  case 454:
#line 3175 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 26279 "gram.c" /* yacc.c:1646  */
    break;

  case 455:
#line 3179 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_DEFAULTS; }
#line 26285 "gram.c" /* yacc.c:1646  */
    break;

  case 456:
#line 3180 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_CONSTRAINTS; }
#line 26291 "gram.c" /* yacc.c:1646  */
    break;

  case 457:
#line 3181 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_INDEXES; }
#line 26297 "gram.c" /* yacc.c:1646  */
    break;

  case 458:
#line 3182 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_STORAGE; }
#line 26303 "gram.c" /* yacc.c:1646  */
    break;

  case 459:
#line 3183 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_COMMENTS; }
#line 26309 "gram.c" /* yacc.c:1646  */
    break;

  case 460:
#line 3184 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_ALL; }
#line 26315 "gram.c" /* yacc.c:1646  */
    break;

  case 461:
#line 3194 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = (Constraint *) (yyvsp[0].node);
					Assert(IsA(n, Constraint));
					n->conname = (yyvsp[-1].str);
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 26327 "gram.c" /* yacc.c:1646  */
    break;

  case 462:
#line 3201 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 26333 "gram.c" /* yacc.c:1646  */
    break;

  case 463:
#line 3206 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_CHECK;
					n->location = (yylsp[-4]);
					n->raw_expr = (yyvsp[-2].node);
					n->cooked_expr = NULL;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "CHECK",
								   NULL, NULL, &n->skip_validation,
								   &n->is_no_inherit, yyscanner);
					n->initially_valid = !n->skip_validation;
					(yyval.node) = (Node *)n;
				}
#line 26350 "gram.c" /* yacc.c:1646  */
    break;

  case 464:
#line 3220 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[-6]);
					n->keys = (yyvsp[-4].list);
					n->options = (yyvsp[-2].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[-1].str);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "UNIQUE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 26368 "gram.c" /* yacc.c:1646  */
    break;

  case 465:
#line 3234 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[-2]);
					n->keys = NIL;
					n->options = NIL;
					n->indexname = (yyvsp[-1].str);
					n->indexspace = NULL;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "UNIQUE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 26386 "gram.c" /* yacc.c:1646  */
    break;

  case 466:
#line 3249 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[-7]);
					n->keys = (yyvsp[-4].list);
					n->options = (yyvsp[-2].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[-1].str);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "PRIMARY KEY",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 26404 "gram.c" /* yacc.c:1646  */
    break;

  case 467:
#line 3263 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[-3]);
					n->keys = NIL;
					n->options = NIL;
					n->indexname = (yyvsp[-1].str);
					n->indexspace = NULL;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "PRIMARY KEY",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 26422 "gram.c" /* yacc.c:1646  */
    break;

  case 468:
#line 3279 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_EXCLUSION;
					n->location = (yylsp[-8]);
					n->access_method	= (yyvsp[-7].str);
					n->exclusions		= (yyvsp[-5].list);
					n->options			= (yyvsp[-3].list);
					n->indexname		= NULL;
					n->indexspace		= (yyvsp[-2].str);
					n->where_clause		= (yyvsp[-1].node);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "EXCLUDE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 26442 "gram.c" /* yacc.c:1646  */
    break;

  case 469:
#line 3296 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_FOREIGN;
					n->location = (yylsp[-10]);
					n->pktable			= (yyvsp[-4].range);
					n->fk_attrs			= (yyvsp[-7].list);
					n->pk_attrs			= (yyvsp[-3].list);
					n->fk_matchtype		= (yyvsp[-2].ival);
					n->fk_upd_action	= (char) ((yyvsp[-1].ival) >> 8);
					n->fk_del_action	= (char) ((yyvsp[-1].ival) & 0xFF);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "FOREIGN KEY",
								   &n->deferrable, &n->initdeferred,
								   &n->skip_validation, NULL,
								   yyscanner);
					n->initially_valid = !n->skip_validation;
					(yyval.node) = (Node *)n;
				}
#line 26464 "gram.c" /* yacc.c:1646  */
    break;

  case 470:
#line 3315 "gram.y" /* yacc.c:1646  */
    {  (yyval.boolean) = TRUE; }
#line 26470 "gram.c" /* yacc.c:1646  */
    break;

  case 471:
#line 3316 "gram.y" /* yacc.c:1646  */
    {  (yyval.boolean) = FALSE; }
#line 26476 "gram.c" /* yacc.c:1646  */
    break;

  case 472:
#line 3320 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 26482 "gram.c" /* yacc.c:1646  */
    break;

  case 473:
#line 3321 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 26488 "gram.c" /* yacc.c:1646  */
    break;

  case 474:
#line 3325 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 26494 "gram.c" /* yacc.c:1646  */
    break;

  case 475:
#line 3326 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 26500 "gram.c" /* yacc.c:1646  */
    break;

  case 476:
#line 3330 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeString((yyvsp[0].str));
				}
#line 26508 "gram.c" /* yacc.c:1646  */
    break;

  case 477:
#line 3336 "gram.y" /* yacc.c:1646  */
    {
				(yyval.ival) = FKCONSTR_MATCH_FULL;
			}
#line 26516 "gram.c" /* yacc.c:1646  */
    break;

  case 478:
#line 3340 "gram.y" /* yacc.c:1646  */
    {
				ereport(ERROR,
						(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
						 errmsg("MATCH PARTIAL not yet implemented"),
						 parser_errposition((yylsp[-1]))));
				(yyval.ival) = FKCONSTR_MATCH_PARTIAL;
			}
#line 26528 "gram.c" /* yacc.c:1646  */
    break;

  case 479:
#line 3348 "gram.y" /* yacc.c:1646  */
    {
				(yyval.ival) = FKCONSTR_MATCH_SIMPLE;
			}
#line 26536 "gram.c" /* yacc.c:1646  */
    break;

  case 480:
#line 3352 "gram.y" /* yacc.c:1646  */
    {
				(yyval.ival) = FKCONSTR_MATCH_SIMPLE;
			}
#line 26544 "gram.c" /* yacc.c:1646  */
    break;

  case 481:
#line 3358 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].list)); }
#line 26550 "gram.c" /* yacc.c:1646  */
    break;

  case 482:
#line 3360 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].list)); }
#line 26556 "gram.c" /* yacc.c:1646  */
    break;

  case 483:
#line 3364 "gram.y" /* yacc.c:1646  */
    {
				(yyval.list) = list_make2((yyvsp[-2].ielem), (yyvsp[0].list));
			}
#line 26564 "gram.c" /* yacc.c:1646  */
    break;

  case 484:
#line 3369 "gram.y" /* yacc.c:1646  */
    {
				(yyval.list) = list_make2((yyvsp[-5].ielem), (yyvsp[-1].list));
			}
#line 26572 "gram.c" /* yacc.c:1646  */
    break;

  case 485:
#line 3375 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 26578 "gram.c" /* yacc.c:1646  */
    break;

  case 486:
#line 3376 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 26584 "gram.c" /* yacc.c:1646  */
    break;

  case 487:
#line 3387 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ((yyvsp[0].ival) << 8) | (FKCONSTR_ACTION_NOACTION & 0xFF); }
#line 26590 "gram.c" /* yacc.c:1646  */
    break;

  case 488:
#line 3389 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (FKCONSTR_ACTION_NOACTION << 8) | ((yyvsp[0].ival) & 0xFF); }
#line 26596 "gram.c" /* yacc.c:1646  */
    break;

  case 489:
#line 3391 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ((yyvsp[-1].ival) << 8) | ((yyvsp[0].ival) & 0xFF); }
#line 26602 "gram.c" /* yacc.c:1646  */
    break;

  case 490:
#line 3393 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ((yyvsp[0].ival) << 8) | ((yyvsp[-1].ival) & 0xFF); }
#line 26608 "gram.c" /* yacc.c:1646  */
    break;

  case 491:
#line 3395 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (FKCONSTR_ACTION_NOACTION << 8) | (FKCONSTR_ACTION_NOACTION & 0xFF); }
#line 26614 "gram.c" /* yacc.c:1646  */
    break;

  case 492:
#line 3398 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[0].ival); }
#line 26620 "gram.c" /* yacc.c:1646  */
    break;

  case 493:
#line 3401 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[0].ival); }
#line 26626 "gram.c" /* yacc.c:1646  */
    break;

  case 494:
#line 3405 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FKCONSTR_ACTION_NOACTION; }
#line 26632 "gram.c" /* yacc.c:1646  */
    break;

  case 495:
#line 3406 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FKCONSTR_ACTION_RESTRICT; }
#line 26638 "gram.c" /* yacc.c:1646  */
    break;

  case 496:
#line 3407 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FKCONSTR_ACTION_CASCADE; }
#line 26644 "gram.c" /* yacc.c:1646  */
    break;

  case 497:
#line 3408 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FKCONSTR_ACTION_SETNULL; }
#line 26650 "gram.c" /* yacc.c:1646  */
    break;

  case 498:
#line 3409 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FKCONSTR_ACTION_SETDEFAULT; }
#line 26656 "gram.c" /* yacc.c:1646  */
    break;

  case 499:
#line 3412 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 26662 "gram.c" /* yacc.c:1646  */
    break;

  case 500:
#line 3413 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 26668 "gram.c" /* yacc.c:1646  */
    break;

  case 501:
#line 3418 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 26674 "gram.c" /* yacc.c:1646  */
    break;

  case 502:
#line 3419 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(defWithOids(true)); }
#line 26680 "gram.c" /* yacc.c:1646  */
    break;

  case 503:
#line 3420 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(defWithOids(false)); }
#line 26686 "gram.c" /* yacc.c:1646  */
    break;

  case 504:
#line 3421 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 26692 "gram.c" /* yacc.c:1646  */
    break;

  case 505:
#line 3424 "gram.y" /* yacc.c:1646  */
    { (yyval.oncommit) = ONCOMMIT_DROP; }
#line 26698 "gram.c" /* yacc.c:1646  */
    break;

  case 506:
#line 3425 "gram.y" /* yacc.c:1646  */
    { (yyval.oncommit) = ONCOMMIT_DELETE_ROWS; }
#line 26704 "gram.c" /* yacc.c:1646  */
    break;

  case 507:
#line 3426 "gram.y" /* yacc.c:1646  */
    { (yyval.oncommit) = ONCOMMIT_PRESERVE_ROWS; }
#line 26710 "gram.c" /* yacc.c:1646  */
    break;

  case 508:
#line 3427 "gram.y" /* yacc.c:1646  */
    { (yyval.oncommit) = ONCOMMIT_NOOP; }
#line 26716 "gram.c" /* yacc.c:1646  */
    break;

  case 509:
#line 3430 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 26722 "gram.c" /* yacc.c:1646  */
    break;

  case 510:
#line 3431 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 26728 "gram.c" /* yacc.c:1646  */
    break;

  case 511:
#line 3434 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 26734 "gram.c" /* yacc.c:1646  */
    break;

  case 512:
#line 3435 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 26740 "gram.c" /* yacc.c:1646  */
    break;

  case 513:
#line 3438 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 26746 "gram.c" /* yacc.c:1646  */
    break;

  case 514:
#line 3454 "gram.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ctas->query = (yyvsp[-1].node);
					ctas->into = (yyvsp[-3].into);
					ctas->relkind = OBJECT_TABLE;
					ctas->is_select_into = false;
					ctas->if_not_exists = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[-3].into)->rel->relpersistence = (yyvsp[-5].ival);
					(yyvsp[-3].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 26763 "gram.c" /* yacc.c:1646  */
    break;

  case 515:
#line 3467 "gram.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ctas->query = (yyvsp[-1].node);
					ctas->into = (yyvsp[-3].into);
					ctas->relkind = OBJECT_TABLE;
					ctas->is_select_into = false;
					ctas->if_not_exists = true;
					/* cram additional flags into the IntoClause */
					(yyvsp[-3].into)->rel->relpersistence = (yyvsp[-8].ival);
					(yyvsp[-3].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 26780 "gram.c" /* yacc.c:1646  */
    break;

  case 516:
#line 3483 "gram.y" /* yacc.c:1646  */
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[-4].range);
					(yyval.into)->colNames = (yyvsp[-3].list);
					(yyval.into)->options = (yyvsp[-2].list);
					(yyval.into)->onCommit = (yyvsp[-1].oncommit);
					(yyval.into)->tableSpaceName = (yyvsp[0].str);
					(yyval.into)->viewQuery = NULL;
					(yyval.into)->skipData = false;		/* might get changed later */
				}
#line 26795 "gram.c" /* yacc.c:1646  */
    break;

  case 517:
#line 3496 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 26801 "gram.c" /* yacc.c:1646  */
    break;

  case 518:
#line 3497 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 26807 "gram.c" /* yacc.c:1646  */
    break;

  case 519:
#line 3498 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 26813 "gram.c" /* yacc.c:1646  */
    break;

  case 520:
#line 3511 "gram.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ctas->query = (yyvsp[-1].node);
					ctas->into = (yyvsp[-3].into);
					ctas->relkind = OBJECT_MATVIEW;
					ctas->is_select_into = false;
					ctas->if_not_exists = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[-3].into)->rel->relpersistence = (yyvsp[-6].ival);
					(yyvsp[-3].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 26830 "gram.c" /* yacc.c:1646  */
    break;

  case 521:
#line 3524 "gram.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ctas->query = (yyvsp[-1].node);
					ctas->into = (yyvsp[-3].into);
					ctas->relkind = OBJECT_MATVIEW;
					ctas->is_select_into = false;
					ctas->if_not_exists = true;
					/* cram additional flags into the IntoClause */
					(yyvsp[-3].into)->rel->relpersistence = (yyvsp[-9].ival);
					(yyvsp[-3].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 26847 "gram.c" /* yacc.c:1646  */
    break;

  case 522:
#line 3540 "gram.y" /* yacc.c:1646  */
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[-3].range);
					(yyval.into)->colNames = (yyvsp[-2].list);
					(yyval.into)->options = (yyvsp[-1].list);
					(yyval.into)->onCommit = ONCOMMIT_NOOP;
					(yyval.into)->tableSpaceName = (yyvsp[0].str);
					(yyval.into)->viewQuery = NULL;		/* filled at analysis time */
					(yyval.into)->skipData = false;		/* might get changed later */
				}
#line 26862 "gram.c" /* yacc.c:1646  */
    break;

  case 523:
#line 3552 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_UNLOGGED; }
#line 26868 "gram.c" /* yacc.c:1646  */
    break;

  case 524:
#line 3553 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_PERMANENT; }
#line 26874 "gram.c" /* yacc.c:1646  */
    break;

  case 525:
#line 3566 "gram.y" /* yacc.c:1646  */
    {
					RefreshMatViewStmt *n = makeNode(RefreshMatViewStmt);
					n->concurrent = (yyvsp[-2].boolean);
					n->relation = (yyvsp[-1].range);
					n->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) n;
				}
#line 26886 "gram.c" /* yacc.c:1646  */
    break;

  case 526:
#line 3586 "gram.y" /* yacc.c:1646  */
    {
					CreateSeqStmt *n = makeNode(CreateSeqStmt);
					(yyvsp[-1].range)->relpersistence = (yyvsp[-3].ival);
					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->ownerId = InvalidOid;
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
#line 26900 "gram.c" /* yacc.c:1646  */
    break;

  case 527:
#line 3596 "gram.y" /* yacc.c:1646  */
    {
					CreateSeqStmt *n = makeNode(CreateSeqStmt);
					(yyvsp[-1].range)->relpersistence = (yyvsp[-6].ival);
					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->ownerId = InvalidOid;
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
#line 26914 "gram.c" /* yacc.c:1646  */
    break;

  case 528:
#line 3609 "gram.y" /* yacc.c:1646  */
    {
					AlterSeqStmt *n = makeNode(AlterSeqStmt);
					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 26926 "gram.c" /* yacc.c:1646  */
    break;

  case 529:
#line 3617 "gram.y" /* yacc.c:1646  */
    {
					AlterSeqStmt *n = makeNode(AlterSeqStmt);
					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 26938 "gram.c" /* yacc.c:1646  */
    break;

  case 530:
#line 3627 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 26944 "gram.c" /* yacc.c:1646  */
    break;

  case 531:
#line 3628 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 26950 "gram.c" /* yacc.c:1646  */
    break;

  case 532:
#line 3631 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 26956 "gram.c" /* yacc.c:1646  */
    break;

  case 533:
#line 3632 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 26962 "gram.c" /* yacc.c:1646  */
    break;

  case 534:
#line 3636 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cache", (Node *)(yyvsp[0].value));
				}
#line 26970 "gram.c" /* yacc.c:1646  */
    break;

  case 535:
#line 3640 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cycle", (Node *)makeInteger(TRUE));
				}
#line 26978 "gram.c" /* yacc.c:1646  */
    break;

  case 536:
#line 3644 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cycle", (Node *)makeInteger(FALSE));
				}
#line 26986 "gram.c" /* yacc.c:1646  */
    break;

  case 537:
#line 3648 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("increment", (Node *)(yyvsp[0].value));
				}
#line 26994 "gram.c" /* yacc.c:1646  */
    break;

  case 538:
#line 3652 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("maxvalue", (Node *)(yyvsp[0].value));
				}
#line 27002 "gram.c" /* yacc.c:1646  */
    break;

  case 539:
#line 3656 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("minvalue", (Node *)(yyvsp[0].value));
				}
#line 27010 "gram.c" /* yacc.c:1646  */
    break;

  case 540:
#line 3660 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("maxvalue", NULL);
				}
#line 27018 "gram.c" /* yacc.c:1646  */
    break;

  case 541:
#line 3664 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("minvalue", NULL);
				}
#line 27026 "gram.c" /* yacc.c:1646  */
    break;

  case 542:
#line 3668 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("owned_by", (Node *)(yyvsp[0].list));
				}
#line 27034 "gram.c" /* yacc.c:1646  */
    break;

  case 543:
#line 3672 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("start", (Node *)(yyvsp[0].value));
				}
#line 27042 "gram.c" /* yacc.c:1646  */
    break;

  case 544:
#line 3676 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("restart", NULL);
				}
#line 27050 "gram.c" /* yacc.c:1646  */
    break;

  case 545:
#line 3680 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("restart", (Node *)(yyvsp[0].value));
				}
#line 27058 "gram.c" /* yacc.c:1646  */
    break;

  case 546:
#line 3685 "gram.y" /* yacc.c:1646  */
    {}
#line 27064 "gram.c" /* yacc.c:1646  */
    break;

  case 547:
#line 3686 "gram.y" /* yacc.c:1646  */
    {}
#line 27070 "gram.c" /* yacc.c:1646  */
    break;

  case 548:
#line 3690 "gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeFloat((yyvsp[0].str)); }
#line 27076 "gram.c" /* yacc.c:1646  */
    break;

  case 549:
#line 3692 "gram.y" /* yacc.c:1646  */
    {
					(yyval.value) = makeFloat((yyvsp[0].str));
					doNegateFloat((yyval.value));
				}
#line 27085 "gram.c" /* yacc.c:1646  */
    break;

  case 550:
#line 3696 "gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeInteger((yyvsp[0].ival)); }
#line 27091 "gram.c" /* yacc.c:1646  */
    break;

  case 551:
#line 3699 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].value)); }
#line 27097 "gram.c" /* yacc.c:1646  */
    break;

  case 552:
#line 3700 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].value)); }
#line 27103 "gram.c" /* yacc.c:1646  */
    break;

  case 553:
#line 3713 "gram.y" /* yacc.c:1646  */
    {
				CreatePLangStmt *n = makeNode(CreatePLangStmt);
				n->replace = (yyvsp[-4].boolean);
				n->plname = (yyvsp[0].str);
				/* parameters are all to be supplied by system */
				n->plhandler = NIL;
				n->plinline = NIL;
				n->plvalidator = NIL;
				n->pltrusted = false;
				(yyval.node) = (Node *)n;
			}
#line 27119 "gram.c" /* yacc.c:1646  */
    break;

  case 554:
#line 3726 "gram.y" /* yacc.c:1646  */
    {
				CreatePLangStmt *n = makeNode(CreatePLangStmt);
				n->replace = (yyvsp[-8].boolean);
				n->plname = (yyvsp[-4].str);
				n->plhandler = (yyvsp[-2].list);
				n->plinline = (yyvsp[-1].list);
				n->plvalidator = (yyvsp[0].list);
				n->pltrusted = (yyvsp[-7].boolean);
				(yyval.node) = (Node *)n;
			}
#line 27134 "gram.c" /* yacc.c:1646  */
    break;

  case 555:
#line 3739 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 27140 "gram.c" /* yacc.c:1646  */
    break;

  case 556:
#line 3740 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 27146 "gram.c" /* yacc.c:1646  */
    break;

  case 557:
#line 3748 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 27152 "gram.c" /* yacc.c:1646  */
    break;

  case 558:
#line 3749 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)); }
#line 27158 "gram.c" /* yacc.c:1646  */
    break;

  case 559:
#line 3753 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 27164 "gram.c" /* yacc.c:1646  */
    break;

  case 560:
#line 3754 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 27170 "gram.c" /* yacc.c:1646  */
    break;

  case 561:
#line 3758 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 27176 "gram.c" /* yacc.c:1646  */
    break;

  case 562:
#line 3759 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 27182 "gram.c" /* yacc.c:1646  */
    break;

  case 563:
#line 3763 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 27188 "gram.c" /* yacc.c:1646  */
    break;

  case 564:
#line 3764 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 27194 "gram.c" /* yacc.c:1646  */
    break;

  case 565:
#line 3769 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_LANGUAGE;
					n->objects = list_make1(list_make1(makeString((yyvsp[-1].str))));
					n->arguments = NIL;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 27209 "gram.c" /* yacc.c:1646  */
    break;

  case 566:
#line 3780 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_LANGUAGE;
					n->objects = list_make1(list_make1(makeString((yyvsp[-1].str))));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 27223 "gram.c" /* yacc.c:1646  */
    break;

  case 567:
#line 3792 "gram.y" /* yacc.c:1646  */
    {}
#line 27229 "gram.c" /* yacc.c:1646  */
    break;

  case 568:
#line 3793 "gram.y" /* yacc.c:1646  */
    {}
#line 27235 "gram.c" /* yacc.c:1646  */
    break;

  case 569:
#line 3804 "gram.y" /* yacc.c:1646  */
    {
					CreateTableSpaceStmt *n = makeNode(CreateTableSpaceStmt);
					n->tablespacename = (yyvsp[-4].str);
					n->owner = (yyvsp[-3].node);
					n->location = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 27248 "gram.c" /* yacc.c:1646  */
    break;

  case 570:
#line 3814 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 27254 "gram.c" /* yacc.c:1646  */
    break;

  case 571:
#line 3815 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 27260 "gram.c" /* yacc.c:1646  */
    break;

  case 572:
#line 3829 "gram.y" /* yacc.c:1646  */
    {
					DropTableSpaceStmt *n = makeNode(DropTableSpaceStmt);
					n->tablespacename = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 27271 "gram.c" /* yacc.c:1646  */
    break;

  case 573:
#line 3836 "gram.y" /* yacc.c:1646  */
    {
					DropTableSpaceStmt *n = makeNode(DropTableSpaceStmt);
					n->tablespacename = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 27282 "gram.c" /* yacc.c:1646  */
    break;

  case 574:
#line 3853 "gram.y" /* yacc.c:1646  */
    {
					CreateExtensionStmt *n = makeNode(CreateExtensionStmt);
					n->extname = (yyvsp[-2].str);
					n->if_not_exists = false;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 27294 "gram.c" /* yacc.c:1646  */
    break;

  case 575:
#line 3861 "gram.y" /* yacc.c:1646  */
    {
					CreateExtensionStmt *n = makeNode(CreateExtensionStmt);
					n->extname = (yyvsp[-2].str);
					n->if_not_exists = true;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 27306 "gram.c" /* yacc.c:1646  */
    break;

  case 576:
#line 3872 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 27312 "gram.c" /* yacc.c:1646  */
    break;

  case 577:
#line 3874 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 27318 "gram.c" /* yacc.c:1646  */
    break;

  case 578:
#line 3879 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("schema", (Node *)makeString((yyvsp[0].str)));
				}
#line 27326 "gram.c" /* yacc.c:1646  */
    break;

  case 579:
#line 3883 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("new_version", (Node *)makeString((yyvsp[0].str)));
				}
#line 27334 "gram.c" /* yacc.c:1646  */
    break;

  case 580:
#line 3887 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("old_version", (Node *)makeString((yyvsp[0].str)));
				}
#line 27342 "gram.c" /* yacc.c:1646  */
    break;

  case 581:
#line 3891 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cascade", (Node *)makeInteger(TRUE));
				}
#line 27350 "gram.c" /* yacc.c:1646  */
    break;

  case 582:
#line 3903 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionStmt *n = makeNode(AlterExtensionStmt);
					n->extname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 27361 "gram.c" /* yacc.c:1646  */
    break;

  case 583:
#line 3913 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 27367 "gram.c" /* yacc.c:1646  */
    break;

  case 584:
#line 3915 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 27373 "gram.c" /* yacc.c:1646  */
    break;

  case 585:
#line 3920 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("new_version", (Node *)makeString((yyvsp[0].str)));
				}
#line 27381 "gram.c" /* yacc.c:1646  */
    break;

  case 586:
#line 3933 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-4].str);
					n->action = (yyvsp[-3].ival);
					n->objtype = OBJECT_ACCESS_METHOD;
					n->objname = list_make1(makeString((yyvsp[0].str)));
					(yyval.node) = (Node *)n;
				}
#line 27394 "gram.c" /* yacc.c:1646  */
    break;

  case 587:
#line 3942 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-4].str);
					n->action = (yyvsp[-3].ival);
					n->objtype = OBJECT_AGGREGATE;
					n->objname = (yyvsp[-1].list);
					n->objargs = extractAggrArgTypes((yyvsp[0].list));
					(yyval.node) = (Node *)n;
				}
#line 27408 "gram.c" /* yacc.c:1646  */
    break;

  case 588:
#line 3952 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-7].str);
					n->action = (yyvsp[-6].ival);
					n->objtype = OBJECT_CAST;
					n->objname = list_make1((yyvsp[-3].typnam));
					n->objargs = list_make1((yyvsp[-1].typnam));
					(yyval.node) = (Node *) n;
				}
#line 27422 "gram.c" /* yacc.c:1646  */
    break;

  case 589:
#line 3962 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_COLLATION;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 27435 "gram.c" /* yacc.c:1646  */
    break;

  case 590:
#line 3971 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_CONVERSION;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 27448 "gram.c" /* yacc.c:1646  */
    break;

  case 591:
#line 3980 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_DOMAIN;
					n->objname = list_make1((yyvsp[0].typnam));
					(yyval.node) = (Node *)n;
				}
#line 27461 "gram.c" /* yacc.c:1646  */
    break;

  case 592:
#line 3989 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_FUNCTION;
					n->objname = (yyvsp[0].funwithargs)->funcname;
					n->objargs = (yyvsp[0].funwithargs)->funcargs;
					(yyval.node) = (Node *)n;
				}
#line 27475 "gram.c" /* yacc.c:1646  */
    break;

  case 593:
#line 3999 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-4].str);
					n->action = (yyvsp[-3].ival);
					n->objtype = OBJECT_LANGUAGE;
					n->objname = list_make1(makeString((yyvsp[0].str)));
					(yyval.node) = (Node *)n;
				}
#line 27488 "gram.c" /* yacc.c:1646  */
    break;

  case 594:
#line 4008 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-4].str);
					n->action = (yyvsp[-3].ival);
					n->objtype = OBJECT_OPERATOR;
					n->objname = (yyvsp[-1].list);
					n->objargs = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 27502 "gram.c" /* yacc.c:1646  */
    break;

  case 595:
#line 4018 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-6].str);
					n->action = (yyvsp[-5].ival);
					n->objtype = OBJECT_OPCLASS;
					n->objname = lcons(makeString((yyvsp[0].str)), (yyvsp[-2].list));
					(yyval.node) = (Node *)n;
				}
#line 27515 "gram.c" /* yacc.c:1646  */
    break;

  case 596:
#line 4027 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-6].str);
					n->action = (yyvsp[-5].ival);
					n->objtype = OBJECT_OPFAMILY;
					n->objname = lcons(makeString((yyvsp[0].str)), (yyvsp[-2].list));
					(yyval.node) = (Node *)n;
				}
#line 27528 "gram.c" /* yacc.c:1646  */
    break;

  case 597:
#line 4036 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_SCHEMA;
					n->objname = list_make1(makeString((yyvsp[0].str)));
					(yyval.node) = (Node *)n;
				}
#line 27541 "gram.c" /* yacc.c:1646  */
    break;

  case 598:
#line 4045 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-4].str);
					n->action = (yyvsp[-3].ival);
					n->objtype = OBJECT_EVENT_TRIGGER;
					n->objname = list_make1(makeString((yyvsp[0].str)));
					(yyval.node) = (Node *)n;
				}
#line 27554 "gram.c" /* yacc.c:1646  */
    break;

  case 599:
#line 4054 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_TABLE;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 27567 "gram.c" /* yacc.c:1646  */
    break;

  case 600:
#line 4063 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-5].str);
					n->action = (yyvsp[-4].ival);
					n->objtype = OBJECT_TSPARSER;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 27580 "gram.c" /* yacc.c:1646  */
    break;

  case 601:
#line 4072 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-5].str);
					n->action = (yyvsp[-4].ival);
					n->objtype = OBJECT_TSDICTIONARY;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 27593 "gram.c" /* yacc.c:1646  */
    break;

  case 602:
#line 4081 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-5].str);
					n->action = (yyvsp[-4].ival);
					n->objtype = OBJECT_TSTEMPLATE;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 27606 "gram.c" /* yacc.c:1646  */
    break;

  case 603:
#line 4090 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-5].str);
					n->action = (yyvsp[-4].ival);
					n->objtype = OBJECT_TSCONFIGURATION;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 27619 "gram.c" /* yacc.c:1646  */
    break;

  case 604:
#line 4099 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_SEQUENCE;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 27632 "gram.c" /* yacc.c:1646  */
    break;

  case 605:
#line 4108 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_VIEW;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 27645 "gram.c" /* yacc.c:1646  */
    break;

  case 606:
#line 4117 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-4].str);
					n->action = (yyvsp[-3].ival);
					n->objtype = OBJECT_MATVIEW;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 27658 "gram.c" /* yacc.c:1646  */
    break;

  case 607:
#line 4126 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-4].str);
					n->action = (yyvsp[-3].ival);
					n->objtype = OBJECT_FOREIGN_TABLE;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 27671 "gram.c" /* yacc.c:1646  */
    break;

  case 608:
#line 4135 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-5].str);
					n->action = (yyvsp[-4].ival);
					n->objtype = OBJECT_FDW;
					n->objname = list_make1(makeString((yyvsp[0].str)));
					(yyval.node) = (Node *)n;
				}
#line 27684 "gram.c" /* yacc.c:1646  */
    break;

  case 609:
#line 4144 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_FOREIGN_SERVER;
					n->objname = list_make1(makeString((yyvsp[0].str)));
					(yyval.node) = (Node *)n;
				}
#line 27697 "gram.c" /* yacc.c:1646  */
    break;

  case 610:
#line 4153 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-6].str);
					n->action = (yyvsp[-5].ival);
					n->objtype = OBJECT_TRANSFORM;
					n->objname = list_make1((yyvsp[-2].typnam));
					n->objargs = list_make1(makeString((yyvsp[0].str)));
					(yyval.node) = (Node *)n;
				}
#line 27711 "gram.c" /* yacc.c:1646  */
    break;

  case 611:
#line 4163 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_TYPE;
					n->objname = list_make1((yyvsp[0].typnam));
					(yyval.node) = (Node *)n;
				}
#line 27724 "gram.c" /* yacc.c:1646  */
    break;

  case 612:
#line 4181 "gram.y" /* yacc.c:1646  */
    {
					CreateFdwStmt *n = makeNode(CreateFdwStmt);
					n->fdwname = (yyvsp[-2].str);
					n->func_options = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 27736 "gram.c" /* yacc.c:1646  */
    break;

  case 613:
#line 4191 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("handler", (Node *)(yyvsp[0].list)); }
#line 27742 "gram.c" /* yacc.c:1646  */
    break;

  case 614:
#line 4192 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("handler", NULL); }
#line 27748 "gram.c" /* yacc.c:1646  */
    break;

  case 615:
#line 4193 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("validator", (Node *)(yyvsp[0].list)); }
#line 27754 "gram.c" /* yacc.c:1646  */
    break;

  case 616:
#line 4194 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("validator", NULL); }
#line 27760 "gram.c" /* yacc.c:1646  */
    break;

  case 617:
#line 4198 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 27766 "gram.c" /* yacc.c:1646  */
    break;

  case 618:
#line 4199 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 27772 "gram.c" /* yacc.c:1646  */
    break;

  case 619:
#line 4203 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 27778 "gram.c" /* yacc.c:1646  */
    break;

  case 620:
#line 4204 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 27784 "gram.c" /* yacc.c:1646  */
    break;

  case 621:
#line 4215 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FDW;
					n->objects = list_make1(list_make1(makeString((yyvsp[-1].str))));
					n->arguments = NIL;
					n->missing_ok = false;
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 27799 "gram.c" /* yacc.c:1646  */
    break;

  case 622:
#line 4226 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FDW;
					n->objects = list_make1(list_make1(makeString((yyvsp[-1].str))));
					n->arguments = NIL;
					n->missing_ok = true;
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 27814 "gram.c" /* yacc.c:1646  */
    break;

  case 623:
#line 4246 "gram.y" /* yacc.c:1646  */
    {
					AlterFdwStmt *n = makeNode(AlterFdwStmt);
					n->fdwname = (yyvsp[-2].str);
					n->func_options = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 27826 "gram.c" /* yacc.c:1646  */
    break;

  case 624:
#line 4254 "gram.y" /* yacc.c:1646  */
    {
					AlterFdwStmt *n = makeNode(AlterFdwStmt);
					n->fdwname = (yyvsp[-1].str);
					n->func_options = (yyvsp[0].list);
					n->options = NIL;
					(yyval.node) = (Node *) n;
				}
#line 27838 "gram.c" /* yacc.c:1646  */
    break;

  case 625:
#line 4265 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 27844 "gram.c" /* yacc.c:1646  */
    break;

  case 626:
#line 4266 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 27850 "gram.c" /* yacc.c:1646  */
    break;

  case 627:
#line 4271 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 27858 "gram.c" /* yacc.c:1646  */
    break;

  case 628:
#line 4275 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 27866 "gram.c" /* yacc.c:1646  */
    break;

  case 629:
#line 4282 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 27872 "gram.c" /* yacc.c:1646  */
    break;

  case 630:
#line 4287 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 27880 "gram.c" /* yacc.c:1646  */
    break;

  case 631:
#line 4291 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 27888 "gram.c" /* yacc.c:1646  */
    break;

  case 632:
#line 4298 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = (yyvsp[0].defelt);
				}
#line 27896 "gram.c" /* yacc.c:1646  */
    break;

  case 633:
#line 4302 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = (yyvsp[0].defelt);
					(yyval.defelt)->defaction = DEFELEM_SET;
				}
#line 27905 "gram.c" /* yacc.c:1646  */
    break;

  case 634:
#line 4307 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = (yyvsp[0].defelt);
					(yyval.defelt)->defaction = DEFELEM_ADD;
				}
#line 27914 "gram.c" /* yacc.c:1646  */
    break;

  case 635:
#line 4312 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElemExtended(NULL, (yyvsp[0].str), NULL, DEFELEM_DROP);
				}
#line 27922 "gram.c" /* yacc.c:1646  */
    break;

  case 636:
#line 4319 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node));
				}
#line 27930 "gram.c" /* yacc.c:1646  */
    break;

  case 637:
#line 4325 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 27936 "gram.c" /* yacc.c:1646  */
    break;

  case 638:
#line 4330 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 27942 "gram.c" /* yacc.c:1646  */
    break;

  case 639:
#line 4342 "gram.y" /* yacc.c:1646  */
    {
					CreateForeignServerStmt *n = makeNode(CreateForeignServerStmt);
					n->servername = (yyvsp[-7].str);
					n->servertype = (yyvsp[-6].str);
					n->version = (yyvsp[-5].str);
					n->fdwname = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 27956 "gram.c" /* yacc.c:1646  */
    break;

  case 640:
#line 4354 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 27962 "gram.c" /* yacc.c:1646  */
    break;

  case 641:
#line 4355 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 27968 "gram.c" /* yacc.c:1646  */
    break;

  case 642:
#line 4360 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 27974 "gram.c" /* yacc.c:1646  */
    break;

  case 643:
#line 4361 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 27980 "gram.c" /* yacc.c:1646  */
    break;

  case 644:
#line 4365 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 27986 "gram.c" /* yacc.c:1646  */
    break;

  case 645:
#line 4366 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 27992 "gram.c" /* yacc.c:1646  */
    break;

  case 646:
#line 4377 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FOREIGN_SERVER;
					n->objects = list_make1(list_make1(makeString((yyvsp[-1].str))));
					n->arguments = NIL;
					n->missing_ok = false;
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 28007 "gram.c" /* yacc.c:1646  */
    break;

  case 647:
#line 4388 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FOREIGN_SERVER;
					n->objects = list_make1(list_make1(makeString((yyvsp[-1].str))));
					n->arguments = NIL;
					n->missing_ok = true;
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 28022 "gram.c" /* yacc.c:1646  */
    break;

  case 648:
#line 4408 "gram.y" /* yacc.c:1646  */
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);
					n->servername = (yyvsp[-2].str);
					n->version = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->has_version = true;
					(yyval.node) = (Node *) n;
				}
#line 28035 "gram.c" /* yacc.c:1646  */
    break;

  case 649:
#line 4417 "gram.y" /* yacc.c:1646  */
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);
					n->servername = (yyvsp[-1].str);
					n->version = (yyvsp[0].str);
					n->has_version = true;
					(yyval.node) = (Node *) n;
				}
#line 28047 "gram.c" /* yacc.c:1646  */
    break;

  case 650:
#line 4425 "gram.y" /* yacc.c:1646  */
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 28058 "gram.c" /* yacc.c:1646  */
    break;

  case 651:
#line 4444 "gram.y" /* yacc.c:1646  */
    {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);
					(yyvsp[-7].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[-7].range);
					n->base.tableElts = (yyvsp[-5].list);
					n->base.inhRelations = (yyvsp[-3].list);
					n->base.ofTypename = NULL;
					n->base.constraints = NIL;
					n->base.options = NIL;
					n->base.oncommit = ONCOMMIT_NOOP;
					n->base.tablespacename = NULL;
					n->base.if_not_exists = false;
					/* FDW-specific data */
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 28080 "gram.c" /* yacc.c:1646  */
    break;

  case 652:
#line 4464 "gram.y" /* yacc.c:1646  */
    {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);
					(yyvsp[-7].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[-7].range);
					n->base.tableElts = (yyvsp[-5].list);
					n->base.inhRelations = (yyvsp[-3].list);
					n->base.ofTypename = NULL;
					n->base.constraints = NIL;
					n->base.options = NIL;
					n->base.oncommit = ONCOMMIT_NOOP;
					n->base.tablespacename = NULL;
					n->base.if_not_exists = true;
					/* FDW-specific data */
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 28102 "gram.c" /* yacc.c:1646  */
    break;

  case 653:
#line 4492 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_FOREIGN_TABLE;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 28115 "gram.c" /* yacc.c:1646  */
    break;

  case 654:
#line 4501 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_FOREIGN_TABLE;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 28128 "gram.c" /* yacc.c:1646  */
    break;

  case 655:
#line 4523 "gram.y" /* yacc.c:1646  */
    {
				ImportForeignSchemaStmt *n = makeNode(ImportForeignSchemaStmt);
				n->server_name = (yyvsp[-3].str);
				n->remote_schema = (yyvsp[-7].str);
				n->local_schema = (yyvsp[-1].str);
				n->list_type = (yyvsp[-6].importqual)->type;
				n->table_list = (yyvsp[-6].importqual)->table_names;
				n->options = (yyvsp[0].list);
				(yyval.node) = (Node *) n;
			}
#line 28143 "gram.c" /* yacc.c:1646  */
    break;

  case 656:
#line 4536 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FDW_IMPORT_SCHEMA_LIMIT_TO; }
#line 28149 "gram.c" /* yacc.c:1646  */
    break;

  case 657:
#line 4537 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FDW_IMPORT_SCHEMA_EXCEPT; }
#line 28155 "gram.c" /* yacc.c:1646  */
    break;

  case 658:
#line 4542 "gram.y" /* yacc.c:1646  */
    {
				ImportQual *n = (ImportQual *) palloc(sizeof(ImportQual));
				n->type = (yyvsp[-3].ival);
				n->table_names = (yyvsp[-1].list);
				(yyval.importqual) = n;
			}
#line 28166 "gram.c" /* yacc.c:1646  */
    break;

  case 659:
#line 4549 "gram.y" /* yacc.c:1646  */
    {
				ImportQual *n = (ImportQual *) palloc(sizeof(ImportQual));
				n->type = FDW_IMPORT_SCHEMA_ALL;
				n->table_names = NIL;
				(yyval.importqual) = n;
			}
#line 28177 "gram.c" /* yacc.c:1646  */
    break;

  case 660:
#line 4565 "gram.y" /* yacc.c:1646  */
    {
					CreateUserMappingStmt *n = makeNode(CreateUserMappingStmt);
					n->user = (yyvsp[-3].node);
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 28189 "gram.c" /* yacc.c:1646  */
    break;

  case 661:
#line 4575 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 28195 "gram.c" /* yacc.c:1646  */
    break;

  case 662:
#line 4576 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeRoleSpec(ROLESPEC_CURRENT_USER, (yylsp[0])); }
#line 28201 "gram.c" /* yacc.c:1646  */
    break;

  case 663:
#line 4589 "gram.y" /* yacc.c:1646  */
    {
					DropUserMappingStmt *n = makeNode(DropUserMappingStmt);
					n->user = (yyvsp[-2].node);
					n->servername = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 28213 "gram.c" /* yacc.c:1646  */
    break;

  case 664:
#line 4597 "gram.y" /* yacc.c:1646  */
    {
					DropUserMappingStmt *n = makeNode(DropUserMappingStmt);
					n->user = (yyvsp[-2].node);
					n->servername = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 28225 "gram.c" /* yacc.c:1646  */
    break;

  case 665:
#line 4614 "gram.y" /* yacc.c:1646  */
    {
					AlterUserMappingStmt *n = makeNode(AlterUserMappingStmt);
					n->user = (yyvsp[-3].node);
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 28237 "gram.c" /* yacc.c:1646  */
    break;

  case 666:
#line 4638 "gram.y" /* yacc.c:1646  */
    {
					CreatePolicyStmt *n = makeNode(CreatePolicyStmt);
					n->policy_name = (yyvsp[-6].str);
					n->table = (yyvsp[-4].range);
					n->cmd_name = (yyvsp[-3].str);
					n->roles = (yyvsp[-2].list);
					n->qual = (yyvsp[-1].node);
					n->with_check = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 28252 "gram.c" /* yacc.c:1646  */
    break;

  case 667:
#line 4653 "gram.y" /* yacc.c:1646  */
    {
					AlterPolicyStmt *n = makeNode(AlterPolicyStmt);
					n->policy_name = (yyvsp[-5].str);
					n->table = (yyvsp[-3].range);
					n->roles = (yyvsp[-2].list);
					n->qual = (yyvsp[-1].node);
					n->with_check = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 28266 "gram.c" /* yacc.c:1646  */
    break;

  case 668:
#line 4666 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_POLICY;
					n->objects = list_make1(lappend((yyvsp[-1].list), makeString((yyvsp[-3].str))));
					n->arguments = NIL;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 28281 "gram.c" /* yacc.c:1646  */
    break;

  case 669:
#line 4677 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_POLICY;
					n->objects = list_make1(lappend((yyvsp[-1].list), makeString((yyvsp[-3].str))));
					n->arguments = NIL;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 28296 "gram.c" /* yacc.c:1646  */
    break;

  case 670:
#line 4690 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 28302 "gram.c" /* yacc.c:1646  */
    break;

  case 671:
#line 4691 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 28308 "gram.c" /* yacc.c:1646  */
    break;

  case 672:
#line 4695 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 28314 "gram.c" /* yacc.c:1646  */
    break;

  case 673:
#line 4696 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 28320 "gram.c" /* yacc.c:1646  */
    break;

  case 674:
#line 4700 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 28326 "gram.c" /* yacc.c:1646  */
    break;

  case 675:
#line 4701 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeRoleSpec(ROLESPEC_PUBLIC, -1)); }
#line 28332 "gram.c" /* yacc.c:1646  */
    break;

  case 676:
#line 4705 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 28338 "gram.c" /* yacc.c:1646  */
    break;

  case 677:
#line 4706 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NULL; }
#line 28344 "gram.c" /* yacc.c:1646  */
    break;

  case 678:
#line 4710 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 28350 "gram.c" /* yacc.c:1646  */
    break;

  case 679:
#line 4711 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "all"; }
#line 28356 "gram.c" /* yacc.c:1646  */
    break;

  case 680:
#line 4715 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "all"; }
#line 28362 "gram.c" /* yacc.c:1646  */
    break;

  case 681:
#line 4716 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "select"; }
#line 28368 "gram.c" /* yacc.c:1646  */
    break;

  case 682:
#line 4717 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "insert"; }
#line 28374 "gram.c" /* yacc.c:1646  */
    break;

  case 683:
#line 4718 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "update"; }
#line 28380 "gram.c" /* yacc.c:1646  */
    break;

  case 684:
#line 4719 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "delete"; }
#line 28386 "gram.c" /* yacc.c:1646  */
    break;

  case 685:
#line 4730 "gram.y" /* yacc.c:1646  */
    {
					CreateAmStmt *n = makeNode(CreateAmStmt);
					n->amname = (yyvsp[-4].str);
					n->handler_name = (yyvsp[0].list);
					n->amtype = AMTYPE_INDEX;
					(yyval.node) = (Node *) n;
				}
#line 28398 "gram.c" /* yacc.c:1646  */
    break;

  case 686:
#line 4751 "gram.y" /* yacc.c:1646  */
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);
					n->trigname = (yyvsp[-12].str);
					n->relation = (yyvsp[-8].range);
					n->funcname = (yyvsp[-3].list);
					n->args = (yyvsp[-1].list);
					n->row = (yyvsp[-7].boolean);
					n->timing = (yyvsp[-11].ival);
					n->events = intVal(linitial((yyvsp[-10].list)));
					n->columns = (List *) lsecond((yyvsp[-10].list));
					n->whenClause = (yyvsp[-6].node);
					n->isconstraint  = FALSE;
					n->deferrable	 = FALSE;
					n->initdeferred  = FALSE;
					n->constrrel = NULL;
					(yyval.node) = (Node *)n;
				}
#line 28420 "gram.c" /* yacc.c:1646  */
    break;

  case 687:
#line 4772 "gram.y" /* yacc.c:1646  */
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);
					n->trigname = (yyvsp[-16].str);
					n->relation = (yyvsp[-12].range);
					n->funcname = (yyvsp[-3].list);
					n->args = (yyvsp[-1].list);
					n->row = TRUE;
					n->timing = TRIGGER_TYPE_AFTER;
					n->events = intVal(linitial((yyvsp[-14].list)));
					n->columns = (List *) lsecond((yyvsp[-14].list));
					n->whenClause = (yyvsp[-6].node);
					n->isconstraint  = TRUE;
					processCASbits((yyvsp[-10].ival), (yylsp[-10]), "TRIGGER",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					n->constrrel = (yyvsp[-11].range);
					(yyval.node) = (Node *)n;
				}
#line 28443 "gram.c" /* yacc.c:1646  */
    break;

  case 688:
#line 4793 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = TRIGGER_TYPE_BEFORE; }
#line 28449 "gram.c" /* yacc.c:1646  */
    break;

  case 689:
#line 4794 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = TRIGGER_TYPE_AFTER; }
#line 28455 "gram.c" /* yacc.c:1646  */
    break;

  case 690:
#line 4795 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = TRIGGER_TYPE_INSTEAD; }
#line 28461 "gram.c" /* yacc.c:1646  */
    break;

  case 691:
#line 4800 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 28467 "gram.c" /* yacc.c:1646  */
    break;

  case 692:
#line 4802 "gram.y" /* yacc.c:1646  */
    {
					int		events1 = intVal(linitial((yyvsp[-2].list)));
					int		events2 = intVal(linitial((yyvsp[0].list)));
					List   *columns1 = (List *) lsecond((yyvsp[-2].list));
					List   *columns2 = (List *) lsecond((yyvsp[0].list));

					if (events1 & events2)
						parser_yyerror("duplicate trigger events specified");
					/*
					 * concat'ing the columns lists loses information about
					 * which columns went with which event, but so long as
					 * only UPDATE carries columns and we disallow multiple
					 * UPDATE items, it doesn't matter.  Command execution
					 * should just ignore the columns for non-UPDATE events.
					 */
					(yyval.list) = list_make2(makeInteger(events1 | events2),
									list_concat(columns1, columns2));
				}
#line 28490 "gram.c" /* yacc.c:1646  */
    break;

  case 693:
#line 4824 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_INSERT), NIL); }
#line 28496 "gram.c" /* yacc.c:1646  */
    break;

  case 694:
#line 4826 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_DELETE), NIL); }
#line 28502 "gram.c" /* yacc.c:1646  */
    break;

  case 695:
#line 4828 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_UPDATE), NIL); }
#line 28508 "gram.c" /* yacc.c:1646  */
    break;

  case 696:
#line 4830 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_UPDATE), (yyvsp[0].list)); }
#line 28514 "gram.c" /* yacc.c:1646  */
    break;

  case 697:
#line 4832 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_TRUNCATE), NIL); }
#line 28520 "gram.c" /* yacc.c:1646  */
    break;

  case 698:
#line 4837 "gram.y" /* yacc.c:1646  */
    {
					(yyval.boolean) = (yyvsp[0].boolean);
				}
#line 28528 "gram.c" /* yacc.c:1646  */
    break;

  case 699:
#line 4841 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * If ROW/STATEMENT not specified, default to
					 * STATEMENT, per SQL
					 */
					(yyval.boolean) = FALSE;
				}
#line 28540 "gram.c" /* yacc.c:1646  */
    break;

  case 700:
#line 4851 "gram.y" /* yacc.c:1646  */
    {}
#line 28546 "gram.c" /* yacc.c:1646  */
    break;

  case 701:
#line 4852 "gram.y" /* yacc.c:1646  */
    {}
#line 28552 "gram.c" /* yacc.c:1646  */
    break;

  case 702:
#line 4856 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 28558 "gram.c" /* yacc.c:1646  */
    break;

  case 703:
#line 4857 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 28564 "gram.c" /* yacc.c:1646  */
    break;

  case 704:
#line 4861 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 28570 "gram.c" /* yacc.c:1646  */
    break;

  case 705:
#line 4862 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 28576 "gram.c" /* yacc.c:1646  */
    break;

  case 706:
#line 4866 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].value)); }
#line 28582 "gram.c" /* yacc.c:1646  */
    break;

  case 707:
#line 4867 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].value)); }
#line 28588 "gram.c" /* yacc.c:1646  */
    break;

  case 708:
#line 4868 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 28594 "gram.c" /* yacc.c:1646  */
    break;

  case 709:
#line 4873 "gram.y" /* yacc.c:1646  */
    {
					(yyval.value) = makeString(psprintf("%d", (yyvsp[0].ival)));
				}
#line 28602 "gram.c" /* yacc.c:1646  */
    break;

  case 710:
#line 4876 "gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeString((yyvsp[0].str)); }
#line 28608 "gram.c" /* yacc.c:1646  */
    break;

  case 711:
#line 4877 "gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeString((yyvsp[0].str)); }
#line 28614 "gram.c" /* yacc.c:1646  */
    break;

  case 712:
#line 4878 "gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeString((yyvsp[0].str)); }
#line 28620 "gram.c" /* yacc.c:1646  */
    break;

  case 713:
#line 4882 "gram.y" /* yacc.c:1646  */
    { (yyval.range) = (yyvsp[0].range); }
#line 28626 "gram.c" /* yacc.c:1646  */
    break;

  case 714:
#line 4883 "gram.y" /* yacc.c:1646  */
    { (yyval.range) = NULL; }
#line 28632 "gram.c" /* yacc.c:1646  */
    break;

  case 715:
#line 4888 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 28638 "gram.c" /* yacc.c:1646  */
    break;

  case 716:
#line 4890 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * We must complain about conflicting options.
					 * We could, but choose not to, complain about redundant
					 * options (ie, where $2's bit is already set in $1).
					 */
					int		newspec = (yyvsp[-1].ival) | (yyvsp[0].ival);

					/* special message for this case */
					if ((newspec & (CAS_NOT_DEFERRABLE | CAS_INITIALLY_DEFERRED)) == (CAS_NOT_DEFERRABLE | CAS_INITIALLY_DEFERRED))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("constraint declared INITIALLY DEFERRED must be DEFERRABLE"),
								 parser_errposition((yylsp[0]))));
					/* generic message for other conflicts */
					if ((newspec & (CAS_NOT_DEFERRABLE | CAS_DEFERRABLE)) == (CAS_NOT_DEFERRABLE | CAS_DEFERRABLE) ||
						(newspec & (CAS_INITIALLY_IMMEDIATE | CAS_INITIALLY_DEFERRED)) == (CAS_INITIALLY_IMMEDIATE | CAS_INITIALLY_DEFERRED))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("conflicting constraint properties"),
								 parser_errposition((yylsp[0]))));
					(yyval.ival) = newspec;
				}
#line 28666 "gram.c" /* yacc.c:1646  */
    break;

  case 717:
#line 4916 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_NOT_DEFERRABLE; }
#line 28672 "gram.c" /* yacc.c:1646  */
    break;

  case 718:
#line 4917 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_DEFERRABLE; }
#line 28678 "gram.c" /* yacc.c:1646  */
    break;

  case 719:
#line 4918 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_INITIALLY_IMMEDIATE; }
#line 28684 "gram.c" /* yacc.c:1646  */
    break;

  case 720:
#line 4919 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_INITIALLY_DEFERRED; }
#line 28690 "gram.c" /* yacc.c:1646  */
    break;

  case 721:
#line 4920 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_NOT_VALID; }
#line 28696 "gram.c" /* yacc.c:1646  */
    break;

  case 722:
#line 4921 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_NO_INHERIT; }
#line 28702 "gram.c" /* yacc.c:1646  */
    break;

  case 723:
#line 4927 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_TRIGGER;
					n->objects = list_make1(lappend((yyvsp[-1].list), makeString((yyvsp[-3].str))));
					n->arguments = NIL;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 28717 "gram.c" /* yacc.c:1646  */
    break;

  case 724:
#line 4938 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_TRIGGER;
					n->objects = list_make1(lappend((yyvsp[-1].list), makeString((yyvsp[-3].str))));
					n->arguments = NIL;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 28732 "gram.c" /* yacc.c:1646  */
    break;

  case 725:
#line 4962 "gram.y" /* yacc.c:1646  */
    {
					CreateEventTrigStmt *n = makeNode(CreateEventTrigStmt);
					n->trigname = (yyvsp[-7].str);
					n->eventname = (yyvsp[-5].str);
					n->whenclause = NULL;
					n->funcname = (yyvsp[-2].list);
					(yyval.node) = (Node *)n;
				}
#line 28745 "gram.c" /* yacc.c:1646  */
    break;

  case 726:
#line 4973 "gram.y" /* yacc.c:1646  */
    {
					CreateEventTrigStmt *n = makeNode(CreateEventTrigStmt);
					n->trigname = (yyvsp[-9].str);
					n->eventname = (yyvsp[-7].str);
					n->whenclause = (yyvsp[-5].list);
					n->funcname = (yyvsp[-2].list);
					(yyval.node) = (Node *)n;
				}
#line 28758 "gram.c" /* yacc.c:1646  */
    break;

  case 727:
#line 4985 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 28764 "gram.c" /* yacc.c:1646  */
    break;

  case 728:
#line 4987 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 28770 "gram.c" /* yacc.c:1646  */
    break;

  case 729:
#line 4992 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem((yyvsp[-4].str), (Node *) (yyvsp[-1].list)); }
#line 28776 "gram.c" /* yacc.c:1646  */
    break;

  case 730:
#line 4997 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 28782 "gram.c" /* yacc.c:1646  */
    break;

  case 731:
#line 4999 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 28788 "gram.c" /* yacc.c:1646  */
    break;

  case 732:
#line 5004 "gram.y" /* yacc.c:1646  */
    {
					AlterEventTrigStmt *n = makeNode(AlterEventTrigStmt);
					n->trigname = (yyvsp[-1].str);
					n->tgenabled = (yyvsp[0].chr);
					(yyval.node) = (Node *) n;
				}
#line 28799 "gram.c" /* yacc.c:1646  */
    break;

  case 733:
#line 5013 "gram.y" /* yacc.c:1646  */
    { (yyval.chr) = TRIGGER_FIRES_ON_ORIGIN; }
#line 28805 "gram.c" /* yacc.c:1646  */
    break;

  case 734:
#line 5014 "gram.y" /* yacc.c:1646  */
    { (yyval.chr) = TRIGGER_FIRES_ON_REPLICA; }
#line 28811 "gram.c" /* yacc.c:1646  */
    break;

  case 735:
#line 5015 "gram.y" /* yacc.c:1646  */
    { (yyval.chr) = TRIGGER_FIRES_ALWAYS; }
#line 28817 "gram.c" /* yacc.c:1646  */
    break;

  case 736:
#line 5016 "gram.y" /* yacc.c:1646  */
    { (yyval.chr) = TRIGGER_DISABLED; }
#line 28823 "gram.c" /* yacc.c:1646  */
    break;

  case 737:
#line 5030 "gram.y" /* yacc.c:1646  */
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);
					n->trigname = (yyvsp[-5].str);
					n->args = list_make1((yyvsp[-2].node));
					n->isconstraint  = TRUE;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "ASSERTION",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);

					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("CREATE ASSERTION is not yet implemented")));

					(yyval.node) = (Node *)n;
				}
#line 28843 "gram.c" /* yacc.c:1646  */
    break;

  case 738:
#line 5049 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->objects = NIL;
					n->arguments = NIL;
					n->behavior = (yyvsp[0].dbehavior);
					n->removeType = OBJECT_TRIGGER; /* XXX */
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("DROP ASSERTION is not yet implemented")));
					(yyval.node) = (Node *) n;
				}
#line 28859 "gram.c" /* yacc.c:1646  */
    break;

  case 739:
#line 5072 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_AGGREGATE;
					n->oldstyle = false;
					n->defnames = (yyvsp[-2].list);
					n->args = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 28873 "gram.c" /* yacc.c:1646  */
    break;

  case 740:
#line 5082 "gram.y" /* yacc.c:1646  */
    {
					/* old-style (pre-8.2) syntax for CREATE AGGREGATE */
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_AGGREGATE;
					n->oldstyle = true;
					n->defnames = (yyvsp[-1].list);
					n->args = NIL;
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 28888 "gram.c" /* yacc.c:1646  */
    break;

  case 741:
#line 5093 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_OPERATOR;
					n->oldstyle = false;
					n->defnames = (yyvsp[-1].list);
					n->args = NIL;
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 28902 "gram.c" /* yacc.c:1646  */
    break;

  case 742:
#line 5103 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TYPE;
					n->oldstyle = false;
					n->defnames = (yyvsp[-1].list);
					n->args = NIL;
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 28916 "gram.c" /* yacc.c:1646  */
    break;

  case 743:
#line 5113 "gram.y" /* yacc.c:1646  */
    {
					/* Shell type (identified by lack of definition) */
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TYPE;
					n->oldstyle = false;
					n->defnames = (yyvsp[0].list);
					n->args = NIL;
					n->definition = NIL;
					(yyval.node) = (Node *)n;
				}
#line 28931 "gram.c" /* yacc.c:1646  */
    break;

  case 744:
#line 5124 "gram.y" /* yacc.c:1646  */
    {
					CompositeTypeStmt *n = makeNode(CompositeTypeStmt);

					/* can't use qualified_name, sigh */
					n->typevar = makeRangeVarFromAnyName((yyvsp[-4].list), (yylsp[-4]), yyscanner);
					n->coldeflist = (yyvsp[-1].list);
					(yyval.node) = (Node *)n;
				}
#line 28944 "gram.c" /* yacc.c:1646  */
    break;

  case 745:
#line 5133 "gram.y" /* yacc.c:1646  */
    {
					CreateEnumStmt *n = makeNode(CreateEnumStmt);
					n->typeName = (yyvsp[-5].list);
					n->vals = (yyvsp[-1].list);
					(yyval.node) = (Node *)n;
				}
#line 28955 "gram.c" /* yacc.c:1646  */
    break;

  case 746:
#line 5140 "gram.y" /* yacc.c:1646  */
    {
					CreateRangeStmt *n = makeNode(CreateRangeStmt);
					n->typeName = (yyvsp[-3].list);
					n->params	= (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 28966 "gram.c" /* yacc.c:1646  */
    break;

  case 747:
#line 5147 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSPARSER;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 28979 "gram.c" /* yacc.c:1646  */
    break;

  case 748:
#line 5156 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSDICTIONARY;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 28992 "gram.c" /* yacc.c:1646  */
    break;

  case 749:
#line 5165 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSTEMPLATE;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 29005 "gram.c" /* yacc.c:1646  */
    break;

  case 750:
#line 5174 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSCONFIGURATION;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 29018 "gram.c" /* yacc.c:1646  */
    break;

  case 751:
#line 5183 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 29031 "gram.c" /* yacc.c:1646  */
    break;

  case 752:
#line 5192 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[-2].list);
					n->definition = list_make1(makeDefElem("from", (Node *) (yyvsp[0].list)));
					(yyval.node) = (Node *)n;
				}
#line 29044 "gram.c" /* yacc.c:1646  */
    break;

  case 753:
#line 5202 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 29050 "gram.c" /* yacc.c:1646  */
    break;

  case 754:
#line 5205 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 29056 "gram.c" /* yacc.c:1646  */
    break;

  case 755:
#line 5206 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 29062 "gram.c" /* yacc.c:1646  */
    break;

  case 756:
#line 5210 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) (yyvsp[0].node));
				}
#line 29070 "gram.c" /* yacc.c:1646  */
    break;

  case 757:
#line 5214 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[0].str), NULL);
				}
#line 29078 "gram.c" /* yacc.c:1646  */
    break;

  case 758:
#line 5220 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)(yyvsp[0].typnam); }
#line 29084 "gram.c" /* yacc.c:1646  */
    break;

  case 759:
#line 5221 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)makeString(pstrdup((yyvsp[0].keyword))); }
#line 29090 "gram.c" /* yacc.c:1646  */
    break;

  case 760:
#line 5222 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)(yyvsp[0].list); }
#line 29096 "gram.c" /* yacc.c:1646  */
    break;

  case 761:
#line 5223 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)(yyvsp[0].value); }
#line 29102 "gram.c" /* yacc.c:1646  */
    break;

  case 762:
#line 5224 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)makeString((yyvsp[0].str)); }
#line 29108 "gram.c" /* yacc.c:1646  */
    break;

  case 763:
#line 5227 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 29114 "gram.c" /* yacc.c:1646  */
    break;

  case 764:
#line 5230 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 29120 "gram.c" /* yacc.c:1646  */
    break;

  case 765:
#line 5231 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 29126 "gram.c" /* yacc.c:1646  */
    break;

  case 766:
#line 5240 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *)(yyvsp[0].node));
				}
#line 29134 "gram.c" /* yacc.c:1646  */
    break;

  case 767:
#line 5246 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 29140 "gram.c" /* yacc.c:1646  */
    break;

  case 768:
#line 5247 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 29146 "gram.c" /* yacc.c:1646  */
    break;

  case 769:
#line 5251 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 29152 "gram.c" /* yacc.c:1646  */
    break;

  case 770:
#line 5253 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 29158 "gram.c" /* yacc.c:1646  */
    break;

  case 771:
#line 5264 "gram.y" /* yacc.c:1646  */
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);
				n->typeName = (yyvsp[-4].list);
				n->newVal = (yyvsp[0].str);
				n->newValNeighbor = NULL;
				n->newValIsAfter = true;
				n->skipIfExists = (yyvsp[-1].boolean);
				(yyval.node) = (Node *) n;
			}
#line 29172 "gram.c" /* yacc.c:1646  */
    break;

  case 772:
#line 5274 "gram.y" /* yacc.c:1646  */
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);
				n->typeName = (yyvsp[-6].list);
				n->newVal = (yyvsp[-2].str);
				n->newValNeighbor = (yyvsp[0].str);
				n->newValIsAfter = false;
				n->skipIfExists = (yyvsp[-3].boolean);
				(yyval.node) = (Node *) n;
			}
#line 29186 "gram.c" /* yacc.c:1646  */
    break;

  case 773:
#line 5284 "gram.y" /* yacc.c:1646  */
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);
				n->typeName = (yyvsp[-6].list);
				n->newVal = (yyvsp[-2].str);
				n->newValNeighbor = (yyvsp[0].str);
				n->newValIsAfter = true;
				n->skipIfExists = (yyvsp[-3].boolean);
				(yyval.node) = (Node *) n;
			}
#line 29200 "gram.c" /* yacc.c:1646  */
    break;

  case 774:
#line 5295 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 29206 "gram.c" /* yacc.c:1646  */
    break;

  case 775:
#line 5296 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 29212 "gram.c" /* yacc.c:1646  */
    break;

  case 776:
#line 5314 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassStmt *n = makeNode(CreateOpClassStmt);
					n->opclassname = (yyvsp[-9].list);
					n->isDefault = (yyvsp[-8].boolean);
					n->datatype = (yyvsp[-5].typnam);
					n->amname = (yyvsp[-3].str);
					n->opfamilyname = (yyvsp[-2].list);
					n->items = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 29227 "gram.c" /* yacc.c:1646  */
    break;

  case 777:
#line 5327 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 29233 "gram.c" /* yacc.c:1646  */
    break;

  case 778:
#line 5328 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 29239 "gram.c" /* yacc.c:1646  */
    break;

  case 779:
#line 5333 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->name = (yyvsp[-2].list);
					n->args = NIL;
					n->number = (yyvsp[-3].ival);
					n->order_family = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 29253 "gram.c" /* yacc.c:1646  */
    break;

  case 780:
#line 5344 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->name = (yyvsp[-3].list);
					n->args = (yyvsp[-2].list);
					n->number = (yyvsp[-4].ival);
					n->order_family = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 29267 "gram.c" /* yacc.c:1646  */
    break;

  case 781:
#line 5354 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->name = (yyvsp[-1].list);
					n->args = extractArgTypes((yyvsp[0].list));
					n->number = (yyvsp[-2].ival);
					(yyval.node) = (Node *) n;
				}
#line 29280 "gram.c" /* yacc.c:1646  */
    break;

  case 782:
#line 5363 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->name = (yyvsp[-1].list);
					n->args = extractArgTypes((yyvsp[0].list));
					n->number = (yyvsp[-5].ival);
					n->class_args = (yyvsp[-3].list);
					(yyval.node) = (Node *) n;
				}
#line 29294 "gram.c" /* yacc.c:1646  */
    break;

  case 783:
#line 5373 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_STORAGETYPE;
					n->storedtype = (yyvsp[0].typnam);
					(yyval.node) = (Node *) n;
				}
#line 29305 "gram.c" /* yacc.c:1646  */
    break;

  case 784:
#line 5381 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 29311 "gram.c" /* yacc.c:1646  */
    break;

  case 785:
#line 5382 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 29317 "gram.c" /* yacc.c:1646  */
    break;

  case 786:
#line 5385 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 29323 "gram.c" /* yacc.c:1646  */
    break;

  case 787:
#line 5386 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 29329 "gram.c" /* yacc.c:1646  */
    break;

  case 788:
#line 5389 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 29335 "gram.c" /* yacc.c:1646  */
    break;

  case 789:
#line 5390 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 29341 "gram.c" /* yacc.c:1646  */
    break;

  case 790:
#line 5391 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 29347 "gram.c" /* yacc.c:1646  */
    break;

  case 791:
#line 5395 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * RECHECK no longer does anything in opclass definitions,
					 * but we still accept it to ease porting of old database
					 * dumps.
					 */
					ereport(NOTICE,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("RECHECK is no longer required"),
							 errhint("Update your data type."),
							 parser_errposition((yylsp[0]))));
					(yyval.boolean) = TRUE;
				}
#line 29365 "gram.c" /* yacc.c:1646  */
    break;

  case 792:
#line 5408 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 29371 "gram.c" /* yacc.c:1646  */
    break;

  case 793:
#line 5414 "gram.y" /* yacc.c:1646  */
    {
					CreateOpFamilyStmt *n = makeNode(CreateOpFamilyStmt);
					n->opfamilyname = (yyvsp[-2].list);
					n->amname = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 29382 "gram.c" /* yacc.c:1646  */
    break;

  case 794:
#line 5424 "gram.y" /* yacc.c:1646  */
    {
					AlterOpFamilyStmt *n = makeNode(AlterOpFamilyStmt);
					n->opfamilyname = (yyvsp[-4].list);
					n->amname = (yyvsp[-2].str);
					n->isDrop = false;
					n->items = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 29395 "gram.c" /* yacc.c:1646  */
    break;

  case 795:
#line 5433 "gram.y" /* yacc.c:1646  */
    {
					AlterOpFamilyStmt *n = makeNode(AlterOpFamilyStmt);
					n->opfamilyname = (yyvsp[-4].list);
					n->amname = (yyvsp[-2].str);
					n->isDrop = true;
					n->items = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 29408 "gram.c" /* yacc.c:1646  */
    break;

  case 796:
#line 5444 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 29414 "gram.c" /* yacc.c:1646  */
    break;

  case 797:
#line 5445 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 29420 "gram.c" /* yacc.c:1646  */
    break;

  case 798:
#line 5450 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->number = (yyvsp[-3].ival);
					n->args = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 29432 "gram.c" /* yacc.c:1646  */
    break;

  case 799:
#line 5458 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->number = (yyvsp[-3].ival);
					n->args = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 29444 "gram.c" /* yacc.c:1646  */
    break;

  case 800:
#line 5470 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->objects = list_make1(lcons(makeString((yyvsp[-1].str)), (yyvsp[-3].list)));
					n->removeType = OBJECT_OPCLASS;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 29458 "gram.c" /* yacc.c:1646  */
    break;

  case 801:
#line 5480 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->objects = list_make1(lcons(makeString((yyvsp[-1].str)), (yyvsp[-3].list)));
					n->removeType = OBJECT_OPCLASS;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 29472 "gram.c" /* yacc.c:1646  */
    break;

  case 802:
#line 5493 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->objects = list_make1(lcons(makeString((yyvsp[-1].str)), (yyvsp[-3].list)));
					n->removeType = OBJECT_OPFAMILY;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 29486 "gram.c" /* yacc.c:1646  */
    break;

  case 803:
#line 5503 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->objects = list_make1(lcons(makeString((yyvsp[-1].str)), (yyvsp[-3].list)));
					n->removeType = OBJECT_OPFAMILY;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 29500 "gram.c" /* yacc.c:1646  */
    break;

  case 804:
#line 5525 "gram.y" /* yacc.c:1646  */
    {
					DropOwnedStmt *n = makeNode(DropOwnedStmt);
					n->roles = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 29511 "gram.c" /* yacc.c:1646  */
    break;

  case 805:
#line 5535 "gram.y" /* yacc.c:1646  */
    {
					ReassignOwnedStmt *n = makeNode(ReassignOwnedStmt);
					n->roles = (yyvsp[-2].list);
					n->newrole = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 29522 "gram.c" /* yacc.c:1646  */
    break;

  case 806:
#line 5553 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = (yyvsp[-4].objtype);
					n->missing_ok = TRUE;
					n->objects = (yyvsp[-1].list);
					n->arguments = NIL;
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 29537 "gram.c" /* yacc.c:1646  */
    break;

  case 807:
#line 5564 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = (yyvsp[-2].objtype);
					n->missing_ok = FALSE;
					n->objects = (yyvsp[-1].list);
					n->arguments = NIL;
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 29552 "gram.c" /* yacc.c:1646  */
    break;

  case 808:
#line 5575 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_TYPE;
					n->missing_ok = FALSE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 29566 "gram.c" /* yacc.c:1646  */
    break;

  case 809:
#line 5585 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_TYPE;
					n->missing_ok = TRUE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 29580 "gram.c" /* yacc.c:1646  */
    break;

  case 810:
#line 5595 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_DOMAIN;
					n->missing_ok = FALSE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 29594 "gram.c" /* yacc.c:1646  */
    break;

  case 811:
#line 5605 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_DOMAIN;
					n->missing_ok = TRUE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 29608 "gram.c" /* yacc.c:1646  */
    break;

  case 812:
#line 5615 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_INDEX;
					n->missing_ok = FALSE;
					n->objects = (yyvsp[-1].list);
					n->arguments = NIL;
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = true;
					(yyval.node) = (Node *)n;
				}
#line 29623 "gram.c" /* yacc.c:1646  */
    break;

  case 813:
#line 5626 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_INDEX;
					n->missing_ok = TRUE;
					n->objects = (yyvsp[-1].list);
					n->arguments = NIL;
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = true;
					(yyval.node) = (Node *)n;
				}
#line 29638 "gram.c" /* yacc.c:1646  */
    break;

  case 814:
#line 5639 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TABLE; }
#line 29644 "gram.c" /* yacc.c:1646  */
    break;

  case 815:
#line 5640 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SEQUENCE; }
#line 29650 "gram.c" /* yacc.c:1646  */
    break;

  case 816:
#line 5641 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_VIEW; }
#line 29656 "gram.c" /* yacc.c:1646  */
    break;

  case 817:
#line 5642 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_MATVIEW; }
#line 29662 "gram.c" /* yacc.c:1646  */
    break;

  case 818:
#line 5643 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_INDEX; }
#line 29668 "gram.c" /* yacc.c:1646  */
    break;

  case 819:
#line 5644 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_FOREIGN_TABLE; }
#line 29674 "gram.c" /* yacc.c:1646  */
    break;

  case 820:
#line 5645 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_ACCESS_METHOD; }
#line 29680 "gram.c" /* yacc.c:1646  */
    break;

  case 821:
#line 5646 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_EVENT_TRIGGER; }
#line 29686 "gram.c" /* yacc.c:1646  */
    break;

  case 822:
#line 5647 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_COLLATION; }
#line 29692 "gram.c" /* yacc.c:1646  */
    break;

  case 823:
#line 5648 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_CONVERSION; }
#line 29698 "gram.c" /* yacc.c:1646  */
    break;

  case 824:
#line 5649 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SCHEMA; }
#line 29704 "gram.c" /* yacc.c:1646  */
    break;

  case 825:
#line 5650 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_EXTENSION; }
#line 29710 "gram.c" /* yacc.c:1646  */
    break;

  case 826:
#line 5651 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSPARSER; }
#line 29716 "gram.c" /* yacc.c:1646  */
    break;

  case 827:
#line 5652 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSDICTIONARY; }
#line 29722 "gram.c" /* yacc.c:1646  */
    break;

  case 828:
#line 5653 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSTEMPLATE; }
#line 29728 "gram.c" /* yacc.c:1646  */
    break;

  case 829:
#line 5654 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSCONFIGURATION; }
#line 29734 "gram.c" /* yacc.c:1646  */
    break;

  case 830:
#line 5658 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].list)); }
#line 29740 "gram.c" /* yacc.c:1646  */
    break;

  case 831:
#line 5659 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].list)); }
#line 29746 "gram.c" /* yacc.c:1646  */
    break;

  case 832:
#line 5662 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 29752 "gram.c" /* yacc.c:1646  */
    break;

  case 833:
#line 5663 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)); }
#line 29758 "gram.c" /* yacc.c:1646  */
    break;

  case 834:
#line 5667 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 29764 "gram.c" /* yacc.c:1646  */
    break;

  case 835:
#line 5669 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 29770 "gram.c" /* yacc.c:1646  */
    break;

  case 836:
#line 5673 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(list_make1((yyvsp[0].typnam))); }
#line 29776 "gram.c" /* yacc.c:1646  */
    break;

  case 837:
#line 5674 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), list_make1((yyvsp[0].typnam))); }
#line 29782 "gram.c" /* yacc.c:1646  */
    break;

  case 838:
#line 5685 "gram.y" /* yacc.c:1646  */
    {
					TruncateStmt *n = makeNode(TruncateStmt);
					n->relations = (yyvsp[-2].list);
					n->restart_seqs = (yyvsp[-1].boolean);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 29794 "gram.c" /* yacc.c:1646  */
    break;

  case 839:
#line 5695 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 29800 "gram.c" /* yacc.c:1646  */
    break;

  case 840:
#line 5696 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 29806 "gram.c" /* yacc.c:1646  */
    break;

  case 841:
#line 5697 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 29812 "gram.c" /* yacc.c:1646  */
    break;

  case 842:
#line 5732 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = (yyvsp[-3].objtype);
					n->objname = (yyvsp[-2].list);
					n->objargs = NIL;
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 29825 "gram.c" /* yacc.c:1646  */
    break;

  case 843:
#line 5741 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TYPE;
					n->objname = list_make1((yyvsp[-2].typnam));
					n->objargs = NIL;
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 29838 "gram.c" /* yacc.c:1646  */
    break;

  case 844:
#line 5750 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_DOMAIN;
					n->objname = list_make1((yyvsp[-2].typnam));
					n->objargs = NIL;
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 29851 "gram.c" /* yacc.c:1646  */
    break;

  case 845:
#line 5759 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_AGGREGATE;
					n->objname = (yyvsp[-3].list);
					n->objargs = extractAggrArgTypes((yyvsp[-2].list));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 29864 "gram.c" /* yacc.c:1646  */
    break;

  case 846:
#line 5768 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_FUNCTION;
					n->objname = (yyvsp[-3].list);
					n->objargs = extractArgTypes((yyvsp[-2].list));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 29877 "gram.c" /* yacc.c:1646  */
    break;

  case 847:
#line 5777 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_OPERATOR;
					n->objname = (yyvsp[-3].list);
					n->objargs = (yyvsp[-2].list);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 29890 "gram.c" /* yacc.c:1646  */
    break;

  case 848:
#line 5786 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TABCONSTRAINT;
					n->objname = lappend((yyvsp[-2].list), makeString((yyvsp[-4].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 29903 "gram.c" /* yacc.c:1646  */
    break;

  case 849:
#line 5795 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_DOMCONSTRAINT;
					/*
					 * should use Typename not any_name in the production, but
					 * there's a shift/reduce conflict if we do that, so fix it
					 * up here.
					 */
					n->objname = list_make1(makeTypeNameFromNameList((yyvsp[-2].list)));
					n->objargs = list_make1(makeString((yyvsp[-5].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 29921 "gram.c" /* yacc.c:1646  */
    break;

  case 850:
#line 5809 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_POLICY;
					n->objname = lappend((yyvsp[-2].list), makeString((yyvsp[-4].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 29934 "gram.c" /* yacc.c:1646  */
    break;

  case 851:
#line 5818 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_RULE;
					n->objname = lappend((yyvsp[-2].list), makeString((yyvsp[-4].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 29947 "gram.c" /* yacc.c:1646  */
    break;

  case 852:
#line 5827 "gram.y" /* yacc.c:1646  */
    {
					/* Obsolete syntax supported for awhile for compatibility */
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_RULE;
					n->objname = list_make1(makeString((yyvsp[-2].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 29961 "gram.c" /* yacc.c:1646  */
    break;

  case 853:
#line 5837 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TRANSFORM;
					n->objname = list_make1((yyvsp[-4].typnam));
					n->objargs = list_make1(makeString((yyvsp[-2].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 29974 "gram.c" /* yacc.c:1646  */
    break;

  case 854:
#line 5846 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TRIGGER;
					n->objname = lappend((yyvsp[-2].list), makeString((yyvsp[-4].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 29987 "gram.c" /* yacc.c:1646  */
    break;

  case 855:
#line 5855 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_OPCLASS;
					n->objname = lcons(makeString((yyvsp[-2].str)), (yyvsp[-4].list));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 29999 "gram.c" /* yacc.c:1646  */
    break;

  case 856:
#line 5863 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_OPFAMILY;
					n->objname = lcons(makeString((yyvsp[-2].str)), (yyvsp[-4].list));
					n->objargs = NIL;
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 30012 "gram.c" /* yacc.c:1646  */
    break;

  case 857:
#line 5872 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_LARGEOBJECT;
					n->objname = list_make1((yyvsp[-2].value));
					n->objargs = NIL;
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 30025 "gram.c" /* yacc.c:1646  */
    break;

  case 858:
#line 5881 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_CAST;
					n->objname = list_make1((yyvsp[-5].typnam));
					n->objargs = list_make1((yyvsp[-3].typnam));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 30038 "gram.c" /* yacc.c:1646  */
    break;

  case 859:
#line 5890 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_LANGUAGE;
					n->objname = (yyvsp[-2].list);
					n->objargs = NIL;
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 30051 "gram.c" /* yacc.c:1646  */
    break;

  case 860:
#line 5901 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_ACCESS_METHOD; }
#line 30057 "gram.c" /* yacc.c:1646  */
    break;

  case 861:
#line 5902 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_COLUMN; }
#line 30063 "gram.c" /* yacc.c:1646  */
    break;

  case 862:
#line 5903 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_DATABASE; }
#line 30069 "gram.c" /* yacc.c:1646  */
    break;

  case 863:
#line 5904 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SCHEMA; }
#line 30075 "gram.c" /* yacc.c:1646  */
    break;

  case 864:
#line 5905 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_INDEX; }
#line 30081 "gram.c" /* yacc.c:1646  */
    break;

  case 865:
#line 5906 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SEQUENCE; }
#line 30087 "gram.c" /* yacc.c:1646  */
    break;

  case 866:
#line 5907 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TABLE; }
#line 30093 "gram.c" /* yacc.c:1646  */
    break;

  case 867:
#line 5908 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_VIEW; }
#line 30099 "gram.c" /* yacc.c:1646  */
    break;

  case 868:
#line 5909 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_MATVIEW; }
#line 30105 "gram.c" /* yacc.c:1646  */
    break;

  case 869:
#line 5910 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_COLLATION; }
#line 30111 "gram.c" /* yacc.c:1646  */
    break;

  case 870:
#line 5911 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_CONVERSION; }
#line 30117 "gram.c" /* yacc.c:1646  */
    break;

  case 871:
#line 5912 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TABLESPACE; }
#line 30123 "gram.c" /* yacc.c:1646  */
    break;

  case 872:
#line 5913 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_EXTENSION; }
#line 30129 "gram.c" /* yacc.c:1646  */
    break;

  case 873:
#line 5914 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_ROLE; }
#line 30135 "gram.c" /* yacc.c:1646  */
    break;

  case 874:
#line 5915 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_FOREIGN_TABLE; }
#line 30141 "gram.c" /* yacc.c:1646  */
    break;

  case 875:
#line 5916 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_FOREIGN_SERVER; }
#line 30147 "gram.c" /* yacc.c:1646  */
    break;

  case 876:
#line 5917 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_FDW; }
#line 30153 "gram.c" /* yacc.c:1646  */
    break;

  case 877:
#line 5918 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_EVENT_TRIGGER; }
#line 30159 "gram.c" /* yacc.c:1646  */
    break;

  case 878:
#line 5919 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSCONFIGURATION; }
#line 30165 "gram.c" /* yacc.c:1646  */
    break;

  case 879:
#line 5920 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSDICTIONARY; }
#line 30171 "gram.c" /* yacc.c:1646  */
    break;

  case 880:
#line 5921 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSPARSER; }
#line 30177 "gram.c" /* yacc.c:1646  */
    break;

  case 881:
#line 5922 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSTEMPLATE; }
#line 30183 "gram.c" /* yacc.c:1646  */
    break;

  case 882:
#line 5926 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 30189 "gram.c" /* yacc.c:1646  */
    break;

  case 883:
#line 5927 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 30195 "gram.c" /* yacc.c:1646  */
    break;

  case 884:
#line 5943 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-5].str);
					n->objtype = (yyvsp[-3].objtype);
					n->objname = (yyvsp[-2].list);
					n->objargs = NIL;
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 30209 "gram.c" /* yacc.c:1646  */
    break;

  case 885:
#line 5954 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_TYPE;
					n->objname = list_make1((yyvsp[-2].typnam));
					n->objargs = NIL;
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 30223 "gram.c" /* yacc.c:1646  */
    break;

  case 886:
#line 5965 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_TYPE;
					n->objname = list_make1((yyvsp[-2].typnam));
					n->objargs = NIL;
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 30237 "gram.c" /* yacc.c:1646  */
    break;

  case 887:
#line 5976 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-6].str);
					n->objtype = OBJECT_AGGREGATE;
					n->objname = (yyvsp[-3].list);
					n->objargs = extractAggrArgTypes((yyvsp[-2].list));
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 30251 "gram.c" /* yacc.c:1646  */
    break;

  case 888:
#line 5987 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-6].str);
					n->objtype = OBJECT_FUNCTION;
					n->objname = (yyvsp[-3].list);
					n->objargs = extractArgTypes((yyvsp[-2].list));
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 30265 "gram.c" /* yacc.c:1646  */
    break;

  case 889:
#line 5998 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-6].str);
					n->objtype = OBJECT_LARGEOBJECT;
					n->objname = list_make1((yyvsp[-2].value));
					n->objargs = NIL;
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 30279 "gram.c" /* yacc.c:1646  */
    break;

  case 890:
#line 6009 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-6].str);
					n->objtype = OBJECT_LANGUAGE;
					n->objname = (yyvsp[-2].list);
					n->objargs = NIL;
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 30293 "gram.c" /* yacc.c:1646  */
    break;

  case 891:
#line 6020 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 30299 "gram.c" /* yacc.c:1646  */
    break;

  case 892:
#line 6021 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 30305 "gram.c" /* yacc.c:1646  */
    break;

  case 893:
#line 6025 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_COLUMN; }
#line 30311 "gram.c" /* yacc.c:1646  */
    break;

  case 894:
#line 6026 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_DATABASE; }
#line 30317 "gram.c" /* yacc.c:1646  */
    break;

  case 895:
#line 6027 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_EVENT_TRIGGER; }
#line 30323 "gram.c" /* yacc.c:1646  */
    break;

  case 896:
#line 6028 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_FOREIGN_TABLE; }
#line 30329 "gram.c" /* yacc.c:1646  */
    break;

  case 897:
#line 6029 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SCHEMA; }
#line 30335 "gram.c" /* yacc.c:1646  */
    break;

  case 898:
#line 6030 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SEQUENCE; }
#line 30341 "gram.c" /* yacc.c:1646  */
    break;

  case 899:
#line 6031 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TABLE; }
#line 30347 "gram.c" /* yacc.c:1646  */
    break;

  case 900:
#line 6032 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_ROLE; }
#line 30353 "gram.c" /* yacc.c:1646  */
    break;

  case 901:
#line 6033 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TABLESPACE; }
#line 30359 "gram.c" /* yacc.c:1646  */
    break;

  case 902:
#line 6034 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_VIEW; }
#line 30365 "gram.c" /* yacc.c:1646  */
    break;

  case 903:
#line 6035 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_MATVIEW; }
#line 30371 "gram.c" /* yacc.c:1646  */
    break;

  case 904:
#line 6038 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 30377 "gram.c" /* yacc.c:1646  */
    break;

  case 905:
#line 6039 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 30383 "gram.c" /* yacc.c:1646  */
    break;

  case 906:
#line 6050 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = (FetchStmt *) (yyvsp[0].node);
					n->ismove = FALSE;
					(yyval.node) = (Node *)n;
				}
#line 30393 "gram.c" /* yacc.c:1646  */
    break;

  case 907:
#line 6056 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = (FetchStmt *) (yyvsp[0].node);
					n->ismove = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 30403 "gram.c" /* yacc.c:1646  */
    break;

  case 908:
#line 6064 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 30415 "gram.c" /* yacc.c:1646  */
    break;

  case 909:
#line 6072 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 30427 "gram.c" /* yacc.c:1646  */
    break;

  case 910:
#line 6080 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 30439 "gram.c" /* yacc.c:1646  */
    break;

  case 911:
#line 6088 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 30451 "gram.c" /* yacc.c:1646  */
    break;

  case 912:
#line 6096 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 30463 "gram.c" /* yacc.c:1646  */
    break;

  case 913:
#line 6104 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = -1;
					(yyval.node) = (Node *)n;
				}
#line 30475 "gram.c" /* yacc.c:1646  */
    break;

  case 914:
#line 6112 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *)n;
				}
#line 30487 "gram.c" /* yacc.c:1646  */
    break;

  case 915:
#line 6120 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_RELATIVE;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *)n;
				}
#line 30499 "gram.c" /* yacc.c:1646  */
    break;

  case 916:
#line 6128 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *)n;
				}
#line 30511 "gram.c" /* yacc.c:1646  */
    break;

  case 917:
#line 6136 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				}
#line 30523 "gram.c" /* yacc.c:1646  */
    break;

  case 918:
#line 6144 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 30535 "gram.c" /* yacc.c:1646  */
    break;

  case 919:
#line 6152 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *)n;
				}
#line 30547 "gram.c" /* yacc.c:1646  */
    break;

  case 920:
#line 6160 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				}
#line 30559 "gram.c" /* yacc.c:1646  */
    break;

  case 921:
#line 6168 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 30571 "gram.c" /* yacc.c:1646  */
    break;

  case 922:
#line 6176 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *)n;
				}
#line 30583 "gram.c" /* yacc.c:1646  */
    break;

  case 923:
#line 6184 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				}
#line 30595 "gram.c" /* yacc.c:1646  */
    break;

  case 924:
#line 6193 "gram.y" /* yacc.c:1646  */
    {}
#line 30601 "gram.c" /* yacc.c:1646  */
    break;

  case 925:
#line 6194 "gram.y" /* yacc.c:1646  */
    {}
#line 30607 "gram.c" /* yacc.c:1646  */
    break;

  case 926:
#line 6197 "gram.y" /* yacc.c:1646  */
    {}
#line 30613 "gram.c" /* yacc.c:1646  */
    break;

  case 927:
#line 6198 "gram.y" /* yacc.c:1646  */
    {}
#line 30619 "gram.c" /* yacc.c:1646  */
    break;

  case 928:
#line 6210 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = true;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ((yyvsp[-3].privtarget))->targtype;
					n->objtype = ((yyvsp[-3].privtarget))->objtype;
					n->objects = ((yyvsp[-3].privtarget))->objs;
					n->grantees = (yyvsp[-1].list);
					n->grant_option = (yyvsp[0].boolean);
					(yyval.node) = (Node*)n;
				}
#line 30635 "gram.c" /* yacc.c:1646  */
    break;

  case 929:
#line 6226 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = false;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ((yyvsp[-3].privtarget))->targtype;
					n->objtype = ((yyvsp[-3].privtarget))->objtype;
					n->objects = ((yyvsp[-3].privtarget))->objs;
					n->grantees = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 30652 "gram.c" /* yacc.c:1646  */
    break;

  case 930:
#line 6240 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = true;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ((yyvsp[-3].privtarget))->targtype;
					n->objtype = ((yyvsp[-3].privtarget))->objtype;
					n->objects = ((yyvsp[-3].privtarget))->objs;
					n->grantees = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 30669 "gram.c" /* yacc.c:1646  */
    break;

  case 931:
#line 6265 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 30675 "gram.c" /* yacc.c:1646  */
    break;

  case 932:
#line 6267 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 30681 "gram.c" /* yacc.c:1646  */
    break;

  case 933:
#line 6269 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 30687 "gram.c" /* yacc.c:1646  */
    break;

  case 934:
#line 6271 "gram.y" /* yacc.c:1646  */
    {
					AccessPriv *n = makeNode(AccessPriv);
					n->priv_name = NULL;
					n->cols = (yyvsp[-1].list);
					(yyval.list) = list_make1(n);
				}
#line 30698 "gram.c" /* yacc.c:1646  */
    break;

  case 935:
#line 6278 "gram.y" /* yacc.c:1646  */
    {
					AccessPriv *n = makeNode(AccessPriv);
					n->priv_name = NULL;
					n->cols = (yyvsp[-1].list);
					(yyval.list) = list_make1(n);
				}
#line 30709 "gram.c" /* yacc.c:1646  */
    break;

  case 936:
#line 6286 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].accesspriv)); }
#line 30715 "gram.c" /* yacc.c:1646  */
    break;

  case 937:
#line 6287 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].accesspriv)); }
#line 30721 "gram.c" /* yacc.c:1646  */
    break;

  case 938:
#line 6291 "gram.y" /* yacc.c:1646  */
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup((yyvsp[-1].keyword));
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 30732 "gram.c" /* yacc.c:1646  */
    break;

  case 939:
#line 6298 "gram.y" /* yacc.c:1646  */
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup((yyvsp[-1].keyword));
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 30743 "gram.c" /* yacc.c:1646  */
    break;

  case 940:
#line 6305 "gram.y" /* yacc.c:1646  */
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup((yyvsp[-1].keyword));
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 30754 "gram.c" /* yacc.c:1646  */
    break;

  case 941:
#line 6312 "gram.y" /* yacc.c:1646  */
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = (yyvsp[-1].str);
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 30765 "gram.c" /* yacc.c:1646  */
    break;

  case 942:
#line 6326 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_RELATION;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 30777 "gram.c" /* yacc.c:1646  */
    break;

  case 943:
#line 6334 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_RELATION;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 30789 "gram.c" /* yacc.c:1646  */
    break;

  case 944:
#line 6342 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_SEQUENCE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 30801 "gram.c" /* yacc.c:1646  */
    break;

  case 945:
#line 6350 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_FDW;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 30813 "gram.c" /* yacc.c:1646  */
    break;

  case 946:
#line 6358 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_FOREIGN_SERVER;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 30825 "gram.c" /* yacc.c:1646  */
    break;

  case 947:
#line 6366 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_FUNCTION;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 30837 "gram.c" /* yacc.c:1646  */
    break;

  case 948:
#line 6374 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_DATABASE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 30849 "gram.c" /* yacc.c:1646  */
    break;

  case 949:
#line 6382 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_DOMAIN;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 30861 "gram.c" /* yacc.c:1646  */
    break;

  case 950:
#line 6390 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_LANGUAGE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 30873 "gram.c" /* yacc.c:1646  */
    break;

  case 951:
#line 6398 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_LARGEOBJECT;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 30885 "gram.c" /* yacc.c:1646  */
    break;

  case 952:
#line 6406 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_NAMESPACE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 30897 "gram.c" /* yacc.c:1646  */
    break;

  case 953:
#line 6414 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_TABLESPACE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 30909 "gram.c" /* yacc.c:1646  */
    break;

  case 954:
#line 6422 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_TYPE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 30921 "gram.c" /* yacc.c:1646  */
    break;

  case 955:
#line 6430 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = ACL_OBJECT_RELATION;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 30933 "gram.c" /* yacc.c:1646  */
    break;

  case 956:
#line 6438 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = ACL_OBJECT_SEQUENCE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 30945 "gram.c" /* yacc.c:1646  */
    break;

  case 957:
#line 6446 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = ACL_OBJECT_FUNCTION;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 30957 "gram.c" /* yacc.c:1646  */
    break;

  case 958:
#line 6457 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 30963 "gram.c" /* yacc.c:1646  */
    break;

  case 959:
#line 6458 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 30969 "gram.c" /* yacc.c:1646  */
    break;

  case 960:
#line 6462 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 30975 "gram.c" /* yacc.c:1646  */
    break;

  case 961:
#line 6463 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 30981 "gram.c" /* yacc.c:1646  */
    break;

  case 962:
#line 6468 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 30987 "gram.c" /* yacc.c:1646  */
    break;

  case 963:
#line 6469 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 30993 "gram.c" /* yacc.c:1646  */
    break;

  case 964:
#line 6473 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].funwithargs)); }
#line 30999 "gram.c" /* yacc.c:1646  */
    break;

  case 965:
#line 6475 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].funwithargs)); }
#line 31005 "gram.c" /* yacc.c:1646  */
    break;

  case 966:
#line 6480 "gram.y" /* yacc.c:1646  */
    {
					FuncWithArgs *n = makeNode(FuncWithArgs);
					n->funcname = (yyvsp[-1].list);
					n->funcargs = extractArgTypes((yyvsp[0].list));
					(yyval.funwithargs) = n;
				}
#line 31016 "gram.c" /* yacc.c:1646  */
    break;

  case 967:
#line 6496 "gram.y" /* yacc.c:1646  */
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = true;
					n->granted_roles = (yyvsp[-4].list);
					n->grantee_roles = (yyvsp[-2].list);
					n->admin_opt = (yyvsp[-1].boolean);
					n->grantor = (yyvsp[0].node);
					(yyval.node) = (Node*)n;
				}
#line 31030 "gram.c" /* yacc.c:1646  */
    break;

  case 968:
#line 6509 "gram.y" /* yacc.c:1646  */
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = false;
					n->admin_opt = false;
					n->granted_roles = (yyvsp[-4].list);
					n->grantee_roles = (yyvsp[-2].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node*)n;
				}
#line 31044 "gram.c" /* yacc.c:1646  */
    break;

  case 969:
#line 6519 "gram.y" /* yacc.c:1646  */
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = false;
					n->admin_opt = true;
					n->granted_roles = (yyvsp[-4].list);
					n->grantee_roles = (yyvsp[-2].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node*)n;
				}
#line 31058 "gram.c" /* yacc.c:1646  */
    break;

  case 970:
#line 6530 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 31064 "gram.c" /* yacc.c:1646  */
    break;

  case 971:
#line 6531 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 31070 "gram.c" /* yacc.c:1646  */
    break;

  case 972:
#line 6534 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 31076 "gram.c" /* yacc.c:1646  */
    break;

  case 973:
#line 6535 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 31082 "gram.c" /* yacc.c:1646  */
    break;

  case 974:
#line 6546 "gram.y" /* yacc.c:1646  */
    {
					AlterDefaultPrivilegesStmt *n = makeNode(AlterDefaultPrivilegesStmt);
					n->options = (yyvsp[-1].list);
					n->action = (GrantStmt *) (yyvsp[0].node);
					(yyval.node) = (Node*)n;
				}
#line 31093 "gram.c" /* yacc.c:1646  */
    break;

  case 975:
#line 6555 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 31099 "gram.c" /* yacc.c:1646  */
    break;

  case 976:
#line 6556 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 31105 "gram.c" /* yacc.c:1646  */
    break;

  case 977:
#line 6561 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("schemas", (Node *)(yyvsp[0].list));
				}
#line 31113 "gram.c" /* yacc.c:1646  */
    break;

  case 978:
#line 6565 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("roles", (Node *)(yyvsp[0].list));
				}
#line 31121 "gram.c" /* yacc.c:1646  */
    break;

  case 979:
#line 6569 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("roles", (Node *)(yyvsp[0].list));
				}
#line 31129 "gram.c" /* yacc.c:1646  */
    break;

  case 980:
#line 6581 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = true;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[-3].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[-1].list);
					n->grant_option = (yyvsp[0].boolean);
					(yyval.node) = (Node*)n;
				}
#line 31145 "gram.c" /* yacc.c:1646  */
    break;

  case 981:
#line 6594 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = false;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[-3].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 31162 "gram.c" /* yacc.c:1646  */
    break;

  case 982:
#line 6608 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = true;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[-3].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 31179 "gram.c" /* yacc.c:1646  */
    break;

  case 983:
#line 6623 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ACL_OBJECT_RELATION; }
#line 31185 "gram.c" /* yacc.c:1646  */
    break;

  case 984:
#line 6624 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ACL_OBJECT_FUNCTION; }
#line 31191 "gram.c" /* yacc.c:1646  */
    break;

  case 985:
#line 6625 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ACL_OBJECT_SEQUENCE; }
#line 31197 "gram.c" /* yacc.c:1646  */
    break;

  case 986:
#line 6626 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ACL_OBJECT_TYPE; }
#line 31203 "gram.c" /* yacc.c:1646  */
    break;

  case 987:
#line 6641 "gram.y" /* yacc.c:1646  */
    {
					IndexStmt *n = makeNode(IndexStmt);
					n->unique = (yyvsp[-12].boolean);
					n->concurrent = (yyvsp[-10].boolean);
					n->idxname = (yyvsp[-9].str);
					n->relation = (yyvsp[-7].range);
					n->accessMethod = (yyvsp[-6].str);
					n->indexParams = (yyvsp[-4].list);
					n->options = (yyvsp[-2].list);
					n->tableSpace = (yyvsp[-1].str);
					n->whereClause = (yyvsp[0].node);
					n->excludeOpNames = NIL;
					n->idxcomment = NULL;
					n->indexOid = InvalidOid;
					n->oldNode = InvalidOid;
					n->primary = false;
					n->isconstraint = false;
					n->deferrable = false;
					n->initdeferred = false;
					n->transformed = false;
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
#line 31231 "gram.c" /* yacc.c:1646  */
    break;

  case 988:
#line 6667 "gram.y" /* yacc.c:1646  */
    {
					IndexStmt *n = makeNode(IndexStmt);
					n->unique = (yyvsp[-15].boolean);
					n->concurrent = (yyvsp[-13].boolean);
					n->idxname = (yyvsp[-9].str);
					n->relation = (yyvsp[-7].range);
					n->accessMethod = (yyvsp[-6].str);
					n->indexParams = (yyvsp[-4].list);
					n->options = (yyvsp[-2].list);
					n->tableSpace = (yyvsp[-1].str);
					n->whereClause = (yyvsp[0].node);
					n->excludeOpNames = NIL;
					n->idxcomment = NULL;
					n->indexOid = InvalidOid;
					n->oldNode = InvalidOid;
					n->primary = false;
					n->isconstraint = false;
					n->deferrable = false;
					n->initdeferred = false;
					n->transformed = false;
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
#line 31259 "gram.c" /* yacc.c:1646  */
    break;

  case 989:
#line 6693 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 31265 "gram.c" /* yacc.c:1646  */
    break;

  case 990:
#line 6694 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 31271 "gram.c" /* yacc.c:1646  */
    break;

  case 991:
#line 6698 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 31277 "gram.c" /* yacc.c:1646  */
    break;

  case 992:
#line 6699 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 31283 "gram.c" /* yacc.c:1646  */
    break;

  case 993:
#line 6703 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 31289 "gram.c" /* yacc.c:1646  */
    break;

  case 994:
#line 6704 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 31295 "gram.c" /* yacc.c:1646  */
    break;

  case 995:
#line 6708 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 31301 "gram.c" /* yacc.c:1646  */
    break;

  case 996:
#line 6709 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = DEFAULT_INDEX_TYPE; }
#line 31307 "gram.c" /* yacc.c:1646  */
    break;

  case 997:
#line 6712 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].ielem)); }
#line 31313 "gram.c" /* yacc.c:1646  */
    break;

  case 998:
#line 6713 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].ielem)); }
#line 31319 "gram.c" /* yacc.c:1646  */
    break;

  case 999:
#line 6722 "gram.y" /* yacc.c:1646  */
    {
					(yyval.ielem) = makeNode(IndexElem);
					(yyval.ielem)->name = (yyvsp[-4].str);
					(yyval.ielem)->expr = NULL;
					(yyval.ielem)->indexcolname = NULL;
					(yyval.ielem)->collation = (yyvsp[-3].list);
					(yyval.ielem)->opclass = (yyvsp[-2].list);
					(yyval.ielem)->ordering = (yyvsp[-1].ival);
					(yyval.ielem)->nulls_ordering = (yyvsp[0].ival);
				}
#line 31334 "gram.c" /* yacc.c:1646  */
    break;

  case 1000:
#line 6733 "gram.y" /* yacc.c:1646  */
    {
					(yyval.ielem) = makeNode(IndexElem);
					(yyval.ielem)->name = NULL;
					(yyval.ielem)->expr = (yyvsp[-4].node);
					(yyval.ielem)->indexcolname = NULL;
					(yyval.ielem)->collation = (yyvsp[-3].list);
					(yyval.ielem)->opclass = (yyvsp[-2].list);
					(yyval.ielem)->ordering = (yyvsp[-1].ival);
					(yyval.ielem)->nulls_ordering = (yyvsp[0].ival);
				}
#line 31349 "gram.c" /* yacc.c:1646  */
    break;

  case 1001:
#line 6744 "gram.y" /* yacc.c:1646  */
    {
					(yyval.ielem) = makeNode(IndexElem);
					(yyval.ielem)->name = NULL;
					(yyval.ielem)->expr = (yyvsp[-5].node);
					(yyval.ielem)->indexcolname = NULL;
					(yyval.ielem)->collation = (yyvsp[-3].list);
					(yyval.ielem)->opclass = (yyvsp[-2].list);
					(yyval.ielem)->ordering = (yyvsp[-1].ival);
					(yyval.ielem)->nulls_ordering = (yyvsp[0].ival);
				}
#line 31364 "gram.c" /* yacc.c:1646  */
    break;

  case 1002:
#line 6756 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 31370 "gram.c" /* yacc.c:1646  */
    break;

  case 1003:
#line 6757 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 31376 "gram.c" /* yacc.c:1646  */
    break;

  case 1004:
#line 6760 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 31382 "gram.c" /* yacc.c:1646  */
    break;

  case 1005:
#line 6761 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 31388 "gram.c" /* yacc.c:1646  */
    break;

  case 1006:
#line 6764 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_ASC; }
#line 31394 "gram.c" /* yacc.c:1646  */
    break;

  case 1007:
#line 6765 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_DESC; }
#line 31400 "gram.c" /* yacc.c:1646  */
    break;

  case 1008:
#line 6766 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_DEFAULT; }
#line 31406 "gram.c" /* yacc.c:1646  */
    break;

  case 1009:
#line 6769 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_NULLS_FIRST; }
#line 31412 "gram.c" /* yacc.c:1646  */
    break;

  case 1010:
#line 6770 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_NULLS_LAST; }
#line 31418 "gram.c" /* yacc.c:1646  */
    break;

  case 1011:
#line 6771 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_NULLS_DEFAULT; }
#line 31424 "gram.c" /* yacc.c:1646  */
    break;

  case 1012:
#line 6789 "gram.y" /* yacc.c:1646  */
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->replace = (yyvsp[-7].boolean);
					n->funcname = (yyvsp[-5].list);
					n->parameters = (yyvsp[-4].list);
					n->returnType = (yyvsp[-2].typnam);
					n->options = (yyvsp[-1].list);
					n->withClause = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 31439 "gram.c" /* yacc.c:1646  */
    break;

  case 1013:
#line 6801 "gram.y" /* yacc.c:1646  */
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->replace = (yyvsp[-10].boolean);
					n->funcname = (yyvsp[-8].list);
					n->parameters = mergeTableFuncParameters((yyvsp[-7].list), (yyvsp[-3].list));
					n->returnType = TableFuncTypeName((yyvsp[-3].list));
					n->returnType->location = (yylsp[-5]);
					n->options = (yyvsp[-1].list);
					n->withClause = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 31455 "gram.c" /* yacc.c:1646  */
    break;

  case 1014:
#line 6814 "gram.y" /* yacc.c:1646  */
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->replace = (yyvsp[-5].boolean);
					n->funcname = (yyvsp[-3].list);
					n->parameters = (yyvsp[-2].list);
					n->returnType = NULL;
					n->options = (yyvsp[-1].list);
					n->withClause = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 31470 "gram.c" /* yacc.c:1646  */
    break;

  case 1015:
#line 6827 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 31476 "gram.c" /* yacc.c:1646  */
    break;

  case 1016:
#line 6828 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 31482 "gram.c" /* yacc.c:1646  */
    break;

  case 1017:
#line 6831 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 31488 "gram.c" /* yacc.c:1646  */
    break;

  case 1018:
#line 6832 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 31494 "gram.c" /* yacc.c:1646  */
    break;

  case 1019:
#line 6836 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].fun_param)); }
#line 31500 "gram.c" /* yacc.c:1646  */
    break;

  case 1020:
#line 6837 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param)); }
#line 31506 "gram.c" /* yacc.c:1646  */
    break;

  case 1021:
#line 6845 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 31512 "gram.c" /* yacc.c:1646  */
    break;

  case 1022:
#line 6846 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 31518 "gram.c" /* yacc.c:1646  */
    break;

  case 1023:
#line 6850 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].fun_param)); }
#line 31524 "gram.c" /* yacc.c:1646  */
    break;

  case 1024:
#line 6852 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param)); }
#line 31530 "gram.c" /* yacc.c:1646  */
    break;

  case 1025:
#line 6867 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[-1].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = (yyvsp[-2].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 31543 "gram.c" /* yacc.c:1646  */
    break;

  case 1026:
#line 6876 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[-2].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = (yyvsp[-1].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 31556 "gram.c" /* yacc.c:1646  */
    break;

  case 1027:
#line 6885 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[-1].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = FUNC_PARAM_IN;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 31569 "gram.c" /* yacc.c:1646  */
    break;

  case 1028:
#line 6894 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = NULL;
					n->argType = (yyvsp[0].typnam);
					n->mode = (yyvsp[-1].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 31582 "gram.c" /* yacc.c:1646  */
    break;

  case 1029:
#line 6903 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = NULL;
					n->argType = (yyvsp[0].typnam);
					n->mode = FUNC_PARAM_IN;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 31595 "gram.c" /* yacc.c:1646  */
    break;

  case 1030:
#line 6914 "gram.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_IN; }
#line 31601 "gram.c" /* yacc.c:1646  */
    break;

  case 1031:
#line 6915 "gram.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_OUT; }
#line 31607 "gram.c" /* yacc.c:1646  */
    break;

  case 1032:
#line 6916 "gram.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_INOUT; }
#line 31613 "gram.c" /* yacc.c:1646  */
    break;

  case 1033:
#line 6917 "gram.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_INOUT; }
#line 31619 "gram.c" /* yacc.c:1646  */
    break;

  case 1034:
#line 6918 "gram.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_VARIADIC; }
#line 31625 "gram.c" /* yacc.c:1646  */
    break;

  case 1036:
#line 6929 "gram.y" /* yacc.c:1646  */
    {
					/* We can catch over-specified results here if we want to,
					 * but for now better to silently swallow typmod, etc.
					 * - thomas 2000-03-22
					 */
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 31637 "gram.c" /* yacc.c:1646  */
    break;

  case 1037:
#line 6943 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 31643 "gram.c" /* yacc.c:1646  */
    break;

  case 1038:
#line 6945 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[-3].str)), (yyvsp[-2].list)));
					(yyval.typnam)->pct_type = true;
					(yyval.typnam)->location = (yylsp[-3]);
				}
#line 31653 "gram.c" /* yacc.c:1646  */
    break;

  case 1039:
#line 6951 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[-3].str)), (yyvsp[-2].list)));
					(yyval.typnam)->pct_type = true;
					(yyval.typnam)->setof = TRUE;
					(yyval.typnam)->location = (yylsp[-3]);
				}
#line 31664 "gram.c" /* yacc.c:1646  */
    break;

  case 1040:
#line 6961 "gram.y" /* yacc.c:1646  */
    {
					(yyval.fun_param) = (yyvsp[0].fun_param);
				}
#line 31672 "gram.c" /* yacc.c:1646  */
    break;

  case 1041:
#line 6965 "gram.y" /* yacc.c:1646  */
    {
					(yyval.fun_param) = (yyvsp[-2].fun_param);
					(yyval.fun_param)->defexpr = (yyvsp[0].node);
				}
#line 31681 "gram.c" /* yacc.c:1646  */
    break;

  case 1042:
#line 6970 "gram.y" /* yacc.c:1646  */
    {
					(yyval.fun_param) = (yyvsp[-2].fun_param);
					(yyval.fun_param)->defexpr = (yyvsp[0].node);
				}
#line 31690 "gram.c" /* yacc.c:1646  */
    break;

  case 1043:
#line 6978 "gram.y" /* yacc.c:1646  */
    {
					if (!((yyvsp[0].fun_param)->mode == FUNC_PARAM_IN ||
						  (yyvsp[0].fun_param)->mode == FUNC_PARAM_VARIADIC))
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("aggregates cannot have output arguments"),
								 parser_errposition((yylsp[0]))));
					(yyval.fun_param) = (yyvsp[0].fun_param);
				}
#line 31704 "gram.c" /* yacc.c:1646  */
    break;

  case 1044:
#line 7019 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(NIL, makeInteger(-1));
				}
#line 31712 "gram.c" /* yacc.c:1646  */
    break;

  case 1045:
#line 7023 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[-1].list), makeInteger(-1));
				}
#line 31720 "gram.c" /* yacc.c:1646  */
    break;

  case 1046:
#line 7027 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[-1].list), makeInteger(0));
				}
#line 31728 "gram.c" /* yacc.c:1646  */
    break;

  case 1047:
#line 7031 "gram.y" /* yacc.c:1646  */
    {
					/* this is the only case requiring consistency checking */
					(yyval.list) = makeOrderedSetArgs((yyvsp[-4].list), (yyvsp[-1].list), yyscanner);
				}
#line 31737 "gram.c" /* yacc.c:1646  */
    break;

  case 1048:
#line 7038 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].fun_param)); }
#line 31743 "gram.c" /* yacc.c:1646  */
    break;

  case 1049:
#line 7039 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param)); }
#line 31749 "gram.c" /* yacc.c:1646  */
    break;

  case 1050:
#line 7044 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 31755 "gram.c" /* yacc.c:1646  */
    break;

  case 1051:
#line 7045 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 31761 "gram.c" /* yacc.c:1646  */
    break;

  case 1052:
#line 7053 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(FALSE));
				}
#line 31769 "gram.c" /* yacc.c:1646  */
    break;

  case 1053:
#line 7057 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(TRUE));
				}
#line 31777 "gram.c" /* yacc.c:1646  */
    break;

  case 1054:
#line 7061 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(TRUE));
				}
#line 31785 "gram.c" /* yacc.c:1646  */
    break;

  case 1055:
#line 7065 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("immutable"));
				}
#line 31793 "gram.c" /* yacc.c:1646  */
    break;

  case 1056:
#line 7069 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("stable"));
				}
#line 31801 "gram.c" /* yacc.c:1646  */
    break;

  case 1057:
#line 7073 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("volatile"));
				}
#line 31809 "gram.c" /* yacc.c:1646  */
    break;

  case 1058:
#line 7077 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(TRUE));
				}
#line 31817 "gram.c" /* yacc.c:1646  */
    break;

  case 1059:
#line 7081 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(FALSE));
				}
#line 31825 "gram.c" /* yacc.c:1646  */
    break;

  case 1060:
#line 7085 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(TRUE));
				}
#line 31833 "gram.c" /* yacc.c:1646  */
    break;

  case 1061:
#line 7089 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(FALSE));
				}
#line 31841 "gram.c" /* yacc.c:1646  */
    break;

  case 1062:
#line 7093 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("leakproof", (Node *)makeInteger(TRUE));
				}
#line 31849 "gram.c" /* yacc.c:1646  */
    break;

  case 1063:
#line 7097 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("leakproof", (Node *)makeInteger(FALSE));
				}
#line 31857 "gram.c" /* yacc.c:1646  */
    break;

  case 1064:
#line 7101 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cost", (Node *)(yyvsp[0].value));
				}
#line 31865 "gram.c" /* yacc.c:1646  */
    break;

  case 1065:
#line 7105 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("rows", (Node *)(yyvsp[0].value));
				}
#line 31873 "gram.c" /* yacc.c:1646  */
    break;

  case 1066:
#line 7109 "gram.y" /* yacc.c:1646  */
    {
					/* we abuse the normal content of a DefElem here */
					(yyval.defelt) = makeDefElem("set", (Node *)(yyvsp[0].vsetstmt));
				}
#line 31882 "gram.c" /* yacc.c:1646  */
    break;

  case 1067:
#line 7114 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("parallel", (Node *)makeString((yyvsp[0].str)));
				}
#line 31890 "gram.c" /* yacc.c:1646  */
    break;

  case 1068:
#line 7121 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("as", (Node *)(yyvsp[0].list));
				}
#line 31898 "gram.c" /* yacc.c:1646  */
    break;

  case 1069:
#line 7125 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("language", (Node *)makeString((yyvsp[0].str)));
				}
#line 31906 "gram.c" /* yacc.c:1646  */
    break;

  case 1070:
#line 7129 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("transform", (Node *)(yyvsp[0].list));
				}
#line 31914 "gram.c" /* yacc.c:1646  */
    break;

  case 1071:
#line 7133 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("window", (Node *)makeInteger(TRUE));
				}
#line 31922 "gram.c" /* yacc.c:1646  */
    break;

  case 1072:
#line 7137 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = (yyvsp[0].defelt);
				}
#line 31930 "gram.c" /* yacc.c:1646  */
    break;

  case 1073:
#line 7142 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 31936 "gram.c" /* yacc.c:1646  */
    break;

  case 1074:
#line 7144 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(makeString((yyvsp[-2].str)), makeString((yyvsp[0].str)));
				}
#line 31944 "gram.c" /* yacc.c:1646  */
    break;

  case 1075:
#line 7150 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].typnam)); }
#line 31950 "gram.c" /* yacc.c:1646  */
    break;

  case 1076:
#line 7151 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-4].list), (yyvsp[0].typnam)); }
#line 31956 "gram.c" /* yacc.c:1646  */
    break;

  case 1077:
#line 7155 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 31962 "gram.c" /* yacc.c:1646  */
    break;

  case 1078:
#line 7156 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 31968 "gram.c" /* yacc.c:1646  */
    break;

  case 1079:
#line 7160 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[-1].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = FUNC_PARAM_TABLE;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 31981 "gram.c" /* yacc.c:1646  */
    break;

  case 1080:
#line 7172 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].fun_param));
				}
#line 31989 "gram.c" /* yacc.c:1646  */
    break;

  case 1081:
#line 7176 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param));
				}
#line 31997 "gram.c" /* yacc.c:1646  */
    break;

  case 1082:
#line 7191 "gram.y" /* yacc.c:1646  */
    {
					AlterFunctionStmt *n = makeNode(AlterFunctionStmt);
					n->func = (yyvsp[-2].funwithargs);
					n->actions = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 32008 "gram.c" /* yacc.c:1646  */
    break;

  case 1083:
#line 7201 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 32014 "gram.c" /* yacc.c:1646  */
    break;

  case 1084:
#line 7202 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 32020 "gram.c" /* yacc.c:1646  */
    break;

  case 1087:
#line 7224 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FUNCTION;
					n->objects = list_make1((yyvsp[-2].list));
					n->arguments = list_make1(extractArgTypes((yyvsp[-1].list)));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 32035 "gram.c" /* yacc.c:1646  */
    break;

  case 1088:
#line 7235 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FUNCTION;
					n->objects = list_make1((yyvsp[-2].list));
					n->arguments = list_make1(extractArgTypes((yyvsp[-1].list)));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 32050 "gram.c" /* yacc.c:1646  */
    break;

  case 1089:
#line 7249 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_AGGREGATE;
					n->objects = list_make1((yyvsp[-2].list));
					n->arguments = list_make1(extractAggrArgTypes((yyvsp[-1].list)));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 32065 "gram.c" /* yacc.c:1646  */
    break;

  case 1090:
#line 7260 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_AGGREGATE;
					n->objects = list_make1((yyvsp[-2].list));
					n->arguments = list_make1(extractAggrArgTypes((yyvsp[-1].list)));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 32080 "gram.c" /* yacc.c:1646  */
    break;

  case 1091:
#line 7274 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_OPERATOR;
					n->objects = list_make1((yyvsp[-2].list));
					n->arguments = list_make1((yyvsp[-1].list));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 32095 "gram.c" /* yacc.c:1646  */
    break;

  case 1092:
#line 7285 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_OPERATOR;
					n->objects = list_make1((yyvsp[-2].list));
					n->arguments = list_make1((yyvsp[-1].list));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 32110 "gram.c" /* yacc.c:1646  */
    break;

  case 1093:
#line 7299 "gram.y" /* yacc.c:1646  */
    {
				   ereport(ERROR,
						   (errcode(ERRCODE_SYNTAX_ERROR),
							errmsg("missing argument"),
							errhint("Use NONE to denote the missing argument of a unary operator."),
							parser_errposition((yylsp[0]))));
				}
#line 32122 "gram.c" /* yacc.c:1646  */
    break;

  case 1094:
#line 7307 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[-3].typnam), (yyvsp[-1].typnam)); }
#line 32128 "gram.c" /* yacc.c:1646  */
    break;

  case 1095:
#line 7309 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(NULL, (yyvsp[-1].typnam)); }
#line 32134 "gram.c" /* yacc.c:1646  */
    break;

  case 1096:
#line 7311 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[-3].typnam), NULL); }
#line 32140 "gram.c" /* yacc.c:1646  */
    break;

  case 1097:
#line 7316 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 32146 "gram.c" /* yacc.c:1646  */
    break;

  case 1098:
#line 7318 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lcons(makeString((yyvsp[-2].str)), (yyvsp[0].list)); }
#line 32152 "gram.c" /* yacc.c:1646  */
    break;

  case 1099:
#line 7331 "gram.y" /* yacc.c:1646  */
    {
					DoStmt *n = makeNode(DoStmt);
					n->args = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 32162 "gram.c" /* yacc.c:1646  */
    break;

  case 1100:
#line 7339 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 32168 "gram.c" /* yacc.c:1646  */
    break;

  case 1101:
#line 7340 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 32174 "gram.c" /* yacc.c:1646  */
    break;

  case 1102:
#line 7345 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("as", (Node *)makeString((yyvsp[0].str)));
				}
#line 32182 "gram.c" /* yacc.c:1646  */
    break;

  case 1103:
#line 7349 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("language", (Node *)makeString((yyvsp[0].str)));
				}
#line 32190 "gram.c" /* yacc.c:1646  */
    break;

  case 1104:
#line 7362 "gram.y" /* yacc.c:1646  */
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);
					n->sourcetype = (yyvsp[-7].typnam);
					n->targettype = (yyvsp[-5].typnam);
					n->func = (yyvsp[-1].funwithargs);
					n->context = (CoercionContext) (yyvsp[0].ival);
					n->inout = false;
					(yyval.node) = (Node *)n;
				}
#line 32204 "gram.c" /* yacc.c:1646  */
    break;

  case 1105:
#line 7373 "gram.y" /* yacc.c:1646  */
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);
					n->sourcetype = (yyvsp[-6].typnam);
					n->targettype = (yyvsp[-4].typnam);
					n->func = NULL;
					n->context = (CoercionContext) (yyvsp[0].ival);
					n->inout = false;
					(yyval.node) = (Node *)n;
				}
#line 32218 "gram.c" /* yacc.c:1646  */
    break;

  case 1106:
#line 7384 "gram.y" /* yacc.c:1646  */
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);
					n->sourcetype = (yyvsp[-6].typnam);
					n->targettype = (yyvsp[-4].typnam);
					n->func = NULL;
					n->context = (CoercionContext) (yyvsp[0].ival);
					n->inout = true;
					(yyval.node) = (Node *)n;
				}
#line 32232 "gram.c" /* yacc.c:1646  */
    break;

  case 1107:
#line 7395 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = COERCION_IMPLICIT; }
#line 32238 "gram.c" /* yacc.c:1646  */
    break;

  case 1108:
#line 7396 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = COERCION_ASSIGNMENT; }
#line 32244 "gram.c" /* yacc.c:1646  */
    break;

  case 1109:
#line 7397 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = COERCION_EXPLICIT; }
#line 32250 "gram.c" /* yacc.c:1646  */
    break;

  case 1110:
#line 7402 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_CAST;
					n->objects = list_make1(list_make1((yyvsp[-4].typnam)));
					n->arguments = list_make1(list_make1((yyvsp[-2].typnam)));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = (yyvsp[-6].boolean);
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 32265 "gram.c" /* yacc.c:1646  */
    break;

  case 1111:
#line 7414 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 32271 "gram.c" /* yacc.c:1646  */
    break;

  case 1112:
#line 7415 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 32277 "gram.c" /* yacc.c:1646  */
    break;

  case 1113:
#line 7426 "gram.y" /* yacc.c:1646  */
    {
					CreateTransformStmt *n = makeNode(CreateTransformStmt);
					n->replace = (yyvsp[-8].boolean);
					n->type_name = (yyvsp[-5].typnam);
					n->lang = (yyvsp[-3].str);
					n->fromsql = linitial((yyvsp[-1].list));
					n->tosql = lsecond((yyvsp[-1].list));
					(yyval.node) = (Node *)n;
				}
#line 32291 "gram.c" /* yacc.c:1646  */
    break;

  case 1114:
#line 7438 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[-6].funwithargs), (yyvsp[0].funwithargs));
				}
#line 32299 "gram.c" /* yacc.c:1646  */
    break;

  case 1115:
#line 7442 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[0].funwithargs), (yyvsp[-6].funwithargs));
				}
#line 32307 "gram.c" /* yacc.c:1646  */
    break;

  case 1116:
#line 7446 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[0].funwithargs), NULL);
				}
#line 32315 "gram.c" /* yacc.c:1646  */
    break;

  case 1117:
#line 7450 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(NULL, (yyvsp[0].funwithargs));
				}
#line 32323 "gram.c" /* yacc.c:1646  */
    break;

  case 1118:
#line 7457 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_TRANSFORM;
					n->objects = list_make1(list_make1((yyvsp[-3].typnam)));
					n->arguments = list_make1(list_make1(makeString((yyvsp[-1].str))));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = (yyvsp[-5].boolean);
					(yyval.node) = (Node *)n;
				}
#line 32337 "gram.c" /* yacc.c:1646  */
    break;

  case 1119:
#line 7478 "gram.y" /* yacc.c:1646  */
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = (yyvsp[-1].ival);
					n->relation = (yyvsp[0].range);
					n->name = NULL;
					n->options = 0;
					(yyval.node) = (Node *)n;
				}
#line 32350 "gram.c" /* yacc.c:1646  */
    break;

  case 1120:
#line 7487 "gram.y" /* yacc.c:1646  */
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = (yyvsp[-1].ival);
					n->name = (yyvsp[0].str);
					n->relation = NULL;
					n->options = 0;
					(yyval.node) = (Node *)n;
				}
#line 32363 "gram.c" /* yacc.c:1646  */
    break;

  case 1121:
#line 7496 "gram.y" /* yacc.c:1646  */
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = (yyvsp[-1].ival);
					n->relation = (yyvsp[0].range);
					n->name = NULL;
					n->options = (yyvsp[-3].ival);
					(yyval.node) = (Node *)n;
				}
#line 32376 "gram.c" /* yacc.c:1646  */
    break;

  case 1122:
#line 7505 "gram.y" /* yacc.c:1646  */
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = (yyvsp[-1].ival);
					n->name = (yyvsp[0].str);
					n->relation = NULL;
					n->options = (yyvsp[-3].ival);
					(yyval.node) = (Node *)n;
				}
#line 32389 "gram.c" /* yacc.c:1646  */
    break;

  case 1123:
#line 7515 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = REINDEX_OBJECT_INDEX; }
#line 32395 "gram.c" /* yacc.c:1646  */
    break;

  case 1124:
#line 7516 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = REINDEX_OBJECT_TABLE; }
#line 32401 "gram.c" /* yacc.c:1646  */
    break;

  case 1125:
#line 7519 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = REINDEX_OBJECT_SCHEMA; }
#line 32407 "gram.c" /* yacc.c:1646  */
    break;

  case 1126:
#line 7520 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = REINDEX_OBJECT_SYSTEM; }
#line 32413 "gram.c" /* yacc.c:1646  */
    break;

  case 1127:
#line 7521 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = REINDEX_OBJECT_DATABASE; }
#line 32419 "gram.c" /* yacc.c:1646  */
    break;

  case 1128:
#line 7524 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[0].ival); }
#line 32425 "gram.c" /* yacc.c:1646  */
    break;

  case 1129:
#line 7525 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-2].ival) | (yyvsp[0].ival); }
#line 32431 "gram.c" /* yacc.c:1646  */
    break;

  case 1130:
#line 7528 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = REINDEXOPT_VERBOSE; }
#line 32437 "gram.c" /* yacc.c:1646  */
    break;

  case 1131:
#line 7539 "gram.y" /* yacc.c:1646  */
    {
					AlterTableSpaceOptionsStmt *n =
						makeNode(AlterTableSpaceOptionsStmt);
					n->tablespacename = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					n->isReset = FALSE;
					(yyval.node) = (Node *)n;
				}
#line 32450 "gram.c" /* yacc.c:1646  */
    break;

  case 1132:
#line 7548 "gram.y" /* yacc.c:1646  */
    {
					AlterTableSpaceOptionsStmt *n =
						makeNode(AlterTableSpaceOptionsStmt);
					n->tablespacename = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					n->isReset = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 32463 "gram.c" /* yacc.c:1646  */
    break;

  case 1133:
#line 7565 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_AGGREGATE;
					n->object = (yyvsp[-4].list);
					n->objarg = extractAggrArgTypes((yyvsp[-3].list));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 32477 "gram.c" /* yacc.c:1646  */
    break;

  case 1134:
#line 7575 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLLATION;
					n->object = (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 32490 "gram.c" /* yacc.c:1646  */
    break;

  case 1135:
#line 7584 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_CONVERSION;
					n->object = (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 32503 "gram.c" /* yacc.c:1646  */
    break;

  case 1136:
#line 7593 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_DATABASE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 32516 "gram.c" /* yacc.c:1646  */
    break;

  case 1137:
#line 7602 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_DOMAIN;
					n->object = (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 32529 "gram.c" /* yacc.c:1646  */
    break;

  case 1138:
#line 7611 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_DOMCONSTRAINT;
					n->object = (yyvsp[-5].list);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 32542 "gram.c" /* yacc.c:1646  */
    break;

  case 1139:
#line 7620 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FDW;
					n->object = list_make1(makeString((yyvsp[-3].str)));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 32555 "gram.c" /* yacc.c:1646  */
    break;

  case 1140:
#line 7629 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FUNCTION;
					n->object = (yyvsp[-3].funwithargs)->funcname;
					n->objarg = (yyvsp[-3].funwithargs)->funcargs;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 32569 "gram.c" /* yacc.c:1646  */
    break;

  case 1141:
#line 7639 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 32582 "gram.c" /* yacc.c:1646  */
    break;

  case 1142:
#line 7648 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_LANGUAGE;
					n->object = list_make1(makeString((yyvsp[-3].str)));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 32595 "gram.c" /* yacc.c:1646  */
    break;

  case 1143:
#line 7657 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_OPCLASS;
					n->object = lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 32608 "gram.c" /* yacc.c:1646  */
    break;

  case 1144:
#line 7666 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_OPFAMILY;
					n->object = lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 32621 "gram.c" /* yacc.c:1646  */
    break;

  case 1145:
#line 7675 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_POLICY;
					n->relation = (yyvsp[-3].range);
					n->subname = (yyvsp[-5].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 32635 "gram.c" /* yacc.c:1646  */
    break;

  case 1146:
#line 7685 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_POLICY;
					n->relation = (yyvsp[-3].range);
					n->subname = (yyvsp[-5].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 32649 "gram.c" /* yacc.c:1646  */
    break;

  case 1147:
#line 7695 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_SCHEMA;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 32662 "gram.c" /* yacc.c:1646  */
    break;

  case 1148:
#line 7704 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FOREIGN_SERVER;
					n->object = list_make1(makeString((yyvsp[-3].str)));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 32675 "gram.c" /* yacc.c:1646  */
    break;

  case 1149:
#line 7713 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 32689 "gram.c" /* yacc.c:1646  */
    break;

  case 1150:
#line 7723 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 32703 "gram.c" /* yacc.c:1646  */
    break;

  case 1151:
#line 7733 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 32717 "gram.c" /* yacc.c:1646  */
    break;

  case 1152:
#line 7743 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 32731 "gram.c" /* yacc.c:1646  */
    break;

  case 1153:
#line 7753 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 32745 "gram.c" /* yacc.c:1646  */
    break;

  case 1154:
#line 7763 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 32759 "gram.c" /* yacc.c:1646  */
    break;

  case 1155:
#line 7773 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 32773 "gram.c" /* yacc.c:1646  */
    break;

  case 1156:
#line 7783 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 32787 "gram.c" /* yacc.c:1646  */
    break;

  case 1157:
#line 7793 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_INDEX;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 32801 "gram.c" /* yacc.c:1646  */
    break;

  case 1158:
#line 7803 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_INDEX;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 32815 "gram.c" /* yacc.c:1646  */
    break;

  case 1159:
#line 7813 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 32829 "gram.c" /* yacc.c:1646  */
    break;

  case 1160:
#line 7823 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 32843 "gram.c" /* yacc.c:1646  */
    break;

  case 1161:
#line 7833 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 32858 "gram.c" /* yacc.c:1646  */
    break;

  case 1162:
#line 7844 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 32873 "gram.c" /* yacc.c:1646  */
    break;

  case 1163:
#line 7855 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 32888 "gram.c" /* yacc.c:1646  */
    break;

  case 1164:
#line 7866 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 32903 "gram.c" /* yacc.c:1646  */
    break;

  case 1165:
#line 7877 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABCONSTRAINT;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 32917 "gram.c" /* yacc.c:1646  */
    break;

  case 1166:
#line 7887 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABCONSTRAINT;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 32931 "gram.c" /* yacc.c:1646  */
    break;

  case 1167:
#line 7897 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 32946 "gram.c" /* yacc.c:1646  */
    break;

  case 1168:
#line 7908 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 32961 "gram.c" /* yacc.c:1646  */
    break;

  case 1169:
#line 7919 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_RULE;
					n->relation = (yyvsp[-3].range);
					n->subname = (yyvsp[-5].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 32975 "gram.c" /* yacc.c:1646  */
    break;

  case 1170:
#line 7929 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TRIGGER;
					n->relation = (yyvsp[-3].range);
					n->subname = (yyvsp[-5].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 32989 "gram.c" /* yacc.c:1646  */
    break;

  case 1171:
#line 7939 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_EVENT_TRIGGER;
					n->object = list_make1(makeString((yyvsp[-3].str)));
					n->newname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 33001 "gram.c" /* yacc.c:1646  */
    break;

  case 1172:
#line 7947 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 33014 "gram.c" /* yacc.c:1646  */
    break;

  case 1173:
#line 7956 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 33027 "gram.c" /* yacc.c:1646  */
    break;

  case 1174:
#line 7965 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABLESPACE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 33040 "gram.c" /* yacc.c:1646  */
    break;

  case 1175:
#line 7974 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSPARSER;
					n->object = (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 33053 "gram.c" /* yacc.c:1646  */
    break;

  case 1176:
#line 7983 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSDICTIONARY;
					n->object = (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 33066 "gram.c" /* yacc.c:1646  */
    break;

  case 1177:
#line 7992 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSTEMPLATE;
					n->object = (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 33079 "gram.c" /* yacc.c:1646  */
    break;

  case 1178:
#line 8001 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSCONFIGURATION;
					n->object = (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 33092 "gram.c" /* yacc.c:1646  */
    break;

  case 1179:
#line 8010 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TYPE;
					n->object = (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 33105 "gram.c" /* yacc.c:1646  */
    break;

  case 1180:
#line 8019 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ATTRIBUTE;
					n->relationType = OBJECT_TYPE;
					n->relation = makeRangeVarFromAnyName((yyvsp[-6].list), (yylsp[-6]), yyscanner);
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 33121 "gram.c" /* yacc.c:1646  */
    break;

  case 1181:
#line 8032 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = COLUMN; }
#line 33127 "gram.c" /* yacc.c:1646  */
    break;

  case 1182:
#line 8033 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 33133 "gram.c" /* yacc.c:1646  */
    break;

  case 1183:
#line 8036 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 1; }
#line 33139 "gram.c" /* yacc.c:1646  */
    break;

  case 1184:
#line 8037 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 33145 "gram.c" /* yacc.c:1646  */
    break;

  case 1185:
#line 8048 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);
					n->objectType = OBJECT_FUNCTION;
					n->relation = NULL;
					n->objname = (yyvsp[-4].funwithargs)->funcname;
					n->objargs = (yyvsp[-4].funwithargs)->funcargs;
					n->extname = makeString((yyvsp[0].str));
					(yyval.node) = (Node *)n;
				}
#line 33159 "gram.c" /* yacc.c:1646  */
    break;

  case 1186:
#line 8058 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);
					n->objectType = OBJECT_TRIGGER;
					n->relation = (yyvsp[-4].range);
					n->objname = list_make1(makeString((yyvsp[-6].str)));
					n->objargs = NIL;
					n->extname = makeString((yyvsp[0].str));
					(yyval.node) = (Node *)n;
				}
#line 33173 "gram.c" /* yacc.c:1646  */
    break;

  case 1187:
#line 8068 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);
					n->objectType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-4].range);
					n->objname = NIL;
					n->objargs = NIL;
					n->extname = makeString((yyvsp[0].str));
					(yyval.node) = (Node *)n;
				}
#line 33187 "gram.c" /* yacc.c:1646  */
    break;

  case 1188:
#line 8078 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);
					n->objectType = OBJECT_INDEX;
					n->relation = (yyvsp[-4].range);
					n->objname = NIL;
					n->objargs = NIL;
					n->extname = makeString((yyvsp[0].str));
					(yyval.node) = (Node *)n;
				}
#line 33201 "gram.c" /* yacc.c:1646  */
    break;

  case 1189:
#line 8097 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_AGGREGATE;
					n->object = (yyvsp[-4].list);
					n->objarg = extractAggrArgTypes((yyvsp[-3].list));
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 33215 "gram.c" /* yacc.c:1646  */
    break;

  case 1190:
#line 8107 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_COLLATION;
					n->object = (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 33228 "gram.c" /* yacc.c:1646  */
    break;

  case 1191:
#line 8116 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_CONVERSION;
					n->object = (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 33241 "gram.c" /* yacc.c:1646  */
    break;

  case 1192:
#line 8125 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_DOMAIN;
					n->object = (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 33254 "gram.c" /* yacc.c:1646  */
    break;

  case 1193:
#line 8134 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_EXTENSION;
					n->object = (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 33267 "gram.c" /* yacc.c:1646  */
    break;

  case 1194:
#line 8143 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_FUNCTION;
					n->object = (yyvsp[-3].funwithargs)->funcname;
					n->objarg = (yyvsp[-3].funwithargs)->funcargs;
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 33281 "gram.c" /* yacc.c:1646  */
    break;

  case 1195:
#line 8153 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_OPERATOR;
					n->object = (yyvsp[-4].list);
					n->objarg = (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 33295 "gram.c" /* yacc.c:1646  */
    break;

  case 1196:
#line 8163 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_OPCLASS;
					n->object = lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 33308 "gram.c" /* yacc.c:1646  */
    break;

  case 1197:
#line 8172 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_OPFAMILY;
					n->object = lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 33321 "gram.c" /* yacc.c:1646  */
    break;

  case 1198:
#line 8181 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 33334 "gram.c" /* yacc.c:1646  */
    break;

  case 1199:
#line 8190 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 33347 "gram.c" /* yacc.c:1646  */
    break;

  case 1200:
#line 8199 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TSPARSER;
					n->object = (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 33360 "gram.c" /* yacc.c:1646  */
    break;

  case 1201:
#line 8208 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TSDICTIONARY;
					n->object = (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 33373 "gram.c" /* yacc.c:1646  */
    break;

  case 1202:
#line 8217 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TSTEMPLATE;
					n->object = (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 33386 "gram.c" /* yacc.c:1646  */
    break;

  case 1203:
#line 8226 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TSCONFIGURATION;
					n->object = (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 33399 "gram.c" /* yacc.c:1646  */
    break;

  case 1204:
#line 8235 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 33412 "gram.c" /* yacc.c:1646  */
    break;

  case 1205:
#line 8244 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 33425 "gram.c" /* yacc.c:1646  */
    break;

  case 1206:
#line 8253 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 33438 "gram.c" /* yacc.c:1646  */
    break;

  case 1207:
#line 8262 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 33451 "gram.c" /* yacc.c:1646  */
    break;

  case 1208:
#line 8271 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 33464 "gram.c" /* yacc.c:1646  */
    break;

  case 1209:
#line 8280 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 33477 "gram.c" /* yacc.c:1646  */
    break;

  case 1210:
#line 8289 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 33490 "gram.c" /* yacc.c:1646  */
    break;

  case 1211:
#line 8298 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 33503 "gram.c" /* yacc.c:1646  */
    break;

  case 1212:
#line 8307 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TYPE;
					n->object = (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 33516 "gram.c" /* yacc.c:1646  */
    break;

  case 1213:
#line 8325 "gram.y" /* yacc.c:1646  */
    {
					AlterOperatorStmt *n = makeNode(AlterOperatorStmt);
					n->opername = (yyvsp[-5].list);
					n->operargs = (yyvsp[-4].list);
					n->options = (yyvsp[-1].list);
					(yyval.node) = (Node *)n;
				}
#line 33528 "gram.c" /* yacc.c:1646  */
    break;

  case 1214:
#line 8334 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 33534 "gram.c" /* yacc.c:1646  */
    break;

  case 1215:
#line 8335 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 33540 "gram.c" /* yacc.c:1646  */
    break;

  case 1216:
#line 8339 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem((yyvsp[-2].str), NULL); }
#line 33546 "gram.c" /* yacc.c:1646  */
    break;

  case 1217:
#line 8341 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) (yyvsp[0].node)); }
#line 33552 "gram.c" /* yacc.c:1646  */
    break;

  case 1218:
#line 8351 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_AGGREGATE;
					n->object = (yyvsp[-4].list);
					n->objarg = extractAggrArgTypes((yyvsp[-3].list));
					n->newowner = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 33565 "gram.c" /* yacc.c:1646  */
    break;

  case 1219:
#line 8360 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_COLLATION;
					n->object = (yyvsp[-3].list);
					n->newowner = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 33577 "gram.c" /* yacc.c:1646  */
    break;

  case 1220:
#line 8368 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_CONVERSION;
					n->object = (yyvsp[-3].list);
					n->newowner = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 33589 "gram.c" /* yacc.c:1646  */
    break;

  case 1221:
#line 8376 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_DATABASE;
					n->object = list_make1(makeString((yyvsp[-3].str)));
					n->newowner = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 33601 "gram.c" /* yacc.c:1646  */
    break;

  case 1222:
#line 8384 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_DOMAIN;
					n->object = (yyvsp[-3].list);
					n->newowner = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 33613 "gram.c" /* yacc.c:1646  */
    break;

  case 1223:
#line 8392 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_FUNCTION;
					n->object = (yyvsp[-3].funwithargs)->funcname;
					n->objarg = (yyvsp[-3].funwithargs)->funcargs;
					n->newowner = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 33626 "gram.c" /* yacc.c:1646  */
    break;

  case 1224:
#line 8401 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_LANGUAGE;
					n->object = list_make1(makeString((yyvsp[-3].str)));
					n->newowner = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 33638 "gram.c" /* yacc.c:1646  */
    break;

  case 1225:
#line 8409 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_LARGEOBJECT;
					n->object = list_make1((yyvsp[-3].value));
					n->newowner = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 33650 "gram.c" /* yacc.c:1646  */
    break;

  case 1226:
#line 8417 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_OPERATOR;
					n->object = (yyvsp[-4].list);
					n->objarg = (yyvsp[-3].list);
					n->newowner = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 33663 "gram.c" /* yacc.c:1646  */
    break;

  case 1227:
#line 8426 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_OPCLASS;
					n->object = lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newowner = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 33675 "gram.c" /* yacc.c:1646  */
    break;

  case 1228:
#line 8434 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_OPFAMILY;
					n->object = lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newowner = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 33687 "gram.c" /* yacc.c:1646  */
    break;

  case 1229:
#line 8442 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_SCHEMA;
					n->object = list_make1(makeString((yyvsp[-3].str)));
					n->newowner = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 33699 "gram.c" /* yacc.c:1646  */
    break;

  case 1230:
#line 8450 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TYPE;
					n->object = (yyvsp[-3].list);
					n->newowner = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 33711 "gram.c" /* yacc.c:1646  */
    break;

  case 1231:
#line 8458 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TABLESPACE;
					n->object = list_make1(makeString((yyvsp[-3].str)));
					n->newowner = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 33723 "gram.c" /* yacc.c:1646  */
    break;

  case 1232:
#line 8466 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TSDICTIONARY;
					n->object = (yyvsp[-3].list);
					n->newowner = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 33735 "gram.c" /* yacc.c:1646  */
    break;

  case 1233:
#line 8474 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TSCONFIGURATION;
					n->object = (yyvsp[-3].list);
					n->newowner = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 33747 "gram.c" /* yacc.c:1646  */
    break;

  case 1234:
#line 8482 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_FDW;
					n->object = list_make1(makeString((yyvsp[-3].str)));
					n->newowner = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 33759 "gram.c" /* yacc.c:1646  */
    break;

  case 1235:
#line 8490 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_FOREIGN_SERVER;
					n->object = list_make1(makeString((yyvsp[-3].str)));
					n->newowner = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 33771 "gram.c" /* yacc.c:1646  */
    break;

  case 1236:
#line 8498 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_EVENT_TRIGGER;
					n->object = list_make1(makeString((yyvsp[-3].str)));
					n->newowner = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 33783 "gram.c" /* yacc.c:1646  */
    break;

  case 1237:
#line 8517 "gram.y" /* yacc.c:1646  */
    {
					RuleStmt *n = makeNode(RuleStmt);
					n->replace = (yyvsp[-11].boolean);
					n->relation = (yyvsp[-4].range);
					n->rulename = (yyvsp[-9].str);
					n->whereClause = (yyvsp[-3].node);
					n->event = (yyvsp[-6].ival);
					n->instead = (yyvsp[-1].boolean);
					n->actions = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 33799 "gram.c" /* yacc.c:1646  */
    break;

  case 1238:
#line 8531 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 33805 "gram.c" /* yacc.c:1646  */
    break;

  case 1239:
#line 8532 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 33811 "gram.c" /* yacc.c:1646  */
    break;

  case 1240:
#line 8533 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 33817 "gram.c" /* yacc.c:1646  */
    break;

  case 1241:
#line 8539 "gram.y" /* yacc.c:1646  */
    { if ((yyvsp[0].node) != NULL)
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				  else
					(yyval.list) = (yyvsp[-2].list);
				}
#line 33827 "gram.c" /* yacc.c:1646  */
    break;

  case 1242:
#line 8545 "gram.y" /* yacc.c:1646  */
    { if ((yyvsp[0].node) != NULL)
					(yyval.list) = list_make1((yyvsp[0].node));
				  else
					(yyval.list) = NIL;
				}
#line 33837 "gram.c" /* yacc.c:1646  */
    break;

  case 1248:
#line 8561 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 33843 "gram.c" /* yacc.c:1646  */
    break;

  case 1249:
#line 8562 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 33849 "gram.c" /* yacc.c:1646  */
    break;

  case 1250:
#line 8565 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CMD_SELECT; }
#line 33855 "gram.c" /* yacc.c:1646  */
    break;

  case 1251:
#line 8566 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CMD_UPDATE; }
#line 33861 "gram.c" /* yacc.c:1646  */
    break;

  case 1252:
#line 8567 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CMD_DELETE; }
#line 33867 "gram.c" /* yacc.c:1646  */
    break;

  case 1253:
#line 8568 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CMD_INSERT; }
#line 33873 "gram.c" /* yacc.c:1646  */
    break;

  case 1254:
#line 8572 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 33879 "gram.c" /* yacc.c:1646  */
    break;

  case 1255:
#line 8573 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 33885 "gram.c" /* yacc.c:1646  */
    break;

  case 1256:
#line 8574 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 33891 "gram.c" /* yacc.c:1646  */
    break;

  case 1257:
#line 8580 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_RULE;
					n->objects = list_make1(lappend((yyvsp[-1].list), makeString((yyvsp[-3].str))));
					n->arguments = NIL;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 33906 "gram.c" /* yacc.c:1646  */
    break;

  case 1258:
#line 8591 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_RULE;
					n->objects = list_make1(lappend((yyvsp[-1].list), makeString((yyvsp[-3].str))));
					n->arguments = NIL;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 33921 "gram.c" /* yacc.c:1646  */
    break;

  case 1259:
#line 8613 "gram.y" /* yacc.c:1646  */
    {
					NotifyStmt *n = makeNode(NotifyStmt);
					n->conditionname = (yyvsp[-1].str);
					n->payload = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 33932 "gram.c" /* yacc.c:1646  */
    break;

  case 1260:
#line 8622 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 33938 "gram.c" /* yacc.c:1646  */
    break;

  case 1261:
#line 8623 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 33944 "gram.c" /* yacc.c:1646  */
    break;

  case 1262:
#line 8627 "gram.y" /* yacc.c:1646  */
    {
					ListenStmt *n = makeNode(ListenStmt);
					n->conditionname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 33954 "gram.c" /* yacc.c:1646  */
    break;

  case 1263:
#line 8636 "gram.y" /* yacc.c:1646  */
    {
					UnlistenStmt *n = makeNode(UnlistenStmt);
					n->conditionname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 33964 "gram.c" /* yacc.c:1646  */
    break;

  case 1264:
#line 8642 "gram.y" /* yacc.c:1646  */
    {
					UnlistenStmt *n = makeNode(UnlistenStmt);
					n->conditionname = NULL;
					(yyval.node) = (Node *)n;
				}
#line 33974 "gram.c" /* yacc.c:1646  */
    break;

  case 1265:
#line 8661 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				}
#line 33985 "gram.c" /* yacc.c:1646  */
    break;

  case 1266:
#line 8668 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_BEGIN;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 33996 "gram.c" /* yacc.c:1646  */
    break;

  case 1267:
#line 8675 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_START;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 34007 "gram.c" /* yacc.c:1646  */
    break;

  case 1268:
#line 8682 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				}
#line 34018 "gram.c" /* yacc.c:1646  */
    break;

  case 1269:
#line 8689 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				}
#line 34029 "gram.c" /* yacc.c:1646  */
    break;

  case 1270:
#line 8696 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				}
#line 34040 "gram.c" /* yacc.c:1646  */
    break;

  case 1271:
#line 8703 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_SAVEPOINT;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[0].str))));
					(yyval.node) = (Node *)n;
				}
#line 34052 "gram.c" /* yacc.c:1646  */
    break;

  case 1272:
#line 8711 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_RELEASE;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[0].str))));
					(yyval.node) = (Node *)n;
				}
#line 34064 "gram.c" /* yacc.c:1646  */
    break;

  case 1273:
#line 8719 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_RELEASE;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[0].str))));
					(yyval.node) = (Node *)n;
				}
#line 34076 "gram.c" /* yacc.c:1646  */
    break;

  case 1274:
#line 8727 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_TO;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[0].str))));
					(yyval.node) = (Node *)n;
				}
#line 34088 "gram.c" /* yacc.c:1646  */
    break;

  case 1275:
#line 8735 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_TO;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[0].str))));
					(yyval.node) = (Node *)n;
				}
#line 34100 "gram.c" /* yacc.c:1646  */
    break;

  case 1276:
#line 8743 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_PREPARE;
					n->gid = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 34111 "gram.c" /* yacc.c:1646  */
    break;

  case 1277:
#line 8750 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT_PREPARED;
					n->gid = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 34122 "gram.c" /* yacc.c:1646  */
    break;

  case 1278:
#line 8757 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_PREPARED;
					n->gid = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 34133 "gram.c" /* yacc.c:1646  */
    break;

  case 1279:
#line 8765 "gram.y" /* yacc.c:1646  */
    {}
#line 34139 "gram.c" /* yacc.c:1646  */
    break;

  case 1280:
#line 8766 "gram.y" /* yacc.c:1646  */
    {}
#line 34145 "gram.c" /* yacc.c:1646  */
    break;

  case 1281:
#line 8767 "gram.y" /* yacc.c:1646  */
    {}
#line 34151 "gram.c" /* yacc.c:1646  */
    break;

  case 1282:
#line 8772 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_isolation",
									   makeStringConst((yyvsp[0].str), (yylsp[0]))); }
#line 34158 "gram.c" /* yacc.c:1646  */
    break;

  case 1283:
#line 8775 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_read_only",
									   makeIntConst(TRUE, (yylsp[-1]))); }
#line 34165 "gram.c" /* yacc.c:1646  */
    break;

  case 1284:
#line 8778 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_read_only",
									   makeIntConst(FALSE, (yylsp[-1]))); }
#line 34172 "gram.c" /* yacc.c:1646  */
    break;

  case 1285:
#line 8781 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_deferrable",
									   makeIntConst(TRUE, (yylsp[0]))); }
#line 34179 "gram.c" /* yacc.c:1646  */
    break;

  case 1286:
#line 8784 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_deferrable",
									   makeIntConst(FALSE, (yylsp[-1]))); }
#line 34186 "gram.c" /* yacc.c:1646  */
    break;

  case 1287:
#line 8791 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 34192 "gram.c" /* yacc.c:1646  */
    break;

  case 1288:
#line 8793 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 34198 "gram.c" /* yacc.c:1646  */
    break;

  case 1289:
#line 8795 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 34204 "gram.c" /* yacc.c:1646  */
    break;

  case 1291:
#line 8801 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 34210 "gram.c" /* yacc.c:1646  */
    break;

  case 1292:
#line 8815 "gram.y" /* yacc.c:1646  */
    {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[-5].range);
					n->view->relpersistence = (yyvsp[-7].ival);
					n->aliases = (yyvsp[-4].list);
					n->query = (yyvsp[-1].node);
					n->replace = false;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					(yyval.node) = (Node *) n;
				}
#line 34226 "gram.c" /* yacc.c:1646  */
    break;

  case 1293:
#line 8828 "gram.y" /* yacc.c:1646  */
    {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[-5].range);
					n->view->relpersistence = (yyvsp[-7].ival);
					n->aliases = (yyvsp[-4].list);
					n->query = (yyvsp[-1].node);
					n->replace = true;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					(yyval.node) = (Node *) n;
				}
#line 34242 "gram.c" /* yacc.c:1646  */
    break;

  case 1294:
#line 8841 "gram.y" /* yacc.c:1646  */
    {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[-7].range);
					n->view->relpersistence = (yyvsp[-10].ival);
					n->aliases = (yyvsp[-5].list);
					n->query = makeRecursiveViewSelect(n->view->relname, n->aliases, (yyvsp[-1].node));
					n->replace = false;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					if (n->withCheckOption != NO_CHECK_OPTION)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("WITH CHECK OPTION not supported on recursive views"),
								 parser_errposition((yylsp[0]))));
					(yyval.node) = (Node *) n;
				}
#line 34263 "gram.c" /* yacc.c:1646  */
    break;

  case 1295:
#line 8859 "gram.y" /* yacc.c:1646  */
    {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[-7].range);
					n->view->relpersistence = (yyvsp[-10].ival);
					n->aliases = (yyvsp[-5].list);
					n->query = makeRecursiveViewSelect(n->view->relname, n->aliases, (yyvsp[-1].node));
					n->replace = true;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					if (n->withCheckOption != NO_CHECK_OPTION)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("WITH CHECK OPTION not supported on recursive views"),
								 parser_errposition((yylsp[0]))));
					(yyval.node) = (Node *) n;
				}
#line 34284 "gram.c" /* yacc.c:1646  */
    break;

  case 1296:
#line 8878 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CASCADED_CHECK_OPTION; }
#line 34290 "gram.c" /* yacc.c:1646  */
    break;

  case 1297:
#line 8879 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CASCADED_CHECK_OPTION; }
#line 34296 "gram.c" /* yacc.c:1646  */
    break;

  case 1298:
#line 8880 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LOCAL_CHECK_OPTION; }
#line 34302 "gram.c" /* yacc.c:1646  */
    break;

  case 1299:
#line 8881 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = NO_CHECK_OPTION; }
#line 34308 "gram.c" /* yacc.c:1646  */
    break;

  case 1300:
#line 8892 "gram.y" /* yacc.c:1646  */
    {
					LoadStmt *n = makeNode(LoadStmt);
					n->filename = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 34318 "gram.c" /* yacc.c:1646  */
    break;

  case 1301:
#line 8908 "gram.y" /* yacc.c:1646  */
    {
					CreatedbStmt *n = makeNode(CreatedbStmt);
					n->dbname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 34329 "gram.c" /* yacc.c:1646  */
    break;

  case 1302:
#line 8917 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 34335 "gram.c" /* yacc.c:1646  */
    break;

  case 1303:
#line 8918 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 34341 "gram.c" /* yacc.c:1646  */
    break;

  case 1304:
#line 8922 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 34347 "gram.c" /* yacc.c:1646  */
    break;

  case 1305:
#line 8923 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 34353 "gram.c" /* yacc.c:1646  */
    break;

  case 1306:
#line 8928 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *)makeInteger((yyvsp[0].ival)));
				}
#line 34361 "gram.c" /* yacc.c:1646  */
    break;

  case 1307:
#line 8932 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *)makeString((yyvsp[0].str)));
				}
#line 34369 "gram.c" /* yacc.c:1646  */
    break;

  case 1308:
#line 8936 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), NULL);
				}
#line 34377 "gram.c" /* yacc.c:1646  */
    break;

  case 1309:
#line 8953 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 34383 "gram.c" /* yacc.c:1646  */
    break;

  case 1310:
#line 8954 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup("connection_limit"); }
#line 34389 "gram.c" /* yacc.c:1646  */
    break;

  case 1311:
#line 8955 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 34395 "gram.c" /* yacc.c:1646  */
    break;

  case 1312:
#line 8956 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 34401 "gram.c" /* yacc.c:1646  */
    break;

  case 1313:
#line 8957 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 34407 "gram.c" /* yacc.c:1646  */
    break;

  case 1314:
#line 8958 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 34413 "gram.c" /* yacc.c:1646  */
    break;

  case 1315:
#line 8959 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 34419 "gram.c" /* yacc.c:1646  */
    break;

  case 1316:
#line 8966 "gram.y" /* yacc.c:1646  */
    {}
#line 34425 "gram.c" /* yacc.c:1646  */
    break;

  case 1317:
#line 8967 "gram.y" /* yacc.c:1646  */
    {}
#line 34431 "gram.c" /* yacc.c:1646  */
    break;

  case 1318:
#line 8979 "gram.y" /* yacc.c:1646  */
    {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);
					n->dbname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				 }
#line 34442 "gram.c" /* yacc.c:1646  */
    break;

  case 1319:
#line 8986 "gram.y" /* yacc.c:1646  */
    {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);
					n->dbname = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				 }
#line 34453 "gram.c" /* yacc.c:1646  */
    break;

  case 1320:
#line 8993 "gram.y" /* yacc.c:1646  */
    {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);
					n->dbname = (yyvsp[-3].str);
					n->options = list_make1(makeDefElem("tablespace",
													(Node *)makeString((yyvsp[0].str))));
					(yyval.node) = (Node *)n;
				 }
#line 34465 "gram.c" /* yacc.c:1646  */
    break;

  case 1321:
#line 9004 "gram.y" /* yacc.c:1646  */
    {
					AlterDatabaseSetStmt *n = makeNode(AlterDatabaseSetStmt);
					n->dbname = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 34476 "gram.c" /* yacc.c:1646  */
    break;

  case 1322:
#line 9021 "gram.y" /* yacc.c:1646  */
    {
					DropdbStmt *n = makeNode(DropdbStmt);
					n->dbname = (yyvsp[0].str);
					n->missing_ok = FALSE;
					(yyval.node) = (Node *)n;
				}
#line 34487 "gram.c" /* yacc.c:1646  */
    break;

  case 1323:
#line 9028 "gram.y" /* yacc.c:1646  */
    {
					DropdbStmt *n = makeNode(DropdbStmt);
					n->dbname = (yyvsp[0].str);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 34498 "gram.c" /* yacc.c:1646  */
    break;

  case 1324:
#line 9046 "gram.y" /* yacc.c:1646  */
    {
					AlterSystemStmt *n = makeNode(AlterSystemStmt);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 34508 "gram.c" /* yacc.c:1646  */
    break;

  case 1325:
#line 9052 "gram.y" /* yacc.c:1646  */
    {
					AlterSystemStmt *n = makeNode(AlterSystemStmt);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 34518 "gram.c" /* yacc.c:1646  */
    break;

  case 1326:
#line 9068 "gram.y" /* yacc.c:1646  */
    {
					CreateDomainStmt *n = makeNode(CreateDomainStmt);
					n->domainname = (yyvsp[-3].list);
					n->typeName = (yyvsp[-1].typnam);
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 34531 "gram.c" /* yacc.c:1646  */
    break;

  case 1327:
#line 9081 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'T';
					n->typeName = (yyvsp[-1].list);
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 34543 "gram.c" /* yacc.c:1646  */
    break;

  case 1328:
#line 9090 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'N';
					n->typeName = (yyvsp[-3].list);
					(yyval.node) = (Node *)n;
				}
#line 34554 "gram.c" /* yacc.c:1646  */
    break;

  case 1329:
#line 9098 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'O';
					n->typeName = (yyvsp[-3].list);
					(yyval.node) = (Node *)n;
				}
#line 34565 "gram.c" /* yacc.c:1646  */
    break;

  case 1330:
#line 9106 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'C';
					n->typeName = (yyvsp[-2].list);
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 34577 "gram.c" /* yacc.c:1646  */
    break;

  case 1331:
#line 9115 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'X';
					n->typeName = (yyvsp[-4].list);
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 34591 "gram.c" /* yacc.c:1646  */
    break;

  case 1332:
#line 9126 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'X';
					n->typeName = (yyvsp[-6].list);
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 34605 "gram.c" /* yacc.c:1646  */
    break;

  case 1333:
#line 9137 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'V';
					n->typeName = (yyvsp[-3].list);
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 34617 "gram.c" /* yacc.c:1646  */
    break;

  case 1334:
#line 9146 "gram.y" /* yacc.c:1646  */
    {}
#line 34623 "gram.c" /* yacc.c:1646  */
    break;

  case 1335:
#line 9147 "gram.y" /* yacc.c:1646  */
    {}
#line 34629 "gram.c" /* yacc.c:1646  */
    break;

  case 1336:
#line 9159 "gram.y" /* yacc.c:1646  */
    {
					AlterTSDictionaryStmt *n = makeNode(AlterTSDictionaryStmt);
					n->dictname = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 34640 "gram.c" /* yacc.c:1646  */
    break;

  case 1337:
#line 9169 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->kind = ALTER_TSCONFIG_ADD_MAPPING;
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = (yyvsp[-2].list);
					n->dicts = (yyvsp[0].list);
					n->override = false;
					n->replace = false;
					(yyval.node) = (Node*)n;
				}
#line 34655 "gram.c" /* yacc.c:1646  */
    break;

  case 1338:
#line 9180 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->kind = ALTER_TSCONFIG_ALTER_MAPPING_FOR_TOKEN;
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = (yyvsp[-2].list);
					n->dicts = (yyvsp[0].list);
					n->override = true;
					n->replace = false;
					(yyval.node) = (Node*)n;
				}
#line 34670 "gram.c" /* yacc.c:1646  */
    break;

  case 1339:
#line 9191 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->kind = ALTER_TSCONFIG_REPLACE_DICT;
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = NIL;
					n->dicts = list_make2((yyvsp[-2].list),(yyvsp[0].list));
					n->override = false;
					n->replace = true;
					(yyval.node) = (Node*)n;
				}
#line 34685 "gram.c" /* yacc.c:1646  */
    break;

  case 1340:
#line 9202 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->kind = ALTER_TSCONFIG_REPLACE_DICT_FOR_TOKEN;
					n->cfgname = (yyvsp[-8].list);
					n->tokentype = (yyvsp[-4].list);
					n->dicts = list_make2((yyvsp[-2].list),(yyvsp[0].list));
					n->override = false;
					n->replace = true;
					(yyval.node) = (Node*)n;
				}
#line 34700 "gram.c" /* yacc.c:1646  */
    break;

  case 1341:
#line 9213 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->kind = ALTER_TSCONFIG_DROP_MAPPING;
					n->cfgname = (yyvsp[-4].list);
					n->tokentype = (yyvsp[0].list);
					n->missing_ok = false;
					(yyval.node) = (Node*)n;
				}
#line 34713 "gram.c" /* yacc.c:1646  */
    break;

  case 1342:
#line 9222 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->kind = ALTER_TSCONFIG_DROP_MAPPING;
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = (yyvsp[0].list);
					n->missing_ok = true;
					(yyval.node) = (Node*)n;
				}
#line 34726 "gram.c" /* yacc.c:1646  */
    break;

  case 1343:
#line 9233 "gram.y" /* yacc.c:1646  */
    {}
#line 34732 "gram.c" /* yacc.c:1646  */
    break;

  case 1344:
#line 9234 "gram.y" /* yacc.c:1646  */
    {}
#line 34738 "gram.c" /* yacc.c:1646  */
    break;

  case 1345:
#line 9250 "gram.y" /* yacc.c:1646  */
    {
				CreateConversionStmt *n = makeNode(CreateConversionStmt);
				n->conversion_name = (yyvsp[-6].list);
				n->for_encoding_name = (yyvsp[-4].str);
				n->to_encoding_name = (yyvsp[-2].str);
				n->func_name = (yyvsp[0].list);
				n->def = (yyvsp[-8].boolean);
				(yyval.node) = (Node *)n;
			}
#line 34752 "gram.c" /* yacc.c:1646  */
    break;

  case 1346:
#line 9272 "gram.y" /* yacc.c:1646  */
    {
					ClusterStmt *n = makeNode(ClusterStmt);
					n->relation = (yyvsp[-1].range);
					n->indexname = (yyvsp[0].str);
					n->verbose = (yyvsp[-2].boolean);
					(yyval.node) = (Node*)n;
				}
#line 34764 "gram.c" /* yacc.c:1646  */
    break;

  case 1347:
#line 9280 "gram.y" /* yacc.c:1646  */
    {
					ClusterStmt *n = makeNode(ClusterStmt);
					n->relation = NULL;
					n->indexname = NULL;
					n->verbose = (yyvsp[0].boolean);
					(yyval.node) = (Node*)n;
				}
#line 34776 "gram.c" /* yacc.c:1646  */
    break;

  case 1348:
#line 9289 "gram.y" /* yacc.c:1646  */
    {
					ClusterStmt *n = makeNode(ClusterStmt);
					n->relation = (yyvsp[0].range);
					n->indexname = (yyvsp[-2].str);
					n->verbose = (yyvsp[-3].boolean);
					(yyval.node) = (Node*)n;
				}
#line 34788 "gram.c" /* yacc.c:1646  */
    break;

  case 1349:
#line 9299 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 34794 "gram.c" /* yacc.c:1646  */
    break;

  case 1350:
#line 9300 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 34800 "gram.c" /* yacc.c:1646  */
    break;

  case 1351:
#line 9313 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_VACUUM;
					if ((yyvsp[-2].boolean))
						n->options |= VACOPT_FULL;
					if ((yyvsp[-1].boolean))
						n->options |= VACOPT_FREEZE;
					if ((yyvsp[0].boolean))
						n->options |= VACOPT_VERBOSE;
					n->relation = NULL;
					n->va_cols = NIL;
					(yyval.node) = (Node *)n;
				}
#line 34818 "gram.c" /* yacc.c:1646  */
    break;

  case 1352:
#line 9327 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_VACUUM;
					if ((yyvsp[-3].boolean))
						n->options |= VACOPT_FULL;
					if ((yyvsp[-2].boolean))
						n->options |= VACOPT_FREEZE;
					if ((yyvsp[-1].boolean))
						n->options |= VACOPT_VERBOSE;
					n->relation = (yyvsp[0].range);
					n->va_cols = NIL;
					(yyval.node) = (Node *)n;
				}
#line 34836 "gram.c" /* yacc.c:1646  */
    break;

  case 1353:
#line 9341 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = (VacuumStmt *) (yyvsp[0].node);
					n->options |= VACOPT_VACUUM;
					if ((yyvsp[-3].boolean))
						n->options |= VACOPT_FULL;
					if ((yyvsp[-2].boolean))
						n->options |= VACOPT_FREEZE;
					if ((yyvsp[-1].boolean))
						n->options |= VACOPT_VERBOSE;
					(yyval.node) = (Node *)n;
				}
#line 34852 "gram.c" /* yacc.c:1646  */
    break;

  case 1354:
#line 9353 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_VACUUM | (yyvsp[-1].ival);
					n->relation = NULL;
					n->va_cols = NIL;
					(yyval.node) = (Node *) n;
				}
#line 34864 "gram.c" /* yacc.c:1646  */
    break;

  case 1355:
#line 9361 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_VACUUM | (yyvsp[-3].ival);
					n->relation = (yyvsp[-1].range);
					n->va_cols = (yyvsp[0].list);
					if (n->va_cols != NIL)	/* implies analyze */
						n->options |= VACOPT_ANALYZE;
					(yyval.node) = (Node *) n;
				}
#line 34878 "gram.c" /* yacc.c:1646  */
    break;

  case 1356:
#line 9373 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[0].ival); }
#line 34884 "gram.c" /* yacc.c:1646  */
    break;

  case 1357:
#line 9374 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-2].ival) | (yyvsp[0].ival); }
#line 34890 "gram.c" /* yacc.c:1646  */
    break;

  case 1358:
#line 9378 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = VACOPT_ANALYZE; }
#line 34896 "gram.c" /* yacc.c:1646  */
    break;

  case 1359:
#line 9379 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = VACOPT_VERBOSE; }
#line 34902 "gram.c" /* yacc.c:1646  */
    break;

  case 1360:
#line 9380 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = VACOPT_FREEZE; }
#line 34908 "gram.c" /* yacc.c:1646  */
    break;

  case 1361:
#line 9381 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = VACOPT_FULL; }
#line 34914 "gram.c" /* yacc.c:1646  */
    break;

  case 1362:
#line 9383 "gram.y" /* yacc.c:1646  */
    {
					if (strcmp((yyvsp[0].str), "disable_page_skipping") == 0)
						(yyval.ival) = VACOPT_DISABLE_PAGE_SKIPPING;
					else
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
							 errmsg("unrecognized VACUUM option \"%s\"", (yyvsp[0].str)),
									 parser_errposition((yylsp[0]))));
				}
#line 34928 "gram.c" /* yacc.c:1646  */
    break;

  case 1363:
#line 9396 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_ANALYZE;
					if ((yyvsp[0].boolean))
						n->options |= VACOPT_VERBOSE;
					n->relation = NULL;
					n->va_cols = NIL;
					(yyval.node) = (Node *)n;
				}
#line 34942 "gram.c" /* yacc.c:1646  */
    break;

  case 1364:
#line 9406 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_ANALYZE;
					if ((yyvsp[-2].boolean))
						n->options |= VACOPT_VERBOSE;
					n->relation = (yyvsp[-1].range);
					n->va_cols = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 34956 "gram.c" /* yacc.c:1646  */
    break;

  case 1365:
#line 9418 "gram.y" /* yacc.c:1646  */
    {}
#line 34962 "gram.c" /* yacc.c:1646  */
    break;

  case 1366:
#line 9419 "gram.y" /* yacc.c:1646  */
    {}
#line 34968 "gram.c" /* yacc.c:1646  */
    break;

  case 1367:
#line 9423 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 34974 "gram.c" /* yacc.c:1646  */
    break;

  case 1368:
#line 9424 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 34980 "gram.c" /* yacc.c:1646  */
    break;

  case 1369:
#line 9427 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 34986 "gram.c" /* yacc.c:1646  */
    break;

  case 1370:
#line 9428 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 34992 "gram.c" /* yacc.c:1646  */
    break;

  case 1371:
#line 9431 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 34998 "gram.c" /* yacc.c:1646  */
    break;

  case 1372:
#line 9432 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 35004 "gram.c" /* yacc.c:1646  */
    break;

  case 1373:
#line 9436 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 35010 "gram.c" /* yacc.c:1646  */
    break;

  case 1374:
#line 9437 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 35016 "gram.c" /* yacc.c:1646  */
    break;

  case 1375:
#line 9451 "gram.y" /* yacc.c:1646  */
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[0].node);
					n->options = NIL;
					(yyval.node) = (Node *) n;
				}
#line 35027 "gram.c" /* yacc.c:1646  */
    break;

  case 1376:
#line 9458 "gram.y" /* yacc.c:1646  */
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[0].node);
					n->options = list_make1(makeDefElem("analyze", NULL));
					if ((yyvsp[-1].boolean))
						n->options = lappend(n->options,
											 makeDefElem("verbose", NULL));
					(yyval.node) = (Node *) n;
				}
#line 35041 "gram.c" /* yacc.c:1646  */
    break;

  case 1377:
#line 9468 "gram.y" /* yacc.c:1646  */
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[0].node);
					n->options = list_make1(makeDefElem("verbose", NULL));
					(yyval.node) = (Node *) n;
				}
#line 35052 "gram.c" /* yacc.c:1646  */
    break;

  case 1378:
#line 9475 "gram.y" /* yacc.c:1646  */
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[0].node);
					n->options = (yyvsp[-2].list);
					(yyval.node) = (Node *) n;
				}
#line 35063 "gram.c" /* yacc.c:1646  */
    break;

  case 1388:
#line 9497 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 35071 "gram.c" /* yacc.c:1646  */
    break;

  case 1389:
#line 9501 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 35079 "gram.c" /* yacc.c:1646  */
    break;

  case 1390:
#line 9508 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node));
				}
#line 35087 "gram.c" /* yacc.c:1646  */
    break;

  case 1391:
#line 9514 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 35093 "gram.c" /* yacc.c:1646  */
    break;

  case 1392:
#line 9515 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "analyze"; }
#line 35099 "gram.c" /* yacc.c:1646  */
    break;

  case 1393:
#line 9519 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 35105 "gram.c" /* yacc.c:1646  */
    break;

  case 1394:
#line 9520 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].value); }
#line 35111 "gram.c" /* yacc.c:1646  */
    break;

  case 1395:
#line 9521 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 35117 "gram.c" /* yacc.c:1646  */
    break;

  case 1396:
#line 9532 "gram.y" /* yacc.c:1646  */
    {
					PrepareStmt *n = makeNode(PrepareStmt);
					n->name = (yyvsp[-3].str);
					n->argtypes = (yyvsp[-2].list);
					n->query = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 35129 "gram.c" /* yacc.c:1646  */
    break;

  case 1397:
#line 9541 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 35135 "gram.c" /* yacc.c:1646  */
    break;

  case 1398:
#line 9542 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 35141 "gram.c" /* yacc.c:1646  */
    break;

  case 1403:
#line 9560 "gram.y" /* yacc.c:1646  */
    {
					ExecuteStmt *n = makeNode(ExecuteStmt);
					n->name = (yyvsp[-1].str);
					n->params = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 35152 "gram.c" /* yacc.c:1646  */
    break;

  case 1404:
#line 9568 "gram.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ExecuteStmt *n = makeNode(ExecuteStmt);
					n->name = (yyvsp[-2].str);
					n->params = (yyvsp[-1].list);
					ctas->query = (Node *) n;
					ctas->into = (yyvsp[-5].into);
					ctas->relkind = OBJECT_TABLE;
					ctas->is_select_into = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[-5].into)->rel->relpersistence = (yyvsp[-7].ival);
					(yyvsp[-5].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 35171 "gram.c" /* yacc.c:1646  */
    break;

  case 1405:
#line 9584 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 35177 "gram.c" /* yacc.c:1646  */
    break;

  case 1406:
#line 9585 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 35183 "gram.c" /* yacc.c:1646  */
    break;

  case 1407:
#line 9596 "gram.y" /* yacc.c:1646  */
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = (yyvsp[0].str);
						(yyval.node) = (Node *) n;
					}
#line 35193 "gram.c" /* yacc.c:1646  */
    break;

  case 1408:
#line 9602 "gram.y" /* yacc.c:1646  */
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = (yyvsp[0].str);
						(yyval.node) = (Node *) n;
					}
#line 35203 "gram.c" /* yacc.c:1646  */
    break;

  case 1409:
#line 9608 "gram.y" /* yacc.c:1646  */
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = NULL;
						(yyval.node) = (Node *) n;
					}
#line 35213 "gram.c" /* yacc.c:1646  */
    break;

  case 1410:
#line 9614 "gram.y" /* yacc.c:1646  */
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = NULL;
						(yyval.node) = (Node *) n;
					}
#line 35223 "gram.c" /* yacc.c:1646  */
    break;

  case 1411:
#line 9631 "gram.y" /* yacc.c:1646  */
    {
					(yyvsp[-2].istmt)->relation = (yyvsp[-3].range);
					(yyvsp[-2].istmt)->onConflictClause = (yyvsp[-1].onconflict);
					(yyvsp[-2].istmt)->returningList = (yyvsp[0].list);
					(yyvsp[-2].istmt)->withClause = (yyvsp[-6].with);
					(yyval.node) = (Node *) (yyvsp[-2].istmt);
				}
#line 35235 "gram.c" /* yacc.c:1646  */
    break;

  case 1412:
#line 9648 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
				}
#line 35243 "gram.c" /* yacc.c:1646  */
    break;

  case 1413:
#line 9652 "gram.y" /* yacc.c:1646  */
    {
					(yyvsp[-2].range)->alias = makeAlias((yyvsp[0].str), NIL);
					(yyval.range) = (yyvsp[-2].range);
				}
#line 35252 "gram.c" /* yacc.c:1646  */
    break;

  case 1414:
#line 9660 "gram.y" /* yacc.c:1646  */
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->selectStmt = (yyvsp[0].node);
				}
#line 35262 "gram.c" /* yacc.c:1646  */
    break;

  case 1415:
#line 9666 "gram.y" /* yacc.c:1646  */
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = (yyvsp[-2].list);
					(yyval.istmt)->selectStmt = (yyvsp[0].node);
				}
#line 35272 "gram.c" /* yacc.c:1646  */
    break;

  case 1416:
#line 9672 "gram.y" /* yacc.c:1646  */
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->selectStmt = NULL;
				}
#line 35282 "gram.c" /* yacc.c:1646  */
    break;

  case 1417:
#line 9681 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 35288 "gram.c" /* yacc.c:1646  */
    break;

  case 1418:
#line 9683 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 35294 "gram.c" /* yacc.c:1646  */
    break;

  case 1419:
#line 9688 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[-1].str);
					(yyval.target)->indirection = check_indirection((yyvsp[0].list), yyscanner);
					(yyval.target)->val = NULL;
					(yyval.target)->location = (yylsp[-1]);
				}
#line 35306 "gram.c" /* yacc.c:1646  */
    break;

  case 1420:
#line 9699 "gram.y" /* yacc.c:1646  */
    {
					(yyval.onconflict) = makeNode(OnConflictClause);
					(yyval.onconflict)->action = ONCONFLICT_UPDATE;
					(yyval.onconflict)->infer = (yyvsp[-5].infer);
					(yyval.onconflict)->targetList = (yyvsp[-1].list);
					(yyval.onconflict)->whereClause = (yyvsp[0].node);
					(yyval.onconflict)->location = (yylsp[-7]);
				}
#line 35319 "gram.c" /* yacc.c:1646  */
    break;

  case 1421:
#line 9709 "gram.y" /* yacc.c:1646  */
    {
					(yyval.onconflict) = makeNode(OnConflictClause);
					(yyval.onconflict)->action = ONCONFLICT_NOTHING;
					(yyval.onconflict)->infer = (yyvsp[-2].infer);
					(yyval.onconflict)->targetList = NIL;
					(yyval.onconflict)->whereClause = NULL;
					(yyval.onconflict)->location = (yylsp[-4]);
				}
#line 35332 "gram.c" /* yacc.c:1646  */
    break;

  case 1422:
#line 9718 "gram.y" /* yacc.c:1646  */
    {
					(yyval.onconflict) = NULL;
				}
#line 35340 "gram.c" /* yacc.c:1646  */
    break;

  case 1423:
#line 9725 "gram.y" /* yacc.c:1646  */
    {
					(yyval.infer) = makeNode(InferClause);
					(yyval.infer)->indexElems = (yyvsp[-2].list);
					(yyval.infer)->whereClause = (yyvsp[0].node);
					(yyval.infer)->conname = NULL;
					(yyval.infer)->location = (yylsp[-3]);
				}
#line 35352 "gram.c" /* yacc.c:1646  */
    break;

  case 1424:
#line 9734 "gram.y" /* yacc.c:1646  */
    {
					(yyval.infer) = makeNode(InferClause);
					(yyval.infer)->indexElems = NIL;
					(yyval.infer)->whereClause = NULL;
					(yyval.infer)->conname = (yyvsp[0].str);
					(yyval.infer)->location = (yylsp[-2]);
				}
#line 35364 "gram.c" /* yacc.c:1646  */
    break;

  case 1425:
#line 9742 "gram.y" /* yacc.c:1646  */
    {
					(yyval.infer) = NULL;
				}
#line 35372 "gram.c" /* yacc.c:1646  */
    break;

  case 1426:
#line 9748 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 35378 "gram.c" /* yacc.c:1646  */
    break;

  case 1427:
#line 9749 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 35384 "gram.c" /* yacc.c:1646  */
    break;

  case 1428:
#line 9762 "gram.y" /* yacc.c:1646  */
    {
					DeleteStmt *n = makeNode(DeleteStmt);
					n->relation = (yyvsp[-3].range);
					n->usingClause = (yyvsp[-2].list);
					n->whereClause = (yyvsp[-1].node);
					n->returningList = (yyvsp[0].list);
					n->withClause = (yyvsp[-6].with);
					(yyval.node) = (Node *)n;
				}
#line 35398 "gram.c" /* yacc.c:1646  */
    break;

  case 1429:
#line 9774 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 35404 "gram.c" /* yacc.c:1646  */
    break;

  case 1430:
#line 9775 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 35410 "gram.c" /* yacc.c:1646  */
    break;

  case 1431:
#line 9787 "gram.y" /* yacc.c:1646  */
    {
					LockStmt *n = makeNode(LockStmt);

					n->relations = (yyvsp[-2].list);
					n->mode = (yyvsp[-1].ival);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 35423 "gram.c" /* yacc.c:1646  */
    break;

  case 1432:
#line 9797 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival); }
#line 35429 "gram.c" /* yacc.c:1646  */
    break;

  case 1433:
#line 9798 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AccessExclusiveLock; }
#line 35435 "gram.c" /* yacc.c:1646  */
    break;

  case 1434:
#line 9801 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AccessShareLock; }
#line 35441 "gram.c" /* yacc.c:1646  */
    break;

  case 1435:
#line 9802 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RowShareLock; }
#line 35447 "gram.c" /* yacc.c:1646  */
    break;

  case 1436:
#line 9803 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RowExclusiveLock; }
#line 35453 "gram.c" /* yacc.c:1646  */
    break;

  case 1437:
#line 9804 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ShareUpdateExclusiveLock; }
#line 35459 "gram.c" /* yacc.c:1646  */
    break;

  case 1438:
#line 9805 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ShareLock; }
#line 35465 "gram.c" /* yacc.c:1646  */
    break;

  case 1439:
#line 9806 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ShareRowExclusiveLock; }
#line 35471 "gram.c" /* yacc.c:1646  */
    break;

  case 1440:
#line 9807 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ExclusiveLock; }
#line 35477 "gram.c" /* yacc.c:1646  */
    break;

  case 1441:
#line 9808 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AccessExclusiveLock; }
#line 35483 "gram.c" /* yacc.c:1646  */
    break;

  case 1442:
#line 9811 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 35489 "gram.c" /* yacc.c:1646  */
    break;

  case 1443:
#line 9812 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 35495 "gram.c" /* yacc.c:1646  */
    break;

  case 1444:
#line 9816 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LockWaitError; }
#line 35501 "gram.c" /* yacc.c:1646  */
    break;

  case 1445:
#line 9817 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LockWaitSkip; }
#line 35507 "gram.c" /* yacc.c:1646  */
    break;

  case 1446:
#line 9818 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LockWaitBlock; }
#line 35513 "gram.c" /* yacc.c:1646  */
    break;

  case 1447:
#line 9834 "gram.y" /* yacc.c:1646  */
    {
					UpdateStmt *n = makeNode(UpdateStmt);
					n->relation = (yyvsp[-5].range);
					n->targetList = (yyvsp[-3].list);
					n->fromClause = (yyvsp[-2].list);
					n->whereClause = (yyvsp[-1].node);
					n->returningList = (yyvsp[0].list);
					n->withClause = (yyvsp[-7].with);
					(yyval.node) = (Node *)n;
				}
#line 35528 "gram.c" /* yacc.c:1646  */
    break;

  case 1448:
#line 9847 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 35534 "gram.c" /* yacc.c:1646  */
    break;

  case 1449:
#line 9848 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_concat((yyvsp[-2].list),(yyvsp[0].list)); }
#line 35540 "gram.c" /* yacc.c:1646  */
    break;

  case 1450:
#line 9852 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 35546 "gram.c" /* yacc.c:1646  */
    break;

  case 1451:
#line 9853 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 35552 "gram.c" /* yacc.c:1646  */
    break;

  case 1452:
#line 9858 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = (yyvsp[-2].target);
					(yyval.target)->val = (Node *) (yyvsp[0].node);
				}
#line 35561 "gram.c" /* yacc.c:1646  */
    break;

  case 1453:
#line 9874 "gram.y" /* yacc.c:1646  */
    {
					ListCell *col_cell;
					ListCell *val_cell;

					/*
					 * Break the ctext_row apart, merge individual expressions
					 * into the destination ResTargets.  This is semantically
					 * equivalent to, and much cheaper to process than, the
					 * general case.
					 */
					if (list_length((yyvsp[-3].list)) != list_length((yyvsp[0].list)))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("number of columns does not match number of values"),
								 parser_errposition((yylsp[0]))));
					forboth(col_cell, (yyvsp[-3].list), val_cell, (yyvsp[0].list))
					{
						ResTarget *res_col = (ResTarget *) lfirst(col_cell);
						Node *res_val = (Node *) lfirst(val_cell);

						res_col->val = res_val;
					}

					(yyval.list) = (yyvsp[-3].list);
				}
#line 35591 "gram.c" /* yacc.c:1646  */
    break;

  case 1454:
#line 9900 "gram.y" /* yacc.c:1646  */
    {
					SubLink *sl = makeNode(SubLink);
					int ncolumns = list_length((yyvsp[-3].list));
					int i = 1;
					ListCell *col_cell;

					/* First, convert bare SelectStmt into a SubLink */
					sl->subLinkType = MULTIEXPR_SUBLINK;
					sl->subLinkId = 0;		/* will be assigned later */
					sl->testexpr = NULL;
					sl->operName = NIL;
					sl->subselect = (yyvsp[0].node);
					sl->location = (yylsp[0]);

					/* Create a MultiAssignRef source for each target */
					foreach(col_cell, (yyvsp[-3].list))
					{
						ResTarget *res_col = (ResTarget *) lfirst(col_cell);
						MultiAssignRef *r = makeNode(MultiAssignRef);

						r->source = (Node *) sl;
						r->colno = i;
						r->ncolumns = ncolumns;
						res_col->val = (Node *) r;
						i++;
					}

					(yyval.list) = (yyvsp[-3].list);
				}
#line 35625 "gram.c" /* yacc.c:1646  */
    break;

  case 1455:
#line 9933 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[-1].str);
					(yyval.target)->indirection = check_indirection((yyvsp[0].list), yyscanner);
					(yyval.target)->val = NULL;	/* upper production sets this */
					(yyval.target)->location = (yylsp[-1]);
				}
#line 35637 "gram.c" /* yacc.c:1646  */
    break;

  case 1456:
#line 9943 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 35643 "gram.c" /* yacc.c:1646  */
    break;

  case 1457:
#line 9944 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list),(yyvsp[0].target)); }
#line 35649 "gram.c" /* yacc.c:1646  */
    break;

  case 1458:
#line 9955 "gram.y" /* yacc.c:1646  */
    {
					DeclareCursorStmt *n = makeNode(DeclareCursorStmt);
					n->portalname = (yyvsp[-5].str);
					/* currently we always set FAST_PLAN option */
					n->options = (yyvsp[-4].ival) | (yyvsp[-2].ival) | CURSOR_OPT_FAST_PLAN;
					n->query = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 35662 "gram.c" /* yacc.c:1646  */
    break;

  case 1459:
#line 9965 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 35668 "gram.c" /* yacc.c:1646  */
    break;

  case 1460:
#line 9968 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 35674 "gram.c" /* yacc.c:1646  */
    break;

  case 1461:
#line 9969 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-2].ival) | CURSOR_OPT_NO_SCROLL; }
#line 35680 "gram.c" /* yacc.c:1646  */
    break;

  case 1462:
#line 9970 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_SCROLL; }
#line 35686 "gram.c" /* yacc.c:1646  */
    break;

  case 1463:
#line 9971 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_BINARY; }
#line 35692 "gram.c" /* yacc.c:1646  */
    break;

  case 1464:
#line 9972 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_INSENSITIVE; }
#line 35698 "gram.c" /* yacc.c:1646  */
    break;

  case 1465:
#line 9975 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 35704 "gram.c" /* yacc.c:1646  */
    break;

  case 1466:
#line 9976 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CURSOR_OPT_HOLD; }
#line 35710 "gram.c" /* yacc.c:1646  */
    break;

  case 1467:
#line 9977 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 35716 "gram.c" /* yacc.c:1646  */
    break;

  case 1470:
#line 10030 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 35722 "gram.c" /* yacc.c:1646  */
    break;

  case 1471:
#line 10031 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 35728 "gram.c" /* yacc.c:1646  */
    break;

  case 1472:
#line 10046 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 35734 "gram.c" /* yacc.c:1646  */
    break;

  case 1473:
#line 10048 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-1].node), (yyvsp[0].list), NIL,
										NULL, NULL, NULL,
										yyscanner);
					(yyval.node) = (yyvsp[-1].node);
				}
#line 35745 "gram.c" /* yacc.c:1646  */
    break;

  case 1474:
#line 10055 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[-1].list),
										list_nth((yyvsp[0].list), 0), list_nth((yyvsp[0].list), 1),
										NULL,
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 35757 "gram.c" /* yacc.c:1646  */
    break;

  case 1475:
#line 10063 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[0].list),
										list_nth((yyvsp[-1].list), 0), list_nth((yyvsp[-1].list), 1),
										NULL,
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 35769 "gram.c" /* yacc.c:1646  */
    break;

  case 1476:
#line 10071 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[0].node), NULL, NIL,
										NULL, NULL,
										(yyvsp[-1].with),
										yyscanner);
					(yyval.node) = (yyvsp[0].node);
				}
#line 35781 "gram.c" /* yacc.c:1646  */
    break;

  case 1477:
#line 10079 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-1].node), (yyvsp[0].list), NIL,
										NULL, NULL,
										(yyvsp[-2].with),
										yyscanner);
					(yyval.node) = (yyvsp[-1].node);
				}
#line 35793 "gram.c" /* yacc.c:1646  */
    break;

  case 1478:
#line 10087 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[-1].list),
										list_nth((yyvsp[0].list), 0), list_nth((yyvsp[0].list), 1),
										(yyvsp[-4].with),
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 35805 "gram.c" /* yacc.c:1646  */
    break;

  case 1479:
#line 10095 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[0].list),
										list_nth((yyvsp[-1].list), 0), list_nth((yyvsp[-1].list), 1),
										(yyvsp[-4].with),
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 35817 "gram.c" /* yacc.c:1646  */
    break;

  case 1480:
#line 10105 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 35823 "gram.c" /* yacc.c:1646  */
    break;

  case 1481:
#line 10106 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 35829 "gram.c" /* yacc.c:1646  */
    break;

  case 1482:
#line 10136 "gram.y" /* yacc.c:1646  */
    {
					SelectStmt *n = makeNode(SelectStmt);
					n->targetList = (yyvsp[-6].list);
					n->intoClause = (yyvsp[-5].into);
					n->fromClause = (yyvsp[-4].list);
					n->whereClause = (yyvsp[-3].node);
					n->groupClause = (yyvsp[-2].list);
					n->havingClause = (yyvsp[-1].node);
					n->windowClause = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 35845 "gram.c" /* yacc.c:1646  */
    break;

  case 1483:
#line 10150 "gram.y" /* yacc.c:1646  */
    {
					SelectStmt *n = makeNode(SelectStmt);
					n->distinctClause = (yyvsp[-7].list);
					n->targetList = (yyvsp[-6].list);
					n->intoClause = (yyvsp[-5].into);
					n->fromClause = (yyvsp[-4].list);
					n->whereClause = (yyvsp[-3].node);
					n->groupClause = (yyvsp[-2].list);
					n->havingClause = (yyvsp[-1].node);
					n->windowClause = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 35862 "gram.c" /* yacc.c:1646  */
    break;

  case 1484:
#line 10162 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 35868 "gram.c" /* yacc.c:1646  */
    break;

  case 1485:
#line 10164 "gram.y" /* yacc.c:1646  */
    {
					/* same as SELECT * FROM relation_expr */
					ColumnRef *cr = makeNode(ColumnRef);
					ResTarget *rt = makeNode(ResTarget);
					SelectStmt *n = makeNode(SelectStmt);

					cr->fields = list_make1(makeNode(A_Star));
					cr->location = -1;

					rt->name = NULL;
					rt->indirection = NIL;
					rt->val = (Node *)cr;
					rt->location = -1;

					n->targetList = list_make1(rt);
					n->fromClause = list_make1((yyvsp[0].range));
					(yyval.node) = (Node *)n;
				}
#line 35891 "gram.c" /* yacc.c:1646  */
    break;

  case 1486:
#line 10183 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSetOp(SETOP_UNION, (yyvsp[-1].boolean), (yyvsp[-3].node), (yyvsp[0].node));
				}
#line 35899 "gram.c" /* yacc.c:1646  */
    break;

  case 1487:
#line 10187 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSetOp(SETOP_INTERSECT, (yyvsp[-1].boolean), (yyvsp[-3].node), (yyvsp[0].node));
				}
#line 35907 "gram.c" /* yacc.c:1646  */
    break;

  case 1488:
#line 10191 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSetOp(SETOP_EXCEPT, (yyvsp[-1].boolean), (yyvsp[-3].node), (yyvsp[0].node));
				}
#line 35915 "gram.c" /* yacc.c:1646  */
    break;

  case 1489:
#line 10208 "gram.y" /* yacc.c:1646  */
    {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[0].list);
				(yyval.with)->recursive = false;
				(yyval.with)->location = (yylsp[-1]);
			}
#line 35926 "gram.c" /* yacc.c:1646  */
    break;

  case 1490:
#line 10215 "gram.y" /* yacc.c:1646  */
    {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[0].list);
				(yyval.with)->recursive = false;
				(yyval.with)->location = (yylsp[-1]);
			}
#line 35937 "gram.c" /* yacc.c:1646  */
    break;

  case 1491:
#line 10222 "gram.y" /* yacc.c:1646  */
    {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[0].list);
				(yyval.with)->recursive = true;
				(yyval.with)->location = (yylsp[-2]);
			}
#line 35948 "gram.c" /* yacc.c:1646  */
    break;

  case 1492:
#line 10231 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 35954 "gram.c" /* yacc.c:1646  */
    break;

  case 1493:
#line 10232 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 35960 "gram.c" /* yacc.c:1646  */
    break;

  case 1494:
#line 10236 "gram.y" /* yacc.c:1646  */
    {
				CommonTableExpr *n = makeNode(CommonTableExpr);
				n->ctename = (yyvsp[-5].str);
				n->aliascolnames = (yyvsp[-4].list);
				n->ctequery = (yyvsp[-1].node);
				n->location = (yylsp[-5]);
				(yyval.node) = (Node *) n;
			}
#line 35973 "gram.c" /* yacc.c:1646  */
    break;

  case 1495:
#line 10247 "gram.y" /* yacc.c:1646  */
    { (yyval.with) = (yyvsp[0].with); }
#line 35979 "gram.c" /* yacc.c:1646  */
    break;

  case 1496:
#line 10248 "gram.y" /* yacc.c:1646  */
    { (yyval.with) = NULL; }
#line 35985 "gram.c" /* yacc.c:1646  */
    break;

  case 1497:
#line 10253 "gram.y" /* yacc.c:1646  */
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[0].range);
					(yyval.into)->colNames = NIL;
					(yyval.into)->options = NIL;
					(yyval.into)->onCommit = ONCOMMIT_NOOP;
					(yyval.into)->tableSpaceName = NULL;
					(yyval.into)->viewQuery = NULL;
					(yyval.into)->skipData = false;
				}
#line 36000 "gram.c" /* yacc.c:1646  */
    break;

  case 1498:
#line 10264 "gram.y" /* yacc.c:1646  */
    { (yyval.into) = NULL; }
#line 36006 "gram.c" /* yacc.c:1646  */
    break;

  case 1499:
#line 10273 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 36015 "gram.c" /* yacc.c:1646  */
    break;

  case 1500:
#line 10278 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 36024 "gram.c" /* yacc.c:1646  */
    break;

  case 1501:
#line 10283 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 36033 "gram.c" /* yacc.c:1646  */
    break;

  case 1502:
#line 10288 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 36042 "gram.c" /* yacc.c:1646  */
    break;

  case 1503:
#line 10293 "gram.y" /* yacc.c:1646  */
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-3]))));
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 36054 "gram.c" /* yacc.c:1646  */
    break;

  case 1504:
#line 10301 "gram.y" /* yacc.c:1646  */
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-3]))));
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 36066 "gram.c" /* yacc.c:1646  */
    break;

  case 1505:
#line 10309 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_UNLOGGED;
				}
#line 36075 "gram.c" /* yacc.c:1646  */
    break;

  case 1506:
#line 10314 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_PERMANENT;
				}
#line 36084 "gram.c" /* yacc.c:1646  */
    break;

  case 1507:
#line 10319 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_PERMANENT;
				}
#line 36093 "gram.c" /* yacc.c:1646  */
    break;

  case 1508:
#line 10325 "gram.y" /* yacc.c:1646  */
    {}
#line 36099 "gram.c" /* yacc.c:1646  */
    break;

  case 1509:
#line 10326 "gram.y" /* yacc.c:1646  */
    {}
#line 36105 "gram.c" /* yacc.c:1646  */
    break;

  case 1510:
#line 10330 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 36111 "gram.c" /* yacc.c:1646  */
    break;

  case 1511:
#line 10331 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 36117 "gram.c" /* yacc.c:1646  */
    break;

  case 1512:
#line 10332 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 36123 "gram.c" /* yacc.c:1646  */
    break;

  case 1513:
#line 10339 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(NIL); }
#line 36129 "gram.c" /* yacc.c:1646  */
    break;

  case 1514:
#line 10340 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 36135 "gram.c" /* yacc.c:1646  */
    break;

  case 1515:
#line 10344 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL;}
#line 36141 "gram.c" /* yacc.c:1646  */
    break;

  case 1516:
#line 10345 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 36147 "gram.c" /* yacc.c:1646  */
    break;

  case 1517:
#line 10349 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list);}
#line 36153 "gram.c" /* yacc.c:1646  */
    break;

  case 1518:
#line 10350 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 36159 "gram.c" /* yacc.c:1646  */
    break;

  case 1519:
#line 10354 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 36165 "gram.c" /* yacc.c:1646  */
    break;

  case 1520:
#line 10358 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].sortby)); }
#line 36171 "gram.c" /* yacc.c:1646  */
    break;

  case 1521:
#line 10359 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].sortby)); }
#line 36177 "gram.c" /* yacc.c:1646  */
    break;

  case 1522:
#line 10363 "gram.y" /* yacc.c:1646  */
    {
					(yyval.sortby) = makeNode(SortBy);
					(yyval.sortby)->node = (yyvsp[-3].node);
					(yyval.sortby)->sortby_dir = SORTBY_USING;
					(yyval.sortby)->sortby_nulls = (yyvsp[0].ival);
					(yyval.sortby)->useOp = (yyvsp[-1].list);
					(yyval.sortby)->location = (yylsp[-1]);
				}
#line 36190 "gram.c" /* yacc.c:1646  */
    break;

  case 1523:
#line 10372 "gram.y" /* yacc.c:1646  */
    {
					(yyval.sortby) = makeNode(SortBy);
					(yyval.sortby)->node = (yyvsp[-2].node);
					(yyval.sortby)->sortby_dir = (yyvsp[-1].ival);
					(yyval.sortby)->sortby_nulls = (yyvsp[0].ival);
					(yyval.sortby)->useOp = NIL;
					(yyval.sortby)->location = -1;		/* no operator */
				}
#line 36203 "gram.c" /* yacc.c:1646  */
    break;

  case 1524:
#line 10384 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[0].node), (yyvsp[-1].node)); }
#line 36209 "gram.c" /* yacc.c:1646  */
    break;

  case 1525:
#line 10385 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[-1].node), (yyvsp[0].node)); }
#line 36215 "gram.c" /* yacc.c:1646  */
    break;

  case 1526:
#line 10386 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(NULL, (yyvsp[0].node)); }
#line 36221 "gram.c" /* yacc.c:1646  */
    break;

  case 1527:
#line 10387 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[0].node), NULL); }
#line 36227 "gram.c" /* yacc.c:1646  */
    break;

  case 1528:
#line 10391 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 36233 "gram.c" /* yacc.c:1646  */
    break;

  case 1529:
#line 10392 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(NULL,NULL); }
#line 36239 "gram.c" /* yacc.c:1646  */
    break;

  case 1530:
#line 10397 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 36245 "gram.c" /* yacc.c:1646  */
    break;

  case 1531:
#line 10399 "gram.y" /* yacc.c:1646  */
    {
					/* Disabled because it was too confusing, bjm 2002-02-18 */
					ereport(ERROR,
							(errcode(ERRCODE_SYNTAX_ERROR),
							 errmsg("LIMIT #,# syntax is not supported"),
							 errhint("Use separate LIMIT and OFFSET clauses."),
							 parser_errposition((yylsp[-3]))));
				}
#line 36258 "gram.c" /* yacc.c:1646  */
    break;

  case 1532:
#line 10409 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-2].node); }
#line 36264 "gram.c" /* yacc.c:1646  */
    break;

  case 1533:
#line 10414 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 36270 "gram.c" /* yacc.c:1646  */
    break;

  case 1534:
#line 10417 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 36276 "gram.c" /* yacc.c:1646  */
    break;

  case 1535:
#line 10421 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 36282 "gram.c" /* yacc.c:1646  */
    break;

  case 1536:
#line 10423 "gram.y" /* yacc.c:1646  */
    {
					/* LIMIT ALL is represented as a NULL constant */
					(yyval.node) = makeNullAConst((yylsp[0]));
				}
#line 36291 "gram.c" /* yacc.c:1646  */
    break;

  case 1537:
#line 10430 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 36297 "gram.c" /* yacc.c:1646  */
    break;

  case 1538:
#line 10440 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst((yyvsp[0].ival), (yylsp[0])); }
#line 36303 "gram.c" /* yacc.c:1646  */
    break;

  case 1539:
#line 10441 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 36309 "gram.c" /* yacc.c:1646  */
    break;

  case 1540:
#line 10442 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(1, -1); }
#line 36315 "gram.c" /* yacc.c:1646  */
    break;

  case 1541:
#line 10450 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 36321 "gram.c" /* yacc.c:1646  */
    break;

  case 1542:
#line 10454 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 36327 "gram.c" /* yacc.c:1646  */
    break;

  case 1543:
#line 10455 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 36333 "gram.c" /* yacc.c:1646  */
    break;

  case 1544:
#line 10458 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 36339 "gram.c" /* yacc.c:1646  */
    break;

  case 1545:
#line 10459 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 36345 "gram.c" /* yacc.c:1646  */
    break;

  case 1546:
#line 10484 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 36351 "gram.c" /* yacc.c:1646  */
    break;

  case 1547:
#line 10485 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 36357 "gram.c" /* yacc.c:1646  */
    break;

  case 1548:
#line 10489 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 36363 "gram.c" /* yacc.c:1646  */
    break;

  case 1549:
#line 10490 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list),(yyvsp[0].node)); }
#line 36369 "gram.c" /* yacc.c:1646  */
    break;

  case 1550:
#line 10494 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 36375 "gram.c" /* yacc.c:1646  */
    break;

  case 1551:
#line 10495 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 36381 "gram.c" /* yacc.c:1646  */
    break;

  case 1552:
#line 10496 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 36387 "gram.c" /* yacc.c:1646  */
    break;

  case 1553:
#line 10497 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 36393 "gram.c" /* yacc.c:1646  */
    break;

  case 1554:
#line 10498 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 36399 "gram.c" /* yacc.c:1646  */
    break;

  case 1555:
#line 10503 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeGroupingSet(GROUPING_SET_EMPTY, NIL, (yylsp[-1]));
				}
#line 36407 "gram.c" /* yacc.c:1646  */
    break;

  case 1556:
#line 10516 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeGroupingSet(GROUPING_SET_ROLLUP, (yyvsp[-1].list), (yylsp[-3]));
				}
#line 36415 "gram.c" /* yacc.c:1646  */
    break;

  case 1557:
#line 10523 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeGroupingSet(GROUPING_SET_CUBE, (yyvsp[-1].list), (yylsp[-3]));
				}
#line 36423 "gram.c" /* yacc.c:1646  */
    break;

  case 1558:
#line 10530 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeGroupingSet(GROUPING_SET_SETS, (yyvsp[-1].list), (yylsp[-4]));
				}
#line 36431 "gram.c" /* yacc.c:1646  */
    break;

  case 1559:
#line 10536 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 36437 "gram.c" /* yacc.c:1646  */
    break;

  case 1560:
#line 10537 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 36443 "gram.c" /* yacc.c:1646  */
    break;

  case 1561:
#line 10541 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 36449 "gram.c" /* yacc.c:1646  */
    break;

  case 1562:
#line 10542 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 36455 "gram.c" /* yacc.c:1646  */
    break;

  case 1563:
#line 10546 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 36461 "gram.c" /* yacc.c:1646  */
    break;

  case 1564:
#line 10547 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 36467 "gram.c" /* yacc.c:1646  */
    break;

  case 1565:
#line 10551 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 36473 "gram.c" /* yacc.c:1646  */
    break;

  case 1566:
#line 10552 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 36479 "gram.c" /* yacc.c:1646  */
    break;

  case 1567:
#line 10557 "gram.y" /* yacc.c:1646  */
    {
					LockingClause *n = makeNode(LockingClause);
					n->lockedRels = (yyvsp[-1].list);
					n->strength = (yyvsp[-2].ival);
					n->waitPolicy = (yyvsp[0].ival);
					(yyval.node) = (Node *) n;
				}
#line 36491 "gram.c" /* yacc.c:1646  */
    break;

  case 1568:
#line 10567 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LCS_FORUPDATE; }
#line 36497 "gram.c" /* yacc.c:1646  */
    break;

  case 1569:
#line 10568 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LCS_FORNOKEYUPDATE; }
#line 36503 "gram.c" /* yacc.c:1646  */
    break;

  case 1570:
#line 10569 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LCS_FORSHARE; }
#line 36509 "gram.c" /* yacc.c:1646  */
    break;

  case 1571:
#line 10570 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LCS_FORKEYSHARE; }
#line 36515 "gram.c" /* yacc.c:1646  */
    break;

  case 1572:
#line 10574 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 36521 "gram.c" /* yacc.c:1646  */
    break;

  case 1573:
#line 10575 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 36527 "gram.c" /* yacc.c:1646  */
    break;

  case 1574:
#line 10581 "gram.y" /* yacc.c:1646  */
    {
					SelectStmt *n = makeNode(SelectStmt);
					n->valuesLists = list_make1((yyvsp[0].list));
					(yyval.node) = (Node *) n;
				}
#line 36537 "gram.c" /* yacc.c:1646  */
    break;

  case 1575:
#line 10587 "gram.y" /* yacc.c:1646  */
    {
					SelectStmt *n = (SelectStmt *) (yyvsp[-2].node);
					n->valuesLists = lappend(n->valuesLists, (yyvsp[0].list));
					(yyval.node) = (Node *) n;
				}
#line 36547 "gram.c" /* yacc.c:1646  */
    break;

  case 1576:
#line 10604 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 36553 "gram.c" /* yacc.c:1646  */
    break;

  case 1577:
#line 10605 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 36559 "gram.c" /* yacc.c:1646  */
    break;

  case 1578:
#line 10609 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 36565 "gram.c" /* yacc.c:1646  */
    break;

  case 1579:
#line 10610 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 36571 "gram.c" /* yacc.c:1646  */
    break;

  case 1580:
#line 10617 "gram.y" /* yacc.c:1646  */
    {
					(yyvsp[-1].range)->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) (yyvsp[-1].range);
				}
#line 36580 "gram.c" /* yacc.c:1646  */
    break;

  case 1581:
#line 10622 "gram.y" /* yacc.c:1646  */
    {
					RangeTableSample *n = (RangeTableSample *) (yyvsp[0].node);
					(yyvsp[-2].range)->alias = (yyvsp[-1].alias);
					/* relation_expr goes inside the RangeTableSample node */
					n->relation = (Node *) (yyvsp[-2].range);
					(yyval.node) = (Node *) n;
				}
#line 36592 "gram.c" /* yacc.c:1646  */
    break;

  case 1582:
#line 10630 "gram.y" /* yacc.c:1646  */
    {
					RangeFunction *n = (RangeFunction *) (yyvsp[-1].node);
					n->alias = linitial((yyvsp[0].list));
					n->coldeflist = lsecond((yyvsp[0].list));
					(yyval.node) = (Node *) n;
				}
#line 36603 "gram.c" /* yacc.c:1646  */
    break;

  case 1583:
#line 10637 "gram.y" /* yacc.c:1646  */
    {
					RangeFunction *n = (RangeFunction *) (yyvsp[-1].node);
					n->lateral = true;
					n->alias = linitial((yyvsp[0].list));
					n->coldeflist = lsecond((yyvsp[0].list));
					(yyval.node) = (Node *) n;
				}
#line 36615 "gram.c" /* yacc.c:1646  */
    break;

  case 1584:
#line 10645 "gram.y" /* yacc.c:1646  */
    {
					RangeSubselect *n = makeNode(RangeSubselect);
					n->lateral = false;
					n->subquery = (yyvsp[-1].node);
					n->alias = (yyvsp[0].alias);
					/*
					 * The SQL spec does not permit a subselect
					 * (<derived_table>) without an alias clause,
					 * so we don't either.  This avoids the problem
					 * of needing to invent a unique refname for it.
					 * That could be surmounted if there's sufficient
					 * popular demand, but for now let's just implement
					 * the spec and see if anyone complains.
					 * However, it does seem like a good idea to emit
					 * an error message that's better than "syntax error".
					 */
					if ((yyvsp[0].alias) == NULL)
					{
						if (IsA((yyvsp[-1].node), SelectStmt) &&
							((SelectStmt *) (yyvsp[-1].node))->valuesLists)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("VALUES in FROM must have an alias"),
									 errhint("For example, FROM (VALUES ...) [AS] foo."),
									 parser_errposition((yylsp[-1]))));
						else
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("subquery in FROM must have an alias"),
									 errhint("For example, FROM (SELECT ...) [AS] foo."),
									 parser_errposition((yylsp[-1]))));
					}
					(yyval.node) = (Node *) n;
				}
#line 36654 "gram.c" /* yacc.c:1646  */
    break;

  case 1585:
#line 10680 "gram.y" /* yacc.c:1646  */
    {
					RangeSubselect *n = makeNode(RangeSubselect);
					n->lateral = true;
					n->subquery = (yyvsp[-1].node);
					n->alias = (yyvsp[0].alias);
					/* same coment as above */
					if ((yyvsp[0].alias) == NULL)
					{
						if (IsA((yyvsp[-1].node), SelectStmt) &&
							((SelectStmt *) (yyvsp[-1].node))->valuesLists)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("VALUES in FROM must have an alias"),
									 errhint("For example, FROM (VALUES ...) [AS] foo."),
									 parser_errposition((yylsp[-1]))));
						else
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("subquery in FROM must have an alias"),
									 errhint("For example, FROM (SELECT ...) [AS] foo."),
									 parser_errposition((yylsp[-1]))));
					}
					(yyval.node) = (Node *) n;
				}
#line 36683 "gram.c" /* yacc.c:1646  */
    break;

  case 1586:
#line 10705 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) (yyvsp[0].jexpr);
				}
#line 36691 "gram.c" /* yacc.c:1646  */
    break;

  case 1587:
#line 10709 "gram.y" /* yacc.c:1646  */
    {
					(yyvsp[-2].jexpr)->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) (yyvsp[-2].jexpr);
				}
#line 36700 "gram.c" /* yacc.c:1646  */
    break;

  case 1588:
#line 10735 "gram.y" /* yacc.c:1646  */
    {
					(yyval.jexpr) = (yyvsp[-1].jexpr);
				}
#line 36708 "gram.c" /* yacc.c:1646  */
    break;

  case 1589:
#line 10739 "gram.y" /* yacc.c:1646  */
    {
					/* CROSS JOIN is same as unqualified inner join */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = FALSE;
					n->larg = (yyvsp[-3].node);
					n->rarg = (yyvsp[0].node);
					n->usingClause = NIL;
					n->quals = NULL;
					(yyval.jexpr) = n;
				}
#line 36724 "gram.c" /* yacc.c:1646  */
    break;

  case 1590:
#line 10751 "gram.y" /* yacc.c:1646  */
    {
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = (yyvsp[-3].jtype);
					n->isNatural = FALSE;
					n->larg = (yyvsp[-4].node);
					n->rarg = (yyvsp[-1].node);
					if ((yyvsp[0].node) != NULL && IsA((yyvsp[0].node), List))
						n->usingClause = (List *) (yyvsp[0].node); /* USING clause */
					else
						n->quals = (yyvsp[0].node); /* ON clause */
					(yyval.jexpr) = n;
				}
#line 36741 "gram.c" /* yacc.c:1646  */
    break;

  case 1591:
#line 10764 "gram.y" /* yacc.c:1646  */
    {
					/* letting join_type reduce to empty doesn't work */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = FALSE;
					n->larg = (yyvsp[-3].node);
					n->rarg = (yyvsp[-1].node);
					if ((yyvsp[0].node) != NULL && IsA((yyvsp[0].node), List))
						n->usingClause = (List *) (yyvsp[0].node); /* USING clause */
					else
						n->quals = (yyvsp[0].node); /* ON clause */
					(yyval.jexpr) = n;
				}
#line 36759 "gram.c" /* yacc.c:1646  */
    break;

  case 1592:
#line 10778 "gram.y" /* yacc.c:1646  */
    {
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = (yyvsp[-2].jtype);
					n->isNatural = TRUE;
					n->larg = (yyvsp[-4].node);
					n->rarg = (yyvsp[0].node);
					n->usingClause = NIL; /* figure out which columns later... */
					n->quals = NULL; /* fill later */
					(yyval.jexpr) = n;
				}
#line 36774 "gram.c" /* yacc.c:1646  */
    break;

  case 1593:
#line 10789 "gram.y" /* yacc.c:1646  */
    {
					/* letting join_type reduce to empty doesn't work */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = TRUE;
					n->larg = (yyvsp[-3].node);
					n->rarg = (yyvsp[0].node);
					n->usingClause = NIL; /* figure out which columns later... */
					n->quals = NULL; /* fill later */
					(yyval.jexpr) = n;
				}
#line 36790 "gram.c" /* yacc.c:1646  */
    break;

  case 1594:
#line 10804 "gram.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[-3].str);
					(yyval.alias)->colnames = (yyvsp[-1].list);
				}
#line 36800 "gram.c" /* yacc.c:1646  */
    break;

  case 1595:
#line 10810 "gram.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[0].str);
				}
#line 36809 "gram.c" /* yacc.c:1646  */
    break;

  case 1596:
#line 10815 "gram.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[-3].str);
					(yyval.alias)->colnames = (yyvsp[-1].list);
				}
#line 36819 "gram.c" /* yacc.c:1646  */
    break;

  case 1597:
#line 10821 "gram.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[0].str);
				}
#line 36828 "gram.c" /* yacc.c:1646  */
    break;

  case 1598:
#line 10827 "gram.y" /* yacc.c:1646  */
    { (yyval.alias) = (yyvsp[0].alias); }
#line 36834 "gram.c" /* yacc.c:1646  */
    break;

  case 1599:
#line 10828 "gram.y" /* yacc.c:1646  */
    { (yyval.alias) = NULL; }
#line 36840 "gram.c" /* yacc.c:1646  */
    break;

  case 1600:
#line 10837 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[0].alias), NIL);
				}
#line 36848 "gram.c" /* yacc.c:1646  */
    break;

  case 1601:
#line 10841 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(NULL, (yyvsp[-1].list));
				}
#line 36856 "gram.c" /* yacc.c:1646  */
    break;

  case 1602:
#line 10845 "gram.y" /* yacc.c:1646  */
    {
					Alias *a = makeNode(Alias);
					a->aliasname = (yyvsp[-3].str);
					(yyval.list) = list_make2(a, (yyvsp[-1].list));
				}
#line 36866 "gram.c" /* yacc.c:1646  */
    break;

  case 1603:
#line 10851 "gram.y" /* yacc.c:1646  */
    {
					Alias *a = makeNode(Alias);
					a->aliasname = (yyvsp[-3].str);
					(yyval.list) = list_make2(a, (yyvsp[-1].list));
				}
#line 36876 "gram.c" /* yacc.c:1646  */
    break;

  case 1604:
#line 10857 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(NULL, NIL);
				}
#line 36884 "gram.c" /* yacc.c:1646  */
    break;

  case 1605:
#line 10862 "gram.y" /* yacc.c:1646  */
    { (yyval.jtype) = JOIN_FULL; }
#line 36890 "gram.c" /* yacc.c:1646  */
    break;

  case 1606:
#line 10863 "gram.y" /* yacc.c:1646  */
    { (yyval.jtype) = JOIN_LEFT; }
#line 36896 "gram.c" /* yacc.c:1646  */
    break;

  case 1607:
#line 10864 "gram.y" /* yacc.c:1646  */
    { (yyval.jtype) = JOIN_RIGHT; }
#line 36902 "gram.c" /* yacc.c:1646  */
    break;

  case 1608:
#line 10865 "gram.y" /* yacc.c:1646  */
    { (yyval.jtype) = JOIN_INNER; }
#line 36908 "gram.c" /* yacc.c:1646  */
    break;

  case 1609:
#line 10869 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 36914 "gram.c" /* yacc.c:1646  */
    break;

  case 1610:
#line 10870 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 36920 "gram.c" /* yacc.c:1646  */
    break;

  case 1611:
#line 10882 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[-1].list); }
#line 36926 "gram.c" /* yacc.c:1646  */
    break;

  case 1612:
#line 10883 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 36932 "gram.c" /* yacc.c:1646  */
    break;

  case 1613:
#line 10889 "gram.y" /* yacc.c:1646  */
    {
					/* default inheritance */
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->inhOpt = INH_DEFAULT;
					(yyval.range)->alias = NULL;
				}
#line 36943 "gram.c" /* yacc.c:1646  */
    break;

  case 1614:
#line 10896 "gram.y" /* yacc.c:1646  */
    {
					/* inheritance query */
					(yyval.range) = (yyvsp[-1].range);
					(yyval.range)->inhOpt = INH_YES;
					(yyval.range)->alias = NULL;
				}
#line 36954 "gram.c" /* yacc.c:1646  */
    break;

  case 1615:
#line 10903 "gram.y" /* yacc.c:1646  */
    {
					/* no inheritance */
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->inhOpt = INH_NO;
					(yyval.range)->alias = NULL;
				}
#line 36965 "gram.c" /* yacc.c:1646  */
    break;

  case 1616:
#line 10910 "gram.y" /* yacc.c:1646  */
    {
					/* no inheritance, SQL99-style syntax */
					(yyval.range) = (yyvsp[-1].range);
					(yyval.range)->inhOpt = INH_NO;
					(yyval.range)->alias = NULL;
				}
#line 36976 "gram.c" /* yacc.c:1646  */
    break;

  case 1617:
#line 10920 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].range)); }
#line 36982 "gram.c" /* yacc.c:1646  */
    break;

  case 1618:
#line 10921 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].range)); }
#line 36988 "gram.c" /* yacc.c:1646  */
    break;

  case 1619:
#line 10935 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
				}
#line 36996 "gram.c" /* yacc.c:1646  */
    break;

  case 1620:
#line 10939 "gram.y" /* yacc.c:1646  */
    {
					Alias *alias = makeNode(Alias);
					alias->aliasname = (yyvsp[0].str);
					(yyvsp[-1].range)->alias = alias;
					(yyval.range) = (yyvsp[-1].range);
				}
#line 37007 "gram.c" /* yacc.c:1646  */
    break;

  case 1621:
#line 10946 "gram.y" /* yacc.c:1646  */
    {
					Alias *alias = makeNode(Alias);
					alias->aliasname = (yyvsp[0].str);
					(yyvsp[-2].range)->alias = alias;
					(yyval.range) = (yyvsp[-2].range);
				}
#line 37018 "gram.c" /* yacc.c:1646  */
    break;

  case 1622:
#line 10959 "gram.y" /* yacc.c:1646  */
    {
					RangeTableSample *n = makeNode(RangeTableSample);
					/* n->relation will be filled in later */
					n->method = (yyvsp[-4].list);
					n->args = (yyvsp[-2].list);
					n->repeatable = (yyvsp[0].node);
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *) n;
				}
#line 37032 "gram.c" /* yacc.c:1646  */
    break;

  case 1623:
#line 10971 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[-1].node); }
#line 37038 "gram.c" /* yacc.c:1646  */
    break;

  case 1624:
#line 10972 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 37044 "gram.c" /* yacc.c:1646  */
    break;

  case 1625:
#line 10988 "gram.y" /* yacc.c:1646  */
    {
					RangeFunction *n = makeNode(RangeFunction);
					n->lateral = false;
					n->ordinality = (yyvsp[0].boolean);
					n->is_rowsfrom = false;
					n->functions = list_make1(list_make2((yyvsp[-1].node), NIL));
					/* alias and coldeflist are set by table_ref production */
					(yyval.node) = (Node *) n;
				}
#line 37058 "gram.c" /* yacc.c:1646  */
    break;

  case 1626:
#line 10998 "gram.y" /* yacc.c:1646  */
    {
					RangeFunction *n = makeNode(RangeFunction);
					n->lateral = false;
					n->ordinality = (yyvsp[0].boolean);
					n->is_rowsfrom = true;
					n->functions = (yyvsp[-2].list);
					/* alias and coldeflist are set by table_ref production */
					(yyval.node) = (Node *) n;
				}
#line 37072 "gram.c" /* yacc.c:1646  */
    break;

  case 1627:
#line 11010 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[-1].node), (yyvsp[0].list)); }
#line 37078 "gram.c" /* yacc.c:1646  */
    break;

  case 1628:
#line 11014 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].list)); }
#line 37084 "gram.c" /* yacc.c:1646  */
    break;

  case 1629:
#line 11015 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].list)); }
#line 37090 "gram.c" /* yacc.c:1646  */
    break;

  case 1630:
#line 11018 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 37096 "gram.c" /* yacc.c:1646  */
    break;

  case 1631:
#line 11019 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 37102 "gram.c" /* yacc.c:1646  */
    break;

  case 1632:
#line 11022 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 37108 "gram.c" /* yacc.c:1646  */
    break;

  case 1633:
#line 11023 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 37114 "gram.c" /* yacc.c:1646  */
    break;

  case 1634:
#line 11028 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 37120 "gram.c" /* yacc.c:1646  */
    break;

  case 1635:
#line 11029 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 37126 "gram.c" /* yacc.c:1646  */
    break;

  case 1636:
#line 11034 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 37132 "gram.c" /* yacc.c:1646  */
    break;

  case 1637:
#line 11036 "gram.y" /* yacc.c:1646  */
    {
					CurrentOfExpr *n = makeNode(CurrentOfExpr);
					/* cvarno is filled in by parse analysis */
					n->cursor_name = (yyvsp[0].str);
					n->cursor_param = 0;
					(yyval.node) = (Node *) n;
				}
#line 37144 "gram.c" /* yacc.c:1646  */
    break;

  case 1638:
#line 11043 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 37150 "gram.c" /* yacc.c:1646  */
    break;

  case 1639:
#line 11048 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 37156 "gram.c" /* yacc.c:1646  */
    break;

  case 1640:
#line 11049 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 37162 "gram.c" /* yacc.c:1646  */
    break;

  case 1641:
#line 11054 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 37170 "gram.c" /* yacc.c:1646  */
    break;

  case 1642:
#line 11058 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 37178 "gram.c" /* yacc.c:1646  */
    break;

  case 1643:
#line 11064 "gram.y" /* yacc.c:1646  */
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[-2].str);
					n->typeName = (yyvsp[-1].typnam);
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collClause = (CollateClause *) (yyvsp[0].node);
					n->collOid = InvalidOid;
					n->constraints = NIL;
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *)n;
				}
#line 37200 "gram.c" /* yacc.c:1646  */
    break;

  case 1644:
#line 11094 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = (yyvsp[0].list);
				}
#line 37209 "gram.c" /* yacc.c:1646  */
    break;

  case 1645:
#line 11099 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = (yyvsp[0].list);
					(yyval.typnam)->setof = TRUE;
				}
#line 37219 "gram.c" /* yacc.c:1646  */
    break;

  case 1646:
#line 11106 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-4].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger((yyvsp[-1].ival)));
				}
#line 37228 "gram.c" /* yacc.c:1646  */
    break;

  case 1647:
#line 11111 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-4].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger((yyvsp[-1].ival)));
					(yyval.typnam)->setof = TRUE;
				}
#line 37238 "gram.c" /* yacc.c:1646  */
    break;

  case 1648:
#line 11117 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger(-1));
				}
#line 37247 "gram.c" /* yacc.c:1646  */
    break;

  case 1649:
#line 11122 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger(-1));
					(yyval.typnam)->setof = TRUE;
				}
#line 37257 "gram.c" /* yacc.c:1646  */
    break;

  case 1650:
#line 11131 "gram.y" /* yacc.c:1646  */
    {  (yyval.list) = lappend((yyvsp[-2].list), makeInteger(-1)); }
#line 37263 "gram.c" /* yacc.c:1646  */
    break;

  case 1651:
#line 11133 "gram.y" /* yacc.c:1646  */
    {  (yyval.list) = lappend((yyvsp[-3].list), makeInteger((yyvsp[-1].ival))); }
#line 37269 "gram.c" /* yacc.c:1646  */
    break;

  case 1652:
#line 11135 "gram.y" /* yacc.c:1646  */
    {  (yyval.list) = NIL; }
#line 37275 "gram.c" /* yacc.c:1646  */
    break;

  case 1653:
#line 11139 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 37281 "gram.c" /* yacc.c:1646  */
    break;

  case 1654:
#line 11140 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 37287 "gram.c" /* yacc.c:1646  */
    break;

  case 1655:
#line 11141 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 37293 "gram.c" /* yacc.c:1646  */
    break;

  case 1656:
#line 11142 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 37299 "gram.c" /* yacc.c:1646  */
    break;

  case 1657:
#line 11143 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 37305 "gram.c" /* yacc.c:1646  */
    break;

  case 1658:
#line 11145 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->typmods = (yyvsp[0].list);
				}
#line 37314 "gram.c" /* yacc.c:1646  */
    break;

  case 1659:
#line 11150 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-3].typnam);
					(yyval.typnam)->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
											 makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
				}
#line 37324 "gram.c" /* yacc.c:1646  */
    break;

  case 1660:
#line 11169 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 37330 "gram.c" /* yacc.c:1646  */
    break;

  case 1661:
#line 11170 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 37336 "gram.c" /* yacc.c:1646  */
    break;

  case 1662:
#line 11171 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 37342 "gram.c" /* yacc.c:1646  */
    break;

  case 1663:
#line 11172 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 37348 "gram.c" /* yacc.c:1646  */
    break;

  case 1664:
#line 11184 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = makeTypeName((yyvsp[-1].str));
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 37358 "gram.c" /* yacc.c:1646  */
    break;

  case 1665:
#line 11190 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[-2].str)), (yyvsp[-1].list)));
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-2]);
				}
#line 37368 "gram.c" /* yacc.c:1646  */
    break;

  case 1666:
#line 11197 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 37374 "gram.c" /* yacc.c:1646  */
    break;

  case 1667:
#line 11198 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 37380 "gram.c" /* yacc.c:1646  */
    break;

  case 1668:
#line 11205 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("int4");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 37389 "gram.c" /* yacc.c:1646  */
    break;

  case 1669:
#line 11210 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("int4");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 37398 "gram.c" /* yacc.c:1646  */
    break;

  case 1670:
#line 11215 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("int2");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 37407 "gram.c" /* yacc.c:1646  */
    break;

  case 1671:
#line 11220 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("int8");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 37416 "gram.c" /* yacc.c:1646  */
    break;

  case 1672:
#line 11225 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("float4");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 37425 "gram.c" /* yacc.c:1646  */
    break;

  case 1673:
#line 11230 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 37434 "gram.c" /* yacc.c:1646  */
    break;

  case 1674:
#line 11235 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("float8");
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 37443 "gram.c" /* yacc.c:1646  */
    break;

  case 1675:
#line 11240 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 37453 "gram.c" /* yacc.c:1646  */
    break;

  case 1676:
#line 11246 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 37463 "gram.c" /* yacc.c:1646  */
    break;

  case 1677:
#line 11252 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 37473 "gram.c" /* yacc.c:1646  */
    break;

  case 1678:
#line 11258 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("bool");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 37482 "gram.c" /* yacc.c:1646  */
    break;

  case 1679:
#line 11265 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Check FLOAT() precision limits assuming IEEE floating
					 * types - thomas 1997-09-18
					 */
					if ((yyvsp[-1].ival) < 1)
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("precision for type float must be at least 1 bit"),
								 parser_errposition((yylsp[-1]))));
					else if ((yyvsp[-1].ival) <= 24)
						(yyval.typnam) = SystemTypeName("float4");
					else if ((yyvsp[-1].ival) <= 53)
						(yyval.typnam) = SystemTypeName("float8");
					else
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("precision for type float must be less than 54 bits"),
								 parser_errposition((yylsp[-1]))));
				}
#line 37507 "gram.c" /* yacc.c:1646  */
    break;

  case 1680:
#line 11286 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("float8");
				}
#line 37515 "gram.c" /* yacc.c:1646  */
    break;

  case 1681:
#line 11296 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 37523 "gram.c" /* yacc.c:1646  */
    break;

  case 1682:
#line 11300 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 37531 "gram.c" /* yacc.c:1646  */
    break;

  case 1683:
#line 11308 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 37539 "gram.c" /* yacc.c:1646  */
    break;

  case 1684:
#line 11312 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
					(yyval.typnam)->typmods = NIL;
				}
#line 37548 "gram.c" /* yacc.c:1646  */
    break;

  case 1685:
#line 11320 "gram.y" /* yacc.c:1646  */
    {
					char *typname;

					typname = (yyvsp[-3].boolean) ? "varbit" : "bit";
					(yyval.typnam) = SystemTypeName(typname);
					(yyval.typnam)->typmods = (yyvsp[-1].list);
					(yyval.typnam)->location = (yylsp[-4]);
				}
#line 37561 "gram.c" /* yacc.c:1646  */
    break;

  case 1686:
#line 11332 "gram.y" /* yacc.c:1646  */
    {
					/* bit defaults to bit(1), varbit to no limit */
					if ((yyvsp[0].boolean))
					{
						(yyval.typnam) = SystemTypeName("varbit");
					}
					else
					{
						(yyval.typnam) = SystemTypeName("bit");
						(yyval.typnam)->typmods = list_make1(makeIntConst(1, -1));
					}
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 37579 "gram.c" /* yacc.c:1646  */
    break;

  case 1687:
#line 11353 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 37587 "gram.c" /* yacc.c:1646  */
    break;

  case 1688:
#line 11357 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 37595 "gram.c" /* yacc.c:1646  */
    break;

  case 1689:
#line 11363 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 37603 "gram.c" /* yacc.c:1646  */
    break;

  case 1690:
#line 11367 "gram.y" /* yacc.c:1646  */
    {
					/* Length was not specified so allow to be unrestricted.
					 * This handles problems with fixed-length (bpchar) strings
					 * which in column definitions must default to a length
					 * of one, but should not be constrained if the length
					 * was not specified.
					 */
					(yyval.typnam) = (yyvsp[0].typnam);
					(yyval.typnam)->typmods = NIL;
				}
#line 37618 "gram.c" /* yacc.c:1646  */
    break;

  case 1691:
#line 11380 "gram.y" /* yacc.c:1646  */
    {
					if (((yyvsp[0].str) != NULL) && (strcmp((yyvsp[0].str), "sql_text") != 0))
						(yyvsp[-4].str) = psprintf("%s_%s", (yyvsp[-4].str), (yyvsp[0].str));

					(yyval.typnam) = SystemTypeName((yyvsp[-4].str));
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.typnam)->location = (yylsp[-4]);
				}
#line 37631 "gram.c" /* yacc.c:1646  */
    break;

  case 1692:
#line 11391 "gram.y" /* yacc.c:1646  */
    {
					if (((yyvsp[0].str) != NULL) && (strcmp((yyvsp[0].str), "sql_text") != 0))
						(yyvsp[-1].str) = psprintf("%s_%s", (yyvsp[-1].str), (yyvsp[0].str));

					(yyval.typnam) = SystemTypeName((yyvsp[-1].str));

					/* char defaults to char(1), varchar to no limit */
					if (strcmp((yyvsp[-1].str), "bpchar") == 0)
						(yyval.typnam)->typmods = list_make1(makeIntConst(1, -1));

					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 37648 "gram.c" /* yacc.c:1646  */
    break;

  case 1693:
#line 11406 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 37654 "gram.c" /* yacc.c:1646  */
    break;

  case 1694:
#line 11408 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 37660 "gram.c" /* yacc.c:1646  */
    break;

  case 1695:
#line 11410 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "varchar"; }
#line 37666 "gram.c" /* yacc.c:1646  */
    break;

  case 1696:
#line 11412 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 37672 "gram.c" /* yacc.c:1646  */
    break;

  case 1697:
#line 11414 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 37678 "gram.c" /* yacc.c:1646  */
    break;

  case 1698:
#line 11416 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 37684 "gram.c" /* yacc.c:1646  */
    break;

  case 1699:
#line 11420 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 37690 "gram.c" /* yacc.c:1646  */
    break;

  case 1700:
#line 11421 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 37696 "gram.c" /* yacc.c:1646  */
    break;

  case 1701:
#line 11425 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 37702 "gram.c" /* yacc.c:1646  */
    break;

  case 1702:
#line 11426 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 37708 "gram.c" /* yacc.c:1646  */
    break;

  case 1703:
#line 11434 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timestamptz");
					else
						(yyval.typnam) = SystemTypeName("timestamp");
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.typnam)->location = (yylsp[-4]);
				}
#line 37721 "gram.c" /* yacc.c:1646  */
    break;

  case 1704:
#line 11443 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timestamptz");
					else
						(yyval.typnam) = SystemTypeName("timestamp");
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 37733 "gram.c" /* yacc.c:1646  */
    break;

  case 1705:
#line 11451 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timetz");
					else
						(yyval.typnam) = SystemTypeName("time");
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.typnam)->location = (yylsp[-4]);
				}
#line 37746 "gram.c" /* yacc.c:1646  */
    break;

  case 1706:
#line 11460 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timetz");
					else
						(yyval.typnam) = SystemTypeName("time");
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 37758 "gram.c" /* yacc.c:1646  */
    break;

  case 1707:
#line 11471 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("interval");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 37767 "gram.c" /* yacc.c:1646  */
    break;

  case 1708:
#line 11478 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 37773 "gram.c" /* yacc.c:1646  */
    break;

  case 1709:
#line 11479 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 37779 "gram.c" /* yacc.c:1646  */
    break;

  case 1710:
#line 11480 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 37785 "gram.c" /* yacc.c:1646  */
    break;

  case 1711:
#line 11485 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(YEAR), (yylsp[0]))); }
#line 37791 "gram.c" /* yacc.c:1646  */
    break;

  case 1712:
#line 11487 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(MONTH), (yylsp[0]))); }
#line 37797 "gram.c" /* yacc.c:1646  */
    break;

  case 1713:
#line 11489 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY), (yylsp[0]))); }
#line 37803 "gram.c" /* yacc.c:1646  */
    break;

  case 1714:
#line 11491 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(HOUR), (yylsp[0]))); }
#line 37809 "gram.c" /* yacc.c:1646  */
    break;

  case 1715:
#line 11493 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(MINUTE), (yylsp[0]))); }
#line 37815 "gram.c" /* yacc.c:1646  */
    break;

  case 1716:
#line 11495 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 37821 "gram.c" /* yacc.c:1646  */
    break;

  case 1717:
#line 11497 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(YEAR) |
												 INTERVAL_MASK(MONTH), (yylsp[-2])));
				}
#line 37830 "gram.c" /* yacc.c:1646  */
    break;

  case 1718:
#line 11502 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY) |
												 INTERVAL_MASK(HOUR), (yylsp[-2])));
				}
#line 37839 "gram.c" /* yacc.c:1646  */
    break;

  case 1719:
#line 11507 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY) |
												 INTERVAL_MASK(HOUR) |
												 INTERVAL_MASK(MINUTE), (yylsp[-2])));
				}
#line 37849 "gram.c" /* yacc.c:1646  */
    break;

  case 1720:
#line 11513 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = (yyvsp[0].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(DAY) |
												INTERVAL_MASK(HOUR) |
												INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[-2]));
				}
#line 37861 "gram.c" /* yacc.c:1646  */
    break;

  case 1721:
#line 11521 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(HOUR) |
												 INTERVAL_MASK(MINUTE), (yylsp[-2])));
				}
#line 37870 "gram.c" /* yacc.c:1646  */
    break;

  case 1722:
#line 11526 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = (yyvsp[0].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(HOUR) |
												INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[-2]));
				}
#line 37881 "gram.c" /* yacc.c:1646  */
    break;

  case 1723:
#line 11533 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = (yyvsp[0].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[-2]));
				}
#line 37891 "gram.c" /* yacc.c:1646  */
    break;

  case 1724:
#line 11539 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 37897 "gram.c" /* yacc.c:1646  */
    break;

  case 1725:
#line 11544 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(SECOND), (yylsp[0])));
				}
#line 37905 "gram.c" /* yacc.c:1646  */
    break;

  case 1726:
#line 11548 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(makeIntConst(INTERVAL_MASK(SECOND), (yylsp[-3])),
									makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
				}
#line 37914 "gram.c" /* yacc.c:1646  */
    break;

  case 1727:
#line 11583 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 37920 "gram.c" /* yacc.c:1646  */
    break;

  case 1728:
#line 11585 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeTypeCast((yyvsp[-2].node), (yyvsp[0].typnam), (yylsp[-1])); }
#line 37926 "gram.c" /* yacc.c:1646  */
    break;

  case 1729:
#line 11587 "gram.y" /* yacc.c:1646  */
    {
					CollateClause *n = makeNode(CollateClause);
					n->arg = (yyvsp[-2].node);
					n->collname = (yyvsp[0].list);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 37938 "gram.c" /* yacc.c:1646  */
    break;

  case 1730:
#line 11595 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("timezone"),
											   list_make2((yyvsp[0].node), (yyvsp[-4].node)),
											   (yylsp[-3]));
				}
#line 37948 "gram.c" /* yacc.c:1646  */
    break;

  case 1731:
#line 11610 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 37954 "gram.c" /* yacc.c:1646  */
    break;

  case 1732:
#line 11612 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = doNegate((yyvsp[0].node), (yylsp[-1])); }
#line 37960 "gram.c" /* yacc.c:1646  */
    break;

  case 1733:
#line 11614 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 37966 "gram.c" /* yacc.c:1646  */
    break;

  case 1734:
#line 11616 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "-", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 37972 "gram.c" /* yacc.c:1646  */
    break;

  case 1735:
#line 11618 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "*", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 37978 "gram.c" /* yacc.c:1646  */
    break;

  case 1736:
#line 11620 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "/", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 37984 "gram.c" /* yacc.c:1646  */
    break;

  case 1737:
#line 11622 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "%", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 37990 "gram.c" /* yacc.c:1646  */
    break;

  case 1738:
#line 11624 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "^", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 37996 "gram.c" /* yacc.c:1646  */
    break;

  case 1739:
#line 11626 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 38002 "gram.c" /* yacc.c:1646  */
    break;

  case 1740:
#line 11628 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 38008 "gram.c" /* yacc.c:1646  */
    break;

  case 1741:
#line 11630 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 38014 "gram.c" /* yacc.c:1646  */
    break;

  case 1742:
#line 11632 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 38020 "gram.c" /* yacc.c:1646  */
    break;

  case 1743:
#line 11634 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 38026 "gram.c" /* yacc.c:1646  */
    break;

  case 1744:
#line 11636 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<>", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 38032 "gram.c" /* yacc.c:1646  */
    break;

  case 1745:
#line 11639 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 38038 "gram.c" /* yacc.c:1646  */
    break;

  case 1746:
#line 11641 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 38044 "gram.c" /* yacc.c:1646  */
    break;

  case 1747:
#line 11643 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[0].list), (yyvsp[-1].node), NULL, (yylsp[0])); }
#line 38050 "gram.c" /* yacc.c:1646  */
    break;

  case 1748:
#line 11646 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeAndExpr((yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 38056 "gram.c" /* yacc.c:1646  */
    break;

  case 1749:
#line 11648 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeOrExpr((yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 38062 "gram.c" /* yacc.c:1646  */
    break;

  case 1750:
#line 11650 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeNotExpr((yyvsp[0].node), (yylsp[-1])); }
#line 38068 "gram.c" /* yacc.c:1646  */
    break;

  case 1751:
#line 11652 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeNotExpr((yyvsp[0].node), (yylsp[-1])); }
#line 38074 "gram.c" /* yacc.c:1646  */
    break;

  case 1752:
#line 11655 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_LIKE, "~~",
												   (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1]));
				}
#line 38083 "gram.c" /* yacc.c:1646  */
    break;

  case 1753:
#line 11660 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall(SystemFuncName("like_escape"),
											   list_make2((yyvsp[-2].node), (yyvsp[0].node)),
											   (yylsp[-3]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_LIKE, "~~",
												   (yyvsp[-4].node), (Node *) n, (yylsp[-3]));
				}
#line 38095 "gram.c" /* yacc.c:1646  */
    break;

  case 1754:
#line 11668 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_LIKE, "!~~",
												   (yyvsp[-3].node), (yyvsp[0].node), (yylsp[-2]));
				}
#line 38104 "gram.c" /* yacc.c:1646  */
    break;

  case 1755:
#line 11673 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall(SystemFuncName("like_escape"),
											   list_make2((yyvsp[-2].node), (yyvsp[0].node)),
											   (yylsp[-4]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_LIKE, "!~~",
												   (yyvsp[-5].node), (Node *) n, (yylsp[-4]));
				}
#line 38116 "gram.c" /* yacc.c:1646  */
    break;

  case 1756:
#line 11681 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_ILIKE, "~~*",
												   (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1]));
				}
#line 38125 "gram.c" /* yacc.c:1646  */
    break;

  case 1757:
#line 11686 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall(SystemFuncName("like_escape"),
											   list_make2((yyvsp[-2].node), (yyvsp[0].node)),
											   (yylsp[-3]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_ILIKE, "~~*",
												   (yyvsp[-4].node), (Node *) n, (yylsp[-3]));
				}
#line 38137 "gram.c" /* yacc.c:1646  */
    break;

  case 1758:
#line 11694 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_ILIKE, "!~~*",
												   (yyvsp[-3].node), (yyvsp[0].node), (yylsp[-2]));
				}
#line 38146 "gram.c" /* yacc.c:1646  */
    break;

  case 1759:
#line 11699 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall(SystemFuncName("like_escape"),
											   list_make2((yyvsp[-2].node), (yyvsp[0].node)),
											   (yylsp[-4]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_ILIKE, "!~~*",
												   (yyvsp[-5].node), (Node *) n, (yylsp[-4]));
				}
#line 38158 "gram.c" /* yacc.c:1646  */
    break;

  case 1760:
#line 11708 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall(SystemFuncName("similar_escape"),
											   list_make2((yyvsp[0].node), makeNullAConst(-1)),
											   (yylsp[-2]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_SIMILAR, "~",
												   (yyvsp[-3].node), (Node *) n, (yylsp[-2]));
				}
#line 38170 "gram.c" /* yacc.c:1646  */
    break;

  case 1761:
#line 11716 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall(SystemFuncName("similar_escape"),
											   list_make2((yyvsp[-2].node), (yyvsp[0].node)),
											   (yylsp[-4]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_SIMILAR, "~",
												   (yyvsp[-5].node), (Node *) n, (yylsp[-4]));
				}
#line 38182 "gram.c" /* yacc.c:1646  */
    break;

  case 1762:
#line 11724 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall(SystemFuncName("similar_escape"),
											   list_make2((yyvsp[0].node), makeNullAConst(-1)),
											   (yylsp[-3]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_SIMILAR, "!~",
												   (yyvsp[-4].node), (Node *) n, (yylsp[-3]));
				}
#line 38194 "gram.c" /* yacc.c:1646  */
    break;

  case 1763:
#line 11732 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall(SystemFuncName("similar_escape"),
											   list_make2((yyvsp[-2].node), (yyvsp[0].node)),
											   (yylsp[-5]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_SIMILAR, "!~",
												   (yyvsp[-6].node), (Node *) n, (yylsp[-5]));
				}
#line 38206 "gram.c" /* yacc.c:1646  */
    break;

  case 1764:
#line 11750 "gram.y" /* yacc.c:1646  */
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[-2].node);
					n->nulltesttype = IS_NULL;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 38218 "gram.c" /* yacc.c:1646  */
    break;

  case 1765:
#line 11758 "gram.y" /* yacc.c:1646  */
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[-1].node);
					n->nulltesttype = IS_NULL;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 38230 "gram.c" /* yacc.c:1646  */
    break;

  case 1766:
#line 11766 "gram.y" /* yacc.c:1646  */
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[-3].node);
					n->nulltesttype = IS_NOT_NULL;
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *)n;
				}
#line 38242 "gram.c" /* yacc.c:1646  */
    break;

  case 1767:
#line 11774 "gram.y" /* yacc.c:1646  */
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[-1].node);
					n->nulltesttype = IS_NOT_NULL;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 38254 "gram.c" /* yacc.c:1646  */
    break;

  case 1768:
#line 11782 "gram.y" /* yacc.c:1646  */
    {
					if (list_length((yyvsp[-2].list)) != 2)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("wrong number of parameters on left side of OVERLAPS expression"),
								 parser_errposition((yylsp[-2]))));
					if (list_length((yyvsp[0].list)) != 2)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("wrong number of parameters on right side of OVERLAPS expression"),
								 parser_errposition((yylsp[0]))));
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("overlaps"),
											   list_concat((yyvsp[-2].list), (yyvsp[0].list)),
											   (yylsp[-1]));
				}
#line 38274 "gram.c" /* yacc.c:1646  */
    break;

  case 1769:
#line 11798 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-2].node);
					b->booltesttype = IS_TRUE;
					b->location = (yylsp[-1]);
					(yyval.node) = (Node *)b;
				}
#line 38286 "gram.c" /* yacc.c:1646  */
    break;

  case 1770:
#line 11806 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-3].node);
					b->booltesttype = IS_NOT_TRUE;
					b->location = (yylsp[-2]);
					(yyval.node) = (Node *)b;
				}
#line 38298 "gram.c" /* yacc.c:1646  */
    break;

  case 1771:
#line 11814 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-2].node);
					b->booltesttype = IS_FALSE;
					b->location = (yylsp[-1]);
					(yyval.node) = (Node *)b;
				}
#line 38310 "gram.c" /* yacc.c:1646  */
    break;

  case 1772:
#line 11822 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-3].node);
					b->booltesttype = IS_NOT_FALSE;
					b->location = (yylsp[-2]);
					(yyval.node) = (Node *)b;
				}
#line 38322 "gram.c" /* yacc.c:1646  */
    break;

  case 1773:
#line 11830 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-2].node);
					b->booltesttype = IS_UNKNOWN;
					b->location = (yylsp[-1]);
					(yyval.node) = (Node *)b;
				}
#line 38334 "gram.c" /* yacc.c:1646  */
    break;

  case 1774:
#line 11838 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-3].node);
					b->booltesttype = IS_NOT_UNKNOWN;
					b->location = (yylsp[-2]);
					(yyval.node) = (Node *)b;
				}
#line 38346 "gram.c" /* yacc.c:1646  */
    break;

  case 1775:
#line 11846 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[-4].node), (yyvsp[0].node), (yylsp[-3]));
				}
#line 38354 "gram.c" /* yacc.c:1646  */
    break;

  case 1776:
#line 11850 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NOT_DISTINCT, "=", (yyvsp[-5].node), (yyvsp[0].node), (yylsp[-4]));
				}
#line 38362 "gram.c" /* yacc.c:1646  */
    break;

  case 1777:
#line 11854 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "=", (yyvsp[-5].node), (Node *) (yyvsp[-1].list), (yylsp[-4]));
				}
#line 38370 "gram.c" /* yacc.c:1646  */
    break;

  case 1778:
#line 11858 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "<>", (yyvsp[-6].node), (Node *) (yyvsp[-1].list), (yylsp[-5]));
				}
#line 38378 "gram.c" /* yacc.c:1646  */
    break;

  case 1779:
#line 11862 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_BETWEEN,
												   "BETWEEN",
												   (yyvsp[-5].node),
												   (Node *) list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												   (yylsp[-4]));
				}
#line 38390 "gram.c" /* yacc.c:1646  */
    break;

  case 1780:
#line 11870 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NOT_BETWEEN,
												   "NOT BETWEEN",
												   (yyvsp[-6].node),
												   (Node *) list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												   (yylsp[-5]));
				}
#line 38402 "gram.c" /* yacc.c:1646  */
    break;

  case 1781:
#line 11878 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_BETWEEN_SYM,
												   "BETWEEN SYMMETRIC",
												   (yyvsp[-5].node),
												   (Node *) list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												   (yylsp[-4]));
				}
#line 38414 "gram.c" /* yacc.c:1646  */
    break;

  case 1782:
#line 11886 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NOT_BETWEEN_SYM,
												   "NOT BETWEEN SYMMETRIC",
												   (yyvsp[-6].node),
												   (Node *) list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												   (yylsp[-5]));
				}
#line 38426 "gram.c" /* yacc.c:1646  */
    break;

  case 1783:
#line 11894 "gram.y" /* yacc.c:1646  */
    {
					/* in_expr returns a SubLink or a list of a_exprs */
					if (IsA((yyvsp[0].node), SubLink))
					{
						/* generate foo = ANY (subquery) */
						SubLink *n = (SubLink *) (yyvsp[0].node);
						n->subLinkType = ANY_SUBLINK;
						n->subLinkId = 0;
						n->testexpr = (yyvsp[-2].node);
						n->operName = NIL;		/* show it's IN not = ANY */
						n->location = (yylsp[-1]);
						(yyval.node) = (Node *)n;
					}
					else
					{
						/* generate scalar IN expression */
						(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_IN, "=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1]));
					}
				}
#line 38450 "gram.c" /* yacc.c:1646  */
    break;

  case 1784:
#line 11914 "gram.y" /* yacc.c:1646  */
    {
					/* in_expr returns a SubLink or a list of a_exprs */
					if (IsA((yyvsp[0].node), SubLink))
					{
						/* generate NOT (foo = ANY (subquery)) */
						/* Make an = ANY node */
						SubLink *n = (SubLink *) (yyvsp[0].node);
						n->subLinkType = ANY_SUBLINK;
						n->subLinkId = 0;
						n->testexpr = (yyvsp[-3].node);
						n->operName = NIL;		/* show it's IN not = ANY */
						n->location = (yylsp[-2]);
						/* Stick a NOT on top; must have same parse location */
						(yyval.node) = makeNotExpr((Node *) n, (yylsp[-2]));
					}
					else
					{
						/* generate scalar NOT IN expression */
						(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_IN, "<>", (yyvsp[-3].node), (yyvsp[0].node), (yylsp[-2]));
					}
				}
#line 38476 "gram.c" /* yacc.c:1646  */
    break;

  case 1785:
#line 11936 "gram.y" /* yacc.c:1646  */
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = (yyvsp[-1].ival);
					n->subLinkId = 0;
					n->testexpr = (yyvsp[-3].node);
					n->operName = (yyvsp[-2].list);
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *)n;
				}
#line 38491 "gram.c" /* yacc.c:1646  */
    break;

  case 1786:
#line 11947 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[-3].ival) == ANY_SUBLINK)
						(yyval.node) = (Node *) makeA_Expr(AEXPR_OP_ANY, (yyvsp[-4].list), (yyvsp[-5].node), (yyvsp[-1].node), (yylsp[-4]));
					else
						(yyval.node) = (Node *) makeA_Expr(AEXPR_OP_ALL, (yyvsp[-4].list), (yyvsp[-5].node), (yyvsp[-1].node), (yylsp[-4]));
				}
#line 38502 "gram.c" /* yacc.c:1646  */
    break;

  case 1787:
#line 11954 "gram.y" /* yacc.c:1646  */
    {
					/* Not sure how to get rid of the parentheses
					 * but there are lots of shift/reduce errors without them.
					 *
					 * Should be able to implement this by plopping the entire
					 * select into a node, then transforming the target expressions
					 * from whatever they are into count(*), and testing the
					 * entire result equal to one.
					 * But, will probably implement a separate node in the executor.
					 */
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("UNIQUE predicate is not yet implemented"),
							 parser_errposition((yylsp[-1]))));
				}
#line 38522 "gram.c" /* yacc.c:1646  */
    break;

  case 1788:
#line 11970 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_DOCUMENT, NULL, NIL,
									 list_make1((yyvsp[-2].node)), (yylsp[-1]));
				}
#line 38531 "gram.c" /* yacc.c:1646  */
    break;

  case 1789:
#line 11975 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeNotExpr(makeXmlExpr(IS_DOCUMENT, NULL, NIL,
												 list_make1((yyvsp[-3].node)), (yylsp[-2])),
									 (yylsp[-2]));
				}
#line 38541 "gram.c" /* yacc.c:1646  */
    break;

  case 1790:
#line 11992 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 38547 "gram.c" /* yacc.c:1646  */
    break;

  case 1791:
#line 11994 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeTypeCast((yyvsp[-2].node), (yyvsp[0].typnam), (yylsp[-1])); }
#line 38553 "gram.c" /* yacc.c:1646  */
    break;

  case 1792:
#line 11996 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 38559 "gram.c" /* yacc.c:1646  */
    break;

  case 1793:
#line 11998 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = doNegate((yyvsp[0].node), (yylsp[-1])); }
#line 38565 "gram.c" /* yacc.c:1646  */
    break;

  case 1794:
#line 12000 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 38571 "gram.c" /* yacc.c:1646  */
    break;

  case 1795:
#line 12002 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "-", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 38577 "gram.c" /* yacc.c:1646  */
    break;

  case 1796:
#line 12004 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "*", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 38583 "gram.c" /* yacc.c:1646  */
    break;

  case 1797:
#line 12006 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "/", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 38589 "gram.c" /* yacc.c:1646  */
    break;

  case 1798:
#line 12008 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "%", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 38595 "gram.c" /* yacc.c:1646  */
    break;

  case 1799:
#line 12010 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "^", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 38601 "gram.c" /* yacc.c:1646  */
    break;

  case 1800:
#line 12012 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 38607 "gram.c" /* yacc.c:1646  */
    break;

  case 1801:
#line 12014 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 38613 "gram.c" /* yacc.c:1646  */
    break;

  case 1802:
#line 12016 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 38619 "gram.c" /* yacc.c:1646  */
    break;

  case 1803:
#line 12018 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 38625 "gram.c" /* yacc.c:1646  */
    break;

  case 1804:
#line 12020 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 38631 "gram.c" /* yacc.c:1646  */
    break;

  case 1805:
#line 12022 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<>", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 38637 "gram.c" /* yacc.c:1646  */
    break;

  case 1806:
#line 12024 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 38643 "gram.c" /* yacc.c:1646  */
    break;

  case 1807:
#line 12026 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 38649 "gram.c" /* yacc.c:1646  */
    break;

  case 1808:
#line 12028 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[0].list), (yyvsp[-1].node), NULL, (yylsp[0])); }
#line 38655 "gram.c" /* yacc.c:1646  */
    break;

  case 1809:
#line 12030 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[-4].node), (yyvsp[0].node), (yylsp[-3]));
				}
#line 38663 "gram.c" /* yacc.c:1646  */
    break;

  case 1810:
#line 12034 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NOT_DISTINCT, "=", (yyvsp[-5].node), (yyvsp[0].node), (yylsp[-4]));
				}
#line 38671 "gram.c" /* yacc.c:1646  */
    break;

  case 1811:
#line 12038 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "=", (yyvsp[-5].node), (Node *) (yyvsp[-1].list), (yylsp[-4]));
				}
#line 38679 "gram.c" /* yacc.c:1646  */
    break;

  case 1812:
#line 12042 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "<>", (yyvsp[-6].node), (Node *) (yyvsp[-1].list), (yylsp[-5]));
				}
#line 38687 "gram.c" /* yacc.c:1646  */
    break;

  case 1813:
#line 12046 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_DOCUMENT, NULL, NIL,
									 list_make1((yyvsp[-2].node)), (yylsp[-1]));
				}
#line 38696 "gram.c" /* yacc.c:1646  */
    break;

  case 1814:
#line 12051 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeNotExpr(makeXmlExpr(IS_DOCUMENT, NULL, NIL,
												 list_make1((yyvsp[-3].node)), (yylsp[-2])),
									 (yylsp[-2]));
				}
#line 38706 "gram.c" /* yacc.c:1646  */
    break;

  case 1815:
#line 12066 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 38712 "gram.c" /* yacc.c:1646  */
    break;

  case 1816:
#line 12067 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 38718 "gram.c" /* yacc.c:1646  */
    break;

  case 1817:
#line 12069 "gram.y" /* yacc.c:1646  */
    {
					ParamRef *p = makeNode(ParamRef);
					p->number = (yyvsp[-1].ival);
					p->location = (yylsp[-1]);
					if ((yyvsp[0].list))
					{
						A_Indirection *n = makeNode(A_Indirection);
						n->arg = (Node *) p;
						n->indirection = check_indirection((yyvsp[0].list), yyscanner);
						(yyval.node) = (Node *) n;
					}
					else
						(yyval.node) = (Node *) p;
				}
#line 38737 "gram.c" /* yacc.c:1646  */
    break;

  case 1818:
#line 12084 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].list))
					{
						A_Indirection *n = makeNode(A_Indirection);
						n->arg = (yyvsp[-2].node);
						n->indirection = check_indirection((yyvsp[0].list), yyscanner);
						(yyval.node) = (Node *)n;
					}
					else if (operator_precedence_warning)
					{
						/*
						 * If precedence warnings are enabled, insert
						 * AEXPR_PAREN nodes wrapping all explicitly
						 * parenthesized subexpressions; this prevents bogus
						 * warnings from being issued when the ordering has
						 * been forced by parentheses.
						 *
						 * In principle we should not be relying on a GUC to
						 * decide whether to insert AEXPR_PAREN nodes.
						 * However, since they have no effect except to
						 * suppress warnings, it's probably safe enough; and
						 * we'd just as soon not waste cycles on dummy parse
						 * nodes if we don't have to.
						 */
						(yyval.node) = (Node *) makeA_Expr(AEXPR_PAREN, NIL, (yyvsp[-2].node), NULL, (yylsp[-3]));
					}
					else
						(yyval.node) = (yyvsp[-2].node);
				}
#line 38771 "gram.c" /* yacc.c:1646  */
    break;

  case 1819:
#line 12114 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 38777 "gram.c" /* yacc.c:1646  */
    break;

  case 1820:
#line 12116 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 38783 "gram.c" /* yacc.c:1646  */
    break;

  case 1821:
#line 12118 "gram.y" /* yacc.c:1646  */
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = EXPR_SUBLINK;
					n->subLinkId = 0;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 38798 "gram.c" /* yacc.c:1646  */
    break;

  case 1822:
#line 12129 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Because the select_with_parens nonterminal is designed
					 * to "eat" as many levels of parens as possible, the
					 * '(' a_expr ')' opt_indirection production above will
					 * fail to match a sub-SELECT with indirection decoration;
					 * the sub-SELECT won't be regarded as an a_expr as long
					 * as there are parens around it.  To support applying
					 * subscripting or field selection to a sub-SELECT result,
					 * we need this redundant-looking production.
					 */
					SubLink *n = makeNode(SubLink);
					A_Indirection *a = makeNode(A_Indirection);
					n->subLinkType = EXPR_SUBLINK;
					n->subLinkId = 0;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[-1].node);
					n->location = (yylsp[-1]);
					a->arg = (Node *)n;
					a->indirection = check_indirection((yyvsp[0].list), yyscanner);
					(yyval.node) = (Node *)a;
				}
#line 38826 "gram.c" /* yacc.c:1646  */
    break;

  case 1823:
#line 12153 "gram.y" /* yacc.c:1646  */
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = EXISTS_SUBLINK;
					n->subLinkId = 0;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 38841 "gram.c" /* yacc.c:1646  */
    break;

  case 1824:
#line 12164 "gram.y" /* yacc.c:1646  */
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = ARRAY_SUBLINK;
					n->subLinkId = 0;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 38856 "gram.c" /* yacc.c:1646  */
    break;

  case 1825:
#line 12175 "gram.y" /* yacc.c:1646  */
    {
					A_ArrayExpr *n = (A_ArrayExpr *) (yyvsp[0].node);
					Assert(IsA(n, A_ArrayExpr));
					/* point outermost A_ArrayExpr to the ARRAY keyword */
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 38868 "gram.c" /* yacc.c:1646  */
    break;

  case 1826:
#line 12183 "gram.y" /* yacc.c:1646  */
    {
					RowExpr *r = makeNode(RowExpr);
					r->args = (yyvsp[0].list);
					r->row_typeid = InvalidOid;	/* not analyzed yet */
					r->colnames = NIL;	/* to be filled in during analysis */
					r->row_format = COERCE_EXPLICIT_CALL; /* abuse */
					r->location = (yylsp[0]);
					(yyval.node) = (Node *)r;
				}
#line 38882 "gram.c" /* yacc.c:1646  */
    break;

  case 1827:
#line 12193 "gram.y" /* yacc.c:1646  */
    {
					RowExpr *r = makeNode(RowExpr);
					r->args = (yyvsp[0].list);
					r->row_typeid = InvalidOid;	/* not analyzed yet */
					r->colnames = NIL;	/* to be filled in during analysis */
					r->row_format = COERCE_IMPLICIT_CAST; /* abuse */
					r->location = (yylsp[0]);
					(yyval.node) = (Node *)r;
				}
#line 38896 "gram.c" /* yacc.c:1646  */
    break;

  case 1828:
#line 12203 "gram.y" /* yacc.c:1646  */
    {
				  GroupingFunc *g = makeNode(GroupingFunc);
				  g->args = (yyvsp[-1].list);
				  g->location = (yylsp[-3]);
				  (yyval.node) = (Node *)g;
			  }
#line 38907 "gram.c" /* yacc.c:1646  */
    break;

  case 1829:
#line 12212 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall((yyvsp[-2].list), NIL, (yylsp[-2]));
				}
#line 38915 "gram.c" /* yacc.c:1646  */
    break;

  case 1830:
#line 12216 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall((yyvsp[-4].list), (yyvsp[-2].list), (yylsp[-4]));
					n->agg_order = (yyvsp[-1].list);
					(yyval.node) = (Node *)n;
				}
#line 38925 "gram.c" /* yacc.c:1646  */
    break;

  case 1831:
#line 12222 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall((yyvsp[-5].list), list_make1((yyvsp[-2].node)), (yylsp[-5]));
					n->func_variadic = TRUE;
					n->agg_order = (yyvsp[-1].list);
					(yyval.node) = (Node *)n;
				}
#line 38936 "gram.c" /* yacc.c:1646  */
    break;

  case 1832:
#line 12229 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall((yyvsp[-7].list), lappend((yyvsp[-5].list), (yyvsp[-2].node)), (yylsp[-7]));
					n->func_variadic = TRUE;
					n->agg_order = (yyvsp[-1].list);
					(yyval.node) = (Node *)n;
				}
#line 38947 "gram.c" /* yacc.c:1646  */
    break;

  case 1833:
#line 12236 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall((yyvsp[-5].list), (yyvsp[-2].list), (yylsp[-5]));
					n->agg_order = (yyvsp[-1].list);
					/* Ideally we'd mark the FuncCall node to indicate
					 * "must be an aggregate", but there's no provision
					 * for that in FuncCall at the moment.
					 */
					(yyval.node) = (Node *)n;
				}
#line 38961 "gram.c" /* yacc.c:1646  */
    break;

  case 1834:
#line 12246 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall((yyvsp[-5].list), (yyvsp[-2].list), (yylsp[-5]));
					n->agg_order = (yyvsp[-1].list);
					n->agg_distinct = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 38972 "gram.c" /* yacc.c:1646  */
    break;

  case 1835:
#line 12253 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * We consider AGGREGATE(*) to invoke a parameterless
					 * aggregate.  This does the right thing for COUNT(*),
					 * and there are no other aggregates in SQL that accept
					 * '*' as parameter.
					 *
					 * The FuncCall node is also marked agg_star = true,
					 * so that later processing can detect what the argument
					 * really was.
					 */
					FuncCall *n = makeFuncCall((yyvsp[-3].list), NIL, (yylsp[-3]));
					n->agg_star = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 38992 "gram.c" /* yacc.c:1646  */
    break;

  case 1836:
#line 12281 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = (FuncCall *) (yyvsp[-3].node);
					/*
					 * The order clause for WITHIN GROUP and the one for
					 * plain-aggregate ORDER BY share a field, so we have to
					 * check here that at most one is present.  We also check
					 * for DISTINCT and VARIADIC here to give a better error
					 * location.  Other consistency checks are deferred to
					 * parse analysis.
					 */
					if ((yyvsp[-2].list) != NIL)
					{
						if (n->agg_order != NIL)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("cannot use multiple ORDER BY clauses with WITHIN GROUP"),
									 parser_errposition((yylsp[-2]))));
						if (n->agg_distinct)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("cannot use DISTINCT with WITHIN GROUP"),
									 parser_errposition((yylsp[-2]))));
						if (n->func_variadic)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("cannot use VARIADIC with WITHIN GROUP"),
									 parser_errposition((yylsp[-2]))));
						n->agg_order = (yyvsp[-2].list);
						n->agg_within_group = TRUE;
					}
					n->agg_filter = (yyvsp[-1].node);
					n->over = (yyvsp[0].windef);
					(yyval.node) = (Node *) n;
				}
#line 39031 "gram.c" /* yacc.c:1646  */
    break;

  case 1837:
#line 12316 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 39037 "gram.c" /* yacc.c:1646  */
    break;

  case 1838:
#line 12326 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 39043 "gram.c" /* yacc.c:1646  */
    break;

  case 1839:
#line 12327 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 39049 "gram.c" /* yacc.c:1646  */
    break;

  case 1840:
#line 12335 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("pg_collation_for"),
											   list_make1((yyvsp[-1].node)),
											   (yylsp[-4]));
				}
#line 39059 "gram.c" /* yacc.c:1646  */
    break;

  case 1841:
#line 12341 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Translate as "'now'::text::date".
					 *
					 * We cannot use "'now'::date" because coerce_type() will
					 * immediately reduce that to a constant representing
					 * today's date.  We need to delay the conversion until
					 * runtime, else the wrong things will happen when
					 * CURRENT_DATE is used in a column default value or rule.
					 *
					 * This could be simplified if we had a way to generate
					 * an expression tree representing runtime application
					 * of type-input conversion functions.  (As of PG 7.3
					 * that is actually possible, but not clear that we want
					 * to rely on it.)
					 *
					 * The token location is attached to the run-time
					 * typecast, not to the Const, for the convenience of
					 * pg_stat_statements (which doesn't want these constructs
					 * to appear to be replaceable constants).
					 */
					Node *n;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					(yyval.node) = makeTypeCast(n, SystemTypeName("date"), (yylsp[0]));
				}
#line 39089 "gram.c" /* yacc.c:1646  */
    break;

  case 1842:
#line 12367 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Translate as "'now'::text::timetz".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					(yyval.node) = makeTypeCast(n, SystemTypeName("timetz"), (yylsp[0]));
				}
#line 39103 "gram.c" /* yacc.c:1646  */
    break;

  case 1843:
#line 12377 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Translate as "'now'::text::timetz(n)".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					TypeName *d;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					d = SystemTypeName("timetz");
					d->typmods = list_make1(makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
					(yyval.node) = makeTypeCast(n, d, (yylsp[-3]));
				}
#line 39120 "gram.c" /* yacc.c:1646  */
    break;

  case 1844:
#line 12390 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Translate as "now()", since we have a function that
					 * does exactly what is needed.
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("now"), NIL, (yylsp[0]));
				}
#line 39132 "gram.c" /* yacc.c:1646  */
    break;

  case 1845:
#line 12398 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Translate as "'now'::text::timestamptz(n)".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					TypeName *d;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					d = SystemTypeName("timestamptz");
					d->typmods = list_make1(makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
					(yyval.node) = makeTypeCast(n, d, (yylsp[-3]));
				}
#line 39149 "gram.c" /* yacc.c:1646  */
    break;

  case 1846:
#line 12411 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Translate as "'now'::text::time".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					(yyval.node) = makeTypeCast((Node *)n, SystemTypeName("time"), (yylsp[0]));
				}
#line 39163 "gram.c" /* yacc.c:1646  */
    break;

  case 1847:
#line 12421 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Translate as "'now'::text::time(n)".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					TypeName *d;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					d = SystemTypeName("time");
					d->typmods = list_make1(makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
					(yyval.node) = makeTypeCast((Node *)n, d, (yylsp[-3]));
				}
#line 39180 "gram.c" /* yacc.c:1646  */
    break;

  case 1848:
#line 12434 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Translate as "'now'::text::timestamp".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					(yyval.node) = makeTypeCast(n, SystemTypeName("timestamp"), (yylsp[0]));
				}
#line 39194 "gram.c" /* yacc.c:1646  */
    break;

  case 1849:
#line 12444 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Translate as "'now'::text::timestamp(n)".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					TypeName *d;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					d = SystemTypeName("timestamp");
					d->typmods = list_make1(makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
					(yyval.node) = makeTypeCast(n, d, (yylsp[-3]));
				}
#line 39211 "gram.c" /* yacc.c:1646  */
    break;

  case 1850:
#line 12457 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("current_user"), NIL, (yylsp[0]));
				}
#line 39219 "gram.c" /* yacc.c:1646  */
    break;

  case 1851:
#line 12461 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("current_user"), NIL, (yylsp[0]));
				}
#line 39227 "gram.c" /* yacc.c:1646  */
    break;

  case 1852:
#line 12465 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("session_user"), NIL, (yylsp[0]));
				}
#line 39235 "gram.c" /* yacc.c:1646  */
    break;

  case 1853:
#line 12469 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("current_user"), NIL, (yylsp[0]));
				}
#line 39243 "gram.c" /* yacc.c:1646  */
    break;

  case 1854:
#line 12473 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("current_database"), NIL, (yylsp[0]));
				}
#line 39251 "gram.c" /* yacc.c:1646  */
    break;

  case 1855:
#line 12477 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("current_schema"), NIL, (yylsp[0]));
				}
#line 39259 "gram.c" /* yacc.c:1646  */
    break;

  case 1856:
#line 12481 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeTypeCast((yyvsp[-3].node), (yyvsp[-1].typnam), (yylsp[-5])); }
#line 39265 "gram.c" /* yacc.c:1646  */
    break;

  case 1857:
#line 12483 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("date_part"), (yyvsp[-1].list), (yylsp[-3]));
				}
#line 39273 "gram.c" /* yacc.c:1646  */
    break;

  case 1858:
#line 12487 "gram.y" /* yacc.c:1646  */
    {
					/* overlay(A PLACING B FROM C FOR D) is converted to
					 * overlay(A, B, C, D)
					 * overlay(A PLACING B FROM C) is converted to
					 * overlay(A, B, C)
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("overlay"), (yyvsp[-1].list), (yylsp[-3]));
				}
#line 39286 "gram.c" /* yacc.c:1646  */
    break;

  case 1859:
#line 12496 "gram.y" /* yacc.c:1646  */
    {
					/* position(A in B) is converted to position(B, A) */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("position"), (yyvsp[-1].list), (yylsp[-3]));
				}
#line 39295 "gram.c" /* yacc.c:1646  */
    break;

  case 1860:
#line 12501 "gram.y" /* yacc.c:1646  */
    {
					/* substring(A from B for C) is converted to
					 * substring(A, B, C) - thomas 2000-11-28
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("substring"), (yyvsp[-1].list), (yylsp[-3]));
				}
#line 39306 "gram.c" /* yacc.c:1646  */
    break;

  case 1861:
#line 12508 "gram.y" /* yacc.c:1646  */
    {
					/* TREAT(expr AS target) converts expr of a particular type to target,
					 * which is defined to be a subtype of the original expression.
					 * In SQL99, this is intended for use with structured UDTs,
					 * but let's make this a generally useful form allowing stronger
					 * coercions than are handled by implicit casting.
					 *
					 * Convert SystemTypeName() to SystemFuncName() even though
					 * at the moment they result in the same thing.
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName(((Value *)llast((yyvsp[-1].typnam)->names))->val.str),
												list_make1((yyvsp[-3].node)),
												(yylsp[-5]));
				}
#line 39325 "gram.c" /* yacc.c:1646  */
    break;

  case 1862:
#line 12523 "gram.y" /* yacc.c:1646  */
    {
					/* various trim expressions are defined in SQL
					 * - thomas 1997-07-19
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("btrim"), (yyvsp[-1].list), (yylsp[-4]));
				}
#line 39336 "gram.c" /* yacc.c:1646  */
    break;

  case 1863:
#line 12530 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("ltrim"), (yyvsp[-1].list), (yylsp[-4]));
				}
#line 39344 "gram.c" /* yacc.c:1646  */
    break;

  case 1864:
#line 12534 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("rtrim"), (yyvsp[-1].list), (yylsp[-4]));
				}
#line 39352 "gram.c" /* yacc.c:1646  */
    break;

  case 1865:
#line 12538 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("btrim"), (yyvsp[-1].list), (yylsp[-3]));
				}
#line 39360 "gram.c" /* yacc.c:1646  */
    break;

  case 1866:
#line 12542 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NULLIF, "=", (yyvsp[-3].node), (yyvsp[-1].node), (yylsp[-5]));
				}
#line 39368 "gram.c" /* yacc.c:1646  */
    break;

  case 1867:
#line 12546 "gram.y" /* yacc.c:1646  */
    {
					CoalesceExpr *c = makeNode(CoalesceExpr);
					c->args = (yyvsp[-1].list);
					c->location = (yylsp[-3]);
					(yyval.node) = (Node *)c;
				}
#line 39379 "gram.c" /* yacc.c:1646  */
    break;

  case 1868:
#line 12553 "gram.y" /* yacc.c:1646  */
    {
					MinMaxExpr *v = makeNode(MinMaxExpr);
					v->args = (yyvsp[-1].list);
					v->op = IS_GREATEST;
					v->location = (yylsp[-3]);
					(yyval.node) = (Node *)v;
				}
#line 39391 "gram.c" /* yacc.c:1646  */
    break;

  case 1869:
#line 12561 "gram.y" /* yacc.c:1646  */
    {
					MinMaxExpr *v = makeNode(MinMaxExpr);
					v->args = (yyvsp[-1].list);
					v->op = IS_LEAST;
					v->location = (yylsp[-3]);
					(yyval.node) = (Node *)v;
				}
#line 39403 "gram.c" /* yacc.c:1646  */
    break;

  case 1870:
#line 12569 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLCONCAT, NULL, NIL, (yyvsp[-1].list), (yylsp[-3]));
				}
#line 39411 "gram.c" /* yacc.c:1646  */
    break;

  case 1871:
#line 12573 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-1].str), NIL, NIL, (yylsp[-4]));
				}
#line 39419 "gram.c" /* yacc.c:1646  */
    break;

  case 1872:
#line 12577 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-3].str), (yyvsp[-1].list), NIL, (yylsp[-6]));
				}
#line 39427 "gram.c" /* yacc.c:1646  */
    break;

  case 1873:
#line 12581 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-3].str), NIL, (yyvsp[-1].list), (yylsp[-6]));
				}
#line 39435 "gram.c" /* yacc.c:1646  */
    break;

  case 1874:
#line 12585 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-5].str), (yyvsp[-3].list), (yyvsp[-1].list), (yylsp[-8]));
				}
#line 39443 "gram.c" /* yacc.c:1646  */
    break;

  case 1875:
#line 12589 "gram.y" /* yacc.c:1646  */
    {
					/* xmlexists(A PASSING [BY REF] B [BY REF]) is
					 * converted to xmlexists(A, B)*/
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("xmlexists"), list_make2((yyvsp[-2].node), (yyvsp[-1].node)), (yylsp[-4]));
				}
#line 39453 "gram.c" /* yacc.c:1646  */
    break;

  case 1876:
#line 12595 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLFOREST, NULL, (yyvsp[-1].list), NIL, (yylsp[-3]));
				}
#line 39461 "gram.c" /* yacc.c:1646  */
    break;

  case 1877:
#line 12599 "gram.y" /* yacc.c:1646  */
    {
					XmlExpr *x = (XmlExpr *)
						makeXmlExpr(IS_XMLPARSE, NULL, NIL,
									list_make2((yyvsp[-2].node), makeBoolAConst((yyvsp[-1].boolean), -1)),
									(yylsp[-5]));
					x->xmloption = (yyvsp[-3].ival);
					(yyval.node) = (Node *)x;
				}
#line 39474 "gram.c" /* yacc.c:1646  */
    break;

  case 1878:
#line 12608 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLPI, (yyvsp[-1].str), NULL, NIL, (yylsp[-4]));
				}
#line 39482 "gram.c" /* yacc.c:1646  */
    break;

  case 1879:
#line 12612 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLPI, (yyvsp[-3].str), NULL, list_make1((yyvsp[-1].node)), (yylsp[-6]));
				}
#line 39490 "gram.c" /* yacc.c:1646  */
    break;

  case 1880:
#line 12616 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLROOT, NULL, NIL,
									 list_make3((yyvsp[-4].node), (yyvsp[-2].node), (yyvsp[-1].node)), (yylsp[-6]));
				}
#line 39499 "gram.c" /* yacc.c:1646  */
    break;

  case 1881:
#line 12621 "gram.y" /* yacc.c:1646  */
    {
					XmlSerialize *n = makeNode(XmlSerialize);
					n->xmloption = (yyvsp[-4].ival);
					n->expr = (yyvsp[-3].node);
					n->typeName = (yyvsp[-1].typnam);
					n->location = (yylsp[-6]);
					(yyval.node) = (Node *)n;
				}
#line 39512 "gram.c" /* yacc.c:1646  */
    break;

  case 1882:
#line 12635 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 39518 "gram.c" /* yacc.c:1646  */
    break;

  case 1883:
#line 12637 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeNullAConst(-1); }
#line 39524 "gram.c" /* yacc.c:1646  */
    break;

  case 1884:
#line 12641 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(XML_STANDALONE_YES, -1); }
#line 39530 "gram.c" /* yacc.c:1646  */
    break;

  case 1885:
#line 12643 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(XML_STANDALONE_NO, -1); }
#line 39536 "gram.c" /* yacc.c:1646  */
    break;

  case 1886:
#line 12645 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(XML_STANDALONE_NO_VALUE, -1); }
#line 39542 "gram.c" /* yacc.c:1646  */
    break;

  case 1887:
#line 12647 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(XML_STANDALONE_OMITTED, -1); }
#line 39548 "gram.c" /* yacc.c:1646  */
    break;

  case 1888:
#line 12650 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 39554 "gram.c" /* yacc.c:1646  */
    break;

  case 1889:
#line 12653 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 39560 "gram.c" /* yacc.c:1646  */
    break;

  case 1890:
#line 12654 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 39566 "gram.c" /* yacc.c:1646  */
    break;

  case 1891:
#line 12658 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[-2].node);
					(yyval.target)->location = (yylsp[-2]);
				}
#line 39578 "gram.c" /* yacc.c:1646  */
    break;

  case 1892:
#line 12666 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[0].node);
					(yyval.target)->location = (yylsp[0]);
				}
#line 39590 "gram.c" /* yacc.c:1646  */
    break;

  case 1893:
#line 12675 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = XMLOPTION_DOCUMENT; }
#line 39596 "gram.c" /* yacc.c:1646  */
    break;

  case 1894:
#line 12676 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = XMLOPTION_CONTENT; }
#line 39602 "gram.c" /* yacc.c:1646  */
    break;

  case 1895:
#line 12679 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 39608 "gram.c" /* yacc.c:1646  */
    break;

  case 1896:
#line 12680 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 39614 "gram.c" /* yacc.c:1646  */
    break;

  case 1897:
#line 12681 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 39620 "gram.c" /* yacc.c:1646  */
    break;

  case 1898:
#line 12687 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[0].node);
				}
#line 39628 "gram.c" /* yacc.c:1646  */
    break;

  case 1899:
#line 12691 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[-2].node);
				}
#line 39636 "gram.c" /* yacc.c:1646  */
    break;

  case 1900:
#line 12695 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[0].node);
				}
#line 39644 "gram.c" /* yacc.c:1646  */
    break;

  case 1901:
#line 12699 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[-2].node);
				}
#line 39652 "gram.c" /* yacc.c:1646  */
    break;

  case 1902:
#line 12709 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 39658 "gram.c" /* yacc.c:1646  */
    break;

  case 1903:
#line 12710 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 39664 "gram.c" /* yacc.c:1646  */
    break;

  case 1904:
#line 12714 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 39670 "gram.c" /* yacc.c:1646  */
    break;

  case 1905:
#line 12715 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 39676 "gram.c" /* yacc.c:1646  */
    break;

  case 1906:
#line 12723 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 39682 "gram.c" /* yacc.c:1646  */
    break;

  case 1907:
#line 12724 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 39688 "gram.c" /* yacc.c:1646  */
    break;

  case 1908:
#line 12728 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].windef)); }
#line 39694 "gram.c" /* yacc.c:1646  */
    break;

  case 1909:
#line 12730 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].windef)); }
#line 39700 "gram.c" /* yacc.c:1646  */
    break;

  case 1910:
#line 12735 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = (yyvsp[0].windef);
					n->name = (yyvsp[-2].str);
					(yyval.windef) = n;
				}
#line 39710 "gram.c" /* yacc.c:1646  */
    break;

  case 1911:
#line 12743 "gram.y" /* yacc.c:1646  */
    { (yyval.windef) = (yyvsp[0].windef); }
#line 39716 "gram.c" /* yacc.c:1646  */
    break;

  case 1912:
#line 12745 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->name = (yyvsp[0].str);
					n->refname = NULL;
					n->partitionClause = NIL;
					n->orderClause = NIL;
					n->frameOptions = FRAMEOPTION_DEFAULTS;
					n->startOffset = NULL;
					n->endOffset = NULL;
					n->location = (yylsp[0]);
					(yyval.windef) = n;
				}
#line 39733 "gram.c" /* yacc.c:1646  */
    break;

  case 1913:
#line 12758 "gram.y" /* yacc.c:1646  */
    { (yyval.windef) = NULL; }
#line 39739 "gram.c" /* yacc.c:1646  */
    break;

  case 1914:
#line 12763 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->name = NULL;
					n->refname = (yyvsp[-4].str);
					n->partitionClause = (yyvsp[-3].list);
					n->orderClause = (yyvsp[-2].list);
					/* copy relevant fields of opt_frame_clause */
					n->frameOptions = (yyvsp[-1].windef)->frameOptions;
					n->startOffset = (yyvsp[-1].windef)->startOffset;
					n->endOffset = (yyvsp[-1].windef)->endOffset;
					n->location = (yylsp[-5]);
					(yyval.windef) = n;
				}
#line 39757 "gram.c" /* yacc.c:1646  */
    break;

  case 1915:
#line 12788 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 39763 "gram.c" /* yacc.c:1646  */
    break;

  case 1916:
#line 12789 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 39769 "gram.c" /* yacc.c:1646  */
    break;

  case 1917:
#line 12792 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 39775 "gram.c" /* yacc.c:1646  */
    break;

  case 1918:
#line 12793 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 39781 "gram.c" /* yacc.c:1646  */
    break;

  case 1919:
#line 12805 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = (yyvsp[0].windef);
					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_RANGE;
					if (n->frameOptions & (FRAMEOPTION_START_VALUE_PRECEDING |
										   FRAMEOPTION_END_VALUE_PRECEDING))
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("RANGE PRECEDING is only supported with UNBOUNDED"),
								 parser_errposition((yylsp[-1]))));
					if (n->frameOptions & (FRAMEOPTION_START_VALUE_FOLLOWING |
										   FRAMEOPTION_END_VALUE_FOLLOWING))
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("RANGE FOLLOWING is only supported with UNBOUNDED"),
								 parser_errposition((yylsp[-1]))));
					(yyval.windef) = n;
				}
#line 39803 "gram.c" /* yacc.c:1646  */
    break;

  case 1920:
#line 12823 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = (yyvsp[0].windef);
					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_ROWS;
					(yyval.windef) = n;
				}
#line 39813 "gram.c" /* yacc.c:1646  */
    break;

  case 1921:
#line 12829 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_DEFAULTS;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 39825 "gram.c" /* yacc.c:1646  */
    break;

  case 1922:
#line 12839 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = (yyvsp[0].windef);
					/* reject invalid cases */
					if (n->frameOptions & FRAMEOPTION_START_UNBOUNDED_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame start cannot be UNBOUNDED FOLLOWING"),
								 parser_errposition((yylsp[0]))));
					if (n->frameOptions & FRAMEOPTION_START_VALUE_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from following row cannot end with current row"),
								 parser_errposition((yylsp[0]))));
					n->frameOptions |= FRAMEOPTION_END_CURRENT_ROW;
					(yyval.windef) = n;
				}
#line 39846 "gram.c" /* yacc.c:1646  */
    break;

  case 1923:
#line 12856 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n1 = (yyvsp[-2].windef);
					WindowDef *n2 = (yyvsp[0].windef);
					/* form merged options */
					int		frameOptions = n1->frameOptions;
					/* shift converts START_ options to END_ options */
					frameOptions |= n2->frameOptions << 1;
					frameOptions |= FRAMEOPTION_BETWEEN;
					/* reject invalid cases */
					if (frameOptions & FRAMEOPTION_START_UNBOUNDED_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame start cannot be UNBOUNDED FOLLOWING"),
								 parser_errposition((yylsp[-2]))));
					if (frameOptions & FRAMEOPTION_END_UNBOUNDED_PRECEDING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame end cannot be UNBOUNDED PRECEDING"),
								 parser_errposition((yylsp[0]))));
					if ((frameOptions & FRAMEOPTION_START_CURRENT_ROW) &&
						(frameOptions & FRAMEOPTION_END_VALUE_PRECEDING))
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from current row cannot have preceding rows"),
								 parser_errposition((yylsp[0]))));
					if ((frameOptions & FRAMEOPTION_START_VALUE_FOLLOWING) &&
						(frameOptions & (FRAMEOPTION_END_VALUE_PRECEDING |
										 FRAMEOPTION_END_CURRENT_ROW)))
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from following row cannot have preceding rows"),
								 parser_errposition((yylsp[0]))));
					n1->frameOptions = frameOptions;
					n1->endOffset = n2->startOffset;
					(yyval.windef) = n1;
				}
#line 39887 "gram.c" /* yacc.c:1646  */
    break;

  case 1924:
#line 12901 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_UNBOUNDED_PRECEDING;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 39899 "gram.c" /* yacc.c:1646  */
    break;

  case 1925:
#line 12909 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_UNBOUNDED_FOLLOWING;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 39911 "gram.c" /* yacc.c:1646  */
    break;

  case 1926:
#line 12917 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_CURRENT_ROW;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 39923 "gram.c" /* yacc.c:1646  */
    break;

  case 1927:
#line 12925 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_VALUE_PRECEDING;
					n->startOffset = (yyvsp[-1].node);
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 39935 "gram.c" /* yacc.c:1646  */
    break;

  case 1928:
#line 12933 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_VALUE_FOLLOWING;
					n->startOffset = (yyvsp[-1].node);
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 39947 "gram.c" /* yacc.c:1646  */
    break;

  case 1929:
#line 12953 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 39953 "gram.c" /* yacc.c:1646  */
    break;

  case 1930:
#line 12954 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 39959 "gram.c" /* yacc.c:1646  */
    break;

  case 1931:
#line 12955 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-3].list), (yyvsp[-1].node)); }
#line 39965 "gram.c" /* yacc.c:1646  */
    break;

  case 1932:
#line 12958 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 39971 "gram.c" /* yacc.c:1646  */
    break;

  case 1933:
#line 12959 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 39977 "gram.c" /* yacc.c:1646  */
    break;

  case 1934:
#line 12962 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-3].list), (yyvsp[-1].node)); }
#line 39983 "gram.c" /* yacc.c:1646  */
    break;

  case 1935:
#line 12965 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ANY_SUBLINK; }
#line 39989 "gram.c" /* yacc.c:1646  */
    break;

  case 1936:
#line 12966 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ANY_SUBLINK; }
#line 39995 "gram.c" /* yacc.c:1646  */
    break;

  case 1937:
#line 12967 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ALL_SUBLINK; }
#line 40001 "gram.c" /* yacc.c:1646  */
    break;

  case 1938:
#line 12970 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 40007 "gram.c" /* yacc.c:1646  */
    break;

  case 1939:
#line 12971 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 40013 "gram.c" /* yacc.c:1646  */
    break;

  case 1940:
#line 12974 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "+"; }
#line 40019 "gram.c" /* yacc.c:1646  */
    break;

  case 1941:
#line 12975 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "-"; }
#line 40025 "gram.c" /* yacc.c:1646  */
    break;

  case 1942:
#line 12976 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "*"; }
#line 40031 "gram.c" /* yacc.c:1646  */
    break;

  case 1943:
#line 12977 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "/"; }
#line 40037 "gram.c" /* yacc.c:1646  */
    break;

  case 1944:
#line 12978 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "%"; }
#line 40043 "gram.c" /* yacc.c:1646  */
    break;

  case 1945:
#line 12979 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "^"; }
#line 40049 "gram.c" /* yacc.c:1646  */
    break;

  case 1946:
#line 12980 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "<"; }
#line 40055 "gram.c" /* yacc.c:1646  */
    break;

  case 1947:
#line 12981 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = ">"; }
#line 40061 "gram.c" /* yacc.c:1646  */
    break;

  case 1948:
#line 12982 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "="; }
#line 40067 "gram.c" /* yacc.c:1646  */
    break;

  case 1949:
#line 12983 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "<="; }
#line 40073 "gram.c" /* yacc.c:1646  */
    break;

  case 1950:
#line 12984 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = ">="; }
#line 40079 "gram.c" /* yacc.c:1646  */
    break;

  case 1951:
#line 12985 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "<>"; }
#line 40085 "gram.c" /* yacc.c:1646  */
    break;

  case 1952:
#line 12989 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 40091 "gram.c" /* yacc.c:1646  */
    break;

  case 1953:
#line 12991 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 40097 "gram.c" /* yacc.c:1646  */
    break;

  case 1954:
#line 12996 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 40103 "gram.c" /* yacc.c:1646  */
    break;

  case 1955:
#line 12998 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 40109 "gram.c" /* yacc.c:1646  */
    break;

  case 1956:
#line 13003 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 40115 "gram.c" /* yacc.c:1646  */
    break;

  case 1957:
#line 13005 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 40121 "gram.c" /* yacc.c:1646  */
    break;

  case 1958:
#line 13007 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString("~~")); }
#line 40127 "gram.c" /* yacc.c:1646  */
    break;

  case 1959:
#line 13009 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString("!~~")); }
#line 40133 "gram.c" /* yacc.c:1646  */
    break;

  case 1960:
#line 13011 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString("~~*")); }
#line 40139 "gram.c" /* yacc.c:1646  */
    break;

  case 1961:
#line 13013 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString("!~~*")); }
#line 40145 "gram.c" /* yacc.c:1646  */
    break;

  case 1962:
#line 13025 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 40153 "gram.c" /* yacc.c:1646  */
    break;

  case 1963:
#line 13029 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 40161 "gram.c" /* yacc.c:1646  */
    break;

  case 1964:
#line 13036 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 40169 "gram.c" /* yacc.c:1646  */
    break;

  case 1965:
#line 13040 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 40177 "gram.c" /* yacc.c:1646  */
    break;

  case 1966:
#line 13046 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[0].node);
				}
#line 40185 "gram.c" /* yacc.c:1646  */
    break;

  case 1967:
#line 13050 "gram.y" /* yacc.c:1646  */
    {
					NamedArgExpr *na = makeNode(NamedArgExpr);
					na->name = (yyvsp[-2].str);
					na->arg = (Expr *) (yyvsp[0].node);
					na->argnumber = -1;		/* until determined */
					na->location = (yylsp[-2]);
					(yyval.node) = (Node *) na;
				}
#line 40198 "gram.c" /* yacc.c:1646  */
    break;

  case 1968:
#line 13059 "gram.y" /* yacc.c:1646  */
    {
					NamedArgExpr *na = makeNode(NamedArgExpr);
					na->name = (yyvsp[-2].str);
					na->arg = (Expr *) (yyvsp[0].node);
					na->argnumber = -1;		/* until determined */
					na->location = (yylsp[-2]);
					(yyval.node) = (Node *) na;
				}
#line 40211 "gram.c" /* yacc.c:1646  */
    break;

  case 1969:
#line 13069 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].typnam)); }
#line 40217 "gram.c" /* yacc.c:1646  */
    break;

  case 1970:
#line 13070 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].typnam)); }
#line 40223 "gram.c" /* yacc.c:1646  */
    break;

  case 1971:
#line 13074 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeAArrayExpr((yyvsp[-1].list), (yylsp[-2]));
				}
#line 40231 "gram.c" /* yacc.c:1646  */
    break;

  case 1972:
#line 13078 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeAArrayExpr((yyvsp[-1].list), (yylsp[-2]));
				}
#line 40239 "gram.c" /* yacc.c:1646  */
    break;

  case 1973:
#line 13082 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeAArrayExpr(NIL, (yylsp[-1]));
				}
#line 40247 "gram.c" /* yacc.c:1646  */
    break;

  case 1974:
#line 13087 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 40253 "gram.c" /* yacc.c:1646  */
    break;

  case 1975:
#line 13088 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 40259 "gram.c" /* yacc.c:1646  */
    break;

  case 1976:
#line 13094 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(makeStringConst((yyvsp[-2].str), (yylsp[-2])), (yyvsp[0].node));
				}
#line 40267 "gram.c" /* yacc.c:1646  */
    break;

  case 1977:
#line 13097 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 40273 "gram.c" /* yacc.c:1646  */
    break;

  case 1978:
#line 13104 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 40279 "gram.c" /* yacc.c:1646  */
    break;

  case 1979:
#line 13105 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "year"; }
#line 40285 "gram.c" /* yacc.c:1646  */
    break;

  case 1980:
#line 13106 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "month"; }
#line 40291 "gram.c" /* yacc.c:1646  */
    break;

  case 1981:
#line 13107 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "day"; }
#line 40297 "gram.c" /* yacc.c:1646  */
    break;

  case 1982:
#line 13108 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "hour"; }
#line 40303 "gram.c" /* yacc.c:1646  */
    break;

  case 1983:
#line 13109 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "minute"; }
#line 40309 "gram.c" /* yacc.c:1646  */
    break;

  case 1984:
#line 13110 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "second"; }
#line 40315 "gram.c" /* yacc.c:1646  */
    break;

  case 1985:
#line 13111 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 40321 "gram.c" /* yacc.c:1646  */
    break;

  case 1986:
#line 13122 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make4((yyvsp[-3].node), (yyvsp[-2].node), (yyvsp[-1].node), (yyvsp[0].node));
				}
#line 40329 "gram.c" /* yacc.c:1646  */
    break;

  case 1987:
#line 13126 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make3((yyvsp[-2].node), (yyvsp[-1].node), (yyvsp[0].node));
				}
#line 40337 "gram.c" /* yacc.c:1646  */
    break;

  case 1988:
#line 13133 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 40343 "gram.c" /* yacc.c:1646  */
    break;

  case 1989:
#line 13139 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[0].node), (yyvsp[-2].node)); }
#line 40349 "gram.c" /* yacc.c:1646  */
    break;

  case 1990:
#line 13140 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 40355 "gram.c" /* yacc.c:1646  */
    break;

  case 1991:
#line 13157 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make3((yyvsp[-2].node), (yyvsp[-1].node), (yyvsp[0].node));
				}
#line 40363 "gram.c" /* yacc.c:1646  */
    break;

  case 1992:
#line 13161 "gram.y" /* yacc.c:1646  */
    {
					/* not legal per SQL99, but might as well allow it */
					(yyval.list) = list_make3((yyvsp[-2].node), (yyvsp[0].node), (yyvsp[-1].node));
				}
#line 40372 "gram.c" /* yacc.c:1646  */
    break;

  case 1993:
#line 13166 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[-1].node), (yyvsp[0].node));
				}
#line 40380 "gram.c" /* yacc.c:1646  */
    break;

  case 1994:
#line 13170 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Since there are no cases where this syntax allows
					 * a textual FOR value, we forcibly cast the argument
					 * to int4.  The possible matches in pg_proc are
					 * substring(text,int4) and substring(text,text),
					 * and we don't want the parser to choose the latter,
					 * which it is likely to do if the second argument
					 * is unknown or doesn't have an implicit cast to int4.
					 */
					(yyval.list) = list_make3((yyvsp[-1].node), makeIntConst(1, -1),
									makeTypeCast((yyvsp[0].node),
												 SystemTypeName("int4"), -1));
				}
#line 40399 "gram.c" /* yacc.c:1646  */
    break;

  case 1995:
#line 13185 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = (yyvsp[0].list);
				}
#line 40407 "gram.c" /* yacc.c:1646  */
    break;

  case 1996:
#line 13189 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 40413 "gram.c" /* yacc.c:1646  */
    break;

  case 1997:
#line 13193 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 40419 "gram.c" /* yacc.c:1646  */
    break;

  case 1998:
#line 13196 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 40425 "gram.c" /* yacc.c:1646  */
    break;

  case 1999:
#line 13199 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[0].list), (yyvsp[-2].node)); }
#line 40431 "gram.c" /* yacc.c:1646  */
    break;

  case 2000:
#line 13200 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 40437 "gram.c" /* yacc.c:1646  */
    break;

  case 2001:
#line 13201 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 40443 "gram.c" /* yacc.c:1646  */
    break;

  case 2002:
#line 13205 "gram.y" /* yacc.c:1646  */
    {
					SubLink *n = makeNode(SubLink);
					n->subselect = (yyvsp[0].node);
					/* other fields will be filled later */
					(yyval.node) = (Node *)n;
				}
#line 40454 "gram.c" /* yacc.c:1646  */
    break;

  case 2003:
#line 13211 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)(yyvsp[-1].list); }
#line 40460 "gram.c" /* yacc.c:1646  */
    break;

  case 2004:
#line 13222 "gram.y" /* yacc.c:1646  */
    {
					CaseExpr *c = makeNode(CaseExpr);
					c->casetype = InvalidOid; /* not analyzed yet */
					c->arg = (Expr *) (yyvsp[-3].node);
					c->args = (yyvsp[-2].list);
					c->defresult = (Expr *) (yyvsp[-1].node);
					c->location = (yylsp[-4]);
					(yyval.node) = (Node *)c;
				}
#line 40474 "gram.c" /* yacc.c:1646  */
    break;

  case 2005:
#line 13235 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 40480 "gram.c" /* yacc.c:1646  */
    break;

  case 2006:
#line 13236 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 40486 "gram.c" /* yacc.c:1646  */
    break;

  case 2007:
#line 13241 "gram.y" /* yacc.c:1646  */
    {
					CaseWhen *w = makeNode(CaseWhen);
					w->expr = (Expr *) (yyvsp[-2].node);
					w->result = (Expr *) (yyvsp[0].node);
					w->location = (yylsp[-3]);
					(yyval.node) = (Node *)w;
				}
#line 40498 "gram.c" /* yacc.c:1646  */
    break;

  case 2008:
#line 13251 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 40504 "gram.c" /* yacc.c:1646  */
    break;

  case 2009:
#line 13252 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 40510 "gram.c" /* yacc.c:1646  */
    break;

  case 2010:
#line 13255 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 40516 "gram.c" /* yacc.c:1646  */
    break;

  case 2011:
#line 13256 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 40522 "gram.c" /* yacc.c:1646  */
    break;

  case 2012:
#line 13260 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeColumnRef((yyvsp[0].str), NIL, (yylsp[0]), yyscanner);
				}
#line 40530 "gram.c" /* yacc.c:1646  */
    break;

  case 2013:
#line 13264 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeColumnRef((yyvsp[-1].str), (yyvsp[0].list), (yylsp[-1]), yyscanner);
				}
#line 40538 "gram.c" /* yacc.c:1646  */
    break;

  case 2014:
#line 13271 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeString((yyvsp[0].str));
				}
#line 40546 "gram.c" /* yacc.c:1646  */
    break;

  case 2015:
#line 13275 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeNode(A_Star);
				}
#line 40554 "gram.c" /* yacc.c:1646  */
    break;

  case 2016:
#line 13279 "gram.y" /* yacc.c:1646  */
    {
					A_Indices *ai = makeNode(A_Indices);
					ai->is_slice = false;
					ai->lidx = NULL;
					ai->uidx = (yyvsp[-1].node);
					(yyval.node) = (Node *) ai;
				}
#line 40566 "gram.c" /* yacc.c:1646  */
    break;

  case 2017:
#line 13287 "gram.y" /* yacc.c:1646  */
    {
					A_Indices *ai = makeNode(A_Indices);
					ai->is_slice = true;
					ai->lidx = (yyvsp[-3].node);
					ai->uidx = (yyvsp[-1].node);
					(yyval.node) = (Node *) ai;
				}
#line 40578 "gram.c" /* yacc.c:1646  */
    break;

  case 2018:
#line 13297 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 40584 "gram.c" /* yacc.c:1646  */
    break;

  case 2019:
#line 13298 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 40590 "gram.c" /* yacc.c:1646  */
    break;

  case 2020:
#line 13302 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 40596 "gram.c" /* yacc.c:1646  */
    break;

  case 2021:
#line 13303 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 40602 "gram.c" /* yacc.c:1646  */
    break;

  case 2022:
#line 13307 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 40608 "gram.c" /* yacc.c:1646  */
    break;

  case 2023:
#line 13308 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 40614 "gram.c" /* yacc.c:1646  */
    break;

  case 2026:
#line 13323 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].node); }
#line 40620 "gram.c" /* yacc.c:1646  */
    break;

  case 2027:
#line 13325 "gram.y" /* yacc.c:1646  */
    {
					SetToDefault *n = makeNode(SetToDefault);
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 40630 "gram.c" /* yacc.c:1646  */
    break;

  case 2028:
#line 13333 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 40636 "gram.c" /* yacc.c:1646  */
    break;

  case 2029:
#line 13334 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 40642 "gram.c" /* yacc.c:1646  */
    break;

  case 2030:
#line 13342 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 40648 "gram.c" /* yacc.c:1646  */
    break;

  case 2031:
#line 13352 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 40654 "gram.c" /* yacc.c:1646  */
    break;

  case 2032:
#line 13353 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 40660 "gram.c" /* yacc.c:1646  */
    break;

  case 2033:
#line 13357 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 40666 "gram.c" /* yacc.c:1646  */
    break;

  case 2034:
#line 13358 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 40672 "gram.c" /* yacc.c:1646  */
    break;

  case 2035:
#line 13362 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)(yyvsp[-2].node);
					(yyval.target)->location = (yylsp[-2]);
				}
#line 40684 "gram.c" /* yacc.c:1646  */
    break;

  case 2036:
#line 13378 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)(yyvsp[-1].node);
					(yyval.target)->location = (yylsp[-1]);
				}
#line 40696 "gram.c" /* yacc.c:1646  */
    break;

  case 2037:
#line 13386 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)(yyvsp[0].node);
					(yyval.target)->location = (yylsp[0]);
				}
#line 40708 "gram.c" /* yacc.c:1646  */
    break;

  case 2038:
#line 13394 "gram.y" /* yacc.c:1646  */
    {
					ColumnRef *n = makeNode(ColumnRef);
					n->fields = list_make1(makeNode(A_Star));
					n->location = (yylsp[0]);

					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)n;
					(yyval.target)->location = (yylsp[0]);
				}
#line 40724 "gram.c" /* yacc.c:1646  */
    break;

  case 2039:
#line 13415 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].range)); }
#line 40730 "gram.c" /* yacc.c:1646  */
    break;

  case 2040:
#line 13416 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].range)); }
#line 40736 "gram.c" /* yacc.c:1646  */
    break;

  case 2041:
#line 13428 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = makeRangeVar(NULL, (yyvsp[0].str), (yylsp[0]));
				}
#line 40744 "gram.c" /* yacc.c:1646  */
    break;

  case 2042:
#line 13432 "gram.y" /* yacc.c:1646  */
    {
					check_qualified_name((yyvsp[0].list), yyscanner);
					(yyval.range) = makeRangeVar(NULL, NULL, (yylsp[-1]));
					switch (list_length((yyvsp[0].list)))
					{
						case 1:
							(yyval.range)->catalogname = NULL;
							(yyval.range)->schemaname = (yyvsp[-1].str);
							(yyval.range)->relname = strVal(linitial((yyvsp[0].list)));
							break;
						case 2:
							(yyval.range)->catalogname = (yyvsp[-1].str);
							(yyval.range)->schemaname = strVal(linitial((yyvsp[0].list)));
							(yyval.range)->relname = strVal(lsecond((yyvsp[0].list)));
							break;
						default:
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("improper qualified name (too many dotted names): %s",
											NameListToString(lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)))),
									 parser_errposition((yylsp[-1]))));
							break;
					}
				}
#line 40773 "gram.c" /* yacc.c:1646  */
    break;

  case 2043:
#line 13459 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 40779 "gram.c" /* yacc.c:1646  */
    break;

  case 2044:
#line 13461 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 40785 "gram.c" /* yacc.c:1646  */
    break;

  case 2045:
#line 13465 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 40791 "gram.c" /* yacc.c:1646  */
    break;

  case 2046:
#line 13468 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 40797 "gram.c" /* yacc.c:1646  */
    break;

  case 2047:
#line 13471 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 40803 "gram.c" /* yacc.c:1646  */
    break;

  case 2048:
#line 13473 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 40809 "gram.c" /* yacc.c:1646  */
    break;

  case 2049:
#line 13475 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 40815 "gram.c" /* yacc.c:1646  */
    break;

  case 2050:
#line 13477 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 40821 "gram.c" /* yacc.c:1646  */
    break;

  case 2051:
#line 13488 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 40827 "gram.c" /* yacc.c:1646  */
    break;

  case 2052:
#line 13490 "gram.y" /* yacc.c:1646  */
    {
						(yyval.list) = check_func_name(lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)),
											 yyscanner);
					}
#line 40836 "gram.c" /* yacc.c:1646  */
    break;

  case 2053:
#line 13501 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeIntConst((yyvsp[0].ival), (yylsp[0]));
				}
#line 40844 "gram.c" /* yacc.c:1646  */
    break;

  case 2054:
#line 13505 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeFloatConst((yyvsp[0].str), (yylsp[0]));
				}
#line 40852 "gram.c" /* yacc.c:1646  */
    break;

  case 2055:
#line 13509 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 40860 "gram.c" /* yacc.c:1646  */
    break;

  case 2056:
#line 13513 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeBitStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 40868 "gram.c" /* yacc.c:1646  */
    break;

  case 2057:
#line 13517 "gram.y" /* yacc.c:1646  */
    {
					/* This is a bit constant per SQL99:
					 * Without Feature F511, "BIT data type",
					 * a <general literal> shall not be a
					 * <bit string literal> or a <hex string literal>.
					 */
					(yyval.node) = makeBitStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 40881 "gram.c" /* yacc.c:1646  */
    break;

  case 2058:
#line 13526 "gram.y" /* yacc.c:1646  */
    {
					/* generic type 'literal' syntax */
					TypeName *t = makeTypeNameFromNameList((yyvsp[-1].list));
					t->location = (yylsp[-1]);
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 40892 "gram.c" /* yacc.c:1646  */
    break;

  case 2059:
#line 13533 "gram.y" /* yacc.c:1646  */
    {
					/* generic syntax with a type modifier */
					TypeName *t = makeTypeNameFromNameList((yyvsp[-5].list));
					ListCell *lc;

					/*
					 * We must use func_arg_list and opt_sort_clause in the
					 * production to avoid reduce/reduce conflicts, but we
					 * don't actually wish to allow NamedArgExpr in this
					 * context, nor ORDER BY.
					 */
					foreach(lc, (yyvsp[-3].list))
					{
						NamedArgExpr *arg = (NamedArgExpr *) lfirst(lc);

						if (IsA(arg, NamedArgExpr))
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("type modifier cannot have parameter name"),
									 parser_errposition(arg->location)));
					}
					if ((yyvsp[-2].list) != NIL)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("type modifier cannot have ORDER BY"),
									 parser_errposition((yylsp[-2]))));

					t->typmods = (yyvsp[-3].list);
					t->location = (yylsp[-5]);
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 40928 "gram.c" /* yacc.c:1646  */
    break;

  case 2060:
#line 13565 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), (yyvsp[-1].typnam));
				}
#line 40936 "gram.c" /* yacc.c:1646  */
    break;

  case 2061:
#line 13569 "gram.y" /* yacc.c:1646  */
    {
					TypeName *t = (yyvsp[-2].typnam);
					t->typmods = (yyvsp[0].list);
					(yyval.node) = makeStringConstCast((yyvsp[-1].str), (yylsp[-1]), t);
				}
#line 40946 "gram.c" /* yacc.c:1646  */
    break;

  case 2062:
#line 13575 "gram.y" /* yacc.c:1646  */
    {
					TypeName *t = (yyvsp[-4].typnam);
					t->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
											makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 40957 "gram.c" /* yacc.c:1646  */
    break;

  case 2063:
#line 13582 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeBoolAConst(TRUE, (yylsp[0]));
				}
#line 40965 "gram.c" /* yacc.c:1646  */
    break;

  case 2064:
#line 13586 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeBoolAConst(FALSE, (yylsp[0]));
				}
#line 40973 "gram.c" /* yacc.c:1646  */
    break;

  case 2065:
#line 13590 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeNullAConst((yylsp[0]));
				}
#line 40981 "gram.c" /* yacc.c:1646  */
    break;

  case 2066:
#line 13595 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[0].ival); }
#line 40987 "gram.c" /* yacc.c:1646  */
    break;

  case 2067:
#line 13596 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 40993 "gram.c" /* yacc.c:1646  */
    break;

  case 2068:
#line 13598 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[0].ival); }
#line 40999 "gram.c" /* yacc.c:1646  */
    break;

  case 2069:
#line 13599 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = + (yyvsp[0].ival); }
#line 41005 "gram.c" /* yacc.c:1646  */
    break;

  case 2070:
#line 13600 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = - (yyvsp[0].ival); }
#line 41011 "gram.c" /* yacc.c:1646  */
    break;

  case 2071:
#line 13605 "gram.y" /* yacc.c:1646  */
    {
					RoleSpec *spc = (RoleSpec *) (yyvsp[0].node);
					switch (spc->roletype)
					{
						case ROLESPEC_CSTRING:
							(yyval.str) = spc->rolename;
							break;
						case ROLESPEC_PUBLIC:
							ereport(ERROR,
									(errcode(ERRCODE_RESERVED_NAME),
									 errmsg("role name \"%s\" is reserved",
											"public"),
									 parser_errposition((yylsp[0]))));
						case ROLESPEC_SESSION_USER:
							ereport(ERROR,
									(errcode(ERRCODE_RESERVED_NAME),
									 errmsg("%s cannot be used as a role name here",
											"SESSION_USER"),
									 parser_errposition((yylsp[0]))));
						case ROLESPEC_CURRENT_USER:
							ereport(ERROR,
									(errcode(ERRCODE_RESERVED_NAME),
									 errmsg("%s cannot be used as a role name here",
											"CURRENT_USER"),
									 parser_errposition((yylsp[0]))));
					}
				}
#line 41043 "gram.c" /* yacc.c:1646  */
    break;

  case 2072:
#line 13635 "gram.y" /* yacc.c:1646  */
    {
						/*
						 * "public" and "none" are not keywords, but they must
						 * be treated specially here.
						 */
						RoleSpec *n;
						if (strcmp((yyvsp[0].str), "public") == 0)
						{
							n = (RoleSpec *) makeRoleSpec(ROLESPEC_PUBLIC, (yylsp[0]));
							n->roletype = ROLESPEC_PUBLIC;
						}
						else if (strcmp((yyvsp[0].str), "none") == 0)
						{
							ereport(ERROR,
									(errcode(ERRCODE_RESERVED_NAME),
									 errmsg("role name \"%s\" is reserved",
											"none"),
									 parser_errposition((yylsp[0]))));
						}
						else
						{
							n = (RoleSpec *) makeRoleSpec(ROLESPEC_CSTRING, (yylsp[0]));
							n->rolename = pstrdup((yyvsp[0].str));
						}
						(yyval.node) = (Node *) n;
					}
#line 41074 "gram.c" /* yacc.c:1646  */
    break;

  case 2073:
#line 13662 "gram.y" /* yacc.c:1646  */
    {
						(yyval.node) = makeRoleSpec(ROLESPEC_CURRENT_USER, (yylsp[0]));
					}
#line 41082 "gram.c" /* yacc.c:1646  */
    break;

  case 2074:
#line 13666 "gram.y" /* yacc.c:1646  */
    {
						(yyval.node) = makeRoleSpec(ROLESPEC_SESSION_USER, (yylsp[0]));
					}
#line 41090 "gram.c" /* yacc.c:1646  */
    break;

  case 2075:
#line 13672 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 41096 "gram.c" /* yacc.c:1646  */
    break;

  case 2076:
#line 13674 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 41102 "gram.c" /* yacc.c:1646  */
    break;

  case 2077:
#line 13690 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 41108 "gram.c" /* yacc.c:1646  */
    break;

  case 2078:
#line 13691 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 41114 "gram.c" /* yacc.c:1646  */
    break;

  case 2079:
#line 13692 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 41120 "gram.c" /* yacc.c:1646  */
    break;

  case 2080:
#line 13697 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 41126 "gram.c" /* yacc.c:1646  */
    break;

  case 2081:
#line 13698 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 41132 "gram.c" /* yacc.c:1646  */
    break;

  case 2082:
#line 13699 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 41138 "gram.c" /* yacc.c:1646  */
    break;

  case 2083:
#line 13704 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 41144 "gram.c" /* yacc.c:1646  */
    break;

  case 2084:
#line 13705 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 41150 "gram.c" /* yacc.c:1646  */
    break;

  case 2085:
#line 13706 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 41156 "gram.c" /* yacc.c:1646  */
    break;

  case 2086:
#line 13707 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 41162 "gram.c" /* yacc.c:1646  */
    break;

  case 2087:
#line 13713 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 41168 "gram.c" /* yacc.c:1646  */
    break;

  case 2088:
#line 13714 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 41174 "gram.c" /* yacc.c:1646  */
    break;

  case 2089:
#line 13715 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 41180 "gram.c" /* yacc.c:1646  */
    break;

  case 2090:
#line 13716 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 41186 "gram.c" /* yacc.c:1646  */
    break;

  case 2091:
#line 13717 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 41192 "gram.c" /* yacc.c:1646  */
    break;


#line 41196 "gram.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (&yylloc, yyscanner, YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (&yylloc, yyscanner, yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }

  yyerror_range[1] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc, yyscanner);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  yyerror_range[1] = yylsp[1-yylen];
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp, yylsp, yyscanner);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, yyerror_range, 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (&yylloc, yyscanner, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc, yyscanner);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp, yylsp, yyscanner);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 14193 "gram.y" /* yacc.c:1906  */


/*
 * The signature of this function is required by bison.  However, we
 * ignore the passed yylloc and instead use the last token position
 * available from the scanner.
 */
static void
base_yyerror(YYLTYPE *yylloc, core_yyscan_t yyscanner, const char *msg)
{
	parser_yyerror(msg);
}

static Node *
makeColumnRef(char *colname, List *indirection,
			  int location, core_yyscan_t yyscanner)
{
	/*
	 * Generate a ColumnRef node, with an A_Indirection node added if there
	 * is any subscripting in the specified indirection list.  However,
	 * any field selection at the start of the indirection list must be
	 * transposed into the "fields" part of the ColumnRef node.
	 */
	ColumnRef  *c = makeNode(ColumnRef);
	int		nfields = 0;
	ListCell *l;

	c->location = location;
	foreach(l, indirection)
	{
		if (IsA(lfirst(l), A_Indices))
		{
			A_Indirection *i = makeNode(A_Indirection);

			if (nfields == 0)
			{
				/* easy case - all indirection goes to A_Indirection */
				c->fields = list_make1(makeString(colname));
				i->indirection = check_indirection(indirection, yyscanner);
			}
			else
			{
				/* got to split the list in two */
				i->indirection = check_indirection(list_copy_tail(indirection,
																  nfields),
												   yyscanner);
				indirection = list_truncate(indirection, nfields);
				c->fields = lcons(makeString(colname), indirection);
			}
			i->arg = (Node *) c;
			return (Node *) i;
		}
		else if (IsA(lfirst(l), A_Star))
		{
			/* We only allow '*' at the end of a ColumnRef */
			if (lnext(l) != NULL)
				parser_yyerror("improper use of \"*\"");
		}
		nfields++;
	}
	/* No subscripting, so all indirection gets added to field list */
	c->fields = lcons(makeString(colname), indirection);
	return (Node *) c;
}

static Node *
makeTypeCast(Node *arg, TypeName *typename, int location)
{
	TypeCast *n = makeNode(TypeCast);
	n->arg = arg;
	n->typeName = typename;
	n->location = location;
	return (Node *) n;
}

static Node *
makeStringConst(char *str, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_String;
	n->val.val.str = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeStringConstCast(char *str, int location, TypeName *typename)
{
	Node *s = makeStringConst(str, location);

	return makeTypeCast(s, typename, -1);
}

static Node *
makeIntConst(int val, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_Integer;
	n->val.val.ival = val;
	n->location = location;

	return (Node *)n;
}

static Node *
makeFloatConst(char *str, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_Float;
	n->val.val.str = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeBitStringConst(char *str, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_BitString;
	n->val.val.str = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeNullAConst(int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_Null;
	n->location = location;

	return (Node *)n;
}

static Node *
makeAConst(Value *v, int location)
{
	Node *n;

	switch (v->type)
	{
		case T_Float:
			n = makeFloatConst(v->val.str, location);
			break;

		case T_Integer:
			n = makeIntConst(v->val.ival, location);
			break;

		case T_String:
		default:
			n = makeStringConst(v->val.str, location);
			break;
	}

	return n;
}

/* makeBoolAConst()
 * Create an A_Const string node and put it inside a boolean cast.
 */
static Node *
makeBoolAConst(bool state, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_String;
	n->val.val.str = (state ? "t" : "f");
	n->location = location;

	return makeTypeCast((Node *)n, SystemTypeName("bool"), -1);
}

/* makeRoleSpec
 * Create a RoleSpec with the given type
 */
static Node *
makeRoleSpec(RoleSpecType type, int location)
{
	RoleSpec *spec = makeNode(RoleSpec);

	spec->roletype = type;
	spec->location = location;

	return (Node *) spec;
}

/* check_qualified_name --- check the result of qualified_name production
 *
 * It's easiest to let the grammar production for qualified_name allow
 * subscripts and '*', which we then must reject here.
 */
static void
check_qualified_name(List *names, core_yyscan_t yyscanner)
{
	ListCell   *i;

	foreach(i, names)
	{
		if (!IsA(lfirst(i), String))
			parser_yyerror("syntax error");
	}
}

/* check_func_name --- check the result of func_name production
 *
 * It's easiest to let the grammar production for func_name allow subscripts
 * and '*', which we then must reject here.
 */
static List *
check_func_name(List *names, core_yyscan_t yyscanner)
{
	ListCell   *i;

	foreach(i, names)
	{
		if (!IsA(lfirst(i), String))
			parser_yyerror("syntax error");
	}
	return names;
}

/* check_indirection --- check the result of indirection production
 *
 * We only allow '*' at the end of the list, but it's hard to enforce that
 * in the grammar, so do it here.
 */
static List *
check_indirection(List *indirection, core_yyscan_t yyscanner)
{
	ListCell *l;

	foreach(l, indirection)
	{
		if (IsA(lfirst(l), A_Star))
		{
			if (lnext(l) != NULL)
				parser_yyerror("improper use of \"*\"");
		}
	}
	return indirection;
}

/* extractArgTypes()
 * Given a list of FunctionParameter nodes, extract a list of just the
 * argument types (TypeNames) for input parameters only.  This is what
 * is needed to look up an existing function, which is what is wanted by
 * the productions that use this call.
 */
static List *
extractArgTypes(List *parameters)
{
	List	   *result = NIL;
	ListCell   *i;

	foreach(i, parameters)
	{
		FunctionParameter *p = (FunctionParameter *) lfirst(i);

		if (p->mode != FUNC_PARAM_OUT && p->mode != FUNC_PARAM_TABLE)
			result = lappend(result, p->argType);
	}
	return result;
}

/* extractAggrArgTypes()
 * As above, but work from the output of the aggr_args production.
 */
static List *
extractAggrArgTypes(List *aggrargs)
{
	Assert(list_length(aggrargs) == 2);
	return extractArgTypes((List *) linitial(aggrargs));
}

/* makeOrderedSetArgs()
 * Build the result of the aggr_args production (which see the comments for).
 * This handles only the case where both given lists are nonempty, so that
 * we have to deal with multiple VARIADIC arguments.
 */
static List *
makeOrderedSetArgs(List *directargs, List *orderedargs,
				   core_yyscan_t yyscanner)
{
	FunctionParameter *lastd = (FunctionParameter *) llast(directargs);
	int			ndirectargs;

	/* No restriction unless last direct arg is VARIADIC */
	if (lastd->mode == FUNC_PARAM_VARIADIC)
	{
		FunctionParameter *firsto = (FunctionParameter *) linitial(orderedargs);

		/*
		 * We ignore the names, though the aggr_arg production allows them;
		 * it doesn't allow default values, so those need not be checked.
		 */
		if (list_length(orderedargs) != 1 ||
			firsto->mode != FUNC_PARAM_VARIADIC ||
			!equal(lastd->argType, firsto->argType))
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 errmsg("an ordered-set aggregate with a VARIADIC direct argument must have one VARIADIC aggregated argument of the same data type"),
					 parser_errposition(exprLocation((Node *) firsto))));

		/* OK, drop the duplicate VARIADIC argument from the internal form */
		orderedargs = NIL;
	}

	/* don't merge into the next line, as list_concat changes directargs */
	ndirectargs = list_length(directargs);

	return list_make2(list_concat(directargs, orderedargs),
					  makeInteger(ndirectargs));
}

/* insertSelectOptions()
 * Insert ORDER BY, etc into an already-constructed SelectStmt.
 *
 * This routine is just to avoid duplicating code in SelectStmt productions.
 */
static void
insertSelectOptions(SelectStmt *stmt,
					List *sortClause, List *lockingClause,
					Node *limitOffset, Node *limitCount,
					WithClause *withClause,
					core_yyscan_t yyscanner)
{
	Assert(IsA(stmt, SelectStmt));

	/*
	 * Tests here are to reject constructs like
	 *	(SELECT foo ORDER BY bar) ORDER BY baz
	 */
	if (sortClause)
	{
		if (stmt->sortClause)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple ORDER BY clauses not allowed"),
					 parser_errposition(exprLocation((Node *) sortClause))));
		stmt->sortClause = sortClause;
	}
	/* We can handle multiple locking clauses, though */
	stmt->lockingClause = list_concat(stmt->lockingClause, lockingClause);
	if (limitOffset)
	{
		if (stmt->limitOffset)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple OFFSET clauses not allowed"),
					 parser_errposition(exprLocation(limitOffset))));
		stmt->limitOffset = limitOffset;
	}
	if (limitCount)
	{
		if (stmt->limitCount)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple LIMIT clauses not allowed"),
					 parser_errposition(exprLocation(limitCount))));
		stmt->limitCount = limitCount;
	}
	if (withClause)
	{
		if (stmt->withClause)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple WITH clauses not allowed"),
					 parser_errposition(exprLocation((Node *) withClause))));
		stmt->withClause = withClause;
	}
}

static Node *
makeSetOp(SetOperation op, bool all, Node *larg, Node *rarg)
{
	SelectStmt *n = makeNode(SelectStmt);

	n->op = op;
	n->all = all;
	n->larg = (SelectStmt *) larg;
	n->rarg = (SelectStmt *) rarg;
	return (Node *) n;
}

/* SystemFuncName()
 * Build a properly-qualified reference to a built-in function.
 */
List *
SystemFuncName(char *name)
{
	return list_make2(makeString("pg_catalog"), makeString(name));
}

/* SystemTypeName()
 * Build a properly-qualified reference to a built-in type.
 *
 * typmod is defaulted, but may be changed afterwards by caller.
 * Likewise for the location.
 */
TypeName *
SystemTypeName(char *name)
{
	return makeTypeNameFromNameList(list_make2(makeString("pg_catalog"),
											   makeString(name)));
}

/* doNegate()
 * Handle negation of a numeric constant.
 *
 * Formerly, we did this here because the optimizer couldn't cope with
 * indexquals that looked like "var = -4" --- it wants "var = const"
 * and a unary minus operator applied to a constant didn't qualify.
 * As of Postgres 7.0, that problem doesn't exist anymore because there
 * is a constant-subexpression simplifier in the optimizer.  However,
 * there's still a good reason for doing this here, which is that we can
 * postpone committing to a particular internal representation for simple
 * negative constants.	It's better to leave "-123.456" in string form
 * until we know what the desired type is.
 */
static Node *
doNegate(Node *n, int location)
{
	if (IsA(n, A_Const))
	{
		A_Const *con = (A_Const *)n;

		/* report the constant's location as that of the '-' sign */
		con->location = location;

		if (con->val.type == T_Integer)
		{
			con->val.val.ival = -con->val.val.ival;
			return n;
		}
		if (con->val.type == T_Float)
		{
			doNegateFloat(&con->val);
			return n;
		}
	}

	return (Node *) makeSimpleA_Expr(AEXPR_OP, "-", NULL, n, location);
}

static void
doNegateFloat(Value *v)
{
	char   *oldval = v->val.str;

	Assert(IsA(v, Float));
	if (*oldval == '+')
		oldval++;
	if (*oldval == '-')
		v->val.str = oldval+1;	/* just strip the '-' */
	else
		v->val.str = psprintf("-%s", oldval);
}

static Node *
makeAndExpr(Node *lexpr, Node *rexpr, int location)
{
	Node	   *lexp = lexpr;

	/* Look through AEXPR_PAREN nodes so they don't affect flattening */
	while (IsA(lexp, A_Expr) &&
		   ((A_Expr *) lexp)->kind == AEXPR_PAREN)
		lexp = ((A_Expr *) lexp)->lexpr;
	/* Flatten "a AND b AND c ..." to a single BoolExpr on sight */
	if (IsA(lexp, BoolExpr))
	{
		BoolExpr *blexpr = (BoolExpr *) lexp;

		if (blexpr->boolop == AND_EXPR)
		{
			blexpr->args = lappend(blexpr->args, rexpr);
			return (Node *) blexpr;
		}
	}
	return (Node *) makeBoolExpr(AND_EXPR, list_make2(lexpr, rexpr), location);
}

static Node *
makeOrExpr(Node *lexpr, Node *rexpr, int location)
{
	Node	   *lexp = lexpr;

	/* Look through AEXPR_PAREN nodes so they don't affect flattening */
	while (IsA(lexp, A_Expr) &&
		   ((A_Expr *) lexp)->kind == AEXPR_PAREN)
		lexp = ((A_Expr *) lexp)->lexpr;
	/* Flatten "a OR b OR c ..." to a single BoolExpr on sight */
	if (IsA(lexp, BoolExpr))
	{
		BoolExpr *blexpr = (BoolExpr *) lexp;

		if (blexpr->boolop == OR_EXPR)
		{
			blexpr->args = lappend(blexpr->args, rexpr);
			return (Node *) blexpr;
		}
	}
	return (Node *) makeBoolExpr(OR_EXPR, list_make2(lexpr, rexpr), location);
}

static Node *
makeNotExpr(Node *expr, int location)
{
	return (Node *) makeBoolExpr(NOT_EXPR, list_make1(expr), location);
}

static Node *
makeAArrayExpr(List *elements, int location)
{
	A_ArrayExpr *n = makeNode(A_ArrayExpr);

	n->elements = elements;
	n->location = location;
	return (Node *) n;
}

static Node *
makeXmlExpr(XmlExprOp op, char *name, List *named_args, List *args,
			int location)
{
	XmlExpr		*x = makeNode(XmlExpr);

	x->op = op;
	x->name = name;
	/*
	 * named_args is a list of ResTarget; it'll be split apart into separate
	 * expression and name lists in transformXmlExpr().
	 */
	x->named_args = named_args;
	x->arg_names = NIL;
	x->args = args;
	/* xmloption, if relevant, must be filled in by caller */
	/* type and typmod will be filled in during parse analysis */
	x->type = InvalidOid;			/* marks the node as not analyzed */
	x->location = location;
	return (Node *) x;
}

/*
 * Merge the input and output parameters of a table function.
 */
static List *
mergeTableFuncParameters(List *func_args, List *columns)
{
	ListCell   *lc;

	/* Explicit OUT and INOUT parameters shouldn't be used in this syntax */
	foreach(lc, func_args)
	{
		FunctionParameter *p = (FunctionParameter *) lfirst(lc);

		if (p->mode != FUNC_PARAM_IN && p->mode != FUNC_PARAM_VARIADIC)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("OUT and INOUT arguments aren't allowed in TABLE functions")));
	}

	return list_concat(func_args, columns);
}

/*
 * Determine return type of a TABLE function.  A single result column
 * returns setof that column's type; otherwise return setof record.
 */
static TypeName *
TableFuncTypeName(List *columns)
{
	TypeName *result;

	if (list_length(columns) == 1)
	{
		FunctionParameter *p = (FunctionParameter *) linitial(columns);

		result = (TypeName *) copyObject(p->argType);
	}
	else
		result = SystemTypeName("record");

	result->setof = true;

	return result;
}

/*
 * Convert a list of (dotted) names to a RangeVar (like
 * makeRangeVarFromNameList, but with position support).  The
 * "AnyName" refers to the any_name production in the grammar.
 */
static RangeVar *
makeRangeVarFromAnyName(List *names, int position, core_yyscan_t yyscanner)
{
	RangeVar *r = makeNode(RangeVar);

	switch (list_length(names))
	{
		case 1:
			r->catalogname = NULL;
			r->schemaname = NULL;
			r->relname = strVal(linitial(names));
			break;
		case 2:
			r->catalogname = NULL;
			r->schemaname = strVal(linitial(names));
			r->relname = strVal(lsecond(names));
			break;
		case 3:
			r->catalogname = strVal(linitial(names));
			r->schemaname = strVal(lsecond(names));
			r->relname = strVal(lthird(names));
			break;
		default:
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("improper qualified name (too many dotted names): %s",
							NameListToString(names)),
					 parser_errposition(position)));
			break;
	}

	r->relpersistence = RELPERSISTENCE_PERMANENT;
	r->location = position;

	return r;
}

/* Separate Constraint nodes from COLLATE clauses in a ColQualList */
static void
SplitColQualList(List *qualList,
				 List **constraintList, CollateClause **collClause,
				 core_yyscan_t yyscanner)
{
	ListCell   *cell;
	ListCell   *prev;
	ListCell   *next;

	*collClause = NULL;
	prev = NULL;
	for (cell = list_head(qualList); cell; cell = next)
	{
		Node   *n = (Node *) lfirst(cell);

		next = lnext(cell);
		if (IsA(n, Constraint))
		{
			/* keep it in list */
			prev = cell;
			continue;
		}
		if (IsA(n, CollateClause))
		{
			CollateClause *c = (CollateClause *) n;

			if (*collClause)
				ereport(ERROR,
						(errcode(ERRCODE_SYNTAX_ERROR),
						 errmsg("multiple COLLATE clauses not allowed"),
						 parser_errposition(c->location)));
			*collClause = c;
		}
		else
			elog(ERROR, "unexpected node type %d", (int) n->type);
		/* remove non-Constraint nodes from qualList */
		qualList = list_delete_cell(qualList, cell, prev);
	}
	*constraintList = qualList;
}

/*
 * Process result of ConstraintAttributeSpec, and set appropriate bool flags
 * in the output command node.  Pass NULL for any flags the particular
 * command doesn't support.
 */
static void
processCASbits(int cas_bits, int location, const char *constrType,
			   bool *deferrable, bool *initdeferred, bool *not_valid,
			   bool *no_inherit, core_yyscan_t yyscanner)
{
	/* defaults */
	if (deferrable)
		*deferrable = false;
	if (initdeferred)
		*initdeferred = false;
	if (not_valid)
		*not_valid = false;

	if (cas_bits & (CAS_DEFERRABLE | CAS_INITIALLY_DEFERRED))
	{
		if (deferrable)
			*deferrable = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked DEFERRABLE",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_INITIALLY_DEFERRED)
	{
		if (initdeferred)
			*initdeferred = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked DEFERRABLE",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_NOT_VALID)
	{
		if (not_valid)
			*not_valid = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked NOT VALID",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_NO_INHERIT)
	{
		if (no_inherit)
			*no_inherit = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked NO INHERIT",
							constrType),
					 parser_errposition(location)));
	}
}

/*----------
 * Recursive view transformation
 *
 * Convert
 *
 *     CREATE RECURSIVE VIEW relname (aliases) AS query
 *
 * to
 *
 *     CREATE VIEW relname (aliases) AS
 *         WITH RECURSIVE relname (aliases) AS (query)
 *         SELECT aliases FROM relname
 *
 * Actually, just the WITH ... part, which is then inserted into the original
 * view definition as the query.
 * ----------
 */
static Node *
makeRecursiveViewSelect(char *relname, List *aliases, Node *query)
{
	SelectStmt *s = makeNode(SelectStmt);
	WithClause *w = makeNode(WithClause);
	CommonTableExpr *cte = makeNode(CommonTableExpr);
	List	   *tl = NIL;
	ListCell   *lc;

	/* create common table expression */
	cte->ctename = relname;
	cte->aliascolnames = aliases;
	cte->ctequery = query;
	cte->location = -1;

	/* create WITH clause and attach CTE */
	w->recursive = true;
	w->ctes = list_make1(cte);
	w->location = -1;

	/* create target list for the new SELECT from the alias list of the
	 * recursive view specification */
	foreach (lc, aliases)
	{
		ResTarget *rt = makeNode(ResTarget);

		rt->name = NULL;
		rt->indirection = NIL;
		rt->val = makeColumnRef(strVal(lfirst(lc)), NIL, -1, 0);
		rt->location = -1;

		tl = lappend(tl, rt);
	}

	/* create new SELECT combining WITH clause, target list, and fake FROM
	 * clause */
	s->withClause = w;
	s->targetList = tl;
	s->fromClause = list_make1(makeRangeVar(NULL, relname, -1));

	return (Node *) s;
}

/* parser_init()
 * Initialize to parse one query string
 */
void
parser_init(base_yy_extra_type *yyext)
{
	yyext->parsetree = NIL;		/* in case grammar forgets to set it */
}
